<?php
function Receiver_GetLayers($projectname,$receiver) {
    if (file_exists('../../etc/projects.xml'))
        $xml = simplexml_load_file('../../etc/projects.xml');
    foreach($xml->project as $project) {
        if($project->name == $projectname) {
            $layers = array();
            foreach($project->receivers->receiver as $recv) {
                if((string) $recv['name'] == $receiver) {
                    foreach($recv->layer as $layer) {
                        if(!$layer['active'] || ($layer['active'] == 'true'))
                            array_push($layers,(string) $layer);
                    }
                }
            }
            break;
        }
    }
    return $layers;
}

function Receiver_GetPersistence($projectname) {
    if (file_exists('../../etc/projects.xml'))
        $xml = simplexml_load_file('../../etc/projects.xml');
    foreach($xml->project as $project) {
        if($project->name == $projectname) {
            $settings = array();
            $settings['dir'] = (string) $project->directory; 
            $indexname = "persistence-type";
            $settings['type'] = (string) $project->$indexname; 
            if($settings['type'] == 'adodb') {
                $dboptions = array();
                $indexname = "persistence-options";
                $subname = "server-address";
                $dboptions['server'] = (string) $project->$indexname->$subname;
                $subname = "username";
                $dboptions['username'] = (string) $project->$indexname->$subname;
                $subname = "password";
                $dboptions['password'] = (string) $project->$indexname->$subname;
                $subname = "dbname";
                $dboptions['dbname'] = (string) $project->$indexname->$subname;
                $settings['dboptions'] = $dboptions;
            }
            break;
        }
    }
    return $settings;
}
?>
