<?php

function convertSimpleXMLToArray($xmlobj) {
	$knownArrays = array(); // Array of known keys

	if(!is_object($xmlobj))
	    return (string) $xmlobj;

	foreach($xmlobj as $key=>$value) {
		if(!$retval) //--- Must be done here, would check class type, but even end nodes are SimpleXMLElements
			$retval = array();

		if($retval[$key]) { // double keys, build array
			if(!$knownArrays[$key]) { // not known, learn it
				$retval[$key] = array($retval[$key]); // shift array
				$knownArrays[$key] = true; // set flag
			}
			array_push($retval[$key], convertSimpleXMLToArray($value)); // stack onto array (we must have a return value, this is recursive.
		} else
			$retval[$key] = convertSimpleXMLToArray($value); // main recursive call
	}
	if(!$retval)
		$retval = (string) $xmlobj; // no kids, get value
	return $retval;
}

function sortServices($options) {
	$services = $options['driver-options']['service-modules']['service-module'];
	$options['driver-options']['service-modules'] = array();
	foreach($services as $service)
		$options['driver-options']['service-modules'][$service['name']] = $service;
	return $options;
}

function loadCCSOptions() {
	if (file_exists('../../etc/ccs_options.xml'))
	   $xml = simplexml_load_file('../../etc/ccs_options.xml');

	if($xml) {
		$oldOptions = $_SESSION['ccs']['options'];
		$_SESSION['ccs']['options'] = sortServices(convertSimpleXMLToArray($xml));
		if($oldOptions) {
			foreach($oldOptions as $key=>$option)
				$_SESSION['ccs']['options'][$key] = $option;
		}
		$_SESSION['ccs']['optionsLoaded'] = true;

		// Set Paths for TCA
		$_SESSION['TCA_HOME']       = $_SESSION['ccs']['options']['tca-options']['tca-home'];
		$_SESSION['TCA_CARTRIDGES'] = $_SESSION['ccs']['options']['tca-options']['tca-cartridges'];
		$_SESSION['TCA_ETC']        = $_SESSION['ccs']['options']['tca-options']['tca-etc'];

		// Get CCS URL info for hopping projects
		//$_SESSION['ccs']['options']['driver-options']['url'] = $_SESSION['ccs']['options']['driver-options']['url-prefix'].'://'.$_SERVER['HTTP_HOST'].$_SERVER['SCRIPT_NAME'];
		$_SESSION['ccs']['options']['driver-options']['url'] = $_SESSION['ccs']['options']['driver-options']['url-prefix'].'://'.$_SERVER['HTTP_HOST'].'/projects'.$_SESSION['ccs']['options']['driver-options']['project-receiver'];

		// Get Billing URL
		$_SESSION['ccs']['options']['driver-options']['billing-module']['url'] = $_SESSION['ccs']['options']['driver-options']['url-prefix'].'://'.$_SERVER['HTTP_HOST'].'/projects'.$_SESSION['ccs']['options']['driver-options']['billing-module']['project-receiver']; 

		// Get Service URLs & Check to see if CCS is enabled
		$CCSenabled = false;
		foreach($_SESSION['ccs']['options']['driver-options']['service-modules'] as $server) {
			if(strcasecmp($server['active'],'true') == 0)
			    $CCSenabled = true;

			$_SESSION['ccs']['options']['driver-options']['service-modules'][$server['name']]['url'] = $_SESSION['ccs']['options']['driver-options']['url-prefix'].'://'.$_SERVER['HTTP_HOST'].'/projects'.$server['project-receiver']; 
		}

		// Set CCS Active
		$_SESSION['ccs']['options']['enabled'] = $CCSenabled;

		// Get WOW Options
		if (file_exists($_SESSION['ccs']['options']['driver-options']['billing-module']['billing-options']['wow-options-file']))
		   $wowxml = simplexml_load_file($_SESSION['ccs']['options']['driver-options']['billing-module']['billing-options']['wow-options-file']);

		if($wowxml) {
			$_SESSION['wow']['address'] = (string)$wowxml->{'wow-address'};
			$_SESSION['wow']['port'] = (int)$wowxml->{'wow-port'};
			$_SESSION['wow']['secure'] = ((string)$wowxml->{'wow-secure'} === "true")?true:false;
			$_SESSION['wow']['fingerprint'] = (string)$wowxml->{'wow-fingerprint'};
			$_SESSION['wow']['staffname'] = $_SESSION['wow']['file_staffname'] = (string)$wowxml->{'wow-username'};
			$_SESSION['wow']['staffpass'] = $_SESSION['wow']['file_staffpass'] = (string)$wowxml->{'wow-password'};
		}


		if($_SESSION['server_type'] == 'WIN')
			set_include_path(get_include_path().';'.$_ENV['TCA_HOME']);
		else
			set_include_path(get_include_path().':'.$_ENV['TCA_HOME']);

		return true;
	} else
		return false;
}

?>
