<?php

// Decoder decodes current request.  Modifies parameters
    
class TemplateEngine extends Smarty 
{
	function __construct()
	{
		global $ACF_TemplateDir, $ACF_CompiledTemplateDir, $ACF_TemplateConfigDir, $ACF_TemplateCacheDir;
    	
		if(empty($ACF_TemplateCacheDir))
			throw new Exception('$ACF_TemplateCacheDir undefined');
 		if(empty($ACF_TemplateConfigDir))
			throw new Exception('$ACF_TemplateConfigDir undefined');
 		if(empty($ACF_CompiledTemplateDir))
			throw new Exception('$ACF_CompiledTemplateDir undefined');
		if(empty($ACF_TemplateDir))
			throw new Exception('$ACF_TemplateDir undefined');
			    			   			   		
		$this->template_dir = $ACF_TemplateDir;
		$this->compile_dir = $ACF_CompiledTemplateDir;
		$this->config_dir = $ACF_TemplateConfigDir;
		$this->cache_dir = $ACF_TemplateCacheDir;
	}
}

function decoder()
{
	$parameterList = new ACF_ParameterList();
	
	// Fetch GET vars
	foreach($_GET as $name=>$value)
		$parameterList->AddParameter(new ACF_DirectParameter($name, $value));

	if(empty($_SERVER['PATH_INFO']))
		$a = array();
	else 
		$a = explode('/', $_SERVER['PATH_INFO']);
	
	while(count($a) && empty($a[0]))
		array_shift($a);
	
	$eventName = count($a) ? array_shift($a) : 'defaultevent';
	
	while(count($a) > 1) { // Parse parameters in the form name1/value1/name2/value2
		$name = strtolower(array_shift($a));
		$value = array_shift($a);
		$parameterList->AddParameter(new ACF_DirectParameter($name, $value));
	}
	
	// Fetch POST vars (trump GET vars and PATHINFO vars)
	foreach($_POST as $name=>$value)
		$parameterList->AddParameter(new ACF_DirectParameter($name, $value));
	
	// Fetch FILES vars (trump POST vars, GET vars, and PATHINFO vars) // Added by JCW (02/28/05)
	foreach($_FILES as $name=>$value) 
		$parameterList->AddParameter(new ACF_DirectParameter($name, $value));

	if(empty($_SERVER["SCRIPT_NAME"]))
		throw new Exception('Cannot read $_SERVER["SCRIPT_NAME"].');
		
	$source = new ACF_EventSource('external', $_SERVER["SCRIPT_NAME"]);
	$event = new ACF_Event($eventName, $parameterList);
	return new ACF_Request($source, $event);
}

?>
