<?php 

function encoder(ACF_ViewInvocation $viewInvocation, $layers = array('defaultlayer'))
{
	$parameters = $viewInvocation->ParameterList()->ParametersArray();

	if(!is_array($parameters))
		throw new exception('encoder(): $parameters is a '.gettype($parameters).' instead of an array of name/value pairs.');

	// Get File Name and File Data
	foreach($parameters as $parameter) {
		if($parameter->Name() == 'filename')
			$filename = $parameter->Value();
		else if($parameter->Name() == 'filedata')
			$filedata = $parameter->Value();
	}

	if($filename && $filedata) {
		header("Pragma: public"); 
		if (strtolower(substr($filename, strrpos($filename, ".") + 1)) == "pdf") {
			header('Content-Type: application/pdf');
			header("Content-Disposition: filename=\"" . $filename . "\"");
		} else {
			header('Content-Type: application/octet-stream');
			header("Content-Disposition: attachment; filename=\"" . $filename . "\"");
		}
		header('Content-Transfer-Encoding: binary');
		header("Content-Length: ".strlen($filedata));
		print $filedata;
	} else
		print ('encoder(): File output missing information: Filename:'.$filename.', FileData: BIN('.strlen($filedata).').');
	
}

function SaveExceptionAndExit(ACF_Exception $e)
{
	global $ACF_LastErrorTemplate;
	
	$te = new TemplateEngine();
	$te->register_outputfilter('SaveErrorAndExit');
	
	$te->assign('sourcelocation', $e->GetSourceLocation());
	$te->assign('message', $e->GetMessage());
	$te->assign('trace', explode("\n",$e->GetTraceAsString()));
	
	$te->display($ACF_LastErrorTemplate);	// Will not return because of output filter that exits.
}

function SaveErrorAndExit($output, &$smarty)
{
	global $ACF_LastErrorFile;
	
	$fp = fopen($ACF_LastErrorFile, 'w');
	if(!$fp)
		return;
	fwrite($fp, $output);
	fclose($fp);
	exit();
}
?>
