<?php 

function encoder(ACF_ViewInvocation $viewInvocation, $layers = array('defaultlayer'))
{
	$parameters = $viewInvocation->ParameterList()->ParametersArray();

	// Get File Name and File Data
	foreach($parameters as $parameter) {
		if($parameter->Name() == 'xml')
			$xml = $parameter->Value();
	}
	
	if(!$xml)
		throw new exception('encoder(): XML not passed.');

	header('Content-type: text/xml');
	print $xml;
}

function SaveExceptionAndExit(ACF_Exception $e)
{
	global $ACF_LastErrorTemplate;
	
	$te = new TemplateEngine();
	$te->register_outputfilter('SaveErrorAndExit');
	
	$te->assign('sourcelocation', $e->GetSourceLocation());
	$te->assign('message', $e->GetMessage());
	$te->assign('trace', explode("\n",$e->GetTraceAsString()));
	
	$te->display($ACF_LastErrorTemplate);	// Will not return because of output filter that exits.
}

function SaveErrorAndExit($output, &$smarty)
{
	global $ACF_LastErrorFile;
	
	$fp = fopen($ACF_LastErrorFile, 'w');
	if(!$fp)
		return;
	fwrite($fp, $output);
	fclose($fp);
	exit();
}
?>
