<?php

function smarty_function_displayknowledgebasetree($args, &$smarty, $target=''){
    print str_repeat("    ", 5) . "<div class=\"Tree\">" . "\n";
    if (extract($args))
        generateTree($tree, $path, $target);
    print str_repeat("    ", 5) . "</div>" . "\n<br />\n";
} 

function generateTree($tree, $path, $target, $indent=6){

/*
    $tree->currentNode
        ->value->display = string from database
        ->value->type = folder|issue|article
        ->name = folder|issue|article 9999
        
*/
//---- start creating the html
    $tree->moveFirst();
    while ($tree->currentNode){

        // Add <DIV> tag to define branch
        print str_repeat("    ", $indent + 1);
        print "<div ";
        print   "id=\"div_" . str_replace(" ", "-", $tree->currentNode->name) . "\" ";
        print   "class=\"" . $tree->currentNode->value->type . "\" ";
        print   "title=\"" . htmlentities($tree->currentNode->value->display, ENT_QUOTES) . "\">";
        print "\n";

        // Add spacers to prefix tree branch icons
        print str_repeat("    ", $indent+2);
        print "<img ";
        print   "src=\"/resources/defaultlayer/knowledgebase/images/space.gif\" ";
        if ($tree->currentNode->child)
            print   "style=\"height:1px;width:" . (($indent-6)*10) . "px;\" />";
        else
            print   "style=\"height:1px;width:" . (($indent-4)*10) . "px;\" />";
            
        print "\n";

        if ($tree->currentNode->child){
            print str_repeat("    ", $indent+2);
            print "<a class=\"icon\" href=\"javascript:switchExpansion('" . str_replace(" ", "-", $tree->currentNode->name) . "');\">";
            print "\n";

            print str_repeat("    ", $indent+3);
            print "<img ";
            print   "id=\"sym_" . str_replace(" ", "-", $tree->currentNode->name) . "\" ";
            print   "src=\"/resources/defaultlayer/knowledgebase/images/menu_minus.gif\" ";
            print "/>";
            print "\n";
        }

        if ($tree->currentNode->child)
            print str_repeat("    ", $indent+3);
        else
            print str_repeat("    ", $indent+2);
            
        // Add icon to tree branch
        print "<img ";
        print   "id=\"img_" . str_replace(" ", "-", $tree->currentNode->name) . "\" ";
        if ($tree->currentNode->value->type == "folder") {
            print   "src=\"/resources/defaultlayer/knowledgebase/images/open_book.gif\" ";
            print   "alt=\"" . $tree->currentNode->name . "\" ";
        } else {
            print   "src=\"/resources/defaultlayer/knowledgebase/images/" . $tree->currentNode->value->type . ".gif\" ";
            print   "alt=\"" . $tree->currentNode->value->type . "\"";
        }
        print "/>";
        print "\n";

        // Close <a> tag
        if ($tree->currentNode->child) {
            print str_repeat("    ", $indent+2);
            print "</a>";
        }
        print "\n";

        print str_repeat("    ", $indent+2);
        print "&nbsp;";
        //---- if the node has a seperate link display it
        if ($tree->currentNode->value->link) {
            if ($tree->currentNode->value->type == "folder") {
                print "<a ";
                print   "href=\"" . $path . "/" . $tree->currentNode->value->link . "\"";
                print   ($target ? " target=\"" . $target . "\"" : "");
                print ">";
                print htmlentities($tree->currentNode->value->display, ENT_QUOTES);
                print "</a>";
            } else { 
                print "<a ";
                print   "id=\"a_" .str_replace(" ", "-", $tree->currentNode->name) . "\"";
                print   "href=\"" . $path . "/" . $tree->currentNode->value->link . "\" ";
                print   ($target ? "target=\"" . $target . "\"" : "");
                print ">";
                print htmlentities($tree->currentNode->value->display, ENT_QUOTES);
                print "</a>";
            }
        } else {
            print htmlentities($tree->currentNode->value->display, ENT_QUOTES) . "\n";
        }
        print "\n";

        // Close <div> tag
        print str_repeat("    ", $indent + 1);
        print "</div>";
        print "\n";

        // If child nodes exist, recursively generate the tree
        if ($tree->currentNode->child){
            print str_repeat("    ", $indent + 1);
            print "<div id=\"span_" . str_replace(" ", "-", $tree->currentNode->name) . "\" style=\"display:block;\">";
            print "\n";
            generateTree($tree->currentNode->child, $path, $target, ($indent+1));
            print str_repeat("    ", $indent + 1);
            print "</div>";
            print "\n";
        }

        $tree->moveNext();
    }
}
?>
