<?php

interface TCA_Cartridge {
    function getVersion();
	
    function getProvider();
	
    function getService();
	
    function getName();
	
    function getServiceOfferings();
	
    function getServiceOfferingByName($serviceName);
	
    function getServiceManager();
	
    function check();
}

abstract class TCA_AbstractCartridge {
    protected $serviceOfferings = array();
    protected $serviceManager;
    
    public function getName() {
    	return $this->getProvider() . '_' . $this->getService();
    }

    public function getServiceOfferings() {
    	return $this->serviceOfferings;
    }

    public function getServiceOfferingByName($serviceName) {
    	return $this->serviceOfferings[$serviceName];
    }

    public function getServiceManager() {
    	return $this->serviceManager;
    }
    
    public function check() {
    	if (count($this->serviceOfferings) == 0) {
    		throw new Exception("No service offerings found in the cartridge");
    	}
    }

    protected function addServiceOffering(TCA_ServiceOffering $serviceOffering) {
    	$this->serviceOfferings[$serviceOffering->getName()] = $serviceOffering;
    }    
}

?>
