<?php

require_once($_ENV['TCA_HOME']."/cartridges/abstract_cartridge.inc.php");
require_once($_ENV['TCA_HOME']."/cartridges/abstract_serviceoffering.inc.php");

require_once("lib/blogware.inc.php");
require_once("lib/blogwaremanager.inc.php");

class TCA_TUCOWS_blogware_cartridge extends TCA_AbstractCartridge implements TCA_Cartridge {
    const PROVIDER = "TUCOWS";
    const SERVICE = "blogware";
    const VERSION = "1.0";
    
    private static $blogwareCartridge = null;
    
    private function __construct() {
    	$this->serviceManager = new TCA_BlogwareServiceManager();

	// Empty Place Holders to pass cart. check b/c blogware doesn't have an abstract layer.
	$trialServiceOffering = new TCA_SimpleServiceOffering("trial");
	$this->addServiceOffering($trialServiceOffering);
    }

    public static function getCartridge() {
    	if (self::$blogwareCartridge === null) {
    		self::$blogwareCartridge = new TCA_TUCOWS_blogware_cartridge();
    	}
    	return self::$blogwareCartridge;
    }

    public function getVersion() {
    	return self::VERSION;
    }

    public function getProvider() {
    	return self::PROVIDER;
    }

    function getService() {
    	return self::SERVICE;
    }
}

?>
