<?php

// marker interfaces
require_once($_ENV['TCA_CARTRIDGES'].'/interface.inc.php');

class TCA_BlogwareDispatcher {
    
    private $blog_map = array(
	"generic"	=> "TCA_GenericBlog",
	"trial"		=> "TCA_TrialBlog",
    );
    
    function getBlog($blogName) {
    	
    	$blogName = strtolower($blogName);
    	//preg_match("/[^\.\/]+$/", $domainName, $matches);
    	//$tld = $matches[0];
    	if ( key_exists($blogName, $this->blog_map) )
	    return new $this->blog_map{$blogName}($blogName);
    	else
	    throw new TCA_IllegalArgumentsException("Invalid Blog: $blogName.");
    }
    
    function getBlogCatalogue() {    	
    	return array_keys($this->blog_map);
    }
    
}

abstract class TCA_Blogware {
    
    protected $blog;
    protected $ruleList;
    
    function __construct($blog) {
	$this->blog = $blog;
    }
    
    function initValidationRuleList() {
    }

    final function getRuleList($action = 'generic') {
    	if ( key_exists($action, $this->ruleList) ) {
	    return $this->ruleList[$action];
    	} else {
    	    return null;
    	}
    }
        
}

class TCA_GenericBlogware extends TCA_Blogware
    implements TCA_Renewable , TCA_Manageable , TCA_Lockable , TCA_Transferable {
    private static $blogwareRuleList = null;
    	
    function __construct($blog) {
	parent::__construct($blog);
    	$this->maxNameLength = 67;

	if (self::$blogwareRuleList == null) {
	    $this->initValidationRuleList();
	    self::$blogwareRuleList = $this->ruleList;
	} else {
	    $this->ruleList = self::$blogwareRuleList;
	}	    	
    }
    
    function initValidationRuleList() {
	parent::initValidationRuleList();
    }        
}

class TCA_TrialBlog extends TCA_Blogware {
    private static $blogwareRuleList = null;
    	
    function __construct($blog) {
	parent::__construct($blog);
    	$this->maxNameLength = 67;

	if (self::$blogwareRuleList == null) {
	    $this->initValidationRuleList();
	    self::$blogwareRuleList = $this->ruleList;
	} else {
	    $this->ruleList = self::$blogwareRuleList;
	}	    	
    }
    
    function initValidationRuleList() {
	parent::initValidationRuleList();
    }
        
}

?>
