<?PHP

class TCA_EnumerationElement {
    private $value;
    private $description;
    
    function __construct($value, $description) {
    	$this->value = $value;
    	$this->description = $description;
    }
    
    function getValue() {
    	return $this->value;
    }
    
    function getDescription() {
    	return $this->description;
    }
}

class TCA_Enumeration {
    private $elements = array();
    private $name;
    
    function __construct($name, $elements) {
    	$this->name = $name;
    	foreach ($elements as $element) {
    		$this->elements[$element->getValue()] = $element;
    	}
    }
    
    function getName() {
    	return $this->name;
    }
    
    function getValues() {    	
    	return array_keys($this->elements);
    }
    
    function getElements() {
    	return array_values($this->elements);
    }
    
    function getElement($value) {
    	return $this->elements[$value];
    }
}

?>
