<?php

class TCA_Exception extends Exception {
    
    function __construct($msg) {
	    parent::__construct($msg);
    }
    
    function GetFunction() {
	    if($this->class)
		    return "$this->class::$this->function()";
	    return "$this->function()";
    }
    
    function GetSourceLocation() {
	    return "Line $this->line of $this->file";
    }
}

class TCA_ConnectionException extends TCA_Exception {}
class TCA_IllegalArgumentsException extends TCA_Exception {}
class TCA_NotImplementedException extends TCA_Exception {}
class TCA_ObjectNotFullyInitializedException extends TCA_Exception {}
class TCA_XMLParseException extends TCA_Exception {}
class TCA_InvalidRequestTypeException extends TCA_Exception {}
class TCA_InvalidServiceActionException extends TCA_Exception {}
class TCA_InvalidServiceRequestException extends TCA_Exception {}
class TCA_ServiceOfferingActionValidationException extends TCA_Exception {}

?>
