<?php

define('PHPUnit2_MAIN_METHOD', '');
set_include_path(get_include_path().":..");

require_once "PHPUnit2/Framework/TestSuite.php";
require_once "PHPUnit2/Framework/TestCase.php";
require_once 'PHPUnit2/TextUI/TestRunner.php';

require_once("client.inc.php");

class apiTest extends PHPUnit2_Framework_TestCase {
    protected static $client;
    protected static $cookie;
    protected $domain = "testbooboo.net";
    protected $domain_new = "tanya.info";
    protected $reg_username = "tanya";
    protected $reg_password = "tanya";
    protected $reseller = "tucows";
    
    public function setUp() {
	if (! self::$client) {
	    self::$client = new TCA_Client(new TCA_XMLConfigReader("tucows-client.xml"));
	}
    }

    public function process($request, $show = false) {
	if ($show) echo "service request: ". $request->__toString()."\n";
	$res = self::$client->processServiceRequest($request);
	if ($show) echo "service response: ". $res->__toString()."\n";
	echo "IS SUCCESS: ".$res->isSuccess()."\n";
	echo "RESPONSE CODE: ".$res->getResponseCode()."\n";
	echo "RESPONSE TEXT: ".$res->getResponseText()."\n";
	return $res;
    }

    public function setCookie() {
	$request = self::$client->createServiceRequest('TUCOWS_domains.set_cookie');
	$pSet = new TCA_ServiceRequestParameterSet();
	$pSet->addParameter(new TCA_ServiceRequestParameter('domain', $this->domain));
	$pSet->addParameter(new TCA_ServiceRequestParameter("reg_username", $this->reg_username));
	$pSet->addParameter(new TCA_ServiceRequestParameter("reg_password", $this->reg_password));
	$request->addParameterSet('attributes',$pSet);
	$result = $this->process($request);
	if (!$result->isSuccess()) {
	    throw Exception("set cookie failed -- ". $result->getResponseText());
	} else {
	    self::$cookie = $result->getResponseData()->getElement("attributes")->getElement('cookie')->getValue();
	}
    }

    public function updateCookie($new_domain = null) {
	$request = self::$client->createServiceRequest('TUCOWS_domains.update_cookie');
	$request->addParameter(new TCA_ServiceRequestParameter('cookie', self::$cookie));
	$pSet = new TCA_ServiceRequestParameterSet();
	$pSet->addParameter(new TCA_ServiceRequestParameter('domain', $this->domain));
	$pSet->addParameter(new TCA_ServiceRequestParameter('domain_new', $new_domain === null ? $this->domain_new : $new_domain));
	$pSet->addParameter(new TCA_ServiceRequestParameter("reg_username", $this->reg_username));
	$pSet->addParameter(new TCA_ServiceRequestParameter("reg_password", $this->reg_password));
	$request->addParameterSet('attributes',$pSet);
	$result = $this->process($request);
	if (!$result->isSuccess()) {
	    throw Exception("update cookie failed -- ". $result->getResponseText());
	} else {
	    self::$cookie = $result->getResponseData()->getElement("attributes")->getElement('cookie')->getValue();
	}
    }

    public function deleteCookie() {
	$request = self::$client->createServiceRequest('TUCOWS_domains.delete_cookie');
	$pSet = new TCA_ServiceRequestParameterSet();
	$pSet->addParameter(new TCA_ServiceRequestParameter('cookie', self::$cookie));
	$request->addParameterSet('attributes',$pSet);
	$result = $this->process($request);
	if (!$result->isSuccess()) {
	    throw Exception("delete cookie failed!");
	}
    }

}

?>
