<?php

define('PHPUnit2_MAIN_METHOD', '');

set_include_path(get_include_path().":..");

require_once "PHPUnit2/Framework/TestSuite.php";
require_once "PHPUnit2/Framework/TestCase.php";
require_once 'PHPUnit2/TextUI/TestRunner.php';
require_once("connector.inc.php");

class communicationTest extends PHPUnit2_Framework_TestCase {
    private $request = array(
		protocol => 'XCP',
		action => 'lookup',
		object => 'domain',
		attributes => array(
		    domain => 'tucows.com',
		),
	    );
    private $connRequest;
    private $connResponse;
    private $authInfo;
    private $cbcRemoteEnd;
    private $httpsRemoteEnd;

    public function setUp() {
	$this->connRequest = new TCA_ConnectorRequest();
	$this->connRequest->setRequest($this->request);
	$this->authInfo = new TCA_ResellerAuthInfo(
				"YOURUSERNAME",
				"YOURKEY" 
			      );
	$this->cbcRemoteEnd = new TCA_RemoteEnd("horizon.opensrs.net", "55000");
	$this->httpsRemoteEnd = new TCA_RemoteEnd("horizon.opensrs.net", "55443");
    }

    public function testCBCConnector() {
	print "\n**** Enter test Connector CBC with Blowfish\n";
	$this->connect('TCA_CbcConnector', 'TCA_BlowfishCipher', $this->cbcRemoteEnd);
	print "\n**** Exit test Connector CBC with Blowfish\n";
	
	print "\n**** Enter test Connector CBC with Des\n";
	$this->connect('TCA_CbcConnector', 'TCA_DesCipher', $this->cbcRemoteEnd);
	print "\n**** Exit test Connector CBC with Des\n";
    }
    
    public function testHttpsConnector() {
	print "\n**** Enter test Connector HTTPS with Null Cipher\n";
	$this->connect('TCA_HttpsConnector', 'TCA_NullCipher', $this->httpsRemoteEnd);
	print "\n**** Exit test Connector HTTPS with Null Cipher\n";
    }
    
    private function connect($connType, $cipher, $remote) {
	$cbc = new TCA_Connector($connType,
	                         "TCA_OPS",
			         $cipher); 
	$cbc->setResellerAuthInfo($this->authInfo);
	$cbc->setRemoteEnd($remote);
	try {
	    $connResponse = $cbc->sendCommand($this->connRequest);
	    $response = $connResponse->getResponse();
	} catch ( TCA_ConnectionException $ConnectionException ) {
	    $this->fail("Connection Failed: ".$ConnectionException->getMessage());
	} catch ( TCA_XMLParseException $XMLParseException ) {
	    $this->fail("XML Parsing Failed: ".$XMLParseException->getMessage());
	}
    }
}

$suite = new PHPUnit2_Framework_TestSuite(new ReflectionClass('communicationTest'));
PHPUnit2_TextUI_TestRunner::run($suite);

?>    
