<?php

require_once("../util/configreader.inc.php");
require_once("../exceptions.inc.php");
require_once("../connector.inc.php");

$confFile = "../tucows-client.xml";

$xmlConf = new TCA_XMLConfigReader($confFile);
$conf = $xmlConf->parseConfig();

$resSettings = $conf->communication->{"reseller-settings"};
$authinfo = new TCA_ResellerAuthInfo(
    $resSettings->{"reseller-auth-info"}->username->value,
    $resSettings->{"reseller-auth-info"}->{"private-key"}->value
);
$conn = new TCA_Connector($resSettings->{"service-endpoint"}->{"connection-type"}->class->value,
	    "TCA_OPS",
	    $resSettings->{"service-endpoint"}->{"encryption-type"}->class->value);
$conn->setResellerAuthInfo($authinfo);
$conn->setRemoteEnd(
	new TCA_RemoteEnd($resSettings->{"service-endpoint"}->hostname->value,
			  $resSettings->{"service-endpoint"}->port->value));

print "\nconnection_type: ".$conf->communication->{"reseller-settings"}->{"service-endpoint"}->{"connection-type"}->class->value;
print "\nencryption_type: ".$conf->communication->{"reseller-settings"}->{"service-endpoint"}->{"encryption-type"}->class->value;
print "\nmanager attr: ".$conf->manager->attr("class");

print "\n";

?>
