<?php

set_include_path(get_include_path().":..");
require_once("connector.inc.php");

/* 
   This script tests HTTPS and CBC connections .
   TPP test is currently not implemented.
*/ 

$request = array(
    protocol => 'XCP',
    action => 'lookup',
    object => 'domain',
    attributes => array(
	domain => 'tucows.com',
    ),
);
$connRequest = new TCA_ConnectorRequest();
$connRequest->setRequest($request);

$request2 = array(
    protocol => 'XCP',
    action => 'lookup',
    object => 'domain',
    attributes => array(
	domain => 'tucows_invalid.com',
    ),
);
$connRequest2 = new TCA_ConnectorRequest();
$connRequest2->setRequest($request2);

$authinfo = new TCA_ResellerAuthInfo(
    "YOURUSERNAME", //reseller username, must be filled up before using
    "YOURKEY"  //reseller private key, must be filled up before using
);

//test CBC connection below
$cbc = new TCA_Connector("TCA_CbcConnector",
		       "TCA_OPS", 
		       "TCA_BlowfishCipher"); // TCA_DesCipher
$cbc->setResellerauthInfo($authinfo);
$cbc->setRemoteEnd(new TCA_RemoteEnd("horizon.opensrs.net", "55000")); //cbc

try {
    $connResponseCBC = $cbc->sendCommand($connRequest);
    $responseCBC = $connResponseCBC->getResponse();
}
catch ( TCA_ConnectionException $ConnectionException ) {
    $responseCBC = $ConnectionException->getMessage();
}
catch ( TCA_XMLParseException $XMLParseException ) {
    $responseCBC = $XMLParseException->getMessage();
} 

try {
    $connResponseCBC2 = $cbc->sendCommand($connRequest2);
    $responseCBC2 = $connResponseCBC2->getResponse();
}
catch ( TCA_ConnectionException $ConnectionException ) {
    $responseCBC2 = $ConnectionException->getMessage();
}
catch ( TCA_XMLParseException $XMLParseException ) {
    $responseCBC2 = $XMLParseException->getMessage();
} 


//test HTTPS connection below
$https = new TCA_Connector("TCA_HttpsConnector",
		       "TCA_OPS", 
		       "TCA_NullCipher"); 
$https->setResellerauthInfo($authinfo);
$https->setRemoteEnd(new TCA_RemoteEnd("horizon.opensrs.net", "55443")); //https

try {
    $connResponseHttps = $https->sendCommand($connRequest);
    $responseHttps = $connResponseHttps->getResponse();
}
catch ( TCA_ConnectionException $ConnectionException ) {
    $responseHttps = $ConnectionException->getMessage();
}
catch ( TCA_XMLParseException $XMLParseException ) {
    $responseHttps = $XMLParseException->getMessage();
} 

try {
    $connResponseHttps2 = $https->sendCommand($connRequest2);
    $responseHttps2 = $connResponseHttps2->getResponse();
}
catch ( TCA_ConnectionException $ConnectionException ) {
    $responseHttps2 = $ConnectionException->getMessage();
}
catch ( TCA_XMLParseException $XMLParseException ) {
    $responseHttps2 = $XMLParseException->getMessage();
} 


if ( $_SERVER{'DOCUMENT_ROOT'} ) {

print <<<HTML
    <!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN">
	<html>
	    <head>
		<title>Test Connection</title>
		<meta http-equiv="Content-Type" content="text/html; charset=iso-8859-1">
            </head>
            <body>
		<table border>
		    <tr><th colspan=3>Test Results for Lookup Domain Command</th></tr>
HTML;

print "<tr>";
print "<td><b>Request</b></td>";
print "<td><b>Response through CBC connection</b></td>";
print "<td><b>Response through HTTPS connection</b></td>";
print "</tr>";
print "<tr>";
print "<td><pre>";
print_r($request);
print "</pre></td><td><pre>";
print_r($responseCBC);
print "</pre></td><td><pre>";
print_r($responseHttps);
print "</pre></td>";
print "</tr>";
print "<tr>";
print "<td><pre>";
print_r($request2);
print "</pre></td><td><pre>";
print_r($responseCBC2);
print "</pre></td><td><pre>";
print_r($responseHttps2);
print "</pre></td>";
print "</tr>";

print <<<HTML
		</table>
            </body>
	</html>       
HTML;
} else {
	print("Test Results for Lookup Domain Command\n\n");
	print("Request 1:\n");
	print_r($request);
	print("Response 1 through CBC connection:\n");
	print_r($responseCBC);
	print("Response 1 through HTTPS connection:\n");
	print_r($responseHttps);

	print "\n\n";

	print("Request 2:\n");
	print_r($request2);
	print("Response 2 through CBC connection:\n");
	print_r($responseCBC2);
	print("Response 2 through HTTPS connection:\n");
	print_r($responseHttps2);
}

?>
