<?php

set_include_path(get_include_path().":..");
require_once("client.inc.php");

function process($client, $request) {
    echo "service request: ". $request->__toString()."\n";
    $res = $client->processServiceRequest($request);

#    echo "service response: ". $res->__toString()."\n";
    echo "IS SUCCESS: ".$res->isSuccess()."\n";
    echo "RESPONSE CODE: ".$res->getResponseCode()."\n";
    echo "RESPONSE TEXT: ".$res->getResponseText()."\n";

    return $res;
}

// instantiate the client object, pass config object
$client = new TCA_Client(new TCA_XMLConfigReader("tucows-client.xml"));

//domain, reg_username and reg_password should be filled in below
$domain = "testbooboo.net";
$domain_new = "tanya.info";
$reg_username = "tanya";
$reg_password = "tanya";

echo "\n\n---- Set Cookie ----\n\n";
$request = $client->createServiceRequest('TUCOWS_domains.set_cookie');
$pSet = new TCA_ServiceRequestParameterSet();
$pSet->addParameter(new TCA_ServiceRequestParameter('domain', $domain));
$pSet->addParameter(new TCA_ServiceRequestParameter("reg_username", $reg_username));
$pSet->addParameter(new TCA_ServiceRequestParameter("reg_password", $reg_password));
$request->addParameterSet('attributes',$pSet);
$result = process($client, $request);
$cookie;
if (!$result->isSuccess()) {
    exit;
} else {
    $cookie = $result->getResponseData()->getElement("attributes")->getElement('cookie')->getValue();
    echo "Cookie -- $cookie\n";
}


echo "\n\n---- Update Cookie ----\n\n";
$request = $client->createServiceRequest('TUCOWS_domains.update_cookie');
$request->addParameter(new TCA_ServiceRequestParameter('cookie', $cookie));
$pSet = new TCA_ServiceRequestParameterSet();
$pSet->addParameter(new TCA_ServiceRequestParameter('domain', $domain));
$pSet->addParameter(new TCA_ServiceRequestParameter('domain_new', $domain_new));
$pSet->addParameter(new TCA_ServiceRequestParameter("reg_username", $reg_username));
$pSet->addParameter(new TCA_ServiceRequestParameter("reg_password", $reg_password));
$request->addParameterSet('attributes',$pSet);
process($client, $request);


echo "\n\n---- Delete Cookie ----\n\n";
$request = $client->createServiceRequest('TUCOWS_domains.delete_cookie');
$pSet = new TCA_ServiceRequestParameterSet();
$pSet->addParameter(new TCA_ServiceRequestParameter('cookie', $cookie));
$request->addParameterSet('attributes',$pSet);
process($client, $request);

?>
