<?php

set_include_path(get_include_path().":..");
require_once("client.inc.php");

function process($client, $workUnit) {
    $workUnitBundle = new TCA_WorkUnitBundle();
    $workUnitBundle->addWorkUnit($workUnit);

    $workOrder = $client->createWorkOrder();
    $workOrder->addWorkUnitBundle($workUnitBundle);

//    var_dump($workOrder);

    $res = $client->processWorkOrder($workOrder);
    print "result: ";
    if ($res->isSuccess()) {
	print "Command successful!";
    } else {
	$workUnitResp = $res->getWorkUnitBundleResponseList();
	$workUnitResp = $workUnitResp['0']->getWorkUnitResponseList();
	$workUnitResp = $workUnitResp['0'];
	print "Command failed: ".$workUnitResp->getResponseCode()." - ".$workUnitResp->getResponseText()."\n";
    }
    print "\n";
    return $res;
}

// instantiate the client object, pass config object
$client = new TCA_Client(new TCA_XMLConfigReader("../tucows-client.xml"));

//domain, reg_username and reg_password should be filled in below
$domain = "testbooboo.net";
$domain_new = "tanya.info"; 
$reg_username = "tanya";
$reg_password = "tanya";

// create a cookie using order workflow API
$workUnit = new TCA_WorkUnit();
$workUnit->addParameter(new TCA_WorkUnitParameter("protocol", "XCP"));
$workUnit->addParameter(new TCA_WorkUnitParameter("action", "set"));
$workUnit->addParameter(new TCA_WorkUnitParameter("object", "cookie"));
$attributes = new TCA_WorkUnitParameterSet();
$attributes->addParameter(new TCA_WorkUnitParameter("domain", $domain));
$attributes->addParameter(new TCA_WorkUnitParameter("reg_username", $reg_username));
$attributes->addParameter(new TCA_WorkUnitParameter("reg_password", $reg_password));
$workUnit->addParameterSet("attributes", $attributes);

print "\n\n---- Set Cookie ----\n\n";
$result = process($client, $workUnit);
$cookie;
if (!$result->isSuccess()) {
    exit;
} else {
    $respData = $result->getWorkUnitBundleResponseList();
    $respData = $respData['0']->getWorkUnitResponseList();
    $respData = $respData['0']->getResponseData();
    $cookie = $respData->getElement("attributes")->getElement('cookie')->getValue();
}
print "Cookie -- $cookie\n";

$workUnit = new TCA_WorkUnit();
$workUnit->addParameter(new TCA_WorkUnitParameter("protocol", "XCP"));
$workUnit->addParameter(new TCA_WorkUnitParameter("action", "update"));
$workUnit->addParameter(new TCA_WorkUnitParameter("object", "cookie"));
$workUnit->addParameter(new TCA_WorkUnitParameter("cookie", $cookie));
$attributes = new TCA_WorkUnitParameterSet();
$attributes->addParameter(new TCA_WorkUnitParameter("domain", $domain));
$attributes->addParameter(new TCA_WorkUnitParameter("domain_new", $domain_new));
$attributes->addParameter(new TCA_WorkUnitParameter("reg_username", $reg_username));
$attributes->addParameter(new TCA_WorkUnitParameter("reg_password", $reg_password));
$workUnit->addParameterSet("attributes", $attributes);

print "\n\n---- Update Cookie ----\n\n";
process($client, $workUnit);

$workUnit = new TCA_WorkUnit();
$workUnit->addParameter(new TCA_WorkUnitParameter("protocol", "XCP"));
$workUnit->addParameter(new TCA_WorkUnitParameter("action", "delete"));
$workUnit->addParameter(new TCA_WorkUnitParameter("object", "cookie"));
$attributes = new TCA_WorkUnitParameterSet();
$attributes->addParameter(new TCA_WorkUnitParameter("cookie", $cookie));
$workUnit->addParameterSet("attributes", $attributes);

print "\n\n---- Delete Cookie ----\n\n";
process($client, $workUnit);

?>
