<?php
set_include_path(get_include_path().":..");

require_once("client.inc.php");

TCA_Client::initEnv();
$client = new TCA_Client(new TCA_XMLConfigReader("tucows-client.xml"));

$servicePackageManager = $client->getServicePackageManager();

$package = $servicePackageManager->getServicePackageByName('domains_com');

$serviceOffering = $package->getServiceOfferingByName('.com');

$action = $serviceOffering->getActionByName('provision');

$parameters = $action->getParametersContainer();

$attr = $parameters->getChildContainerByName('attributes');
$attr->getParameterByName('handle')->setValue('process');
$attr->getParameterByName('domain')->setValue('provision'. time() .'.com');
$attr->getParameterByName('reg_domain')->setValue('tanya.info');
$attr->getParameterByName('reg_username')->setValue('tanya');
$attr->getParameterByName('reg_password')->setValue('tanya');
$attr->getParameterByName('encoding_type')->setValue('ascii');
$attr->getParameterByName('period')->setValue('1');
$attr->getParameterByName('custom_nameservers')->setValue('1');
$attr->getParameterByName('custom_tech_contact')->setValue('0');

$nameServerListParam = $attr->getChildContainerByName('nameserver_list');
$nameServerListParam->getChildContainerByName('ns1')->getParameterByName('name')->setValue('dns1.tucows.com');
$nameServerListParam->getChildContainerByName('ns2')->getParameterByName('name')->setValue('dns2.tucows.com');

$contactSetContainer = $attr->getChildContainerByName('contact_set');

$contact = $contactSetContainer->getChildContainerByName('admin');
$contact->getParameterByName('first_name')->setValue('John');
$contact->getParameterByName('last_name')->setValue('Doe');
$contact->getParameterByName('org_name')->setValue('Secret Organization');
$contact->getParameterByName('address1')->setValue('100 Main Str.');
$contact->getParameterByName('city')->setValue('Capital City');
$contact->getParameterByName('state')->setValue('Orange State');
$contact->getParameterByName('postal_code')->setValue('1234');
$contact->getParameterByName('phone')->setValue('+1.4165350123');
$contact->getParameterByName('email')->setValue('ikolomiets@tucows.com');
$contact->getParameterByName('country')->setValue('CA');

$contact = $contactSetContainer->getChildContainerByName('billing');
$contact->getParameterByName('first_name')->setValue('Foo');
$contact->getParameterByName('last_name')->setValue('Bar');
$contact->getParameterByName('org_name')->setValue('Mean Organization');
$contact->getParameterByName('address1')->setValue('101 Main Str.');
$contact->getParameterByName('city')->setValue('Suburb City');
$contact->getParameterByName('state')->setValue('Apple State');
$contact->getParameterByName('postal_code')->setValue('4321');
$contact->getParameterByName('phone')->setValue('+1.4165350123');
$contact->getParameterByName('email')->setValue('ikolomiets@tucows.com');
$contact->getParameterByName('country')->setValue('US');

$contact = $contactSetContainer->getChildContainerByName('owner');
$contact->getParameterByName('first_name')->setValue('Igor');
$contact->getParameterByName('last_name')->setValue('Kolomiets');
$contact->getParameterByName('org_name')->setValue('Tucows');
$contact->getParameterByName('address1')->setValue('96 Mowat Avenue');
$contact->getParameterByName('city')->setValue('Toronto');
$contact->getParameterByName('state')->setValue('Ontario');
$contact->getParameterByName('postal_code')->setValue('M6K 3M1');
$contact->getParameterByName('phone')->setValue('+1.4165350123');
$contact->getParameterByName('email')->setValue('ikolomiets@tucows.com');
$contact->getParameterByName('country')->setValue('CA');

echo "Provision domain parameters:\n" . $parameters->__toString();

$result =  $action->perform();

echo "Provision domain result:\n" . $result->__toString();

?>
