<?php

set_include_path(get_include_path().":..");
require_once("client.inc.php");
require_once("util/string.inc.php");

TCA_Client::initEnv();

$client = new TCA_Client(new TCA_XMLConfigReader("tucows-client.xml"));

///////////////// set cookie /////////////

$domain = "testbooboo.net";
$reg_username = "tanya";
$reg_password = "tanya";

$request = $client->createServiceRequest('TUCOWS_domains.set_cookie');


$pSet = new TCA_ServiceRequestParameterSet();
$pSet->addParameter(new TCA_ServiceRequestParameter('domain', $domain));
$pSet->addParameter(new TCA_ServiceRequestParameter("reg_username", $reg_username));
$pSet->addParameter(new TCA_ServiceRequestParameter("reg_password", $reg_password));
$request->addParameterSet('attributes', $pSet);
$result = $client->processServiceRequest($request);

$cookie;
if (!$result->isSuccess()) {
    exit;
} else {
    $cookie = $result->getResponseData()->getElement("attributes")->getElement('cookie')->getValue();
}

////////////////// test query domain /////////////

$servicePackageManager = $client->getServicePackageManager();

$servicePackage = $servicePackageManager->getServicePackageByName('domains_net');

$serviceOffering = $servicePackage->getServiceOfferingByName('.net');

$soAction = $serviceOffering->getActionByName('query');

$cookieParam = $soAction->getParametersContainer()->getParameterByName('cookie');
$cookieParam->setValue($cookie);

$attrContainer = $soAction->getParametersContainer()->getChildContainerByName('attributes');

$typeParam = $attrContainer->getParameterByName('type');

$typeParam->setValue('nameservers');

echo "Query domain params:\n" .
    $soAction->getParametersContainer()->__toString();

$result = $soAction->perform();

echo "Query domain result:\n" . $result->__toString();

?>
