<?php

set_include_path(get_include_path().":..");
require_once("client.inc.php");
require_once("util/string.inc.php");

TCA_Client::initEnv();

$client = new TCA_Client(new TCA_XMLConfigReader("tucows-client.xml"));

$cartridegManager = $client->getCartridgeManager();

$domainCartridge = $cartridegManager->getCartridgeByName("TCA_TUCOWS_domains_cartridge");

$domainCartridge->getServiceManager()->setWorkOrderManager($client->getWorkOrderManager());

$serviceOfferings = $domainCartridge->getServiceOfferings();

$soAction = $serviceOfferings['.com']->getActionByName('refund');

$attrContainer = $soAction->getParametersContainer()->getChildContainerByName('attributes');

$attrContainer->getParameterByName('domain')->setValue('acf-test-1095280560.com');
$attrContainer->getParameterByName('reseller')->setValue('tucows');
$attrContainer->getParameterByName('notes')->setValue('stupid notes');

echo "Refund domain params:\n" .
    $soAction->getParametersContainer()->__toString();

$result = $soAction->perform();

echo "Refund domain result:\n" . $result->__toString();

?>
