<?php

require_once("../exceptions.inc.php");
require_once("../services/domain.inc.php");

$domainDispatcher = new TCA_DomainDispatcher();

// get tld catalogue
$catalogue = $domainDispatcher->getTldCatalogue();

echo "AVAILABLE TLDS: ";
print_r($catalogue);

try {
    
    foreach ( $catalogue as $tld ) {
    	$domainName = "test.$tld";
	$domain = $domainDispatcher->getDomain($domainName);
	echo "MAX domain name length for $tld: ".
	    $domain->getMaxNameLength()."\n";
    }

    // throw exception
    $domain = $domainDispatcher->getDomain("test.uk");
    
} catch (TCA_IllegalArgumentsException $e) {
    echo "Exception: ".$e->getMessage()."\n";	
}

?>