<?php

set_include_path(get_include_path().":..");
require_once("client.inc.php");

class domainUsage {
    //domain, reg_username and reg_password should be filled in below

    protected $domain = "testbooboo.net";
    protected $domain_new = "tanya.info";
    protected $reg_username = "tanya";
    protected $reg_password = "tanya";
    protected $reseller = "tucows";
    protected $show = false;
    protected $client;
    protected $cookie;
    
    function setShow($show) {
	$this->show = $show;
    }
    
    function __construct() {
	$this->client = new TCA_Client(new TCA_XMLConfigReader("tucows-client.xml"));
    }

    function _getRegPassword() {
	return $this->reg_password;
    }
    
    function wait($seconds=1) {
	sleep($seconds);
    }
    
    function process($request, $show = true) {
	$res = null;
	try {
//	    if ($this->show) echo "service request: ". $request->__toString()."\n";
	    $res = $this->client->processServiceRequest($request);

	    if ($this->show) echo "service response: ". $res->__toString()."\n";
	    echo "IS SUCCESS: ".$res->isSuccess()."\n";
	    echo "RESPONSE CODE: ".$res->getResponseCode()."\n";
	    echo "RESPONSE TEXT: ".$res->getResponseText()."\n";
	} catch (Exception $e) {
	    echo "ERROR: ".$e->getMessage()."\n";
	}
	return $res;
    }

    function setCookie() {
	echo "\n\n---- Set Cookie ----\n\n";
	$request = $this->client->createServiceRequest('TUCOWS_domains.set_cookie');
	$pSet = new TCA_ServiceRequestParameterSet();
	$pSet->addParameter(new TCA_ServiceRequestParameter('domain', $this->domain));
	$pSet->addParameter(new TCA_ServiceRequestParameter("reg_username", $this->reg_username));
	$pSet->addParameter(new TCA_ServiceRequestParameter("reg_password", $this->reg_password));
	$request->addParameterSet('attributes',$pSet);
	$result = $this->process($request, false);
	if (!$result->isSuccess()) {
	    throw new Exception("set cookie failed -- ". $result->getResponseText());
	} else {
	    $this->cookie = $result->getResponseData()->getElement("attributes")->getElement('cookie')->getValue();
	}
    }

    function updateCookie($new_domain = null) {
	echo "\n\n---- Update Cookie ----\n\n";
	$request = $this->client->createServiceRequest('TUCOWS_domains.update_cookie');
	$request->addParameter(new TCA_ServiceRequestParameter('cookie', $this->cookie));
	$pSet = new TCA_ServiceRequestParameterSet();
	$pSet->addParameter(new TCA_ServiceRequestParameter('domain', $this->domain));
	$pSet->addParameter(new TCA_ServiceRequestParameter('domain_new', $new_domain === null ? $this->domain_new : $new_domain));
	$pSet->addParameter(new TCA_ServiceRequestParameter("reg_username", $this->reg_username));
	$pSet->addParameter(new TCA_ServiceRequestParameter("reg_password", $this->reg_password));
	$request->addParameterSet('attributes',$pSet);
	$result = $this->process($request, false);
	if (!$result->isSuccess()) {
	    throw new Exception("update cookie failed -- ". $result->getResponseText());
	} else {
	    $this->cookie = $result->getResponseData()->getElement("attributes")->getElement('cookie')->getValue();
	}
    }

    function deleteCookie() {
	echo "\n\n---- Delete Cookie ----\n\n";
	$request = $this->client->createServiceRequest('TUCOWS_domains.delete_cookie');
	$pSet = new TCA_ServiceRequestParameterSet();
	$pSet->addParameter(new TCA_ServiceRequestParameter('cookie', $this->cookie));
	$request->addParameterSet('attributes',$pSet);
	$this->process($request, false);
    }

    function getCookie() {
	$this->setCookie();
    	return $this->cookie;
    }
}

?>
