<?php

set_include_path(get_include_path().":..");
require_once("client.inc.php");

// instantiate the client object, pass config object
$client = new TCA_Client(new TCA_XMLConfigReader("tucows-client.xml"));

// list of domains
$domains = array( 
    'tucows.com',	// domain taken
    'zdfkjkll.com',	// domain available 
    '++++++.com',	// invalid domain name
    '',			// empty
    domains => 'tucows.com',	// invalid parameter name (correct param not specified)
); 
    
foreach ( $domains as $param => $domain_name ) {     
    if ( $param !== 'domains' ) $param = 'domain';
    
    // lookup a domain using business layer API
    $request = $client->createServiceRequest('TUCOWS_domains.lookup_domain');
    $pSet = new TCA_ServiceRequestParameterSet();
    $pSet->addParameter(new TCA_ServiceRequestParameter($param, $domain_name));
    $request->addParameterSet('attributes',$pSet);
    //echo "service request: ". $request->__toString()."\n";
    echo "===================================================================================\n";
    try {
	$res = $client->processServiceRequest($request);
	// echo "service response: ". $res->__toString()."\n";
	echo "IS SUCCESS: ".$res->isSuccess()."\n";
	echo "RESPONSE CODE: ".$res->getResponseCode()."\n";
	echo "RESPONSE TEXT: ".$res->getResponseText()."\n";
    } catch (Exception $e) {
	echo "ERROR: ".$e->getMessage()."\n";
    }
    echo "===================================================================================\n";
}

?>
