<?php

class TCA_Configurator {
    private $_path;
    private $_xml;

    function __construct($path) {
        $this->_path = $path;
        $this->_xml = simplexml_load_file($this->_path);
    }

    function save() {
        $fh = fopen($this->_path,"w");
        fwrite($fh, $this->_xml->asXML());
        fclose ($fh);
    }

    function getValue($path) {
        $elems = explode('/', $path);
        $temp = $this->_xml->{array_shift($elems)};
        foreach ($elems as $elem)
            $temp = $temp->$elem;
        return $temp;
    }

    function setValue($path, $value) {
        $elems = explode('/', $path);
        $temp = $this->_xml->{array_shift($elems)};
        foreach ($elems as $elem)
            $temp = $temp->$elem;
            $temp[0] = $value;
        }

    // convenience functions
    function getPrivateKey() {
        return $this->_xml->communication_layer->reseller_auth_info->private_key;
    }

    function getUsername() {
        return $this->_xml->communication_layer->reseller_auth_info->username;
    }

    function getConnectionType() {
        return $this->_xml->communication_layer->connection_type;
    }

    function getEncryptionType() {
        return $this->_xml->communication_layer->encryption_type;
    }

    function getPort($type) {
        return $this->_xml->communication_layer->remote_end->port->$type;
    }

    function getHost($type) {
        return $this->_xml->communication_layer->remote_end->host->$type;
    }
}

?>
