<?php

class IdnConverter {
    private static $idnHost = "rr-n1-tor.opensrs.net";
    private static $idnPort = "55044";

    public static function setIdnHost($host) {
        self::$idnHost = $host;
    }

    public static function setIdnPort($port) {
        self::$idnPort = $port;
    }

    public static function nativeToPunycode($native, $encoding='UTF-8') {
        if (!preg_match('/[^a-z0-9\.\-]/', $native)) {
            return $native;
        }
        return IdnConverter::convert(array('command' => 'from',
               'str' => $native,
               'encoding' => $encoding)
        );
    }

    public static function punycodeToNative($punycode, $encoding='UTF-8') {
        if (!preg_match('/^xn--/', $punycode)) {
            return $punycode;
        }
        return IdnConverter::convert(array('command' => 'to',
               'str' => $punycode,
               'encoding' => $encoding)
        );
    }

    private static function convert($data) {
        $converted = '';
        $httpRequest = 
                "http://" . self::$idnHost . ":" . self::$idnPort .
                "?$data[command]=$data[encoding]&name=$data[str]";
        $fp = fopen($httpRequest, 'r');
        $response= stream_get_contents($fp);

        $contents = array();
        foreach (explode("\015\012", $response) as $str) {
            list ($key, $value) = explode("=", $str);
            if (!empty($key)) {
                $contents[$key] = $value;
            }
        }

        if ($contents['is_success']) {
            if ($data['command'] == 'from') {
                $converted = $contents['punycode'];
            } else {
                $converted = $contents['native'];
            }
        } else {
            $converted = $data['str'];
        }
        return $converted;
    }
}

?>
