<?php

    global $backwards;
    global $previous;
    $backwards  = false;
//---- Resume the session or start a new one
    if (isset($_GET['NEWSESSION'])) {        //---- URL flag to start a new session.  Helps with testing.
        session_start();
        session_destroy();
        $_SESSION = array();
    }

    if (!session_id())
        session_start();

//---- load the steps
    if (!$_SESSION['ccs']['configuration']['steps']){
        $_SESSION['ccs']['configuration']['steps'] = array();

//---- load options file
    if (file_exists('../../etc/ccs_options.xml')) {
        $xml = simplexml_load_file('../../etc/ccs_options.xml');
        if($xml)
            $_SESSION['ccs']['configuration']['loadedOptions'] = convertSimpleXMLToArray($xml);
    }else
	$_SESSION['ccs']['configuration']['message'] = "File 'etc/ccs_options.xml' not found please run 'etc/setup.php' before using this wizard.";

//---- flag so we do not skip the display of the first page
        $firstStep = true;
        if (file_exists('configure/stepconfig.xml')){
            $xml = simplexml_load_file('configure/stepconfig.xml');
            if($xml){
                $arrayXML = convertSimpleXMLToArray($xml);
                foreach($arrayXML['steps']['step'] as $step)
                    $_SESSION['ccs']['configuration']['steps'][$step] = array('active' => true);
                foreach($_SESSION['ccs']['configuration']['steps'] as $key => $step)
                    if ($step['active']){
                        $_SESSION['ccs']['configuration']['current'] = $key;
                        break;
                    }
                $_SESSION['ccs']['configuration']['data'] = array();
            }
        }
    }

//---- setup short reference names
    $data    = &$_SESSION['ccs']['configuration']['data'];
    $current = &$_SESSION['ccs']['configuration']['current'];
    $steps   = &$_SESSION['ccs']['configuration']['steps'];

//---- if a step is passed in make sure we are on it (this is for when people hit refresh)
    $checkStep = $_POST['ccsStep'] ? $_POST['ccsStep'] : $_GET['ccsStep'];
    if (array_key_exists($checkStep, $steps) && $steps[$checkStep]['active'])
        $current = $checkStep;

//--- if back is clicked jump back a step
    if ($_POST['backButton'] || $_GET['backButton']){
        $previous  = $current;
        $backwards = true;
        if (!$steps[$current]['stayOnCurrentStep'])
            getNextStep(array_reverse($steps, true));
    }

//---- if the file defined in the step exist bring it in
    if (file_exists("configure/" . $current . ".inc.php")){
        require_once("configure/" . $current . ".inc.php");
//---- if this is not the first time here or if back was not pressed attempt the execute function for the current step
        if (!$firstStep && ($_POST || ($_GET && !isset($_GET['NEWSESSION']))) && !$backwards){
            if (eval('return ' . $current . 'Execute();')){
//---- the execution was successful move to the next step and bring in the next file
                getNextStep($steps);
                if (file_exists("configure/" . $current . ".inc.php"))
                    require_once("configure/" . $current . ".inc.php");
                else if(file_exists('configure/error.php'))
                    print "Error Encountered: Failed to find file 'configure/$current'.\nPlease seek professional help.";
                else
                    print "Error Encountered: Failed to find file 'configure/error.php'.\nPlease seek professional help.";
            }
        }
//---- execute the init for the current step
        eval($current . 'Init();');
    }else if(file_exists('configure/error.php'))
        print "Error Encountered: Failed to find file 'configure/$current'.\nPlease seek professional help.";
    else
        print "Error Encountered: Failed to find file 'configure/error.php'.\nPlease seek professional help.";


//---- function to get the next step
function getNextStep($steps){
    $current = &$_SESSION['ccs']['configuration']['current'];
    foreach($steps as $key => $step){
        if ($current == $key)
            $pos = true;
        if ($pos && $current != $key && $step['active']){
            $current = $key;
            break;
        }
    }
    return $current;
}


//---- function to convert the simple xml over to an array
function convertSimpleXMLToArray($xmlobj) {
    $knownArrays = array(); // Array of known keys
    foreach($xmlobj as $key=>$value) {
        if(!$retval) //--- Must be done here, would check class type, but even end nodes are SimpleXMLElements
            $retval = array();

        if($retval[$key]) { // double keys, build array
            if(!$knownArrays[$key]) { // not known, learn it
                $retval[$key] = array($retval[$key]); // shift array
                $knownArrays[$key] = true; // set flag
            }
            array_push($retval[$key], convertSimpleXMLToArray($value)); // stack onto array (we must have a return value, this is recursive.
        } else
            $retval[$key] = convertSimpleXMLToArray($value); // main recursive call
    }
    if(!$retval)
        $retval = (string) $xmlobj; // no kids, get value
    return $retval;
}
?>
