<?php

//---- function to display the current screen
function domainParametersInit(){
    $_SESSION['ccs']['configuration']['pageTitle'] = 'Additional Domain Parameters';

    foreach($_SESSION['ccs']['configuration']['loadedOptions']['driver-options']['service-modules']['service-module'] as $thisService) {
        if($thisService['name'] == 'domain') {
            if(!$_SESSION['ccs']['configuration']['data']['domain']['allowTech'])
                $_SESSION['ccs']['configuration']['data']['domain']['allowTech'] = $thisService['service-options']['allow-custom-tech-info'] == 'yes' ? 'Y' : 'N';
            if(!$_SESSION['ccs']['configuration']['data']['domain']['allowCustomNameservers'])
                $_SESSION['ccs']['configuration']['data']['domain']['allowCustomNameservers'] = $thisService['service-options']['allow-custom-nameservers'] == 'yes' ? 'Y' : 'N';
            if(!$_SESSION['ccs']['configuration']['data']['domain']['allowModifyNameservers'])
                $_SESSION['ccs']['configuration']['data']['domain']['allowModifyNameservers'] = $thisService['service-options']['allow-manage-nameservers'] == 'yes' ? 'Y' : 'N';
            if(!$_SESSION['ccs']['configuration']['data']['domain']['allowLocalNameservers'])
                $_SESSION['ccs']['configuration']['data']['domain']['allowLocalNameservers'] = $thisService['service-options']['allow-register-nameservers'] == 'yes' ? 'Y' : 'N';
            break;
        }
    }

    require("configure/templates/domainParameters.php");
}


//---- function that manipulates data
function domainParametersExecute(){
    $data  = &$_SESSION['ccs']['configuration']['data'];
    $steps = &$_SESSION['ccs']['configuration']['steps'];

//---- grab the custom tech
    $allowDomainTech = $_POST['allowDomainTech'] ? $_POST['allowDomainTech'] : $_GET['allowDomainTech'];
    if (in_array($allowDomainTech, array('Y', 'N'))){
        $data['domain']['allowTech'] = $allowDomainTech;
    }else{
        $_SESSION['ccs']['configuration']['message'] = "Invalid allow technical contact state selected.";
        return false;
    }
//---- grab the allow custom nameservers
    $allowCustomNameservers = $_POST['allowCustomNameservers'] ? $_POST['allowCustomNameservers'] : $_GET['allowCustomNameservers'];
    if (in_array($allowCustomNameservers, array('Y', 'N'))){
        $data['domain']['allowCustomNameservers'] = $allowCustomNameservers;
    }else{
        $_SESSION['ccs']['configuration']['message'] = "Invalid custom nameservers state selected.";
        return false;
    }
//---- grab the modify nameservers flag
    $allowModifyNameservers = $_POST['allowModifyNameservers'] ? $_POST['allowModifyNameservers'] : $_GET['allowModifyNameservers'];
    if (in_array($allowModifyNameservers, array('Y', 'N'))){
        $data['domain']['allowModifyNameservers'] = $allowModifyNameservers;
    }else{
        $_SESSION['ccs']['configuration']['message'] = "Invalid modify nameserver state selected.";
        return false;
    }
//---- grab the allow local nameservers
    $allowLocalNameservers = $_POST['allowLocalNameservers'] ? $_POST['allowLocalNameservers'] : $_GET['allowLocalNameservers'];
    if (in_array($allowLocalNameservers, array('Y', 'N'))){
        $data['domain']['allowLocalNameservers'] = $allowLocalNameservers;
    }else{
        $_SESSION['ccs']['configuration']['message'] = "Invalid allow local nameserver state selected.";
        return false;
    }

    if($data['mode'] == 'platypus') {
        if ($steps['domainSellingExtras'])
            $steps['domainSellingExtras']['active'] = false;
    } else {
        if ($steps['domainSellingExtras'])
            $steps['domainSellingExtras']['active'] = true;
    }

    return true;
}
?>
