<?php

function DC_GetSystemError(ACF_ParameterList $inParameterList)
{
	// This function digs and returns the last system error from the session.
	$retParams; // Retruned Parameters
	$retParams = new ACF_ParameterList();
	$retParams->AddParameter(new ACF_DirectParameter('errorMessage',$_SESSION['ccs']['lastSystemError']));
	return $retParams;
}

function DC_GetAvailableServices(ACF_ParameterList $inParameterList)
{
	$services = $_SESSION['ccs']['options']['driver-options']['service-modules'];

	// Prep Options for smarty
	foreach($services as &$serv) {
		$serv['options'] = $serv['service-options'];
		unset($serv['service-options']);
	}
	
	if($services['blogware']['options']['package']['name']) {// Single package, array it for template
		$services['blogware']['options']['package'] = array($services['blogware']['options']['package']);
	}

	// Prep Domains
	if($services['domain']) {
		$minPrice = 1000;
		foreach($services['domain']['options']['service-offering-list']['service-offering'] as $offering) {
			if((strcasecmp($offering['active'],'yes') == 0) && ($minPrice > $offering['price']['new']))
				$minPrice = $offering['price']['new'];
		}
		$services['domain']['minprice'] = $minPrice;
	}

	if($services) {
		foreach($services as $key=>$service) { // Deactivate Services
			if($service['active'] != 'true')
				unset($services[$key]);
		}
	}

	// This function digs and returns all available services.
	$retParams; // Retruned Parameters
	$retParams = new ACF_ParameterList();
	$retParams->AddParameter(new ACF_DirectParameter('services',$services));
	return $retParams;
}

function DC_GetPurchaseInfo(ACF_ParameterList $inParameterList)
{
	require_once('../modules/datacollectors/dc_modules.php');

	$info = array('orderid'=>$_SESSION['modules']['shared']['orderid']);

	$retParams = DC_GetTemplateStatus($inParameterList);
	$retParams->AddParameter(new ACF_DirectParameter('info',$info));
	return $retParams;
}

function DC_GetTemplateStatusCCS(ACF_ParameterList $inParameterList)
{
	require_once('../modules/datacollectors/dc_modules.php');
	return DC_GetTemplateStatus($inParameterList);
}

function DC_GetStatus(ACF_ParameterList $inParameterList)
{
	$status = $_SESSION['modules']['shared']['status'];
	if($status)
		unset($_SESSION['modules']['shared']['status']);
	$retParams; // Retruned Parameters
	$retParams = new ACF_ParameterList();
	$retParams->AddParameter(new ACF_DirectParameter('status',$status));
	return $retParams;
}
	
function DC_GetInfoText(ACF_ParameterList $inParameterList) {
	$type = $inParameterList->ParameterValue('type');

	if(file_exists("../../etc/infotext/".$type.".info"))
		$infotext = file_get_contents("../../etc/infotext/".$type.".info");

	if(!$infotext)
		$infotext = "Information Not Found";
	
	$paramList = new ACF_ParameterList();
	$paramList->AddParameter(new ACF_DirectParameter('infotext',$infotext));
	return $paramList;
}

?>
