<?php
function GetCurrentController($refreshdb=false) {

    $project = $_SESSION['project'];

    // Cut layers down to names
    $simplelayers = array();
    foreach($project['receivers'][0]['layers'] as $layer) {
	array_push($simplelayers,$layer['name']);
    }

    if($project['type'] == 'adodb') {
	$db_server = $project['dboptions']['server'];
	$db_dbname = $project['dboptions']['dbname'];
	$db_uname = $project['dboptions']['username'];
	$db_pass = $project['dboptions']['password'];

	if(!$_SESSION['currentcontroller']) {
	    $db = new ACF_DB($db_server, $db_dbname, $db_uname, $db_pass);
	    $controller = new ACF_ControllerADODB(true, $db, $simplelayers);
	    $controller->LoadFramework(); // Add For XML support, Not required for ADODB
	    $_SESSION['currentcontroller'] = $controller;
	} else {
	    $controller = $_SESSION['currentcontroller'];

	    if($refreshdb) {
		$db = new ACF_DB($db_server, $db_dbname, $db_uname, $db_pass);
		$controller->SetDB($db);	// Necessary because db connections do not persist in sessions
	    }
	}
    } else if($project['type'] == 'xml') {
	if(!$_SESSION['currentcontroller']) {
	    $controller = new ACF_ControllerXML(true, $simplelayers);
	    $controller->SetProjectPath($project['dir']);
	    $controller->LoadFramework(); // Add For XML support, Not required for ADODB
	    $_SESSION['currentcontroller'] = $controller;
	}
    }

    return $_SESSION['currentcontroller'];
}
?>
