<?php
require_once('acf_refresh.inc.php');

function AH_ChangeEventName(ACF_ParameterList $inParameterList) {
    $layer = $_SESSION['layer'];
    $Controller = GetCurrentController(true);
    $processManager = $Controller->ProcessManager();

    $EventSource = new ACF_EventSource($inParameterList->ParameterValue('realm'),$inParameterList->ParameterValue('source'));
    $oldEvent = new ACF_Event($inParameterList->ParameterValue('oldEventName'));
    $newEvent = new ACF_Event($inParameterList->ParameterValue('newEventName'));
    
    if ($oldEvent != $newEvent) {
        $processManager->MoveResponse($layer,$EventSource,$oldEvent,$EventSource,$newEvent);
    }

    $Controller->SaveFramework();
    
    $retEvent = new ACF_Event('changeeventname_Success');
    $parameterList = new ACF_ParameterList();

    $parameterList->AddParameter(new ACF_DirectParameter('eventname', $inParameterList->ParameterValue('newEventName')));
    $parameterList->AddParameter(new ACF_DirectParameter('parentid', $inParameterList->ParameterValue('parentid')));
    
    $retEvent->SetParameterList($parameterList);

    return $retEvent;
}

function AH_InsertEvent(ACF_ParameterList $inParameterList) {
    $parentid = $inParameterList->ParameterValue('parentid');
    $neweventname = $inParameterList->ParameterValue('neweventname');
    $popstack = $inParameterList->ParameterValue('popstack');
    $clearstack = $inParameterList->ParameterValue('clearstack');
    if($inParameterList->ParameterValue('exteventname')) {
	$exteventname = $inParameterList->ParameterValue('exteventname');
    }
    $parentArray = explode("/",$parentid);
    $eventArray = explode("/",$neweventname);

    $layer = $_SESSION['layer'];
    $realm = $parentArray[0];

    if ($realm == "external") {
        $source = "/";
	if ($parentArray[1]) {
	    for ($parentIndex = 1; $parentIndex < count($parentArray); $parentIndex++) {
		$source .= $parentArray[$parentIndex]."/";
	    }
	}
        if (count($eventArray) > 1) {
	    for ($eventIndex = 0; $eventIndex < count($eventArray) - 1; $eventIndex++) {
	        $source .= $eventArray[$eventIndex]."/";
            }
        }
	$source = substr($source,0,strlen($source)-1);
    } else {
        $source = $exteventname;
    }

    $eventname = $eventArray[count($eventArray) - 1];

    $controller = GetCurrentController(true);
    $processManager = $controller->ProcessManager();
    $newEventSource = new ACF_EventSource($realm,$source);
    $newEvent = new ACF_Event($eventname);

    $newStackAdvice = new ACF_InvocationStackAdvice();
    $newStackAdvice->SetPopStack($popstack == 1);
    $newStackAdvice->SetClearStack($clearstack == 1);

    $newInvocationList = $controller->CreateInvocationList();

    $newEventResponse = new ACF_EventResponse($newStackAdvice,$newInvocationList);
    $processManager->AddResponse($newEventSource,$newEvent,$newEventResponse,$layer);

    $controller->SaveFramework();
    return new ACF_Event('insertevent_Success');
}

function AH_RemoveEvent(ACF_ParameterList $inParameterList) {
    $parentid = $inParameterList->ParameterValue('parentid');
    $eventname = $inParameterList->ParameterValue('eventname');
    $realm = $inParameterList->ParameterValue('realm');
    $source = $inParameterList->ParameterValue('source');
    $layer = $_SESSION['layer'];
    
    $controller = GetCurrentController(true);
    $processManager = $controller->ProcessManager();

    $processManager->RemoveResponse($layer,$realm,$source,$eventname);

    $controller->SaveFramework();
    return new ACF_Event('removeevent_Success');
}

?>
