<?php
require_once('acf_refresh.inc.php');

function AH_UpdateView(ACF_ParameterList $inParameterList) {
    $layer = $_SESSION['layer'];
    $viewname = $inParameterList->ParameterValue('viewname');
    $oldviewname = $inParameterList->ParameterValue('oldviewname');
    $parentid = $inParameterList->ParameterValue('parentid');
    $reqinput = $inParameterList->ParameterValue('reqinput');
    $oldreqinput = $inParameterList->ParameterValue('oldreqinput');
    $optinput = $inParameterList->ParameterValue('optinput');
    $oldoptinput = $inParameterList->ParameterValue('oldoptinput');

    $Controller = GetCurrentController(true);

    $viewDefManager = $Controller->ViewDefinitionManager();
    if($parentid)
	$viewDef = $viewDefManager->FindDefinition($layer,$parentid."/".$oldviewname);
    else
	$viewDef = $viewDefManager->FindDefinition($layer,$oldviewname);

    if ($viewname != $oldviewname) {
	if($parentid) {
	    $viewDefManager->MoveDefinition($layer,$parentid."/".$oldviewname,$parentid."/".$viewname);
	    $viewDef->SetName($parentid."/".$viewname);
	} else {
	    $viewDefManager->MoveDefinition($layer,$oldviewname,$viewname);
	    $viewDef->SetName($viewname);
	}
    }

    if ($reqinput != $oldreqinput) {
        if ($reqinput == NULL) {
            $reqinput = "";
        }
        $viewDef->SetRequiredInputParameters($reqinput);
    }

    if ($optinput != $oldoptinput) {
        if ($optinput == NULL) {
            $optinput = "";
        }
        $viewDef->SetOptionalInputParameters($optinput);
    }

    $Controller->SaveFramework();

    $retEvent = new ACF_Event('updateview_Success');
    $parameterList = new ACF_ParameterList();

    $parameterList->AddParameter(new ACF_DirectParameter('viewname', $viewname));
    $parameterList->AddParameter(new ACF_DirectParameter('parentid', $parentid));

    $retEvent->SetParameterList($parameterList);

    return $retEvent;
}

function AH_WizardStoreParameters(ACF_ParameterList $inParameterList) {

    $reqinput = explode(",",$inParameterList->ParameterValue('reqinput'));
    $optinput = explode(",",$inParameterList->ParameterValue('optinput'));

    $layer = $_SESSION['layer'];
    $viewname = $_SESSION['viewwizard_name'];

    $controller = GetCurrentController(true);
    $viewDefManager = $controller->ViewDefinitionManager();
    $viewDef = new ACF_ViewDefinition($viewname);
    $viewDef->SetRequiredInputParameters($reqinput);
    $viewDef->SetOptionalInputParameters($optinput);

    $newInvocationList = $controller->CreateInvocationList();
    $viewDef->SetDataCollectorList($newInvocationList);

    $viewDefManager->AddViewDefinition($viewDef,$layer);

    $controller->SaveFramework();
    return new ACF_Event('viewwizard_storeparameters_success');
}

function AH_RemoveView(ACF_ParameterList $inParameterList) {
    $parentid = $inParameterList->ParameterValue('parentid');
    $viewname = $inParameterList->ParameterValue('viewname');
    $layer = $_SESSION['layer'];

    if($parentid)
	$fullviewname = $parentid."/".$viewname;
    else
	$fullviewname = $viewname;

    $controller = GetCurrentController(true);
    $viewDefManager = $controller->ViewDefinitionManager();
    $viewDef = new ACF_ViewDefinition($fullviewname);
    $viewDefManager->DeleteViewDefinition($viewDef,$layer);

    $processManager = $controller->ProcessManager();

    $controller->SaveFramework();
    return new ACF_Event('removeview_Success');
}

function AH_WizardStoreName(ACF_ParameterList $inParameterList) {
    $name = $inParameterList->ParameterValue('name');
    $path= $inParameterList->ParameterValue('path');

    if($name)
	$_SESSION['viewwizard_name'] = $path.$name;
    else
	return new ACF_Event('viewwizard_error');

    return new ACF_Event('viewwizard_storename_success');
}
?>
