<?php
function DC_GetHeaderInfo(ACF_ParameterList $inParameterList) {

    $conn = $_SESSION['currentcontroller'];
    $layerlist = $conn->Layers();

    $layers = array();
    foreach($layerlist as $l) {
	$newlayer = array();
	$newlayer['current'] = ($l == $_SESSION['layer']);
	$newlayer['name'] = $l;
	array_push($layers,$newlayer);
    }

    $parameterList = new ACF_ParameterList();
    $parameterList->AddParameter(new ACF_DirectParameter('layers',$layers));
    return $parameterList;
}

function DC_LoadProjects(ACF_ParameterList $inParameterList) {
    $projects = array();
    
    if (file_exists('../../etc/projects.xml'))
       $xml = simplexml_load_file('../../etc/projects.xml');

    foreach($xml->project as $project) {
	array_push($projects,(string) $project->name);
    }

    $parameterList = new ACF_ParameterList();
    $parameterList->AddParameter(new ACF_DirectParameter('projects',$projects));
    return $parameterList;
}

function DC_GetProjectName(ACF_ParameterList $inParameterList) {
    $parameterList = new ACF_ParameterList();
    $parameterList->AddParameter(new ACF_DirectParameter('projectname',$_SESSION['projname']));
    return $parameterList;
}

function DC_GetCurrentLayers(ACF_ParameterList $inParameterList) {
    $currentreceiver = $inParameterList->ParameterValue('receiver');
    $retlayers = array();

    $parameterList = new ACF_ParameterList();
    if($currentreceiver) { 
	if (file_exists('../../etc/projects.xml'))
	   $xml = simplexml_load_file('../../etc/projects.xml');

	$index = 0;
	foreach($xml->project as $project) {
	    if($project->name == $_SESSION['projname']) {
		$_SESSION['project']['receivers'] = array();
		foreach($project->receivers->receiver as $recv) {
		    $newrecv = array();
		    $newrecv['name'] = (string) $recv['name'];
		    $newrecv['layers'] = array();
		    
		    foreach($recv->layer as $layer) {
			$newlayer = array();
			$newlayer['name'] = (string) $layer;
			if($layer['active'])
			    $newlayer['active'] = (string) $layer['active'];
			else
			    $newlayer['active'] = 'true';
			array_push($newrecv['layers'],$newlayer);

			if((string) $recv['name'] == $currentreceiver)
			    array_push($retlayers,$newlayer);
		    }
		    array_push($_SESSION['project']['receivers'],$newrecv);
		}
		$_SESSION['layer'] = $_SESSION['project']['receivers'][0]['layers'][0];
	    }
	}
	$parameterList->AddParameter(new ACF_DirectParameter('currentlayers',$retlayers));
    }

    return $parameterList;
}

function DC_GetCurrentReceivers(ACF_ParameterList $inParameterList) {
    if (file_exists('../../etc/projects.xml'))
       $xml = simplexml_load_file('../../etc/projects.xml');

    $recvs = array();
    
    foreach($xml->project as $project) {
	if($project->name == $_SESSION['projname']) {
	    foreach($project->receivers->receiver as $recv) {
		array_push($recvs,(string) $recv['name']);
	    }
	    break;
	}
    }
    $parameterList = new ACF_ParameterList();
    $parameterList->AddParameter(new ACF_DirectParameter('currentreceivers',$recvs));
    return $parameterList;
}
?>
