<?php
require_once("acfitems.inc.php");
require_once("acf_refresh.inc.php");

function DC_GetEvents(ACF_ParameterList $inParameterList) {
    $id = $inParameterList->ParameterValue('id');


    if(!$_SESSION['expands'])
        $_SESSION['expands'] = array();

    if($id) {
        if(!removefromarray($_SESSION['expands'],$id))
            array_push($_SESSION['expands'],$id);
    }

    $controller = GetCurrentController();
    $processManager = $controller->ProcessManager();
    $processes = $processManager->Responses();

    $events = array();

    $currentLayer = $_SESSION['layer']; 
    
    foreach($processes as $layer => $realms) {
        if($layer == $currentLayer) {
            foreach($realms as $sourcerealm => $names) {
                $events[$sourcerealm] = array();
                $events[$sourcerealm]['name'] = $sourcerealm;
                $events[$sourcerealm]['id'] = "EVENT_".$sourcerealm;
		$events[$sourcerealm]['add'] = true;
                $events[$sourcerealm]['expand'] = inexpand("EVENT_".$sourcerealm);
                $events[$sourcerealm]['content'] = array();
                $sourcerealmindex++;

		ksort($names); // sort recievers & internal events
                foreach($names as $sourcename => $es) {
                    $levels = explode("/",$sourcename);
                    $currentarray = "\$events['".$sourcerealm."']['content']";
                    $currentid = "EVENT_".$sourcerealm;
		    $lvlcount = 1;
                    foreach($levels as $lvl) {
                        if($lvl) {
                            $currentid .= "/".$lvl;
                            $currentarray .= "['".$lvl."']";
                            $execstring = "if(!is_array(".$currentarray.")) {".$currentarray." = array();";
                            $execstring .= $currentarray."['name'] = '".$lvl."';";
                            $execstring .= $currentarray."['id'] = '".$currentid."';";
			    $execstring .= $currentarray."['add'] = ".(($lvlcount == count($levels) && $sourcerealm=='external') ? 'true' : 'false').";";
                            $execstring .= $currentarray."['expand'] = InExpand('".$currentid."');";
                            $execstring .= $currentarray."['content'] = array();";
			    $execstring .= "}";
                            eval($execstring);
                            $currentarray .= "['content']";
                        }
                        $lvlcount++;
                    }    
                   
		    ksort($es); // sort events
                    foreach($es as $eventname => $response) {
                        $execstring = "array_push(".$currentarray.",'".$eventname."');";
                        eval($execstring);
                    }
                }
            }
        }
    }

    // Repair for empty projects
    if(!$events['external']) {
	$events['external'] = Array();
	$events['external']['name'] = "external";
	$events['external']['id'] = "EVENT_external";
	$events['external']['add'] = true;
	$events['external']['expand'] = true;
	$events['external']['content'] = Array();
    }
    if(!$events['internal']) {
	$events['internal'] = Array();
	$events['internal']['name'] = "internal";
	$events['internal']['id'] = "EVENT_internal";
	$events['internal']['add'] = true;
	$events['internal']['expand'] = true;
	$events['internal']['content'] = Array();
    }

    $parameterList = new ACF_ParameterList();
    $parameterList->AddParameter(new ACF_DirectParameter('events',$events));
    return $parameterList;
}

function DC_GetEvent(ACF_ParameterList $inParameterList) {
    $eventname = $inParameterList->ParameterValue('eventname');
    $parentid = $inParameterList->ParameterValue('parentid');
    if (substr($parentid,0,6) == "EVENT_") {
        $parentid = substr($parentid,6,strlen($parentid)-6);
    }
    $parentArray = explode("/",$parentid);
    $layer = $_SESSION['layer'];
    $realm = $parentArray[0];
    $source = "";
    for($i=1;$i<count($parentArray);$i++) {
        $source .= "/".$parentArray[$i];
    }
    if($realm=="internal") {
        $source = substr($source,1,strlen($source)-1);
    }
    $event = array();
    $event['layer'] = $layer;
    $event['realm'] = $realm;
    $event['source'] = $source;
    $event['eventname'] = $eventname;
    $event['parentid'] = $parentid;
    $event['projname'] = $_SESSION['projname'];
    $controller = GetCurrentController();
    $processManager = $controller->ProcessManager();
    $process = $processManager->FindResponse($layer,$realm,$source,$eventname);
    $invocationsList = $process->InvocationsArray();
    $invocations = array();
    foreach($invocationsList as $invocation) {
        $newInvocation = array();
    $newInvocation['name'] = $invocation->TaskName();
    $newInvocation['type'] = $invocation->TaskType();
    
    // Get Location
    $rev = strrev($newInvocation['name']);
    $newInvocation['location'] = (($newInvocation['type']=='activity')?'executable_show?executablename=':'view_show?viewname=').strrev(substr($rev,0,strpos($rev,"/"))).'&parentid='.(($newInvocation['type']=='activity')?'EXECUTABLE/':'VIEW/').substr($newInvocation['name'],0,strlen($newInvocation['name']) - strpos($rev,"/") - 1);
    
    $newInvocation['parameters'] = array();

    $paramList = $invocation->ParameterList();
    $parameters = $paramList->ParametersArray();

    foreach($parameters as $parameter) {
            $newParameter = array();
        $newParameter['name'] = $parameter->Name();
        if($parameter->IsDirect()) {
                $newParameter['type'] = "Direct";
                $newParameter['value'] = $parameter->Value();
            } else {
                $newParameter['type'] = "Indirect";
                $newParameter['reference'] = $parameter->Reference();
            }

            if($parameter->IsOptional()) {
            $newParameter['optional'] = "True";
            } else {
        $newParameter['optional'] = "False";
            }

        array_push($newInvocation['parameters'],$newParameter);
    }
    array_push($invocations,$newInvocation);
    }
    $parameterList = new ACF_ParameterList();
    $parameterList->AddParameter(new ACF_DirectParameter('event',$event));
    $parameterList->AddParameter(new ACF_DirectParameter('invocations',$invocations));
    return $parameterList;
}

function DC_GetNewEvent(ACF_ParameterList $inParameterList) {
    $parentid = $inParameterList->ParameterValue('parentid');
    $currentLayer = $_SESSION['layer'];
    $eventlist = array();

    if (substr($parentid,0,6) == "EVENT_") {
        $parentid = substr($parentid,6,strlen($parentid)-6);
    }
    $realm = substr($parentid,0,8);
    if ($realm == "internal") {
        $controller = GetCurrentController();
	$ExecManager = $controller->ExecutableWrapperManager();
        $wrappers = $ExecManager->Wrappers();

	foreach($wrappers as $layer => $names) {
	    //if($layer == $currentLayer) { // Lets display all layers, its easier for customizers
		ksort($names); // sort by name
	        foreach($names as $name => $wrapper) {
		    if ($wrapper->ReturnType() == "event") {
			$levels = explode("/",$name);
			$wrappername = $levels[count($levels) - 1];
			unset($levels[count($levels) - 1]);
			$executablename = "";
			foreach ($levels as $lvl) {
			    $executablename .= $lvl."/";
			}
			$executablename .= $wrappername;
			array_push($eventlist,$executablename);
		    }
		}
	    //}
	}
    }
    $parameterList = new ACF_ParameterList();
    $parameterList->AddParameter(new ACF_DirectParameter('parentid',$parentid));
    $parameterList->AddParameter(new ACF_DirectParameter('realm',$realm));
    $parameterList->AddParameter(new ACF_DirectParameter('eventlist',$eventlist));

    return $parameterList;
}

function DC_AskRemoveEvent (ACF_ParameterList $inParameterList) {
    $parameterList = new ACF_ParameterList();
    $parameterList->AddParameter(new ACF_DirectParameter('parentid',$inParameterList->ParameterValue('parentid')));
    $parameterList->AddParameter(new ACF_DirectParameter('eventname',$inParameterList->ParameterValue('eventname')));
    $parameterList->AddParameter(new ACF_DirectParameter('realm',$inParameterList->ParameterValue('realm')));
    $parameterList->AddParameter(new ACF_DirectParameter('source',$inParameterList->ParameterValue('source')));

    return $parameterList;
}
?>
