<?php
require_once("acfitems.inc.php");
require_once("acf_refresh.inc.php");

function DC_GetExecutables(ACF_ParameterList $inParameterList) {
    $id = $inParameterList->ParameterValue('id');
    if(!$_SESSION['expands'])
        $_SESSION['expands'] = array();
    
    if($id) {
        if(!removefromarray($_SESSION['expands'],$id))
            array_push($_SESSION['expands'],$id);
    }    
 
    $conn = GetCurrentController();
    $ExecManager = $conn->ExecutableWrapperManager();
    $wrappers = $ExecManager->Wrappers();

    $executables = array();
    
    $currentLayer = $_SESSION['layer'];

    if($wrappers) {
	foreach($wrappers as $layer => $names) {
	    if($layer == $currentLayer) {
		ksort($names);
		foreach($names as $name => $wrapper) {
			$levels = explode("/",$name);
			// remove last element
			$wrappername = $levels[count($levels) - 1];
			unset($levels[count($levels) - 1]);

			$currentarray = "\$executables";
			$currentid = "EXECUTABLE";
			foreach($levels as $lvl) {
			    if($lvl) {
				$currentid .= "/".$lvl;
				$currentarray .= "['".$lvl."']";
				$execstring = "if(!is_array(".$currentarray.")) {".$currentarray." = array();";
				$execstring .= $currentarray."['name'] = '".$lvl."';";
				$execstring .= $currentarray."['id'] = '".$currentid."';";
				$execstring .= $currentarray."['expand'] = InExpand('".$currentid."');";
				$execstring .= $currentarray."['add'] = true;";
				$execstring .= $currentarray."['content'] = array();";
				$execstring .= "}";
				eval($execstring);
				$currentarray .= "['content']";
			    }
			}    
	 
			$execstring = "array_push(".$currentarray.",'".$wrappername."');asort(".$currentarray.");";
			eval($execstring);
		}
	    }
	}
    }

    $parameterList = new ACF_ParameterList();
    $parameterList->AddParameter(new ACF_DirectParameter('executables',$executables));
    return $parameterList;
}

function DC_GetExecutable(ACF_ParameterList $inParameterList) {
    $executablename = $inParameterList->ParameterValue('executablename');
    $parentid = $inParameterList->ParameterValue('parentid');

    $levels = explode("/",$parentid);
    array_shift($levels);
    foreach($levels as $lvl) {
	if($lvl)
	    $taskname .= $lvl."/";
    }
    
    $taskname .= $executablename;
    $layer = $_SESSION['layer'];

    $controller = GetCurrentController();
    $executableManager = $controller->ExecutableWrapperManager();
    $wrapper = $executableManager->FindWrapper($layer,$taskname);
	
    $name = $wrapper->Name(); 
    $callType = $wrapper->CallType();
    $retType = $wrapper->ReturnType();

    $cacheTimeout = $wrapper->CacheTimeout();
    $cacheGlobal = $wrapper->CacheGlobal();

    $req_inparam = implode(",",$wrapper->Names('required_input'));
    $opt_inparam = implode(",",$wrapper->Names('optional_input'));
    $req_outparam = implode(",",$wrapper->Names('required_output'));
    $opt_outparam = implode(",",$wrapper->Names('optional_output'));

    if($callType == 'localphp') {
	$resourcelocation = $wrapper->FileName();
	$resourcename = $wrapper->FunctionName();
    } else if($callType == 'xmlrpc') {
	$server = $wrapper->Server();
	$port = $wrapper->Port();
	$uri = $wrapper->URI();
	$functionname = $wrapper->MethodName();
    } else if($callType == 'soap') {
	$serverpath = $wrapper->ServerPath();
	$uri = $wrapper->URI();
	$functionname = $wrapper->MethodName();
    }

    if($retType == 'event')
	$retevents = implode(",",$wrapper->Names('output_event'));

    $parameterList = new ACF_ParameterList();
    $parameterList->AddParameter(new ACF_DirectParameter('name',$name));
    $parameterList->AddParameter(new ACF_DirectParameter('callType',$callType));
    $parameterList->AddParameter(new ACF_DirectParameter('req_inparam',$req_inparam));
    $parameterList->AddParameter(new ACF_DirectParameter('opt_inparam',$opt_inparam));
    $parameterList->AddParameter(new ACF_DirectParameter('req_outparam',$req_outparam));
    $parameterList->AddParameter(new ACF_DirectParameter('opt_outparam',$opt_outparam));
    $parameterList->AddParameter(new ACF_DirectParameter('returntype',$retType));
   
    $parameterList->AddParameter(new ACF_DirectParameter('cache_timeout',$cacheTimeout));
    if($cacheGlobal) {
        $parameterList->AddParameter(new ACF_DirectParameter('cache_global',$cacheGlobal));
    }

    if($callType == 'localphp') {
	$parameterList->AddParameter(new ACF_DirectParameter('resourcelocation',$resourcelocation));
	$parameterList->AddParameter(new ACF_DirectParameter('resourcename',$resourcename));
    } else if($callType == 'xmlrpc') {
	$parameterList->AddParameter(new ACF_DirectParameter('server',$server));
	$parameterList->AddParameter(new ACF_DirectParameter('port',$port));
	$parameterList->AddParameter(new ACF_DirectParameter('uri',$uri));
	$parameterList->AddParameter(new ACF_DirectParameter('functionname',$functionname));
    } else if($callType == 'soap') {
	$parameterList->AddParameter(new ACF_DirectParameter('serverpath',$serverpath));
	$parameterList->AddParameter(new ACF_DirectParameter('uri',$uri));
	$parameterList->AddParameter(new ACF_DirectParameter('functionname',$functionname));
    }

    if($retType == 'event')
	$parameterList->AddParameter(new ACF_DirectParameter('outputevents',$retevents));

    return $parameterList;
}

function DC_GetExecutablePath(ACF_ParameterList $inParameterList) {
    $parentid = $inParameterList->ParameterValue('parentid');

    $path = "";
    $levels = explode("/",$parentid);
    array_shift($levels);
    foreach($levels as $lvl) {
	$path .= $lvl."/";
    }

    $parameterList = new ACF_ParameterList();
    $parameterList->AddParameter(new ACF_DirectParameter('path',$path));
    return $parameterList;
}
?>
