<?php
require_once("acf_refresh.inc.php");

function DC_GetNewInvocation (ACF_ParameterList $inParameterList) {
    $controller = GetCurrentController();
    $currentLayer = $_SESSION['layer'];
    $invoctype = $inParameterList->ParameterValue('invoctype');
    $eventlist = array();

    switch($invoctype) {
        case "datacollector" :
            $ExecManager = $controller->ExecutableWrapperManager();
            $wrappers = $ExecManager->Wrappers();

            foreach($wrappers as $layer => $names) {
                //if($layer == $currentLayer) {
		    ksort($names);
                    foreach($names as $name => $wrapper) {
                        if ($wrapper->ReturnType() == "parameterlist") {
                            $levels = explode("/",$name);
                            $wrappername = $levels[count($levels) - 1];
                            unset($levels[count($levels) - 1]);
                            $executablename = "";
                            foreach($levels as $lvl) {
                                $executablename .= $lvl."/";
                            }
                            $executablename .= $wrappername;
                            array_push($eventlist,$executablename);
                        }
                    }
                //}
            }

            break;
        case "activity" :
            $ExecManager = $controller->ExecutableWrapperManager();
            $wrappers = $ExecManager->Wrappers();

            foreach($wrappers as $layer => $names) {
                //if($layer == $currentLayer) {
		    ksort($names);
                    foreach($names as $name => $wrapper) {
                        if ($wrapper->ReturnType() == "event") {
                            $levels = explode("/",$name);
                            $wrappername = $levels[count($levels) - 1];
                            unset($levels[count($levels) - 1]);
                            $executablename = "";
                            foreach($levels as $lvl) {
                                $executablename .= $lvl."/";
                            }
                            $executablename .= $wrappername;
                            array_push($eventlist,$executablename);
                        }
                    }
                //}
            }

            break;
        case "view" :
            $viewDefinitionManager = $controller->ViewDefinitionManager();
            $viewdefs = $viewDefinitionManager->Definitions();

            foreach($viewdefs as $layer => $names) {
               //if($layer == $currentLayer) {
		ksort($names);
                  foreach($names as $name => $definition) {
                     $levels = explode("/",$name);
                     $definitionname = $levels[count($levels) -1];
                     unset($levels[count($levels)-1]);
                     $viewname = "";
                     foreach($levels as $lvl) {
                         $viewname .= $lvl."/";
                     }
                     $viewname .= $definitionname;
                     array_push($eventlist,$viewname);
                  }
               //}
            }
            break;
        default :
            throw new ACF_Exception("Unrecognized type for invoctype ' in database: '$invoctype'");
    }

    $parameterList = new ACF_ParameterList();

    if ($inParameterList->ParameterValue('realm')) {
        $parameterList->AddParameter(new ACF_DirectParameter('realm',$inParameterList->ParameterValue('realm')));
    }
    if ($inParameterList->ParameterValue('source')) {
        $parameterList->AddParameter(new ACF_DirectParameter('source',$inParameterList->ParameterValue('source')));
    }
    $parameterList->AddParameter(new ACF_DirectParameter('dataname',$inParameterList->ParameterValue('dataname')));
    $parameterList->AddParameter(new ACF_DirectParameter('parentid',$inParameterList->ParameterValue('parentid')));
    $parameterList->AddParameter(new ACF_DirectParameter('datatype',$inParameterList->ParameterValue('datatype')));
    $parameterList->AddParameter(new ACF_DirectParameter('invoctype',$invoctype));
    $parameterList->AddParameter(new ACF_DirectParameter('eventlist',$eventlist));

    return $parameterList;
}

function DC_GetNewInvocationType(ACF_ParameterList $inParameterList) {
    $parameterList = new ACF_ParameterList();
    if ($inParameterList->ParameterValue('realm')) {
        $parameterList->AddParameter(new ACF_DirectParameter('realm',$inParameterList->ParameterValue('realm')));
    }
    if ($inParameterList->ParameterValue('source')) {
        $parameterList->AddParameter(new ACF_DirectParameter('source',$inParameterList->ParameterValue('source')));
    }
    $parameterList->AddParameter(new ACF_DirectParameter('dataname',$inParameterList->ParameterValue('dataname')));
    $parameterList->AddParameter(new ACF_DirectParameter('parentid',$inParameterList->ParameterValue('parentid')));
    $parameterList->AddParameter(new ACF_DirectParameter('datatype',$inParameterList->ParameterValue('datatype')));

    return $parameterList;
}

function DC_GetNewParameter(ACF_ParameterList $inParameterList) {
    $parameterList = new ACF_ParameterList();
    if ($inParameterList->ParameterValue('realm')) {
        $parameterList->AddParameter(new ACF_DirectParameter('realm',$inParameterList->ParameterValue('realm')));
    }
    if ($inParameterList->ParameterValue('source')) {
        $parameterList->AddParameter(new ACF_DirectParameter('source',$inParameterList->ParameterValue('source')));
    }
    $parameterList->AddParameter(new ACF_DirectParameter('dataname',$inParameterList->ParameterValue('dataname')));
    $parameterList->AddParameter(new ACF_DirectParameter('parentid',$inParameterList->ParameterValue('parentid')));
    $parameterList->AddParameter(new ACF_DirectParameter('datatype',$inParameterList->ParameterValue('datatype')));
    $parameterList->AddParameter(new ACF_DirectParameter('invocname',$inParameterList->ParameterValue('invocname')));
    return $parameterList;
}

function DC_AskRemoveInvocation(ACF_ParameterList $inParameterList) {
    $parameterList = new ACF_ParameterList();
    if ($inParameterList->ParameterValue('realm')) {
        $parameterList->AddParameter(new ACF_DirectParameter('realm',$inParameterList->ParameterValue('realm')));
    }
    if ($inParameterList->ParameterValue('source')) {
        $parameterList->AddParameter(new ACF_DirectParameter('source',$inParameterList->ParameterValue('source')));
    }
    $parameterList->AddParameter(new ACF_DirectParameter('dataname',$inParameterList->ParameterValue('dataname')));
    $parameterList->AddParameter(new ACF_DirectParameter('parentid',$inParameterList->ParameterValue('parentid')));
    $parameterList->AddParameter(new ACF_DirectParameter('datatype',$inParameterList->ParameterValue('datatype')));
    $parameterList->AddParameter(new ACF_DirectParameter('invocname',$inParameterList->ParameterValue('invocname')));
    return $parameterList;
}

function DC_AskRemoveParameter(ACF_ParameterList $inParameterList) {
    $parameterList = new ACF_ParameterList();
    if ($inParameterList->ParameterValue('realm')) {
        $parameterList->AddParameter(new ACF_DirectParameter('realm',$inParameterList->ParameterValue('realm')));
    }
    if ($inParameterList->ParameterValue('source')) {
        $parameterList->AddParameter(new ACF_DirectParameter('source',$inParameterList->ParameterValue('source')));
    }
    $parameterList->AddParameter(new ACF_DirectParameter('dataname',$inParameterList->ParameterValue('dataname')));
    $parameterList->AddParameter(new ACF_DirectParameter('parentid',$inParameterList->ParameterValue('parentid')));
    $parameterList->AddParameter(new ACF_DirectParameter('datatype',$inParameterList->ParameterValue('datatype')));
    $parameterList->AddParameter(new ACF_DirectParameter('invocname',$inParameterList->ParameterValue('invocname')));
    $parameterList->AddParameter(new ACF_DirectParameter('paramname',$inParameterList->ParameterValue('paramname')));
    return $parameterList;
}

?>
