<?php
require_once("acfitems.inc.php");
require_once("acf_refresh.inc.php");

function DC_GetViews(ACF_ParameterList $inParameterList) {
    $id = $inParameterList->ParameterValue('id');
    if(!$_SESSION['expands'])
        $_SESSION['expands'] = array();
    
    if($id) {
        if(!removefromarray($_SESSION['expands'],$id))
            array_push($_SESSION['expands'],$id);
    }    
 
    $controller = GetCurrentController();
    $viewDefinitionManager = $controller->ViewDefinitionManager();
    $viewdefs = $viewDefinitionManager->Definitions();

    $views = array();
    
    $currentLayer = $_SESSION['layer'];

    foreach($viewdefs as $layer => $names) {
        if($layer == $currentLayer) {
	    ksort($names);
            foreach($names as $name => $definition) {
                    $levels = explode("/",$name);
		    // remove last element
		    $definitionname = $levels[count($levels) - 1];
		    unset($levels[count($levels) - 1]);

                    $currentarray = "\$views";
                    $currentid = "VIEW";
                    foreach($levels as $lvl) {
                        if($lvl) {
                            $currentid .= "/".$lvl;
                            $currentarray .= "['".$lvl."']";
                            $execstring = "if(!is_array(".$currentarray.")) {".$currentarray." = array();";
                            $execstring .= $currentarray."['name'] = '".$lvl."';";
                            $execstring .= $currentarray."['id'] = '".$currentid."';";
			    $execstring .= $currentarray."['add'] = true;";
                            $execstring .= $currentarray."['expand'] = InExpand('".$currentid."');";
                            $execstring .= $currentarray."['content'] = array();";
                            $execstring .= "}";
                            eval($execstring);
                            $currentarray .= "['content']";
                        }
                    } 
     
		    $execstring = "array_push(".$currentarray.",'".$definitionname."');asort(".$currentarray.");";
		    eval($execstring);
	    }
	}
    }
    $parameterList = new ACF_ParameterList();
    $parameterList->AddParameter(new ACF_DirectParameter('views',$views));
    return $parameterList;
}

function DC_GetView(ACF_ParameterList $inParameterList) {
    $viewname = $inParameterList->ParameterValue('viewname');
    $parentid = $inParameterList->ParameterValue('parentid');

    $fullviewname = "";
    $levels = explode("/",$parentid);
    if($levels[0] == "VIEW")
	array_shift($levels);
    foreach($levels as $lvl) {
	if($lvl)
	    $fullviewname .= $lvl."/";
    }
    $fullviewname .= $viewname;
    
    $cleanparentid = implode("/",$levels);

    $layer = $_SESSION['layer'];
    $view = array();
    $view['layer'] = $layer;
    $view['name'] = $fullviewname;
    $view['viewname'] = $viewname;
    $view['parentid'] = $cleanparentid;
    $view['projname'] = $_SESSION['projname'];
    $view['parameters'] = array();
    $controller = GetCurrentController();
    $viewDefinitionManager = $controller->ViewDefinitionManager();
    $viewdef = $viewDefinitionManager->FindDefinition($layer,$fullviewname);
    $view['parameters']['required_input'] = implode(",",$viewdef->names("required_input"));
    $view['parameters']['optional_input'] = implode(",",$viewdef->names("optional_input"));
    $dataCollectors = $viewdef->DataCollectors();
    $invocationsList = $dataCollectors->InvocationsArray();
    $invocations = array();
    foreach($invocationsList as $invocation) {
        $newInvocation = array();
        $newInvocation['name'] = $invocation->TaskName();
        $newInvocation['type'] = $invocation->TaskType();

	// Get Location
	$rev = strrev($newInvocation['name']);
	$newInvocation['location'] = 'executable_show?executablename='.strrev(substr($rev,0,strpos($rev,"/"))).'&parentid=EXECUTABLE/'.substr($newInvocation['name'],0,strlen($newInvocation['name']) - strpos($rev,"/") - 1);

        $newInvocation['parameters'] = array();
        $paramList = $invocation->ParameterList();
        $parameters = $paramList->ParametersArray();

        foreach($parameters as $parameter) {
            $newParameter = array();
            $newParameter['name'] = $parameter->Name();
            if($parameter->IsDirect()) {
                $newParameter['type'] = "Direct";
                $newParameter['value'] = $parameter->Value();
            } else {
                $newParameter['type'] = "Indirect";
                $newParameter['reference'] = $parameter->Reference();
            }

            if($parameter->IsOptional()) {
                $newParameter['optional'] = "True";
            } else {
                $newParameter['optional'] = "False";
            }

            array_push($newInvocation['parameters'],$newParameter);
        }
        array_push($invocations,$newInvocation);
    }
    $parameterList = new ACF_ParameterList();
    $parameterList->AddParameter(new ACF_DirectParameter('view',$view));
    $parameterList->AddParameter(new ACF_DirectParameter('invocations',$invocations));
    return $parameterList;
}

function DC_GetViewPath(ACF_ParameterList $inParameterList) {
    $parentid = $inParameterList->ParameterValue('parentid');

    $path = "";
    $levels = explode("/",$parentid);
    array_shift($levels);
    foreach($levels as $lvl) {
	$path .= $lvl."/";
    }
/*
    if (substr($parentid,0,5) == "VIEW_") {
        $parentid = substr($parentid,5,strlen($parentid)-6);
    }
*/    
    $parameterList = new ACF_ParameterList();
    $parameterList->AddParameter(new ACF_DirectParameter('path',$path));

    return $parameterList;
}

function DC_GetNewView2(ACF_ParameterList $inParameterList) {
    $parameterList  = new ACF_ParameterList();
    $parameterList->AddParameter(new ACF_DirectParameter('parentid',$inParameterList->ParameterValue('parentid')));
    $parameterList->AddParameter(new ACF_DirectParameter('newviewname',$inParameterList->ParameterValue('newviewname')));
    return $parameterList;
}

function DC_AskRemoveView(ACF_ParameterList $inParameterList) {
    $parameterList = new ACF_ParameterList();
    $parameterList->AddParameter(new ACF_DirectParameter('parentid',$inParameterList->ParameterValue('parentid')));
    $parameterList->AddParameter(new ACF_DirectParameter('viewname',$inParameterList->ParameterValue('viewname')));
    return $parameterList;
}

?>
