<?php
    function formatName($name) {
	//$revname = strrev($name);
	//$name=strrev(substr($revname,0,strpos($revname,"/")));
	return $name;
    }

    function indent($level,&$htmltxt) {
	if($level > 0) {
	    for($i=0;$i<$level;++$i) {
		if(($i+1) == $level)
		    $htmltxt .= "<td><div class=\"link_block\">--></div></td>";
		else
		    $htmltxt .= "<td><div class=\"link_block\"></div></td>";
	    }
	}
    }

    function findActivity($activity,$xml) {
	if($xml->executables->executable) {
	    foreach($xml->executables->executable as $executable) {
		if(($executable->name == $activity) && $executable->{'output-events'})
		    return $executable;
	    }
	}
	return false;
    }
    
    function findView($name,$xml) {
	if($xml->views->view) {
	    foreach($xml->views->view as $view) {
		if($view->name == $name)
		    return $view;
	    }
	}
	return false;
    }
    
    function findEvent($name,$xml) {
	foreach($xml->{'event-responses'}->{'response'} as $response) {
	    if(($response->{'event-name'} == $name) && ($response->{'source-realm'} == 'internal'))
		return $response;
	}
	return false;
    }

    function printInvocation($invocation,$level,$xml,&$htmltxt) {
	$htmltxt .= "<tr>";
	// Indent
	indent($level,$htmltxt);
	
	if($invocation->{'task-type'} == 'activity')
	    $htmltxt .= "<td COLSPAN=2><div class=\"activity_block\"><b><u>".formatName($invocation->{'task-name'})."</u></b>";
	if($invocation->{'task-type'} == 'view')
	    $htmltxt .= "<td COLSPAN=2><div class=\"view_block\"><b><u>".formatName($invocation->{'task-name'})."</u></b>";
	if($invocation->{'task-type'} == 'datacollector')
	    $htmltxt .= "<td COLSPAN=2><div class=\"collector_block\"><b><u>".formatName($invocation->{'task-name'})."</u></b>";

	// Parameters
	if($invocation->parameters->parameter) { // Print Parameters
	    //$htmltxt .= "<br>Input Parameters:";
	    foreach($invocation->parameters->parameter as $parameter) {
		$prefix = "";
		if($parameter->optional)
		    $prefix = "(opt)";
		if($parameter->type == 'direct')
		    $prefix = " = ".$parameter->value;
		$htmltxt .= "<br>".$parameter->name.$prefix;
	    }
	}
	$htmltxt .= "</div></td>";
	$htmltxt .= "</tr>";

	// Return Events
	if($invocation->{'task-type'} == 'activity') {
	    $executable = findActivity($invocation->{'task-name'},$xml);
	    if($executable) {
		$level++;
		foreach($executable->{'output-events'}->{'output-event'} as $internalevent) {
		    $event = findEvent($internalevent,$xml);
		    if($event)
			printEvent($event,$level,$xml,$htmltxt);
		}
	    }
	}

	// Datacollectors
	if($invocation->{'task-type'} == 'view') {
	    $view = findView($invocation->{'task-name'},$xml);
	    if($view) {
		$level++;
		foreach($view->datacollectors->invocation as $dc)
		    printInvocation($dc,$level,$xml,$htmltxt);
	    }
	}
    }

    function printEvent($event,$level,$xml,&$htmltxt) {
	$htmltxt .= "<tr>";

	// Indent
	indent($level,$htmltxt);

	$level++; // Shift Indent for kids
	
	// Event Name
	if($event->{'source-realm'} == 'external')
	    $htmltxt .= "<td COLSPAN=2><div class=\"event_block\"><b><u>".$event->{'event-name'}."</u></b></div></td>";
	else
	    $htmltxt .= "<td COLSPAN=2><div class=\"internal_block\"><b><u>".$event->{'event-name'}."</u></b></div></td>";

	$htmltxt .= "</tr>";

	// Invocations
	if($event->{'invocations'}->{'invocation'}) {
	    // Reverse Stack for ordering
	    $invarray = array();
	    foreach($event->{'invocations'}->{'invocation'} as $invocation) {
		array_unshift($invarray,$invocation); 
	    }	
	    
	    foreach($invarray as $invocation) {
		printInvocation($invocation,$level,$xml,$htmltxt);
	    } 
	}
    }

    function drawLayer($layerfile) {
	$htmltxt = "";

	if (file_exists($layerfile))
	    $xml = simplexml_load_file($layerfile);

	if($xml) {	    
	    // Sort and Order
	    $events = array();
	    foreach($xml->{'event-responses'}->response as $event) {
		if($event->{'source-realm'} == 'external') {
		    if($events[(string)$event->{'source-name'}])
			$events[(string)$event->{'source-name'}][(string)$event->{'event-name'}] = $event;
		    else
			$events[(string)$event->{'source-name'}] = array((string)$event->{'event-name'} => $event);
		}
	    }
	    ksort($events);
	    reset($events);
	
	    foreach($events as &$receiver) {
		ksort($receiver);
		reset($receiver);
	    }
		
	    foreach($events as $name=>&$receiver) {
		$htmltxt .= "<hr><h1>".$name."</h1><hr>";
		foreach($receiver as $event) {
		    $htmltxt .= "<table>";
		    printEvent($event,0,$xml,$htmltxt);
		    $htmltxt .= "</table>";
		    $htmltxt .= "<hr>";
		}
	    }
	}
	return $htmltxt;
    }
?>
