<?php
require_once('../../libs/platypus/wow.inc.php');
require_once("../../libs/ccs/options.inc.php");
//---- load the CCS Options have to laod it here because this is the first manditory function call
if (!$_SESSION['ccs'])
    loadCCSOptions();


function DC_GetTree(ACF_ParameterList $inParameterList){
    $status = array();
//---- if the session object does not exist create it
    if (!$_SESSION['knowledgebase']['tree'] || $inParameterList->ParameterValue('reload')){
        $_SESSION['knowledgebase']['tree'] = array();
//---- grab the data
	$helpdesk = new WOW_Request('', '', 'wombat');
        $helpdesk->setMethod('KB_Get_Tree');
        $helpdesk->setUsername($_SESSION['knowledgebase']['username']);
        $helpdesk->setPassword($_SESSION['knowledgebase']['password']);
	$helpdesk->addAttribute('logintype', 'staff');
        if($helpdesk->execute()){
	    $data = $helpdesk->getAttribute(0);
            $data = convertSimpleXMLToArray(simplexml_load_string($data[KB_Get_Tree]));
	    if ($data){
		$_SESSION['knowledgebase']['tree']['root'] = buildTree($data);
		$_SESSION['knowledgebase']['tree']['root']->name = 'root';
	    }else
		$_SESSION['knowledgebase']['tree'] = array();
        }else
            $_SESSION['knowledgebase']['tree'] = array();
    }
    if (!$_SESSION['knowledgebase']['tree']['root']){
        $status['code'] = '404';

        if (isset($helpdesk)) {
            $status['text'] = $helpdesk->lastError;
        } else {
            $status['text'] = 'Knowledge Base Not Found';
        }
    }
    if ($_SESSION['knowledgebase']['status']['text']){
        $status['text'] = ($status['text'] ? $status['text'] . "\n<BR>\n" : '') . $_SESSION['knowledgebase']['status']['text'];
        $_SESSION['knowledgebase']['status'] = array();
    }
//---- create a parameter object
    $parameterList = new ACF_ParameterList();
//---- add values to the parameter object
    if ($_SESSION['knowledgebase']['tree']['root']){
        $_SESSION['knowledgebase']['tree']['root']->moveFirst();
        $parameterList->AddParameter(new ACF_DirectParameter('tree', $_SESSION['knowledgebase']['tree']['root']));
    }else
        $parameterList->AddParameter(new ACF_DirectParameter('tree', ''));
    if ($status['text'])
        $parameterList->AddParameter(new ACF_DirectParameter('status', $status));

    return $parameterList;
}


function buildTree($branch){
    $tree = new Tree($treeName);
    if ($branch['kbnode']['id']){
        $arrayFix = $branch;
        $branch = array('kbnode' => array());
        array_push($branch['kbnode'], $arrayFix['kbnode']);
    }
    foreach($branch['kbnode'] as $node){
        $type       = $node['type'];
        $id         = $node['id'];
        $title      = $node['title'];
        $link       = false;
        $expandLink = false;
        $subTree    = null;
        if ($node['kbchildren'])
            $subTree = buildTree($node['kbchildren']);
        if (strtoupper($type) == "FOLDER")
            $expandLink = "expandfolder" . "?id=" . $id;
        else
            $link = "view" . $type . "?id=" . $id;
        $tree->insertTail(new data($title, $type, $link, $expandLink), $type . " " .$id);
        if ($subTree){
            $subTree->name = $id;
            $tree->currentNode->child = $subTree;
            $tree->currentNode->child->parent = $tree;
        }
    }
    return $tree;
}


function DC_GetIssue(ACF_ParameterList $inParameterList){
    $_SESSION['knowledgebase']['status'] = array();
    $issue = array('id' => $inParameterList->ParameterValue('id'), 'title' => '', 'sections' => array(), 'keywords' => array(), 'attachments' => array(), 'articles' => array());
    if (!is_numeric($issue['id'])) {
	$_SESSION['knowledgebase']['status']['text'] = "Invalid Issue Number";
    } else {
	$helpdesk = new WOW_Request('', '', 'wombat');
	$helpdesk->setMethod('KB_Get_Issue');
	$helpdesk->setUsername($_SESSION['knowledgebase']['username']);
	$helpdesk->setPassword($_SESSION['knowledgebase']['password']);
	$helpdesk->addAttribute('logintype', 'staff');
	$helpdesk->addParameter('nId', $issue['id'], 'int');
	if($helpdesk->execute()){
	   $data = $helpdesk->getAttribute(0);
	   $data = simplexml_load_string($data['KB_Get_Issue']);
//---- get the title
	   $issue['title'] = (string) $data->title->kbi_title;
//---- get the sections
	    foreach($data->section as $value)
		$issue['sections'][(string) $value->kbsec_section_name] = (string) $value->kbsec_body;
//---- get the keywords
	    foreach($data->keyword as $value)
		array_push($issue['keywords'], (string) $value->kbkey_word);
//---- get the attachments
	    foreach($data->attachment as $value){
		$attachment = array();
		$attachment['id']          = (string) $value->at_id;
		$attachment['description'] = (string) $value->at_description;
		$attachment['filename']    = (string) $value->at_filename;
		array_push($issue['attachments'], $attachment);
	    }
//---- get the articles
	    foreach($data->article as $value){
		$article = array();
		$article['id']    = (string) $value->kba_id;
		$article['title'] = (string) $value->kba_title;
		array_push($issue['articles'], $article);
	    }
	    $issue['path'] = dirname($_SERVER["SCRIPT_NAME"]);
	} else {
	    $_SESSION['knowledgebase']['status']['text'] = $helpdesk->lasterror;
	}
    }
//---- create a parameter object
    $parameterList = new ACF_ParameterList();
//---- add values to the parameter object
    $parameterList->AddParameter(new ACF_DirectParameter('issue', $issue));
//---- if the mru list has been loaded so send a flag to the page so it doesn't have to reload the mru list everytime
    if ($_SESSION['knowledgebase']['mruLoaded'])
	$parameterList->AddParameter(new ACF_DirectParameter('mruloaded', 'true'));
    return $parameterList;
}


function DC_GetArticle(ACF_ParameterList $inParameterList){
    $_SESSION['knowledgebase']['status'] = array();
    $article = array('id' => $inParameterList->ParameterValue('id'), 'title' => '', 'sections' => array(), 'keywords' => array(), 'attachments' => array(), 'issue' => array());
    if (!is_numeric($article['id'])) {
	$_SESSION['knowledgebase']['status']['text'] = "Invalid Article Number";
    } else {
	$helpdesk = new WOW_Request('', '', 'wombat');
	$helpdesk->setMethod('KB_Get_Article');
	$helpdesk->setUsername($_SESSION['knowledgebase']['username']);
	$helpdesk->setPassword($_SESSION['knowledgebase']['password']);
	$helpdesk->addAttribute('logintype', 'staff');
	$helpdesk->addParameter('nId', $article['id'], 'int');
	if($helpdesk->execute()){
	    $data = $helpdesk->getAttribute(0);
	    $data = simplexml_load_string($data['KB_Get_Article']);
//---- get the title
	    $article['title'] = (string) $data->title->kba_title;
//---- get the sections
	    foreach($data->section as $value)
		$article['sections'][(string) $value->kbsec_section_name] = (string) $value->kbsec_body;
//---- get the keywords
	    foreach($data->keyword as $value)
		array_push($article['keywords'], (string) $value->kbkey_word);
//---- get the attachments
	    foreach($data->attachment as $value){
		$attachment = array();
		$attachment['id']          = (string) $value->at_id;
		$attachment['description'] = (string) $value->at_description;
		$attachment['filename']    = (string) $value->at_filename;
		array_push($article['attachments'], $attachment);
		}
//---- get the issue
	    foreach($data->issue as $value){
		$issue = array();
		$issue['id']    = (string) $value->kbi_id;
		$issue['title'] = (string) $value->kbi_title;
		array_push($article['issue'], $issue);
	    }
	    $article['path'] = dirname($_SERVER["SCRIPT_NAME"]);
	} else {
	    $_SESSION['knowledgebase']['status']['text'] = $helpdesk->lasterror;
	}
    }
//---- create a parameter object
    $parameterList = new ACF_ParameterList();
//---- if the mru list has been loaded so send a flag to the page so it doesn't have to reload the mru list everytime
    if ($_SESSION['knowledgebase']['mruLoaded'])
        $parameterList->AddParameter(new ACF_DirectParameter('mruloaded', 'true'));
//---- add values to the parameter object
    $parameterList->AddParameter(new ACF_DirectParameter('article', $article));
    return $parameterList;
}


function DC_PerformSearch(ACF_ParameterList $inParameterList){
    $_SESSION['knowledgebase']['status'] = array();
    $search = array('results' => array());
    $search['query']   = $inParameterList->ParameterValue('query');
    $search['keyword'] = $inParameterList->ParameterValue('keyword');
    $search['title']   = $inParameterList->ParameterValue('title');
    $search['body']    = $inParameterList->ParameterValue('body');
    $helpdesk = new WOW_Request('', '', 'wombat');
    $helpdesk->setMethod('KB_Search');
    $helpdesk->setUsername($_SESSION['knowledgebase']['username']);
    $helpdesk->setPassword($_SESSION['knowledgebase']['password']);
    $helpdesk->addAttribute('logintype', 'staff');
    $helpdesk->addParameter('cQuery', $search['query']);
    if ($search['keyword'])
        $helpdesk->addParameter('bKeyword', true, "boolean");
    if ($search['title'])
        $helpdesk->addParameter('bTitle', true, "boolean");
    if ($search['body'])
        $helpdesk->addParameter('bBody', true, "boolean");
    if($helpdesk->execute())
        $search['results'] = $helpdesk->getAttributesArray();
    else
        $_SESSION['knowledgebase']['status']['text'] = $helpdesk->lasterror;
//---- create a parameter object
    $parameterList = new ACF_ParameterList();
//---- add values to the parameter object
    $parameterList->AddParameter(new ACF_DirectParameter('search', $search));
    return $parameterList;
}


function DC_GetFile(ACF_ParameterList $inParameterList){
    $filename = '';
    $filedata = '';
    if (!is_numeric($inParameterList->ParameterValue('id'))) {
	$_SESSION['knowledgebase']['status']['text'] = "Invalid Attachment Number";
	$filename = 'error.txt';
	$filedata = $_SESSION['knowledgebase']['status']['text'];
    } else {
//---- get the message data
	$helpdesk = new WOW_Request('', '', 'wombat');
	$helpdesk->setMethod('KB_Get_Attachment');
	$helpdesk->setUsername($_SESSION['knowledgebase']['username']);
	$helpdesk->setPassword($_SESSION['knowledgebase']['password']);
	$helpdesk->addAttribute('logintype', 'staff');
	$helpdesk->addParameter('cId', $inParameterList->ParameterValue('id'));
	if($helpdesk->execute()){
	    $results    = $helpdesk->getAttribute(0);
	    $filename   = $results['at_filename'];
	    $filedata   = $results['at_file'];
//---- if the file is compressed strip off the header and append .zip to the file name
	    if (strtoupper($results['foxpro-row']['at_compressed']) != "N"){
		$filename = $filename . ".zip";
	    }
//---- strip off the header and decode it
	    $filedata = base64_decode(substr($filedata, strpos($filedata, "\n\n") + 1, strlen($filedata) - strpos($filedata, "\n\n") + 1));
	}else{
            $filename = 'error.txt';
            $filedata = $helpdesk->lastError;
	}
    }
//---- create a parameter object
    $parameterList = new ACF_ParameterList();
//---- add values to the parameter object
    $parameterList->AddParameter(new ACF_DirectParameter('filename', $filename));
    $parameterList->AddParameter(new ACF_DirectParameter('filedata', $filedata));
    return $parameterList;
}


function DC_GetMRU(ACF_ParameterList $inParameterList){
    $cookie = array();
    $validitems = array();
    $cookieitems  = array();
    $search = array('results' => array());
//---- go through the cookie(s) and collect the MRU
    $cookie = $_COOKIE['kb_mru'];
//---- cookies are not pulled in order
    if (is_array($cookie)){
	ksort($cookie);
	foreach($cookie as $entry){
	    $parts = explode("|" , $entry);
	    if (is_numeric($parts[1]) && (strtolower($parts[0]) == "article" || strtolower($parts[0]) == "issue")){
		array_push($cookieitems, array('type' => $parts[0], 'id' => $parts[1]));
	    }
	}
    }
    // Do not query, if no valid entries exist in the cookie
    if (!$cookieitems) {
	$_SESSION['knowledgebase']['mruLoaded'] = true;
    } else {
//---- query the db for the title
	$helpdesk = new WOW_Request('', '', 'wombat');
	$helpdesk->setMethod('KB_Get_Titles');
	$helpdesk->setUsername($_SESSION['knowledgebase']['username']);
	$helpdesk->setPassword($_SESSION['knowledgebase']['password']);
	$helpdesk->addAttribute('logintype', 'staff');
	$helpdesk->addParameter('aList', $cookieitems, 'array');
	if($helpdesk->execute()){
	    $validitems = $helpdesk->getAttributesArray();
	    if ($validitems['element-1'])
		$validitems = array();
	    else
		$_SESSION['knowledgebase']['mruLoaded'] = true;
	}else
	    $_SESSION['knowledgebase']['status']['text'] = $helpdesk->lasterror;
    }
//---- create a parameter object
    $parameterList = new ACF_ParameterList();
    if ($validitems)
        $parameterList->AddParameter(new ACF_DirectParameter('kbmru', $validitems));
//---- add values to the parameter object
    return $parameterList;
}
?>
