<?php
	function AH_CheckForCCSOptions(ACF_ParameterList $inParameterList) {
		if($_SESSION['ccs']['optionsLoaded'])
			return new ACF_Event('checkforccsoptions_present');
		else {
			require_once('../../libs/ccs/options.inc.php');
			loadCCSOptions();

			$retEvent = new ACF_Event('checkforccsoptions_absent');
			$paramList = new ACF_ParameterList();
			$paramList->AddParameter(new ACF_DirectParameter('url',''));
			$retEvent->SetParameterList($paramList);
			return $retEvent;
		}
	}
	
	function AH_GlobalHopProject(ACF_ParameterList $inParameterList)
	{
		// This activity handler redirects a user to the given url (for Project hopping)

		$retEvent; // Return Event
		
		$prefix = $inParameterList->ParameterValue('prefix');
		$url = $inParameterList->ParameterValue('url');

		if($url) {
			if(!$prefix)
				$location = $_SESSION['ccs']['options']['driver-options']['url'].'/'.$url;
			else
				$location = $prefix.'/'.$url;
		} else {
			if(!$prefix)
				$location = $_SESSION['ccs']['options']['driver-options']['url'];
			else
				$location = $prefix;
		}

		header("location:".$location); // Send HTML header

		$retEvent = new ACF_Event('hopproject_return');
		return $retEvent;
	}

	function AH_SetServiceType(ACF_ParameterList $inParameterList) {
		$servicetype = $inParameterList->ParameterValue('servicetype');
		$_SESSION['modules']['requiredService'] = $servicetype;
		return new ACF_Event('setservicetype_return');
	}

	function AH_SetTask(ACF_ParameterList $inParameterList) {
		$task = $inParameterList->ParameterValue('task');
		if(($task == "flush") && $_SESSION['modules'][$_SESSION['modules']['requiredService']]['task'])
			unset($_SESSION['modules'][$_SESSION['modules']['requiredService']]['task']);
		elseif($task != "flush")
			$_SESSION['modules'][$_SESSION['modules']['requiredService']]['task'] = $task;

		return new ACF_Event('settask_return');
	}

	function AH_SetAlternate(ACF_ParameterList $inParameterList) {
		$alternate = $inParameterList->ParameterValue('alternate');
		if(($alternate == "flush") && $_SESSION['modules'][$_SESSION['modules']['requiredService']]['alternate'])
			unset($_SESSION['modules'][$_SESSION['modules']['requiredService']]['alternate']);
		elseif($alternate != "flush")
			$_SESSION['modules'][$_SESSION['modules']['requiredService']]['alternate'] = $alternate;

		return new ACF_Event('setalternate_return');
	}

	function AH_FlushTemplateStatus(ACF_ParameterList $inParameterList) {
		if($_SESSION['ccs']['knownSteps'])
			unset($_SESSION['ccs']['knownSteps']);
		if($_SESSION['ccs']['maxStep'])
			unset($_SESSION['ccs']['maxStep']);
		if($_SESSION['modules'][$status['servicetype']]['task'])
			unset($_SESSION['modules'][$status['servicetype']]['task']);
		if($_SESSION['modules'][$status['servicetype']]['alternate'])
			unset($_SESSION['modules'][$status['servicetype']]['alternate']);
		if($_SESSION['ccs']['excludeSteps'])
			unset($_SESSION['ccs']['excludeSteps']);

		return new ACF_Event('flushtemplatestatus_return');
	}
	
	function AH_CheckForCurrentUser(ACF_ParameterList $inParameterList) {
		if($_SESSION['ccs']['source'] && ($_SESSION['ccs']['source'] != 'default'))
			return new ACF_Event('checkforcurrentuser_success');
		else {
			$_SESSION['modules']['shared']['status'] = array('isError'=>true,
									 'text'=>'There is currently no user logged in.');
			return new ACF_Event('checkforcurrentuser_failed');
		}
	}

	function AH_CheckAuthorized(ACF_ParameterList $inParameterList) {
		if($_SESSION['modules']['shared']['authorized'])
			return new ACF_Event('checkauthorized_success');

		$_SESSION['modules']['shared']['status'] = array('isError'=>true,
								 'text'=>'Charges where not authorized.');
		return new ACF_Event('checkauthorized_failed');
	}
	
	function AH_ClearChargeItem(ACF_ParameterList $inParameterList) {
		if($_SESSION['modules']['shared']['chargeItem'])
			unset($_SESSION['modules']['shared']['chargeItem']);
		
		if($_SESSION['modules']['billing']['chargeitem'])
			unset($_SESSION['modules']['billing']['chargeitem']);	

		return new ACF_Event('clearchargeitem_return');
	}
?>
