<?php
    function setDomainChargeItem($type,$options = NULL) {
        $_SESSION['modules']['shared']['chargeItem']            = array();
        $_SESSION['modules']['domain']['manager']['backupData'] = array();
        $tldList = $_SESSION['ccs']['options']['driver-options']['service-modules']['domain']['service-options']['service-offering-list']['service-offering'];

        switch ($type){
            case 'renewal':
                $price = 0;
                foreach($tldList as $tldDetails)
                    if ($tldDetails['tld'] == $_SESSION['modules']['domain']['manager']['domainSuffix']){
                        if(isset($tldDetails['price']['period-pricing-renew'])) {
                            $price = $tldDetails['price']['period-pricing-renew'][$options['quantity'] - 1];
                            if($price == 0)
                                $price = $tldDetails['price']['period-pricing-renew'][0] * $options['quantity'];
                        } else 
                            $price = $options['quantity'] * $tldDetails['price']['renew'];
                        break;
                    }
                $autoRenewOption   = $_SESSION['ccs']['options']['driver-options']['service-modules']['domain']['service-options']['allow-renew-change'];
                $changeRenewOption = $autoRenewOption == "yes" || $autoRenewOption == "1";
                $autoRenewOption   = $_SESSION['ccs']['options']['driver-options']['service-modules']['domain']['service-options']['allow-renew-default'];
                $autoRenew         = ($autoRenewOption == "yes" || $autoRenewOption == "1") ? 1 : 0;
                if ($changeRenewOption && $options['autoRenew'])
                    $autoRenew = $options['autoRenew'];
                $_SESSION['modules']['shared']['chargeItem']['description']           = 'Domain Renewal';
                $_SESSION['modules']['shared']['chargeItem']['quantity']              = $options['quantity'];
                $_SESSION['modules']['shared']['chargeItem']['price']                 = $price;
                $_SESSION['modules']['shared']['chargeItem']['details']               = array('tld' => $_SESSION['modules']['domain']['manager']['domainSuffix'],
                                                                                         'domain' => $_SESSION['modules']['domain']['manager']['domain']);
                $_SESSION['modules']['domain']['manager']['backupData']['period']     = $options['quantity'];
                $_SESSION['modules']['domain']['manager']['backupData']['autoRenew']  = $autoRenew;
                $_SESSION['modules']['domain']['manager']['backupData']['expireYear'] = $options['expireyear'];
                $_SESSION['modules']['domain']['manager']['ccsEvent']                 = 'chargeserviceitem_auth';
                break;
            case 'register':
                foreach($_SESSION['modules']['domain']['register']['registerDomain'] as $domainName=>$domain) {
                    $price = 0;
                    foreach($tldList as $tldDetails)
                        if ($tldDetails['tld'] == $domain['tld']){
                            if(isset($tldDetails['price']['period-pricing-new'])) {
                                if(isset($tldDetails['price']['period-pricing-new'][$domain['period']-1]))
                                    $price = $tldDetails['price']['period-pricing-new'][$domain['period']-1];
                            } else
                                $price = $domain['period'] * $tldDetails['price']['new'];
                            break;
                        }
                
                    array_push($_SESSION['modules']['shared']['chargeItem'],array('description' => "Domain Registration: ".$domainName,
                                                                                  'quantity' => $domain['period'],
                                                                                  'price' => $price,
                                                                                  'details' => $domain['tld'],
                                                                                  'id' => $domainName));
                }

                break;
	    case 'trade':
//---- .eu trades
                $price = 0;
                foreach($tldList as $tldDetails)
                    if ($tldDetails['tld'] == '.eu'){
                        if(isset($tldDetails['price']['period-pricing-transfer']))
			    $price = $tldDetails['price']['period-pricing-tranfser'][0];
                        else 
                            $price = $tldDetails['price']['transfer'];
                        break;
                    }
                $_SESSION['modules']['shared']['chargeItem']['price']       = $price;
                $_SESSION['modules']['shared']['chargeItem']['description'] = 'Domain Trade';
                $_SESSION['modules']['shared']['chargeItem']['quantity']    = '1';
                $_SESSION['modules']['shared']['chargeItem']['details']     = array('tld' => $_SESSION['modules']['domain']['manager']['domainSuffix'],
                                                                                    'domain' => $_SESSION['modules']['domain']['manager']['domain']);
                $_SESSION['modules']['domain']['manager']['backupData']['contact'] = $options['contact'];
		break;
        }
    }
    
    function setDomainChargeItemInfo() {
        
        $serviceInfo = array();
        $serviceInfo['Login Information'] = array('ccsEditLink' => array('url' => 'billingurl','uri' => '/selectuser'),
                                                  'username' => $_SESSION['modules']['domain']['register']['loginInfo']['username'],
                                                  'password' => str_repeat('*',strlen($_SESSION['modules']['domain']['register']['loginInfo']['password'])));
        // All Information is the same for each domain
        foreach($_SESSION['modules']['domain']['register']['registerDomain'] as $domain) {
            $serviceInfo['Contact Information'] = $domain['contact_set'];
            $serviceInfo['Contact Information']['ccsEditLink'] = array('url'=>'serviceurl','uri'=>'/contactinfo');
            $serviceInfo['Details'] = array('ccsEditLink' => array('url'=>'serviceurl','uri'=>'/configure'), 'Domain Lock' => ($domain['domain_lock']?'Locked':'Unlocked'));
            if (isset($domain['nameserver_list'])){
                $serviceInfo['Nameservers'] = array('ccsEditLink' => array('url'=>'serviceurl','uri'=>'/configure'));
                foreach($domain['nameserver_list'] as $ns)
                    array_push($serviceInfo['Nameservers'],$ns['name']);
            }
            break;
        }

        $_SESSION['modules']['shared']['chargeItem']['confirmInfo'] = $serviceInfo;
    }


//---- Function to generate arrays used for dynamic templates
    function GenerateTemplateField($name, $type, $title, $manditory=false, $reference='', $attrib='', $options=''){
        $query                = array();
        $query['name']        = $name;
        $query['reference']   = $reference ? $reference : $name;
        $query['title']       = $title;
        $query['manditory']   = $manditory;
        $query['type']        = $type;
        if ($options)
            $query['options'] = $options;
        if ($attrib)
            $query['attrib']  = $attrib;
        return $query;
    }


//---- this function returns an array with the countries
    function getCountry($tld=''){
        $countries = array();
        switch ($tld){
            case '.eu':
//---- European Union has a limited country array
                $countries = array(
                    ""   => "",
                    "GB" => "United Kingdom (GB)",
                    "AT" => "Austria",
                    "BE" => "Belgium",
                    "CY" => "Cyprus",
                    "CZ" => "Czech Republic",
                    "DK" => "Denmark",
                    "EE" => "Estonia",
                    "FI" => "Finland",
                    "FR" => "France",
                    "DE" => "Germany",
                    "GR" => "Greece",
                    "HU" => "Hungary",
                    "IE" => "Ireland",
                    "IT" => "Italy",
                    "LV" => "Latvia",
                    "LT" => "Lithuania",
                    "LU" => "Luxembourg",
                    "MT" => "Malta (including Gozo and Comino)",
                    "NL" => "Netherlands",
                    "PL" => "Poland",
                    "PT" => "Portugal",
                    "SK" => "Slovakia",
                    "SI" => "Slovenia",
                    "ES" => "Spain",
                    "SE" => "Sweden",
                    "AX" => "Aland Islands",
                    "GI" => "Gibraltar",
                    "MQ" => "Martinique",
                    "GF" => "French Guyana",
                    "GP" => "Guadeloupe",
                    "RE" => "Reunion",
                );
                break;
            default:
                if (file_exists($_ENV['TCA_ETC'] . "/countrieslist.xml")){
                    $countryxml = simplexml_load_file($_ENV['TCA_ETC'] . "/countrieslist.xml");
                    foreach($countryxml as $country)
                        $countries[(string) $country->code] = (string) $country->name;
                }else
                    $countries = array(
                        "US" => "United States of America",
                        "AF" => "Afghanistan",
                        "AL" => "Albania",
                        "DZ" => "Algeria",
                        "AS" => "American Samoa",
                        "AD" => "Andorra",
                        "AI" => "Anguilla",
                        "AQ" => "Antarctica",
                        "AG" => "Antigua And Barbuda",
                        "AR" => "Argentina",
                        "AM" => "Armenia",
                        "AW" => "Aruba",
                        "AU" => "Australia",
                        "AT" => "Austria",
                        "AZ" => "Azerbaijan",
                        "BS" => "Bahamas",
                        "BH" => "Bahrain",
                        "BD" => "Bangladesh",
                        "BB" => "Barbados",
                        "BY" => "Belarus",
                        "BE" => "Belgium",
                        "BZ" => "Belize",
                        "BJ" => "Benin",
                        "BM" => "Bermuda",
                        "BT" => "Bhutan",
                        "BO" => "Bolivia",
                        "BA" => "Bosnia And Herzegowina",
                        "BW" => "Botswana",
                        "BV" => "Bouvet Island",
                        "BR" => "Brazil",
                        "IO" => "British Indian Ocean Territory",
                        "BN" => "Brunei Darussalam",
                        "BG" => "Bulgaria",
                        "BF" => "Burkina Faso",
                        "BI" => "Burundi",
                        "KH" => "Cambodia",
                        "CM" => "Cameroon",
                        "CA" => "Canada",
                        "CV" => "Cape Verde",
                        "KY" => "Cayman Islands",
                        "CF" => "Central African Republic",
                        "TD" => "Chad",
                        "CL" => "Chile",
                        "CN" => "China",
                        "CX" => "Christmas Island",
                        "CC" => "Cocos (Keeling) Islands",
                        "CO" => "Colombia",
                        "KM" => "Comoros",
                        "CG" => "Congo",
                        "CK" => "Cook Islands",
                        "CR" => "Costa Rica",
                        "CI" => "Cote D'ivoire",
                        "HR" => "Croatia",
                        "CY" => "Cyprus",
                        "CZ" => "Czech Republic",
                        "DK" => "Denmark",
                        "DJ" => "Djibouti",
                        "DM" => "Dominica",
                        "DO" => "Dominican Republic",
                        "TP" => "East Timor",
                        "EC" => "Ecuador",
                        "EG" => "Egypt",
                        "SV" => "El Salvador",
                        "GQ" => "Equatorial Guinea",
                        "ER" => "Eritrea",
                        "EE" => "Estonia",
                        "ET" => "Ethiopia",
                        "FK" => "Falkland Islands",
                        "FO" => "Faroe Islands",
                        "FJ" => "Fiji",
                        "FI" => "Finland",
                        "FR" => "France",
                        "GF" => "French Guiana",
                        "PF" => "French Polynesia",
                        "TF" => "French Southern Territories",
                        "GA" => "Gabon",
                        "GM" => "Gambia",
                        "GE" => "Georgia",
                        "DE" => "Germany",
                        "GH" => "Ghana",
                        "GI" => "Gibraltar",
                        "GR" => "Greece",
                        "GL" => "Greenland",
                        "GD" => "Grenada",
                        "GP" => "Guadeloupe",
                        "GU" => "Guam",
                        "GT" => "Guatemala",
                        "GN" => "Guinea",
                        "GW" => "Guinea-Bissau",
                        "GY" => "Guyana",
                        "HT" => "Haiti",
                        "HM" => "Heard And Mcdonald Islands",
                        "HN" => "Honduras",
                        "HK" => "Hong Kong",
                        "HU" => "Hungary",
                        "IS" => "Iceland",
                        "IN" => "India",
                        "ID" => "Indonesia",
                        "IE" => "Ireland",
                        "IL" => "Israel",
                        "IT" => "Italy",
                        "JM" => "Jamaica",
                        "JP" => "Japan",
                        "JO" => "Jordan",
                        "KZ" => "Kazakstan",
                        "KE" => "Kenya",
                        "KI" => "Kiribati",
                        "KR" => "Korea, Republic Of (South)",
                        "KW" => "Kuwait",
                        "KG" => "Kyrgyzstan",
                        "LA" => "Lao People's Democratic Republic",
                        "LV" => "Latvia",
                        "LB" => "Lebanon",
                        "LS" => "Lesotho",
                        "LR" => "Liberia",
                        "LI" => "Liechtenstein",
                        "LT" => "Lithuania",
                        "LU" => "Luxembourg",
                        "MO" => "Macau",
                        "MK" => "Macedonia",
                        "MG" => "Madagascar",
                        "MW" => "Malawi",
                        "MY" => "Malaysia",
                        "MV" => "Maldives",
                        "ML" => "Mali",
                        "MT" => "Malta",
                        "MH" => "Marshall Islands",
                        "MQ" => "Martinique",
                        "MR" => "Mauritania",
                        "MU" => "Mauritius",
                        "YT" => "Mayotte",
                        "MX" => "Mexico",
                        "FM" => "Micronesia",
                        "MD" => "Moldova, Republic Of",
                        "MC" => "Monaco",
                        "MN" => "Mongolia",
                        "MS" => "Montserrat",
                        "MA" => "Morocco",
                        "MZ" => "Mozambique",
                        "NA" => "Namibia",
                        "NR" => "Nauru",
                        "NP" => "Nepal",
                        "NL" => "Netherlands",
                        "AN" => "Netherlands Antilles",
                        "NC" => "New Caledonia",
                        "NZ" => "New Zealand",
                        "NI" => "Nicaragua",
                        "NE" => "Niger",
                        "NG" => "Nigeria",
                        "NU" => "Niue",
                        "NF" => "Norfolk Island",
                        "MP" => "Northern Mariana Islands",
                        "NO" => "Norway",
                        "OM" => "Oman",
                        "PK" => "Pakistan",
                        "PW" => "Palau",
                        "PA" => "Panama",
                        "PG" => "Papua New Guinea",
                        "PY" => "Paraguay",
                        "PE" => "Peru",
                        "PH" => "Philippines",
                        "PN" => "Pitcairn",
                        "PL" => "Poland",
                        "PT" => "Portugal",
                        "PR" => "Puerto Rico",
                        "QA" => "Qatar",
                        "RE" => "Reunion",
                        "RO" => "Romania",
                        "RU" => "Russian Federation",
                        "RW" => "Rwanda",
                        "SH" => "Saint Helena",
                        "KN" => "Saint Kitts And Nevis",
                        "LC" => "Saint Lucia",
                        "PM" => "Saint Pierre And Miquelon",
                        "VC" => "Saint Vincent And The Grenadines",
                        "WS" => "Samoa",
                        "SM" => "San Marino",
                        "ST" => "Sao Tome And Principe",
                        "SA" => "Saudi Arabia",
                        "SN" => "Senegal",
                        "SC" => "Seychelles",
                        "SL" => "Sierra Leone",
                        "SG" => "Singapore",
                        "SK" => "Slovakia",
                        "SI" => "Slovenia",
                        "SB" => "Solomon Islands",
                        "SO" => "Somalia",
                        "ZA" => "South Africa",
                        "ES" => "Spain",
                        "LK" => "Sri Lanka",
                        "SR" => "Suriname",
                        "SJ" => "Svalbard And Jan Mayen",
                        "SZ" => "Swaziland",
                        "SE" => "Sweden",
                        "CH" => "Switzerland",
                        "TW" => "Taiwan",
                        "TJ" => "Tajikistan",
                        "TZ" => "Tanzania",
                        "TH" => "Thailand",
                        "TG" => "Togo",
                        "TK" => "Tokelau",
                        "TO" => "Tonga",
                        "TT" => "Trinidad And Tobago",
                        "TN" => "Tunisia",
                        "TR" => "Turkey",
                        "TM" => "Turkmenistan",
                        "TC" => "Turks And Caicos Islands",
                        "TV" => "Tuvalu",
                        "UG" => "Uganda",
                        "UA" => "Ukraine",
                        "AE" => "United Arab Emirates",
                        "GB" => "United Kingdom",
                        "UM" => "United States Minor Outlying Islands",
                        "UY" => "Uruguay",
                        "UZ" => "Uzbekistan",
                        "VU" => "Vanuatu",
                        "VA" => "Vatican City State (Holy See)",
                        "VE" => "Venezuela",
                        "VN" => "Viet Nam",
                        "VG" => "Virgin Islands, (British)",
                        "VI" => "Virgin Islands, (U.S.)",
                        "WF" => "Wallis And Futuna",
                        "EH" => "Western Sahara",
                        "YE" => "Yemen",
                        "YU" => "Yugoslavia",
                        "ZM" => "Zambia",
                        "ZW" => "Zimbabwe"
                    );
        }
        return $countries;
    }
?>
