<?php
require_once("plat_billing/platfunctions.php");

global $storeid;
$storeid = $_SESSION['modules']['billing']['storeid'] ? $_SESSION['modules']['billing']['storeid'] : ($_SESSION['piwi']['storeid'] ? $_SESSION['piwi']['storeid'] : ($_SESSION['piwi']['defaultstore'] ? $_SESSION['piwi']['defaultstore'] : false));

function AH_InitPlatBilling (ACF_ParameterList $inParameterList) {
    $_SESSION['ccs']['source'] = 'default';
 // following line placed here to set $_SESSION['modules']['billing']['staffid'] to the ID of the staff user in wow_options.xml
    SetStaffLogin();

    // get GST display options
    $_SESSION['GST']['showGST'] = GetWebOption('australianGST_display',$storeid);

    if(strtoupper($_SESSION['GST']['showGST']) ==  'Y') {
	    $_SESSION['GST']['percent'] = GetWebOption('australianGST_percent',$storeid);
	    $_SESSION['GST']['desc'] = GetWebOption('australianGST_desc',$storeid);
    } else {
	    unset($_SESSION['GST']);
    }

    return new ACF_Event('initplatbilling_done');
}

function AH_SetBundled (ACF_ParameterList $inParameterList) {
    $_SESSION['ccs']['bundles'] = true;
    $_SESSION['modules']['billing']['returnEvent'] = 'setbundled';
    return new ACF_Event('setbundled_success');
}

function AH_CheckPassedRate (ACF_ParameterList $inParameterList) {
    if($_SESSION['ccs']['options']['passed']['rate']) {
        $paramList = new ACF_ParameterList();
        $paramList->AddParameter(new ACF_DirectParameter('bundleid',$_SESSION['ccs']['options']['passed']['rate']));
        $retEvent = new ACF_Event('rate_set');
        $retEvent->SetParameterList($paramList);
        return $retEvent;
    } else {
		return new ACF_Event('rate_notset');
    }
}

function AH_CheckStoreID (ACF_ParameterList $inParameterList) {
    global $storeid;
    // Added to notify CCS this is a bundling billing module
    $_SESSION['ccs']['bundled'] = true;

    if($_SESSION['ccs']['source'] == 'piwi6') {
        $_SESSION['ccs']['options']['passed']['storeid'] = $_SESSION['piwi']['storeid'];
        $_SESSION['modules']['billing']['custid'] = $_SESSION['piwi']['custid'];
        unset($_SESSION['piwi']['currentCRID']);
    }

    if ($_SESSION['ccs']['options']['passed']['storeid']) {
        $storeid = $_SESSION['modules']['billing']['storeid'] = $_SESSION['ccs']['options']['passed']['storeid'];
        return new ACF_Event('storeid_set');
    } else {
        return new ACF_Event('storeid_notset');
    }
}

function AH_Logout (ACF_ParameterList $inParameterList) {
    ResetStaffLogin();

    $URL         = $_SESSION['ccs']['options']['driver-options']['url'];
    header("location:".$URL."?NEWSESSION");
    return new ACF_Event('logout_done');
}

function AH_SetStore (ACF_ParameterList $inParameterList) {
    if(FixSlash($inParameterList->ParameterValue('storeid'))) {
        $_SESSION['modules']['billing']['storeid'] = FixSlash($inParameterList->ParameterValue('storeid'));
        return new ACF_Event('setstore_success');
    } else {
        return new ACF_Event('setstore_fail');
    }
}

function AH_GetDomainPrices (ACF_ParameterList $inParameterList) {
    $allPrices = GetAllPrices($inParameterList->ParameterValue('rgid'));

    $priceArray = array();
    $allowedTLDsByRate = array();
    $tldList = $_SESSION['ccs']['options']['driver-options']['service-modules']['domain']['service-options']['related-tld-groups'];

    if(isset($allPrices) && is_array($allPrices)) {
        foreach($allPrices as $thisPrice) {
            if(!in_array('.'.strtolower($thisPrice['service_subtype']),$allowedTLDsByRate)) {
                array_push($allowedTLDsByRate,'.'.strtolower($thisPrice['service_subtype']));
            }

            switch($thisPrice['transaction_type']) {
                case "Register":
                    $type = "new";
                    break;
                default:
                    $type = strtolower($thisPrice['transaction_type']);
            }
            $type = 'period-pricing-'.$type;

            $tld = ".".strtolower($thisPrice['service_subtype']);
            $year = $thisPrice['period'];

            if(!$priceArray[$tld]) {
                $priceArray[$tld] = array();
            }
            if(!$priceArray[$tld][$type]) {
                $priceArray[$tld][$type] = array();
            }
            $priceArray[$tld][$type][$year-1] = $thisPrice['price'];
        }

        if(isset($_SESSION['ccs']['options']['driver-options']['service-modules']['domain']['service-options']['service-offering-list']['service-offering']) && is_array($_SESSION['ccs']['options']['driver-options']['service-modules']['domain']['service-options']['service-offering-list']['service-offering'])) {
            foreach($_SESSION['ccs']['options']['driver-options']['service-modules']['domain']['service-options']['service-offering-list']['service-offering'] as &$thisTLD) {
                $thisTLD['price']['period-pricing-new'] = $priceArray[$thisTLD['tld']]['period-pricing-new'];
                $thisTLD['price']['period-pricing-renew'] = $priceArray[$thisTLD['tld']]['period-pricing-renew'];
                $thisTLD['price']['period-pricing-transfer'] = $priceArray[$thisTLD['tld']]['period-pricing-transfer'];
            }
        }
    }
	if(isset($tldList['group']) && is_array($tldList['group'])) {
		foreach($tldList['group'] as $tldGroupKey=>$tldGroup) {
			if(isset($tldGroup['tld']) && is_array($tldGroup['tld'])) { // more than one TLD in this group
				foreach($tldGroup['tld'] as $thisTLDKey=>$thisTLDName) {
					if(!in_array($thisTLDName,$allowedTLDsByRate) && $thisTLDName != 'default') {
						unset($tldList['group'][$tldGroupKey]['tld'][$thisTLDKey]);
					}
				}
			} else {
				if(!in_array($tldGroup['tld'],$allowedTLDsByRate)) {
					unset($tldList['group'][$tldGroupKey]);
				}
			}
		}
	}

    $_SESSION['ccs']['tldGroups'] = $tldList;

    return new ACF_Event('getdomainprices_done');
}

function AH_TestCharge (ACF_ParameterList $inParameterList) {
    if($_SESSION['ccs']['options']['driver-options']['billing-module']['billing-options']['rate-auth'] && $_SESSION['ccs']['options']['driver-options']['billing-module']['billing-options']['rate-auth'] == 'yes') {
        if(!$_SESSION['modules']['billing']['noCharge'] && !$_SESSION['piwi']['currentCRID'] && !$_SESSION['modules']['billing']['renewal'] && ($_SESSION['modules']['billing']['bundle']['rg_fixed_price'] > 0 || $_SESSION['modules']['billing']['bundle']['rg_one_time_fees'] > 0)) {
            $authinput = array();
            $authinput['custid'] = $_SESSION['modules']['billing']['custid'];
            $authinput['amount'] = $_SESSION['modules']['billing']['bundle']['rg_fixed_price'] + $_SESSION['modules']['billing']['bundle']['rg_one_time_fees'];
            $authinput['servicetype'] = 'testcharge';
            $authinput['servicename'] = '';
            $authinput['transactiontype'] = '';
            $authinput['ccinfo'] = array();
            $authinput['ccinfo']['ccnumber'] = $_SESSION['modules']['billing']['userdata']['ccdata']['number'];
            $authinput['ccinfo']['ccexpire'] = $_SESSION['modules']['billing']['userdata']['ccdata']['month'].$_SESSION['modules']['billing']['userdata']['ccdata']['year'];
            $authinput['ccinfo']['ccname'] = $_SESSION['modules']['billing']['userdata']['ccdata']['name'];
            $authinput['ccinfo']['cctype'] = $_SESSION['modules']['billing']['userdata']['ccdata']['type'];
            $authinput['ccinfo']['cvv2'] = $_SESSION['modules']['billing']['userdata']['ccdata']['cvv2'];
            $authinput['ccinfo']['ccaddress'] = array();
            $authinput['ccinfo']['ccaddress']['addr1'] = $_SESSION['modules']['billing']['userdata']['ccdata']['address']['addr1'];
            $authinput['ccinfo']['ccaddress']['addr2'] = $_SESSION['modules']['billing']['userdata']['ccdata']['address']['addr2'];
            $authinput['ccinfo']['ccaddress']['city'] = $_SESSION['modules']['billing']['userdata']['ccdata']['address']['city'];
            $authinput['ccinfo']['ccaddress']['state'] = $_SESSION['modules']['billing']['userdata']['ccdata']['address']['state'];
            $authinput['ccinfo']['ccaddress']['zip'] = $_SESSION['modules']['billing']['userdata']['ccdata']['address']['zip'];
            $authinput['ccinfo']['ccaddress']['country'] = $_SESSION['modules']['billing']['userdata']['ccdata']['address']['country'];
            $authinput['invoice'] = array();
            $authinput['invoice']['details'] = array();
            $authinput['invoice']['details'][0] = array();
            $authinput['invoice']['details'][0]['code'] = 'TEST';
            $authinput['invoice']['details'][0]['desc'] = 'Test Charge for First Bundle Charge';
            $authinput['invoice']['details'][0]['price'] = $_SESSION['modules']['billing']['bundle']['rg_fixed_price'];
            $authinput['invoice']['details'][0]['quantity'] = '1';
            $authinput['invoice']['details'][0]['profile'] = $_SESSION['modules']['billing']['priceData']['profile'];
            if($_SESSION['modules']['billing']['bundle']['rg_one_time_fees'] > 0) {
                $authinput['invoice']['details'][1] = array();
                $authinput['invoice']['details'][1]['code'] = 'TEST';
                $authinput['invoice']['details'][1]['desc'] = 'Test Charge for Setup Fee on First Bundle';
                $authinput['invoice']['details'][1]['price'] = $_SESSION['modules']['billing']['bundle']['rg_one_time_fees'];
                $authinput['invoice']['details'][1]['quantity'] = '1';
                $authinput['invoice']['details'][1]['profile'] = $_SESSION['modules']['billing']['priceData']['profile'];
            }

            $results = TestCharge($authinput);

            if($results['success']) {
                return new ACF_Event('testcharge_success');
            } else {
                $paramList = new ACF_ParameterList();
                $paramList->AddParameter(new ACF_DirectParameter('error',$results['errormsg']));
                $paramList->AddParameter(new ACF_DirectParameter('ccdata',$_SESSION['modules']['billing']['userdata']['ccdata']));
                $retEvent = new ACF_Event('testcharge_fail');
                $retEvent->SetParameterList($paramList);
                return $retEvent;
            }
        } else {
            return new ACF_Event('testcharge_success');
        }
    } else {
        return new ACF_Event('testcharge_success');
    }
}

function AH_Auth (ACF_ParameterList $inParameterList) {
	$_SESSION['modules']['billing']['staffpayment'] = false;
	if($_SESSION['piwi']['custinfo'][$_SESSION['modules']['billing']['custid']])
		unset($_SESSION['piwi']['custinfo'][$_SESSION['modules']['billing']['custid']]);

    if(isset($_SESSION['modules']['domain']['register-status']) && is_array($_SESSION['modules']['domain']['register-status'])) {
        foreach($_SESSION['modules']['domain']['register-status'] as $domainName=>$domainDetails) {
            $domain = $domainName;
            break;
        }
    }

    global $storeid;
    if($_SESSION['modules']['billing']['custid']) { // for sure, the id should be set now, if not it should definitely error out
        if((!$_SESSION['modules']['billing']['noCharge'] && $_SESSION['modules']['billing']['priceData']['price'] > 0 && !$_SESSION['piwi']['currentCRID']) || ($_SESSION['piwi']['currentCRID'] && $_SESSION['piwi']['firstService']) && !$_SESSION['ccs']['excludeService']) { // don't prompt for CC info
            $authinput = array();
            $authinput['custid'] = $_SESSION['modules']['billing']['custid'];
            $authinput['amount'] = $_SESSION['modules']['billing']['priceData']['price'];
            $authinput['servicetype'] = $_SESSION['modules']['billing']['bundle']['svc_ccs_service'];
            $authinput['servicename'] = $_SESSION['modules']['billing']['priceData']['servicename'];
            $authinput['transactiontype'] = $_SESSION['modules']['billing']['priceData']['transaction_type'];
            $authinput['ccinfo'] = array();
            $authinput['ccinfo']['ccnumber'] = $_SESSION['modules']['billing']['userdata']['ccdata']['number'];
            $authinput['ccinfo']['ccexpire'] = $_SESSION['modules']['billing']['userdata']['ccdata']['month'].$_SESSION['modules']['billing']['userdata']['ccdata']['year'];
            $authinput['ccinfo']['ccname'] = $_SESSION['modules']['billing']['userdata']['ccdata']['name'];
            $authinput['ccinfo']['cctype'] = $_SESSION['modules']['billing']['userdata']['ccdata']['type'];
            $authinput['ccinfo']['cvv2'] = $_SESSION['modules']['billing']['userdata']['ccdata']['cvv2'];
            $authinput['ccinfo']['ccaddress'] = array();
            $authinput['ccinfo']['ccaddress']['addr1'] = $_SESSION['modules']['billing']['userdata']['ccdata']['address']['addr1'];
            $authinput['ccinfo']['ccaddress']['addr2'] = $_SESSION['modules']['billing']['userdata']['ccdata']['address']['addr2'];
            $authinput['ccinfo']['ccaddress']['city'] = $_SESSION['modules']['billing']['userdata']['ccdata']['address']['city'];
            $authinput['ccinfo']['ccaddress']['state'] = $_SESSION['modules']['billing']['userdata']['ccdata']['address']['state'];
            $authinput['ccinfo']['ccaddress']['zip'] = $_SESSION['modules']['billing']['userdata']['ccdata']['address']['zip'];
            $authinput['ccinfo']['ccaddress']['country'] = $_SESSION['modules']['billing']['userdata']['ccdata']['address']['country'];
            $authinput['invoice'] = array();
            $authinput['invoice']['details'] = array();
            $authinput['invoice']['details']['item'] = array();
            $authinput['invoice']['details']['item']['code'] = $_SESSION['modules']['billing']['priceData']['item'];
            if ($_SESSION['modules']['billing']['renewal']) {
                $authinput['invoice']['details']['item']['desc'] = $_SESSION['modules']['billing']['priceData']['desc'].' ('.$_SESSION['modules']['billing']['priceData']['servicename'].')';
            } else {
                $authinput['invoice']['details']['item']['desc'] = $_SESSION['modules']['billing']['priceData']['desc'].' ('.$domain.')';
            }
            $authinput['invoice']['details']['item']['price'] = $_SESSION['modules']['billing']['priceData']['price'];
            $authinput['invoice']['details']['item']['quantity'] = '1';
            $authinput['invoice']['details']['item']['profile'] = $_SESSION['modules']['billing']['priceData']['profile'];

            $authResults = Authorize($authinput,$_SESSION['ccs']['options']['driver-options']['billing-module']['billing-options']['service-preauth']);

            if($authResults['success']) {
                $_SESSION['modules']['shared']['authorized'] = true;

                if($_SESSION['modules']['billing']['renewal'])
                    $_SESSION['modules']['billing']['returnEvent'] = 'chargeitem_auth';
                else
                    $_SESSION['modules']['billing']['returnEvent'] = 'authorize';
                $_SESSION['modules']['billing']['transactionData'] = $authResults['transactionData'];
                if($_SESSION['modules']['billing']['usertype'] == 'NEW')
                    WelcomeEmail($_SESSION['modules']['billing']['custid']);

                return new ACF_Event('auth_success');
            } else {
                $paramList = new ACF_ParameterList();
                $paramList->AddParameter(new ACF_DirectParameter('error',$authResults['error']));
                $paramList->AddParameter(new ACF_DirectParameter('ccdata',$_SESSION['modules']['billing']['userdata']['ccdata']));
                $retEvent = new ACF_Event('auth_fail');
                $retEvent->SetParameterList($paramList);
                return $retEvent;
            }
        } else {
            $_SESSION['modules']['shared']['authorized'] = true;

            if(!$_SESSION['ccs']['excludeService']) {
                if($domain && (strtolower($_SESSION['modules']['billing']['priceData']['transaction_type']) == 'transfer' || $_SESSION['modules']['billing']['priceData']['ca_domain'])) {
                    ExecuteSQL("insert into billing_transaction (bt_id, bt_date_start, bt_service_type, bt_service_name, bt_transaction_type, bt_customer_id, bt_subtotal, bt_taxtotal, bt_total, bt_last_action, bt_last_result, bt_payment_trans_id) select key_value+1, getdate(), 'domain', '".$domain."', '".$_SESSION['modules']['billing']['priceData']['transaction_type']."', ".$_SESSION['modules']['billing']['custid'].", 0, 0, 0, 'AUTHORIZE', 'SUCCESS', 0 from keytable where key_name = 'billing_transaction'");
                    ExecuteSQL("update keytable set key_value = key_value+1 where key_name = 'billing_transaction'");
                }

                if($_SESSION['modules']['billing']['renewal']) {
                    $_SESSION['modules']['billing']['returnEvent'] = 'chargeitem_auth';
                } else {
                    $_SESSION['modules']['billing']['returnEvent'] = 'authorize';
                }
                $_SESSION['modules']['billing']['transactionData'] = false;

                if($_SESSION['modules']['billing']['usertype'] == 'NEW')
                    WelcomeEmail($_SESSION['modules']['billing']['custid']);
                return new ACF_Event('auth_success');
            } else {
                if($_SESSION['modules']['billing']['usertype'] == 'NEW')
                    WelcomeEmail($_SESSION['modules']['billing']['custid']);
                return new ACF_Event('auth_notrans');
            }
        }
    } else {
        $paramList = new ACF_ParameterList();
        $paramList->AddParameter(new ACF_DirectParameter('error','NO CUSTID'));
        $retEvent = new ACF_Event('auth_fail');
        $retEvent->SetParameterList($paramList);
        return $retEvent;
    }
}

function AH_AuthStaff (ACF_ParameterList $inParameterList) {
	$_SESSION['modules']['billing']['staffpayment'] = true;
	if($_SESSION['piwi']['custinfo'][$_SESSION['modules']['billing']['custid']])
		unset($_SESSION['piwi']['custinfo'][$_SESSION['modules']['billing']['custid']]);

	if(isset($_SESSION['modules']['domain']['register-status']) && is_array($_SESSION['modules']['domain']['register-status'])) {
		foreach($_SESSION['modules']['domain']['register-status'] as $domainName=>$domainDetails) {
			$domain = $domainName;
			break;
		}
	}

	global $storeid;
	if($_SESSION['modules']['billing']['custid']) { // for sure, the id should be set now, if not it should definitely error out
		if((!$_SESSION['modules']['billing']['noCharge'] && $_SESSION['modules']['billing']['priceData']['price'] > 0 && !$_SESSION['piwi']['currentCRID']) || ($_SESSION['piwi']['currentCRID'] && $_SESSION['piwi']['firstService']) && !$_SESSION['ccs']['excludeService']) { // don't prompt for CC info
			// build code to create invoice for domain
			//$authResults = FunctionToCreateInvoice(built code);
			$invoiceItems = array();
			$invoiceItem = array();
			$invoiceItem['item'] = $_SESSION['modules']['billing']['priceData']['item'];
			if($_SESSION['modules']['billing']['renewal'])
				$invoiceItem['description'] = $_SESSION['modules']['billing']['priceData']['desc'] . ' (' . $_SESSION['modules']['billing']['priceData']['servicename'] . ')';
			else
				$invoiceItem['description'] = $_SESSION['modules']['billing']['priceData']['desc'] . ' (' . $domain . ')';
			$invoiceItem['quantity'] = 1;
			$invoiceItem['price'] = $_SESSION['modules']['billing']['priceData']['price'];
			$invoiceItem['profileid'] = $_SESSION['modules']['billing']['priceData']['profile'];

			switch(GetDateFormat()) {
				case "YMD":
					$invoiceItem['startdate'] = $invoiceItem['enddate'] = date("Y/n/j",mktime(0,0,0,date("m"),date("d"),date("Y")));
					break;
				case "DMY":
					$invoiceItem['startdate'] = $invoiceItem['enddate'] = date("j/n/Y",mktime(0,0,0,date("m"),date("d"),date("Y")));
					break;
				case "MDY":
					$invoiceItem['startdate'] = $invoiceItem['enddate'] = date("n/j/Y",mktime(0,0,0,date("m"),date("d"),date("Y")));
					break;
			}

			array_push($invoiceItems,$invoiceItem);

			$authResults = CreateMultiLineInvoice($_SESSION['modules']['billing']['custid'],$_SESSION['modules']['billing']['userdata']['guarantor'],$_SESSION['piwi']['staffid'],'',$invoiceItems);

			if($authResults['success']) {
				$_SESSION['modules']['shared']['authorized'] = true;

				if($_SESSION['modules']['billing']['renewal'])
					$_SESSION['modules']['billing']['returnEvent'] = 'chargeitem_auth';
				else
					$_SESSION['modules']['billing']['returnEvent'] = 'authorize';

				//$_SESSION['modules']['billing']['transactionData'] = $authResults['transactionData'];
				if($_SESSION['modules']['billing']['usertype'] == 'NEW')
					WelcomeEmail($_SESSION['modules']['billing']['custid']);

				return new ACF_Event('auth_success');
			} else {
				$paramList = new ACF_ParameterList();
				$paramList->AddParameter(new ACF_DirectParameter('error',$authResults['error']));
				$paramList->AddParameter(new ACF_DirectParameter('ccdata',$_SESSION['modules']['billing']['userdata']['ccdata']));
				$retEvent = new ACF_Event('auth_fail');
				$retEvent->SetParameterList($paramList);
				return $retEvent;
			}
		} else {
			$_SESSION['modules']['shared']['authorized'] = true;

			if(!$_SESSION['ccs']['excludeService']) {
				if($domain && (strtolower($_SESSION['modules']['billing']['priceData']['transaction_type']) == 'transfer' || $_SESSION['modules']['billing']['priceData']['ca_domain'])) {
					ExecuteSQL("insert into billing_transaction (bt_id, bt_date_start, bt_service_type, bt_service_name, bt_transaction_type, bt_customer_id, bt_subtotal, bt_taxtotal, bt_total, bt_last_action, bt_last_result, bt_payment_trans_id) select key_value+1, getdate(), 'domain', '".$domain."', '".$_SESSION['modules']['billing']['priceData']['transaction_type']."', ".$_SESSION['modules']['billing']['custid'].", 0, 0, 0, 'AUTHORIZE', 'SUCCESS', 0 from keytable where key_name = 'billing_transaction'");
					ExecuteSQL("update keytable set key_value = key_value+1 where key_name = 'billing_transaction'");
				}

				if($_SESSION['modules']['billing']['renewal']) {
					$_SESSION['modules']['billing']['returnEvent'] = 'chargeitem_auth';
				} else {
					$_SESSION['modules']['billing']['returnEvent'] = 'authorize';
				}

				$_SESSION['modules']['billing']['transactionData'] = false;

				if($_SESSION['modules']['billing']['usertype'] == 'NEW')
					WelcomeEmail($_SESSION['modules']['billing']['custid']);

				return new ACF_Event('auth_success');
			} else {
				if($_SESSION['modules']['billing']['usertype'] == 'NEW')
					WelcomeEmail($_SESSION['modules']['billing']['custid']);

				return new ACF_Event('auth_notrans');
			}
		}
	} else {
		$paramList = new ACF_ParameterList();
		$paramList->AddParameter(new ACF_DirectParameter('error','NO CUSTID'));
		$retEvent = new ACF_Event('auth_fail');
		$retEvent->SetParameterList($paramList);
		return $retEvent;
	}
}

function AH_ChargeItemSetup (ACF_ParameterList $inParameterList) {
    $_SESSION['modules']['billing']['noSignup'] = true;
    switch($_SESSION['modules']['shared']['chargeItem']['description']) {
        case "Domain Renewal":
            $_SESSION['modules']['billing']['chargeItemType'] = 'renew';
            return new ACF_Event('chargeitem_renew');
            break;
    }
}

function AH_CommitCheck (ACF_ParameterList $inParameterList) { // used to check for the staff payment path
	if($_SESSION['modules']['billing']['staffpayment'])
		return new ACF_Event('commit_staff');
	else
		return new ACF_Event('commit_standard');
}

function AH_Commit (ACF_ParameterList $inParameterList) {
    if(!$_SESSION['ccs']['excludeService']) {
        if($_SESSION['modules']['billing']['renewal'])
            $_SESSION['modules']['billing']['returnEvent'] = 'chargeitem_commit';
        else
            $_SESSION['modules']['billing']['returnEvent'] = 'commit';

        if($_SESSION['modules']['billing']['noCharge'] || $_SESSION['modules']['billing']['priceData']['price'] == 0 || ($_SESSION['piwi']['currentCRID'] && !$_SESSION['piwi']['firstService']) || strtolower($_SESSION['modules']['billing']['priceData']['transaction_type']) == 'transfer' || $_SESSION['modules']['billing']['priceData']['ca_domain']) {
            $commitSuccess = true; // say the commit worked anyway
        } else {
            if($_SESSION['modules']['billing']['transactionData'] && strtolower($_SESSION['modules']['billing']['priceData']['transaction_type']) != 'transfer' && !$_SESSION['modules']['billing']['priceData']['ca_domain']) {
                $commitSuccess = Commit($_SESSION['modules']['billing']['transactionData']['transid']);
            } else {
                $commitSuccess = false;
            }
        }

        if($commitSuccess) {
            if(!$_SESSION['modules']['billing']['OpenSRSProfile'] && $_SESSION['modules']['billing']['randomProfile']) { // && !$_SESSION['piwi']['currentCRID'] && !$_SESSION['modules']['billing']['noSignup'])
                SetProfile($_SESSION['modules']['billing']['custid'],$_SESSION['modules']['billing']['randomProfile']['username'],$_SESSION['modules']['billing']['randomProfile']['password']);
				$_SESSION['modules']['billing']['OpenSRSProfile']['username'] = $_SESSION['modules']['billing']['randomProfile']['username'];
				$_SESSION['modules']['billing']['OpenSRSProfile']['password'] = $_SESSION['modules']['billing']['randomProfile']['password'];
				if($_SESSION['piwi']) {
					$_SESSION['piwi']['OpenSRSProfile'] = $_SESSION['modules']['billing']['OpenSRSProfile'];
				}
			}
	
            if($_SESSION['modules']['billing']['usertype'] == 'NEW')
                LaunchUM('UM_New Save',$_SESSION['modules']['billing']['custid']);

// SECTION TO HANDLE CREATION OF SERVICES
            $fieldArray = array();

            if(!$_SESSION['modules']['billing']['renewal']) {

                $serviceType = $_SESSION['piwi']['servicetype'] ? $_SESSION['piwi']['servicetype'] : $_SESSION['modules']['billing']['bundle']['svc_ccs_service'];
                $serviceID = $_SESSION['ccs']['source'] == 'piwi' ? $_SESSION['piwi']['serviceid'] : $_SESSION['modules']['billing']['bundle']['rg_ccs_svc_id'];

                switch($serviceType) {
                    case 'blogware':
                        array_push($fieldArray,array('fieldname'=>'blog_id','value'=>$_SESSION['modules']['blogware']['register-status']['blog_id'],'ctrl'=>'txt_text','displayname'=>'Blogware ID'));
                        array_push($fieldArray,array('fieldname'=>'blog_package','value'=>$_SESSION['modules']['blogware']['register-status']['package'],'ctrl'=>'txt_text','displayname'=>'Blogware Package'));
                        array_push($fieldArray,array('fieldname'=>'blog_hostname','value'=>$_SESSION['modules']['blogware']['register-status']['hostname'],'ctrl'=>'txt_text','displayname'=>'Blogware Hostname'));
                        array_push($fieldArray,array('fieldname'=>'blog_trial','value'=>$_SESSION['modules']['blogware']['register-status']['trial'] ? 1 : 0,'ctrl'=>'chk_checkbox','displayname'=>'Blogware Trial'));
                        break;
                    case 'domain':
                        $dateFormat = GetDateFormat();
                        if(isset($_SESSION['modules']['domain']['register-status']) && is_array($_SESSION['modules']['domain']['register-status'])) {
                            foreach($_SESSION['modules']['domain']['register-status'] as $domainName=>$domainDetails) {
                                array_push($fieldArray,array('fieldname'=>'domain','value'=>$domainName,'ctrl'=>'txt_text','displayname'=>'Domain'));
                                array_push($fieldArray,array('fieldname'=>'register_period','value'=>$domainDetails['period'],'ctrl'=>'txt_date','displayname'=>'Registration Period'));
                                switch($dateFormat) {
                                    case "YMD":
                                        array_push($fieldArray,array('fieldname'=>'expire_date','value'=>date("Y/n/j",mktime(0,0,0,date("m"),date("d"),date("Y")+$domainDetails['period'])),'ctrl'=>'txt_date','displayname'=>'Expiration Date'));
                                        break;
                                    case "DMY":
                                        array_push($fieldArray,array('fieldname'=>'expire_date','value'=>date("j/n/Y",mktime(0,0,0,date("m"),date("d"),date("Y")+$domainDetails['period'])),'ctrl'=>'txt_date','displayname'=>'Expiration Date'));
                                        break;
                                    case "MDY":
                                        array_push($fieldArray,array('fieldname'=>'expire_date','value'=>date("n/j/Y",mktime(0,0,0,date("m"),date("d"),date("Y")+$domainDetails['period'])),'ctrl'=>'txt_date','displayname'=>'Expiration Date'));
                                        break;
				}
 // NOTE: THIS DOES NOT SUPPORT MULTIPLE DOMAIN REGISTRATIONS AT THIS TIME!!!
                            }
                        }
                        break;
                }

                AddService(
                    $_SESSION['modules']['billing']['crid'],
                    $_SESSION['modules']['billing']['custid'],
                    $serviceID,
                    $fieldArray,
                    $_SESSION['modules']['billing']['bundle']['structdata']['rs_id'],
                    $_SESSION['modules']['billing']['bundle']['structdata']['rs_parent_instance'],
                    $_SESSION['modules']['billing']['bundle']['structdata']['rs_parent_service'],
                    strtolower($_SESSION['modules']['billing']['priceData']['transaction_type']) == 'transfer' ? 'N' : 'Y'
                );
				
				if(!$_SESSION['piwi']['needsRefresh']) {
					$_SESSION['piwi']['needsRefresh'] = true;
				}
// END SERVICE CREATION SECTION
            } else {
                ExecuteSQL("update registered_domain_data set expire_date = dateadd(year,".SQLTrim($_SESSION['modules']['billing']['priceData']['period']).",expire_date) where domain = '".SQLTrim($_SESSION['modules']['shared']['domain'])."'");
            }

            unset($_SESSION['piwi']['firstRun']);

            return new ACF_Event('commit_success');
        } else {
            return new ACF_Event('commit_fail');
        }
    } else {
        $fieldArray = array();
        if(isset($_SESSION['modules']['domain']['register-status']) && is_array($_SESSION['modules']['domain']['register-status'])) {
            foreach($_SESSION['modules']['domain']['register-status'] as $domainName=>$domainDetails) {
                array_push($fieldArray,array('fieldname'=>'domain','value'=>$domainName,'ctrl'=>'txt_unique','displayname'=>'Domain Name'));
                array_push($fieldArray,array('fieldname'=>'gid','value'=>'1','ctrl'=>'chk_show_to_children','displayname'=>'Show to Children'));
            }
        }
        AddService($_SESSION['modules']['billing']['crid'],$_SESSION['modules']['billing']['custid'],2,$fieldArray,$_SESSION['modules']['billing']['bundle']['structdata']['rs_id'],$_SESSION['modules']['billing']['bundle']['structdata']['rs_parent_instance'],$_SESSION['modules']['billing']['bundle']['structdata']['rs_parent_service'],'Y');
		if(!$_SESSION['piwi']['needsRefresh']) {
			$_SESSION['piwi']['needsRefresh'] = true;
		}

        unset($_SESSION['piwi']['firstRun']);

        return new ACF_Event('commit_notrans');
    }
}

function AH_CommitStaff (ACF_ParameterList $inParameterList) {
	if(!$_SESSION['ccs']['excludeService']) {
		if($_SESSION['modules']['billing']['renewal'])
			$_SESSION['modules']['billing']['returnEvent'] = 'chargeitem_commit';
		else
			$_SESSION['modules']['billing']['returnEvent'] = 'commit';

		if($_SESSION['modules']['billing']['noCharge'] || $_SESSION['modules']['billing']['priceData']['price'] == 0 || ($_SESSION['piwi']['currentCRID'] && !$_SESSION['piwi']['firstService']) || strtolower($_SESSION['modules']['billing']['priceData']['transaction_type']) == 'transfer' || $_SESSION['modules']['billing']['priceData']['ca_domain']) {
			$commitSuccess = true; // say the commit worked anyway
		} else {
			if(strtolower($_SESSION['modules']['billing']['priceData']['transaction_type']) != 'transfer' && !$_SESSION['modules']['billing']['priceData']['ca_domain']) {
				$commitSuccess = true;
			} else {
				$commitSuccess = false;
			}
		}

		if($commitSuccess) {
			if(!$_SESSION['modules']['billing']['OpenSRSProfile'] && $_SESSION['modules']['billing']['randomProfile']) { // && !$_SESSION['piwi']['currentCRID'] && !$_SESSION['modules']['billing']['noSignup'])
				SetProfile($_SESSION['modules']['billing']['custid'],$_SESSION['modules']['billing']['randomProfile']['username'],$_SESSION['modules']['billing']['randomProfile']['password']);
				$_SESSION['modules']['billing']['OpenSRSProfile']['username'] = $_SESSION['modules']['billing']['randomProfile']['username'];
				$_SESSION['modules']['billing']['OpenSRSProfile']['password'] = $_SESSION['modules']['billing']['randomProfile']['password'];

				if($_SESSION['piwi']) {
					$_SESSION['piwi']['OpenSRSProfile'] = $_SESSION['modules']['billing']['OpenSRSProfile'];
				}
			}

			if($_SESSION['modules']['billing']['usertype'] == 'NEW')
			LaunchUM('UM_New Save',$_SESSION['modules']['billing']['custid']);

// SECTION TO HANDLE CREATION OF SERVICES
			$fieldArray = array();

			if(!$_SESSION['modules']['billing']['renewal']) {
				$serviceType = $_SESSION['piwi']['servicetype'] ? $_SESSION['piwi']['servicetype'] : $_SESSION['modules']['billing']['bundle']['svc_ccs_service'];
				$serviceID = $_SESSION['ccs']['source'] == 'piwi' ? $_SESSION['piwi']['serviceid'] : $_SESSION['modules']['billing']['bundle']['rg_ccs_svc_id'];

				switch($serviceType) {
					case 'blogware':
						array_push($fieldArray,array('fieldname'=>'blog_id','value'=>$_SESSION['modules']['blogware']['register-status']['blog_id'],'ctrl'=>'txt_text','displayname'=>'Blogware ID'));
						array_push($fieldArray,array('fieldname'=>'blog_package','value'=>$_SESSION['modules']['blogware']['register-status']['package'],'ctrl'=>'txt_text','displayname'=>'Blogware Package'));
						array_push($fieldArray,array('fieldname'=>'blog_hostname','value'=>$_SESSION['modules']['blogware']['register-status']['hostname'],'ctrl'=>'txt_text','displayname'=>'Blogware Hostname'));
						array_push($fieldArray,array('fieldname'=>'blog_trial','value'=>$_SESSION['modules']['blogware']['register-status']['trial'] ? 1 : 0,'ctrl'=>'chk_checkbox','displayname'=>'Blogware Trial'));
						break;
					case 'domain':
						$dateFormat = GetDateFormat();

						if(isset($_SESSION['modules']['domain']['register-status']) && is_array($_SESSION['modules']['domain']['register-status'])) {
							foreach($_SESSION['modules']['domain']['register-status'] as $domainName=>$domainDetails) {
								array_push($fieldArray,array('fieldname'=>'domain','value'=>$domainName,'ctrl'=>'txt_text','displayname'=>'Domain'));
								array_push($fieldArray,array('fieldname'=>'register_period','value'=>$domainDetails['period'],'ctrl'=>'txt_date','displayname'=>'Registration Period'));
								switch($dateFormat) {
									case "YMD":
										array_push($fieldArray,array('fieldname'=>'expire_date','value'=>date("Y/n/j",mktime(0,0,0,date("m"),date("d"),date("Y")+$domainDetails['period'])),'ctrl'=>'txt_date','displayname'=>'Expiration Date'));
										break;
									case "DMY":
										array_push($fieldArray,array('fieldname'=>'expire_date','value'=>date("j/n/Y",mktime(0,0,0,date("m"),date("d"),date("Y")+$domainDetails['period'])),'ctrl'=>'txt_date','displayname'=>'Expiration Date'));
										break;
									case "MDY":
										array_push($fieldArray,array('fieldname'=>'expire_date','value'=>date("n/j/Y",mktime(0,0,0,date("m"),date("d"),date("Y")+$domainDetails['period'])),'ctrl'=>'txt_date','displayname'=>'Expiration Date'));
										break;
								}
 // NOTE: THIS DOES NOT SUPPORT MULTIPLE DOMAIN REGISTRATIONS AT THIS TIME!!!
							}
						}

						break;
				}

                AddService(
                    $_SESSION['modules']['billing']['crid'],
                    $_SESSION['modules']['billing']['custid'],
                    $serviceID,
                    $fieldArray,
                    $_SESSION['modules']['billing']['bundle']['structdata']['rs_id'],
                    $_SESSION['modules']['billing']['bundle']['structdata']['rs_parent_instance'],
                    $_SESSION['modules']['billing']['bundle']['structdata']['rs_parent_service'],
                    strtolower($_SESSION['modules']['billing']['priceData']['transaction_type']) == 'transfer' ? 'N' : 'Y'
                );

				if(!$_SESSION['piwi']['needsRefresh']) {
					$_SESSION['piwi']['needsRefresh'] = true;
				}
// END SERVICE CREATION SECTION
			} else {
				ExecuteSQL("update registered_domain_data set expire_date = dateadd(year,".SQLTrim($_SESSION['modules']['billing']['priceData']['period']).",expire_date) where domain = '".SQLTrim($_SESSION['modules']['shared']['domain'])."'");
			}

			unset($_SESSION['piwi']['firstRun']);

			return new ACF_Event('commit_success');
		} else {
			return new ACF_Event('commit_fail');
		}
	} else {
		$fieldArray = array();

		if(isset($_SESSION['modules']['domain']['register-status']) && is_array($_SESSION['modules']['domain']['register-status'])) {
			foreach($_SESSION['modules']['domain']['register-status'] as $domainName=>$domainDetails) {
				array_push($fieldArray,array('fieldname'=>'domain','value'=>$domainName,'ctrl'=>'txt_unique','displayname'=>'Domain Name'));
				array_push($fieldArray,array('fieldname'=>'gid','value'=>'1','ctrl'=>'chk_show_to_children','displayname'=>'Show to Children'));
			}
		}

		AddService($_SESSION['modules']['billing']['crid'],$_SESSION['modules']['billing']['custid'],2,$fieldArray,$_SESSION['modules']['billing']['bundle']['structdata']['rs_id'],$_SESSION['modules']['billing']['bundle']['structdata']['rs_parent_instance'],$_SESSION['modules']['billing']['bundle']['structdata']['rs_parent_service'],'Y');

		if(!$_SESSION['piwi']['needsRefresh']) {
			$_SESSION['piwi']['needsRefresh'] = true;
		}

		unset($_SESSION['piwi']['firstRun']);

		return new ACF_Event('commit_notrans');
	}
}

function AH_CheckBalance (ACF_ParameterList $inParameterList) {
    if(!$_SESSION['ccs']['excludeService']) {
        if($_SESSION['modules']['billing']['bundle']['svc_ccs_service'] == 'domain') {
            if(!$_SESSION['piwi']['currentCRID'] || ($_SESSION['piwi']['currentCRID'] && $_SESSION['piwi']['firstService'])) {
// BEGIN SECTION FOR GETPRICE ON DOMAINS
                if($_SESSION['modules']['billing']['bundle']['svc_ccs_service'] == 'domain' && isset($_SESSION['modules']['domain']['register-status']) && is_array($_SESSION['modules']['domain']['register-status'])) {
                    foreach($_SESSION['modules']['domain']['register-status'] as $domainName=>$domainDetails) {
			    $priceData = GetPrice('domain',$domainDetails['owned'] ? 'transfer' : 'register',$domainDetails['owned'] ? 0 : $domainDetails['period'],substr($domainDetails['tld'],1),$_SESSION['modules']['billing']['bundle']['rg_id']);
			    if($priceData['success'])
				    $_SESSION['modules']['billing']['priceData'] = $priceData['priceData']; // NOTE: THIS DOES NOT SUPPORT MULTIPLE DOMAIN REGISTRATIONS AT THIS TIME!!!
                        $_SESSION['modules']['billing']['priceData']['servicename'] = $domainName;
                        $_SESSION['modules']['billing']['priceData']['ca_domain'] = strtolower($domainDetails['tld']) == '.ca';
                    }
                }
            }
// END SECTION FOR GETPRICE ON DOMAINS
        } else {
            $_SESSION['modules']['billing']['priceData']['price'] = 0;
            if($_SESSION['modules']['billing']['bundle']['svc_ccs_service'] == 'domain' && isset($_SESSION['modules']['domain']['register-status']) && is_array($_SESSION['modules']['domain']['register-status'])) {
                foreach($_SESSION['modules']['domain']['register-status'] as $domainName=>$domainDetails) {
                    $_SESSION['modules']['billing']['priceData']['servicename'] = $domainName;
                    $_SESSION['modules']['billing']['priceData']['transaction_type'] = $domainDetails['owned'] ? 'transfer' : 'register';
                    $_SESSION['modules']['billing']['priceData']['ca_domain'] = strtolower($domainDetails['tld']) == '.ca';
                }
            }
        }
    } else {
        $_SESSION['modules']['billing']['priceData']['price'] = 0;
        if($_SESSION['modules']['billing']['bundle']['svc_ccs_service'] == 'domain' && isset($_SESSION['modules']['domain']['register-status']) && is_array($_SESSION['modules']['domain']['register-status'])) {
            foreach($_SESSION['modules']['domain']['register-status'] as $domainName=>$domainDetails) {
                $_SESSION['modules']['billing']['priceData']['servicename'] = $domainName;
                $_SESSION['modules']['billing']['priceData']['transaction_type'] = $domainDetails['owned'] ? 'transfer' : 'register';
                $_SESSION['modules']['billing']['priceData']['ca_domain'] = strtolower($domainDetails['tld']) == '.ca';
            }
        }
    }

    if($_SESSION['modules']['billing']['priceData']['price'] <= 0 && $_SESSION['modules']['billing']['usertype'] == 'EXISTING' && ($_SESSION['piwi']['currentCRID'] || $_SESSION['modules']['billing']['bundle']['rg_fixed_price'] <= 0 || $_SESSION['modules']['billing']['bundle']['rg_one_time_fees'] <= 0 )) { // don't prompt for CC info
        $_SESSION['modules']['billing']['noCharge'] = true;
        if(is_array($_SESSION['ccs']['excludeSteps'])) {
            array_push($_SESSION['ccs']['excludeSteps'],'payment');
        } else {
            $_SESSION['ccs']['excludeSteps'] = array('payment');
        }

        return new ACF_Event('checkbalance_zero');
    } else { // prompt for CC info
	    $_SESSION['modules']['billing']['noCharge'] = false;
	    // check for staffid, go to different page in that case to give staff choice between cc payment and pay later
	    if($_SESSION['piwi']['staffid'])
		    return new ACF_Event('checkbalance_staff');
            else
		    return new ACF_Event('checkbalance_success');
    }
}

function AH_CheckBalanceRenew (ACF_ParameterList $inParameterList) {
	$_SESSION['modules']['billing']['renewal'] = true;

	if(!$_SESSION['modules']['billing']['custid']) {
		$username = $_SESSION['modules']['billing']['passed']['platuser'];
		$password = $_SESSION['modules']['billing']['passed']['platpass'];

		unset($_SESSION['modules']['billing']['passed']);

		if(strlen(trim($username)) || strlen(trim($password))) {
			$custIDarray = Login($username,$password,'customer');
			if(!$custIDarray) {
				$loginerror = "failed";
			}
		} else {
			$loginerror = "empty";
		}

		if($loginerror) {
            //$returnURL = $_SESSION['piwi']['options']['ccs-url'];
            //header("location:".$returnURL);
            $paramList = new ACF_ParameterList();
            $paramList->AddParameter(new ACF_DirectParameter('error',$loginerror));
            $retEvent = new ACF_Event('checkbalancerenew_loginfail');
            $retEvent->SetParameterList($paramList);
            return $retEvent;
		} else {
			$_SESSION['modules']['billing']['custid']  = $custIDarray['id'];
			$_SESSION['modules']['billing']['storeid'] = $custIDarray['storeid'];
			$_SESSION['modules']['billing']['OpenSRSProfile'] = GetProfile($_SESSION['modules']['billing']['custid']);
		}
	}

	$priceData = GetPrice('domain','renew',$_SESSION['modules']['shared']['chargeItem']['quantity'],substr($_SESSION['modules']['shared']['chargeItem']['details']['tld'],1),$_SESSION['modules']['billing']['bundle']['rg_id']);
	if($priceData['success'])
		$_SESSION['modules']['billing']['priceData'] = $priceData['priceData'];

	$_SESSION['modules']['billing']['priceData']['servicename'] = $_SESSION['modules']['shared']['chargeItem']['details']['domain'];

	$_SESSION['modules']['billing']['userdata'] = GetCustomerData($_SESSION['modules']['billing']['custid']);

	if($_SESSION['modules']['billing']['priceData']['price'] <= 0) {
		if(is_array($_SESSION['ccs']['excludeSteps']))
			array_push($_SESSION['ccs']['excludeSteps'],'payment');
		else
			$_SESSION['ccs']['excludeSteps'] = array('payment');

		return new ACF_Event('checkbalancerenew_zero');
	} else {
		$_SESSION['modules']['shared']['email'] = $_SESSION['modules']['billing']['userdata']['email'];
		$userdata = $_SESSION['modules']['billing']['userdata'];
		if($userdata) {
			$ccdata['month']        = date("m",strtotime($userdata['ccdate']));
			$ccdata['year']         = date("Y",strtotime($userdata['ccdate']));
			$ccdata['number']       = $userdata['ccnumber'];
			$ccdata['numberMasked'] = $userdata['creditcardmasked'];
			$ccdata['type']         = $userdata['cctype'];

			$addressData = GetAddressData($_SESSION['modules']['billing']['custid']);
			if(isset($addressData) && is_array($addressData)) {
				foreach($addressData as $address) {
					if($address['type'] == 5) {
						$ccdata['name']               = $address['attn'];
						$ccdata['address']['addr1']   = $address['addr1'];
						$ccdata['address']['addr2']   = $address['addr2'];
						$ccdata['address']['city']    = $address['city'];
						$ccdata['address']['state']   = $address['state'];
						$ccdata['address']['zip']     = $address['zip'];
						$ccdata['address']['country'] = $address['country'];
						break;
					}
				}
			}
		}

		$_SESSION['modules']['billing']['userdata']['ccdata'] = $ccdata;
		// check for staffid, go to different page in that case to give staff choice between cc payment and pay later
		if($_SESSION['piwi']['staffid'])
			return new ACF_Event('checkbalancerenew_staff');
		else
			return new ACF_Event('checkbalancerenew_success');
	}
}

function AH_SetBundle (ACF_ParameterList $inParameterList) {
    global $storeid;

    if(FixSlash($inParameterList->ParameterValue('bundleid'))) {
        if($_SESSION['ccs']['options']['driver-options']['billing-module']['billing-options']['display-non-ccs-bundles'] == 'yes') {
            $ccsBundleData = GetAvailableWebRates($storeid,true);

            if(isset($ccsBundleData) && is_array($ccsBundleData)) {
                foreach($ccsBundleData as $thisCCSBundle) {
                    if(($thisCCSBundle['rg_id'] . 'X' . $thisCCSBundle['r_frequency']) == FixSlash($inParameterList->ParameterValue('bundleid'))) {
                        $bundle = $thisCCSBundle;
                        $bundle['ccs'] = true;
						$bundle['name'] = $bundle['rg_name'] . ' - ' . $bundle['r_frequency'] . ' month' . ($bundle['r_frequency'] > 1 ? 's' : '');
						$bundle['id'] = $bundle['rg_id'] . 'X' . $bundle['r_frequency'];
                        break;
                    }
                }
            }

            if(!$bundle) {
				$bundleData = GetAvailableWebRates($storeid);
				if(isset($bundleData) && is_array($bundleData)) {
					foreach($bundleData as $thisBundle) {
						if(($thisBundle['rg_id'] . 'X' . $thisBundle['r_frequency']) == FixSlash($inParameterList->ParameterValue('bundleid'))) {
							$bundle = $thisBundle;
							$bundle['name'] = $bundle['rg_name'] . ' - ' . $bundle['r_frequency'] . ' month' . ($bundle['r_frequency'] > 1 ? 's' : '');
							$bundle['id'] = $bundle['rg_id'] . 'X' . $bundle['r_frequency'];
							break;
						}
					}
				}
            }
        } else {
            $bundleData = GetAvailableWebRates($storeid,true);
            if(isset($bundleData) && is_array($bundleData)) {
                foreach($bundleData as $thisBundle) {
                    if(($thisBundle['rg_id'] . 'X' . $thisBundle['r_frequency']) == FixSlash($inParameterList->ParameterValue('bundleid'))) {
                        $bundle = $thisBundle;
                        $bundle['ccs'] = true;
						$bundle['name'] = $bundle['rg_name'] . ' - ' . $bundle['r_frequency'] . ' month' . ($bundle['r_frequency'] > 1 ? 's' : '');
						$bundle['id'] = $bundle['rg_id'] . 'X' . $bundle['r_frequency'];
                        break;
                    }
                }
            }
        }

        if(!$storeid) {
            $storesList = explode(",",$bundle['rg_companies']);
            $storeid = $_SESSION['modules']['billing']['storeid'] = $storesList[0];
        } else {
            $_SESSION['modules']['billing']['storeid'] = $storeid;
        }

        $serviceTree = GetServiceTree($bundle['rg_id'],$_SESSION['modules']['billing']['custid']);
		if(isset($serviceTree) && is_array($serviceTree)) {
			foreach($serviceTree as $thisServiceStruct) {
				if(strtolower($bundle['svc_ccs_service']) == strtolower($thisServiceStruct['rs_ccs_service'])) {
					$bundle['structdata'] = $thisServiceStruct;
					break;
				}
			}
		}

        $_SESSION['modules']['billing']['bundle'] = $bundle;

        if($bundle['ccs']) {
            $_SESSION['modules']['billing']['returnEvent'] = 'selectbundle';

            $_SESSION['modules']['requiredService'] = $bundle['svc_ccs_service'];

            $fieldData = GetServiceFields($bundle['rg_ccs_svc_id'],$bundle['rg_id'],false,$bundle['structdata']['rs_id'],$bundle['structdata']['rs_parent_service'],$bundle['structdata']['rs_parent_instance']);

			if(isset($fieldData) && is_array($fieldData)) {
				switch($bundle['svc_ccs_service']) {
					case 'domain':
						foreach($fieldData as $thisField) {
							if($thisField['datacol'] == 'register_period' && !$_SESSION['modules']['domain']['passed']['register_period'] && $thisField['template_dflt'] != 'NULL' && $thisField['template_dflt'] != '') {
								$_SESSION['modules']['domain']['passed']['register_period'] = $thisField['template_dflt'];
							}
                        }
						break;
					case 'blogware':
						foreach($fieldData as $thisField) {
							if($thisField['datacol'] == 'blog_package' && $thisField['template_dflt'] != 'NULL' && $thisField['template_dflt'] != '') {
								$_SESSION['modules']['blogware']['package'] = $thisField['template_dflt'];
							}

							if($thisField['datacol'] == 'blog_trial' && $thisField['template_dflt'] != 'NULL' && $thisField['template_dflt'] != '') {
								$_SESSION['modules']['blogware']['trial'] = $thisField['template_dflt'] == 1 ? true : false;
                            }
						}

						if(!$_SESSION['modules']['blogware']['package']) {
							$error = "No Default Value set on Service Template assigned to this Bundle";
						}
						break;
				}
			} else {
				$error = "No Service Template assigned to this Bundle";
			}

			if($error && $bundle['svc_ccs_service'] == 'blogware') {
                $paramList = new ACF_ParameterList();
                $paramList->AddParameter(new ACF_DirectParameter('error','Blogware Signup is not currently available<BR>ERROR: '.$error));
                $retEvent = new ACF_Event('setbundle_fail');
                $retEvent->SetParameterList($paramList);
                return $retEvent;
            } else {
				$paramList = new ACF_ParameterList();
				$paramList->AddParameter(new ACF_DirectParameter('rgid',$bundle['rg_id']));
				$retEvent = new ACF_Event('setbundle_success');
				$retEvent->SetParameterList($paramList);
				return $retEvent;
			}
        } else { // jump to platsignup
            $_SESSION['ccs']['options']['driver-options']['url'] = $_SESSION['ccs']['options']['driver-options']['url-prefix'].'://'.$_SERVER['HTTP_HOST'].'/projects/platsignup';
            $_SESSION['modules']['billing']['returnEvent']       = "index.php?options[storeid]=".$storeid;
            return new ACF_Event('setbundle_success');
        }
    } else {
        $paramList = new ACF_ParameterList();
        $paramList->AddParameter(new ACF_DirectParameter('error','No Bundle ID selected'));
        $retEvent = new ACF_Event('setbundle_fail');
        $retEvent->SetParameterList($paramList);
        return $retEvent;
    }
}

function AH_CheckUser (ACF_ParameterList $inParameterList) {
    $_SESSION['modules']['billing']['returnEvent'] = 'selectuser';

    if($_SESSION['modules']['billing']['custid']) { // customer id is already set, return back to driver
        $userdata = GetCustomerData($_SESSION['modules']['billing']['custid']);
        $_SESSION['modules']['billing']['userdata'] = $userdata;
        $_SESSION['modules']['shared']['email'] = $userdata['email'];

        $_SESSION['modules']['billing']['usertype'] = 'EXISTING';

        if(!$_SESSION['ccs']['excludeService']) {
            $_SESSION['modules']['billing']['OpenSRSProfile'] = GetProfile($_SESSION['modules']['billing']['custid']);

            if($_SESSION['piwi']['OpenSRSProfile']) {
                $_SESSION['modules']['billing']['OpenSRSProfile'] = $_SESSION['piwi']['OpenSRSProfile'];
            }

            if($_SESSION['modules']['billing']['OpenSRSProfile']) { // BEGIN SECTION FOR DOMAIN BUNDLE COMPATIBILITY
                $_SESSION['modules']['shared']['username'] = $_SESSION['modules']['billing']['OpenSRSProfile']['username'];
                $_SESSION['modules']['shared']['password'] = $_SESSION['modules']['billing']['OpenSRSProfile']['password'];
                $_SESSION['modules']['shared']['domain']   = $_SESSION['modules']['billing']['OpenSRSProfile']['domain'];
            } else {
                $_SESSION['modules']['billing']['randomProfile'] = GenerateProfile();
                $_SESSION['modules']['shared']['username'] = $_SESSION['modules']['billing']['randomProfile']['username'];
                $_SESSION['modules']['shared']['password'] = $_SESSION['modules']['billing']['randomProfile']['password'];
                $_SESSION['modules']['shared']['domain']   = false;
            } // END SECTION FOR DOMAIN BUNDLE COMPATIBILITY
        }

        if(!$_SESSION['modules']['shared']['contact_info'] && (!$_SESSION['modules']['shared']['domain'] || $_SESSION['modules']['billing']['bundle']['svc_ccs_service'] != 'domain')) {
            if(strpos($userdata['name'],' ')) {
                $_SESSION['modules']['shared']['contact_info']['first_name'] = substr($userdata['name'],0,strpos($userdata['name'],' '));
                $_SESSION['modules']['shared']['contact_info']['last_name'] = substr($userdata['name'],strpos($userdata['name'],' ')+1);
            } else {
                $_SESSION['modules']['shared']['contact_info']['first_name'] = $userdata['name'];
                $_SESSION['modules']['shared']['contact_info']['last_name'] = false;
            }
            $_SESSION['modules']['shared']['contact_info']['company'] = $userdata['name'];
            $_SESSION['modules']['shared']['contact_info']['addr1'] = $userdata['addr1'];
            $_SESSION['modules']['shared']['contact_info']['addr2'] = $userdata['addr2'];
            $_SESSION['modules']['shared']['contact_info']['city'] = $userdata['city'];
            $_SESSION['modules']['shared']['contact_info']['state'] = $userdata['state'];
            $_SESSION['modules']['shared']['contact_info']['country'] = $userdata['country'];
            $_SESSION['modules']['shared']['contact_info']['postal_code'] = $userdata['zip'];
            $_SESSION['modules']['shared']['contact_info']['phone'] = str_replace(array("(",")","-"," "),"",$userdata['phone']);
            $_SESSION['modules']['shared']['contact_info']['fax'] = str_replace(array("(",")","-"," "),"",$userdata['phone2']);
            $_SESSION['modules']['shared']['contact_info']['email'] = $userdata['email'];
        }


        if($_SESSION['modules']['billing']['userdata']) {
            $_SESSION['modules']['billing']['userdata']['ccdata']['month'] = date("m",strtotime($_SESSION['modules']['billing']['userdata']['ccdate']));
            $_SESSION['modules']['billing']['userdata']['ccdata']['year'] = date("Y",strtotime($_SESSION['modules']['billing']['userdata']['ccdate']));
            $_SESSION['modules']['billing']['userdata']['ccdata']['number'] = $_SESSION['modules']['billing']['userdata']['ccnumber'];
            $_SESSION['modules']['billing']['userdata']['ccdata']['numberMasked'] = $_SESSION['modules']['billing']['userdata']['creditcardmasked'];
            $_SESSION['modules']['billing']['userdata']['ccdata']['type'] = $_SESSION['modules']['billing']['userdata']['cctype'];
            $addressData = GetAddressData($_SESSION['modules']['billing']['custid']);

            if(isset($addressData) && is_array($addressData)) {
                foreach($addressData as $address) {
                    if($address['type'] == 5) {
                        $_SESSION['modules']['billing']['userdata']['ccdata']['name']               = $address['attn'];
                        $_SESSION['modules']['billing']['userdata']['ccdata']['address']['addr1']   = $address['addr1'];
                        $_SESSION['modules']['billing']['userdata']['ccdata']['address']['addr2']   = $address['addr2'];
                        $_SESSION['modules']['billing']['userdata']['ccdata']['address']['city']    = $address['city'];
                        $_SESSION['modules']['billing']['userdata']['ccdata']['address']['state']   = $address['state'];
                        $_SESSION['modules']['billing']['userdata']['ccdata']['address']['zip']     = $address['zip'];
                        $_SESSION['modules']['billing']['userdata']['ccdata']['address']['country'] = $address['country'];
                        break;
                    }
                }
            }

            $_SESSION['modules']['billing']['bundle']['disallowed'] = true;
            $bundleData = GetAvailableWebRates($_SESSION['modules']['billing']['userdata']['storeid'],true);
            if(isset($bundleData) && is_array($bundleData)) {
                foreach($bundleData as $thisBundle) {
                    if($thisBundle['id'] == $_SESSION['modules']['billing']['bundle']['id']) {
                        $_SESSION['modules']['billing']['bundle']['disallowed'] = false;
                    }
                }
            }
        }

        if($_SESSION['ccs']['source'] == 'piwi' && $_SESSION['piwi']['currentCRID'])
            $_SESSION['modules']['billing']['bundle']['rg_fixed_price'] = 0;
            $_SESSION['modules']['billing']['bundle']['rg_one_time_fees'] = 0;

        $paramList = new ACF_ParameterList();
        $paramList->AddParameter(new ACF_DirectParameter('userdata',$_SESSION['modules']['billing']['userdata']));
        if($_SESSION['ccs']['source'] == 'piwi' && !$_SESSION['piwi']['firstRun']) {
            $_SESSION['piwi']['firstRun'] = true;
            if(!$_SESSION['ccs']['excludeService']) {
                $retEvent = new ACF_Event('checkuser_jump');
            } else {
                $retEvent = new ACF_Event('checkuser_notrans');
            }
        } else {
            if(!$_SESSION['ccs']['excludeService']) {
                $retEvent = new ACF_Event('checkuser_jump');
            } else {
                $retEvent = new ACF_Event('checkuser_notrans');
            }
        }

	$retEvent->SetParameterList($paramList);
        return $retEvent;
    } else { // user either needs to login or signup, present page that offers this option
        if($_SESSION['modules']['billing']['usertype'] == 'NEW') { // if a signup is in progress, go to the enter information screen
            $paramList = new ACF_ParameterList();
            $paramList->AddParameter(new ACF_DirectParameter('userdata',$_SESSION['modules']['billing']['signupData']));
            $retEvent = new ACF_Event('checkuser_signup');
            $retEvent->SetParameterList($paramList);
            return $retEvent;
        } else {
            return new ACF_Event('checkuser_login');
        }
    }
}

function AH_LoginUser (ACF_ParameterList $inParameterList) {
    $username = FixSlash($inParameterList->ParameterValue('username'));
    $password = FixSlash($inParameterList->ParameterValue('password'));

    if (strlen(trim($username)) || strlen(trim($password))) { // if the login or password is empty skip this, since this case is not allowed in the system
        $custloginarray = Login($username,$password,'customer');
        $custid = $custloginarray['id'];
        if($custid) {
	    $_SESSION['wow']['staffname'] = $username;
	    $_SESSION['wow']['staffpass'] = $password;
	    $_SESSION['wow']['logintype'] = 'customer';
	    SetStaffLogin();

            $OpenSRSProfile = GetProfile($custid);
            if($OpenSRSProfile) {
                $_SESSION['modules']['shared']['username'] = $OpenSRSProfile['username'];
                $_SESSION['modules']['shared']['password'] = $OpenSRSProfile['password'];
                $_SESSION['modules']['shared']['domain']   = $OpenSRSProfile['domain'];
            } else {
                $_SESSION['modules']['billing']['randomProfile'] = GenerateProfile();
                $_SESSION['modules']['shared']['username'] = $_SESSION['modules']['billing']['randomProfile']['username'];
                $_SESSION['modules']['shared']['password'] = $_SESSION['modules']['billing']['randomProfile']['password'];
                $_SESSION['modules']['shared']['domain']   = false;
            }
        } else {
            $loginError = 'failed';
        }
    } else {
        $loginError = 'empty';
    }

    if($loginError) {
        $paramList = new ACF_ParameterList();
        $paramList->AddParameter(new ACF_DirectParameter('error',$loginError));
        $retEvent = new ACF_Event('loginuser_fail');
        $retEvent->SetParameterList($paramList);
        return $retEvent;
    } else {
        $_SESSION['modules']['billing']['returnEvent'] = 'login';
        return new ACF_Event('loginuser_success');
    }
}

function AH_SetUser (ACF_ParameterList $inParameterList) {
    $username = FixSlash($inParameterList->ParameterValue('username'));
    $password = FixSlash($inParameterList->ParameterValue('password'));

    if (strlen(trim($username)) || strlen(trim($password))) { // if the login or password is empty skip this, since this case is not allowed in the system
        $custloginarray = Login($username,$password,'customer');
        $_SESSION['modules']['billing']['custid'] = $custloginarray['id'];
        if($_SESSION['modules']['billing']['custid']) {
    	    $_SESSION['wow']['staffname'] = $username;
	    $_SESSION['wow']['staffpass'] = $password;
	    $_SESSION['wow']['logintype'] = 'customer';
	    SetStaffLogin();

            $userdata = GetCustomerData($_SESSION['modules']['billing']['custid']);
            $_SESSION['modules']['shared']['email'] = $userdata['email'];
            $_SESSION['modules']['billing']['usertype'] = 'EXISTING';
            $_SESSION['modules']['billing']['username'] = $username;
            $_SESSION['modules']['billing']['password'] = $password;

            if(!$_SESSION['ccs']['excludeService']) {
                $_SESSION['modules']['billing']['OpenSRSProfile'] = GetProfile($_SESSION['modules']['billing']['custid']);
                if($_SESSION['modules']['billing']['OpenSRSProfile']) { // BEGIN SECTION FOR DOMAIN BUNDLE COMPATIBILITY
                    $_SESSION['modules']['shared']['username'] = $_SESSION['modules']['billing']['OpenSRSProfile']['username'];
                    $_SESSION['modules']['shared']['password'] = $_SESSION['modules']['billing']['OpenSRSProfile']['password'];
                    $_SESSION['modules']['shared']['domain']   = $_SESSION['modules']['billing']['OpenSRSProfile']['domain'];
                } else {
                    $_SESSION['modules']['billing']['randomProfile'] = GenerateProfile();
                    $_SESSION['modules']['shared']['username'] = $_SESSION['modules']['billing']['randomProfile']['username'];
                    $_SESSION['modules']['shared']['password'] = $_SESSION['modules']['billing']['randomProfile']['password'];
                    $_SESSION['modules']['shared']['domain']   = false;
                } // END SECTION FOR DOMAIN BUNDLE COMPATIBILITY
            }

            if(!$_SESSION['modules']['shared']['contact_info'] && (!$_SESSION['modules']['shared']['domain'] || $_SESSION['modules']['billing']['bundle']['svc_ccs_service'] != 'domain')) {
                if(strpos($userdata['name'],' ')) {
                    $_SESSION['modules']['shared']['contact_info']['first_name'] = substr($userdata['name'],0,strpos($userdata['name'],' '));
                    $_SESSION['modules']['shared']['contact_info']['last_name'] = substr($userdata['name'],strpos($userdata['name'],' ')+1);
                } else {
                    $_SESSION['modules']['shared']['contact_info']['first_name'] = $userdata['name'];
                    $_SESSION['modules']['shared']['contact_info']['last_name'] = false;
                }
                $_SESSION['modules']['shared']['contact_info']['company'] = $userdata['name'];
                $_SESSION['modules']['shared']['contact_info']['addr1'] = $userdata['addr1'];
                $_SESSION['modules']['shared']['contact_info']['addr2'] = $userdata['addr2'];
                $_SESSION['modules']['shared']['contact_info']['city'] = $userdata['city'];
                $_SESSION['modules']['shared']['contact_info']['state'] = $userdata['state'];
                $_SESSION['modules']['shared']['contact_info']['country'] = $userdata['country'];
                $_SESSION['modules']['shared']['contact_info']['postal_code'] = $userdata['zip'];
                $_SESSION['modules']['shared']['contact_info']['phone'] = str_replace(array("(",")","-"," "),"",$userdata['phone']);
                $_SESSION['modules']['shared']['contact_info']['fax'] = str_replace(array("(",")","-"," "),"",$userdata['phone2']);
                $_SESSION['modules']['shared']['contact_info']['email'] = $userdata['email'];
            }

            $_SESSION['modules']['billing']['userdata'] = $userdata;
            if($_SESSION['modules']['billing']['userdata']) {
                $_SESSION['modules']['billing']['userdata']['ccdata']['month'] = date("m",strtotime($_SESSION['modules']['billing']['userdata']['ccdate']));
                $_SESSION['modules']['billing']['userdata']['ccdata']['year'] = date("Y",strtotime($_SESSION['modules']['billing']['userdata']['ccdate']));
                $_SESSION['modules']['billing']['userdata']['ccdata']['number'] = $_SESSION['modules']['billing']['userdata']['ccnumber'];
                $_SESSION['modules']['billing']['userdata']['ccdata']['numberMasked'] = $_SESSION['modules']['billing']['userdata']['creditcardmasked'];
                $_SESSION['modules']['billing']['userdata']['ccdata']['type'] = $_SESSION['modules']['billing']['userdata']['cctype'];
                $addressData = GetAddressData($_SESSION['modules']['billing']['custid']);

                if(isset($addressData) && is_array($addressData)) {
                    foreach($addressData as $address) {
                        if($address['type'] == 5) {
                            $_SESSION['modules']['billing']['userdata']['ccdata']['name']               = $address['attn'];
                            $_SESSION['modules']['billing']['userdata']['ccdata']['address']['addr1']   = $address['addr1'];
                            $_SESSION['modules']['billing']['userdata']['ccdata']['address']['addr2']   = $address['addr2'];
                            $_SESSION['modules']['billing']['userdata']['ccdata']['address']['city']    = $address['city'];
                            $_SESSION['modules']['billing']['userdata']['ccdata']['address']['state']   = $address['state'];
                            $_SESSION['modules']['billing']['userdata']['ccdata']['address']['zip']     = $address['zip'];
                            $_SESSION['modules']['billing']['userdata']['ccdata']['address']['country'] = $address['country'];
                            break;
                        }
                    }
                }

                $_SESSION['modules']['billing']['bundle']['disallowed'] = true;
                $bundleData = GetAvailableWebRates($_SESSION['modules']['billing']['userdata']['storeid'],true);
                if(isset($bundleData) && is_array($bundleData)) {
                    foreach($bundleData as $thisBundle) {
                        if($thisBundle['id'] == $_SESSION['modules']['billing']['bundle']['id']) {
                            $_SESSION['modules']['billing']['bundle']['disallowed'] = false;
                        }
                    }
                }
            }
        } else {
            $loginerror = "failed";
        }
    } else {
        $loginerror = "empty";
    }

    if ($loginerror) {
        $paramList = new ACF_ParameterList();
        $paramList->AddParameter(new ACF_DirectParameter('error',$loginerror));
        $retEvent = new ACF_Event('setuser_fail');
        $retEvent->SetParameterList($paramList);
        return $retEvent;
    } else {
        if($_SESSION['modules']['shared']['domain'] || $_SESSSION['modules']['billing']['bundle']['svc_ccs_service'] != 'domain')
            if(!$_SESSION['ccs']['excludeService']) {
                return new ACF_Event('setuser_success');
            } else {
                return new ACF_Event('setuser_notrans');
            }
        else
            return new ACF_Event('setuser_agree');
    }
}

function AH_CheckAgree (ACF_ParameterList $inParameterList) {
    if(FixSlash($inParameterList->ParameterValue('terms'))) {
        $_SESSION['modules']['shared']['terms'] = true;
        return new ACF_Event('checkagree_success');
    } else {
        $paramList = new ACF_ParameterList();
        $paramList->AddParameter(new ACF_DirectParameter('error','You must agree with the Terms of Agreement in order to continue.'));
        $retEvent = new ACF_Event('checkagree_fail');
        $retEvent->SetParameterList($paramList);
        return $retEvent;
    }
}

function AH_AddUserToSession (ACF_ParameterList $inParameterList) {
    global $storeid;

    if(FixSlash($inParameterList->ParameterValue('userdata'))) {
        $userdata = FixSlash($inParameterList->ParameterValue('userdata'));
        if($userdata['nonrequired'])
            $mergedData = $userdata['required'] + $userdata['nonrequired'];
        else
            $mergedData = $userdata['required'];
        $mergedData['terms'] = $userdata['terms'];

        $_SESSION['modules']['billing']['signupData'] = $mergedData; // support for jumping back to the Signup screen
        $_SESSION['modules']['shared']['email'] = $mergedData['email'];

        unset($error);
        if(isset($userdata['required']) && is_array($userdata['required'])) {
            foreach($userdata['required'] as $fieldname=>$fieldvalue) {
                if (!$fieldvalue) {
                    $error = 'BLANK FIELD: '.$fieldname;
                    break;
                }
            }
        }

        if($userdata['required']['password'] != $userdata['required']['password2'] && !$error) {
            $error = 'PASSWORD FIELDS DO NOT MATCH';
        }

        if(!$error) {
	    if(!$_SESSION['modules']['billing']['webdefaults']['defaultshell'])
	        $_SESSION['modules']['billing']['webdefaults']['defaultshell'] = GetWebOption('defaultshell',$storeid);
	    if(!$_SESSION['modules']['billing']['webdefaults']['defaultpop'])
                $_SESSION['modules']['billing']['webdefaults']['defaultpop']   = GetWebOption('defaultpop',$storeid);

            $userchk = VerifyNewUser($storeid,$mergedData,$_SESSION['modules']['billing']['bundle']['id'],$_SESSION['modules']['billing']['webdefaults']['defaultshell'],$_SESSION['modules']['billing']['webdefaults']['defaultpop']);

            if(!$userchk['success']) {
                $error = $userchk['error'];
            }
        }

        if(!$userdata['terms']) {
            $error = 'You must agree with the Terms of Agreement in order to continue.';
        }

        if($error) {
            $paramList = new ACF_ParameterList();
            $paramList->AddParameter(new ACF_DirectParameter('error',$error));
            $paramList->AddParameter(new ACF_DirectParameter('userdata',$mergedData));
            $retEvent = new ACF_Event('addusertosession_fail');
            $retEvent->SetParameterList($paramList);
            return $retEvent;
        } else {
            if($_SESSION['modules']['billing']['userdata']['ccdata']) // support for jumping back, save any CC info entered so it can be reattached
                $tempCCData = $_SESSION['modules']['billing']['userdata']['ccdata'];

            $_SESSION['modules']['billing']['userdata'] = $mergedData;
            if($tempCCData)
                $_SESSION['modules']['billing']['userdata']['ccdata'] = $tempCCData;

            $_SESSION['modules']['billing']['usertype'] = 'NEW';
            $_SESSION['modules']['billing']['username'] = $_SESSION['modules']['billing']['userdata']['username'];
            $_SESSION['modules']['billing']['password'] = $_SESSION['modules']['billing']['userdata']['password'];

            $_SESSION['modules']['billing']['randomProfile'] = GenerateProfile();
            $_SESSION['modules']['shared']['username'] = $_SESSION['modules']['billing']['randomProfile']['username'];
            $_SESSION['modules']['shared']['password'] = $_SESSION['modules']['billing']['randomProfile']['password'];

            $_SESSION['modules']['shared']['domain']   = false;
            $_SESSION['modules']['shared']['terms']    = true;

            return new ACF_Event('addusertosession_success');
        }
    } else {
        $paramList = new ACF_ParameterList();
        $paramList->AddParameter(new ACF_DirectParameter('error','NO DATA ENTERED'));
        $paramList->AddParameter(new ACF_DirectParameter('userdata',''));
        $retEvent = new ACF_Event('addusertosession_fail');
        $retEvent->SetParameterList($paramList);
        return $retEvent;
    }
}

function AH_AddCCInfoToSession (ACF_ParameterList $inParameterList) {
    global $storeid;

    if(FixSlash($inParameterList->ParameterValue('ccinput'))) { // cc data passed from separate page, set it
        $ccinput = FixSlash($inParameterList->ParameterValue('ccinput'));
        if($ccinput['nonrequired']) {
            if($ccinput['nonrequired']['address']) {
                $mergedAddress = $ccinput['required']['address'] + $ccinput['nonrequired']['address'];
            } else {
                $mergedAddress = $ccinput['required']['address'];
            }
            $mergedInput = $ccinput['required'] + $ccinput['nonrequired'];
            $mergedInput['address'] = $mergedAddress;
        } else {
            $mergedInput = $ccinput['required'];
        }

        if(isset($ccinput['required']) && is_array($ccinput['required'])) {
            foreach($ccinput['required'] as $fieldname=>$fieldvalue) {
                if(!$fieldvalue) {
                    $error = 'BLANK FIELD: '.$fieldname;
                    break;
                }
            }
        }

        if($mergedInput['number'] == $_SESSION['modules']['billing']['userdata']['ccdata']['numberMasked']) {
            $mergedInput['numberMasked'] = $mergedInput['number'];
            $mergedInput['number']       = $_SESSION['modules']['billing']['userdata']['ccdata']['number'];
        } else {
            $mergedInput['numberMasked'] = str_repeat("*",strlen($mergedInput['number'])-4).substr($mergedInput['number'],strlen($mergedInput['number'])-4);
        }

        $validate = ValidateCard($mergedInput['type'],$mergedInput['number'],$mergedInput['month'],$mergedInput['year']);
        if(!$validate['success']) {
            $error = 'Invalid Credit Card Number and/or Expiration Date:  '.$validate['error'];
        }

	if($error) {
            $mergedInput['cvv2Required'] = strtoupper(GetWebOption('show_card_sec_code',$storeid));
            $paramList = new ACF_ParameterList();
            $paramList->AddParameter(new ACF_DirectParameter('error',$error));
            $paramList->AddParameter(new ACF_DirectParameter('ccdata',$mergedInput));
            $retEvent = new ACF_Event('addccinfotosession_fail');
            $retEvent->SetParameterList($paramList);
            return $retEvent;
        } else {
            if($mergedInput['number'] != $_SESSION['modules']['billing']['userdata']['ccdata']['numberMasked']) {
                $_SESSION['modules']['billing']['userdata']['ccdata']                 = $mergedInput;
                $_SESSION['modules']['billing']['userdata']['ccdata']['numberMasked'] = str_repeat("*",strlen($mergedInput['number'])-4).substr($mergedInput['number'],strlen($mergedInput['number'])-4);
            } else {
                $tempNumber = $_SESSION['modules']['billing']['userdata']['ccdata']['number'];
                $tempMask   = $_SESSION['modules']['billing']['userdata']['ccdata']['numberMasked'];
                $_SESSION['modules']['billing']['userdata']['ccdata']                 = $mergedInput;
                $_SESSION['modules']['billing']['userdata']['ccdata']['number']       = $tempNumber;
                $_SESSION['modules']['billing']['userdata']['ccdata']['numberMasked'] = $tempMask;
            }

            return new ACF_Event('addccinfotosession_success');
        }
    } else {
        $paramList = new ACF_ParameterList();
        $paramList->AddParameter(new ACF_DirectParameter('error','NO DATA ENTERED'));
        $paramList->AddParameter(new ACF_DirectParameter('ccdata',''));
        $retEvent = new ACF_Event('addccinfotosession_fail');
        $retEvent->SetParameterList($paramList);
        return $retEvent;
    }
}

function AH_AddUser (ACF_ParameterList $inParameterList) {
    if($_SESSION['modules']['billing']['usertype'] == 'NEW') {
        global $storeid;

        if(!$_SESSION['modules']['billing']['webdefaults']['defaultshell'])
	    $_SESSION['modules']['billing']['webdefaults']['defaultshell'] = GetWebOption('defaultshell',$storeid);
	if(!$_SESSION['modules']['billing']['webdefaults']['defaultpop'])
            $_SESSION['modules']['billing']['webdefaults']['defaultpop']   = GetWebOption('defaultpop',$storeid);

        $addUserResults = AddNewUser($storeid,$_SESSION['modules']['billing']['userdata'],$_SESSION['modules']['billing']['bundle']['id'],$_SESSION['modules']['billing']['webdefaults']['defaultshell'],$_SESSION['modules']['billing']['webdefaults']['defaultpop']);

        if($addUserResults['success']) {
            $_SESSION['modules']['billing']['custid'] = $addUserResults['custid'];
            return new ACF_Event('adduser_success');
        } else {
            $paramList = new ACF_ParameterList();
            $paramList->AddParameter(new ACF_DirectParameter('userdata',$_SESSION['modules']['billing']['userdata']));
            $paramList->AddParameter(new ACF_DirectParameter('error',$addUserResults['error']));
            $retEvent = new ACF_Event('adduser_fail');
            $retEvent->SetParameterList($paramList);
            return $retEvent;
        }
    } else {
        return new ACF_Event('adduser_success');
    }
}

function AH_AddRate (ACF_ParameterList $inParameterList) {
    if($_SESSION['modules']['billing']['custid'] && !$_SESSION['piwi']['currentCRID'] && !$_SESSION['modules']['billing']['renewal']) {
        $addRateResults = AddRate($_SESSION['modules']['billing']['custid'],$_SESSION['modules']['billing']['bundle']['rg_id'],$_SESSION['modules']['billing']['bundle']['r_frequency']);
        if($addRateResults['success']) {
	    if(!$_SESSION['piwi']['needsRefresh']) {
		$_SESSION['piwi']['needsRefresh'] = true;
	    }

            $_SESSION['modules']['billing']['crid'] = $addRateResults['crid'];

	    $serviceTree = GetServiceTree($_SESSION['modules']['billing']['bundle']['rg_id'],$_SESSION['modules']['billing']['custid']);
	    if(isset($serviceTree) && is_array($serviceTree)) {
	    foreach($serviceTree as $thisServiceStruct) {
		if(strtolower($_SESSION['modules']['billing']['bundle']['svc_ccs_service']) == strtolower($thisServiceStruct['rs_ccs_service']) && $_SESSION['modules']['billing']['crid'] == $thisServiceStruct['rs_cr_id'] && $thisServiceStruct['rs_parent_id'] == 0) {
		    $_SESSION['modules']['billing']['bundle']['structdata'] = $thisServiceStruct;
		    break;
		}
	    }
	    }

            return new ACF_Event('addrate_success');
        }
    }

    if($_SESSION['piwi']['currentCRID']) {
        $_SESSION['modules']['billing']['crid'] = $_SESSION['piwi']['currentCRID'];

	return new ACF_Event('addrate_success');
    }

    if($_SESSION['modules']['billing']['renewal']) {
        return new ACF_Event('addrate_success');
    }

// if the code's gotten to here, then the success returns never got hit... therefore, return fail

    $paramList = new ACF_ParameterList();
    $paramList->AddParameter(new ACF_DirectParameter('userdata',$_SESSION['modules']['billing']['userdata']));
    $paramList->AddParameter(new ACF_DirectParameter('error',$addRateResults['error']));
    $retEvent = new ACF_Event('addrate_fail');
    $retEvent->SetParameterList($paramList);
    return $retEvent;
}

function AH_Refund (ACF_ParameterList $inParameterList) {
    if($_SESSION['modules']['billing']['renewal'])
        $_SESSION['modules']['billing']['returnEvent'] = 'chargeitem_failed';
    else
        $_SESSION['modules']['billing']['returnEvent'] = 'provisionfailed';

    if($_SESSION['modules']['billing']['transactionData']) {
        Refund($_SESSION['modules']['billing']['transactionData']['transid']);
    }

    return new ACF_Event('refund_success');
}

function AH_RollbackUser (ACF_ParameterList $inParameterList) {
    if($_SESSION['modules']['billing']['custid'] && $_SESSION['modules']['billing']['usertype'] == 'NEW') {
        if(DeleteUser($_SESSION['modules']['billing']['custid'])) {
            unset($_SESSION['modules']['billing']['custid']);
        } else {
            return new ACF_Event('rollbackuser_fail');
        }
    }
    return new ACF_Event('rollbackuser_success');
}

function AH_RollbackRate (ACF_ParameterList $inParameterList) {
    if($_SESSION['modules']['billing']['crid'] && $_SESSION['modules']['billing']['usertype'] == 'EXISTING') {
        if(!$_SESSION['piwi']['currentCRID']) {
            $rollbackResults = ExecuteSQL('delete from custrate where crid = '.SQLTrim($_SESSION['modules']['billing']['crid']));
            if($rollbackResults['success']) {
                unset($_SESSION['modules']['billing']['crid']);
            } else {
                return new ACF_Event('rollbackrate_fail');
            }
        }
    }
    return new ACF_Event('rollbackrate_success');
}

function AH_PostCharges (ACF_ParameterList $inParameterList) {
    global $storeid;

    if ($_SESSION['modules']['billing']['custid'] && $_SESSION['modules']['billing']['crid'] && !$_SESSION['piwi']['currentCRID']) { // if that value is set, then a customer is loaded and rate is added
        if(!$_SESSION['modules']['billing']['webdefaults']['futuredays'])
            $_SESSION['modules']['billing']['webdefaults']['futuredays'] = GetWebOption('futuredays',$storeid);
        $postChargesResults = PostCharges($_SESSION['modules']['billing']['custid'],$storeid,$_SESSION['modules']['billing']['webdefaults']['futuredays']);

        if($postChargesResults['success']) {
            return new ACF_Event('postcharges_success');
        }
    }

    if($_SESSION['piwi']['currentCRID'] || $_SESSION['modules']['billing']['renewal']) {
        return new ACF_Event('postcharges_success');
    }

// if the code's gotten to here, then the success returns never got hit... therefore, return fail

    $paramList = new ACF_ParameterList();
    $paramList->AddParameter(new ACF_DirectParameter('userdata',$_SESSION['modules']['billing']['userdata']));
    $paramList->AddParameter(new ACF_DirectParameter('error',$postChargesResults['error']));
    $retEvent = new ACF_Event('postcharges_fail');
    $retEvent->SetParameterList($paramList);
    return $retEvent;
}

function AH_SendPassword (ACF_ParameterList $inParameterList) {
    $mailResults = EmailPassword(FixSlash($inParameterList->ParameterValue('username')));
    if($mailResults['success']) {
        return new ACF_Event('sendpassword_success');
    } else {
        $paramList = new ACF_ParameterList();
        $paramList->AddParameter(new ACF_DirectParameter('error',$mailResults['error']));
        $retEvent = new ACF_Event('sendpassword_fail');
        $retEvent->SetParameterList($paramList);
        return $retEvent;
    }
}

function AH_PLAT_HopProject (ACF_ParameterList $inParameterList) {
    $URL         = $_SESSION['ccs']['options']['driver-options']['url'];
    $returnEvent = $_SESSION['modules']['billing']['returnEvent'];
    header("location:".$URL."/".$returnEvent);
    unset($_SESSION['modules']['billing']['returnEvent']);
    return new ACF_Event('hop_success');
}

function AH_PlatLogin (ACF_ParameterList $inParameterList) {
/*
    if(!Login($_SESSION['wow']['staffname'],$_SESSION['wow']['staffpass'],$_SESSION['wow']['logintype'])) {
        unset($_SESSION['piwi']);

        $paramList = new ACF_ParameterList();
        $paramList->AddParameter(new ACF_DirectParameter('error','The staff login info in wow_options.xml is incorrect.'));
        $retEvent = new ACF_Event('platlogin_fail');
        $retEvent->SetParameterList($paramList);
        return $retEvent;
    } else {
*/
        $username = FixSlash($inParameterList->ParameterValue('username'));
        $password = FixSlash($inParameterList->ParameterValue('password'));

        if (strlen(trim($username)) || strlen(trim($password))) { // if the login or password is empty skip this, since this case is not allowed in the system
            $custIDarray = Login($username,$password,'customer');
            $custid = $custIDarray['id'];
            if(!$custid) {
                $loginerror = "failed";
            }
        } else {
            $loginerror = "empty";
        }

        if ($loginerror) {
            $paramList = new ACF_ParameterList();
            $paramList->AddParameter(new ACF_DirectParameter('error',$loginerror));
            $retEvent = new ACF_Event('platlogin_fail');
            $retEvent->SetParameterList($paramList);
            return $retEvent;
        } else {
            $_SESSION['wow']['staffname'] = $username;
            $_SESSION['wow']['staffpass'] = $password;
            $_SESSION['wow']['logintype'] = 'customer';
            SetStaffLogin();

            $_SESSION['piwi']['custid'] = $custid;
            $_SESSION['piwi']['storeid'] = $custIDarray['storeid'];
            $_SESSION['piwi']['displaystaffpages'] = false;
            $_SESSION['piwi']['OpenSRSProfile'] = GetProfile($_SESSION['piwi']['custid']);

            $URL = "/projects/piwi/index.php/ccshome";
            header("location:".$URL);
            return new ACF_Event('platlogin_success');
        }
//    }
}

function AH_SelectPaymentPage (ACF_ParameterList $inParameterList) {
	if($_SESSION['piwi']['staffid'])
		return new ACF_Event('payment_staff');
	else
		return new ACF_Event('payment_customer');
}

function AH_VerifyStaff (ACF_ParameterList $inParameterList) {
	if($_SESSION['piwi']['staffid']) {
            unset($_SESSION['modules']['billing']['userdata']['ccdata']);
            $retEvent = new ACF_Event('staffexists');
            return $retEvent;
	} else {
            $paramList = new ACF_ParameterList();
            $paramList->AddParameter(new ACF_DirectParameter('error','There is no staff member currently logged in.  You are not allowed to execute this command.'));
            $retEvent = new ACF_Event('nostaff');
            $retEvent->SetParameterList($paramList);
            return $retEvent;
	}
}

?>
