<?php
require_once("plat_billing/platfunctions.php");

global $storeid;
$storeid = $_SESSION['modules']['billing']['storeid'] ? $_SESSION['modules']['billing']['storeid'] : ($_SESSION['piwi']['storeid'] ? $_SESSION['piwi']['storeid'] : ($_SESSION['piwi']['defaultstore'] ? $_SESSION['piwi']['defaultstore'] : false));

function DC_GetStores (ACF_ParameterList $inParameterList) {
    $storeData = GetStores();

    $paramList = new ACF_ParameterList();
    $paramList->AddParameter(new ACF_DirectParameter('stores',$storeData));

    return $paramList;
}

function DC_GetConfirmationData (ACF_ParameterList $inParameterList) {
    $service_charge = $_SESSION['modules']['billing']['priceData']['price'] != 0 ? ShowMoney($_SESSION['modules']['billing']['priceData']['price']) : false;
    $bundleData  = $_SESSION['modules']['billing']['bundle'];
    $bundleData['priceDisplay'] = ShowMoney($bundleData['rg_fixed_price']);
    $bundleData['setupfeeDisplay'] = ShowMoney($bundleData['rg_one_time_fees']);
    if($_SESSION['ccs']['excludeSteps'] && $_SESSION['ccs']['excludeSteps'][array_search('payment',$_SESSION['ccs']['excludeSteps'])] == 'payment')
        $bundleData['noPayment'] = true;
    $bundleData['GST'] = $_SESSION['GST'];

    $custData = $_SESSION['modules']['billing']['userdata'];
    if(!$_SESSION['modules']['billing']['renewal']) {
        $serviceType = $_SESSION['modules']['requiredService'];
        $sourceArray = $_SESSION['modules'][$serviceType];
        $serviceData = array();
        switch($serviceType) {
            case 'domain':
                if(isset($sourceArray['register']['registerDomain']) && is_array($sourceArray['register']['registerDomain'])) {
                    foreach($sourceArray['register']['registerDomain'] as $domainName=>$domainDetails) {
                        $serviceData['Domain_Name'] = $domainName;
                        if($domainDetails['period'] > 1)
                            $serviceData['Registration_Length'] = $domainDetails['period']." years";
                        else
                            $serviceData['Registration_Length'] = $domainDetails['period']." year";
                        $nameservers = array();
                        if(isset($domainDetails['nameserver_list']) && is_array($domainDetails['nameserver_list'])) {
                            foreach($domainDetails['nameserver_list'] as $thisServer) {
                                array_push($nameservers,$thisServer['name']);
                            }
                        }
                        $serviceData['Nameservers'] = implode(",",$nameservers);
                        $domainContacts = $domainDetails['contact_set'];
                        break;
                    }
                }
                break;
            case 'blogware':
                $serviceData['Blog_Hostname'] = $sourceArray['hostname'];
                $serviceData['Blog_Name'] = $sourceArray['blogname'];
                if($sourceArray['user']['email'])
                    $serviceData['Email_Address'] = $sourceArray['user']['email'];
                $serviceData['Blog_Username'] = $sourceArray['user']['username'];
                if($sourceArray['user']['displayname'])
                    $serviceData['Blog_Display_Name'] = $sourceArray['user']['displayname'];
                break;
            default:
                $serviceData = false;
        }

        $serviceType = strtoupper(substr($serviceType,0,1)).substr($serviceType,1);
    }

    if($_SESSION['modules']['billing']['userdata']['ccdata']['number']) {
        $custData['creditcardmasked'] = str_repeat("*",strlen($_SESSION['modules']['billing']['userdata']['ccdata']['number'])-4).substr($_SESSION['modules']['billing']['userdata']['ccdata']['number'],strlen($_SESSION['modules']['billing']['userdata']['ccdata']['number'])-4);
    }

    $paramList = new ACF_ParameterList();
    $paramList->AddParameter(new ACF_DirectParameter('service_charge',$service_charge));
    $paramList->AddParameter(new ACF_DirectParameter('bundledata',$bundleData));
    $paramList->AddParameter(new ACF_DirectParameter('custdata',$custData));
    $paramList->AddParameter(new ACF_DirectParameter('servicetype',$serviceType));
    $paramList->AddParameter(new ACF_DirectParameter('servicedata',$serviceData));
    if($serviceType == 'Domain')
        $paramList->AddParameter(new ACF_DirectParameter('domaincontacts',$domainContacts));

    return $paramList;
}

function DC_SelectBundle (ACF_ParameterList $inParameterList) {
    global $storeid;
    ResetStaffLogin();

    if($_SESSION['ccs']['options']['driver-options']['billing-module']['billing-options']['display-non-ccs-bundles'] == 'yes') {
        $bundleData = GetAvailableWebRates($storeid);
        $ccsBundleData = GetAvailableWebRates($storeid,true);
	if(isset($bundleData) && is_array($bundleData)) {
            foreach($bundleData as &$thisBundle) {
		if(isset($ccsBundleData) && is_array($ccsBundleData)) {
                    foreach($ccsBundleData as $thisCCSBundle) {
                        if($thisBundle['rg_id'] == $thisCCSBundle['rg_id']) {
                            $thisBundle['ccs'] = true;
                            break;
                        }
                    }
		}
		$thisBundle['id'] = $thisBundle['rg_id'] . 'X' . $thisBundle['r_frequency'];
		$thisBundle['name'] = $thisBundle['rg_name'] . ' - ' . $thisBundle['r_frequency'] . ' month' . ($thisBundle['r_frequency'] > 1 ? 's' : '');
            }
	}
    } else {
        $bundleData = GetAvailableWebRates($storeid,true);
	if(isset($bundleData) && is_array($bundleData)) {
	    foreach($bundleData as &$thisBundle) {
		$thisBundle['id'] = $thisBundle['rg_id'] . 'X' . $thisBundle['r_frequency'];
		$thisBundle['name'] = $thisBundle['rg_name'] . ' - ' . $thisBundle['r_frequency'] . ' month' . ($thisBundle['r_frequency'] > 1 ? 's' : '');
	    }
	}
    }

    $parameterList = new ACF_ParameterList();
    $parameterList->AddParameter(new ACF_DirectParameter('bundles',$bundleData));

    return $parameterList;
}

function DC_SelectUser (ACF_ParameterList $inParameterList) {
    $paramList = new ACF_ParameterList();
    return $paramList;
}

function DC_GetPOPChkVal (ACF_ParameterList $inParameterList) {
    global $storeid;

    $popvalue = strtoupper(GetWebOption('popvalue'),$storeid);

    $paramList = new ACF_ParameterList();
    $paramList->AddParameter(new ACF_DirectParameter('popvalue',$popvalue));

    return $paramList;
}

function DC_GetPaymentTypes (ACF_ParameterList $inParameterList) {
    global $storeid;
    $paymenttypes = array();

    // *********************************
    //--- Check to see if ACH is allowed
    // *********************************
    if(GetWebOption('acceptach',$storeid) == 'Y')
        $paymenttypes['ach'] = 'Direct Debit (ACH)';
    //--- THE FAILURE SHOULD BE LOGGED BUT SHOULD CONTINUE (JCW NEEDS TO ADD LOGGING SCHEME)

    // ***********************************
    //--- Check to see if Check is allowed
    // ***********************************
    if(GetWebOption('acceptck',$storeid) == 'Y')
        $paymenttypes['check'] = 'Check';
    //--- THE FAILURE SHOULD BE LOGGED BUT SHOULD CONTINUE (JCW NEEDS TO ADD LOGGING SCHEME)

    // ********************************
    //--- Check to see if CC is allowed
    // ********************************
    if(GetWebOption('acceptcc',$storeid) == 'Y')
        $paymenttypes['ccard'] = 'Credit Card';
    //--- THE FAILURE SHOULD BE LOGGED BUT SHOULD CONTINUE (JCW NEEDS TO ADD LOGGING SCHEME)

    $paramList = new ACF_ParameterList();
    $paramList->AddParameter(new ACF_DirectParameter('paytypes',$paymenttypes));
    $paramList->AddParameter(new ACF_DirectParameter('default_paymenttype',GetWebOption('default_billingmeth',$storeid)));

    return $paramList;
}

function DC_GetPaymentType (ACF_ParameterList $inParameterList) {
    $paramList = new ACF_ParameterList();
    $paramList->AddParameter(new ACF_DirectParameter('paymenttype',$_SESSION['signup']['paymenttype']));

    return $paramList;
}

function DC_GetCustomerInfo (ACF_ParameterList $inParameterList) {
    $paramList = new ACF_ParameterList();
    $paramList->AddParameter(new ACF_DirectParameter('customer',$_SESSION['signup']['customer']));

    return $paramList;
}

function DC_GetBillingReview (ACF_ParameterList $inParameterList) {
    $lineitems = array();
    $lineitems['details'] = array();

    if($_SESSION['modules']['billing']['renewal']) {
        array_push($lineitems['details'],array('svcname'=>$_SESSION['modules']['billing']['priceData']['period'].'-year Renewal: '.$_SESSION['modules']['billing']['priceData']['servicename'],'svcdesc'=>$_SESSION['modules']['billing']['priceData']['desc'],'svcprice'=>ShowMoney($_SESSION['modules']['billing']['priceData']['price'])));
        $lineitems['charges'] = ShowMoney($_SESSION['modules']['billing']['priceData']['price']);
    } else {
        $bundlePrice = ShowMoney($_SESSION['modules']['billing']['bundle']['rg_fixed_price']);
        if($_SESSION['modules']['billing']['bundle']['rg_frequency'] > 1) {
            $bundlePrice .= "/".$_SESSION['modules']['billing']['bundle']['rg_frequency']." months";
        } else {
            $bundlePrice .= "/month";
        }
        $setupfeePrice = ShowMoney($_SESSION['modules']['billing']['bundle']['rg_one_time_fees']);

        array_push($lineitems['details'],array('svcname'=>$_SESSION['modules']['billing']['bundle']['rg_name'],'svcdesc'=>$_SESSION['modules']['billing']['bundle']['svc_ccs_service'],'svcprice'=>$bundlePrice));
        if($setupfeePrice > 0)
            array_push($lineitems['details'],array('svcname'=>'Setup Fee for '.$_SESSION['modules']['billing']['bundle']['rg_name'],'svcdesc'=>'','svcprice'=>$setupfeePrice));
        switch($_SESSION['modules']['billing']['bundle']['svc_ccs_service']) {
            case 'domain':
                if($_SESSION['modules']['billing']['priceData']['price']) {
                    array_push($lineitems['details'],array('svcname'=>$_SESSION['modules']['billing']['priceData']['servicename'],'svcdesc'=>$_SESSION['modules']['billing']['priceData']['desc'],'svcprice'=>ShowMoney($_SESSION['modules']['billing']['priceData']['price'])));
                    $lineitems['charges'] = ShowMoney($_SESSION['modules']['billing']['priceData']['price']);
                }
                break;
            case 'blogware':
                array_push($lineitems['details'],array('svcname'=>$_SESSION['modules']['blogware']['hostname'],'svcdesc'=>$_SESSION['modules']['blogware']['blogname'],'svcprice'=>''));
                break;
        }
    }

    $paramList = new ACF_ParameterList();
    $paramList->AddParameter(new ACF_DirectParameter('lineitems',$lineitems));

    return $paramList;
}

function DC_GetBillingData (ACF_ParameterList $inParameterList) {
    global $storeid;

    $paramList = new ACF_ParameterList();
    if(!$inParameterList->ParameterValue('displayoverride')) { // if displayoverride, then addccinfotosession errored out, and it will return ccdata
        $ccdata = array();

        if($_SESSION['modules']['billing']['userdata']['ccdata']) {
            $ccdata = $_SESSION['modules']['billing']['userdata']['ccdata'];
        } else {
            if($_SESSION['modules']['billing']['usertype'] == 'NEW') { // if this is true, then ccdata should be set to different userdata
                $ccdata['name']               = $_SESSION['modules']['billing']['userdata']['name'];
                $ccdata['address']['addr1']   = $_SESSION['modules']['billing']['userdata']['addr1'];
                $ccdata['address']['addr2']   = $_SESSION['modules']['billing']['userdata']['addr2'];
                $ccdata['address']['city']    = $_SESSION['modules']['billing']['userdata']['city'];
                $ccdata['address']['state']   = $_SESSION['modules']['billing']['userdata']['state'];
                $ccdata['address']['zip']     = $_SESSION['modules']['billing']['userdata']['zip'];
                $ccdata['address']['country'] = $_SESSION['modules']['billing']['userdata']['country'];
            }
	}
	$ccdata['cvv2Required'] = strtoupper(GetWebOption('show_card_sec_code',$storeid));
        $paramList->AddParameter(new ACF_DirectParameter('ccdata',$ccdata));
    }

    return $paramList;
}

function DC_GetRates (ACF_ParameterList $inParameterList) {
    global $storeid;

    $rates = GetRates($storeid);

    $parameterList = new ACF_ParameterList();
    $parameterList->AddParameter(new ACF_DirectParameter('rates',$rates));

    return $parameterList;
}

function DC_GetBlockRates (ACF_ParameterList $inParameterList) {
    $blockRates = GetBlockRates();

    $parameterList = new ACF_ParameterList();
    $parameterList->AddParameter(new ACF_DirectParameter('blockrates',$blockRates));

    return $parameterList;
}

function DC_GetCCInfo (ACF_ParameterList $inParameterList) {
    $ccinfo = array();

    $ccinfo['ccyear'] = array();
    $ccinfo['ccmonth'] = array();

    $ccinfo['cctypes'] = GetCCTypes();

    for($expyear=date("Y");$expyear<date("Y")+10;$expyear++)
        array_push($ccinfo['ccyear'],$expyear);

    for($expmonth=1;$expmonth<=12;$expmonth++) {
        if($expmonth<10)
            array_push($ccinfo['ccmonth'],'0'.$expmonth);
        else
            array_push($ccinfo['ccmonth'],$expmonth);
    }
    $paramList = new ACF_ParameterList();
    $paramList->AddParameter(new ACF_DirectParameter('ccinfo',$ccinfo));

    return $paramList;
}

function DC_GetPOPLocations (ACF_ParameterList $inParameterList) {
    $paramList = new ACF_ParameterList();
    $paramList->AddParameter(new ACF_DirectParameter('matchvalue',$_SESSION['signup']['matchvalue']));
    if(!$_SESSION['signup']['poplistSet'] || $inParameterList->ParameterValue('error')) { // if the activity handler is bypassed and the select POP page is still loaded, the POPlist should be made here
        $popList = GetPOPLocations();

        $paramList->AddParameter(new ACF_DirectParameter('poplist',$popList));
    }

    return $paramList;
}

function DC_GetExtraFields (ACF_ParameterList $inParameterList) {
    $paramList = new ACF_ParameterList();
    $paramList->AddParameter(new ACF_DirectParameter('extrafields',$_SESSION['signup']['extrafields']));

    return $paramList;
}

function DC_SuggestUsername (ACF_ParameterList $inParameterList) {
    global $storeid;

    if(!$_SESSION['signup']['username'] && $_SESSION['signup']['customer']['name']) { // username hasn't been set and customer's name has, so suggest away...
        $unamefmtResults = ExecuteSQL("select value from options where name = 'Username Format'");
        if($unamefmtResults['success'])
            $unamefmt = $unamefmtResults['sqlreturn'];

        if(!strpos($unamefmt[0]['value'],'9')) { // if the format strictly specifies a number, then don't suggest any usernames
            if(!strpos($unamefmt[0]['value'],'['))
                $maxlength = strlen($unamefmt[0]['value']);
            else
                $maxlength = strlen($unamefmt[0]['value'])-2;

            $name = $_SESSION['signup']['customer']['name'];

            $spaceinname = strpos($name,' ');

            if(!$spaceinname) {
                $firstname = $name;
                $lastname = "";
            } else {
                $firstname = substr($name,0,$spaceinname);
                $lastname = substr($name,$spaceinname+1,strlen($name)-($spaceinname+1));
            }
            if(GetWebOption('suggest1',$storeid) == 'Y') { // first initial plus last name for username
                $suggestion = strtolower(substr($firstname,0,1).$lastname);
                $usernamecheckResults = ExecuteSQL("select id from customer where username = '".SQLTrim($suggestion)."'");
                if($usernamecheckResults['success'])
                    $usernamecheck = $usernamecheckResults['sqlreturn'];

                $emailnamecheckResults = ExecuteSQL("select data_id from email_data where username = '".SQLTrim($suggestion)."'");
                if($emailnamecheckResults['success'])
                    $emailnamecheck = $emailnamecheckResults['sqlreturn'];

                if(isset($usernamecheck[0]['id']) || isset($emailnamecheck[0]['data_id']) || strlen($suggestion) > $maxlength) // this username is taken or it's too long
                    unset($suggestion);
            }
            if(GetWebOption('suggest2',$storeid) == 'Y' && !$suggestion) { // first name plus last initial for username
                $suggestion = strtolower($firstname.substr($lastname,0,1));
                $usernamecheckResults = ExecuteSQL("select id from customer where username = '".SQLTrim($suggestion)."'");
                if($usernamecheckResults['success'])
                    $usernamecheck = $usernamecheckResults['sqlreturn'];

                $emailnamecheckResults = ExecuteSQL("select data_id from email_data where username = '".SQLTrim($suggestion)."'");
                if($emailnamecheckResults['success'])
                    $emailnamecheck = $emailnamecheckResults['sqlreturn'];

                if(isset($usernamecheck[0]['id']) || isset($emailnamecheck[0]['data_id']) || strlen($suggestion) > $maxlength) // this username is taken or it's too long
                    unset($suggestion);
            }
            if(GetWebOption('suggest3',$storeid) == 'Y' && !$suggestion) { // first name plus last initial plus number for username
                for($i = 1;$i < 100;$i++) {
                    $suggestion = strtolower($firstname.substr($lastname,0,1).$i);
                    $usernamecheckResults = ExecuteSQL("select id from customer where username = '".SQLTrim($suggestion)."'");
                    if($usernamecheckResults['success'])
                        $usernamecheck = $usernamecheckResults['sqlreturn'];

                    $emailnamecheckResults = ExecuteSQL("select data_id from email_data where username = '".SQLTrim($suggestion)."'");
                    if($emailnamecheckResults['success'])
                        $emailnamecheck = $emailnamecheckResults['sqlreturn'];

                    if(isset($usernamecheck[0]['id']) || isset($emailnamecheck[0]['data_id']) || strlen($suggestion) > $maxlength) // this username is taken or it's too long
                        unset($suggestion);
                    else
                        $i = 100; // set $i to the break point, so it drops out with the good username
                }
            }
        }
    }
    $paramList = new ACF_ParameterList();
    $paramList->AddParameter(new ACF_DirectParameter('suggestion',$suggestion));

    return $paramList;
}

function DC_GetShellTypes (ACF_ParameterList $inParameterList) {
    global $storeid;

    $shells = array();
    $sqlresultsArray = ExecuteSQL('select value, display from shelltypes');
    if($sqlresultsArray['success']) {
	    $sqlresults = $sqlresultsArray['sqlreturn'];
	    if(isset($sqlresults) && is_array($sqlresults)) {
        foreach($sqlresults as $sqlrow) {
		$shells[$sqlrow['value']] = $sqlrow['display'];
	}
	    }
    }

    if(!$_SESSION['modules']['billing']['webdefaults']['defaultshell'])
        $_SESSION['modules']['billing']['webdefaults']['defaultshell'] = GetWebOption('defaultshell',$storeid);

    $paramList = new ACF_ParameterList();
    $paramList->AddParameter(new ACF_DirectParameter('shells',$shells));
    $paramList->AddParameter(new ACF_DirectParameter('default_shell',$_SESSION['modules']['billing']['webdefaults']['defaultshell']));
    return $paramList;
}

function DC_GetSalespeople (ACF_ParameterList $inParameterList) {
    global $storeid;

    $salespeople = array();
    $sqlresultsArray = ExecuteSQL('select num, name from staff where position != 1');
    if($sqlresultsArray['success']) {
        $sqlresults = $sqlresultsArray['sqlreturn'];
	    if(isset($sqlresults) && is_array($sqlresults)) {
        foreach($sqlresults as $sqlrow) {
		$salespeople[$sqlrow['num']] = $sqlrow['name'];
	}
	    }
    }

    $paramList = new ACF_ParameterList();
    $paramList->AddParameter(new ACF_DirectParameter('salespeople',$salespeople));
    $paramList->AddParameter(new ACF_DirectParameter('default_salesperson',GetWebOption('defaultsales',$storeid)));
    return $paramList;
}

function DC_GetReferralInfo (ACF_ParameterList $inParameterList) {
    global $storeid;

    $paramList = new ACF_ParameterList();
    $paramList->AddParameter(new ACF_DirectParameter('referraltype',GetWebOption('referralvalue',$storeid)));
    return $paramList;
}

function DC_GetPOPData (ACF_ParameterList $inParameterList) {
    global $storeid;

    $popdata = array();
    $popdata['cities'] = array();
    $popdata['states'] = array();
    $popdata['areacodes'] = array();

    $popdata['inputtype'] = strtoupper(GetWebOption('popinputtype',$storeid));
    //--- THE FAILURE SHOULD BE LOGGED BUT SHOULD CONTINUE (JCW NEEDS TO ADD LOGGING SCHEME)

    // *************************
    //--- Getting cities from DB
    // *************************
    $sqlresultsArray = ExecuteSQL('select distinct pop_city from pop');
    if($sqlresultsArray['success']) {
        $sqlresults = $sqlresultsArray['sqlreturn'];
	    if(isset($sqlresults) && is_array($sqlresults)) {
        foreach($sqlresults as $sqlrow) {
		array_push($popdata['cities'],$sqlrow['pop_city']);
	}
	    }
    }

    // *************************
    //--- Getting states from DB
    // *************************
    $sqlresultsArray = ExecuteSQL('select distinct pop_state from pop');
    if($sqlresultsArray['success']) {
        $sqlresults = $sqlresultsArray['sqlreturn'];
	    if(isset($sqlresults) && is_array($sqlresults)) {
        foreach($sqlresults as $sqlrow) {
		array_push($popdata['states'],$sqlrow['pop_state']);
	}
	    }
    }

    // *****************************************************
    //--- Getting area codes from DB (using same WOW method)
    // *****************************************************
    $sqlresultsArray = ExecuteSQL('select distinct pop_areacode = substring(pop_number,1,3) from pop');
    if($sqlresultsArray['success']) {
        $sqlresults = $sqlresultsArray['sqlreturn'];
	    if(isset($sqlresults) && is_array($sqlresults)) {
        foreach($sqlresults as $sqlrow) {
		array_push($popdata['areacodes'],$sqlrow['pop_areacode']);
	}
	    }
    }

    $paramList = new ACF_ParameterList();
    $paramList->AddParameter(new ACF_DirectParameter('popdata',$popdata));

    return $paramList;
}

function DC_GetStatesList (ACF_ParameterList $inParameterList) {
    if (file_exists('../../etc/stateslist.xml')) {
        $statexml = simplexml_load_file('../../etc/stateslist.xml');
        $states = array();
        if($statexml)
        foreach($statexml as $state)
            $states[(string) $state->code] = (string) $state->name;
    }
    if (!$states) {
        $states = array(
            "AL" => "Alabama",
            "AK" => "Alaska",
            "AS" => "American Samoa",
            "AB" => "Alberta",
            "AZ" => "Arizona",
            "AR" => "Arkansas",
            "BC" => "British Columbia",
            "CA" => "California",
            "CO" => "Colorado",
            "CT" => "Connecticut",
            "DE" => "Deleware",
            "DC" => "District of Columbia",
            "FM" => "Federated States of Micronesia",
            "FL" => "Florida",
            "GA" => "Georgia",
            "GU" => "Guam",
            "HI" => "Hawaii",
            "ID" => "Idaho",
            "IL" => "Illinois",
            "IN" => "Indiana",
            "IA" => "Iowa",
            "KS" => "Kansas",
            "KY" => "Kentucky",
            "LA" => "Louisiana",
            "ME" => "Maine",
            "MB" => "Manitoba",
            "MH" => "Marshall Islands",
            "MD" => "Maryland",
            "MA" => "Massachusetts",
            "MI" => "Michigan",
            "MN" => "Minnesota",
            "MS" => "Mississippi",
            "MO" => "Missouri",
            "MT" => "Montana",
            "NE" => "Nebraska",
            "NV" => "Nevada",
            "NB" => "New Brunswick",
            "NH" => "New Hampshire",
            "NJ" => "New Jersey",
            "NM" => "New Mexico",
            "NY" => "New York",
            "NL" => "Newfoundland and Labrador",
            "NC" => "North Carolina",
            "ND" => "North Dakota",
            "MP" => "Northern Mariana Islands",
            "NT" => "Northwest Territories",
            "NS" => "Nova Scotia",
            "NU" => "Nunavut",
            "OH" => "Ohio",
            "OK" => "Oklahoma",
            "ON" => "Ontario",
            "OR" => "Oregon",
            "PW" => "Palau",
            "PA" => "Pennsylvania",
            "PE" => "Prince Edward Island",
            "PR" => "Puerto Rico",
            "QC" => "Quebec",
            "RI" => "Rhode Island",
            "SK" => "Saskatchewan",
            "SC" => "South Carolina",
            "SD" => "South Dakota",
            "TN" => "Tennessee",
            "TX" => "Texas",
            "UT" => "Utah",
            "VT" => "Vermont",
            "VI" => "Virgin Islands",
            "VA" => "Virginia",
            "WA" => "Washington",
            "WV" => "West Virginia",
            "WI" => "Wisconsin",
            "WY" => "Wyoming",
            "YT" => "Yukon"
        );
    }
    $paramList = new ACF_ParameterList();
    $paramList->AddParameter(new ACF_DirectParameter('states',$states));

    return $paramList;
}

function DC_GetCountriesList() {
    global $storeid;

    if (file_exists('../../etc/countrieslist.xml')) {
        $countryxml = simplexml_load_file('../../etc/countrieslist.xml');
        $countries = array();
        if($countryxml)
        foreach($countryxml as $country)
            $countries[(string) $country->code] = (string) $country->name;
    }

    if (!$countries) {
        $countries = array(
            "US" => "United States of America",
            "CA" => "Canada",
            "AF" => "Afghanistan",
            "AL" => "Albania",
            "DZ" => "Algeria",
            "AS" => "American Samoa",
            "AD" => "Andorra",
            "AI" => "Anguilla",
            "AQ" => "Antarctica",
            "AG" => "Antigua And Barbuda",
            "AR" => "Argentina",
            "AM" => "Armenia",
            "AW" => "Aruba",
            "AU" => "Australia",
            "AT" => "Austria",
            "AZ" => "Azerbaijan",
            "BS" => "Bahamas",
            "BH" => "Bahrain",
            "BD" => "Bangladesh",
            "BB" => "Barbados",
            "BY" => "Belarus",
            "BY" => "Belarus",
            "BE" => "Belgium",
            "BZ" => "Belize",
            "BJ" => "Benin",
            "BM" => "Bermuda",
            "BT" => "Bhutan",
            "BO" => "Bolivia",
            "BA" => "Bosnia And Herzegowina",
            "BW" => "Botswana",
            "BV" => "Bouvet Island",
            "BR" => "Brazil",
            "IO" => "British Indian Ocean Territory",
            "BN" => "Brunei Darussalam",
            "BG" => "Bulgaria",
            "BF" => "Burkina Faso",
            "BI" => "Burundi",
            "KH" => "Cambodia",
            "CM" => "Cameroon",
            "CV" => "Cape Verde",
            "KY" => "Cayman Islands",
            "CF" => "Central African Republic",
            "TD" => "Chad",
            "CL" => "Chile",
            "CN" => "China",
            "CX" => "Christmas Island",
            "CC" => "Cocos (Keeling) Islands",
            "CO" => "Colombia",
            "KM" => "Comoros",
            "CG" => "Congo",
            "CK" => "Cook Islands",
            "CR" => "Costa Rica",
            "CI" => "Cote D'ivoire",
            "HR" => "Croatia",
            "CY" => "Cyprus",
            "CZ" => "Czech Republic",
            "DK" => "Denmark",
            "DJ" => "Djibouti",
            "DM" => "Dominica",
            "DO" => "Dominican Republic",
            "TP" => "East Timor",
            "EC" => "Ecuador",
            "EG" => "Egypt",
            "SV" => "El Salvador",
            "GQ" => "Equatorial Guinea",
            "ER" => "Eritrea",
            "EE" => "Estonia",
            "ET" => "Ethiopia",
            "FK" => "Falkland Islands",
            "FO" => "Faroe Islands",
            "FJ" => "Fiji",
            "FI" => "Finland",
            "FR" => "France",
            "GF" => "French Guiana",
            "PF" => "French Polynesia",
            "TF" => "French Southern Territories",
            "GA" => "Gabon",
            "GM" => "Gambia",
            "GE" => "Georgia",
            "DE" => "Germany",
            "GH" => "Ghana",
            "GI" => "Gibraltar",
            "GR" => "Greece",
            "GL" => "Greenland",
            "GD" => "Grenada",
            "GP" => "Guadeloupe",
            "GU" => "Guam",
            "GT" => "Guatemala",
            "GN" => "Guinea",
            "GW" => "Guinea-Bissau",
            "GY" => "Guyana",
            "HT" => "Haiti",
            "HM" => "Heard And Mcdonald Islands",
            "HN" => "Honduras",
            "HK" => "Hong Kong",
            "HU" => "Hungary",
            "IS" => "Iceland",
            "IN" => "India",
            "ID" => "Indonesia",
            "IE" => "Ireland",
            "IL" => "Israel",
            "IT" => "Italy",
            "JM" => "Jamaica",
            "JP" => "Japan",
            "JO" => "Jordan",
            "KZ" => "Kazakstan",
            "KE" => "Kenya",
            "KI" => "Kiribati",
            "KR" => "Korea, Republic Of (South)",
            "KW" => "Kuwait",
            "KG" => "Kyrgyzstan",
            "LA" => "Lao People's Democratic Republic",
            "LV" => "Latvia",
            "LB" => "Lebanon",
            "LS" => "Lesotho",
            "LR" => "Liberia",
            "LI" => "Liechtenstein",
            "LT" => "Lithuania",
            "LU" => "Luxembourg",
            "MO" => "Macau",
            "MK" => "Macedonia",
            "MG" => "Madagascar",
            "MW" => "Malawi",
            "MY" => "Malaysia",
            "MV" => "Maldives",
            "ML" => "Mali",
            "MT" => "Malta",
            "MH" => "Marshall Islands",
            "MQ" => "Martinique",
            "MR" => "Mauritania",
            "MU" => "Mauritius",
            "YT" => "Mayotte",
            "MX" => "Mexico",
            "FM" => "Micronesia",
            "MD" => "Moldova, Republic Of",
            "MC" => "Monaco",
            "MN" => "Mongolia",
            "MS" => "Montserrat",
            "MA" => "Morocco",
            "MZ" => "Mozambique",
            "NA" => "Namibia",
            "NR" => "Nauru",
            "NP" => "Nepal",
            "NL" => "Netherlands",
            "AN" => "Netherlands Antilles",
            "NC" => "New Caledonia",
            "NZ" => "New Zealand",
            "NI" => "Nicaragua",
            "NE" => "Niger",
            "NG" => "Nigeria",
            "NU" => "Niue",
            "NF" => "Norfolk Island",
            "MP" => "Northern Mariana Islands",
            "NO" => "Norway",
            "OM" => "Oman",
            "PK" => "Pakistan",
            "PW" => "Palau",
            "PA" => "Panama",
            "PG" => "Papua New Guinea",
            "PY" => "Paraguay",
            "PE" => "Peru",
            "PH" => "Philippines",
            "PN" => "Pitcairn",
            "PL" => "Poland",
            "PT" => "Portugal",
            "PR" => "Puerto Rico",
            "QA" => "Qatar",
            "RE" => "Reunion",
            "RO" => "Romania",
            "RU" => "Russian Federation",
            "RW" => "Rwanda",
            "SH" => "Saint Helena",
            "KN" => "Saint Kitts And Nevis",
            "LC" => "Saint Lucia",
            "PM" => "Saint Pierre And Miquelon",
            "VC" => "Saint Vincent And The Grenadines",
            "WS" => "Samoa",
            "SM" => "San Marino",
            "ST" => "Sao Tome And Principe",
            "SA" => "Saudi Arabia",
            "SN" => "Senegal",
            "SC" => "Seychelles",
            "SL" => "Sierra Leone",
            "SG" => "Singapore",
            "SK" => "Slovakia",
            "SI" => "Slovenia",
            "SB" => "Solomon Islands",
            "SO" => "Somalia",
            "ZA" => "South Africa",
            "ES" => "Spain",
            "LK" => "Sri Lanka",
            "SR" => "Suriname",
            "SJ" => "Svalbard And Jan Mayen",
            "SZ" => "Swaziland",
            "SE" => "Sweden",
            "CH" => "Switzerland",
            "TW" => "Taiwan",
            "TJ" => "Tajikistan",
            "TZ" => "Tanzania",
            "TH" => "Thailand",
            "TG" => "Togo",
            "TK" => "Tokelau",
            "TO" => "Tonga",
            "TT" => "Trinidad And Tobago",
            "TN" => "Tunisia",
            "TR" => "Turkey",
            "TM" => "Turkmenistan",
            "TC" => "Turks And Caicos Islands",
            "TV" => "Tuvalu",
            "UG" => "Uganda",
            "UA" => "Ukraine",
            "AE" => "United Arab Emirates",
            "GB" => "United Kingdom",
            "UM" => "United States Minor Outlying Islands",
            "UY" => "Uruguay",
            "UZ" => "Uzbekistan",
            "VU" => "Vanuatu",
            "VA" => "Vatican City State (Holy See)",
            "VE" => "Venezuela",
            "VN" => "Viet Nam",
            "VG" => "Virgin Islands, (British)",
            "VI" => "Virgin Islands, (U.S.)",
            "WF" => "Wallis And Futuna",
            "EH" => "Western Sahara",
            "YE" => "Yemen",
            "YU" => "Yugoslavia",
            "ZM" => "Zambia",
            "ZW" => "Zimbabwe"
        );
    }

    if(!$_SESSION['modules']['billing']['webdefaults']['display_country'])
        $_SESSION['modules']['billing']['webdefaults']['display_country'] = GetWebOption('display_country',$storeid);
    if(!$_SESSION['modules']['billing']['webdefaults']['default_country'])
        $_SESSION['modules']['billing']['webdefaults']['default_country'] = GetWebOption('default_country',$storeid);

    $parameterList = new ACF_ParameterList();
    $parameterList->AddParameter(new ACF_DirectParameter('countries',$countries));
    $parameterList->AddParameter(new ACF_DirectParameter('display_country',strtoupper($_SESSION['modules']['billing']['webdefaults']['display_country'])));
    $parameterList->AddParameter(new ACF_DirectParameter('default_country',strtoupper($_SESSION['modules']['billing']['webdefaults']['default_country'])));

    return $parameterList;
}

function DC_GetInfoText(ACF_ParameterList $inParameterList) {
	$type = $inParameterList->ParameterValue('type');

	if(file_exists("../../etc/infotext/".$type.".info"))
		$infotext = file_get_contents("../../etc/infotext/".$type.".info");

	if(!$infotext)
		$infotext = "Information Not Found";
	
	$paramList = new ACF_ParameterList();
	$paramList->AddParameter(new ACF_DirectParameter('infotext',$infotext));
	return $paramList;
}

?>
