<?php
require_once("../../libs/platypus/wow.inc.php");
require_once('../../libs/ccs/utilities.inc.php');

$stafflogin = $_SESSION['wow']['staffname'];
$staffpass  = $_SESSION['wow']['staffpass'];

global $wowlogintype;
$wowlogintype = $_SESSION['wow']['logintype'] ? $_SESSION['wow']['logintype'] : 'staff';

global $wow;
$wow = new WOW_Request();
$wow->setUsername($stafflogin);
$wow->setPassword($staffpass);

function ResetStaffLogin() {
    global $wow;
    global $wowlogintype;

    $stafflogin   = $_SESSION['wow']['staffname'] = $_SESSION['wow']['file_staffname'];
    $staffpass    = $_SESSION['wow']['staffpass'] = $_SESSION['wow']['file_staffpass'];
    $wowlogintype = $_SESSION['wow']['logintype'] = 'staff';

    $wow->setUsername($stafflogin);
    $wow->setPassword($staffpass);
}

function SetStaffLogin() {
    global $wow;
    global $wowlogintype;

    $stafflogin   = $_SESSION['wow']['staffname'];
    $staffpass    = $_SESSION['wow']['staffpass'];
    $wowlogintype = $_SESSION['wow']['logintype'] ? $_SESSION['wow']['logintype'] : 'staff';

    $wow->setUsername($stafflogin);
    $wow->setPassword($staffpass);

    $loginData = Login($stafflogin,$staffpass,'staff');
    $_SESSION['modules']['billing']['staffid'] = $loginData['id'];
}

function GetDateFormat() {
    global $wow;
    global $wowlogintype;

    $wow->setMethod('GetDateFormat');
    $wow->addAttribute('logintype',$wowlogintype);

    $wow->addParameter('datatype','XML');

    if($wow->execute()) {
	return $wow->getAttribute(0,'dateformat');
    } else {
	return false;
    }
}

function GetWebOption ($optionname,$storeid) {
    global $wow;
    global $wowlogintype;

    $wow->setMethod('GetWebOption');
    $wow->addAttribute('logintype',$wowlogintype);

    //--- Set Parameters
    $wow->addParameter('option_name',$optionname);
    $wow->addParameter('storeappended',false,'boolean');
    $wow->addParameter('datatype','XML');

    $wow->addProperty('storeid',$storeid,'integer');

    if($wow->execute())
        return $wow->getAttribute(0,$optionname);
    else
        return false;
}

function ExecuteSQL ($query) {
    global $wow;
    global $wowlogintype;

    $wow->setMethod('SQL');
    $wow->addAttribute('logintype',$wowlogintype);

    //--- Set Parameters
    $wow->addParameter('query',$query);
    $wow->addParameter('noconn',false,'boolean');
    $wow->addParameter('datatype','XML');

    if($wow->execute()) {
        $results['success'] = true;
        $results['sqlreturn'] = $wow->getAttributesArray();
    } else {
        $results['success'] = false;
        $results['errormsg'] = $wow->lastError;
    }

    return $results;

/*
    if($wow->execute())
        return $wow->getAttributesArray();
    else
        return false;
*/
}

function SQLTrim ($instring) {
    if(!$instring)
        return "";
    if(!is_string($instring))
	return $instring;

    $instring = str_replace("&apos;","'",$instring);

    $outstring = "";

    while ($instring != $outstring) {
	$outstring = $instring;
	$instring = trim(str_replace("''","'",$instring));
    }

    return trim(str_replace("'","''",$instring));
}

function LogError($funcname,$errmsg) {
    if(!$_SESSION['signup']['lastError'])
        $_SESSION['signup']['lastError'] = $funcname.":".$errmsg."<BR>";
    else
        $_SESSION['signup']['lastError'] .= $funcname.":".$errmsg."<BR>";
}

function GetStores() {
    global $wow;
    global $wowlogintype;

    $wow->setMethod('GetStores');
    $wow->addAttribute('logintype',$wowlogintype);

    $wow->addParameter('datatype','xml');

    if($wow->execute()) {
        return $wow->getAttributesArray();
    } else {
        return false;
    }
}

function GetAvailableWebRates($storeid,$ccs = false) {
    global $wow;
    global $wowlogintype;

    $wow->setMethod('GetAvailableWebRates');
    $wow->addAttribute('logintype',$wowlogintype);

    $wow->addParameter('datatype','XML');
    $wow->addParameter('ccs',$ccs,'boolean');

    $wow->addProperty('storeid',$storeid ? $storeid : 0,'integer');

    if($wow->execute()) {
        return $wow->getAttributesArray();
    } else {
        return false;
    }
}

function GetServiceFields($serviceID,$rgid = false,$crid = false,$branch = false,$parent_service = false,$parent_instance = false) {
    global $wow;
    global $wowlogintype;

    $wow->setMethod('GetServiceInfo');
    $wow->addAttribute('logintype',$wowlogintype);

    $wow->addParameter('svcid',$serviceID);
    $wow->addParameter('datatype','XML');
    $wow->addParameter('rgid',$rgid,$rgid ? 'string' : 'boolean');
    $wow->addParameter('crid',$crid,$crid ? 'string' : 'boolean');
    $wow->addParameter('branch',$branch);
    $wow->addParameter('parent_instance',$parent_instance);
    $wow->addParameter('parent_service',$parent_service);

    $wow->addProperty('custid',0,'integer');

    if($wow->execute()) {
        return $wow->getAttributesArray();
    } else {
        return false;
    }
}

function GetServiceTree($rgid,$custid = false) {
    global $wow;
    global $wowlogintype;

    $wow->setMethod('ListServiceTree');
    $wow->addAttribute('logintype',$wowlogintype);

    $wow->addParameter('datatype','XML');
    $wow->addParameter('rgid',$rgid);

    if($custid)
        $wow->addProperty('custid',$custid);

    if($wow->execute()) {
	$serviceTree = $wow->getAttributesArray();
    } else {
	$serviceTree = false;
    }

    return $serviceTree;
}

function GetBlockRates() {
    global $wow;
    global $wowlogintype;

    $wow->setMethod('GetAvailableBlockRates');
    $wow->addAttribute('logintype',$wowlogintype);

    $wow->addParameter('datatype','XML');

    if($wow->execute()) {
        $blockRateList = $wow->getAttributesArray();
	$blockRates = array();
	if(isset($blockRateList) && is_array($blockRateList)) {
        foreach($blockRateList as $thisRate) {
		$blockRates[$thisRate['id']] = $thisRate['value'];
	}
	}
        return $blockRates;
    } else {
        return false;
    }
}

function GetPOPLocations() {
    global $wow;
    global $wowlogintype;

    $wow->setMethod('GetAvailablePOPs');
    $wow->addAttribute('logintype',$wowlogintype);

    $wow->addParameter('datatype','XML');

    if($wow->execute()) {
        return $wow->getAttributesArray();
    } else {
        return false;
    }
}

function GetCCTypes() {
    global $wow;
    global $wowlogintype;

    $wow->setMethod('getpaymenttypes');
    $wow->addAttribute('logintype',$wowlogintype);

    $wow->addParameter('datatype','XML');
    $wow->addParameter('active','Y');

    if($wow->execute()) {
        $paymentTypes = $wow->getAttributesArray();
        $cctypes = array();
        if(isset($paymentTypes) && is_array($paymentTypes)) {
            foreach($paymentTypes as $thisType) {
                if($thisType['p_type'] == 'CREDITCARD') {
                    array_push($cctypes,$thisType['p_name']);
                }
            }
        }

        return $cctypes;
    } else {
        return false;
    }
}

function Login($username,$password,$type) {
    global $wow;
    global $wowlogintype;

    $wow->setMethod('Login');
    $wow->addAttribute('logintype',$wowlogintype);

    $wow->addParameter('logintype',$type);
    $wow->addParameter('username',$username);
    $wow->addParameter('password',$password);
    $wow->addParameter('datatype','XML');
    $wow->addParameter('allowedactive',"'Y','H','S'");

    if($wow->execute()) {
        return $wow->getAttribute(0);
    } else {
        return false;
    }
}

function SetProfile($custid,$username,$password) {
    global $wow;
    global $wowlogintype;

    $wow->setMethod('OpenSRSSetProfile');
    $wow->addAttribute('logintype',$wowlogintype);

    $wow->addParameter('nCustID',$custid,'integer');
    $wow->addParameter('cUsername',$username);
    $wow->addParameter('cPassword',$password);
    $wow->addParameter('cDataType','XML');

    if($wow->execute()) {
        return true;
    } else {
        return false;
    }
}

function GetProfile($custid) {
    global $wow;
    global $wowlogintype;

    $wow->setMethod('OpenSRSGetProfile');
    $wow->addAttribute('logintype',$wowlogintype);

    $wow->addParameter('nCustID',$custid,'string');
    $wow->addParameter('cDataType','XML');

    if($wow->execute()) {
        return $wow->getAttribute(0,'profile');
    } else {
        return false;
    }
}

function GenerateProfile() {
    global $wow;
    global $wowlogintype;

    $wow->setMethod('OpenSRSGenProfile');
    $wow->addAttribute('logintype',$wowlogintype);

    $wow->addParameter('cDataType','XML');

    if($wow->execute()) {
        return $wow->getAttribute(0,'profile');
    } else {
        return false;
    }
}

function GetCustomerData($custid) {
    global $wow;
    global $wowlogintype;

    $wow->setMethod('GetCustomer');
    $wow->addAttribute('logintype',$wowlogintype);

    $wow->addParameter('datatype','XML');

    $wow->addProperty('custid',$custid);

    if($wow->execute()) {
        $custData = $wow->getAttribute(0);
        if($custData['ccnumber'] == '' || $custData['ccnumber'] == 'NULL' || !$custData['ccnumber']) {
            $custData['creditcardmasked'] = false;
        }
        return $custData;
    } else {
        return false;
    }
}

function GetAddressData($custid) {
    global $wow;
    global $wowlogintype;

    $wow->setMethod('GetAddress');
    $wow->addAttribute('logintype',$wowlogintype);

    $wow->addParameter('datatype', 'XML');

    $wow->addProperty('custid', $custid);

    if($wow->execute()) {
        return $wow->getAttributesArray();
    } else {
        return false;
    }
}

function GetCustomerRates($custid) {
    global $wow;
    global $wowlogintype;

    $wow->setMethod('GetRates');
    $wow->addAttribute('logintype',$wowlogintype);

    $wow->addParameter('datatype', 'XML');

    $wow->addProperty('custid', $custid);

    if($wow->execute()) {
        return $wow->getAttributesArray();
    } else {
        return false;
    }
}

function AddNewUser($storeid,$userdata,$rgid,$default_shell,$default_pop) {
    global $wow;
    global $wowlogintype;

    $wow->setMethod('addtoplat');
    $wow->addAttribute('logintype',$wowlogintype);

    $wow->addProperty('BillingMeth','ccard');
    $wow->addProperty('Phone',$userdata['phone']);
    $wow->addProperty('Username',$userdata['username']);
    $wow->addProperty('Password',$userdata['password']);
    $wow->addProperty('Name2',$userdata['company'] ? $userdata['company'] : $userdata['name']);
    $wow->addProperty('Address',$userdata['addr1']);
    $wow->addProperty('Address2',$userdata['addr2']);
    $wow->addProperty('State',$userdata['state']);
    $wow->addProperty('City',$userdata['city']);
    $wow->addProperty('Zip',$userdata['zip']);
    $wow->addProperty('Fax',$userdata['phone2']);
    $wow->addProperty('Guarantor','false','boolean');
    $wow->addProperty('Email',$userdata['email']);
    $wow->addProperty('BonusType','F');
    $wow->addProperty('StaffID',$_SESSION['modules']['billing']['staffid'] ? $_SESSION['modules']['billing']['staffid'] : 1);
    $wow->addProperty('SelectPop',$userdata['poplocation'] ? $userdata['poplocation'] : $default_pop,'string');
    $wow->addProperty('SelectRate','-1');
    $wow->addProperty('SelectShell',$userdata['shellid'] ? $userdata['shellid'] : $default_shell,'string');
    $wow->addProperty('HTMLEmail','Y');
    $wow->addProperty('Country',$userdata['country']);
    $wow->addProperty('storeid',$storeid,'int');

    $wow->addProperty('CCExpireM',$userdata['ccdata']['month']);
    $wow->addProperty('CCExpireY',$userdata['ccdata']['year']);
    $wow->addProperty('CCName',$userdata['ccdata']['name']);
    $wow->addProperty('CCAddr',$userdata['ccdata']['address']['addr1']);
    $wow->addProperty('CCAddr2',$userdata['ccdata']['address']['addr2']);
    $wow->addProperty('CCCity',$userdata['ccdata']['address']['city']);
    $wow->addProperty('CCState',$userdata['ccdata']['address']['state']);
    $wow->addProperty('CCZip',$userdata['ccdata']['address']['zip']);
    $wow->addProperty('CCCountry',$userdata['ccdata']['address']['country']);
    $wow->addProperty('CCNumber',$userdata['ccdata']['number']);
    $wow->addProperty('CCType',$userdata['ccdata']['type']);

    $wow->addProperty('BankNumber','');
    $wow->addProperty('RouteNumber','');
    $wow->addProperty('Bank_Acct_Type','');

    $wow->addParameter('activeconn','false','boolean');
    $wow->addParameter('datatype','XML');

    if($wow->execute()) {
        $result['success'] = true;
        $result['custid'] = $wow->getAttribute(0,'custid');

        ExecuteSQL("update address set deflt = case type when 5 then 'Y' else 'N' end where idtype = 'Customer' and idnum = ".SQLTrim($result['custid']));
        if($userdata['company'])
            ExecuteSQL("update customer set attn = '".SQLTrim($userdata['name'])."' where id = ".SQLTrim($result['custid']));

    } else {
        $result['success'] = false;
        $result['error'] = $wow->lastError;
    }

    return $result;
}

function WelcomeEmail($custid) {
    global $wow;
    global $wowlogintype;

    $wow->setMethod('Welcome_Email');
    $wow->addAttribute('logintype',$wowlogintype);

    $wow->addParameter('datatype','XML');

    $wow->addProperty('custid',$custid);

    if($wow->execute())
        return true;
    else
        return false;
}

function VerifyNewUser($storeid,$userdata,$rgid,$default_shell,$default_pop) {
    global $wow;
    global $wowlogintype;

    $results = array();

    $wow->setMethod('VerifyInfo');
    $wow->addAttribute('logintype',$wowlogintype);

    $wow->addProperty('BillingMeth','CHECK');
    $wow->addProperty('Phone',$userdata['phone']);
    $wow->addProperty('Username',$userdata['username']);
    $wow->addProperty('Password',$userdata['password']);
    $wow->addProperty('Password2',$userdata['password2']);
    $wow->addProperty('Name2',$userdata['company'] ? $userdata['company'] : $userdata['name']);
    $wow->addProperty('Address',$userdata['addr1']);
    $wow->addProperty('Address2',$userdata['addr2']);
    if (!$userdata['state'] && $userdata['country'] != 'CA' && $userdata['country'] != 'US')
        $wow->addProperty('State','NA');
    else
        $wow->addProperty('State',$userdata['state']);
    $wow->addProperty('City',$userdata['city']);
    $wow->addProperty('Zip',$userdata['zip']);
    $wow->addProperty('Fax',$userdata['phone2']);
    $wow->addProperty('Guarantor','false','boolean');
    $wow->addProperty('Email',$userdata['email']);
    $wow->addProperty('BonusType','F');
    $wow->addProperty('StaffID',$_SESSION['modules']['billing']['staffid'] ? $_SESSION['modules']['billing']['staffid'] : 1);
    $wow->addProperty('SelectPop',$userdata['poplocation'] ? $userdata['poplocation'] : $default_pop,'string');
    $wow->addProperty('SelectRate',$rgid,'string');
    $wow->addProperty('SelectShell',$userdata['shellid'] ? $userdata['shellid'] : $default_shell,'string');
    $wow->addProperty('HTMLEmail','Y');
    $wow->addProperty('Country',$userdata['country']);
    $wow->addProperty('storeid',$storeid,'int');

    $wow->addProperty('CCExpireM',$userdata['ccdata']['month']);
    $wow->addProperty('CCExpireY',$userdata['ccdata']['year']);
    $wow->addProperty('CCName',$userdata['ccdata']['name']);
    $wow->addProperty('CCAddr',$userdata['ccdata']['address']['addr1']);
    $wow->addProperty('CCAddr2',$userdata['ccdata']['address']['addr2']);
    $wow->addProperty('CCCity',$userdata['ccdata']['address']['city']);
    $wow->addProperty('CCState',$userdata['ccdata']['address']['state']);
    $wow->addProperty('CCZip',$userdata['ccdata']['address']['zip']);
    $wow->addProperty('CCCountry',$userdata['ccdata']['address']['country']);
    $wow->addProperty('CCNumber',$userdata['ccdata']['number']);
    $wow->addProperty('CCType',$userdata['ccdata']['type']);

    $wow->addProperty('BankNumber','');
    $wow->addProperty('RouteNumber','');
    $wow->addProperty('Bank_Acct_Type','');

    $wow->addParameter('display_rates','N');
    $wow->addParameter('display_block_rates','N');
    $wow->addParameter('sales_required','N');
    $wow->addParameter('show_sales','N');
    $wow->addParameter('selectsales',1);
    $wow->addParameter('selectref',1);
    $wow->addParameter('selectblock','');
    $wow->addParameter('datatype','XML');

    if($wow->execute()) {
        $results['success'] = true;

        if(!$_SESSION['modules']['shared']['contact_info']) {
            if(strpos($userdata['name'],' ')) {
                $_SESSION['modules']['shared']['contact_info']['first_name'] = substr($userdata['name'],0,strpos($userdata['name'],' '));
                $_SESSION['modules']['shared']['contact_info']['last_name'] = substr($userdata['name'],strpos($userdata['name'],' ')+1);
            } else {
                $_SESSION['modules']['shared']['contact_info']['first_name'] = $userdata['name'];
                $_SESSION['modules']['shared']['contact_info']['last_name'] = false;
            }
            if ($userdata['company'])
                $_SESSION['modules']['shared']['contact_info']['company'] = $userdata['company'];
            else
                $_SESSION['modules']['shared']['contact_info']['company'] = $userdata['name'];
            $_SESSION['modules']['shared']['contact_info']['addr1'] = $userdata['addr1'];
            $_SESSION['modules']['shared']['contact_info']['addr2'] = $userdata['addr2'];
            $_SESSION['modules']['shared']['contact_info']['city'] = $userdata['city'];
            $_SESSION['modules']['shared']['contact_info']['state'] = $userdata['state'];
            $_SESSION['modules']['shared']['contact_info']['country'] = $userdata['country'];
            $_SESSION['modules']['shared']['contact_info']['postal_code'] = $userdata['zip'];
            $_SESSION['modules']['shared']['contact_info']['phone'] = str_replace(array("(",")","-"," "),"",$userdata['phone']);
            $_SESSION['modules']['shared']['contact_info']['fax'] = str_replace(array("(",")","-"," "),"",$userdata['phone2']);
            $_SESSION['modules']['shared']['contact_info']['email'] = $userdata['email'];
        }
    } else {
        $results['success'] = false;
        $results['error'] = $wow->lastError;
    }

    return $results;
}

function ValidateCard($cctype,$ccnumber,$ccmonth,$ccyear) {
    $cclength = strlen($ccnumber);
    $error = "";
    switch($cctype) {
        case 'VISA':
            if($cclength != 13 && $cclength != 16)
                $error .= 'VISA Length Invalid.  ';
            if(substr($ccnumber,0,1) != '4')
                $error .= 'VISA Number Invalid.  ';
            break;
        case 'MASTERCARD':
            if($cclength != 16)
                $error .= 'MASTERCARD Length Invalid.  ';
            if(substr($ccnumber,0,2) != '51' && substr($ccnumber,0,2) != '52' && substr($ccnumber,0,2) != '53' && substr($ccnumber,0,2) != '54' && substr($ccnumber,0,2) != '55')
                $error .= 'MASTERCARD Number Invalid.  ';
            break;
        case 'AMEX':
            if($cclength != 15)
                $error .= 'AMEX Length Invalid.  ';
            if(substr($ccnumber,0,2) != '34' && substr($ccnumber,0,2) != '37')
                $error .= 'AMEX Number Invalid.  ';
            break;
        case 'DISCOVER':
            if($cclength != 16)
                $error .= 'DISCOVER Length Invalid.  ';
            if(substr($ccnumber,0,4) != '6011')
                $error .= 'DISCOVER Number Invalid.  ';
            break;
    }

    $ccnumberArray = array();
    $ccextradigits = 0;
    $checksum = 0;

    for($index=$cclength-1;$index>=0;$index--) {
        array_push($ccnumberArray,substr($ccnumber,$index,1));
    }

    if(isset($ccnumberArray) && is_array($ccnumberArray)) {
    foreach($ccnumberArray as $ccIndex=>$ccValue) {
        if($ccIndex%2 == 1) {
            $checksum += ($ccValue * 2);
            if(($ccValue * 2) > 9) {
                $checksum -= 9;
            }
        } else {
            $checksum += $ccValue;
        }
    }
    }

    if($checksum%10 != 0) {
        $error .= 'INVALID CARD NUMBER.  ';
    }

    $expDate = mktime(0,0,0,$ccmonth+1,0,$ccyear);

    if(time() > $expDate) {
        $error .= 'INVALID EXPIRATION DATE.  ';
    }

    if(strlen($error) == 0) {
        $results['success'] = true;
    } else {
        $results['success'] = false;
        $results['error'] = $error;
    }

    return $results;
}

function GetPrice($service,$action,$period,$subservice = false,$rgid) {
    global $wow;
    global $wowlogintype;

    $wow->setMethod('Transaction_GetPrice');
    $wow->addAttribute('logintype',$wowlogintype);

    $wow->addParameter('Service',$service);
    $wow->addParameter('SubService',$subservice,$subservice ? 'string' : 'boolean');
    $wow->addParameter('Action',$action);
    $wow->addParameter('Period',$period,'int');
    $wow->addParameter('RGID',$rgid,'string');
    $wow->addParameter('DataType','XML');

    if($wow->execute()) {
	    $results['success'] = true;
	    $results['priceData'] = $wow->getAttribute(0);
    } else {
	    $results['success'] = false;
	    $results['error'] = $wow->lastError;
    }

    return $results;
}

function GetAllPrices($rgid) {
    global $wow;
    global $wowlogintype;

    $wow->setMethod('Transaction_GetPrice');
    $wow->addAttribute('logintype',$wowlogintype);

    $wow->addParameter('Service',false,'boolean');
    $wow->addParameter('SubService',false,'boolean');
    $wow->addParameter('Action',false,'boolean');
    $wow->addParameter('Period',false,'boolean');
    $wow->addParameter('RGID',$rgid,'string');
    $wow->addParameter('DataType','XML');

    if($wow->execute()) {
        return $wow->getAttributesArray();
    } else {
        return false;
    }
}

function Authorize($authinput,$svc_preauth = false) {
    $results = array();
    global $wow;
    global $wowlogintype;

    if(!$svc_preauth)
        $svc_preauth = 'yes';

    $wow->setMethod('Transaction_Auth');
    $wow->addAttribute('logintype',$wowlogintype);

    $wow->addParameter('authinput',$authinput,'xml');
    $wow->addParameter('lChargeNow',$svc_preauth == 'yes' ? false : true,'boolean');
    $wow->addParameter('cDataType','XML');

    if($wow->execute()) {
        $results['success'] = true;
        $results['transactionData'] = $wow->getAttribute(0,'transaction');
    } else {
        $results['success'] = false;
        $results['error'] = $wow->lastError;
    }

    return $results;
}

function Commit($transactionID) {
    global $wow;
    global $wowlogintype;

    $wow->setMethod('Transaction_Commit');
    $wow->addAttribute('logintype',$wowlogintype);

    $wow->addParameter('transid',$transactionID);
    $wow->addParameter('cDataType','XML');

    if($wow->execute()) {
        return true;
    } else {
        return false;
    }

}

function Refund($transactionID) {
    global $wow;
    global $wowlogintype;

    $wow->setMethod('Transaction_Refund');
    $wow->addAttribute('logintype',$wowlogintype);

    $wow->addParameter('transid',$transactionID);
    $wow->addParameter('cDataType','XML');

    if($wow->execute()) {
        return true;
    } else {
        return false;
    }
}

function TestCharge($authinput) {
    $results = array();
    global $wow;
    global $wowlogintype;

    $wow->setMethod('Transaction_Auth');
    $wow->addAttribute('logintype',$wowlogintype);

    $wow->addParameter('authinput',$authinput,'xml');
    $wow->addParameter('lChargeNow',false,'boolean');
    $wow->addParameter('cDataType','XML');

    if($wow->execute()) {
        $transactionData = $wow->getAttribute(0,'transaction');
        Refund($transactionData['transid']);
        $results['success'] = true;
    } else {
        $results['success'] = false;
        $results['errormsg'] = $wow->lastError;
    }

    return $results;
}

function DeleteUser($custid) {
    global $wow;
    global $wowlogintype;

    $wow->setMethod('DeleteCustomer');
    $wow->addAttribute('logintype',$wowlogintype);

    $wow->addParameter('datatype','XML');
    $wow->addProperty('custid',$custid);
    if($wow->execute()) {
        return true;
    } else {
        return false;
    }
}

function AddRate($custid,$rgid,$freq) {
    global $wow;
    global $wowlogintype;

    $wow->setMethod('addrate');
    $wow->addAttribute('logintype',$wowlogintype);

    $wow->addProperty('custid',$custid);

    $wow->addParameter('rate',$rgid);
    $wow->addParameter('noconn',false);
    $wow->addParameter('datatype','XML');
    $wow->addParameter('freq',$freq);

    if($wow->execute()) {
	$results['success'] = true;
	$results['crid'] = $wow->getAttribute(0,'crid');
	if(isset($_SESSION['piwi']['listservices']))
	    unset($_SESSION['piwi']['listservices']);
    } else {
        $results['success'] = false;
	$results['error'] = $wow->lastError;
    }

    return $results;
}

function PostCharges($custid,$storeid,$days) {
    global $wow;
    global $wowlogintype;

    $wow->setMethod('Post');
    $wow->addAttribute('logintype',$wowlogintype);

    $wow->addParameter('noconn',false,'boolean');
    $wow->addParameter('days',$days,'string');
    $wow->addParameter('datatype','XML');

    $wow->addProperty('custid',$custid,'string');

    if($wow->execute()) {
        $results['success'] = true;
    } else {
        $results['success'] = false;
        $results['error'] = $wow->lastError;
    }

    return $results;
}

function getInvoices($custid) {
    global $wow;
    global $wowlogintype;

    $invoiceData = array();

    $wow->setMethod('GetInvoices');
    $wow->addAttribute('logintype',$wowlogintype);

    $wow->addParameter('datatype','XML');
    $wow->addParameter('startdate',false,'boolean');
    $wow->addParameter('enddate',false,'boolean');
    $wow->addParameter('invoiceowner','Guarantor');

    $wow->addProperty('custid',$custid);

    if($wow->execute()) {
        $balance = 0;
	$invoices = array();
	if(is_array($wow->getAttributesArray())) {
        foreach($wow->getAttributesArray() as $invoice) {
            if($invoice['due'] > 0) {
                $balance += $invoice['due'];
                array_push($invoices,$invoice['invoice']);
            }
	}
	}

        $invoiceData['balance'] = $balance;
        $invoiceData['invoices'] = $invoices;

        return $invoiceData;

        return true;
    } else {
        return false;
    }
}

function chargeCard($custid,$balance,$invoices,$paymentinfo,$storeid) {
    if($balance > 0) {
        $ccaction = GetWebOption('cc_action',$storeid);
        if($ccaction == 1)
            $chargecard = true;
        else
            $chargecard = false;

        global $wow;
        global $wowlogintype;

        $wow->setMethod('ChargeCard');
        $wow->addAttribute('logintype',$wowlogintype);

        $wow->addParameter('balance',$balance,'currency');
        $wow->addParameter('invoicelist',implode($invoices,','));
        $wow->addParameter('activeconn',false,'boolean');
        $wow->addParameter('ccaction',$chargecard,'boolean');
        $wow->addParameter('datatype','XML');

        $wow->addProperty('cctype',$paymentinfo['cctype']);
        $wow->addProperty('ccexpirem',$paymentinfo['ccmonth']);
        $wow->addProperty('ccexpirey',$paymentinfo['ccyear']);
        $wow->addProperty('ccnumber',$paymentinfo['ccnumber']);
        $wow->addProperty('name2',$paymentinfo['ccname']);
        $wow->addProperty('ccv2',$paymentinfo['cvv2']);
        $wow->addProperty('staffid',1,'string');
        $wow->addProperty('custid',$custid);

        if($wow->execute()) {
            return true;
        } else {
            return false;
        }
    } else {
        return true;
    }
}

function getEmail($custid) {
    global $wow;
    global $wowlogintype;

    $wow->setMethod('GetCustomer');
    $wow->addAttribute('logintype',$wowlogintype);

    $wow->addParameter('datatype','XML');

    $wow->addProperty('custid',$custid);

    if($wow->execute()) {
        return $wow->getAttribute(0,'email');
    } else {
        return false;
    }
}

function CreateMultiLineInvoice($custid,$guarid,$staffid,$comment,$itemarray) {
    global $wow;
    global $wowlogintype;

    $wow->setMethod('CreateMultiLineInvoice');
    $wow->addAttribute('logintype',$wowlogintype);

    $wow->addParameter('custid',$custid,'int');
    $wow->addParameter('guarid',$guarid,'int');
    $wow->addParameter('staffid',$staffid,'int');
    $wow->addParameter('comment',$comment);
    $wow->addParameter('item_array',$itemarray,'array');
    $wow->addParameter('noconn',false,'boolean');
    $wow->addParameter('datatype','XML');

    if($wow->execute()) {
	$results['success'] = true;
	$results['invoicenumber'] = $wow->getAttribute(0,'invoice');
    } else {
	$results['success'] = false;
	$results['error'] = $wow->lastError;
    }

    return $results;
}

function AddService($crid,$custid,$svcid,$fieldArray,$branch,$p_instance,$p_service,$active) {
    global $wow;
    global $wowlogintype;

    $servicearray = array();

    $newrow = array();
    $newrow['column_name'] = 'crid';
    $newrow['newvalue']    = $crid;
    $newrow['oldvalue']    = 'NEW ENTRY';
    $newrow['control']     = 'txt_text';
    $newrow['display']     = 'CRID';
    array_push($servicearray,$newrow);

    $newrow = array();
    $newrow['column_name'] = 'd_custid';
    $newrow['newvalue']    = $custid;
    $newrow['oldvalue']    = 'NEW ENTRY';
    $newrow['control']     = 'txt_text';
    $newrow['display']     = 'Customer ID';
    array_push($servicearray,$newrow);

    $newrow = array();
    $newrow['column_name'] = 'd_active';
    $newrow['newvalue']    = $active;
    $newrow['oldvalue']    = $active;
    $newrow['control']     = 'txt_text';
    $newrow['display']     = 'Active';
    array_push($servicearray,$newrow);

    if(isset($fieldArray) && is_array($fieldArray)) {
        foreach($fieldArray as $thisField) {
            $newrow = array();
            $newrow['column_name'] = $thisField['fieldname'];
            $newrow['newvalue']    = $thisField['value'];
            $newrow['oldvalue']    = 'NEW ENTRY';
            $newrow['control']     = $thisField['ctrl'];
            $newrow['display']     = $thisField['displayname'];
            array_push($servicearray,$newrow);
        }
    }

    $wow->setMethod('AddService');
    $wow->addAttribute('logintype',$wowlogintype);

    $wow->addParameter('serviceid',$svcid);
    $wow->addParameter('crid',$crid);
    $wow->addParameter('columnarray',$servicearray,'array');
    $wow->addParameter('datatype','XML');
    $wow->addParameter('noconn',false,'boolean');
    $wow->addParameter('branch',$branch);
    $wow->addParameter('parentInstance',$p_instance);
    $wow->addParameter('parentService',$p_service);

    $wow->addProperty('custid',$custid);

    if($wow->execute()) {
        $results['success'] = true;
        $results['data_id'] = $wow->getAttribute(0,'dataid');
	if(isset($_SESSION['piwi']['listservices'][$svcid]))
            unset($_SESSION['piwi']['listservices'][$svcid]);
	if(isset($_SESSION['piwi']['listservices']['BLANK']))
	    unset($_SESSION['piwi']['listservices']['BLANK']);
    } else {
        $results['success'] = false;
        $results['error'] = $wow->lastError;
    }

    return $results;
}

function UpdateService($custid,$svcid,$dataid,$fieldArray) {
    global $wow;
    global $wowlogintype;

    $servicearray = array();

    if(isset($fieldArray) && is_array($fieldArray)) {
    foreach($fieldArray as $thisFieldName=>$thisFieldData) {
        $newrow = array();
        $newrow['columnname']   = $thisFieldName;
        $newrow['newvalue']     = $thisFieldData['value'];
        $newrow['currentvalue'] = $thisFieldData['currentvalue'];
        $newrow['control']      = $thisFieldData['type'];
        $newrow['displayname']  = $thisFieldData['name'];
        array_push($servicearray,$newrow);
    }
    }

    $wow->setMethod('UpdateService');
    $wow->addAttribute('logintype',$wowlogintype);

    $wow->addParameter('serviceid',$svcid);
    $wow->addParameter('dataid',$dataid);
    $wow->addParameter('columnarray',$servicearray,'array');
    $wow->addParameter('datatype','XML');

    $wow->addProperty('custid',$custid);

    if($wow->execute()) {
        return true;
    } else {
        return false;
    }
}

function UpdateColumn ($table,$column,$value,$where) {
    global $wow;
    global $wowlogintype;

    $wow->setMethod('Update');
    $wow->addAttribute('logintype',$wowlogintype);

    $wow->addParameter('table',$table);
    $wow->addParameter('column',$column);
    $wow->addParameter('value',"'".$value."'");
    $wow->addParameter('whereclause',$where);
    $wow->addParameter('noconn',false,'boolean');
    $wow->addParameter('datatype','XML');

    if($wow->execute())
        return true;
    else
        return false;
}

function addEmailService($crid,$custid,$active,$email,$username,$password) {
    $servicearray = array();
    global $wow;
    global $wowlogintype;

    $newrow = array();
    $newrow['column_name'] = 'crid';
    $newrow['newvalue'] = $crid;
    $newrow['control'] = 'txt_text';
    $newrow['display'] = 'CRID';
    array_push($servicearray,$newrow);

    $newrow = array();
    $newrow['column_name'] = 'd_custid';
    $newrow['newvalue'] = $custid;
    $newrow['control'] = 'txt_text';
    $newrow['display'] = 'Customer ID';
    array_push($servicearray,$newrow);

    $newrow = array();
    $newrow['column_name'] = 'd_active';
    $newrow['newvalue'] = $active;
    $newrow['control'] = 'txt_text';
    $newrow['display'] = 'Active';
    array_push($servicearray,$newrow);

    $newrow = array();
    $newrow['column_name'] = 'emailaddr';
    $newrow['newvalue'] = $email;
    $newrow['control'] = 'txt_service_email';
    $newrow['display'] = 'Email Address';
    array_push($servicearray,$newrow);

    $startpos = strpos($email,'@')+1;
    $stringlen = strlen($email);
    $newrow = array();
    $newrow['column_name'] = 'domain';
    $newrow['newvalue'] = substr($email,$startpos,$stringlen-$startpos);
    $newrow['control'] = 'cmb_service_domain';
    $newrow['display'] = 'Domain';
    array_push($servicearray,$newrow);

    $newrow = array();
    $newrow['column_name'] = 'username';
    $newrow['newvalue'] = $username;
    $newrow['control'] = 'txt_service_username_with_domain';
    $newrow['display'] = 'Username';
    array_push($servicearray,$newrow);

    $newrow = array();
    $newrow['column_name'] = 'password';
    $newrow['newvalue'] = $password;
    $newrow['control'] = 'txt_password';
    $newrow['display'] = 'Password';
    array_push($servicearray,$newrow);

    $wow->setMethod('AddService');
    $wow->addAttribute('logintype',$wowlogintype);

    $wow->addParameter('serviceid',1);
    $wow->addParameter('crid',$crid);
    $wow->addParameter('columnarray',$servicearray,'array');
    $wow->addParameter('datatype','XML');

    $wow->addProperty('custid',$custid);

    if($wow->execute()) {
        return $wow->getAttribute(0,'dataid');
    } else {
        return false;
    }
}

function LaunchUM($umaction,$custid,$svcid = false) {
    global $wow;
    global $wowlogintype;

    $wow->setMethod('LaunchUM');
    $wow->addAttribute('logintype',$wowlogintype);

    $wow->addParameter('option',$umaction);
    $wow->addParameter('dataid',$svcid,$svcid ? 'string' : 'boolean');
    $wow->addParameter('openconnection','1','string');
    $wow->addParameter('datatype','XML');

    $wow->addProperty('custid',$custid);

    if($wow->execute()) {
        return true;
    } else {
        return false;
    }
}

function deleteCustomer($custid) {
    global $wow;
    global $wowlogintype;

    $wow->setMethod('DeleteCustomer');
    $wow->addAttribute('logintype','customer');

    $wow->addParameter('datatype','XML');

    $wow->addProperty('custid',$custid);

    if($wow->execute())
        return true;
    else {
        return false;
    }
}

function EmailPassword($username) {
    $results = array();
    $templateFile = "../../etc/lostpassword.xml";
    $userData = ExecuteSQL("select email,password from customer where username = '".SQLTrim($username)."'");

    if($userData['success'] && count($userData['sqlreturn'][0]) != 2) {
        $results['success'] = false;
        $results['error'] = "Invalid username.";
    } else {
        if($userData['success'] && !$userData['sqlreturn'][0]['email']) {
            $results['success'] = false;
            $results['error'] = "There is no email address associated with the specified username.";
        } else {
            if(!file_exists($templateFile)) {
                $results['success'] = false;
                $results['error'] = "Service unavailable at this time.";
            } else {
                $templateData = simplexml_load_file($templateFile);

                if(isset($templateData)) {
                foreach($templateData as $thisFieldName=>$thisFieldData) {
                    $template[$thisFieldName] = (string) $thisFieldData;
                }
                }

                $template['body'] = str_replace('XXUSERNAMEXX',$username,$template['body']);
                $template['body'] = str_replace('XXPASSWORDXX',$userData['sqlreturn'][0]['password'],$template['body']);

                global $wow;
                global $wowlogintype;

                $wow->setMethod('SendMail');
                $wow->addAttribute('logintype',$wowlogintype);

                $wow->addParameter('toaddr',$userData['sqlreturn'][0]['email']);
                $wow->addParameter('fromaddr',$template['from']);
                $wow->addParameter('subject',$template['subject']);
                $wow->addParameter('emailbody',$template['body']);
                $wow->addParameter('ccaddr','');
                $wow->addParameter('datatype','XML');

                if($wow->execute()) {
                    $results['success'] = true;
                } else {
                    $results['success'] = false;
                    $results['error'] = $wow->lastError;
                }
            }
        }
    }

    return $results;
}

function ShowMoney($string) {
    return str_replace(" ","",fixMoney($string));
}

function FixSlash($string) {
    return stripslashes_deep($string);
}

?>
