<?php
require_once("platfunctions.php");
require_once("../../libs/platypus/wow.inc.php");
require_once("../../libs/ccs/options.inc.php");
require_once("../../libs/ccs/utilities.inc.php");

$stafflogin = $_SESSION['wow']['staffname'];
$staffpass  = $_SESSION['wow']['staffpass'];

global $wowlogintype;
$wowlogintype  = $_SESSION['wow']['logintype'] ? $_SESSION['wow']['logintype'] : 'staff';

global $wow;
$wow = new WOW_Request();
$wow->setUsername($stafflogin);
$wow->setPassword($staffpass);

global $storeid;
$storeid = $_SESSION['piwi']['storeid'] ? $_SESSION['piwi']['storeid'] : ($_SESSION['piwi']['defaultstore'] ? $_SESSION['piwi']['defaultstore'] : false);

//---- load the helpdesk options
if(!$_SESSION['helpdesk']['options']) {
    loadHelpdeskOptions();
}

function AH_LoadOptions (ACF_ParameterList $inParameterList) {
    global $storeid;

    if(!$_SESSION['wow']) {
        loadCCSOptions();
    }

    if(!$_SESSION['piwi']['options']) {
        $_SESSION['piwi']['options']['ccs-url'] = $_SESSION['ccs']['options']['driver-options']['url'];
    }

    $_SESSION['ccs']['source'] = 'piwi';

// Added By JCW for custom css solution on login page - 02/02/06
    if($inParameterList->ParameterValue('options')) {
        $optionsArray = $inParameterList->ParameterValue('options');
        $_SESSION['piwi']['storeid'] = $optionsArray['storeid'];
        if ($_SESSION['piwi']['storeid'])
            $storeid = $_SESSION['piwi']['storeid'];
        elseif ($_SESSION['piwi']['defaultstore'])
            $storeid = $_SESSION['piwi']['defaultstore'];
        else
            $storeid = false;
    }
// End of Add

    if(!$_SESSION['piwi']['options'] && !$_SESSION['wow'] && !$_SESSION['helpdesk']['options']) {
        $paramList = new ACF_ParameterList();
        $paramList->AddParameter(new ACF_DirectParameter('errormessage',"The CCS options could not be loaded."));
        $retEvent = new ACF_Event('loadoptions_fail');
        $retEvent->SetParameterList($paramList);
        return $retEvent;
    } else {
        SetStaffLogin();
        $_SESSION['piwi']['dateformat'] = GetDateFormat();
        $serviceDefs = GetServiceDefs();
        if(isset($serviceDefs) && is_array($serviceDefs)) {
            foreach($serviceDefs as $thisDef) {
                $svcID = $thisDef['svc_id'];
                unset($thisDef['svc_id']);
                $_SESSION['piwi']['serviceDefs'][$svcID] = $thisDef;
            }
        }

        // get GST display options
        $_SESSION['GST']['showGST'] = GetWebOption('australianGST_display',$storeid);

        if(strtoupper($_SESSION['GST']['showGST']) ==  'Y') {
            $_SESSION['GST']['percent'] = GetWebOption('australianGST_percent',$storeid);
            $_SESSION['GST']['desc'] = GetWebOption('australianGST_desc',$storeid);

        } else {
            unset($_SESSION['GST']);
        }

        return new ACF_Event('loadoptions_success');
    }
}

function AH_SearchCheck (ACF_ParameterList $inParameterList) {
    if(!$_SESSION['piwi']['staffid']) {
        unset($_SESSION['piwi']);

        $paramList = new ACF_ParameterList();
        $paramList->AddParameter(new ACF_DirectParameter('error','Invalid attempt to access staff pages.  Please re-login.'));
        $retEvent = new ACF_Event('searchcheck_fail');
        $retEvent->SetParameterList($paramList);
        return $retEvent;
    } else {
        return new ACF_Event('searchcheck_success');
    }
}

function AH_CheckStaff (ACF_ParameterList $inParameterList) {
//Proposed change to allow customers to run their own functions:
    if(!Login($_SESSION['wow']['staffname'],$_SESSION['wow']['staffpass'],$_SESSION['wow']['logintype']?$_SESSION['wow']['logintype']:'staff')) {
        unset($_SESSION['piwi']);

        $paramList = new ACF_ParameterList();
        $paramList->AddParameter(new ACF_DirectParameter('error','The staff login info in wow_options.xml is incorrect.'));
        $retEvent = new ACF_Event('staffid_notset');
        $retEvent->SetParameterList($paramList);
        return $retEvent;
    } else {
        return new ACF_Event('staffid_set');
    }
}

function AH_CheckCustomer (ACF_ParameterList $inParameterList) {
    if(!$_SESSION['piwi']['custid']) {
        unset($_SESSION['piwi']);

        $paramList = new ACF_ParameterList();
        $paramList->AddParameter(new ACF_DirectParameter('error','Not Logged In.  Please Login.'));
        $retEvent = new ACF_Event('custid_notset');
        $retEvent->SetParameterList($paramList);
        return $retEvent;
    } else {
        return new ACF_Event('custid_set');
    }
}

function AH_Login (ACF_ParameterList $inParameterList) {
    $username = $inParameterList->ParameterValue('username');
    $password = $inParameterList->ParameterValue('password');

    if (strlen(trim($username)) || strlen(trim($password))) { // if the login or password is empty skip this, since this case is not allowed in the system
        $custIDarray = Login($username,$password,'customer');
        if(!$custIDarray) {
            $loginerror = "failed";
        }
    } else {
        $loginerror = "empty";
    }

    if ($loginerror) {
        $paramList = new ACF_ParameterList();
        $paramList->AddParameter(new ACF_DirectParameter('error',$loginerror));
        $retEvent = new ACF_Event('dologin_fail');
        $retEvent->SetParameterList($paramList);
        return $retEvent;
    } else {
//Proposed change to allow customers to run their own functions:
        $_SESSION['wow']['staffname'] = $username;
        $_SESSION['wow']['staffpass'] = $password;
        $_SESSION['wow']['logintype'] = 'customer';

        SetStaffLogin();

        $_SESSION['piwi']['custid'] = $custIDarray['id'];
        $_SESSION['piwi']['storeid'] = $custIDarray['storeid'];
        $_SESSION['piwi']['displaystaffpages'] = false;
        $_SESSION['piwi']['OpenSRSProfile'] = GetProfile($_SESSION['piwi']['custid']);

        return new ACF_Event('dologin_success');
    }
}

function AH_StaffLogin (ACF_ParameterList $inParameterList) {
    $username = $inParameterList->ParameterValue('username');
    $password = $inParameterList->ParameterValue('password');

    if (strlen(trim($username)) || strlen(trim($password))) { // if the login or password is empty skip this, since this case is not allowed in the system
        $staffIDarray = Login($username,$password,'staff');
        if(!$staffIDarray) {
            $loginerror = "failed";
        }
    } else {
        $loginerror = "empty";
    }

    if ($loginerror) {
        $paramList = new ACF_ParameterList();
        $paramList->AddParameter(new ACF_DirectParameter('error',$loginerror));
        $retEvent = new ACF_Event('dostafflogin_fail');
        $retEvent->SetParameterList($paramList);
        return $retEvent;
    } else {
        $_SESSION['wow']['staffname'] = $_SESSION['piwi']['staffname'] = $username;
        $_SESSION['wow']['staffpass'] = $password;
//Proposed change to allow customers to run their own functions:
        $_SESSION['wow']['logintype'] = 'staff';

        SetStaffLogin();

        $_SESSION['piwi']['staffid'] = $staffIDarray['id'];
        $_SESSION['piwi']['defaultstore'] = $staffIDarray['storeid'];
        $_SESSION['piwi']['displaystaffpages'] = true;
        return new ACF_Event('dostafflogin_success');
    }
}

function AH_CustomerSearch (ACF_ParameterList $inParameterList) {
    if(!$_SESSION['piwi']['staffid']) {
        unset($_SESSION['piwi']);

        $paramList = new ACF_ParameterList();
        $paramList->AddParameter(new ACF_DirectParameter('error','Invalid attempt to switch customer records.  Please re-login.'));
        $retEvent = new ACF_Event('customersearch_relogin');
        $retEvent->SetParameterList($paramList);
        return $retEvent;
    } else {
        $results = CustomerSearch(stripslashes_deep($inParameterList->ParameterValue('searchstring')));
        $paramList = new ACF_ParameterList();

        if ($results['success']) {
            $paramList->AddParameter(new ACF_DirectParameter('searchresults',$results['searchResults']));
            $retEvent = new ACF_Event('customersearch_success');
            $retEvent->SetParameterList($paramList);
        } else {
            $paramList->AddParameter(new ACF_DirectParameter('error',$results['errormsg']));
            $retEvent = new ACF_Event('customersearch_fail');
            $retEvent->SetParameterList($paramList);
        }

        return $retEvent;
    }
}

function AH_SelectCustomer (ACF_ParameterList $inParameterList) {
    if(!$_SESSION['piwi']['staffid']) {
        unset($_SESSION['piwi']['listservices']);

        $children = GetChildren($_SESSION['piwi']['custid']);
        if(isset($children) && is_array($children)) {
            foreach($children as $child) {
                if($child['id'] == stripslashes_deep($inParameterList->ParameterValue('custid'))) {
                    $childAccessAllowed = true;
                    break;
                }
            }
        }

        if(!$childAccessAllowed) {
            unset($_SESSION['piwi']);

            $paramList = new ACF_ParameterList();
            $paramList->AddParameter(new ACF_DirectParameter('error','You have been logged out due to an invalid attempt to switch customer records.  Please login again.'));
            $retEvent = new ACF_Event('selectcustomer_fail');
            $retEvent->SetParameterList($paramList);
            return $retEvent;
        } else {
            $_SESSION['piwi']['parentid'] = $_SESSION['piwi']['custid'];
            $_SESSION['piwi']['childid']   = stripslashes_deep($inParameterList->ParameterValue('custid'));

            $_SESSION['piwi']['custid']   = stripslashes_deep($inParameterList->ParameterValue('custid'));

            return new ACF_Event('selectcustomer_success');
        }
    } else {
        unset($_SESSION['piwi']['listservices']);

        // Clear Cache
        if($_SESSION['piwi']['custinfo'][stripslashes_deep($inParameterList->ParameterValue('custid'))])
            unset($_SESSION['piwi']['custinfo'][stripslashes_deep($inParameterList->ParameterValue('custid'))]);

        $_SESSION['piwi']['custid'] = stripslashes_deep($inParameterList->ParameterValue('custid'));
        $loadedCustomer = ExecuteSQL("select guarantor,storeid from customer where id = ".SQLTrim($_SESSION['piwi']['custid']));
        if($loadedCustomer['success'] && isset($loadedCustomer['sqlreturn'][0]['storeid'])) {
            $_SESSION['piwi']['storeid'] = $loadedCustomer['sqlreturn'][0]['storeid'];
            $_SESSION['piwi']['parentid'] = $loadedCustomer['sqlreturn'][0]['guarantor'];
        }
        $_SESSION['piwi']['OpenSRSProfile'] = GetProfile($_SESSION['piwi']['custid']);



        return new ACF_Event('selectcustomer_success');
    }
}

function AH_SetSubMenu (ACF_ParameterList $inParameterList) {
    $_SESSION['piwi']['currentSection'] = stripslashes_deep($inParameterList->ParameterValue('section'));
    $_SESSION['piwi']['currentSubsection'] = stripslashes_deep($inParameterList->ParameterValue('subsection'));

    if($_SESSION['piwi']['needsRefresh']) {
        unset($_SESSION['piwi']['needsRefresh']);
        return new ACF_Event('setsubmenu_refreshsvc');
    } else {
        return new ACF_Event('setsubmenu_success');
    }
}

function AH_Logout (ACF_ParameterList $inParameterList) {
    $returnURL  = "/projects/piwi/index.php?NEWSESSION";
    $returnURL .= "&options[storeid]=".$_SESSION['piwi']['storeid'];
    if($_SESSION['piwi']['displaystaffpages']) {
        $returnURL .= "&logintype=staff";
        $retEvent = new ACF_Event('logout_staff');
    } else {
        $retEvent = new ACF_Event('logout_customer');
    }

    header("location:".$returnURL);

    return $retEvent;
}

function AH_ChildSwitch (ACF_ParameterList $inParameterList) {
    if(!$_SESSION['piwi']['custid']) {
        unset($_SESSION['piwi']);

        $paramList = new ACF_ParameterList();
        $paramList->AddParameter(new ACF_DirectParameter('error','Invalid attempt to switch customer records.  Please re-login.'));
        $retEvent = new ACF_Event('childswitch_fail');
        $retEvent->SetParameterList($paramList);
        return $retEvent;
    } else {
        $children = GetChildren($_SESSION['piwi']['custid']);
        if(isset($children) && is_array($children)) {
            foreach($children as $child) {
                if($child['id'] == stripslashes_deep($inParameterList->ParameterValue('custid'))) {
                    $childAccessAllowed = true;
                    break;
                }
            }
        }

        if(!$childAccessAllowed) {
            unset($_SESSION['piwi']);

            $paramList = new ACF_ParameterList();
            $paramList->AddParameter(new ACF_DirectParameter('error','You do not have access to this customer record.  Please re-login.'));
            $retEvent = new ACF_Event('childswitch_fail');
            $retEvent->SetParameterList($paramList);
            return $retEvent;
        } else {
            $_SESSION['piwi']['parentid'] = $_SESSION['piwi']['custid'];
            $_SESSION['piwi']['childid']   = stripslashes_deep($inParameterList->ParameterValue('custid'));

            $_SESSION['piwi']['custid']   = stripslashes_deep($inParameterList->ParameterValue('custid'));

            return new ACF_Event('childswitch_success');
        }
    }
}

function AH_ParentSwitch (ACF_ParameterList $inParameterList) {
    if(!$_SESSION['piwi']['parentid'] && !$_SESSION['piwi']['custid']) {
        unset($_SESSION['piwi']);

        $paramList = new ACF_ParameterList();
        $paramList->AddParameter(new ACF_DirectParameter('error','Invalid attempt to switch customer records.  Please re-login.'));
        $retEvent = new ACF_Event('parentswitch_fail');
        $retEvent->SetParameterList($paramList);
        return $retEvent;
    } else {
        $_SESSION['piwi']['custid'] = $_SESSION['piwi']['parentid'] ? $_SESSION['piwi']['parentid'] : $_SESSION['piwi']['custid'];

        if($_SESSION['piwi']['parentid']) {
            unset($_SESSION['piwi']['parentid']);
        }

        if($_SESSION['piwi']['childid']) {
            unset($_SESSION['piwi']['childid']);
        }

        return new ACF_Event('parentswitch_success');
    }
}

function AH_AddBlockTime (ACF_ParameterList $inParameterList) {
    if(stripslashes_deep($inParameterList->ParameterValue('blockid'))) {
        $blockid = stripslashes_deep($inParameterList->ParameterValue('blockid'));
        $addblock = AddBlockTime($_SESSION['piwi']['custid'],$blockid);
        if($addblock['success']) {
            return new ACF_Event('addblocktime_success');
        } else {
            $paramList = new ACF_ParameterList();
            $paramList->AddParameter(new ACF_DirectParameter('error',$addblock['errormsg']));
            $retEvent = new ACF_Event('addblocktime_fail');
            $retEvent->SetParameterList($paramList);
            return $retEvent;
        }
    } else {
        $paramList = new ACF_ParameterList();
        $paramList->AddParameter(new ACF_DirectParameter('error','No Block Item Selected'));
        $retEvent = new ACF_Event('addblocktime_fail');
        $retEvent->SetParameterList($paramList);
        return $retEvent;
    }
}

function AH_SwitchReferralView (ACF_ParameterList $inParameterList) {
    switch($inParameterList->ParameterValue('referraltype')) {
    case 'pending':
        return new ACF_Event('switchreferralview_pending');
        break;
    default:
        return new ACF_Event('switchreferralview_paid');
    }
}

function AH_SwitchCommissionView (ACF_ParameterList $inParameterList) {
    switch($inParameterList->ParameterValue('commissiontype')) {
    case 'pending':
        return new ACF_Event('switchcommissionview_pending');
        break;
    default:
        return new ACF_Event('switchcommissionview_paid');
    }
}

function AH_SetServiceTree (ACF_ParameterList $inParameterList) {
    global $wow;
    global $wowlogintype;

    $_SESSION['piwi']['serviceList'] = array();
    $parentList = array();

    $wow->setMethod('ListServiceTree');
    $wow->addAttribute('logintype',$wowlogintype);

    $wow->addParameter('datatype','XML');

    $wow->addProperty('custid',$_SESSION['piwi']['custid']);

    if($wow->execute()) {
        $serviceTree = $wow->getAttributesArray();
    }

// this section removes dupe branches to work with either-or
    if(isset($serviceTree) && is_array($serviceTree)) {
        foreach($serviceTree as $thisKey=>$thisBranch) { // for each branch of the tree
            for($i = 0; $i < $thisKey; $i++) { // instantiate a loop through each of the previous elements
            // check each of the branch elements (except for path and order) for equality
            // if equal, remove the current branch
            // note: the "thiskey != 0" is needed for the first runthrough, so that 0 doesn't eliminate itself
                if($thisKey != 0
                        && $serviceTree[$i]['rs_id'] == $thisBranch['rs_id']
                        && $serviceTree[$i]['rs_parent_id'] == $thisBranch['rs_parent_id']
                        && $serviceTree[$i]['rs_rg_id'] == $thisBranch['rs_rg_id']
                        && $serviceTree[$i]['rs_cr_id'] == $thisBranch['rs_cr_id']
                        && $serviceTree[$i]['rs_svc_id'] == $thisBranch['rs_svc_id']
                        && $serviceTree[$i]['rs_svc_qty'] == $thisBranch['rs_svc_qty']
                        && $serviceTree[$i]['rs_base_qty'] == $thisBranch['rs_base_qty']
                        && $serviceTree[$i]['rs_template_id'] == $thisBranch['rs_template_id']
                        && $serviceTree[$i]['rs_svc_pool'] == $thisBranch['rs_svc_pool']
                        && $serviceTree[$i]['rs_show_detail'] == $thisBranch['rs_show_detail']
                        && $serviceTree[$i]['rs_parent_service'] == $thisBranch['rs_parent_service']
                        && $serviceTree[$i]['rs_parent_instance'] == $thisBranch['rs_parent_instance']
                        && $serviceTree[$i]['rs_used'] == $thisBranch['rs_used']
                        && $serviceTree[$i]['rs_total'] == $thisBranch['rs_total']
                        && $serviceTree[$i]['rs_ccs_service'] == $thisBranch['rs_ccs_service']
                        && $serviceTree[$i]['rs_hidden'] == $thisBranch['rs_hidden']
                ) {
                    unset($serviceTree[$thisKey]);
                }
            }

            if(isset($serviceTree[$thisKey])) { // if this item is still set, init some values
                $serviceTree[$thisKey]['rs_svc_web_only'] = $_SESSION['piwi']['serviceDefs'][$thisBranch['rs_svc_id']]['svc_web_only'];  // make a flag for web-only services

                if(!$serviceTree[$thisKey]['rs_ccs_service'])
                    $serviceTree[$thisKey]['rs_ccs_service'] = 'None'; // make a non-boolean value for the existance of rs_ccs_service

                if($serviceTree[$thisKey]['rs_parent_id'] != 0)
                    array_push($parentList,$serviceTree[$thisKey]['rs_parent_id']);  // if it has a parent, put its parent on the parent list
            }
        }

        if(isset($serviceTree) && is_array($serviceTree)) { // if, after the paring down of the tree, you still have elements...
            $svcCommandList = array();

            foreach($serviceTree as &$thisBranch) {
                // get creation commands -- service_instance set to 0
                if(!isset($svcCommandList[$thisBranch['rs_svc_id']]['addCommand'])) { // only execute if the svcCommandList for this service id is not populated with addCommand
                    $wow->setMethod('GetServiceCommands');
                    $wow->addAttribute('logintype',$wowlogintype);

                    $wow->addParameter('service_type',$thisBranch['rs_svc_id']);
                    $wow->addParameter('service_instance',0,'int');
                    $wow->addParameter('datatype','XML');

                    $wow->addProperty('custid',$_SESSION['piwi']['custid']);

                    if($wow->execute()) {
                        if(is_array($wow->getAttribute(0))) {
                            $svcCommandList[$thisBranch['rs_svc_id']]['addCommand'] = $wow->getAttribute(0);
                        } else {
                            $svcCommandList[$thisBranch['rs_svc_id']]['addCommand'] = false;
                        }
                    }
                }

                // get modification commands -- service_instance set to 1
                if(!isset($svcCommandList[$thisBranch['rs_svc_id']]['modifyCommands'])) { // only execute if the svcCommandList for this service id is not populated with modifyCommands
                    $wow->setMethod('GetServiceCommands');
                    $wow->addAttribute('logintype',$wowlogintype);

                    $wow->addParameter('service_type',$thisBranch['rs_svc_id']);
                    $wow->addParameter('service_instance',1,'int');
                    $wow->addParameter('datatype','XML');

                    $wow->addProperty('custid',$_SESSION['piwi']['custid']);

                    if($wow->execute()) {
                        if(is_array($wow->getAttributesArray())) {
                            $svcCommandList[$thisBranch['rs_svc_id']]['modifyCommands'] = $wow->getAttributesArray();
                        } else {
                            $svcCommandList[$thisBranch['rs_svc_id']]['modifyCommands'] = false;
                        }
                    }
                }

                if(in_array($thisBranch['rs_id'],$parentList)) { // if this service type is in the aforementioned parent list, mark it as a parent
                    $thisBranch['rs_is_parent'] = true;
                }

                if($thisBranch['rs_parent_service'] == 'NULL' || $thisBranch['rs_parent_service'] == '') { // update the SQL NULL value with a 0
                    $thisBranch['rs_parent_service'] = 0;
                }

                if($thisBranch['rs_parent_instance'] == 'NULL' || $thisBranch['rs_parent_instance'] == '') {// update the SQL NULL value with a 0
                    $thisBranch['rs_parent_instance'] = 0;
                }

                if(strrpos($thisBranch['rs_path'],'->')) { // parse the path for branches to get the proper svc_type for this service
                    $thisBranch['rs_svc_type'] = substr($thisBranch['rs_path'],strrpos($thisBranch['rs_path'],'->')+2);
                } else {
                    $thisBranch['rs_svc_type'] = $thisBranch['rs_path'];
                }

                if(!array_key_exists($thisBranch['rs_svc_id'],$_SESSION['piwi']['serviceList'])) {
                    $securityTags = array(
                        array('Form Svc-'.$thisBranch['rs_svc_type'].'-Edit',false),
                        array('Form Svc-'.$thisBranch['rs_svc_type'].'-Save',false),
                        array('Form Svc-'.$thisBranch['rs_svc_type'].'-Delete',false),
                        array('Form Svc-'.$thisBranch['rs_svc_type'].'-New',false),
                        array('Form Svc-'.$thisBranch['rs_svc_type'].'-Overload',false)
                    );

                    $securityResult = MultiSecurityCheck($securityTags);

                    $_SESSION['piwi']['serviceList'][$thisBranch['rs_svc_id']] = array();
                    $_SESSION['piwi']['serviceList'][$thisBranch['rs_svc_id']]['name'] = $thisBranch['rs_svc_type'];
                    $_SESSION['piwi']['serviceList'][$thisBranch['rs_svc_id']]['allowEdit'] = $securityResult[0]['item_2'];
                    $_SESSION['piwi']['serviceList'][$thisBranch['rs_svc_id']]['allowSave'] = $securityResult[1]['item_2'];
                    $_SESSION['piwi']['serviceList'][$thisBranch['rs_svc_id']]['allowDelete'] = $securityResult[2]['item_2'];
                    $_SESSION['piwi']['serviceList'][$thisBranch['rs_svc_id']]['allowNew'] = $securityResult[3]['item_2'];
                    $_SESSION['piwi']['serviceList'][$thisBranch['rs_svc_id']]['allowOverload'] = $securityResult[4]['item_2'];
                }
            }

        // with the service types gathered, now gather service instances
            $wow->setMethod('ListServiceInstances');
            $wow->addAttribute('logintype',$wowlogintype);

            $wow->addParameter('serviceType',false,'boolean');
            $wow->addParameter('serviceID',false,'boolean');
            $wow->addParameter('datatype','XML');

            $wow->addProperty('custid',$_SESSION['piwi']['custid']);

            if($wow->execute()) {
                $instances = $wow->getAttributesArray();
            }

            if(isset($instances) && is_array($instances)) { // if instances are returned
                foreach($serviceTree as &$thisBranch) { // loop through each branch
                    foreach($instances as $thisService) { // ... and instance
            // if the instance matches the type, add it to the array of services on that branch
                        if($thisService['s_struct_id'] == $thisBranch['rs_id'] && $thisService['s_parent_id'] == $thisBranch['rs_parent_instance'] && $thisService['s_parent_type'] == $thisBranch['rs_parent_service'] && $thisService['s_custrate'] == $thisBranch['rs_cr_id'] && $thisService['s_svc_id'] == $thisBranch['rs_svc_id']) {
                            if(!is_array($thisBranch['services'])) { // if the services value on the branch has not been populated yet, make a new array
                                $thisBranch['services'] = array();
                            }
                            array_push($thisBranch['services'],$thisService);
                        }
                    }
                }
            }
        }
    }

    // set our values in the session
    $_SESSION['piwi']['serviceTree'] = $serviceTree;
    $_SESSION['piwi']['serviceCommands'] = $svcCommandList;

    // copy values to modules
    $_SESSION['modules']['shared']['serviceList'] = $_SESSION['piwi']['serviceList'];
    $_SESSION['modules']['shared']['serviceTree'] = $_SESSION['piwi']['serviceTree'];
    $_SESSION['modules']['shared']['serviceCommands'] = $_SESSION['piwi']['serviceCommands'];

    return new ACF_Event('setservicetree_done');
}

function AH_GetBundleCount (ACF_ParameterList $inParameterList) {
    $bundledata = GetCustomerRates($_SESSION['piwi']['custid']);

    $paramList = new ACF_ParameterList();
    if(stripslashes_deep($inParameterList->ParameterValue('error')))
        $paramList->AddParameter(new ACF_DirectParameter('error',stripslashes_deep($inParameterList->ParameterValue('error'))));

    if (count($bundledata) == 1) {
        $paramList->AddParameter(new ACF_DirectParameter('crid',$bundledata[0]['crid']));
        $retEvent = new ACF_Event('getbundlecount_single');
    } else {
        if (count($bundledata) > 1) {
            $retEvent = new ACF_Event('getbundlecount_multiple');
        } else {
            $retEvent = new ACF_Event('getbundlecount_fail');
        }
    }
    $retEvent->SetParameterList($paramList);

    return $retEvent;
}

function AH_ExecuteServiceCommand (ACF_ParameterList $inParameterList) {
    $paramList = new ACF_ParameterList;

    global $wow;
    global $wowlogintype;

    $wow->setMethod('RunServiceCommand');
    $wow->addAttribute('logintype',$wowlogintype);

    $wow->addParameter('command_id',$inParameterList->ParameterValue('command_id'));
    $wow->addParameter('data_id',$inParameterList->ParameterValue('data_id'));
    $wow->addParameter('datatype','XML');

    $wow->addProperty('custid',$_SESSION['piwi']['custid']);

    if($wow->execute()) {
        switch($inParameterList->ParameterValue('returnview')) {
        case 'servicedetails':
            $paramList->AddParameter(new ACF_DirectParameter('svc_id',$inParameterList->ParameterValue('p_service')));
            $paramList->AddParameter(new ACF_DirectParameter('data_id',$inParameterList->ParameterValue('p_instance')));
            $paramList->AddParameter(new ACF_DirectParameter('crid',$inParameterList->ParameterValue('crid')));
            $paramList->AddParameter(new ACF_DirectParameter('parentid',$inParameterList->ParameterValue('parentid')));
            $retEvent = new ACF_Event('executeservicecommand_success_servicedetails');
            break;
        case 'services':
            $paramList->AddParameter(new ACF_DirectParameter('svc_id',$inParameterList->ParameterValue('svc_id')));
            $retEvent = new ACF_Event('executeservicecommand_success_services');
            break;
        case 'currentrateinfo':
            $paramList->AddParameter(new ACF_DirectParameter('crid',$inParameterList->ParameterValue('crid')));
            $retEvent = new ACF_Event('executeservicecommand_success_currentrateinfo');
            break;
        default:
            $retEvent = new ACF_Event('executeservicecommand_success_bundles');
        }
    } else {
        $paramList->AddParameter(new ACF_DirectParameter('error',$wow->lastError));
        switch($inParameterList->ParameterValue('returnview')) {
        case 'servicedetails':
            $paramList->AddParameter(new ACF_DirectParameter('svc_id',$inParameterList->ParameterValue('p_service')));
            $paramList->AddParameter(new ACF_DirectParameter('data_id',$inParameterList->ParameterValue('p_instance')));
            $paramList->AddParameter(new ACF_DirectParameter('crid',$inParameterList->ParameterValue('crid')));
            $paramList->AddParameter(new ACF_DirectParameter('parentid',$inParameterList->ParameterValue('parentid')));
            $retEvent = new ACF_Event('executeservicecommand_fail_servicedetails');
            break;
        case 'services':
            $paramList->AddParameter(new ACF_DirectParameter('svc_id',$inParameterList->ParameterValue('svc_id')));
            $retEvent = new ACF_Event('executeservicecommand_fail_services');
            break;
        case 'currentrateinfo':
            $paramList->AddParameter(new ACF_DirectParameter('crid',$inParameterList->ParameterValue('crid')));
            $retEvent = new ACF_Event('executeservicecommand_fail_currentrateinfo');
            break;
        default:
            $retEvent = new ACF_Event('executeservicecommand_fail_bundles');
        }
    }

    $retEvent->SetParameterList($paramList);
    return $retEvent;
}

function AH_UpgradeBundle (ACF_ParameterList $inParameterList) {
    $changeResults = ChangeRate($_SESSION['piwi']['bundleupgrade']['crid'],$_SESSION['piwi']['bundleupgrade']['rgid'],$_SESSION['piwi']['bundleupgrade']['freq'],$_SESSION['piwi']['custid']);

    if($changeResults['success']) {
        $paramList = new ACF_ParameterList;
        $paramList->AddParameter(new ACF_DirectParameter('returnmsg','Rate successfully upgraded'));
        $retEvent = new ACF_Event('upgradebundle_success');
        $retEvent->SetParameterList($paramList);
        return $retEvent;
    } else {
        $paramList = new ACF_ParameterList;
        $paramList->AddParameter(new ACF_DirectParameter('error',$changeResults['error']));
        $retEvent = new ACF_Event('upgradebundle_fail');
        $retEvent->SetParameterList($paramList);
        return $retEvent;
    }
}

function AH_SetBundleUpgrade (ACF_ParameterList $inParameterList) {
    $_SESSION['piwi']['bundleupgrade']['crid'] = stripslashes_deep($inParameterList->ParameterValue('crid'));
    $_SESSION['piwi']['bundleupgrade']['bundleid'] = stripslashes_deep($inParameterList->ParameterValue('bundleid'));
    $_SESSION['piwi']['bundleupgrade']['rgid'] = substr($_SESSION['piwi']['bundleupgrade']['bundleid'],0,strpos($_SESSION['piwi']['bundleupgrade']['bundleid'],'X'));
    $_SESSION['piwi']['bundleupgrade']['freq'] = substr($_SESSION['piwi']['bundleupgrade']['bundleid'],strpos($_SESSION['piwi']['bundleupgrade']['bundleid'],'X')+1);


    if($_SESSION['piwi']['bundleupgrade']['crid'] && $_SESSION['piwi']['bundleupgrade']['bundleid']) {
        return new ACF_Event('setbundleupgrade_success');
    } else {
        return new ACF_Event('setbundleupgrade_fail');
    }
}

function AH_BuyBundle (ACF_ParameterList $inParameterList) {
    $crid = AddRate($_SESSION['piwi']['custid'],stripslashes_deep($inParameterList->ParameterValue('bundleid')));

    if($crid) {
        unset($_SESSION['optimization']['webrates']);
        return new ACF_Event('buybundle_success');
    } else {
        $paramList = new ACF_ParameterList();
        $paramList->AddParameter(new ACF_DirectParameter('error','Failed to add rate.'));
        $retEvent = new ACF_Event('buybundle_fail');
        $retEvent->SetParameterList($paramList);
        return $retEvent;
    }
}

function AH_SetInvoices (ACF_ParameterList $inParameterList) {
	unset($_SESSION['piwi']['payment']['ccdata']);
	unset($_SESSION['piwi']['payment']['invoiceList']);
	unset($_SESSION['piwi']['payment']['invoiceArray']);

    if(stripslashes_deep($inParameterList->ParameterValue('invoicelist'))) {
        $invoiceList = stripslashes_deep($inParameterList->ParameterValue('invoicelist'));

        if(isset($invoiceList) && is_array($invoiceList)) {
            $_SESSION['piwi']['payment']['invoiceArray'] = $invoiceList;
            $_SESSION['piwi']['payment']['invoiceList'] = implode(',',$invoiceList);
        }
        else {
            $_SESSION['piwi']['payment']['invoiceArray'] = "";
            $_SESSION['piwi']['payment']['invoiceList'] = "";
        }
    }

    if(!$_SESSION['piwi']['staffid'] && !$_SESSION['piwi']['payment']['invoiceList']) {
        $paramList = new ACF_ParameterList();
        $paramList->AddParameter(new ACF_DirectParameter('error',$error));
        $retEvent = new ACF_Event('setinvoices_fail');
        $retEvent->SetParameterList($paramList);
    } else {
        $retEvent = new ACF_Event('setinvoices_success');
    }

    return $retEvent;
}

function AH_SetPaymentType (ACF_ParameterList $inParameterList) {
    if($inParameterList->ParameterValue('paymenttype')) {
        $paymentTypeID = $inParameterList->ParameterValue('paymenttype');
        $paymentTypes = GetPaymentTypes();
        if(isset($paymentTypes) && is_array($paymentTypes)) {

            foreach($paymentTypes as $thisPaymentType) {
                if($thisPaymentType['p_id'] == $paymentTypeID) {
                    $_SESSION['piwi']['payment']['paymentType'] = $thisPaymentType;
                    return new ACF_Event('setpaymenttype_success');
                }
            }
        }
    } else {
    	if($_SESSION['piwi']['payment']['paymentType']) {
			$paramList = new ACF_ParameterList();
			$paramList->AddParameter(new ACF_DirectParameter('paymenttype',$_SESSION['piwi']['payment']['paymentType']));
			$retEvent = new ACF_Event('setpaymenttype_success');
			$retEvent->SetParameterList($paramList);
			return $retEvent;
    	}
    }

    $paramList = new ACF_ParameterList();
    $paramList->AddParameter(new ACF_DirectParameter('error','Error selecting payment type.'));
    $retEvent = new ACF_Event('setpaymenttype_fail');
    $retEvent->SetParameterList($paramList);
    return $retEvent;
}

function AH_SetCCInfo (ACF_ParameterList $inParameterList) {
    global $storeid;

    if(stripslashes_deep($inParameterList->ParameterValue('ccdata'))) {
        $ccdata       = stripslashes_deep($inParameterList->ParameterValue('ccdata'));
        $paymentTypes = GetPaymentTypes();
        if(isset($paymentTypes) && is_array($paymentTypes)) {
            foreach($paymentTypes as $thisPaymentType) {
                if($thisPaymentType['p_id'] == $ccdata['type']) {
                    $paymentType = $thisPaymentType;
                    break;
                }
            }
        }

        if(!$paymentType) {
            $paramList = new ACF_ParameterList;
            $paramList->AddParameter(new ACF_DirectParameter('error','Payment Type Not Set.'));

            $retEvent = new ACF_Event('setccinfo_fail');
            $retEvent->SetParameterList($paramList);

            return $retEvent;
        }

        switch($paymentType['p_type']) {
        case 'ACH':
            $_SESSION['piwi']['payment']['ccdata'] = $ccdata;
            break;
        case 'ECHECK':
            $storedecheckdata = array();

            $storedecheckdata['number'] = $_SESSION['modules']['shared']['custdata']['customer']['acctnumber'];
            $storedecheckdata['numberMasked'] = $_SESSION['modules']['shared']['custdata']['customer']['acctnumbermasked'];

            $prevecheckdata = $_SESSION['piwi']['payment']['ccdata'];

            if($ccdata['number'] == $prevecheckdata['numberMasked']) {
                $ccdata['number'] = $prevecheckdata['number'];
                $ccdata['numberMasked'] = $prevecheckdata['numberMasked'];
            } else {
                if($ccdata['number'] == $storedecheckdata['numberMasked']) {
					$ccdata['number']       = $storedecheckdata['number'];
					$ccdata['numberMasked'] = $storedecheckdata['numberMasked'];
                } else {
                	if(strlen($ccdata['number']) > 4) {
	                    $ccdata['numberMasked'] = str_repeat("*",strlen($ccdata['number'])-4).substr($ccdata['number'],strlen($ccdata['number'])-4);
	                }
                }
            }

            $_SESSION['piwi']['payment']['ccdata'] = $ccdata;

        	$echeckError = '';
			if($ccdata['number'] == '') {
				$echeckError .= 'Bank Account Number Not Set.  ';
			}
			if($ccdata['routenumber'] == '') {
				$echeckError .= 'Routing Number Not Set.  ';
			}
			if($ccdata['accttype'] == '') {
				$echeckError .= 'Bank Account Type Not Set.  ';
			}
			if($ccdata['name'] == '') {
				$echeckError .= 'Name On Account Not Set.  ';
			}

			if($echeckError != '') {
				$paramList = new ACF_ParameterList;
				$paramList->AddParameter(new ACF_DirectParameter('error',$echeckError));

				$retEvent = new ACF_Event('setccinfo_fail');
				$retEvent->SetParameterList($paramList);

				return $retEvent;
			}

            break;

        case 'CREDITCARD':
            $storedccdata = array();

            $storedccdata['number']             = $_SESSION['modules']['shared']['custdata']['customer']['ccnumber'];
            $storedccdata['numberMasked']       = $_SESSION['modules']['shared']['custdata']['customer']['creditcardmasked'];
            $prevccdata   = $_SESSION['piwi']['payment']['ccdata'];

            if($ccdata['number'] == $prevccdata['numberMasked']) {
                $ccdata['number']       = $prevccdata['number'];
                $ccdata['numberMasked'] = $prevccdata['numberMasked'];
            } else {
                if($ccdata['number'] == $storedccdata['numberMasked']) {
                    $ccdata['number']       = $storedccdata['number'];
                    $ccdata['numberMasked'] = $storedccdata['numberMasked'];
                } else {
                	if(strlen($ccdata['number']) > 4) {
	                    $ccdata['numberMasked'] = str_repeat("*",strlen($ccdata['number'])-4).substr($ccdata['number'],strlen($ccdata['number'])-4);
	                }
                }
            }
            $validateData = ValidateCard($paymentType['p_name'],$ccdata['number'],$ccdata['month'],$ccdata['year']);

        	$_SESSION['piwi']['payment']['ccdata'] = $ccdata;

			if($ccdata['name'] == '') {
				$validateData['success'] = false;
				$validateData['error'] .= 'Name on Card Not Set.  ';
			}

            if(!$ccdata['cvv2'] && strtoupper(GetWebOption('show_card_sec_code',$storeid)) == 'R') {
				$validateData['success'] = false;
				$validateData['error'] .= 'The Credit Card Validation Code is Required.  ';
			}

            if(!$validateData['success']) {
                $paramList = new ACF_ParameterList;
                $paramList->AddParameter(new ACF_DirectParameter('error',$validateData['error']));
                $retEvent = new ACF_Event('setccinfo_fail');
                $retEvent->SetParameterList($paramList);
                return $retEvent;
            }

            break;
        default:
            $_SESSION['piwi']['payment']['ccdata'] = $ccdata;
        }
    } else {
        if($_SESSION['piwi']['payment']['ccdata']) {
            unset($_SESSION['piwi']['payment']['ccdata']);
        }
    }

    if(!$_SESSION['piwi']['payment']['ccdata']) {
        $retEvent = new ACF_Event('setccinfo_fail');
    } else {
        if(!$_SESSION['piwi']['displaystaffpages']&& $_SESSION['piwi']['payment']['ccdata']['amount'] <= 0) {
            $paramList = new ACF_ParameterList;
            $paramList->AddParameter(new ACF_DirectParameter('error','Negative Payments are not allowed.  '));
            $retEvent = new ACF_Event('setccinfo_fail');
            $retEvent->SetParameterList($paramList);
            return $retEvent;
        } else {
            $retEvent = new ACF_Event('setccinfo_success');
        }
    }

    return $retEvent;
}

function AH_SubmitPayment (ACF_ParameterList $inParameterList) {
    global $storeid;

    $chargeSuccess = MakePayment($_SESSION['piwi']['custid'],$_SESSION['piwi']['payment']['ccdata']['amount'],$_SESSION['piwi']['payment']['invoiceList'],$_SESSION['piwi']['payment']['ccdata'],$storeid);

    if($chargeSuccess['success']) {
        unset($_SESSION['piwi']['payment']);
        return new ACF_Event('submitpayment_success');
    } else {
        $paramList = new ACF_ParameterList;
        $paramList->AddParameter(new ACF_DirectParameter('error',$chargeSuccess['errormsg']));
        $paramList->AddParameter(new ACF_DirectParameter('ccdata',$_SESSION['piwi']['payment']['ccdata']));
        $retEvent = new ACF_Event('submitpayment_fail');
        $retEvent->SetParameterList($paramList);
        return $retEvent;
    }
}

function AH_CancelPayment (ACF_ParameterList $inParameterList) {
    unset($_SESSION['piwi']['payment']);
    return new ACF_Event('cancelpayment_success');
}

function AH_ChangeCCInfo (ACF_ParameterList $inParameterList) {
    $ccdata = stripslashes_deep($inParameterList->ParameterValue('ccdata'));

    $custData = GetCustomerData($_SESSION['piwi']['custid']);

    if($custdata['creditcardmasked'] == $ccdata['number']) {
        $ccdata['number'] = $custdata['ccnumber'];
    }

    $_SESSION['piwi']['cvv2'] = $ccdata['cvv2'];

    $updateaddressResults = UpdateAddress($_SESSION['piwi']['custid'],'5',$ccdata['name'],$ccdata['addr1'],$ccdata['addr2'],$ccdata['city'],$ccdata['state'],$ccdata['zip'],$ccdata['country']);
    $updatebillingResults = UpdateBillingInfo($_SESSION['piwi']['custid'],$ccdata['type'],$ccdata['month'],$ccdata['year'],$ccdata['number'],$ccdata['name']);

    if($updateaddressResults['success'] && $updatebillingResults['success']) {
        $paramList = new ACF_ParameterList;
        $paramList->AddParameter(new ACF_DirectParameter('bundleid',$_SESSION['piwi']['bundleSelected']));
        $retEvent = new ACF_Event('changeccinfo_success');
        $retEvent->SetParameterList($paramList);
        return $retEvent;
    } else {
        return new ACF_Event('changeccinfo_fail');
    }
}

function AH_BuyBundleRedirect (ACF_ParameterList $inParameterList) {
    global $storeid;
    $bundleid = $inParameterList->ParameterValue('bundleid');

    if($bundleid) {
        $rgid = substr($bundleid,0,strpos($bundleid,'X'));
        $freq = substr($bundleid,strpos($bundleid,'X')+1);
    }

    $ratetoAdd = GetSingleRate($storeid,$_SESSION['piwi']['custid'],$rgid,$freq);

    $URL = $_SESSION['piwi']['options']['ccs-url'];

    $_SESSION['piwi']['bundleSelected'] = $bundleid;

    $_SESSION['ccs']['bundled'] = true;

    if($_SESSION['piwi']['bundleSelected']) {
        if($ratetoAdd['svc_ccs_service'] && $_SESSION['ccs']['options']['enabled']) { // rate is ccs bundle AND ccs is in place
            $bundleData = GetAvailableWebRates($storeid,$_SESSION['piwi']['custid'],false);

            if(isset($bundleData) && is_array($bundleData)) {
                foreach($bundleData as $thisBundle) {
                    if($thisBundle['rg_id'].'X'.$thisBundle['r_frequency'] == $_SESSION['piwi']['bundleSelected']) {
                        $bundle = $ratetoAdd;
                        break;
                    }
                }
            }

            SetPriceList($bundle['rg_id']);

            $_SESSION['piwi']['serviceid'] = $bundle['rg_ccs_svc_id'];

            $_SESSION['modules']['billing']['custid'] = $_SESSION['piwi']['custid'];
            $_SESSION['modules']['billing']['usertype'] = 'EXISTING';

            $_SESSION['modules']['shared']['domain'] = $_SESSION['piwi']['OpenSRSProfile']['domain'];
            $_SESSION['modules']['shared']['username'] = $_SESSION['piwi']['OpenSRSProfile']['username'];
            $_SESSION['modules']['shared']['password'] = $_SESSION['piwi']['OpenSRSProfile']['password'];

            switch($bundle['svc_ccs_service']) {
            case 'domain':
                $passedVariable = 'register_period';
                break;
            case 'blogware':
                $passedVariable = 'blog_package';
                break;
            }

            $_SESSION['modules']['billing']['bundle'] = $bundle;
            $serviceHeader = GetCCSServiceDetails($bundle['rg_id']);
            $fieldData = GetServiceFields($bundle['rg_ccs_svc_id'],$bundle['rg_id'],false,$serviceHeader['serviceData']['rs_id'],$serviceHeader['serviceData']['rs_parent_instance'],$serviceHeader['serviceData']['rs_parent_service'],$_SESSION['piwi']['custid']);

            if(isset($fieldData) && is_array($fieldData)) {
                foreach($fieldData as $thisField) {
                    if(!isset($thisField['template_dflt'])) {
                        $error = "No Service Template assigned to this Rate";
                        break;
                    } else {
                        switch($bundle['svc_ccs_service']) {
                            case 'domain':
                                if ($thisField['datacol'] == 'register_period') {
                                    $_SESSION['modules']['domain']['passed']['register_period'] = $thisField['template_dflt'];
                                }
                                break;

                            case 'blogware':
                                if($thisField['datacol'] == 'blog_package') {
                                    if($thisField['template_dflt'] != 'NULL' && $thisField['template_dflt'] != '') {
                                        $_SESSION['modules']['blogware']['package'] = strtolower($thisField['template_dflt']);
                                        $_SESSION['modules']['blogware']['trial']   = $thisField['template_dflt'] == 'Trial' ? true : false;
                                    } else {
                                        $error = "No Default Value set on Service Template assigned to this Rate";
                                    }
                                }
                                break;
                        }
                    }
                }

                if($error && $bundle['svc_ccs_service'] == 'blogware') {
                    $paramList = new ACF_ParameterList();
                    $paramList->AddParameter(new ACF_DirectParameter('error',"Blogware Signup is not currently available\nERROR: ".$error));
                    $retEvent = new ACF_Event('buybundleredirect_blogfail');
                    $retEvent->SetParameterList($paramList);
                    return $retEvent;
                }
            } else {
                if($bundle['svc_ccs_service'] == 'blogware') {
                    $paramList = new ACF_ParameterList();
                    $paramList->AddParameter(new ACF_DirectParameter('error',"Blogware Signup is not currently available\nERROR: ".$fieldData));
                    $retEvent = new ACF_Event('buybundleredirect_blogfail');
                    $retEvent->SetParameterList($paramList);
                    return $retEvent;
                }
            }

            if($bundle['svc_ccs_service'] != 'blogware') {
                if(is_array($_SESSION['ccs']['excludeSteps'])) {
                    array_push($_SESSION['ccs']['excludeSteps'],'user');
                } else {
                    $_SESSION['ccs']['excludeSteps'] = array('user');
                }
            }

            if($_SESSION['modules']['billing']['bundle']['rg_fixed_price'] <= 0 && $_SESSION['modules']['billing']['bundle']['rg_one_time_fees'] <= 0) {
                if(is_array($_SESSION['ccs']['excludeSteps'])) {
                    array_push($_SESSION['ccs']['excludeSteps'],'payment');
                } else {
                    $_SESSION['ccs']['excludeSteps'] = array('payment');
                }
            }

            unset($_SESSION['optimization']['webrates'][$_SESSION['piwi']['custid']]);
            $returnURL = $URL."/checkserviceavailability?servicetype=".$bundle['svc_ccs_service'];
            header("location:".$returnURL);
            $retEvent = new ACF_Event('buybundleredirect_selected');
            return $retEvent;
        } else {
            $crid = AddRate($_SESSION['piwi']['custid'],$rgid,$freq);

            if($crid) {
                unset($_SESSION['optimization']['webrates']);

				$returnmsg = 'Rate "' . $ratetoAdd['rg_name'] . ' - ' .$ratetoAdd['r_frequency']. ' month' . ($ratetoAdd['r_frequency'] > 1 ? 's' : '') . '" added successfully';

                $paramList = new ACF_ParameterList();
                $paramList->AddParameter(new ACF_DirectParameter('returnmsg',$returnmsg));
                $retEvent = new ACF_Event('buybundleredirect_platadd_success');
                $retEvent->SetParameterList($paramList);
                return $retEvent;
            } else {
                $paramList = new ACF_ParameterList();
                $paramList->AddParameter(new ACF_DirectParameter('error','Failed to add Rate.'));
                $retEvent = new ACF_Event('buybundleredirect_fail');
                $retEvent->SetParameterList($paramList);
                return $retEvent;
            }
        }
    } else {
        return new ACF_Event('buybundleredirect_showall');
    }
}

function AH_UpgradeBundleRedirect (ACF_ParameterList $inParameterList) {
    unset($_SESSION['piwi']['bundleupgradeData']);

    $_SESSION['piwi']['cridSelected'] = stripslashes_deep($inParameterList->ParameterValue('crid'));

    if($_SESSION['piwi']['cridSelected']) {
        $paramList = new ACF_ParameterList();
        $paramList->AddParameter(new ACF_DirectParameter('crid',$_SESSION['piwi']['cridSelected']));
        $retEvent = new ACF_Event('upgradebundleredirect_selected');
        $retEvent->SetParameterList($paramList);
        return $retEvent;
    } else {
        return new ACF_Event('upgradebundleredirect_showall');
    }
}

function AH_GetDomainPrices (ACF_ParameterList $inParameterList) {
    $allPrices = GetAllPrices($inParameterList->ParameterValue('rgid'));

    $priceArray = array();
    $allowedTLDsByRate = array();
    $tldList = $_SESSION['ccs']['options']['driver-options']['service-modules']['domain']['service-options']['related-tld-groups'];

    if(isset($allPrices) && is_array($allPrices)) {
        foreach($allPrices as $thisPrice) {
            if(!in_array('.'.strtolower($thisPrice['service_subtype']),$allowedTLDsByRate)) {
                array_push($allowedTLDsByRate,'.'.strtolower($thisPrice['service_subtype']));
            }

            switch($thisPrice['transaction_type']) {
            case "Register":
                $type = "new";
                break;
            default:
                $type = strtolower($thisPrice['transaction_type']);
            }
            $type = 'period-pricing-'.$type;

            $tld = ".".strtolower($thisPrice['service_subtype']);
            $year = $thisPrice['period'];

            if(!$priceArray[$tld]) {
                $priceArray[$tld] = array();
            }
            if(!$priceArray[$tld][$type]) {
                $priceArray[$tld][$type] = array();
            }
            $priceArray[$tld][$type][$year-1] = $thisPrice['price'];
        }

        if(isset($_SESSION['ccs']['options']['driver-options']['service-modules']['domain']['service-options']['service-offering-list']['service-offering']) && is_array($_SESSION['ccs']['options']['driver-options']['service-modules']['domain']['service-options']['service-offering-list']['service-offering'])) {
            foreach($_SESSION['ccs']['options']['driver-options']['service-modules']['domain']['service-options']['service-offering-list']['service-offering'] as &$thisTLD) {
                $thisTLD['price']['period-pricing-new'] = $priceArray[$thisTLD['tld']]['period-pricing-new'];
                $thisTLD['price']['period-pricing-renew'] = $priceArray[$thisTLD['tld']]['period-pricing-renew'];
                $thisTLD['price']['period-pricing-transfer'] = $priceArray[$thisTLD['tld']]['period-pricing-transfer'];
            }
        }
    }

    if(isset($tldList['group']) && is_array($tldList['group'])) {
        foreach($tldList['group'] as $tldGroupKey=>$tldGroup) {
            if(isset($tldGroup['tld']) && is_array($tldGroup['tld'])) { // more than one TLD in this group
                foreach($tldGroup['tld'] as $thisTLDKey=>$thisTLDName) {
                    if(!in_array($thisTLDName,$allowedTLDsByRate) && $thisTLDName != 'default') {
                        unset($tldList['group'][$tldGroupKey]['tld'][$thisTLDKey]);
                    }
                }
            } else {
                if(!in_array($tldGroup['tld'],$allowedTLDsByRate)) {
                    unset($tldList['group'][$tldGroupKey]);
                }
            }
        }
    }

    $_SESSION['ccs']['tldGroups'] = $tldList;
    return new ACF_Event('getdomainprices_done');
}

function AH_CheckUsageDate (ACF_ParameterList $inParameterList) {
    $startdate = $inParameterList->ParameterValue('startdate');
    $enddate   = $inParameterList->ParameterValue('enddate');

    if($startdate || $enddate) {
        $startArray = $startdate ? explode('/',$startdate) : false;
        $endArray   = $enddate   ? explode('/',$enddate)   : false;

        switch($_SESSION['piwi']['dateformat']) {
        case "YMD":
            $startGood = is_array($startArray) ? checkdate($startArray[1],$startArray[2],$startArray[0]) : false;
            if($startGood)
                $startstamp = mktime(0,0,0,$startArray[1],$startArray[2],$startArray[0]);
            $endGood = is_array($endArray) ? checkdate($endArray[1],$endArray[2],$endArray[0]) : false;
            if($endGood)
                $endstamp = mktime(0,0,0,$endArray[1],$endArray[2],$endArray[0]);
            break;
        case "DMY":
            $startGood = is_array($startArray) ? checkdate($startArray[1],$startArray[0],$startArray[2]) : false;
            if($startGood)
                $startstamp = mktime(0,0,0,$startArray[1],$startArray[0],$startArray[2]);
            $endGood = is_array($endArray) ? checkdate($endArray[1],$endArray[0],$endArray[2]) : false;
            if($endGood)
                $endstamp = mktime(0,0,0,$endArray[1],$endArray[0],$endArray[2]);
            break;
        case "MDY":
            $startGood = is_array($startArray) ? checkdate($startArray[0],$startArray[1],$startArray[2]) : false;
            if($startGood)
                $startstamp = mktime(0,0,0,$startArray[0],$startArray[1],$startArray[2]);
            $endGood = is_array($endArray) ? checkdate($endArray[0],$endArray[1],$endArray[2]) : false;
            if($endGood)
                $endstamp = mktime(0,0,0,$endArray[0],$endArray[1],$endArray[2]);
            break;
        }

        if($startGood && $endGood) {
            if($startstamp > $endstamp) {
                $paramList = new ACF_ParameterList();
                $paramList->AddParameter(new ACF_DirectParameter('startdate',$startdate));
                $paramList->AddParameter(new ACF_DirectParameter('enddate',$enddate));
                $paramList->AddParameter(new ACF_DirectParameter('error',"The Start Date should come before the End Date."));
                $retEvent = new ACF_Event('checkusagedate_fail');
                $retEvent->SetParameterList($paramList);
                return $retEvent;
            } else {
                $paramList = new ACF_ParameterList();
                $paramList->AddParameter(new ACF_DirectParameter('startdate',$startdate));
                $paramList->AddParameter(new ACF_DirectParameter('enddate',$enddate));
                $retEvent = new ACF_Event('checkusagedate_success');
                $retEvent->SetParameterList($paramList);
                return $retEvent;
            }
        } else {
            if(!$startGood && !$endGood) {
                $error = "The Start Date and the End Date are invalid.";
            } else {
                if($endGood) {
                    $error = "The Start Date is invalid.";
                } else {
                    $error = "The End Date is invalid.";
                }
            }

            $paramList = new ACF_ParameterList();
            $paramList->AddParameter(new ACF_DirectParameter('startdate',$startdate));
            $paramList->AddParameter(new ACF_DirectParameter('enddate',$enddate));
            $paramList->AddParameter(new ACF_DirectParameter('error',$error));
            $retEvent = new ACF_Event('checkusagedate_fail');
            $retEvent->SetParameterList($paramList);
            return $retEvent;
        }
    } else {
        return new ACF_Event('checkusagedate_success');
    }
}

function AH_SetReportCategory (ACF_ParameterList $inParameterList) {
    $_SESSION['piwi']['reports']['category'] = stripslashes_deep($inParameterList->ParameterValue('category'));
    $_SESSION['piwi']['reports']['reportlist'] = GetReports($_SESSION['piwi']['reports']['category']);
    return new ACF_Event('setreportcategory_success');
}

function AH_SetReport (ACF_ParameterList $inParameterList) {
    $_SESSION['piwi']['reports']['id'] = stripslashes_deep($inParameterList->ParameterValue('id'));
    return new ACF_Event('setreport_success');
}

function AH_CCSServiceCheck (ACF_ParameterList $inParameterList) {
    $_SESSION['piwi']['newservice']['crid'] = stripslashes_deep($inParameterList->ParameterValue('crid'));
    $_SESSION['piwi']['newservice']['servicetype'] = stripslashes_deep($inParameterList->ParameterValue('servicetype'));
    $_SESSION['piwi']['newservice']['svc_id'] = stripslashes_deep($inParameterList->ParameterValue('svc_id'));
    $_SESSION['piwi']['newservice']['branch'] = stripslashes_deep($inParameterList->ParameterValue('branch'));
    $_SESSION['piwi']['newservice']['p_service'] = stripslashes_deep($inParameterList->ParameterValue('p_service'));
    $_SESSION['piwi']['newservice']['p_instance'] = stripslashes_deep($inParameterList->ParameterValue('p_instance'));

    $rgidInfo = ExecuteSQL("select rgid,freq=cr_frequency from custrate where crid = ".SQLTrim($_SESSION['piwi']['newservice']['crid']));

    if($rgidInfo['success'] && is_array($rgidInfo['sqlreturn'])) {
        $_SESSION['piwi']['newservice']['rgid'] = $rgidInfo['sqlreturn'][0]['rgid'];
        $_SESSION['piwi']['newservice']['freq'] = $rgidInfo['sqlreturn'][0]['freq'];
    }

    if(stripslashes_deep($inParameterList->ParameterValue('data_id')))
        $_SESSION['piwi']['newservice']['data_id'] = stripslashes_deep($inParameterList->ParameterValue('data_id'));
    else
        $_SESSION['piwi']['newservice']['data_id'] = false;

    $paramList = new ACF_ParameterList();
    $paramList->AddParameter(new ACF_DirectParameter('action',stripslashes_deep($inParameterList->ParameterValue('action'))));

    if(stripslashes_deep($inParameterList->ParameterValue('ccsservice') == 'true')) {
        $retEvent = new ACF_Event('ccsservicecheck_ccs');
    } else {
        $retEvent = new ACF_Event('ccsservicecheck_plat');
    }

    $retEvent->SetParameterList($paramList);
    return $retEvent;
}

function AH_PlatServiceAction (ACF_ParameterList $inParameterList) {
    switch(stripslashes_deep($inParameterList->ParameterValue('action'))) {
    case 'add':
        return new ACF_Event('addplatservice');
        break;
    case 'manage':
        return new ACF_Event('manageplatservice');
        break;
    }
}

function AH_AddService (ACF_ParameterList $inParameterList) {
// remove fields passed in not used in actual service array
    $serviceFields = $inParameterList->ParameterValue('service');
    unset($serviceFields['crid']);
    unset($serviceFields['d_custid']);
    unset($serviceFields['d_storeid']);
    unset($serviceFields['d_struct_id']);
    unset($serviceFields['d_parent_id']);
    unset($serviceFields['d_parent_type']);

    if(isset($serviceFields) && is_array($serviceFields)) {
        $emptyFieldArray = array();

        foreach($serviceFields as &$thisField) {
            if($thisField['type'] == 'chk_checkbox') {
                $thisField['value'] = $thisField['value'] ? 1 : 0;
            }

            if($thisField['required'] === '1' && trim($thisField['value']) === '') { // required field not set!
                array_push($emptyFieldArray,$thisField['name']);
            }
        }
    }

    if(count($emptyFieldArray) > 0) {
        $returnfields = array();
        foreach($serviceFields as $thisFieldName=>$thisFieldData) {
            if($thisFieldData['value']) {
                $returnfields[$thisFieldName] = $thisFieldData['value'];
            }
        }

        $paramList = new ACF_ParameterList();
        $paramList->AddParameter(new ACF_DirectParameter('error','The following Required fields have not been set: ' . implode(',',$emptyFieldArray)));
        $paramList->AddParameter(new ACF_DirectParameter('returnfields',$returnfields));
        $retEvent = new ACF_Event('addservice_fail');
            $retEvent->SetParameterList($paramList);
            return $retEvent;
    }

    if(!$serviceFields['d_active'] && !$_SESSION['piwi']['staffid']) { // set active to Y for all services made by customers
        $serviceFields['d_active'] = array('name'=>'Yes','type'=>'dropdown','value'=>'Y','required'=>false);
    }

    $addServiceResults = AddService($_SESSION['piwi']['newservice']['crid'],$_SESSION['piwi']['custid'],$_SESSION['piwi']['newservice']['svc_id'],$serviceFields,$_SESSION['piwi']['newservice']['branch'],$_SESSION['piwi']['newservice']['p_instance'],$_SESSION['piwi']['newservice']['p_service']);

    if($addServiceResults['success']) {
        $paramList = new ACF_ParameterList();
        $paramList->AddParameter(new ACF_DirectParameter('crid',$_SESSION['piwi']['newservice']['crid']));
        $retEvent = new ACF_Event('addservice_success');
        $retEvent->SetParameterList($paramList);
        return $retEvent;
    } else {
        foreach($serviceFields as $thisFieldName=>$thisFieldData) {
            if($thisFieldData['value']) {
                $returnfields[$thisFieldName] = $thisFieldData['value'];
            }
        }

        $paramList = new ACF_ParameterList();
        $paramList->AddParameter(new ACF_DirectParameter('error',$addServiceResults['error']));
        $paramList->AddParameter(new ACF_DirectParameter('returnfields',$returnfields));
        $retEvent = new ACF_Event('addservice_fail');
        $retEvent->SetParameterList($paramList);
        return $retEvent;
    }
}

function AH_UpdatePlatService (ACF_ParameterList $inParameterList) {
// remove fields passed in not used in actual service array
    $serviceFields = $inParameterList->ParameterValue('service');
    unset($serviceFields['data_id']);
    unset($serviceFields['crid']);
    unset($serviceFields['d_custid']);
    unset($serviceFields['d_storeid']);
    unset($serviceFields['d_struct_id']);
    unset($serviceFields['d_parent_id']);
    unset($serviceFields['d_parent_type']);
    if(isset($serviceFields) && is_array($serviceFields)) {
        $emptyFieldArray = array();
        foreach($serviceFields as &$thisField) {
            if($thisField['type'] == 'chk_checkbox') {
                $thisField['value'] = $thisField['value'] ? 1 : 0;
            }
            if($thisField['required'] === '1' && trim($thisField['value']) === '') { // required field not set!
                array_push($emptyFieldArray,$thisField['name']);
            }
        }
    }

    if(count($emptyFieldArray) > 0) {
        foreach($serviceFields as $thisFieldName=>$thisFieldData) {
            if($thisFieldData['value']) {
                $returnfields[$thisFieldName] = $thisFieldData['value'];
            }
        }

        $paramList = new ACF_ParameterList();
        $paramList->AddParameter(new ACF_DirectParameter('error','The following Required fields have not been set: ' . implode(',',$emptyFieldArray)));
        $paramList->AddParameter(new ACF_DirectParameter('returnfields',$returnfields));
        $retEvent = new ACF_Event('updateplatservice_fail');
            $retEvent->SetParameterList($paramList);
            return $retEvent;
    }

    $updateServiceResults = UpdateService($_SESSION['piwi']['custid'],$_SESSION['piwi']['newservice']['svc_id'],$_SESSION['piwi']['newservice']['data_id'],$serviceFields,$_SESSION['piwi']['newservice']['branch'],$_SESSION['piwi']['newservice']['p_instance'],$_SESSION['piwi']['newservice']['p_service']);

    if($updateServiceResults['success']) {
        return new ACF_Event('updateplatservice_success');
    } else {
        foreach($serviceFields as $thisFieldName=>$thisFieldData) {
            if($thisFieldData['value']) {
                $returnfields[$thisFieldName] = $thisFieldData['value'];
            }
        }

        $paramList = new ACF_ParameterList();
        $paramList->AddParameter(new ACF_DirectParameter('error',$updateServiceResults['error']));
        $paramList->AddParameter(new ACF_DirectParameter('returnfields',$returnfields));
        $retEvent = new ACF_Event('updateplatservice_fail');
        $retEvent->SetParameterList($paramList);
        return $retEvent;
    }
}

function AH_DeleteService (ACF_ParameterList $inParameterList) {
    $deleteResult = DeleteService($inParameterList->ParameterValue('service'));

    if($deleteResult['success']) {
        return new ACF_Event('deleteservice_success');
    } else {
        $paramList = new ACF_ParameterList();
        $paramList->AddParameter(new ACF_DirectParameter('error',$deleteResult['error']));
        $retEvent = new ACF_Event('deleteservice_fail');
        $retEvent->SetParameterList($paramList);
        return $retEvent;
    }
}


function AH_ParentServiceCheck(ACF_ParameterList $inParameterList) {
    if($_SESSION['piwi']['parentService']) {
        $paramList = new ACF_ParameterList();
        $paramList->AddParameter(new ACF_DirectParameter('svc_id',$_SESSION['piwi']['parentService']['current']['rs_svc_id']));
        $paramList->AddParameter(new ACF_DirectParameter('data_id',$_SESSION['piwi']['parentService']['current']['detail']['s_num']));
        $retEvent = new ACF_Event('parentservice_found');
        $retEvent->SetParameterList($paramList);
        return $retEvent;
    } else {
        return new ACF_Event('parentservice_notfound');
    }
}

//---- function to hop to the Helpdesk project
function AH_JumpToHelpdesk(ACF_ParameterList $inParameterList){
    $username = '';
    $password = '';
    $_SESSION['piwi']['currentSection'] = 'tickets';
    if (isset($_SESSION['piwi']['staffid']) && $_SESSION['helpdesk']['options']['staffEnabled']){
        $info = ExecuteSQL("select username = name, password from staff where num = " . $_SESSION['piwi']['staffid']);
        $_SESSION['helpdesk']['passed']['customer'] = false;
    }else{
        $info = ExecuteSQL("select username, password from customer where id = " . $_SESSION['piwi']['custid']);
        $_SESSION['helpdesk']['passed']['customer'] = true;
    }
    if($info['success'] && is_array($info['sqlreturn'])){
        $username = $info['sqlreturn'][0]['username'];
        $password = $info['sqlreturn'][0]['password'];
    }
    $_SESSION['helpdesk']['passed']['username']   = $username;
    $_SESSION['helpdesk']['passed']['password']   = $password;
    $_SESSION['helpdesk']['passed']['customerid'] = $_SESSION['piwi']['custid'];
    header("location:" . $_SESSION['helpdesk']['options']['driver-options']['url'] . "/autologin");
    return new ACF_Event('jumptohelpdesk_success');
}


function AH_JumpToCCS (ACF_ParameterList $inParameterList) {
    global $storeid;

    $URL = $_SESSION['piwi']['options']['ccs-url'];
    $_SESSION['ccs']['bundled'] = true;

    $_SESSION['modules']['billing']['custid'] = $_SESSION['piwi']['custid'];
    $_SESSION['modules']['billing']['usertype'] = 'EXISTING';
//    $_SESSION['modules']['billing']['OpenSRSProfile'] = $_SESSION['piwi']['OpenSRSProfile'];
    $_SESSION['modules']['billing']['bundle'] = GetSingleBundle($storeid,$_SESSION['piwi']['custid'],$_SESSION['piwi']['newservice']['crid']);

    if(!$_SESSION['modules']['billing']['bundle']['svc_ccs_service'] && $_SESSION['piwi']['newservice']['servicetype']) {
        $_SESSION['modules']['billing']['bundle']['svc_ccs_service'] = $_SESSION['piwi']['newservice']['servicetype'];
    }

    SetPriceList($_SESSION['modules']['billing']['bundle']['rg_id']);

    $action = stripslashes_deep($inParameterList->ParameterValue('action'));

    $_SESSION['piwi']['serviceid'] = $_SESSION['piwi']['newservice']['svc_id'];

    if($action == 'add') {
        $serviceTree = GetServiceTree($_SESSION['modules']['billing']['bundle']['rg_id'],$_SESSION['piwi']['custid']);
        if(isset($serviceTree) && is_array($serviceTree)) {
            foreach($serviceTree as $thisServiceStruct) {
                if(strtolower($_SESSION['modules']['billing']['bundle']['svc_ccs_service']) == strtolower($thisServiceStruct['rs_ccs_service']) && $_SESSION['modules']['billing']['bundle']['crid'] == $thisServiceStruct['rs_cr_id'] && $_SESSION['piwi']['newservice']['branch'] == $thisServiceStruct['rs_id'] && $_SESSION['piwi']['newservice']['p_service'] == $thisServiceStruct['rs_parent_service'] && $_SESSION['piwi']['newservice']['p_instance'] == $thisServiceStruct['rs_parent_instance']) {
                    $_SESSION['modules']['billing']['bundle']['structdata'] = $thisServiceStruct;
                    break;
                }
            }
        }

        $_SESSION['piwi']['servicetype'] = $_SESSION['piwi']['newservice']['servicetype'];
        $_SESSION['piwi']['currentCRID'] = $_SESSION['piwi']['newservice']['crid'];

        if($_SESSION['piwi']['OpenSRSProfile']) {
            $_SESSION['modules']['billing']['OpenSRSProfile'] = $_SESSION['piwi']['OpenSRSProfile'];
            $_SESSION['modules']['shared']['domain'] = $_SESSION['piwi']['OpenSRSProfile']['domain'];
            $_SESSION['modules']['shared']['username'] = $_SESSION['piwi']['OpenSRSProfile']['username'];
            $_SESSION['modules']['shared']['password'] = $_SESSION['piwi']['OpenSRSProfile']['password'];
        } else {
            $_SESSION['modules']['billing']['randomProfile'] = GenerateProfile();
            $_SESSION['modules']['shared']['domain'] = false;
            $_SESSION['modules']['shared']['username'] = $_SESSION['modules']['billing']['randomProfile']['username'];
            $_SESSION['modules']['shared']['password'] = $_SESSION['modules']['billing']['randomProfile']['password'];
        }

        switch($_SESSION['piwi']['servicetype']) {
            case 'domain':
                $passedVariable = 'register_period';
                break;
            case 'blogware':
                $passedVariable = 'blog_package';
                break;
        }

        $fieldData = GetServiceFields($_SESSION['piwi']['newservice']['svc_id'],$_SESSION['modules']['billing']['bundle']['rg_id'],$_SESSION['piwi']['newservice']['crid'],$_SESSION['piwi']['newservice']['branch'],$_SESSION['piwi']['newservice']['p_instance'],$_SESSION['piwi']['newservice']['p_service'],$_SESSION['piwi']['custid']);
        if(isset($fieldData) && is_array($fieldData)) {
            foreach($fieldData as $thisField) {
                if(!isset($thisField['template_dflt'])) {
                    $error = "No Service Template assigned to this Rate";
                    break;
                } else {
                    switch($_SESSION['modules']['billing']['bundle']['svc_ccs_service']) {
                    case 'domain':
                        if ($thisField['datacol'] == 'register_period' && !$_SESSION['modules']['domain']['passed']['register_period']) {
                            $_SESSION['modules']['domain']['passed']['register_period'] = $thisField['template_dflt'];
                        }
                        break;

                    case 'blogware':
                        if($thisField['datacol'] == 'blog_package') {
                            if($thisField['template_dflt'] != 'NULL' && $thisField['template_dflt'] != '') {
                                $_SESSION['modules']['blogware']['package'] = strtolower($thisField['template_dflt']);
                                $_SESSION['modules']['blogware']['trial']   = $thisField['template_dflt'] == 'Trial' ? true : false;
                            } else {
                                $error = "No Default Value set on Service Template assigned to this Rate";
                            }
                        }
                        break;
                    }
                }
            }

            if($error && $_SESSION['modules']['billing']['bundle']['svc_ccs_service'] == 'blogware') {
                $paramList = new ACF_ParameterList();
                $paramList->AddParameter(new ACF_DirectParameter('error',"Blogware Signup is not currently available\nERROR: ".$error));
                $retEvent = new ACF_Event('jumptoccs_fail');
                $retEvent->SetParameterList($paramList);
                return $retEvent;
            }
        } else {
            if($_SESSION['modules']['billing']['bundle']['svc_ccs_service'] == 'blogware') {
                $paramList = new ACF_ParameterList();
                $paramList->AddParameter(new ACF_DirectParameter('error',"Blogware Signup is not currently available\nERROR: ".$fieldData));
                $retEvent = new ACF_Event('jumptoccs_fail');
                $retEvent->SetParameterList($paramList);
                return $retEvent;
            }
        }


        if($_SESSION['modules']['billing']['bundle']['svc_ccs_service'] == 'domain') {
            $servicecount = GetServiceHeader($_SESSION['piwi']['custid'],$_SESSION['piwi']['currentCRID']);
            if(isset($servicecount) && is_array($servicecount)) {
                foreach($servicecount as $thisService) {
                    if($thisService['svc_id'] == $_SESSION['modules']['billing']['bundle']['rg_ccs_svc_id']) {
                        $_SESSION['piwi']['firstService'] = $thisService['used'] ? false : true;
                        break;
                    }
                }
            } else {
                $_SESSION['piwi']['firstService'] = true;
            }

            if($_SESSION['piwi']['firstService']) {
                $_SESSION['ccs']['excludeSteps'] = array('user');
            } else {
                $_SESSION['ccs']['excludeSteps'] = array('user','payment');
            }
        }

        if($_SESSION['modules']['billing']['bundle']['svc_ccs_service'] == 'blogware') {
            $_SESSION['ccs']['excludeSteps'] = array('payment');
        }

        $returnURL = $URL."/checkserviceavailability?servicetype=".$_SESSION['piwi']['servicetype'];
    }

    if($action == 'manage') {
        $serviceArray = GetSingleService($_SESSION['piwi']['custid'],$_SESSION['piwi']['newservice']['svc_id'],$_SESSION['piwi']['newservice']['data_id']);
        $_SESSION['modules']['domain']['passed']['domain']   = $serviceArray['s_data'];
        $_SESSION['modules']['domain']['passed']['target']   = 'details';
        if($_SESSION['piwi']['OpenSRSProfile']['username'] && $_SESSION['piwi']['OpenSRSProfile']['password']) {
        $_SESSION['modules']['billing']['OpenSRSProfile'] = $_SESSION['piwi']['OpenSRSProfile'];
            $_SESSION['modules']['domain']['passed']['username'] = $_SESSION['piwi']['OpenSRSProfile']['username'];
            $_SESSION['modules']['domain']['passed']['password'] = $_SESSION['piwi']['OpenSRSProfile']['password'];
        } else {
            $paramList = new ACF_ParameterList();
            $paramList->AddParameter(new ACF_DirectParameter('error',"Domain Management is not currently available\nERROR: Invalid OpenSRS Profile for domain ".$serviceArray['s_data'].'.'));
            $retEvent = new ACF_Event('jumptoccs_fail');
            $retEvent->SetParameterList($paramList);
            return $retEvent;
        }
        $returnURL = $URL."/manageaction?servicetype=domain";
    }
    header("location:".$returnURL);
    return new ACF_Event('jumptoccs_success');
}

function AH_ChangeStatus (ACF_ParameterList $inParameterList) {
    $changeResults = ChangeStatus($_SESSION['piwi']['custid'],stripslashes_deep($inParameterList->ParameterValue('newstatus')),stripslashes_deep($inParameterList->ParameterValue('reason')) ? stripslashes_deep($inParameterList->ParameterValue('reason')) : '');

    if($changeResults['success']) {
// unset the customer data cache so that the new active status will be reflected upon reload
        unset($_SESSION['piwi']['custinfo'][$_SESSION['piwi']['custid']]);
        return new ACF_Event('changestatus_success');
    } else {
        $paramList = new ACF_ParameterList();
        $paramList->AddParameter(new ACF_DirectParameter('error',$changeResults['error']));
        $retEvent = new ACF_Event('changestatus_fail');
        $retEvent->SetParameterList($paramList);
        return $retEvent;
    }
}

function AH_UpdateNote (ACF_ParameterList $inParameterList) {
    $noteid     = $inParameterList->ParameterValue('noteid');
    $status     = $inParameterList->ParameterValue('status');
    $resolution = $inParameterList->ParameterValue('resolution');
    $updateResults = UpdateNote($noteid,$resolution,$status,$_SESSION['piwi']['staffid']);

    $paramList = new ACF_ParameterList();
    $paramList->AddParameter(new ACF_DirectParameter('noteid',$noteid));

    if($updateResults['success']) {
        $retEvent = new ACF_Event('updatenote_success');
    } else {
        $paramList->AddParameter(new ACF_DirectParameter('error',$updateResults['error']));
        $retEvent = new ACF_Event('updatenote_fail');
    }

    $retEvent->SetParameterList($paramList);
    return $retEvent;
}

function AH_AddNote (ACF_ParameterList $inParameterList) {
    if($_SESSION['piwi']['custid'])
        $custid = $_SESSION['piwi']['custid'];
    else
        $custid = $inParameterList->ParameterValue('custid');

    $status    = $inParameterList->ParameterValue('status');
    $staffasgn = $inParameterList->ParameterValue('staffasgn');
    $priority  = $inParameterList->ParameterValue('priority');
    $notetext  = $inParameterList->ParameterValue('notetext');
    $sendemail = $inParameterList->ParameterValue('sendemail');
    if($sendemail)
        $emailsubject = $inParameterList->ParameterValue('emailsubject');

// at this point, an error should be returned in 3 cases:  a blank note  OR  custid is false  OR  sendemail is true and emailsubject is false

    if(!$notetext) {
        $paramList = new ACF_ParameterList();
        $paramList->AddParameter(new ACF_DirectParameter('error','No Note entered'));
        $retEvent = new ACF_Event('addnote_fail');
        $retEvent->SetParameterList($paramList);
        return $retEvent;
    }

    if(!$custid) {
        $paramList = new ACF_ParameterList();
        $paramList->AddParameter(new ACF_DirectParameter('error','No Customer has been selected'));
        $retEvent = new ACF_Event('addnote_fail');
        $retEvent->SetParameterList($paramList);
        return $retEvent;
    }

    if($sendemail && !$emailsubject) {
        $paramList = new ACF_ParameterList();
        $paramList->AddParameter(new ACF_DirectParameter('error','No Subject entered for email'));
        $retEvent = new ACF_Event('addnote_fail');
        $retEvent->SetParameterList($paramList);
        return $retEvent;
    }

    $addResults = AddNote($custid,$_SESSION['piwi']['staffid'],$status,$notetext,$staffasgn,$priority,$sendemail,$emailsubject);

    if($addResults['success']) {
        return new ACF_Event('addnote_success');
    } else {
        $paramList = new ACF_ParameterList();
        $paramList->AddParameter(new ACF_DirectParameter('error',$addResults['error']));
        $retEvent = new ACF_Event('addnote_fail');
        $retEvent->SetParameterList($paramList);
        return $retEvent;
    }
}

function AH_AddCCSService (ACF_ParameterList $inParameterList) {
    $_SESSION['ccs']['bundled'] = true;

    $username = $inParameterList->ParameterValue('username');
    $password = $inParameterList->ParameterValue('password');

    if (strlen(trim($username)) || strlen(trim($password))) {
        $custIDarray = Login($username,$password,'customer');
        if(!$custIDarray) {
            $loginerror = "failed";
        }
    } else {
        $loginerror = "empty";
    }

    if ($loginerror) {
        $returnURL = $_SESSION['piwi']['options']['ccs-url'];
        header("location:".$returnURL);
        return new ACF_Event('addccsservice_loginfail');
    } else {
        $custid  = $custIDarray['id'];
        $storeid = $custIDarray['storeid'];

        $svctype = trim($inParameterList->ParameterValue('svctype'));
        $crid = $inParameterList->ParameterValue('crid');
        $branch = $inParameterList->ParameterValue('branch');
        $p_service = $inParameterList->ParameterValue('p_service');
        $p_instance = $inParameterList->ParameterValue('p_instance');

        $_SESSION['modules']['billing']['custid'] = $_SESSION['piwi']['custid'] = $custid;
        $_SESSION['modules']['billing']['usertype'] = 'EXISTING';
        $_SESSION['modules']['billing']['storeid'] = $_SESSION['piwi']['storeid'];

        if($crid && $crid != '0' && ValidCRID($custid,$crid)) { // go to add a service based on the svctype
// pull header data and place it in the session, since the DC that normally does this would not have been executed by this point
            $_SESSION['modules']['shared']['custdata'] = GetHeader($_SESSION['piwi']['custid'],$_SESSION['piwi']['parentid'],$_SESSION['piwi']['displaystaffpages'],$_SESSION['piwi']['staffid'],$_SESSION['piwi']['staffname'],$_SESSION['piwi']['currentSection'],$_SESSION['piwi']['currentSubsection']);

    // begin actual forwarding function
            $_SESSION['piwi']['currentCRID'] = $crid;
            $_SESSION['modules']['billing']['bundle'] = $bundle = GetSingleBundle($storeid,$custid,$crid);

            $serviceTree = GetServiceTree($_SESSION['modules']['billing']['bundle']['rg_id'],$_SESSION['piwi']['custid']);
            if(isset($serviceTree) && is_array($serviceTree)) {
                foreach($serviceTree as $thisServiceStruct) {
                    if($thisServiceStruct['rs_id'] == $branch && $thisServiceStruct['rs_parent_service'] == $p_service && $thisServiceStruct['rs_parent_instance'] == $p_instance) {
                        $_SESSION['modules']['billing']['bundle']['structdata'] = $thisServiceStruct;
                        break;
                    }
                }
            }

            if(!$svctype) {
                $svctype = trim($bundle['svc_ccs_service']);
            }

            if(!$_SESSION['modules']['billing']['bundle']['svc_ccs_service'] && $svctype) {
                $_SESSION['modules']['billing']['bundle']['svc_ccs_service'] = $bundle['svc_ccs_service'] = $svctype;
            }

            $_SESSION['piwi']['servicetype'] = $svctype;
            $servicedata = $_SESSION['piwi']['serviceDefs'];

            if(isset($servicedata) && is_array($servicedata)) {
                foreach($servicedata as $thisServiceID=>$thisServiceType) {
                    if($thisServiceType['svc_ccs_service'] == $svctype) {
                        $svcid = $thisServiceID;
                        if($svctype == 'domain') {
                            $_SESSION['piwi']['firstService'] = $thisServiceType['used'] ? false : true;
                        }
                        break;
                    }
                }
            }

            $_SESSION['piwi']['serviceid'] = $svcid;

            $fieldData = GetServiceFields($svcid,$bundle['rg_id'],$crid,$branch,$p_instance,$p_service,$custid);
            if(isset($fieldData) && is_array($fieldData)) {
                foreach($fieldData as $thisField) {
                    if(!isset($thisField['template_dflt'])) {
                        $noTemplate = true;
                    }
                    break;
                }
                if($noTemplate) {
                    $fieldData = false;
                }
            }

            switch($svctype) {
            case 'domain':
                $_SESSION['modules']['billing']['OpenSRSProfile'] = GetProfile($custid);
                if($_SESSION['modules']['billing']['OpenSRSProfile']) {
                    $_SESSION['modules']['shared']['domain']   = $_SESSION['modules']['billing']['OpenSRSProfile']['domain'];
                    $_SESSION['modules']['shared']['username'] = $_SESSION['modules']['billing']['OpenSRSProfile']['username'];
                    $_SESSION['modules']['shared']['password'] = $_SESSION['modules']['billing']['OpenSRSProfile']['password'];
                } else {
                    $_SESSION['modules']['billing']['randomProfile'] = GenerateProfile();
                    $_SESSION['modules']['shared']['domain'] = false;
                    $_SESSION['modules']['shared']['username'] = $_SESSION['modules']['billing']['randomProfile']['username'];
                    $_SESSION['modules']['shared']['password'] = $_SESSION['modules']['billing']['randomProfile']['password'];
                }

                if(isset($fieldData) && is_array($fieldData)) {
                    foreach($fieldData as $thisField) {
                        if($thisField['datacol'] == 'register_period') {
                            $_SESSION['modules']['domain']['passed']['register_period'] = $thisField['template_dflt'];
                            break;
                        }
                    }
                }

                if($_SESSION['piwi']['firstService']) {
                    $_SESSION['ccs']['excludeSteps'] = array('user');
                } else {
                    $_SESSION['ccs']['excludeSteps'] = array('user','payment');
                }

                $allPrices = GetAllPrices($_SESSION['modules']['billing']['bundle']['rg_id']);

                $priceArray = array();
                $allowedTLDsByRate = array();
                $tldList = $_SESSION['ccs']['options']['driver-options']['service-modules']['domain']['service-options']['related-tld-groups'];

                if(isset($allPrices) && is_array($allPrices)) {
                    foreach($allPrices as $thisPrice) {
                        if(!in_array('.'.strtolower($thisPrice['service_subtype']),$allowedTLDsByRate)) {
                            array_push($allowedTLDsByRate,'.'.strtolower($thisPrice['service_subtype']));
                        }

                        switch($thisPrice['transaction_type']) {
                        case "Register":
                            $type = "new";
                            break;
                        default:
                            $type = strtolower($thisPrice['transaction_type']);
                        }
                        $type = 'period-pricing-'.$type;

                        $tld = ".".strtolower($thisPrice['service_subtype']);
                        $year = $thisPrice['period'];

                        if(!$priceArray[$tld]) {
                            $priceArray[$tld] = array();
                        }
                        if(!$priceArray[$tld][$type]) {
                            $priceArray[$tld][$type] = array();
                        }
                        $priceArray[$tld][$type][$year-1] = $thisPrice['price'];
                    }

                    if(isset($_SESSION['ccs']['options']['driver-options']['service-modules']['domain']['service-options']['service-offering-list']['service-offering']) && is_array($_SESSION['ccs']['options']['driver-options']['service-modules']['domain']['service-options']['service-offering-list']['service-offering'])) {
                        foreach($_SESSION['ccs']['options']['driver-options']['service-modules']['domain']['service-options']['service-offering-list']['service-offering'] as &$thisTLD) {
                            $thisTLD['price']['period-pricing-new'] = $priceArray[$thisTLD['tld']]['period-pricing-new'];
                            $thisTLD['price']['period-pricing-renew'] = $priceArray[$thisTLD['tld']]['period-pricing-renew'];
                            $thisTLD['price']['period-pricing-transfer'] = $priceArray[$thisTLD['tld']]['period-pricing-transfer'];
                        }
                    }
                }
                if(isset($tldList['group']) && is_array($tldList['group'])) {
                    foreach($tldList['group'] as $tldGroupKey=>$tldGroup) {
                        if(is_array($tldGroup['tld'])) { // more than one TLD in this group
                            foreach($tldGroup['tld'] as $thisTLDKey=>$thisTLDName) {
                                if(!in_array($thisTLDName,$allowedTLDsByRate) && $thisTLDName != 'default') {
                                    unset($tldList['group'][$tldGroupKey]['tld'][$thisTLDKey]);
                                }
                            }
                        } else {
                            if(!in_array($tldGroup['tld'],$allowedTLDsByRate)) {
                                unset($tldList['group'][$tldGroupKey]);
                            }
                        }
                    }
                }
                $_SESSION['ccs']['tldGroups'] = $tldList;
                break;

            case 'blogware':
                if(isset($fieldData) && is_array($fieldData)) {
                    foreach($fieldData as $thisField) {
                        if($thisField['datacol'] == 'blog_package' && $thisField['template_dflt'] != 'NULL' && $thisField['template_dflt'] != '') {
                            $_SESSION['modules']['blogware']['package'] = $thisField['template_dflt'];
                        }

                        if($thisField['datacol'] == 'blog_trial' && $thisField['template_dflt'] != 'NULL' && $thisField['template_dflt'] != '') {
                            $_SESSION['modules']['blogware']['trial'] = $thisField['template_dflt'] == 1 ? true : false;
                        }
                    }
                }
                if(!$_SESSION['modules']['blogware']['package']) {
                    $paramList = new ACF_ParameterList();
                    $paramList->AddParameter(new ACF_DirectParameter('error',"Blogware Signup is not currently available\nERROR:  No Service Template set on the Blogware service on this Rate."));
                    $retEvent = new ACF_Event('addccsservice_fail');
                    $retEvent->SetParameterList($paramList);

                    return $retEvent;
                }
                $_SESSION['ccs']['excludeSteps'] = array('payment');
                break;
            }

            $returnURL = $_SESSION['piwi']['options']['ccs-url']."/checkserviceavailability?servicetype=".$svctype;
            header("location:".$returnURL);
            return new ACF_Event('addccsservice_success');
        } else { // if no crid, simply go to the buy bundle page
            return new ACF_Event('addccsservice_buybundle');
        }
    }
}

function AH_LoadGlobalOptions(ACF_ParameterList $inParameterList) {
    require_once('../../libs/ccs/options.inc.php');

    // This function parses the options file for global options.
    // Prep Session
    if(!$_SESSION['ccs'])
        $_SESSION['ccs'] = array();
    $retEvent; // Return Event

    if(loadCCSOptions()) { // Loads options into an array (Located in options.inc.php)
        // Check for services
        if(count($_SESSION['ccs']['options']['driver-options']['service-modules']) < 1) {
            $_SESSION['ccs']['lastSystemError'] = "No services were loaded.";
            $paramList = new ACF_ParameterList();
            $paramList->AddParameter(new ACF_DirectParameter('errormessage',$_SESSION['ccs']['lastSystemError']));
            $retEvent = new ACF_Event('loadglobaloptions_fail');
            $retEvent->SetParameterList($paramList);
            return $retEvent;
            return new ACF_Event('loadglobaloptions_fail');
        }

        if(!$_SESSION['ccs']['options']['driver-options']['url']) { // url option does not exist.
            $_SESSION['ccs']['lastSystemError'] = "Failed to load global CCS option: URL";
            $paramList = new ACF_ParameterList();
            $paramList->AddParameter(new ACF_DirectParameter('errormessage',$_SESSION['ccs']['lastSystemError']));
            $retEvent = new ACF_Event('loadglobaloptions_fail');
            $retEvent->SetParameterList($paramList);
            return $retEvent;
        }

        SetStaffLogin();

        return new ACF_Event('loadglobaloptions_success');
    } else {
        $_SESSION['ccs']['lastSystemError'] = "Failed to load global CCS options file";
        $paramList = new ACF_ParameterList();
        $paramList->AddParameter(new ACF_DirectParameter('errormessage',$_SESSION['ccs']['lastSystemError']));
        $retEvent = new ACF_Event('loadglobaloptions_fail');
        $retEvent->SetParameterList($paramList);
        return $retEvent;
    }
}

function AH_ChangeBlogPackage(ACF_ParameterList $inParameterList) {
    $paramList = new ACF_ParameterList();

    $username = $inParameterList->ParameterValue('username');
    $password = $inParameterList->ParameterValue('password');

    if (strlen(trim($username)) || strlen(trim($password))) {
        $custIDarray = Login($username,$password,'customer');
        if(!$custIDarray) {
            $loginerror = "failed";
        }
    } else {
        $loginerror = "empty";
    }

    if ($loginerror) {
        $paramList->AddParameter(new ACF_DirectParameter('returnmsg','SHOWLOGERROR Login '.$loginerror));
    } else {
        $custid = $custIDarray['id'];

        $serviceData = GetAllServices($custid);
        if(!$serviceData) {
            $paramList->AddParameter(new ACF_DirectParameter('returnmsg','SHOWLOGERROR Customer '.$custid.' has no services.'));
        } else {
            if(isset($serviceData) && is_array($serviceData)) {
                foreach($serviceData as $thisServiceType) {
                    if($thisServiceType['svc_ccs_service'] == 'blogware') {
                        if(!$thisServiceType['details']) {
                            $paramList->AddParameter(new ACF_DirectParameter('returnmsg','SHOWLOGERROR Customer '.$custid.' has no blogs.'));
                        } else {
                            if(isset($thisServiceType['details']) && is_array($thisServiceType['details'])) {
                                foreach($thisServiceType['details'] as $thisBlog) {
                                    $serviceDetail = GetServiceDetail($custid,$thisServiceType['svc_id'],$thisBlog['data_id']);
                                    if($serviceDetail['blog_id'] == $inParameterList->ParameterValue('blogid')) {
                                        $blogFound = true;
                                    }
                                }
                            }
                        }
                    }
                }
            }
        }

        if(!$blogFound) {
            $paramList->AddParameter(new ACF_DirectParameter('returnmsg','SHOWLOGERROR Customer '.$custid.' does not own this blog.'));
        } else {
            require_once("../modules/blogware/blogfunctions.php");

            $url = executeAPICall('get_bloginfo',array('blog_id'=>$inParameterList->ParameterValue('blogid')),'url');

            $updateblog = executeAPICall('update_blogpackage',array('blog_id'=>$inParameterList->ParameterValue('blogid'),'package'=>$inParameterList->ParameterValue('package')));

            if(!$updateblog) {
                $paramList->AddParameter(new ACF_DirectParameter('returnmsg','SHOWLOGERROR '.$_SESSION['modules']['blogware']['status']['text']));
            } else {
                $paramList->AddParameter(new ACF_DirectParameter('returnmsg','SHOWLOGSUCCESS Package changed for blogware '.$url.' to '.$inParameterList->ParameterValue('package').'.'));
            }
        }
    }

    $retEvent = new ACF_Event('changeblogpackage_done');
    $retEvent->SetParameterList($paramList);
    return $retEvent;
}

function AH_TargetManage(ACF_ParameterList $inParameterList) {
    $ServiceType = $inParameterList->ParameterValue('servicetype');
    $options = $inParameterList->ParameterValue('options');
    $staffid = $inParameterList->ParameterValue('staffid');

    // Set Service Type
    $_SESSION['modules']['requiredService'] = $ServiceType;

    if(!$_SESSION['ccs'])
        $_SESSION['ccs'] = array();

    if(!$_SESSION['ccs']['optionsLoaded'])
        loadCCSOptions();

    if($options) {
        $_SESSION['modules']['billing']['passed'] = array();
        foreach($options as $key=>$option) { // Doesn't override options
            $_SESSION['modules'][$ServiceType]['passed'][$key] = $option;
            $_SESSION['modules']['billing']['passed'][$key] = $option;
        }

        $_SESSION['wow']['staffname'] = $options['platuser'];
            $_SESSION['wow']['staffpass'] = $options['platpass'];
            $_SESSION['wow']['logintype'] = 'customer';

            SetStaffLogin();
    }

    if($staffid) {
        $_SESSION['piwi']['staffid'] = $staffid;
    }

    $retParams = new ACF_ParameterList();
    $retParams->AddParameter(new ACF_DirectParameter('url',$_SESSION['ccs']['options']['driver-options']['service-modules'][$ServiceType]['url'].'/targetpage'));
    if($options['rgid']) {
        $retParams->AddParameter(new ACF_DirectParameter('rgid',$options['rgid']));
        $retEvent = new ACF_Event('targetmanage_resetprices');
    } else {
        $retEvent = new ACF_Event('targetmanage_return');
    }
    $retEvent->SetParameterList($retParams);
    return $retEvent;
}

function AH_HopProject(ACF_ParameterList $inParameterList) {
    // This activity handler redirects a user to the given url (for Project hopping)

    $retEvent; // Return Event
    //$retParams; // Return Parameters

    $url = $inParameterList->ParameterValue('url');
    header("location:".$url); // Send HTML header

    /*
    $retEvent = new ACF_Event('hopproject_success');
    $retParams = new ACF_ParameterList();
    $retParams->AddParameter(new ACF_DirectParameter('hopurl',$url));
    $retEvent->SetParameterList($retParams);
    //*/

    $retEvent = new ACF_Event('hopproject_success');

    return $retEvent;
}


function AH_UpdateEmailAddress (ACF_ParameterList $inParameterList) {
    if($inParameterList->ParameterValue('account')) {
        $accountInfo = $inParameterList->ParameterValue('account');
        $custData = GetCustomerData($_SESSION['piwi']['custid']);

        if(!$accountInfo['custinfo']['email']) {
            if($errors['heading']) {
                $errors['heading'] .= "The Email field is blank!\n";
            } else {
                $errors['heading']  = "The Email field is blank!\n";
            }
        } else {
            if($accountInfo['custinfo']['email'] != $custData['email']) {
                $updateemailResults = UpdateCustomer($_SESSION['piwi']['custid'],'email',$accountInfo['custinfo']['email']);
                if(!$updateemailResults['success']) {
                    if($errors['heading']) {
                        $errors['heading'] .= $updateemailResults['error']."\n";
                    } else {
                        $errors['heading']  = $updateemailResults['error']."\n";
                    }
                }
            }
        }

        if($errors) {
            $paramList = new ACF_ParameterList();
            $paramList->AddParameter(new ACF_DirectParameter('error',$errors['heading']));
            $paramList->AddParameter(new ACF_DirectParameter('errors',$errors));
            $paramList->AddParameter(new ACF_DirectParameter('returndata',$accountInfo));
            $retEvent = new ACF_Event('updateemailaddress_fail');
            $retEvent->SetParameterList($paramList);
            return $retEvent;
        } else {
            return new ACF_Event('updateemailaddress_success');
        }
    } else {
        return new ACF_Event('updateemailaddress_fail');
    }
}

function AH_UpdatePhones (ACF_ParameterList $inParameterList) {
    if($inParameterList->ParameterValue('account')) {
        $accountInfo = $inParameterList->ParameterValue('account');
        $custData = GetCustomerData($_SESSION['piwi']['custid']);

        if(isset($accountInfo['reqphone']) && is_array($accountInfo['reqphone'])) {
            foreach($accountInfo['reqphone'] as $phoneType=>$phoneNumber) {
                if(!$phoneNumber) {
                    if(!$phoneErrorSet) {
                        if($errors['heading']) {
                            $errors['heading'] .= "There were errors updating one or more phone numbers.  See the Phone Numbers section below for more details.\n";
                        } else {
                            $errors['heading']  = "There were errors updating one or more phone numbers.  See the Phone Numbers section below for more details.\n";
                        }
                        $phoneErrorSet = true;
                    }

                    $errors['phone'][$phoneType] = " This is a required phone number! ";
                } else {
                    $updatethisphoneResults = UpdatePhone($_SESSION['piwi']['custid'],$phoneType,$phoneNumber);
                    if(!$updatethisphoneResults['success']) {
                        if(!$phoneErrorSet) {
                            if($errors['heading']) {
                                $errors['heading'] .= "There were errors updating one or more phone numbers.  See the Phone Numbers section below for more details.\n";
                            } else {
                                $errors['heading']  = "There were errors updating one or more phone numbers.  See the Phone Numbers section below for more details.\n";
                            }
                            $phoneErrorSet = true;
                        }
                        $errors['phone'][$phoneType] = " ".$updatethisphoneResults['error'];
                    }
                }
            }
        }

        if(isset($accountInfo['phone']) && is_array($accountInfo['phone'])) {
            foreach($accountInfo['phone'] as $phoneType=>$phoneNumber) {
                $updatethisphoneResults = UpdatePhone($_SESSION['piwi']['custid'],$phoneType,$phoneNumber);
                if(!$updatethisphoneResults['success']) {
                    if(!$phoneErrorSet) {
                        if($errors['heading']) {
                            $errors['heading'] .= "There were errors updating one or more phone numbers.  See the Phone Numbers section below for more details.\n";
                        } else {
                            $errors['heading']  = "There were errors updating one or more phone numbers.  See the Phone Numbers section below for more details.\n";
                        }
                        $phoneErrorSet = true;
                    }
                    $errors['phone'][$phoneType] = " ".$updatethisphoneResults['error'];
                }
            }
        }

        if($errors) {
            $paramList = new ACF_ParameterList();
            $paramList->AddParameter(new ACF_DirectParameter('error',$errors['heading']));
            $paramList->AddParameter(new ACF_DirectParameter('errors',$errors));
            $paramList->AddParameter(new ACF_DirectParameter('returndata',$accountInfo));
            $retEvent = new ACF_Event('updatephones_fail');
            $retEvent->SetParameterList($paramList);
            return $retEvent;
        } else {
            return new ACF_Event('updatephones_success');
        }
    } else {
        return new ACF_Event('updatephones_fail');
    }
}

function AH_UpdateAddress (ACF_ParameterList $inParameterList) {
    if($inParameterList->ParameterValue('account')) {
        $accountInfo = $inParameterList->ParameterValue('account');
        $custData = GetCustomerData($_SESSION['piwi']['custid']);

        if(isset($accountInfo['address']) && is_array($accountInfo['address'])) {
            $addressType = $accountInfo['address']['typeid'];
            if($accountInfo['address']['nonrequired']) {
                if($accountInfo['address']['required']) {
                    $combinedAddressData = $accountInfo['address']['required'] + $accountInfo['address']['nonrequired'];
                    if($accountInfo['billing']['stmtmethod'] != 'CREDIT CARD' && $addressType == 5) {
                        $accountInfo['address']['nonrequired'] = $combinedAddressData;
                        $accountInfo['address']['required'] = array();
                    }
                } else {
                    $combinedAddressData = $accountInfo['address']['nonrequired'];
                }
            } else {
                $combinedAddressData = $accountInfo['address']['required'];
            }
            $isAddress = false;
            if($addressType == '5' && $accountInfo['billing']['stmtmethod'] == 'CREDIT CARD') {
                $isAddress = true;
            } else {
                if(isset($combinedAddressData) && is_array($combinedAddressData)) {
                    foreach($combinedAddressData as $thisField=>$thisValue) {
                        if($thisValue) {
                            $isAddress = true;
                            break;
                        }
                    }
                }
            }

            if(isset($accountInfo['address']['required']) && is_array($accountInfo['address']['required'])) {
                foreach($accountInfo['address']['required'] as $requiredField=>$value) {
                    if(!$value && $isAddress) {
                        if(!$addrErrorSet || $addressType == 5) {
                            if($errors['heading']) {
                                if($addressType == 5) {
                                    $errors['heading'] .= "There were errors updating the Credit Card Address.  See the Billing Information section below for more details.\n";
                                } else {
                                    $errors['heading'] .= "There were errors updating one or more addresses.  See the Address section below for more details.\n";
                                }
                            } else {
                                if($addressType == 5) {
                                    $errors['heading'] = "There were errors updating the Credit Card Address.  See the Billing Information section below for more details.\n";
                                } else {
                                    $errors['heading'] = "There were errors updating one or more addresses.  See the Address section below for more details.\n";
                                }
                            }
                            $addrErrorSet = true;
                        }

                        if($errors['address'][$addressType]) {
                            $errors['address'][$addressType] .= "The ".$requiredField." field is blank!\n";
                        } else {
                            $errors['address'][$addressType]  = "The ".$requiredField." field is blank!\n";
                        }
                    }
                }
            }

            if(!$errors['address'][$addressType]) {
                if($addressType == '5') {
                    if($accountInfo['address']['default'] == 'Y') {
                        $ccName = $accountInfo['custinfo']['attn'];
                    } else {
                        $ccName = $combinedAddressData['attn'];
                    }
                }

                if($accountInfo['address']['default'] == 'Y') {
                    $updatethisaddrResults = UpdateAddress($_SESSION['piwi']['custid'],$addressType,$accountInfo['custinfo']['attn'],$combinedAddressData['addr1'],$combinedAddressData['addr2'],$combinedAddressData['city'],$combinedAddressData['state'],$combinedAddressData['zip'],$combinedAddressData['country']);
                    if(!$updatethisaddrResults['success']) {
                        if(!$addrErrorSet || $addressType == 5) {
                            if($errors['heading']) {
                                if($addressType == 5) {
                                    $errors['heading'] .= "There were errors updating the Credit Card Address.  See the Billing Information section below for more details.\n";
                                } else {
                                    $errors['heading'] .= "There were errors updating one or more addresses.  See the Address section below for more details.\n";
                                }
                            } else {
                                if($addressType == 5) {
                                    $errors['heading'] = "There were errors updating the Credit Card Address.  See the Billing Information section below for more details.\n";
                                } else {
                                    $errors['heading'] = "There were errors updating one or more addresses.  See the Address section below for more details.\n";
                                }
                            }
                            $addrErrorSet = true;
                        }

                        if($errors['address'][$addressType]) {
                            $errors['address'][$addressType] .= $updatethisaddrResults['error']."\n";
                        } else {
                            $errors['address'][$addressType]  = $updatethisaddrResults['error']."\n";
                        }
                    }
                } else {
                    $updatethisaddrResults = UpdateAddress($_SESSION['piwi']['custid'],$addressType,$combinedAddressData['attn'],$combinedAddressData['addr1'],$combinedAddressData['addr2'],$combinedAddressData['city'],$combinedAddressData['state'],$combinedAddressData['zip'],$combinedAddressData['country']);
                    if(!$updatethisaddrResults['success']) {
                        if(!$addrErrorSet || $addressType == 5) {
                            if($errors['heading']) {
                                if($addressType == 5) {
                                    $errors['heading'] .= "There were errors updating the Credit Card Address.  See the Billing Information section below for more details.\n";
                                } else {
                                    $errors['heading'] .= "There were errors updating one or more addresses.  See the Address section below for more details.\n";
                                }
                            } else {
                                if($addressType == 5) {
                                    $errors['heading'] = "There were errors updating the Credit Card Address.  See the Billing Information section below for more details.\n";
                                } else {
                                    $errors['heading'] = "There were errors updating one or more addresses.  See the Address section below for more details.\n";
                                }
                            }
                            $addrErrorSet = true;
                        }

                        if($errors['address'][$addressType]) {
                            $errors['address'][$addressType] .= $updatethisaddrResults['error']."\n";
                        } else {
                            $errors['address'][$addressType]  = $updatethisaddrResults['error']."\n";
                        }
                    }
                }
            }
        }

        if($errors) {
            $paramList = new ACF_ParameterList();
            $paramList->AddParameter(new ACF_DirectParameter('error',$errors['heading']));
            $paramList->AddParameter(new ACF_DirectParameter('errors',$errors));
            $paramList->AddParameter(new ACF_DirectParameter('returndata',$accountInfo));
            $retEvent = new ACF_Event('updateaddress_fail');
            $retEvent->SetParameterList($paramList);
            return $retEvent;
        } else {
            return new ACF_Event('updateaddress_success');
        }
    } else {
        return new ACF_Event('updateaddress_fail');
    }
}


function AH_UpdateBillingInfo (ACF_ParameterList $inParameterList) {
    if($inParameterList->ParameterValue('account')) {
        $accountInfo = $inParameterList->ParameterValue('account');
        $custData = GetCustomerData($_SESSION['piwi']['custid']);

//Section IVa: ACH Fields
        $achStmtMethod = strtoupper(GetWebOption('achstmt',$storeid));
        if($accountInfo['billing']['stmtmethod'] == $achStmtMethod) {
            $accountInfo['reqstmt_override'] = 'ACH';
            if($accountInfo['billing']['bank_acct_type'] && $accountInfo['billing']['routenumber'] && $accountInfo['billing']['acctnumber']) {
                $achOK = True;
            } else {
            	$achOK = False;
            	if(!$accountInfo['billing']['bank_acct_type']) {
            		$errors['bank_acct_type'] = "Required";
            	}
            	if(!$accountInfo['billing']['routenumber']) {
            		$errors['routenumber'] = "Required";
            	}
            	if(!$accountInfo['billing']['acctnumber']) {
            		$errors['acctnumber'] = "Required";
            	}

	            $sectionError = "One or more required fields for ACH billing were left blank.";
	            if($errors['heading']) {
	                $errors['heading'] .= $sectionError."\n";
	            } else {
	                $errors['heading']  = $sectionError."\n";
	            }
            }
        } else {
            $achOK = True;
        }

		if($achOK) {
			if($accountInfo['billing']['bank_acct_type'] != $custData['bank_acct_type']) { // value has changed
				$updateResult = UpdateCustomer($_SESSION['piwi']['custid'],'bank_acct_type',$accountInfo['billing']['bank_acct_type']);
				if(!$updateResult['success']) {
					$achOK = False;
					if($errors['heading']) {
						$errors['heading'] .= $updateResult['error']."\n";
					} else {
						$errors['heading']  = $updateResult['error']."\n";
					}
				}
			}

			if($accountInfo['billing']['routenumber'] != $custData['routenumber']) { // value has changed
				$updateResult = UpdateCustomer($_SESSION['piwi']['custid'],'routenumber',$accountInfo['billing']['routenumber']);
				if(!$updateResult['success']) {
					$achOK = False;

					if($errors['heading']) {
						$errors['heading'] .= $updateResult['error']."\n";
					} else {
						$errors['heading']  = $updateResult['error']."\n";
					}
				}
			}

			if($accountInfo['billing']['acctnumber'] != $custData['acctnumbermasked'] && $accountInfo['billing']['acctnumber'] != $custData['acctnumber']) {
				$updateResult = UpdateCustomer($_SESSION['piwi']['custid'],'acctnumber',$accountInfo['billing']['acctnumber']);
				if(!$updateResult['success']) {
					$achOK = False;

					if($errors['heading']) {
						$errors['heading'] .= $updateResult['error']."\n";
					} else {
						$errors['heading']  = $updateResult['error']."\n";
					}
				}
			}
		}

//Section IVb: CC Fields
        if(isset($accountInfo['address']) && is_array($accountInfo['address'])) {
            foreach($accountInfo['address'] as $addressType=>&$addressData) {
                if($addressData['nonrequired']) {
                    if($addressData['required']) {
                        $combinedAddressData = $addressData['required'] + $addressData['nonrequired'];
                        if($accountInfo['billing']['stmtmethod'] != 'CREDIT CARD' && $addressType == 5) {
                            $addressData['nonrequired'] = $combinedAddressData;
                            $addressData['required'] = array();
                        }
                    } else {
                        $combinedAddressData = $addressData['nonrequired'];
                    }
                } else {
                    $combinedAddressData = $addressData['required'];
                }
                $isAddress = false;
                if($addressType == '5' && $accountInfo['billing']['stmtmethod'] == 'CREDIT CARD') {
                    $isAddress = true;
                } else {
                    if(isset($combinedAddressData) && is_array($combinedAddressData)) {
                        foreach($combinedAddressData as $thisField=>$thisValue) {
                            if($thisValue) {
                                $isAddress = true;
                                break;
                            }
                        }
                    }
                }

                if(isset($addressData['required']) && is_array($addressData['required'])) {
                    foreach($addressData['required'] as $requiredField=>$value) {
                        if(!$value && $isAddress) {
                            if(!$addrErrorSet) {
                                if($errors['heading']) {
                                    if($addressType == 5) {
                                        $errors['heading'] .= "Required fields in the Credit Card Address were left blank.\n";
                                    } else {
                                        $errors['heading'] .= "Required fields in one of the addresses were left blank.\n";
                                    }
                                } else {
                                    if($addressType == 5) {
                                        $errors['heading'] = "Required fields in the Credit Card Address were left blank.\n";
                                    } else {
                                        $errors['heading'] = "Required fields in one of the addresses were left blank.\n";
                                    }
                                }
                                $addrErrorSet = true;
                            }

							$errors['address'][$addressType][$requiredField] = "Required";
                        }
                    }
                }

                if(!$errors['address'][$addressType]) {
                    $updatethisaddrResults = UpdateAddress($_SESSION['piwi']['custid'],$addressType,$combinedAddressData['attn'],$combinedAddressData['addr1'],$combinedAddressData['addr2'],$combinedAddressData['city'],$combinedAddressData['state'],$combinedAddressData['zip'],$combinedAddressData['country']);
                    if(!$updatethisaddrResults['success']) {
                        if(!$addrErrorSet) {
                            if($errors['heading']) {
                                if($addressType == 5) {
                                    $errors['heading'] .= "An error occurred updating the Credit Card Address.\n ";
                                } else {
                                    $errors['heading'] .= "An error occurred updating one or more addresses.\n ";
                                }
                            } else {
                                if($addressType == 5) {
                                    $errors['heading'] = "An error occurred updating the Credit Card Address.\n ";
                                } else {
                                    $errors['heading'] = "An error occurred updating one or more addresses.\n ";
                                }
                            }
                            $addrErrorSet = true;
                        }
                        $errors['heading'] .= $updatethisaddrResults['error']."\n";
                    }
                }
            }
        }

        if($accountInfo['billing']['stmtmethod'] == 'CREDIT CARD') {
            $accountInfo['reqstmt_override'] = 'CREDIT CARD';
            if($accountInfo['billing']['paymenttype'] && $accountInfo['billing']['ccnumber'] && $accountInfo['billing']['ccmonth'] && $accountInfo['billing']['ccyear'] && !$addrErrorSet) {
                $ccOK = True;
            } else {
            	$ccOK = False;

	            $sectionError = "One or more required fields for Credit Card billing were left blank.";
	            if($errors['heading']) {
	                $errors['heading'] .= $sectionError."\n";
	            } else {
	                $errors['heading']  = $sectionError."\n";
	            }

            	if(!$accountInfo['billing']['paymenttype']) {
            		$errors['paymenttype'] = "Required";
            	}
            	if(!$accountInfo['billing']['ccnumber']) {
            		$errors['ccnumber'] = "Required";
            	}
            	if(!($accountInfo['billing']['ccmonth'] && $accountInfo['billing']['ccyear'])) {
            		$errors['ccdate'] = "Required";
            	}
            }
        } else {
            $ccOK = True;
        }

		if($ccOK) {
			if($accountInfo['billing']['paymenttype']) {
				$cctypeSelection = ExecuteSQL("select p_name from payment_types where p_id = ".$accountInfo['billing']['paymenttype']);
				if($cctypeSelection['success']) {
					$cctype = $cctypeSelection['sqlreturn'][0]['p_name'];
				}
			}

			if($accountInfo['billing']['ccnumber'] && $accountInfo['billing']['ccnumber'] != $custData['creditcardmasked'] && $accountInfo['billing']['ccnumber'] != $custData['ccnumber']) {
				if($accountInfo['billing']['ccnumber'] == $custData['creditcardmasked']) {
					$accountInfo['billing']['ccnumber'] = $custData['ccnumber'];
					$accountInfo['billing']['ccnumbermasked'] = $custData['creditcardmasked'];
				}

				$validateResults = ValidateCard($cctype,$accountInfo['billing']['ccnumber'],$accountInfo['billing']['ccmonth'],$accountInfo['billing']['ccyear']);

				if($validateResults['success']) {
					if($errors['address'][5]) {
						$ccOK = False;
						if($errors['heading']) {
							$errors['heading'] .= "The Credit Card Address is required if the Statement Method is Credit Card.\n";
						} else {
							$errors['heading']  = "The Credit Card Address is required if the Statement Method is Credit Card.\n";
						}
					}
				} else {
					$ccOK = False;
					if($errors['heading']) {
						$errors['heading'] .= $validateResults['error']."\n";
					} else {
						$errors['heading']  = $validateResults['error']."\n";
					}
				}
			}

			if($ccOK && (($accountInfo['billing']['ccnumber'] != $custData['creditcardmasked'] && $accountInfo['billing']['ccnumber'] != $custData['ccnumber']) || $cctype != $custData['cctype'] || date("m",strtotime($custData['ccdate'])) != $accountInfo['billing']['ccmonth'] || date("Y",strtotime($custData['ccdate'])) != $accountInfo['billing']['ccyear']) ) {
				if($accountInfo['billing']['ccnumber'] == $custData['creditcardmasked']) {
					$accountInfo['billing']['ccnumber'] = $custData['ccnumber'];
					$accountInfo['billing']['ccnumbermasked'] = $custData['creditcardmasked'];
				}

				$billingupdateResults = UpdateBillingInfo($_SESSION['piwi']['custid'],$cctype,$accountInfo['billing']['ccmonth'],$accountInfo['billing']['ccyear'],$accountInfo['billing']['ccnumber'],$combinedAddressData['attn'],$accountInfo['billing']['stmtmethod'] == 'CREDIT CARD');

				if(!$billingupdateResults['success']) {
					$ccOK = False;
					if($errors['heading']) {
						$errors['heading'] .= $billingupdateResults['error']."\n";
					} else {
						$errors['heading']  = $billingupdateResults['error']."\n";
					}
				}
			}
		}

//Section IVc: stmt method update
        if((($achOK && $accountInfo['billing']['stmtmethod'] == $achStmtMethod) || ($ccOK && $accountInfo['billing']['stmtmethod'] == 'CREDIT CARD') || ($accountInfo['billing']['stmtmethod'] != $achStmtMethod && $accountInfo['billing']['stmtmethod'] != 'CREDIT CARD')) && $accountInfo['billing']['stmtmethod'] != $custData['stmtmethod']) {
            $updatestmtmethodResults = UpdateCustomer($_SESSION['piwi']['custid'],'stmtmethod',$accountInfo['billing']['stmtmethod']);
            if(!$updatestmtmethodResults['success']) {
                if($errors['heading']) {
                    $errors['heading'] .= $updatestmtmethodResults['error']."\n";
                } else {
                    $errors['heading']  = $updatestmtmethodResults['error']."\n";
                }
            }
        }

        if($errors) {
            $paramList = new ACF_ParameterList();
            $paramList->AddParameter(new ACF_DirectParameter('error',$errors['heading']));
            $paramList->AddParameter(new ACF_DirectParameter('errors',$errors));
            $paramList->AddParameter(new ACF_DirectParameter('returndata',$accountInfo));
            $retEvent = new ACF_Event('updatebillinginfo_fail');
            $retEvent->SetParameterList($paramList);
            return $retEvent;
        } else {
            return new ACF_Event('updatebillinginfo_success');
        }
    } else {
        return new ACF_Event('updatebillinginfo_fail');
    }
}

function AH_UpdatePassword (ACF_ParameterList $inParameterList) {
    if($inParameterList->ParameterValue('account')) {
        $accountInfo = $inParameterList->ParameterValue('account');
        $custData = GetCustomerData($_SESSION['piwi']['custid']);

        if($accountInfo['login']['oldpassword'] || $accountInfo['login']['newpassword'] || $accountInfo['login']['newpassword2']) {
            if($accountInfo['login']['newpassword'] == $accountInfo['login']['newpassword2']) {
                $updatepassResults = UpdatePassword($_SESSION['piwi']['custid'],$accountInfo['login']['oldpassword'],$accountInfo['login']['newpassword'],$accountInfo['login']['newpassword2']);
                if(!$updatepassResults['success']) {
                    if($errors['heading']) {
                        $errors['heading'] .= $updatepassResults['error']."\n";
                    } else {
                        $errors['heading']  = $updatepassResults['error']."\n";
                    }
                } else {
                    if($_SESSION['wow']['logintype'] == 'customer') { // if logged in as a customer, update the session so that WOW calls now work with the new password
                        $_SESSION['wow']['staffpass'] = $accountInfo['login']['newpassword'];
                        SetStaffLogin();
                    }
                }
            } else {
                if($errors['heading']) {
                    $errors['heading'] .= "The New Password Fields Do Not Match.\n";
                } else {
                    $errors['heading'] = "The New Password Fields Do Not Match.\n";
                }
            }
        } else {
            $oldsaveResults = launchUM($_SESSION['piwi']['custid'],'Old Save');
        }

        if($errors) {
            $paramList = new ACF_ParameterList();
            $paramList->AddParameter(new ACF_DirectParameter('error',$errors['heading']));
            $paramList->AddParameter(new ACF_DirectParameter('errors',$errors));
            $paramList->AddParameter(new ACF_DirectParameter('returndata',$accountInfo));
            $retEvent = new ACF_Event('updatepassword_fail');
            $retEvent->SetParameterList($paramList);
            return $retEvent;
        } else {
            return new ACF_Event('updatepassword_success');
        }
    } else {
        return new ACF_Event('updatepassword_fail');
    }
}

function AH_SendPassword (ACF_ParameterList $inParameterList) {
    $mailResults = EmailPassword(stripslashes_deep($inParameterList->ParameterValue('username')));
    if($mailResults['success']) {
        return new ACF_Event('sendpassword_success');
    } else {
        $paramList = new ACF_ParameterList();
        $paramList->AddParameter(new ACF_DirectParameter('error',$mailResults['error']));
        $retEvent = new ACF_Event('sendpassword_fail');
        $retEvent->SetParameterList($paramList);
        return $retEvent;
    }
}

function AH_CreateMultiLineInvoice (ACF_ParameterList $inParameterList) {
	global $wow;
	global $wowlogintype;

	$guarantor = $inParameterList->ParameterValue('guarantor');
	$comment = $inParameterList->ParameterValue('comment');
	$staff = $inParameterList->ParameterValue('staff');
	$itemArray = $inParameterList->ParameterValue('itemarray');

	$staffIdResult = ExecuteSQL("select num from staff where name = '".SQLTrim($staff)."'");
	$staffId = $staffIdResult['sqlreturn'][0]['num'];

	$wow->setMethod('CreateMultiLineInvoice');
	$wow->addAttribute('logintype',$wowlogintype);

	$wow->addParameter('custid',$_SESSION['piwi']['custid'],'integer');
	if ($guarantor) {
		$wow->addParameter('guarantorid',$_SESSION['piwi']['parentid'],'integer');
	} else {
		$wow->addParameter('guarantorid',0,'integer');
	}
	$wow->addParameter('staffid',$staffId,'integer');
	$wow->addParameter('comment',$comment);
	$wow->addParameter('itemarray',$itemArray,'array');
	$wow->addParameter('noconn',false,'boolean');
	$wow->addParameter('datatype','XML');

	$wow->addProperty('custid',$_SESSION['piwi']['custid']);

	if($wow->execute()) {
		$invoicenumber = $wow->getAttribute(0);

		$paramList = new ACF_ParameterList();
		$paramList->AddParameter(new ACF_DirectParameter('invoicenumber',$invoicenumber['invoice']));
		if ($guarantor) {
			$paramList->AddParameter(new ACF_DirectParameter('invoiceowner','Customer'));
		} else {
			$paramList->AddParameter(new ACF_DirectParameter('invoiceowner','Guarantor'));
		}
		$retEvent = new ACF_Event('createmultilineinvoice_success');
		$retEvent->SetParameterList($paramList);
		return $retEvent;
	} else {
		$paramList = new ACF_ParameterList();
		$paramList->AddParameter(new ACF_DirectParameter('error',$wow->lastError));
		$retEvent = new ACF_Event('createmultilineinvoice_failure');
		$retEvent->SetParameterList($paramList);
		return $retEvent;
	}
}


function AH_AddServiceTopup(ACF_ParameterList $inParameterList) {
	global $wow;
	global $wowlogintype;

	$ccdata = $inParameterList->ParameterValue('ccdata');

	$storedccdata = array();
    $storedccdata['number']             = $_SESSION['modules']['shared']['custdata']['customer']['ccnumber'];
    $storedccdata['numberMasked']       = $_SESSION['modules']['shared']['custdata']['customer']['creditcardmasked'];
    $prevccdata   = $_SESSION['piwi']['payment']['ccdata'];

    if($ccdata['number'] == $prevccdata['numberMasked']) {
        $ccdata['number']       = $prevccdata['number'];
        $ccdata['numberMasked'] = $prevccdata['numberMasked'];
    } else {
        if($ccdata['number'] == $storedccdata['numberMasked']) {
            $ccdata['number']       = $storedccdata['number'];
            $ccdata['numberMasked'] = $storedccdata['numberMasked'];
        } else {
        	if(strlen($ccdata['number']) > 4) {
	            $ccdata['numberMasked'] = str_repeat("*",strlen($ccdata['number'])-4).substr($ccdata['number'],strlen($ccdata['number'])-4);
	        }
        }
    }
	$_SESSION['piwi']['payment']['ccdata'] = $ccdata;


	$wow->setMethod('service_topup_charge');
	$wow->addAttribute('logintype', $wowlogintype);

	$wow->addParameter('top_up', $inParameterList->ParameterValue('top_up'));
	$wow->addParameter('svc_id', $inParameterList->ParameterValue('svc_id'));
	$wow->addParameter('data_id', $inParameterList->ParameterValue('data_id'));
	$wow->addParameter('CCNumber', $ccdata['number']);
	$wow->addParameter('CCName', $ccdata['name']);
    if($ccdata['month'] && $ccdata['year']) {
        switch($_SESSION['piwi']['dateformat']) {
        case "YMD":
            $wow->addParameter('ccexpire',date("Y/m/d",mktime(0,0,0,$ccdata['month']+1,0,$ccdata['year'])));
            break;
        case "DMY":
            $wow->addParameter('ccexpire',date("d/m/Y",mktime(0,0,0,$ccdata['month']+1,0,$ccdata['year'])));
            break;
        case "MDY":
            $wow->addParameter('ccexpire',date("m/d/Y",mktime(0,0,0,$ccdata['month']+1,0,$ccdata['year'])));
            break;
        default:
            $wow->addParameter('ccexpire',date("m/d/Y",mktime(0,0,0,$ccdata['month']+1,0,$ccdata['year'])));
        }
    } else {
        $wow->addParameter('ccexpire',false,'boolean');
    }
	$wow->addParameter('CCSecurityCode', $ccdata['cvv2']);
	$wow->addParameter('CCAddress', trim($ccdata['address']['addr1']." ".$ccdata['address']['addr2']));
	$wow->addParameter('CCCity', $ccdata['address']['city']);
	$wow->addParameter('CCState', $ccdata['address']['state']);
	$wow->addParameter('CCZip', $ccdata['address']['zip']);
	$wow->addParameter('CCCountry', $ccdata['address']['country']);

	$wow->addProperty('custid',$_SESSION['piwi']['custid'],'integer');

	if($wow->execute()) {
		$return = $wow->getAttribute(0);
	    $paramList = new ACF_ParameterList();
	    $paramList->AddParameter(new ACF_DirectParameter('invoice',$return['invoice']));
	    $paramList->AddParameter(new ACF_DirectParameter('payment',$return['payment']));
	    $paramList->AddParameter(new ACF_DirectParameter('fraudstatus',$return['fraudstatus']));
		$retEvent = new ACF_Event('addservicetopup_success');
	} else {
	    $paramList = new ACF_ParameterList();
		$paramList->AddParameter(new ACF_DirectParameter('error',$wow->lastError));
	    $paramList->AddParameter(new ACF_DirectParameter('svc_id',$inParameterList->ParameterValue('svc_id')));
	    $paramList->AddParameter(new ACF_DirectParameter('data_id',$inParameterList->ParameterValue('data_id')));
		$retEvent = new ACF_Event('addservicetopup_fail');
	}

	$retEvent->SetParameterList($paramList);
    return $retEvent;
}


function AH_LoginCheck(ACF_ParameterList $inParameterList) {
	global $wow;
	global $wowlogintype;

	if($inParameterList->ParameterValue('error')) {
		$error = $inParameterList->ParameterValue('error');
	}

	$retEvent = new ACF_Event('logincheck_home');

	$isActive = ExecuteSQL("select active from customer where id = ".SQLTrim($_SESSION['piwi']['custid']));
    if($isActive['success'] && $isActive['sqlreturn'][0]['active'] == 'H') {
      	$retEvent = new ACF_Event('logincheck_payment');
	} else {
		$wow->setMethod('service_topup_maxed_get');
		$wow->addAttribute('logintype', $wowlogintype);
		$wow->addProperty('custid',$_SESSION['piwi']['custid']);

		if($wow->execute()) {
			$svcMaxedTopups = $wow->getAttributesArray();
			if($svcMaxedTopups) {
				$paramList = new ACF_ParameterList();
				$paramList->AddParameter(new ACF_DirectParameter('error','Usage limits have been exceeded on the services below.  Please click the service name below to purchase additional usage.'));
				$retEvent = new ACF_Event('logincheck_topup');
				$retEvent->SetParameterList($paramList);
				return $retEvent;
			}
		}
	}

	return $retEvent;
}

?>
