<?php
/*---------------------------------------------------------------------------------------------------------*/
/*---- This file has performs the logging in and logging out of the helpdesk pages                     ----*/
/*---- These functions are invoked from the acf framework                                              ----*/
/*---------------------------------------------------------------------------------------------------------*/

require_once('../../libs/platypus/wow.inc.php');
require_once("../../libs/ccs/options.inc.php");
//---- load the CCS Options have to laod it here because this is the first manditory function call
if (!$_SESSION['ccs'])
    loadCCSOptions();

function AH_GetDefaults(ACF_ParameterList $inParameterList){
    $_SESSION['helpdesk']['staffid']                       = -1;
    $_SESSION['helpdesk']['customerid']                    = -1;
    $_SESSION['helpdesk']['view']                          = 'status';
    $_SESSION['helpdesk']['viewStaffTickets']              = -1;
    $_SESSION['helpdesk']['viewCustomerTickets']           = -1;
    $_SESSION['helpdesk']['customerContact']               = 'N';
    $_SESSION['helpdesk']['currentTickettreeView']         = 'staff';
    $_SESSION['helpdesk']['ticketCreationAssigned']        = -1;
    $_SESSION['helpdesk']['error']                         = '';
    $_SESSION['helpdesk']['alternateHeader']               = false;
    $_SESSION['helpdesk']['tickettree']['categoryFilters'] = array('None' => array('id' => '0', 'current' => true));

    if (!isset($_SESSION['helpdesk']['ticketid'])){
	$_SESSION['helpdesk']['ticketid']           = '0';
	$_SESSION['helpdesk']['oldticketid']        = '0';
    }
//---- assign the logintype, login,  and pass
    $_SESSION['helpdesk']['username']         = $_SESSION['wow']['staffname'];
    $_SESSION['helpdesk']['password']         = $_SESSION['wow']['staffpass'];
    if ($_SESSION['wow']['logintype'] == "staff")
	$_SESSION['helpdesk']['useCustWebTicket'] = false;
    else
	$_SESSION['helpdesk']['useCustWebTicket'] = $customer = true;

//---- if staff members are not allowed to login leave
    if (!$customer && (!isset($_SESSION['ccs']['options']['helpdesk-options']['staff-enabled']) ||
	    strtolower($_SESSION['ccs']['options']['helpdesk-options']['staff-enabled']) != 'true'))
	$error = 'Staff login has been disabled.';
//---- if customers are not allowed to login leave
    if (!$error && ($customer && (!isset($_SESSION['ccs']['options']['helpdesk-options']['customer-enabled']) ||
	    strtolower($_SESSION['ccs']['options']['helpdesk-options']['customer-enabled']) != 'true')))
	$error = 'Customer login has been disabled.';
    if (!$error){
	if (isset($_SESSION['piwi']['custid']) && ($inParameterList->ParameterValue('section') == 'tickets')){
	    $_SESSION['helpdesk']['currentTickettreeView'] = 'customer';
	    $_SESSION['helpdesk']['viewCustomerTickets']   = $_SESSION['piwi']['custid'];
	}else{
	    $_SESSION['helpdesk']['currentTickettreeView'] = 'staff';
	    $_SESSION['helpdesk']['viewStaffTickets']      = $_SESSION['piwi']['staffid'];
	}
    }else{
	$retEvent = new ACF_Event('GetDefaults_Failure');
	$parameterList = new ACF_ParameterList();
	$parameterList->AddParameter(new ACF_DirectParameter('error', $error));
	if (!$_SESSION['helpdesk']['useCustWebTicket'])
	    $parameterList->AddParameter(new ACF_DirectParameter('type', 'staff'));
	$retEvent->SetParameterList($parameterList);
	return $retEvent;
    }

    if (!$_SESSION['helpdesk']['useCustWebTicket']){
//---- get the defaults for viewing the tickettree
	$helpdesk = new WOW_Request('', '', 'wombat');
        $helpdesk->setMethod('get_Option');
        $helpdesk->setUsername($_SESSION['helpdesk']['username']);
        $helpdesk->setPassword($_SESSION['helpdesk']['password']);
	$helpdesk->addAttribute('logintype', 'staff');
        $helpdesk->addParameter('cOptionName', 'Ticket Queue-Default Staff');
        if ($helpdesk->execute())
            if ($helpdesk->getAttribute(0, 'get_Option') == 1)
                $_SESSION['helpdesk']['viewStaffTickets'] = 0;
//---- get the defaults for creating a new ticket
	$helpdesk = new WOW_Request('', '', 'wombat');
        $helpdesk->setMethod('get_Option');
        $helpdesk->setUsername($_SESSION['helpdesk']['username']);
        $helpdesk->setPassword($_SESSION['helpdesk']['password']);
	$helpdesk->addAttribute('logintype', 'staff');
        $helpdesk->addParameter('cOptionName', 'Ticket Creation-Default Assigned');
        if ($helpdesk->execute())
            if ($helpdesk->getAttribute(0, 'get_Option') == 1)
                $_SESSION['helpdesk']['ticketCreationAssigned'] = 0;
//---- get the category filters
	$helpdesk = new WOW_Request('', '', 'wombat');
        $helpdesk->setMethod('ticketTree_Get_Filters');
        $helpdesk->setUsername($_SESSION['helpdesk']['username']);
        $helpdesk->setPassword($_SESSION['helpdesk']['password']);
	$helpdesk->addAttribute('logintype', 'staff');
        if ($helpdesk->execute()){
             $results = $helpdesk->getAttributesArray();
	     foreach($results as $filter){
		  $_SESSION['helpdesk']['tickettree']['categoryFilters'][$filter['cft_name']]['id']      = $filter['cft_id'];
		  $_SESSION['helpdesk']['tickettree']['categoryFilters'][$filter['cft_name']]['current'] = false;
             }
        }
    }
//---- get the default security
    $_SESSION['helpdesk']['tickettree']['security'] = array();
    $helpdesk = new WOW_Request('', '', 'wombat');
    $helpdesk->setMethod('get_Security_Settings');
    $helpdesk->setUsername($_SESSION['helpdesk']['username']);
    $helpdesk->setPassword($_SESSION['helpdesk']['password']);
    $helpdesk->addAttribute('logintype', $_SESSION['helpdesk']['useCustWebTicket'] ? 'customer' : 'staff');
    if ($helpdesk->execute()){
         $results = $helpdesk->getAttributesArray();
         foreach($results as $sec){
             $_SESSION['helpdesk']['tickettree']['security'][$sec['tag']]  = $sec['value'];
         }
    }
//---- get the default views
    $helpdesk = new WOW_Request('', '', 'wombat');
    $helpdesk->setMethod('ticketTree_Get_Viewable');
    $helpdesk->setUsername($_SESSION['helpdesk']['username']);
    $helpdesk->setPassword($_SESSION['helpdesk']['password']);
    $helpdesk->addAttribute('logintype', $_SESSION['helpdesk']['useCustWebTicket'] ? 'customer' : 'staff');
    if ($helpdesk->execute()){
         $_SESSION['helpdesk']['tickettree']['viewable'] = array();
         $results = $helpdesk->getAttributesArray();
         foreach($results as $view){
	    $_SESSION['helpdesk']['tickettree']['viewable'][$view['view']][$view['id']]['name']  = $view['name'];
	    $_SESSION['helpdesk']['tickettree']['viewable'][$view['view']][$view['id']]['shown'] = $view['shown'];
         }
    }
//---- override the selected view with the cookie
    if (isset($_COOKIE['changeView' . $_SESSION['piwi']['staffid']])){
	$views = explode("&", $_COOKIE['changeView' . $_SESSION['piwi']['staffid']]);
	foreach($views as $value){
	    $item = substr($value, 0, strpos($value, "="));
	    $itemValue = substr($value, strlen($item) + 1);
	    if (strtolower($item) == 'view')
		$_SESSION['helpdesk']['view'] = $itemValue;
	}
    }

    return new ACF_Event('GetDefaults_Success');
}
?>
