<?php
require_once("platfunctions.php");
require_once("../../libs/platypus/wow.inc.php");
require_once("../../libs/ccs/options.inc.php");
require_once("../../libs/ccs/utilities.inc.php");

$stafflogin = $_SESSION['wow']['staffname'];
$staffpass  = $_SESSION['wow']['staffpass'];

global $wowlogintype;
$wowlogintype  = $_SESSION['wow']['logintype'] ? $_SESSION['wow']['logintype'] : 'staff';

global $wow;
$wow = new WOW_Request();
$wow->setUsername($stafflogin);
$wow->setPassword($staffpass);

global $storeid;
$storeid = $_SESSION['piwi']['storeid'] ? $_SESSION['piwi']['storeid'] : ($_SESSION['piwi']['defaultstore'] ? $_SESSION['piwi']['defaultstore'] : false);

function DC_GetHeaderInfo (ACF_ParameterList $inParameterList) {
    global $storeid;
    $header = GetHeader($_SESSION['piwi']['custid'],$_SESSION['piwi']['parentid'],$_SESSION['piwi']['displaystaffpages'],$_SESSION['piwi']['staffid'],$_SESSION['piwi']['staffname'],$_SESSION['piwi']['currentSection'],$_SESSION['piwi']['currentSubsection']);

    $header['storeid'] = $storeid;
    if (!isset($_SESSION['piwi']['dateformat']))
        $_SESSION['piwi']['dateformat'] = GetDateFormat();
    if (!$_SESSION['piwi']['dateformat'])
        $_SESSION['piwi']['dateformat'] = GetDateFormat();

    $header['dateformat'] = $_SESSION['piwi']['dateformat'];

    if(isset($header['customer']) && is_array($header['customer'])) {
        foreach($header['customer'] as &$thisField) {
            if($thisField == 'NULL' || $thisField == '') {
                $thisField = '';
            }
        }

        $laststmtTimestamp = strtotime($header['customer']['laststmt']);
        $nextstmtTimestamp = strtotime($header['customer']['nextstmt']);
        switch($_SESSION['piwi']['dateformat']) {
            case "YMD":
                $header['customer']['laststmt'] = date("Y/n/j",$laststmtTimestamp);
                $header['customer']['nextstmt'] = date("Y/n/j",$nextstmtTimestamp);
                $header['customer']['laststmtDisplay'] = date("Y F j",$laststmtTimestamp);
                $header['customer']['nextstmtDisplay'] = date("Y F j",$nextstmtTimestamp);
                break;
            case "DMY":
                $header['customer']['laststmt'] = date("j/n/Y",$laststmtTimestamp);
                $header['customer']['nextstmt'] = date("j/n/Y",$nextstmtTimestamp);
                $header['customer']['laststmtDisplay'] = date("j F Y",$laststmtTimestamp);
                $header['customer']['nextstmtDisplay'] = date("j F Y",$nextstmtTimestamp);
                break;
            case "MDY":
                $header['customer']['laststmt'] = date("n/j/Y",$laststmtTimestamp);
                $header['customer']['nextstmt'] = date("n/j/Y",$nextstmtTimestamp);
                $header['customer']['laststmtDisplay'] = date("F j, Y",$laststmtTimestamp);
                $header['customer']['nextstmtDisplay'] = date("F j, Y",$nextstmtTimestamp);
                break;
        }
    }

    // Get GST Options
    if($_SESSION['GST']) {
        $header['GST'] = $_SESSION['GST'];
    }

    $_SESSION['modules']['shared']['custdata'] = $header;

    $paramList = new ACF_ParameterList();
    $paramList->AddParameter(new ACF_DirectParameter('headerdata',$header));

    return $paramList;
}

function DC_GetCustomerRates (ACF_ParameterList $inParameterList) {
    $custrates = GetCustomerRates($_SESSION['piwi']['custid'],$inParameterList->ParameterValue('crid'));
    if(isset($custrates) && is_array($custrates)) {
        foreach($custrates as &$thisRate) {
            $thisRate['name'] = $thisRate['rg_name'] . ' - ' . $thisRate['cr_frequency'] . ' month' . ($thisRate['cr_frequency'] > 1 ? 's' : '');
        }
    }

    $paramList = new ACF_ParameterList();
    $paramList->AddParameter(new ACF_DirectParameter('custrates',$custrates));

    return $paramList;
}

function DC_GetCCSURL (ACF_ParameterList $inParameterList) {
    $paramList = new ACF_ParameterList();
    $paramList->AddParameter(new ACF_DirectParameter('ccs_url',$_SESSION['piwi']['options']['ccs-url']));
    return $paramList;
}

function DC_GetStaffNames (ACF_ParameterList $inParameterList) {
    $staffList = GetStaffNames();

    $paramList = new ACF_ParameterList();
    $paramList->AddParameter(new ACF_DirectParameter('stafflist',$staffList));

    return $paramList;
}

function DC_GetBlockRates (ACF_ParameterList $inParameterList) {
    $blockRates = GetBlockTime(true);

    $paramList = new ACF_ParameterList();
    $paramList->AddParameter(new ACF_DirectParameter('blockrates',$blockRates));

    return $paramList;
}

function DC_GetPaymentInfo (ACF_ParameterList $inParameterList) {
    $paymentTypes = GetPaymentTypes();
    if(isset($paymentTypes) && is_array($paymentTypes)) {
        foreach($paymentTypes as $thisPaymentType) {
            if($thisPaymentType['p_id'] == $_SESSION['piwi']['payment']['ccdata']['type']) {
                $_SESSION['piwi']['payment']['ccdata']['paymentType'] = $thisPaymentType['p_type'];
                break;
            }
        }
    }

    $paramList = new ACF_ParameterList();
    $paramList->AddParameter(new ACF_DirectParameter('paymentdata',$_SESSION['piwi']['payment']));
    return $paramList;
}

function DC_GetBillingData (ACF_ParameterLIst $inParameterList) {
    if($_SESSION['piwi']['payment']['ccdata']) {
        $ccdata = $_SESSION['piwi']['payment']['ccdata'];
    } else {
        $ccdata = false;
    }

    $paramList = new ACF_ParameterList();
    $paramList->AddParameter(new ACF_DirectParameter('ccdata',$ccdata));
    $paramList->AddParameter(new ACF_DirectParameter('paymenttype',$_SESSION['piwi']['payment']['paymentType']));

    return $paramList;
}

function DC_GetPhones (ACF_ParameterList $inParameterList) {
    $phoneData = GetPhones($_SESSION['piwi']['custid']);

    $paramList = new ACF_ParameterList();
    $paramList->AddParameter(new ACF_DirectParameter('phonedata',$phoneData));

    return $paramList;
}

function DC_GetAddresses (ACF_ParameterList $inParameterList) {
    $addressData = GetAddresses($_SESSION['piwi']['custid']);
    if($addressData) {
        $addressData = $addressData;
        if(isset($addressData) && is_array($addressData)) {
            foreach($addressData as &$thisAddress) {
                if(strpos($thisAddress['attn'],' ')) {
                    $thisAddress['fattn'] = substr($thisAddress['attn'],0,strpos($thisAddress['attn'],' '));
                    $thisAddress['lattn'] = substr($thisAddress['attn'],strpos($thisAddress['attn'],' ')+1);
                }
                if(strtolower($thisAddress['deflt']) == 'y' && $thisAddress['type'] == 5) {
                    $defaultCC = true;
                }
            }
        }
    }

    $paramList = new ACF_ParameterList();
    $paramList->AddParameter(new ACF_DirectParameter('addressdata',$addressData));
    if($defaultCC)
        $paramList->AddParameter(new ACF_DirectParameter('defaultcc',true));

    return $paramList;
}

function DC_GetCCAddress (ACF_ParameterList $inParameterList) {
    $ccAddress = GetAddresses($_SESSION['piwi']['custid'],'5');
    if($ccAddress)
        $ccAddress = stripslashes_deep($ccAddress);

    $paramList = new ACF_ParameterList();
    $paramList->AddParameter(new ACF_DirectParameter('ccaddress',$ccAddress));

    return $paramList;
}

function DC_GetSingleCustomerBundle (ACF_ParameterList $inParameterList) {
    global $storeid;

    $bundle = GetSingleBundle($storeid,$_SESSION['piwi']['custid'],$inParameterList->ParameterValue('crid'));

    $bundle['name'] = $bundle['rg_name'] . ' - ' . $bundle['cr_frequency'] . ' month' . ($bundle['cr_frequency'] > 1 ? 's' : '');
    $bundle['rg_frequency'] = $bundle['cr_frequency'];
    $bundle['rg_fixed_priceDisplay'] = ($bundle['price'] != 'NULL' && $bundle['price'] != '') ? ShowMoney($bundle['price']) : ShowMoney($bundle['rg_fixed_price']);
    $bundle['rg_one_time_feesDisplay'] = ShowMoney($bundle['rg_one_time_fees']);

    $paramList = new ACF_ParameterList();
    $paramList->AddParameter(new ACF_DirectParameter('bundle',$bundle));

    return $paramList;
}

function DC_GetUpgrades (ACF_ParameterList $inParameterList) {
    global $storeid;

    $rateData = GetCustomerRates($_SESSION['piwi']['custid']);
    if(isset($rateData) && is_array($rateData)) {
        foreach($rateData as $thisRate) {
            if($thisRate['crid'] == $inParameterList->ParameterValue('crid')) {
                $rgid = $thisRate['rgid'];
                break;
            }
        }
    }
    $upgradeData = GetUDPath($storeid,$rgid,'Upgrade',$_SESSION['piwi']['custid']);
    $bundleData = GetAvailableWebRates($storeid,$_SESSION['piwi']['custid'],false);

    if(isset($upgradeData) && is_array($upgradeData)) {
        $availableUpgrades = array();
        foreach($upgradeData as $thisUpgrade) {
            if(isset($bundleData) && is_array($bundleData)) {
                foreach($bundleData as &$thisBundle) {
                   if($thisUpgrade['rg_id'] == $thisBundle['rg_id'] && $thisUpgrade['r_frequency'] == $thisBundle['r_frequency']) {
                       $thisBundle['rg_fixed_priceDisplay'] = ShowMoney($thisBundle['rg_fixed_price']);
                       $thisBundle['rg_one_time_feesDisplay'] = ShowMoney($thisBundle['rg_one_time_fees']);
                       array_push($availableUpgrades,$thisBundle);
                       break;
                   }
                }
            }
        }
    } else {
        $availableUpgrades = false;
    }

    $paramList = new ACF_ParameterList();
    $paramList->AddParameter(new ACF_DirectParameter('availableupgrades',$availableUpgrades));

    return $paramList;
}

function DC_GetDowngrades (ACF_ParameterList $inParameterList) {
    global $storeid;

    $rateData = GetCustomerRates($_SESSION['piwi']['custid']);
    if(isset($rateData) && is_array($rateData)) {
        foreach($rateData as $thisRate) {
            if($thisRate['crid'] == $inParameterList->ParameterValue('crid')) {
                $rgid = $thisRate['rgid'];
                break;
            }
        }
    }

    $downgradeData = GetUDPath($storeid,$rgid,'Downgrade',$_SESSION['piwi']['custid']);
    $bundleData = GetAvailableWebRates($storeid,$_SESSION['piwi']['custid'],false);

    if(isset($downgradeData) && is_array($downgradeData)) {
        $availableDowngrades = array();
        foreach($downgradeData as $thisDowngrade) {
            if(isset($bundleData) && is_array($bundleData)) {
                foreach($bundleData as $thisBundle) {
                   if($thisDowngrade['id'] == $thisBundle['id']) {
                       array_push($availableDowngrades,$thisBundle);
                       break;
                   }
                }
            }
        }
    } else {
        $availableDowngrades = array();
    }

    $paramList = new ACF_ParameterList();
    $paramList->AddParameter(new ACF_DirectParameter('availabledowngrades',$availableDowngrades));

    return $paramList;
}

function DC_GetPaymentsEnabled (ACF_ParameterList $inParameterList) {
    $paymentsEnabled = true; //Assume online payments should be enabled

    if (!$_SESSION['piwi']['staffid']) { //If a customer is logged in, rather than a staff member
        $enableRealTime = ExecuteSQL("select value from options where name = 'Enable Real Time'"); //check the Plat 'Enable Real Time' option
        if(strtolower($enableRealTime['sqlreturn'][0]['value']) == 'n') { //if 'Enable Real Time' option is set to 'N'
            $paymentsEnabled = false; //disable payments because the payment would post without actually charging the customer.
        }
    }

    $paramList = new ACF_ParameterList();
    $paramList->AddParameter(new ACF_DirectParameter('paymentsenabled',$paymentsEnabled));

    if (!$paymentsEnabled) {
        $paramList->AddParameter(new ACF_DirectParameter('error','Online payments are unavailable at this time.'));
    }

    return $paramList;
}

function DC_GetInvoices (ACF_ParameterList $inParameterList) {
    $paramList = new ACF_ParameterList();

    if (!isset($_SESSION['piwi']['dateformat']))
        $_SESSION['piwi']['dateformat'] = GetDateFormat();
    if (!$_SESSION['piwi']['dateformat'])
        $_SESSION['piwi']['dateformat'] = GetDateFormat();

    if ($inParameterList->ParameterExists('paymentsenabled') && $inParameterList->ParameterValue('paymentsenabled') == false) {
        $paramList->AddParameter(new ACF_DirectParameter('invoicedata',false));
    } else {
        if($inParameterList->ParameterValue('nodates')) {
            $startdate = false;
            $enddate = false;
        } else {
            switch($_SESSION['piwi']['dateformat']) {
                case "YMD":
                    $default_enddate = date("Y/n/j");
                    $default_startdate = date("Y/n/j",strtotime("-6 months",time()));
                    break;
                case "DMY":
                    $default_enddate = date("j/n/Y");
                    $default_startdate = date("j/n/Y",strtotime("-6 months",time()));
                    break;
                case "MDY":
                    $default_enddate = date("n/j/Y");
                    $default_startdate = date("n/j/Y",strtotime("-6 months",time()));
                    break;
            }

            $startdate = $inParameterList->ParameterValue('startdate') ? $inParameterList->ParameterValue('startdate') : $default_startdate;
            $enddate = $inParameterList->ParameterValue('enddate') ? $inParameterList->ParameterValue('enddate') : $default_enddate;
        }

        $invoiceData = GetInvoices($_SESSION['piwi']['custid'],$inParameterList->ParameterValue('invoicetype'),$inParameterList->ParameterValue('owner'),false,$startdate,$enddate);

        if($invoiceData['success']) {
            if(isset($invoiceData['list']) && is_array($invoiceData['list'])) {
                foreach($invoiceData['list'] as &$thisInvoice) {
                    $thisInvoice['totalDisplay'] = ShowMoney($thisInvoice['total']);
                    $thisInvoice['paidDisplay']  = ShowMoney($thisInvoice['paid']);
                    $thisInvoice['dueDisplay']   = ShowMoney($thisInvoice['due']);
                    $invoiceTimestamp = strtotime($thisInvoice['date']);
                    switch($_SESSION['piwi']['dateformat']) {
                        case "YMD":
                            $thisInvoice['date'] = date("Y/n/j",$invoiceTimestamp);
                            $thisInvoice['longdate'] = date("Y F j",$invoiceTimestamp);
                            break;
                        case "DMY":
                            $thisInvoice['date'] = date("j/n/Y",$invoiceTimestamp);
                            $thisInvoice['longdate'] = date("j F Y",$invoiceTimestamp);
                            break;
                        case "MDY":
                            $thisInvoice['date'] = date("n/j/Y",$invoiceTimestamp);
                            $thisInvoice['longdate'] = date("F j, Y",$invoiceTimestamp);
                            break;
            }
                }
            } else {
                $invoiceData = false;
            }
        } else {
//            $error = $invoiceData['error'];
        }

        $paramList->AddParameter(new ACF_DirectParameter('invoicedata',$invoiceData['list']));

        if($startdate && $enddate) {
            $paramList->AddParameter(new ACF_DirectParameter('startdate',$startdate));
            $paramList->AddParameter(new ACF_DirectParameter('enddate',$enddate));
        }

        if($inParameterList->ParameterValue('invoicetype'))
        	$paramList->AddParameter(new ACF_DirectParameter('invoicetype',$inParameterList->ParameterValue('invoicetype')));

        if($inParameterList->ParameterValue('owner'))
        	$paramList->AddParameter(new ACF_DirectParameter('owner',$inParameterList->ParameterValue('owner')));

        if($error)
            $paramList->AddParameter(new ACF_DirectParameter('error',$error));
    }

    return $paramList;
}

function DC_GetInvoiceDetails (ACF_ParameterList $inParameterList) {
    $invoiceHeader = GetInvoices($_SESSION['piwi']['custid'],false,$inParameterList->ParameterValue('invoiceowner'),$inParameterList->ParameterValue('invoicenumber'));

    if (!isset($_SESSION['piwi']['dateformat']))
        $_SESSION['piwi']['dateformat'] = GetDateFormat();
    if (!$_SESSION['piwi']['dateformat'])
        $_SESSION['piwi']['dateformat'] = GetDateFormat();

    if($invoiceHeader['success']) {
        if(isset($invoiceHeader['list']) && is_array($invoiceHeader['list'])) {
            $invoiceHeader['list']['totalDisplay']      = ShowMoney($invoiceHeader['list']['total']);
            $invoiceHeader['list']['paidDisplay']       = ShowMoney($invoiceHeader['list']['paid']);
            $invoiceHeader['list']['dueDisplay']        = ShowMoney($invoiceHeader['list']['due']);
            $invoiceHeader['list']['subtotalDisplay']   = ShowMoney($invoiceHeader['list']['subtotal']);
            $invoiceHeader['list']['taxtotalDisplay']   = ShowMoney($invoiceHeader['list']['taxtotal']);
            $invoiceTimestamp = strtotime($invoiceHeader['list']['date']);
            switch($_SESSION['piwi']['dateformat']) {
                case "YMD":
                    $invoiceHeader['list']['date'] = date("Y/n/j",$invoiceTimestamp);
                    $invoiceHeader['list']['longdate'] = date("Y F j",$invoiceTimestamp);
                    break;
                case "DMY":
                    $invoiceHeader['list']['date'] = date("j/n/Y",$invoiceTimestamp);
                    $invoiceHeader['list']['longdate'] = date("j F Y",$invoiceTimestamp);
                    break;
                case "MDY":
                    $invoiceHeader['list']['date'] = date("n/j/Y",$invoiceTimestamp);
                    $invoiceHeader['list']['longdate'] = date("F j, Y",$invoiceTimestamp);
                    break;
            }
        } else {
            $invoiceHeader['list'] = false;
        }
    } else {
        $headerError = $invoiceHeader['error'];
    }

    $invoiceDetails = GetSingleInvoice($_SESSION['piwi']['custid'],$inParameterList->ParameterValue('invoicenumber'));

    if($invoiceDetails['success']) {
        if(isset($invoiceDetails['data']) && is_array($invoiceDetails['data'])) {
            foreach($invoiceDetails['data'] as &$thisDetail) {
                $thisDetail['priceDisplay']   = ShowMoney($thisDetail['price']);
                $thisDetail['amountDisplay']  = ShowMoney($thisDetail['amount']);
            }
        }
    } else {
        $detailError = $invoiceDetails['error'];
    }

    $invoiceData['header'] = $invoiceHeader['list'];
    $invoiceData['detail'] = $invoiceDetails['data'];

    $paramList = new ACF_ParameterList();
    $paramList->AddParameter(new ACF_DirectParameter('invoicedetail',$invoiceData));
    if($headerError || $detailError)
        $paramList->AddParameter(new ACF_DirectParameter('error',$headerError ? ($headerError . '<BR>') : '' . $detailError ? ($detailError . '<BR>') : ''));

    return $paramList;
}

function DC_GetCompanies (ACF_ParameterList $inParameterList) {
    global $storeid;

    $companyResults = ExecuteSQL("select * from stores where storeid = ".SQLTrim($storeid));

    $paramList = new ACF_ParameterList();
    $paramList->AddParameter(new ACF_DirectParameter('companydata',$companyResults['success'] ? $companyResults['sqlreturn'][0] : false));

    return $paramList;
}

function DC_GetStaffNameForInvoice (ACF_ParameterList $inParameterList) {
    $thisInvoice = GetInvoices($_SESSION['piwi']['custid'],false,false,$inParameterList->ParameterValue('invoicenumber'));

    $staffnum = $thisInvoice['list']['staffnum'] ? $thisInvoice['list']['staffnum'] : 0;
    $sqlQuery = "select name from staff where num = " . SQLTrim($staffnum);
    $staffnameResults = ExecuteSQL($sqlQuery);

    if($staffnameResults['success'] && is_array($staffnameResults['sqlreturn'])) {
        $staffname = $staffnameResults['sqlreturn'][0]['name'];
    }

    $paramList = new ACF_ParameterList();
    $paramList->AddParameter(new ACF_DirectParameter('staffname',$staffname));

    return $paramList;
}

function DC_ReviewBundleUpgrade (ACF_ParameterList $inParameterList) {
    global $storeid;
    if(!$_SESSION['piwi']['bundleupgradeData']) {
        $bundles = GetAvailableWebRates($storeid,$_SESSION['piwi']['custid'],false);
        $oldBundle = GetSingleBundle($storeid,$_SESSION['piwi']['custid'],$_SESSION['piwi']['bundleupgrade']['crid']);
        if(isset($bundles) && is_array($bundles)) {
            foreach($bundles as $thisBundle) {
                if($thisBundle['rg_id'] == $_SESSION['piwi']['bundleupgrade']['rgid'] && $thisBundle['r_frequency'] == $_SESSION['piwi']['bundleupgrade']['freq']) {
                    $newBundle = $thisBundle;
                    break;
                }
            }
        }
        $bundleReview['old'] = $oldBundle;
        $bundleReview['new'] = $newBundle;
        $bundleReview['crid'] = $_SESSION['piwi']['bundleupgrade']['crid'];
        $bundleReview['old']['rg_fixed_priceDisplay'] = ShowMoney($bundleReview['old']['rg_fixed_price']);
        $bundleReview['new']['rg_fixed_priceDisplay'] = ShowMoney($bundleReview['new']['rg_fixed_price']);
        $bundleReview['old']['rg_one_time_feesDisplay'] = ShowMoney($bundleReview['old']['rg_one_time_fees']);
        $bundleReview['new']['rg_one_time_feesDisplay'] = ShowMoney($bundleReview['new']['rg_one_time_fees']);

        $_SESSION['piwi']['bundleupgradeData'] = $bundleReview;
    }

    $paramList = new ACF_ParameterList();
    $paramList->AddParameter(new ACF_DirectParameter('bundlereview',$_SESSION['piwi']['bundleupgradeData']));

    return $paramList;
}

function DC_GetPayments (ACF_ParameterList $inParameterList) {
    if (!isset($_SESSION['piwi']['dateformat']))
        $_SESSION['piwi']['dateformat'] = GetDateFormat();
    if (!$_SESSION['piwi']['dateformat'])
        $_SESSION['piwi']['dateformat'] = GetDateFormat();

    if($inParameterList->ParameterValue('nodates')) {
        $startdate = false;
        $enddate = false;
    } else {
        switch($_SESSION['piwi']['dateformat']) {
            case "YMD":
                $default_enddate = date("Y/n/j");
                $default_startdate = date("Y/n/j",strtotime("-6 months",time()));
                break;
            case "DMY":
                $default_enddate = date("j/n/Y");
                $default_startdate = date("j/n/Y",strtotime("-6 months",time()));
                break;
            case "MDY":
                $default_enddate = date("n/j/Y");
                $default_startdate = date("n/j/Y",strtotime("-6 months",time()));
                break;
        }

        $startdate = $inParameterList->ParameterValue('startdate') ? $inParameterList->ParameterValue('startdate') : $default_startdate;
        $enddate = $inParameterList->ParameterValue('enddate') ? $inParameterList->ParameterValue('enddate') : $default_enddate;
    }

    $paymentData = GetPayments($_SESSION['piwi']['custid'],$startdate,$enddate);

    if(isset($paymentData) && is_array($paymentData)) {
        foreach($paymentData as &$thisPayment) {
            $thisPayment['pmt_totalDisplay']    = ShowMoney($thisPayment['pmt_total']);
            $thisPayment['pmt_appliedDisplay']  = ShowMoney($thisPayment['pmt_applied']);
//            $thisPayment['details']             = GetSinglePayment($_SESSION['piwi']['custid'],$thisPayment['pmt_id']);
//            if($thisPayment['details']['success']) {
//                $thisPayment['details'] = $thisPayment['details']['data'];
//            } else {
//                $thisPayment['details'] = false;
//            }
//            if(isset($thisPayment['details']) && is_array($thisPayment['details'])) {
//                foreach($thisPayment['details'] as &$thisDetail) {
//                    $thisDetail['pd_amountDisplay'] = ShowMoney($thisDetail['pd_amount']);
//                }
//            }
            $paymentTimestamp = strtotime($thisPayment['pmt_date']);
            switch($_SESSION['piwi']['dateformat']) {
                case "YMD":
                    $thisPayment['pmt_date'] = date("Y/n/j",$paymentTimestamp);
                    $thisPayment['longdate'] = date("Y F j",$paymentTimestamp);
                    break;
                case "DMY":
                    $thisPayment['pmt_date'] = date("j/n/Y",$paymentTimestamp);
                    $thisPayment['longdate'] = date("j F Y",$paymentTimestamp);
                    break;
                case "MDY":
                    $thisPayment['pmt_date'] = date("n/j/Y",$paymentTimestamp);
                    $thisPayment['longdate'] = date("F j, Y",$paymentTimestamp);
                    break;
            }
        }
    }

    $paramList = new ACF_ParameterList();
    $paramList->AddParameter(new ACF_DirectParameter('paymentdata',$paymentData));

    if($startdate && $enddate) {
        $paramList->AddParameter(new ACF_DirectParameter('startdate',$startdate));
        $paramList->AddParameter(new ACF_DirectParameter('enddate',$enddate));
    }

    return $paramList;
}

function DC_GetPaymentDetails (ACF_ParameterList $inParameterList) {
    $paymentData = GetSinglePayment($_SESSION['piwi']['custid'],$inParameterList->ParameterValue('paymentnumber'));

    if (!isset($_SESSION['piwi']['dateformat']))
        $_SESSION['piwi']['dateformat'] = GetDateFormat();
    if (!$_SESSION['piwi']['dateformat'])
        $_SESSION['piwi']['dateformat'] = GetDateFormat();

    if($paymentData['success']) {
        if(isset($paymentData['data']) && is_array($paymentData['data'])) {
            foreach($paymentData['data'] as &$thisPayment) {
                $thisPayment['pd_amountDisplay'] = ShowMoney($thisPayment['pd_amount']);
                $paymentTimestamp = strtotime($thisPayment['pd_applied']);
                switch($_SESSION['piwi']['dateformat']) {
                    case "YMD":
                        $thisPayment['pd_applied'] = date("Y/n/j",$paymentTimestamp);
                        $thisPayment['pd_appliedDisplay'] = date("Y F j",$paymentTimestamp);
                        break;
                    case "DMY":
                        $thisPayment['pd_applied'] = date("j/n/Y",$paymentTimestamp);
                        $thisPayment['pd_appliedDisplay'] = date("j F Y",$paymentTimestamp);
                        break;
                    case "MDY":
                        $thisPayment['pd_applied'] = date("n/j/Y",$paymentTimestamp);
                        $thisPayment['pd_appliedDisplay'] = date("F j, Y",$paymentTimestamp);
                        break;
                }
            }
        }
    }

    $paramList = new ACF_ParameterList();
    $paramList->AddParameter(new ACF_DirectParameter('paymentdetail',$paymentData['data']));
    if(!$paymentData['success'])
        $paramList->AddParameter(new ACF_DirectParameter('error',$paymentData['error']));

    return $paramList;
}

function DC_GetPayment (ACF_ParameterList $inParameterList) {
    $paymentData = GetPayments($_SESSION['piwi']['custid']);
    if(isset($paymentData) && is_array($paymentData)) {
        foreach($paymentData as $thisPayment) {
            if($thisPayment['pmt_id'] == $inParameterList->ParameterValue('paymentnumber')) {
                $payment = $thisPayment;
                break;
            }
        }
        $payment['details'] = GetSinglePayment($_SESSION['piwi']['custid'],$inParameterList->ParameterValue('paymentnumber'));

        $payment['pmt_totalDisplay']    = ShowMoney($payment['pmt_total']);
        $payment['pmt_appliedDisplay']  = ShowMoney($payment['pmt_applied']);
        if($payment['details']['success']) {
            $payment['details'] = $payment['details']['data'];
        } else {
            $payment['details'] = false;
        }

        if(isset($payment['details']) && is_array($payment['details'])) {
            foreach($payment['details'] as &$thisDetail) {
                $thisDetail['pd_amountDisplay'] = ShowMoney($thisDetail['pd_amount']);
            }
        }
    }

    $paramList = new ACF_ParameterList();
    $paramList->AddParameter(new ACF_DirectParameter('payment',$payment));

    return $paramList;
}

function DC_GetCurrentPaymentTotal (ACF_ParameterList $inParameterList) {
    $balanceDue = 0;

    $payInvoiceList = explode(",",$_SESSION['piwi']['payment']['invoiceList']);

    if(isset($payInvoiceList) && is_array($payInvoiceList)) {
        foreach($payInvoiceList as $payThisInvoice) {
            $thisInvoice = GetInvoices($_SESSION['piwi']['custid'],false,false,$payThisInvoice);
            $balanceDue += $thisInvoice['list']['due'];
        }
    }

    $balanceDue = ShowMoney($balanceDue);

    $paramList = new ACF_ParameterList();
    $paramList->AddParameter(new ACF_DirectParameter('balancedue',$balanceDue));

    return $paramList;
}

function DC_GetAvailableBundles (ACF_ParameterList $inParameterList) {
    global $storeid;

    $bundleData = GetAvailableWebRates($storeid,$_SESSION['piwi']['custid'],false);
    if(isset($bundleData) && is_array($bundleData)) {
        foreach($bundleData as &$thisBundle) {
            $thisBundle['id'] = $thisBundle['rg_id'] . 'X' . $thisBundle['r_frequency'];
            $thisBundle['name'] = $thisBundle['rg_name'] . ' - ' . $thisBundle['r_frequency'] . ' month' . ($thisBundle['r_frequency'] > 1 ? 's' : '');
            $thisBundle['rg_frequency'] = $thisBundle['r_frequency'];
            $thisBundle['rg_fixed_priceDisplay'] = ShowMoney($thisBundle['rg_fixed_price']);
            $thisBundle['rg_one_time_feesDisplay'] = ShowMoney($thisBundle['rg_one_time_fees']);
        }
    }

    $paramList = new ACF_ParameterList();
    $paramList->AddParameter(new ACF_DirectParameter('availablebundles',$bundleData));

    return $paramList;
}

function DC_GetNotes (ACF_ParameterList $inParameterList) {
    if($inParameterList->ParameterValue('shownotetype')) {
        $noteTypeArray = explode(",",$inParameterList->ParameterValue('shownotetype'));
        $noteIDType = $noteTypeArray[0];
        $notetype   = $noteTypeArray[1] == 'all' ? false : $noteTypeArray[1];
    }

    if(!$noteIDType)
        if($_SESSION['piwi']['custid'])
            $noteIDType = 'customer';
        else
            $noteIDType = 'staff';

    $noteList = GetNotes($_SESSION['piwi']['staffid'],$_SESSION['piwi']['custid'],$noteIDType,$notetype);

    $paramList = new ACF_ParameterList();
    $paramList->AddParameter(new ACF_DirectParameter('noteslist',$noteList));

    return $paramList;
}

function DC_GetSingleNote (ACF_ParameterList $inParameterList) {
    $noteID = $inParameterList->ParameterValue('noteid');
    $noteData = GetSingleNote($_SESSION['piwi']['staffid'],$_SESSION['piwi']['custid'],$noteID,'staff');

    $paramList = new ACF_ParameterList();
    $paramList->AddParameter(new ACF_DirectParameter('note',$noteData));

    return $paramList;
}

function DC_PopulateSQLField (ACF_ParameterList $inParameterList) {
    $parsefields = $inParameterList->ParameterValue('service');
    $fieldName = $inParameterList->ParameterValue('fieldname');

    $serviceData = GetServiceFields($_SESSION['piwi']['newservice']['svc_id'],$_SESSION['piwi']['newservice']['rgid'],$_SESSION['piwi']['newservice']['crid'],$_SESSION['piwi']['newservice']['branch'],$_SESSION['piwi']['newservice']['p_instance'],$_SESSION['piwi']['newservice']['p_service'],$_SESSION['piwi']['custid']);

    if(isset($serviceData) && is_array($serviceData)) {
        foreach($serviceData as $thisServiceField) {
            if($thisServiceField['datacol'] == $fieldName) {
                $sqlCommand = html_entity_decode($thisServiceField['mask']);
                break;
            }
        }
    }

    if(isset($parsefields) && is_array($parsefields)) {
        foreach($parsefields as $fieldName=>$fieldData) {
            $strValue = $fieldData['value'];
            $strValue = str_replace("'", "''", $strValue);
            $strValue = "'" . $strValue . "'";
            $sqlCommand = str_replace("'<<".$fieldName.">>'",$strValue,$sqlCommand);
            $sqlCommand = str_replace("<<".$fieldName.">>",$strValue,$sqlCommand);
        }
    }

    $sqlResults = ExecuteSQL($sqlCommand);
    if($sqlResults['success']) {
// Create Base XML
        $domdoc = new domDocument();
        $options = $domdoc->createElement('options');
        $domdoc->appendChild($options);

// Loop Through Fields
        if(isset($sqlResults['sqlreturn']) && is_array($sqlResults['sqlreturn'])) {
            foreach($sqlResults['sqlreturn'] as $sqlRow) {
// get number of fields returned in SQL statement -- one field means dropword, two fields means dropdown with first field being display value and second field being id
                $fieldCount = count($sqlRow);

                if($fieldCount == 1) {
                    foreach($sqlRow as $sqlFieldName=>$sqlFieldValue) {
                        $vals = array($sqlFieldValue,$sqlFieldValue);
                        $option = $options->appendChild($domdoc->createElement('option'));
                        $name = $option->appendChild($domdoc->createElement('name'));
                        $name->appendChild($domdoc->createTextNode($vals[1]));
                        $value = $option->appendChild($domdoc->createElement('value'));
                        $value->appendChild($domdoc->createTextNode($vals[0]));
                        break;
                    }
                } else if($fieldCount > 1) { // more than 1 returned, but just grab first 2 as display and id
                    $nextPass = false;
                    foreach($sqlRow as $sqlFieldName=>$sqlFieldValue) {
                        if(!$nextPass) {
                            $displayValue = $sqlFieldValue;
                        } else {
                            $idValue = $sqlFieldValue;
                        }

                        if($displayValue && $idValue) {
                            $vals = array($idValue,$displayValue);
                            $option = $options->appendChild($domdoc->createElement('option'));
                            $name = $option->appendChild($domdoc->createElement('name'));
                            $name->appendChild($domdoc->createTextNode($vals[1]));
                            $value = $option->appendChild($domdoc->createElement('value'));
                            $value->appendChild($domdoc->createTextNode($vals[0]));
                            unset($displayValue);
                            unset($idValue);
                            break;
                        } else {
                            $nextPass = true;
                        }
                    }
                }
            }
        }

        $xml = $domdoc->saveXML();
    }


    $paramList = new ACF_ParameterList();
    $paramList->AddParameter(new ACF_DirectParameter('xml',$xml));

    return $paramList;
}

function DC_GetServiceFields (ACF_ParameterList $inParameterList) {
    global $storeid;

    $hostPrefix = $_SESSION['ccs']['options']['driver-options']['url-prefix'].'://'.$_SERVER['HTTP_HOST']; // added for javascript support for sql fields

    $serviceData = GetServiceFields($_SESSION['piwi']['newservice']['svc_id'],$_SESSION['piwi']['newservice']['rgid'],$_SESSION['piwi']['newservice']['crid'],$_SESSION['piwi']['newservice']['branch'],$_SESSION['piwi']['newservice']['p_instance'],$_SESSION['piwi']['newservice']['p_service'],$_SESSION['piwi']['custid']);

    if($_SESSION['piwi']['newservice']['data_id']) { // support for manage page
        $singleService['fielddata'] = GetServiceDetail($_SESSION['piwi']['custid'],$_SESSION['piwi']['newservice']['svc_id'],$_SESSION['piwi']['newservice']['data_id']);
        if(!$_SESSION['piwi']['staffid']) { // return a read-only active status value if not logged in as staff
            switch($singleService['fielddata']['d_active']) {
            case 'Y':
                $singleService['active'] = 'Yes';
                $singleService['activeFlag'] = 'Y';
                break;
            case 'H':
                $singleService['active'] = 'Hold';
                $singleService['activeFlag'] = 'H';
                break;
            case 'S':
                $singleService['active'] = 'Suspend';
                $singleService['activeFlag'] = 'S';
                break;
            case 'N':
                $singleService['active'] = 'No';
                $singleService['activeFlag'] = 'N';
                break;
            default:
                $singleService['active'] = false;
                $singleService['activeFlag'] = false;
            }
        }
    } else {
        $singleService['fielddata'] = array('crid'=>$_SESSION['piwi']['newservice']['crid'],'d_custid'=>$_SESSION['piwi']['custid'],'d_storeid'=>$storeid,'d_struct_id'=>$_SESSION['piwi']['newservice']['branch'],'d_parent_id'=>$_SESSION['piwi']['newservice']['p_instance'],'d_parent_type'=>$_SESSION['piwi']['newservice']['p_service']);
            if(!$_SESSION['piwi']['staffid'])
                $singleService['active'] = 'Yes';
                $singleService['activeFlag'] = 'Y';
    }

    $service = array('id'=>$_SESSION['piwi']['newservice']['svc_id'],'d_custid'=>$_SESSION['piwi']['custid'],'rates'=>array(),'control'=>array());

    if($_SESSION['piwi']['staffid']) {
        $activefield = array('name'=>'d_active','trueType'=>'dropdown','default'=>'Y','header'=>'Active Status','mask'=>'','webdisplay'=>'E','type'=>'select','details'=>Array(0=>Array('name'=>'Yes','value'=>'Y'),1=>Array('name'=>'Hold','value'=>'H'),2=>Array('name'=>'Suspend','value'=>'S'),3=>Array('name'=>'No','value'=>'N')));
        array_push($service['control'], $activefield);
    }

    $service['name'] = $_SESSION['piwi']['newservice']['servicetype'];
    if(isset($serviceData) && is_array($serviceData)) {
        foreach($serviceData as $serviceItem) {
            $control                    = array();
            $control['name']            = strtolower($serviceItem['datacol']);
            $control['trueType']        = strtolower($serviceItem['ctrl']);
            $control['default']         = ($serviceItem['template_dflt'] && $serviceItem['template_dflt'] != 'NULL' && $serviceItem['template_dflt'] != '') ? $serviceItem['template_dflt'] : $serviceItem['dflt'];
            $control['header']          = $serviceItem['datahdr'];
            $control['mask']            = strtoupper($serviceItem['mask']);
            if($_SESSION['piwi']['newservice']['data_id'])
                $control['readonly']    = $_SESSION['piwi']['serviceList'][$_SESSION['piwi']['newservice']['svc_id']]['allowSave'] ? strtoupper($serviceItem['readonly']) : 'Y';
            else
                $control['readonly']    = strtoupper($serviceItem['readonly']);
            $control['webdisplay']      = strtoupper($serviceItem['uf_webdisplay']);
            $control['required']        = strtoupper($serviceItem['reqd']) == 'Y' ? true : false;

            if($control['webdisplay'] == 'H' && !$_SESSION['piwi']['staffid']) { // HIDDEN: hide from customers
                $control['webdisplay'] = 'hidden';
            } else {
                if($control['readonly'] == 'Y') { // READONLY: always read only
                    $control['webdisplay'] = 'readonly';
                } else {
                    if($control['readonly'] == 'E' && $singleService['fielddata'][$serviceItem['datacol']] != 'NULL' && $singleService['fielddata'][$serviceItem['datacol']] != '') { // CHANGEABLE WHEN BLANK
                        $control['webdisplay'] = 'readonly';
                    } else {
                        if($control['readonly'] == 'W' && $singleService['fielddata']['data_id']) { // CHANGEABLE WHEN NEW
                            $control['webdisplay'] = 'readonly';
                        } else {
                            if($control['webdisplay'] == 'R' && !$_SESSION['piwi']['staffid']) { // READONLY from web
                                $control['webdisplay'] = 'readonly';
                            } else {
                                $control['webdisplay'] = 'changeable';
                            }
                        }
                    }
                }
            }

            switch ($control['trueType']) {
            case 'datespinner':
            case 'txt_date':
                $control['type']      = 'text';
                $control['datefield'] = true;
                $control['value']     = $control['default'];
                break;

            case 'dropdown':
            case 'dropword':
                $control['type']            = 'select';
                $controlValues = ExecuteSQL("select * from ".SQLTrim($control['mask']));
                $control['details']         = array();

                if($controlValues['success'] && isset($controlValues['sqlreturn']) && is_array($controlValues['sqlreturn'])) {
                    foreach ($controlValues['sqlreturn'] as $value){
                        $details                = array();

                        if ($control['trueType'] == 'dropword') {
                            $details['value']   = $details['name'] = $value['value'];
                        } else {
                            $details['name']    = $value['value'];
                            $details['value']   = $value['id'];
                        }

                        array_push($control['details'], $details);
                    }
                }
                break;

            case 'dropdown_sql':
            case 'dropword_sql':
            case 'cmb_service_domain_sql':
                $control['type'] = 'sqlselect';
                $parseFields = array();
                $startFrom = 0;
                $control['mask'] = html_entity_decode(strtolower($control['mask']));
                while (strpos($control['mask'],'<<',$startFrom)) {
                    array_push($parseFields,'service['.strtolower(substr($control['mask'],strpos($control['mask'],'<<',$startFrom) + 2, strpos($control['mask'],'>>',$startFrom) - strpos($control['mask'],'<<',$startFrom) - 2)).'][value]');
                    $startFrom = strpos($control['mask'],'>>',$startFrom) + 2;
                }
                $control['parseFields'] = implode(',',$parseFields);

                $controlValues = ExecuteSQL(SQLTrim($control['mask']));
                $control['details']         = array();

                if($controlValues['success'] && isset($controlValues['sqlreturn']) && is_array($controlValues['sqlreturn'])) {
                    foreach ($controlValues['sqlreturn'] as $value){
                        $details                = array();

                        if ($control['trueType'] == 'dropword_sql') {
                            $details['value']   = $details['name'] = $value['value'];
                        } else {
                            $details['name']    = $value['value'];
                            $details['value']   = $value['id'];
                        }

                        array_push($control['details'], $details);
                    }
                }

                break;

            case 'lb_domain':
            case 'cmb_service_domain':
                $control['type']            = 'select';
                $controlValues = GetEmailDomains($_SESSION['piwi']['custid'],$control['mask']);
                $control['details']         = array();
                if(isset($controlValues) && is_array($controlValues)) {
                    foreach ($controlValues as $value){
                        $details                = array();
                        $details['value']       = $details['name'] = $value['domain'];

                        array_push($control['details'], $details);
                    }
                }
                break;

            case 'txt_emailaddr':
            case 'txt_service_email':
            case 'txt_guarpick':
            case 'txt_unique':
                $control['type']            = 'text';
                $control['maxLen']          = strlen($control['mask']) === 0 ? 250 : strlen($control['mask']);
                $control['value']           = $control['default'];
                break;

            case 'txt_username':
            case 'txt_service_username':
            case 'txt_service_username_with_domain':
                $control['type']            = 'text';
                $control['maxLen']          = strlen($control['mask']) === 0 ? 250 : strlen($control['mask']);
                $control['value']           = $control['default'];
                break;

            case 'txt_password':
                $control['type']            = 'password';
                $control['maxLen']          = strlen($control['mask']) === 0 ? 250 : strlen($control['mask']);
                $control['value']           = $control['default'];
                break;

            case 'txt_text':
                if ($control['mask'] == 'Y' || $control['mask'] == 'L') {
                    $control['type']        = 'select';
                    $control['details']     = array();
                    $options                = array();

                    if (!$control['required']) {
                        $options['value']   = '';
                        $options['name']    = '&nbsp;';
                        array_push($control['details'], $options);
                    }

                    $options['value']       = 'Y';
                    $options['name']        = 'Yes';
                    array_push($control['details'], $options);

                    $options['value']       = 'N';
                    $options['name']        = 'No';
                    array_push($control['details'], $options);
                } else {
                    $control['type']        = 'text';
                    $control['maxLen']      = strlen($control['mask']) === 0 ? 250 : strlen($control['mask']);
                    $control['value']       = $control['default'];
                }

                break;

            case 'chk_show_to_children':
                $control['type']            = 'select';
                $control['details']         = array();
                $options                    = array();
                $options['value']           = '1';
                $options['name']            = 'Yes';
                array_push($control['details'], $options);

                $options['value']           = '0';
                $options['name']            = 'No';
                array_push($control['details'], $options);
                break;

            case 'chk_checkbox':
                $control['type']            = 'checkbox';
                break;

            default:
                $control['type']            = '';
                $control['value']          = 'Not Yet Supported';
            }

            array_push($service['control'], $control);
        }
    }

    $paramList = new ACF_ParameterList();
    $paramList->AddParameter(new ACF_DirectParameter('servicedata',$service));

    if(isset($singleService['fielddata']) && is_array($singleService['fielddata'])) {
        foreach($singleService['fielddata'] as &$thisFieldValue) {
            if($thisFieldValue == 'NULL' || $thisFieldValue == '') {
                $thisFieldValue = false;
            }
        }

        $paramList->AddParameter(new ACF_DirectParameter('servicedetail',$singleService));
    }

    $paramList->AddParameter(new ACF_DirectParameter('hostprefix',$hostPrefix));

    return $paramList;
}

function DC_GetCustomerBundles (ACF_ParameterList $inParameterList) {
    global $storeid;

    $serviceData = $inParameterList->ParameterValue('services');
    $bundleData = GetDtlCustRates($storeid,$_SESSION['piwi']['custid'],$inParameterList->ParameterValue('crid'));

    $webrates = GetAvailableWebRates($storeid,$_SESSION['piwi']['custid'],false);
    $webrateList = array();
    if(isset($webrates) && is_array($webrates)) {
        foreach($webrates as $thisWebRate) {
            array_push($webrateList,$thisWebRate['rg_id']);
        }
    }

    if(isset($bundleData) && is_array($bundleData)) {
        foreach($bundleData as &$thisRate) {
            $thisRate['name'] = $thisRate['rg_name'] . ' - ' . $thisRate['cr_frequency'] . ' month' . ($thisRate['cr_frequency'] > 1 ? 's' : '');

            $upgradePath = GetUDPath($storeid,$thisRate['rg_id'],'Upgrade',$_SESSION['piwi']['custid']);
            if(isset($upgradePath) && is_array($upgradePath)) {
                foreach($upgradePath as $thisPath) {
                    if(in_array($thisPath['rg_id'],$webrateList)) {
                        $thisRate['upgradeable'] = true;
                    }
                }
            }

            $thisRate['services'] = $serviceData[$thisRate['crid']];

            if(is_array($thisRate['services']) && isset($thisRate['services'])) {

/* BEGIN TRANSFER CHECK */
                foreach($thisRate['services'] as &$thisServiceType) {
                    if($thisServiceType['rs_ccs_service'] == 'domain') {
                        $addUsed = ExecuteSQL("select addUsed = count(*) from billing_transaction, registered_domain_data where bt_service_type = 'domain' and (bt_transaction_type = 'transfer' or (bt_transaction_type = 'register' and right(bt_service_name,3) = '.ca')) and bt_last_action = 'Authorize' and bt_last_result = 'Success' and bt_service_name = domain and bt_customer_id = ".SQLTrim($_SESSION['piwi']['custid'])." and crid = ".SQLTrim($thisRate['crid']));

                        if($addUsed['success'] && isset($addUsed['sqlreturn']) && is_array($addUsed['sqlreturn']) & $addUsed['sqlreturn'][0]['addused'] > 0) {
                            $thisServiceType['rs_used'] += $addUsed['sqlreturn'][0]['addused'];
                        }

                        break;
                    }
                }
/* END TRANSFER CHECK */

            } else {
                $thisRate['services'] = false;
            }
        }
    }

    $paramList = new ACF_ParameterList();
    $paramList->AddParameter(new ACF_DirectParameter('bundledata',$bundleData));

    return $paramList;
}

function DC_GetServiceTree (ACF_ParameterList $inParameterList) {
    global $wow;
    global $wowlogintype;

    $data_id = $inParameterList->ParameterValue('data_id');
    $svc_id  = $inParameterList->ParameterValue('svc_id');
    $crid  = $inParameterList->ParameterValue('crid');

    $parentStack = array();

    if($data_id && $svc_id) {
        $local_data_id = $data_id;
        $local_svc_id  = $svc_id;
        do {
            if(isset($_SESSION['piwi']['serviceTree']) && is_array($_SESSION['piwi']['serviceTree'])) {
                foreach($_SESSION['piwi']['serviceTree'] as $thisBranch) {
                    if($thisBranch['rs_svc_id'] == $local_svc_id && isset($thisBranch['services']) && is_array($thisBranch['services'])) {
                        foreach($thisBranch['services'] as $thisInstance) {
                            if($thisInstance['s_num'] == $local_data_id) {
                                $parentService = $thisBranch;
                                $parentService['detail'] = $thisInstance;
                                unset($parentService['services']);
                                array_push($parentStack,$parentService);
                                $local_data_id = $parentService['rs_parent_instance'];
                                $local_svc_id = $parentService['rs_parent_service'];
                            }
                        }
                    }
                }
            }
        } while ($parentService['rs_parent_id'] != 0);

        $parentTree = array();

        if(count($parentStack) > 1) {
            for($stackCount = 1; $stackCount <= count($parentStack); $stackCount++) {
                $currentParent = $parentStack[count($parentStack) - $stackCount];
                array_push($parentTree,$currentParent);
            }
        } else if(count($parentStack) == 1) {
            $currentParent = $parentStack[0];
            $parentTree = $parentStack;
        } else { // used when deleting head of branch, to move up one level
            $parentStack = $_SESSION['piwi']['parentService']['tree'];
            array_pop($parentStack); // take now-removed element from tree
            if(count($parentStack) > 0) { // items still exist
                $currentParent = $parentStack[count($parentStack)-1];
                $parentTree = $parentStack;
                // also, change svc_id and data_id to match the new current parent
                $svc_id = $currentParent['detail']['s_svc_id'];
                $data_id = $currentParent['detail']['s_num'];
            } else { // no more items, go to top level
                unset($_SESSION['piwi']['parentService']);
                header("location:/projects/piwi/index.php/services");
            }
        }

        $parentData['tree'] = $parentTree;
        $parentData['current'] = $currentParent;
        $_SESSION['piwi']['parentService'] = $parentData;

        $serviceTree = array();

        if(isset($_SESSION['piwi']['serviceTree']) && is_array($_SESSION['piwi']['serviceTree'])) {
            foreach($_SESSION['piwi']['serviceTree'] as $thisBranch) {
                if($thisBranch['rs_parent_service'] == $svc_id && $thisBranch['rs_parent_instance'] == $data_id && (strtoupper($thisBranch['rs_hidden']) != 'Y' || $_SESSION['piwi']['staffid'])) {
                    array_push($serviceTree,$thisBranch);
                }
            }
            if(isset($serviceTree) && is_array($serviceTree)) {
                foreach($serviceTree as &$thisBranch) {
                    GetServiceCommands($thisBranch);
                }
            }
        }
    } else if ($svc_id) {
		unset($_SESSION['piwi']['parentService']);
        $serviceTree = array();
        $serviceTree['name'] = false;
        $serviceTree['list'] = array();
        if(isset($_SESSION['piwi']['serviceTree']) && is_array($_SESSION['piwi']['serviceTree'])) {
            foreach($_SESSION['piwi']['serviceTree'] as $thisService) {
                if($thisService['rs_svc_id'] == $svc_id) {
                    if(!$serviceTree['name']) {
                        $serviceTree['name'] = $thisService['rs_svc_type'];
                    }

                    array_push($serviceTree['list'],$thisService);
                }
            }
            if(isset($serviceTree['list']) && is_array($serviceTree['list'])) {
                foreach($serviceTree['list'] as &$thisBranch) {
                    GetServiceCommands($thisBranch);
                }
            }
        }
    } else if ($crid) {
    	unset($_SESSION['piwi']['parentService']);
        if(isset($_SESSION['piwi']['serviceTree']) && is_array($_SESSION['piwi']['serviceTree'])) {
            foreach($_SESSION['piwi']['serviceTree'] as $thisBranch) {
                if($thisBranch['rs_cr_id'] == $crid) {
                	if($thisBranch['rs_parent_id'] == 0 && (strtoupper($thisBranch['rs_hidden']) != 'Y' || $_SESSION['piwi']['staffid'])) {
						if(!is_array($serviceTree[$thisBranch['rs_cr_id']])) {
							$serviceTree[$thisBranch['rs_cr_id']] = array();
						}
                    	array_push($serviceTree[$thisBranch['rs_cr_id']],$thisBranch);
                    }
                }
            }
            if(isset($serviceTree) && is_array($serviceTree)) {
                foreach($serviceTree as &$thisRSRCID) {
                    foreach($thisRSRCID as &$thisBranch) {
                        GetServiceCommands($thisBranch);
                    }
                }
            }
        }
    } else {
    	unset($_SESSION['piwi']['parentService']);
        if(isset($_SESSION['piwi']['serviceTree']) && is_array($_SESSION['piwi']['serviceTree'])) {
            foreach($_SESSION['piwi']['serviceTree'] as $thisBranch) {
                if($thisBranch['rs_parent_id'] == 0 && (strtoupper($thisBranch['rs_hidden']) != 'Y' || $_SESSION['piwi']['staffid'])) {
                    if(!is_array($serviceTree[$thisBranch['rs_cr_id']])) {
                        $serviceTree[$thisBranch['rs_cr_id']] = array();
                    }

                    array_push($serviceTree[$thisBranch['rs_cr_id']],$thisBranch);
                }
            }
            if(isset($serviceTree) && is_array($serviceTree)) {
                foreach($serviceTree as &$thisRSRCID) {
                    foreach($thisRSRCID as &$thisBranch) {
                        GetServiceCommands($thisBranch);
                    }
                }
            }
        }
    }

    $paramList = new ACF_ParameterList();
    $paramList->AddParameter(new ACF_DirectParameter('services',$serviceTree));

    if($parentStack) {
        $paramList->AddParameter(new ACF_DirectParameter('parentservice',$parentData));
    }

    return $paramList;
}

function DC_GetParentTree (ACF_ParameterList $inParameterList) {
    $paramList = new ACF_ParameterList();
    $paramList->AddParameter(new ACF_DirectParameter('parenttree',$_SESSION['piwi']['parentService']));

    return $paramList;
}

function DC_GetServiceList (ACF_ParameterList $inParameterList) {
    $paramList = new ACF_ParameterList();
    $paramList->AddParameter(new ACF_DirectParameter('servicelist',$_SESSION['piwi']['serviceList']));

    return $paramList;
}

function DC_GetServices (ACF_ParameterList $inParameterList) {
    $serviceData = GetRateServices($_SESSION['piwi']['custid'],$inParameterList->ParameterValue('crid'));

    $paramList = new ACF_ParameterList();
    $paramList->AddParameter(new ACF_DirectParameter('servicedata',$serviceData));

    return $paramList;
}

function DC_GetServiceDisplay (ACF_ParameterList $inParameterList) {
    $serviceTree = $inParameterList->ParameterValue('servicetree');

    if(!GetBlockTime())
        $services['noblock'] = true;

    $paramList = new ACF_ParameterList();
    $paramList->AddParameter(new ACF_DirectParameter('services',$serviceTree));

    if($parentService) {
        $paramList->AddParameter(new ACF_DirectParameter('parentservice',$parentService));
    }

    return $paramList;
}

function DC_GetServiceHeader (ACF_ParameterList $inParameterList) {
    $serviceData = GetServiceHeader($_SESSION['piwi']['custid'],$inParameterList->ParameterValue('crid'));

    $paramList = new ACF_ParameterList();
    if(is_array($serviceData)) {
/* BEGIN TRANSFER CHECK */
        foreach($serviceData as &$thisServiceType) {
            if($thisServiceType['svc_ccs_service'] == 'domain') {
                $addUsed = ExecuteSQL("select addUsed = count(*) from billing_transaction, registered_domain_data where bt_service_type = 'domain' and (bt_transaction_type = 'transfer' or (bt_transaction_type = 'register' and right(bt_service_name,3) = '.ca')) and bt_last_action = 'Authorize' and bt_last_result = 'Success' and bt_service_name = domain and bt_customer_id = ".SQLTrim($_SESSION['piwi']['custid'])." and crid = ".SQLTrim($inParameterList->ParameterValue('crid')));

                if($addUsed['success'] && isset($serviceData) && is_array($serviceData) && $addUsed['sqlreturn'][0]['addused'] > 0) {
                    $thisServiceType['used'] += $addUsed['sqlreturn'][0]['addused'];
                }

                break;
            }
        }
/* END TRANSFER CHECK */
        $paramList->AddParameter(new ACF_DirectParameter('servicecount',$serviceData));
    } else {
        $paramList->AddParameter(new ACF_DirectParameter('servicecount',false));
    }

    return $paramList;
}

function DC_GetReferrals (ACF_ParameterList $inParameterList) {
    if($inParameterList->ParameterValue('type')) {
        $listtype = $inParameterList->ParameterValue('type');
    } else {
        $listtype = 'I';
    }

    if($listtype == 'D') {
        $payid = $inParameterList->ParameterValue('payid');
    }

    $referralData = GetBonuses('customer',$_SESSION['piwi']['custid'],$listtype,$payid);
    if(isset($referralData) && is_array($referralData)) {
        foreach($referralData as &$thisReferral) {
            $thisReferral['totalDisplay']  = ShowMoney($thisReferral['total']);
            $thisReferral['amountDisplay'] = ShowMoney($thisReferral['amount']);
            $thisReferral['paidDisplay']   = ShowMoney($thisReferral['paid']);
        }
    }

    $paramList = new ACF_ParameterList();
    $paramList->AddParameter(new ACF_DirectParameter('referraldata',$referralData));

    return $paramList;
}

function DC_GetCommissions (ACF_ParameterList $inParameterList) {
    if($inParameterList->ParameterValue('type')) {
        $listtype = $inParameterList->ParameterValue('type');
    } else {
        $listtype = 'I';
    }

    if($listtype == 'D') {
        $payid = $inParameterList->ParameterValue('payid');
    }

    $commissionData = GetBonuses('staff',$_SESSION['piwi']['staffid'],$listtype,$payid);
    if(isset($commissionData) && is_array($commissionData)) {
        foreach($commissionData as &$thisCommission) {
            $thisCommission['totalDisplay']  = ShowMoney($thisCommission['total']);
            $thisCommission['amountDisplay'] = ShowMoney($thisCommission['amount']);
            $thisCommission['paidDisplay']   = ShowMoney($thisCommission['paid']);
        }
    }

    $paramList = new ACF_ParameterList();
    $paramList->AddParameter(new ACF_DirectParameter('commissiondata',$commissionData));

    return $paramList;
}

function DC_GetServiceUsage (ACF_ParameterList $inParameterList) {
    global $storeid;

    if (!isset($_SESSION['piwi']['dateformat']))
        $_SESSION['piwi']['dateformat'] = GetDateFormat();
    if (!$_SESSION['piwi']['dateformat'])
        $_SESSION['piwi']['dateformat'] = GetDateFormat();

    $lbdData = ExecuteSQL("select date = min(lastbilled) from custrate where rgid in (select rg_id from rgheader where rg_fixed = '' or rg_fixed = 'N') and custid = ".SQLTrim($_SESSION['piwi']['custid']));
    if($lbdData['success'] && $lbdData['sqlreturn'][0]['date'] && $lbdData['sqlreturn'][0]['date'] != 'NULL' && $lbdData['sqlreturn'][0]['date'] != '') { // they have a usage based rate
        $startdate = strtotime($lbdData['sqlreturn'][0]['date']);
        $nbdData = ExecuteSQL("select date = max(nextbill) from custrate where rgid in (select rg_id from rgheader where rg_fixed = '' or rg_fixed = 'N') and lastbilled = '".SQLTrim(str_replace("T"," ",$lbdData['sqlreturn'][0]['date']))."' and custid = ".SQLTrim($_SESSION['piwi']['custid']));
        if($nbdData['success'] && $nbdData['sqlreturn'][0]['date'] != 'NULL' && $nbdData['sqlreturn'][0]['date'] != '') {
            $enddate = strtotime($nbdData['sqlreturn'][0]['date']);
        } else {
            $enddate = strtotime("+1 month",$startdate);
        }
    } else { // they don't have a usage based rate
        $cbdData = ExecuteSQL("select custbillday from customer where id = ".SQLTrim($_SESSION['piwi']['custid']));
        if($cbdData['success'] && $cbdData['sqlreturn'][0]['custbillday'] != 'NULL' && $cbdData['sqlreturn'][0]['custbillday'] != '') {
            if($cbdData['sqlreturn'][0]['custbillday'] <= date("j")) {
                $startdate = mktime(0,0,0,date("n"),$cbdData['sqlreturn'][0]['custbillday'],date("Y"));
                $enddate = strtotime("+1 month",$startdate);
            } else {
                $enddate = mktime(0,0,0,date("n"),$cbdData['sqlreturn'][0]['custbillday'],date("Y"));
                $startdate = strtotime("-1 month",$enddate);
            }
        } else { // the custbillday is not set for some reason
            $enddate = time();
            $startdate = strtotime("-1 month",$enddate);
        }
    }

    if($inParameterList->ParameterValue('startdate')) {
        $startdate = $inParameterList->ParameterValue('startdate');
    } else {
        switch($_SESSION['piwi']['dateformat']) {
            case "YMD":
                $startdate = date("Y/n/j",$startdate);
                break;
            case "DMY":
                $startdate = date("j/n/Y",$startdate);
                break;
            case "MDY":
                $startdate = date("n/j/Y",$startdate);
                break;
        }
    }

    if($inParameterList->ParameterValue('enddate')) {
        $enddate = $inParameterList->ParameterValue('enddate');
    } else {
        switch($_SESSION['piwi']['dateformat']) {
            case "YMD":
                $enddate = date("Y/n/j",$enddate);
                break;
            case "DMY":
                $enddate = date("j/n/Y",$enddate);
                break;
            case "MDY":
                $enddate = date("n/j/Y",$enddate);
                break;
        }
    }

    $usageData = array();

    if(isset($_SESSION['piwi']['serviceTree']) && is_array($_SESSION['piwi']['serviceTree'])) {
        foreach($_SESSION['piwi']['serviceTree'] as $thisBranch) {
            if(isset($thisBranch['services']) && is_array($thisBranch['services'])) {
                foreach($thisBranch['services'] as $thisService) {
                    $thisServiceUsage = GetServiceUsage($thisService['s_svc_id'],$thisService['s_num'],$startdate,$enddate,$thisService['s_struct_id']);
                    if(is_array($thisServiceUsage[0]['data_items'])) { // usage exists
                        $thisServiceUsage = $thisServiceUsage[0]['data_items'];
                        $svcname = substr($thisService['s_name'],0,strpos($thisService['s_name'],'#')-1);

                        if(is_array($thisServiceUsage['data_item'][0])) { // multiple billing definitions
                            foreach($thisServiceUsage['data_item'] as $thisBillingDefUsage) {
                                $thisBillingDefUsage = $thisBillingDefUsage['row'];
                                if(is_array($thisBillingDefUsage[0])) { // multiple usage data rows for this definition
                                    foreach($thisBillingDefUsage as $thisUsage) {
                                        if(!is_array($usageData[$svcname][$thisUsage['name']]['detail'][$thisService['s_data']])) {
                                            $usageData[$svcname][$thisUsage['name']]['detail'][$thisService['s_data']] = array();
                                        }

                                        $tmpArray = array();
                                        $usageData[$svcname][$thisUsage['name']]['header'] = array();
                                        if(is_array($thisUsage)) {
                                            foreach($thisUsage as $usageLabel=>$usageDetail) {
                                                switch($usageLabel) {
                                                case "name":
                                                    break;
                                                case "type":
                                                    $usageData[$svcname][$thisUsage['name']]['datatype'] = $usageDetail;
                                                    break;
                                                default:
                                                    $tmpArray[$usageLabel] = $usageDetail;
                                                    array_push($usageData[$svcname][$thisUsage['name']]['header'],$usageLabel);
                                                }
                                            }
                                        }

                                        if(count($usageData[$svcname][$thisUsage['name']]['header']) == 1) {
                                            $usageData[$svcname][$thisUsage['name']]['singleHeader'] =  $usageData[$svcname][$thisUsage['name']]['header'][0];
                                            unset($usageData[$svcname][$thisUsage['name']]['header']);
                                        }

                                        array_push($usageData[$svcname][$thisUsage['name']]['detail'][$thisService['s_data']],$tmpArray);
                                    }
                                } else { // one usage row for this definition
                                    if(!is_array($usageData[$svcname][$thisBillingDefUsage['name']]['detail'][$thisService['s_data']])) {
                                        $usageData[$svcname][$thisBillingDefUsage['name']]['detail'][$thisService['s_data']] = array();
                                    }

                                    $tmpArray = array();
                                    $usageData[$svcname][$thisBillingDefUsage['name']]['header'] = array();
                                    if(is_array($thisBillingDefUsage)) {
                                        foreach($thisBillingDefUsage as $usageLabel=>$usageDetail) {
                                            switch($usageLabel) {
                                            case "name":
                                                break;
                                            case "type":
                                                $usageData[$svcname][$thisBillingDefUsage['name']]['datatype'] = $usageDetail;
                                                break;
                                            default:
                                                $tmpArray[$usageLabel] = $usageDetail;
                                                array_push($usageData[$svcname][$thisBillingDefUsage['name']]['header'],$usageLabel);
                                            }
                                        }
                                    }

                                    if(count($usageData[$svcname][$thisBillingDefUsage['name']]['header']) == 1) {
                                        $usageData[$svcname][$thisBillingDefUsage['name']]['singleHeader'] =  $usageData[$svcname][$thisBillingDefUsage['name']]['header'][0];
                                        unset($usageData[$svcname][$thisBillingDefUsage['name']]['header']);
                                    }

                                    array_push($usageData[$svcname][$thisBillingDefUsage['name']]['detail'][$thisService['s_data']],$tmpArray);
                                }
                            }
                        } else { // one billing definition
                            if(is_array($thisServiceUsage['data_item']['row'][0])) { // multiple usage data rows for this definition
                                foreach($thisServiceUsage['data_item']['row'] as $thisUsage) {
                                    if(!is_array($usageData[$svcname][$thisUsage['name']]['detail'][$thisService['s_data']])) {
                                        $usageData[$svcname][$thisUsage['name']]['detail'][$thisService['s_data']] = array();
                                    }

                                    $tmpArray = array();
                                    $usageData[$svcname][$thisUsage['name']]['header'] = array();
                                    if(is_array($thisUsage)) {
                                        foreach($thisUsage as $usageLabel=>$usageDetail) {
                                            switch($usageLabel) {
                                            case "name":
                                                break;
                                            case "type":
                                                $usageData[$svcname][$thisUsage['name']]['datatype'] = $usageDetail;
                                                break;
                                            default:
                                                $tmpArray[$usageLabel] = $usageDetail;
                                                array_push($usageData[$svcname][$thisUsage['name']]['header'],$usageLabel);
                                            }
                                        }
                                    }

                                    if(count($usageData[$svcname][$thisUsage['name']]['header']) == 1) {
                                        $usageData[$svcname][$thisUsage['name']]['singleHeader'] =  $usageData[$svcname][$thisUsage['name']]['header'][0];
                                        unset($usageData[$svcname][$thisUsage['name']]['header']);
                                    }

                                    array_push($usageData[$svcname][$thisUsage['name']]['detail'][$thisService['s_data']],$tmpArray);
                                }
                            } else { // one usage row for this definition
                                $thisUsage = $thisServiceUsage['data_item']['row'];
                                if(!is_array($usageData[$svcname][$thisUsage['name']]['detail'][$thisService['s_data']])) {
                                    $usageData[$svcname][$thisUsage['name']]['detail'][$thisService['s_data']] = array();
                                }

                                $tmpArray = array();
                                $usageData[$svcname][$thisUsage['name']]['header'] = array();
                                if(is_array($thisUsage)) {
                                    foreach($thisUsage as $usageLabel=>$usageDetail) {
                                        switch($usageLabel) {
                                        case "name":
                                            break;
                                        case "type":
                                            $usageData[$svcname][$thisUsage['name']]['datatype'] = $usageDetail;
                                            break;
                                        default:
                                            $tmpArray[$usageLabel] = $usageDetail;
                                            array_push($usageData[$svcname][$thisUsage['name']]['header'],$usageLabel);
                                        }
                                    }
                                }

                                if(count($usageData[$svcname][$thisUsage['name']]['header']) == 1) {
                                    $usageData[$svcname][$thisUsage['name']]['singleHeader'] =  $usageData[$svcname][$thisUsage['name']]['header'][0];
                                    unset($usageData[$svcname][$thisUsage['name']]['header']);
                                }

                                array_push($usageData[$svcname][$thisUsage['name']]['detail'][$thisService['s_data']],$tmpArray);
                            }
                        }
                    }
                }
            }
        }
    }

    $paramList = new ACF_ParameterList();
    $paramList->AddParameter(new ACF_DirectParameter('serviceusagedata',$usageData));

    return $paramList;
}

function DC_GetUsage (ACF_ParameterList $inParameterList) {
    global $storeid;

    if (!isset($_SESSION['piwi']['dateformat']))
        $_SESSION['piwi']['dateformat'] = GetDateFormat();
    if (!$_SESSION['piwi']['dateformat'])
        $_SESSION['piwi']['dateformat'] = GetDateFormat();

    $lbdData = ExecuteSQL("select date = min(lastbilled) from custrate where rgid in (select rg_id from rgheader where rg_fixed = '' or rg_fixed = 'N') and custid = ".SQLTrim($_SESSION['piwi']['custid']));
    if($lbdData['success'] && $lbdData['sqlreturn'][0]['date'] && $lbdData['sqlreturn'][0]['date'] != 'NULL' && $lbdData['sqlreturn'][0]['date'] != '') { // they have a usage based rate
        $startdate = strtotime($lbdData['sqlreturn'][0]['date']);
        $nbdData = ExecuteSQL("select date = max(nextbill) from custrate where rgid in (select rg_id from rgheader where rg_fixed = '' or rg_fixed = 'N') and lastbilled = '".SQLTrim(str_replace("T"," ",$lbdData['sqlreturn'][0]['date']))."' and custid = ".SQLTrim($_SESSION['piwi']['custid']));
        if($nbdData['success'] && $nbdData['sqlreturn'][0]['date'] != 'NULL' && $nbdData['sqlreturn'][0]['date'] != '') {
            $enddate = strtotime($nbdData['sqlreturn'][0]['date']);
        } else {
            $enddate = strtotime("+1 month",$startdate);
        }
    } else { // they don't have a usage based rate
        $cbdData = ExecuteSQL("select custbillday from customer where id = ".SQLTrim($_SESSION['piwi']['custid']));
        if($cbdData['success'] && $cbdData['sqlreturn'][0]['custbillday'] && $cbdData['sqlreturn'][0]['custbillday'] != 'NULL' && $cbdData['sqlreturn'][0]['custbillday'] != '') {
            if($cbdData['sqlreturn'][0]['custbillday'] <= date("j")) {
                $startdate = mktime(0,0,0,date("n"),$cbdData['sqlreturn'][0]['custbillday'],date("Y"));
                $enddate = strtotime("+1 month",$startdate);
            } else {
                $enddate = mktime(0,0,0,date("n"),$cbdData['sqlreturn'][0]['custbillday'],date("Y"));
                $startdate = strtotime("-1 month",$enddate);
            }
        } else { // the custbillday is not set for some reason
            $enddate = time();
            $startdate = strtotime("-1 month",$enddate);
        }
    }

    if($inParameterList->ParameterValue('startdate')) {
        $usageData['startdate'] = $inParameterList->ParameterValue('startdate');
    } else {
        switch($_SESSION['piwi']['dateformat']) {
            case "YMD":
                $usageData['startdate'] = date("Y/n/j",$startdate);
                break;
            case "DMY":
                $usageData['startdate'] = date("j/n/Y",$startdate);
                break;
            case "MDY":
                $usageData['startdate'] = date("n/j/Y",$startdate);
                break;
        }
    }

    if($inParameterList->ParameterValue('enddate')) {
        $usageData['enddate'] = $inParameterList->ParameterValue('enddate');
    } else {
        switch($_SESSION['piwi']['dateformat']) {
            case "YMD":
                $usageData['enddate'] = date("Y/n/j",$enddate);
                break;
            case "DMY":
                $usageData['enddate'] = date("j/n/Y",$enddate);
                break;
            case "MDY":
                $usageData['enddate'] = date("n/j/Y",$enddate);
                break;
        }
    }

    $datain    = GetWebOption('data_in_unit',$storeid);
    $dataout   = GetWebOption('data_out_unit',$storeid);
    $datainout = GetWebOption('data_in_out_unit',$storeid);

    $smallMB = ExecuteSQL("select value from options where name = 'Small Megabytes'");

    if($smallMB['success'] && strtolower($smallMB['sqlreturn'][0]['value']) == 'y') {
        $mbFactor = 1000000.0;
        $gbFactor = 1000000000.0;
    } else {
        $mbFactor = 1048576.0;
        $gbFactor = 1073741824.0;
    }

    $usageData['summary'] = GetUsageSummary($_SESSION['piwi']['custid'],$usageData['startdate'],$usageData['enddate']);

    $usageData['totals'] = array();
    $usageData['totals']['calls'] = 0;
    $usageData['totals']['datain'] = 0;
    $usageData['totals']['dataout'] = 0;
    $usageData['totals']['datainout'] = 0;

    $hoursTotal = 0;
    $minutesTotal = 0;
    $secondsTotal = 0;

    if(isset($usageData['summary']) && is_array($usageData['summary'])) {
        foreach($usageData['summary'] as &$thisDay) {
            $timeArray = explode(':',$thisDay['ttltime']);
            if(isset($timeArray) && is_array($timeArray)) {
                $hoursTotal += $timeArray[0];
                $minutesTotal += $timeArray[1];
                $secondsTotal += $timeArray[2];
                foreach($timeArray as &$thisTimePart) {
                    if($thisTimePart < 10) {
                        $thisTimePart = '0'.$thisTimePart;
                    }
                }
                $thisDay['ttltime'] = implode(':',$timeArray);
            }
            $usageData['totals']['calls']     += $thisDay['calls'];

            switch($datain) {
            case '1':
                $usageData['totals']['datain']    += $thisDay['total_in'];
                break;
            case '2':
                $thisDay['total_in'] = round(($thisDay['total_in'] / $mbFactor),2);
                $usageData['totals']['datain']    += $thisDay['total_in'];
                break;
            case '3':
                $thisDay['total_in'] = round(($thisDay['total_in'] / $gbFactor),2);
                $usageData['totals']['datain']    += $thisDay['total_in'];
                break;
            }
            switch($dataout) {
            case '1':
                $usageData['totals']['dataout']    += $thisDay['total_out'];
                break;
            case '2':
                $thisDay['total_out'] = round(($thisDay['total_out'] / $mbFactor),2);
                $usageData['totals']['dataout']    += $thisDay['total_out'];
                break;
            case '3':
                $thisDay['total_out'] = round(($thisDay['total_out'] / $gbFactor),2);
                $usageData['totals']['dataout']    += $thisDay['total_out'];
                break;
            }
            switch($datainout) {
            case '1':
                $usageData['totals']['datainout']    += $thisDay['total_inout'];
                break;
            case '2':
                $thisDay['total_inout'] = round(($thisDay['total_inout'] / $mbFactor),2);
                $usageData['totals']['datainout']    += $thisDay['total_inout'];
                break;
            case '3':
                $thisDay['total_inout'] = round(($thisDay['total_inout'] / $gbFactor),2);
                $usageData['totals']['datainout']    += $thisDay['total_inout'];
                break;
            }

            $usageData['totals']['time']      += ($thisDay['avglen'] * $thisDay['calls']);
        }
    }

    if($usageData['totals']['calls'] > 0) {
        $usageData['totals']['avg']  = intval($usageData['totals']['time'] / $usageData['totals']['calls']);

        $minutesTotal = $minutesTotal + intval($secondsTotal / 60);
        $secondsTotal = $secondsTotal % 60;
        $hoursTotal   = $hoursTotal + intval($minutesTotal / 60);
        $minutesTotal = $minutesTotal % 60;

        if($hoursTotal < 10)
            $hoursTotal = '0'.$hoursTotal;
        if($minutesTotal < 10)
            $minutesTotal = '0'.$minutesTotal;
        if($secondsTotal < 10)
            $secondsTotal = '0'.$secondsTotal;

        $usageData['totals']['time'] = $hoursTotal.':'.$minutesTotal.':'.$secondsTotal;
    }

    switch($datain) {
        case '1':
            $usageData['options']['displayin'] = 'Bytes';
            break;
        case '2':
            $usageData['options']['displayin'] = 'MB';
            break;
        case '3':
            $usageData['options']['displayin'] = 'GB';
            break;
        default:
            $usageData['options']['displayin'] = false;
    }
    switch($dataout) {
        case '1':
            $usageData['options']['displayout'] = 'Bytes';
            break;
        case '2':
            $usageData['options']['displayout'] = 'MB';
            break;
        case '3':
            $usageData['options']['displayout'] = 'GB';
            break;
        default:
            $usageData['options']['displayout'] = false;
    }
    switch($datainout) {
        case '1':
            $usageData['options']['displayinout'] = 'Bytes';
            break;
        case '2':
            $usageData['options']['displayinout'] = 'MB';
            break;
        case '3':
            $usageData['options']['displayinout'] = 'GB';
            break;
        default:
            $usageData['options']['displayinout'] = false;
    }


    $paramList = new ACF_ParameterList();
    $paramList->AddParameter(new ACF_DirectParameter('usagedata',$usageData));

	$enableLegacy = ExecuteSQL("select value from options where name = 'Legacy Radius Support'");
	if($enableLegacy['success'])
		$paramList->AddParameter(new ACF_DirectParameter('enableLegacy',$enableLegacy['sqlreturn'][0]['value']));

	$enableInterim = ExecuteSQL("select value=case when date is null then 'N' else 'Y' end from appdata where name='Radius Interim Packet Logging Enabled'");
	if($enableInterim['success'])
		$paramList->AddParameter(new ACF_DirectParameter('enableInterim',$enableInterim['sqlreturn'][0]['value']));

    return $paramList;
}

function DC_GetUsageDetails (ACF_ParameterList $inParameterList) {
    $usageDate = $inParameterList->ParameterValue('usagedate');
    $usageDateArray = explode('/',$usageDate);

    if (!isset($_SESSION['piwi']['dateformat']))
        $_SESSION['piwi']['dateformat'] = GetDateFormat();
    if (!$_SESSION['piwi']['dateformat'])
        $_SESSION['piwi']['dateformat'] = GetDateFormat();

    switch($_SESSION['piwi']['dateformat']) {
        case "YMD":
            $usageDate = mktime(0,0,0,$usageDateArray[1],$usageDateArray[2],$usageDateArray[0]);
            $usageTotal = GetUsageSummary($_SESSION['piwi']['custid'],date("Y/n/j",$usageDate),date("Y/n/j",strtotime("+1 day",$usageDate)));
            break;
        case "DMY":
            $usageDate = mktime(0,0,0,$usageDateArray[1],$usageDateArray[0],$usageDateArray[2]);
            $usageTotal = GetUsageSummary($_SESSION['piwi']['custid'],date("j/n/Y",$usageDate),date("j/n/Y",strtotime("+1 day",$usageDate)));
            break;
        case "MDY":
            $usageDate = mktime(0,0,0,$usageDateArray[0],$usageDateArray[1],$usageDateArray[2]);
            $usageTotal = GetUsageSummary($_SESSION['piwi']['custid'],date("n/j/Y",$usageDate),date("n/j/Y",strtotime("+1 day",$usageDate)));
            break;
    }

    $usageData['total'] = $usageTotal[0];

    $datain    = GetWebOption('data_in_unit',$storeid);
    $dataout   = GetWebOption('data_out_unit',$storeid);
    $datainout = GetWebOption('data_in_out_unit',$storeid);

    if($storeid == 1 || !$storeid)
        $smallMB = ExecuteSQL("select value from options where name = 'Small Megabytes'");
    else
        $smallMB = ExecuteSQL("select value from store_options where name = 'Small Megabytes' and storeid = ".SQLTrim($storeid));

    if($smallMB['success'] && strtolower($smallMB['sqlreturn'][0]['value']) == 'y') {
        $mbFactor = 1000000.0;
        $gbFactor = 1000000000.0;
    } else {
        $mbFactor = 1048576.0;
        $gbFactor = 1073741824.0;
    }
    $usageData['calllist'] = GetDailyUsage($_SESSION['piwi']['custid'],$usageDate);

    if(isset($usageData['calllist']) && is_array($usageData['calllist'])) {
        foreach ($usageData['calllist'] as &$thisCall) {
            $tempTimeArray = explode(':',$thisCall['ttltime']);
            if(isset($tempTimeArray) && is_array($tempTimeArray)) {
                foreach($tempTimeArray as &$tempTimePart) {
                    if($tempTimePart < 10) {
                        $tempTimePart = '0'.$tempTimePart;
                    }
                }

                $thisCall['ttltime'] = implode(':',$tempTimeArray);
            }

            switch($datain) {
            case '2':
                $thisCall['total_in'] = round(($thisCall['total_in'] / $mbFactor),2);
                break;
            case '3':
                $thisCall['total_in'] = round(($thisCall['total_in'] / $gbFactor),2);
                break;
            }
            switch($dataout) {
            case '2':
                $thisCall['total_out'] = round(($thisCall['total_out'] / $mbFactor),2);
                break;
            case '3':
                $thisCall['total_out'] = round(($thisCall['total_out'] / $gbFactor),2);
                break;
            }
            switch($datainout) {
            case '2':
                $thisCall['total_inout'] = round(($thisCall['total_inout'] / $mbFactor),2);
                break;
            case '3':
                $thisCall['total_inout'] = round(($thisCall['total_inout'] / $gbFactor),2);
                break;
            }
        }
    }

    switch($datain) {
        case '1':
            $usageData['options']['displayin'] = 'Bytes';
            break;
        case '2':
            $usageData['options']['displayin'] = 'Megabytes';
            $usageData['total']['total_in'] = round(($usageData['total']['total_in'] / $mbFactor),2);
            break;
        case '3':
            $usageData['options']['displayin'] = 'Gigabytes';
            $usageData['total']['total_in'] = round(($usageData['total']['total_in'] / $gbFactor),2);
            break;
        default:
            $usageData['options']['displayin'] = false;
    }
    switch($dataout) {
        case '1':
            $usageData['options']['displayout'] = 'Bytes';
            break;
        case '2':
            $usageData['options']['displayout'] = 'Megabytes';
            $usageData['total']['total_out'] = round(($usageData['total']['total_out'] / $mbFactor),2);
            break;
        case '3':
            $usageData['options']['displayout'] = 'Gigabytes';
            $usageData['total']['total_out'] = round(($usageData['total']['total_out'] / $gbFactor),2);
            break;
        default:
            $usageData['options']['displayout'] = false;
    }
    switch($datainout) {
        case '1':
            $usageData['options']['displayinout'] = 'Bytes';
            break;
        case '2':
            $usageData['options']['displayinout'] = 'Megabytes';
            $usageData['total']['total_inout'] = round(($usageData['total']['total_inout'] / $mbFactor),2);
            break;
        case '3':
            $usageData['options']['displayinout'] = 'Gigabytes';
            $usageData['total']['total_inout'] = round(($usageData['total']['total_inout'] / $gbFactor),2);
            break;
        default:
            $usageData['options']['displayinout'] = false;
    }

    $paramList = new ACF_ParameterList();
    $paramList->AddParameter(new ACF_DirectParameter('usagedetails',$usageData));

    return $paramList;
}

function DC_GetPhoneTypes (ACF_ParameterList $inParameterList) {
    $typeList = ExecuteSQL('select * from phone_type');
    $phoneTypes = array();

    if($typeList['success'] && isset($typeList['sqlreturn']) && is_array($typeList['sqlreturn'])) {
        foreach($typeList['sqlreturn'] as $thisType) {
            $phoneTypes[$thisType['id']] = $thisType['name'];
        }
    }

    $paramList = new ACF_ParameterList();
    $paramList->AddParameter(new ACF_DirectParameter('phonetypes',$phoneTypes));

    return $paramList;
}

function DC_GetAddressTypes (ACF_ParameterList $inParameterList) {
    $typeList = ExecuteSQL('select * from address_type');
    $addressTypes = array();

    if($typeList['success'] && isset($typeList['sqlreturn']) && is_array($typeList['sqlreturn'])) {
        foreach($typeList['sqlreturn'] as $thisType) {
            $addressTypes[$thisType['id']] = $thisType['name'];
        }
    }

    $paramList = new ACF_ParameterList();
    $paramList->AddParameter(new ACF_DirectParameter('addresstypes',$addressTypes));

    return $paramList;
}

function DC_GetCCInfo (ACF_ParameterList $inParameterList) {
    $ccinfo = array();
    $ccinfo['ccyear'] = array();
    $ccinfo['ccmonth'] = array();

    if($_SESSION['piwi']['displaystaffpages']) {
        $paymentTypes = GetPaymentTypes();
    } else {
        $paymentTypes = GetPaymentTypes(true);
    }

    if(isset($paymentTypes) && is_array($paymentTypes)) {
        foreach($paymentTypes as $thisType) {
            // This is used to display payment types when editing an account
            // and when making a payment.  This needs to be split into two functions!
            //if (strtoupper($thisType['p_type']) == "CREDITCARD") {
                $ccinfo['cctypes'][$thisType['p_id']] = $thisType['p_name'];
            //}
        }
    }

    for($expyear=date("Y");$expyear<date("Y")+10;$expyear++)
        array_push($ccinfo['ccyear'],$expyear);

    for($expmonth=1;$expmonth<=12;$expmonth++) {
        if($expmonth<10)
            array_push($ccinfo['ccmonth'],'0'.$expmonth);
        else
            array_push($ccinfo['ccmonth'],$expmonth);
    }

    $ccinfo['cvv2Required'] = strtoupper(GetWebOption('show_card_sec_code',$storeid));

    if($storeid == 1 || !$storeid)
        $avsOption = ExecuteSQL("select value from options where name = 'Include AVS'");
    else
        $avsOption = ExecuteSQL("select value from store_options where name = 'Include AVS' and storeid = ".SQLTrim($storeid));

    if($avsOption['success'])
    	$ccinfo['includeAVS'] = strtoupper($avsOption['sqlreturn'][0]['value']);

    $paramList = new ACF_ParameterList();
    $paramList->AddParameter(new ACF_DirectParameter('ccinfo',$ccinfo));

    return $paramList;
}

function DC_GetReportCategories (ACF_ParameterList $inParameterList) {
    $categories = GetReportCategories();

    $paramList = new ACF_ParameterList();
    $paramList->AddParameter(new ACF_DirectParameter('categories',$categories));

    return $paramList;
}

function DC_GetReports (ACF_ParameterList $inParameterList) {
    $paramList = new ACF_ParameterList();
    $paramList->AddParameter(new ACF_DirectParameter('reports',$_SESSION['piwi']['reports']['reportlist'] ? $_SESSION['piwi']['reports']['reportlist'] : GetReports($_SESSION['piwi']['reports']['category'])));

    return $paramList;
}

function DC_GetSingleReport (ACF_ParameterList $inParameterList) {
    $report = GetSingleReport($_SESSION['piwi']['reports']['category'],$_SESSION['piwi']['reports']['id'],$_SESSION['piwi']['reports']['reportlist']);

    $paramList = new ACF_ParameterList();
    $paramList->AddParameter(new ACF_DirectParameter('report',$report));

    return $paramList;
}

function DC_RunReport (ACF_ParameterList $inParameterList) {
    $reportArray = $inParameterList->ParameterValue('reportinput');
    $reportInfo = GetSingleReport($_SESSION['piwi']['reports']['category'],$_SESSION['piwi']['reports']['id'],$_SESSION['piwi']['reports']['reportlist']);
    $fileName = $reportInfo['filename'].'.pdf';

    if($reportArray) {
        if($reportInfo['criteria']['date'] || $reportInfo['criteria']['daterange']) {
            if($reportArray['startdate']['month'] && $reportArray['startdate']['day'] && $reportArray['startdate']['year']) {
                if(checkdate($reportArray['startdate']['month'],$reportArray['startdate']['day'],$reportArray['startdate']['year'])) {
                    $reportArray['startdate']['formatted'] = $reportArray['startdate']['month'].'/'.$reportArray['startdate']['day'].'/'.$reportArray['startdate']['year'];
                }
            }

            if($reportArray['enddate']['month'] && $reportArray['enddate']['day'] && $reportArray['enddate']['year']) {
                if(checkdate($reportArray['enddate']['month'],$reportArray['enddate']['day'],$reportArray['enddate']['year'])) {
                    $reportArray['enddate']['formatted'] = $reportArray['enddate']['month'].'/'.$reportArray['enddate']['day'].'/'.$reportArray['enddate']['year'];
                }
            }

            if($reportArray['date']['month'] && $reportArray['date']['day'] && $reportArray['date']['year']) {
                if(checkdate($reportArray['date']['month'],$reportArray['date']['day'],$reportArray['date']['year'])) {
                    $reportArray['date']['formatted'] = $reportArray['date']['month'].'/'.$reportArray['date']['day'].'/'.$reportArray['date']['year'];
                }
            }
        }
    }

    $fileData = RunReport($reportArray,$_SESSION['piwi']['staffid']);

    $paramList = new ACF_ParameterList();
    $paramList->AddParameter(new ACF_DirectParameter('filedata',$fileData));
    $paramList->AddParameter(new ACF_DirectParameter('filename',$fileName));

    return $paramList;
}

function DC_RunInvoice (ACF_ParameterList $inParameterList) {
    $invoice = $inParameterList->ParameterValue('invoicenumber');
    $fileName = 'invoice'.$invoice.'.pdf';
    $_SESSION['piwi']['reports']['id'] = 341; // id of the invoice.rpt report in my database... will have to figure out how to make this dynamic
    $reportArray['id'] = $invoice;

    $fileData = RunReport($reportArray,1);

    $paramList = new ACF_ParameterList();
    $paramList->AddParameter(new ACF_DirectParameter('filedata',$fileData));
    $paramList->AddParameter(new ACF_DirectParameter('filename',$fileName));

    return $paramList;
}

function DC_GetWebRoot (ACF_ParameterList $inParameterList) {
    $paramList = new ACF_ParameterList();
    $paramList->AddParameter(new ACF_DirectParameter('path',dirname($_SERVER["SCRIPT_NAME"])));

    return $paramList;
}

function DC_GetStores (ACF_ParameterList $inParameterList) {
    $storesList = GetStores($_SESSION['piwi']['staffid']);

    $paramList = new ACF_ParameterList();
    $paramList->AddParameter(new ACF_DirectParameter('stores',$storesList));

    return $paramList;
}

function DC_GetStmtMethods (ACF_ParameterList $inParameterList) {
    global $storeid;

    $customerData = GetCustomerData($_SESSION['piwi']['custid']);
    $currentStmtMethod = strtoupper($customerData['stmtmethod']);

    $stmtmethods['list']['Paper'] = 'PAPER';
    $stmtmethods['list']['Email'] = 'EMAIL';
    $stmtmethods['list']['Credit Card'] = 'CREDIT CARD';
    $stmtmethods['list']['Direct Debit (ACH)'] = strtoupper(GetWebOption('achstmt',$storeid));
    if(!in_array($currentStmtMethod,$stmtmethods['list'])) {
        $stmtmethods['list'][$currentStmtMethod] = $currentStmtMethod;
    }

    if($currentStmtMethod == 'CREDIT CARD')
        $stmtmethods['required'] = 'CREDIT CARD';
    if($currentStmtMethod == $stmtmethods['list']['Direct Debit (ACH)'])
        $stmtmethods['required'] = 'ACH';

    $paramList = new ACF_ParameterList();
    $paramList->AddParameter(new ACF_DirectParameter('stmtmethods',$stmtmethods));

    return $paramList;
}

function DC_GetStatesList (ACF_ParameterList $inParameterList) {
    if (file_exists('../../etc/stateslist.xml')) {
        $statexml = simplexml_load_file('../../etc/stateslist.xml');
        $states = array();
        if($statexml)
            foreach($statexml as $state)
                $states[(string) $state->code] = (string) $state->name;
    }
    if (!$states) {
        $states = array(
            "AL" => "Alabama",
            "AK" => "Alaska",
            "AS" => "American Samoa",
            "AB" => "Alberta",
            "AZ" => "Arizona",
            "AR" => "Arkansas",
            "BC" => "British Columbia",
            "CA" => "California",
            "CO" => "Colorado",
            "CT" => "Connecticut",
            "DE" => "Deleware",
            "DC" => "District of Columbia",
            "FM" => "Federated States of Micronesia",
            "FL" => "Florida",
            "GA" => "Georgia",
            "GU" => "Guam",
            "HI" => "Hawaii",
            "ID" => "Idaho",
            "IL" => "Illinois",
            "IN" => "Indiana",
            "IA" => "Iowa",
            "KS" => "Kansas",
            "KY" => "Kentucky",
            "LA" => "Louisiana",
            "ME" => "Maine",
            "MB" => "Manitoba",
            "MH" => "Marshall Islands",
            "MD" => "Maryland",
            "MA" => "Massachusetts",
            "MI" => "Michigan",
            "MN" => "Minnesota",
            "MS" => "Mississippi",
            "MO" => "Missouri",
            "MT" => "Montana",
            "NE" => "Nebraska",
            "NV" => "Nevada",
            "NB" => "New Brunswick",
            "NH" => "New Hampshire",
            "NJ" => "New Jersey",
            "NM" => "New Mexico",
            "NY" => "New York",
            "NL" => "Newfoundland and Labrador",
            "NC" => "North Carolina",
            "ND" => "North Dakota",
            "MP" => "Northern Mariana Islands",
            "NT" => "Northwest Territories",
            "NS" => "Nova Scotia",
            "NU" => "Nunavut",
            "OH" => "Ohio",
            "OK" => "Oklahoma",
            "ON" => "Ontario",
            "OR" => "Oregon",
            "PW" => "Palau",
            "PA" => "Pennsylvania",
            "PE" => "Prince Edward Island",
            "PR" => "Puerto Rico",
            "QC" => "Quebec",
            "RI" => "Rhode Island",
            "SK" => "Saskatchewan",
            "SC" => "South Carolina",
            "SD" => "South Dakota",
            "TN" => "Tennessee",
            "TX" => "Texas",
            "UT" => "Utah",
            "VT" => "Vermont",
            "VI" => "Virgin Islands",
            "VA" => "Virginia",
            "WA" => "Washington",
            "WV" => "West Virginia",
            "WI" => "Wisconsin",
            "WY" => "Wyoming",
            "YT" => "Yukon"
        );
    }
    $paramList = new ACF_ParameterList();
    $paramList->AddParameter(new ACF_DirectParameter('states',$states));

    return $paramList;
}

function DC_GetCountriesList() {
    global $storeid;

    if (file_exists('../../etc/countrieslist.xml')) {
        $countryxml = simplexml_load_file('../../etc/countrieslist.xml');
        $countries = array();
        if($countryxml)
            foreach($countryxml as $country)
                $countries[(string) $country->code] = (string) $country->name;
    }

    if (!$countries) {
        $countries = array(
            "US" => "United States of America",
            "CA" => "Canada",
            "AF" => "Afghanistan",
            "AL" => "Albania",
            "DZ" => "Algeria",
            "AS" => "American Samoa",
            "AD" => "Andorra",
            "AI" => "Anguilla",
            "AQ" => "Antarctica",
            "AG" => "Antigua And Barbuda",
            "AR" => "Argentina",
            "AM" => "Armenia",
            "AW" => "Aruba",
            "AU" => "Australia",
            "AT" => "Austria",
            "AZ" => "Azerbaijan",
            "BS" => "Bahamas",
            "BH" => "Bahrain",
            "BD" => "Bangladesh",
            "BB" => "Barbados",
            "BY" => "Belarus",
            "BY" => "Belarus",
            "BE" => "Belgium",
            "BZ" => "Belize",
            "BJ" => "Benin",
            "BM" => "Bermuda",
            "BT" => "Bhutan",
            "BO" => "Bolivia",
            "BA" => "Bosnia And Herzegowina",
            "BW" => "Botswana",
            "BV" => "Bouvet Island",
            "BR" => "Brazil",
            "IO" => "British Indian Ocean Territory",
            "BN" => "Brunei Darussalam",
            "BG" => "Bulgaria",
            "BF" => "Burkina Faso",
            "BI" => "Burundi",
            "KH" => "Cambodia",
            "CM" => "Cameroon",
            "CV" => "Cape Verde",
            "KY" => "Cayman Islands",
            "CF" => "Central African Republic",
            "TD" => "Chad",
            "CL" => "Chile",
            "CN" => "China",
            "CX" => "Christmas Island",
            "CC" => "Cocos (Keeling) Islands",
            "CO" => "Colombia",
            "KM" => "Comoros",
            "CG" => "Congo",
            "CK" => "Cook Islands",
            "CR" => "Costa Rica",
            "CI" => "Cote D'ivoire",
            "HR" => "Croatia",
            "CY" => "Cyprus",
            "CZ" => "Czech Republic",
            "DK" => "Denmark",
            "DJ" => "Djibouti",
            "DM" => "Dominica",
            "DO" => "Dominican Republic",
            "TP" => "East Timor",
            "EC" => "Ecuador",
            "EG" => "Egypt",
            "SV" => "El Salvador",
            "GQ" => "Equatorial Guinea",
            "ER" => "Eritrea",
            "EE" => "Estonia",
            "ET" => "Ethiopia",
            "FK" => "Falkland Islands",
            "FO" => "Faroe Islands",
            "FJ" => "Fiji",
            "FI" => "Finland",
            "FR" => "France",
            "GF" => "French Guiana",
            "PF" => "French Polynesia",
            "TF" => "French Southern Territories",
            "GA" => "Gabon",
            "GM" => "Gambia",
            "GE" => "Georgia",
            "DE" => "Germany",
            "GH" => "Ghana",
            "GI" => "Gibraltar",
            "GR" => "Greece",
            "GL" => "Greenland",
            "GD" => "Grenada",
            "GP" => "Guadeloupe",
            "GU" => "Guam",
            "GT" => "Guatemala",
            "GN" => "Guinea",
            "GW" => "Guinea-Bissau",
            "GY" => "Guyana",
            "HT" => "Haiti",
            "HM" => "Heard And Mcdonald Islands",
            "HN" => "Honduras",
            "HK" => "Hong Kong",
            "HU" => "Hungary",
            "IS" => "Iceland",
            "IN" => "India",
            "ID" => "Indonesia",
            "IE" => "Ireland",
            "IL" => "Israel",
            "IT" => "Italy",
            "JM" => "Jamaica",
            "JP" => "Japan",
            "JO" => "Jordan",
            "KZ" => "Kazakstan",
            "KE" => "Kenya",
            "KI" => "Kiribati",
            "KR" => "Korea, Republic Of (South)",
            "KW" => "Kuwait",
            "KG" => "Kyrgyzstan",
            "LA" => "Lao People's Democratic Republic",
            "LV" => "Latvia",
            "LB" => "Lebanon",
            "LS" => "Lesotho",
            "LR" => "Liberia",
            "LI" => "Liechtenstein",
            "LT" => "Lithuania",
            "LU" => "Luxembourg",
            "MO" => "Macau",
            "MK" => "Macedonia",
            "MG" => "Madagascar",
            "MW" => "Malawi",
            "MY" => "Malaysia",
            "MV" => "Maldives",
            "ML" => "Mali",
            "MT" => "Malta",
            "MH" => "Marshall Islands",
            "MQ" => "Martinique",
            "MR" => "Mauritania",
            "MU" => "Mauritius",
            "YT" => "Mayotte",
            "MX" => "Mexico",
            "FM" => "Micronesia",
            "MD" => "Moldova, Republic Of",
            "MC" => "Monaco",
            "MN" => "Mongolia",
            "MS" => "Montserrat",
            "MA" => "Morocco",
            "MZ" => "Mozambique",
            "NA" => "Namibia",
            "NR" => "Nauru",
            "NP" => "Nepal",
            "NL" => "Netherlands",
            "AN" => "Netherlands Antilles",
            "NC" => "New Caledonia",
            "NZ" => "New Zealand",
            "NI" => "Nicaragua",
            "NE" => "Niger",
            "NG" => "Nigeria",
            "NU" => "Niue",
            "NF" => "Norfolk Island",
            "MP" => "Northern Mariana Islands",
            "NO" => "Norway",
            "OM" => "Oman",
            "PK" => "Pakistan",
            "PW" => "Palau",
            "PA" => "Panama",
            "PG" => "Papua New Guinea",
            "PY" => "Paraguay",
            "PE" => "Peru",
            "PH" => "Philippines",
            "PN" => "Pitcairn",
            "PL" => "Poland",
            "PT" => "Portugal",
            "PR" => "Puerto Rico",
            "QA" => "Qatar",
            "RE" => "Reunion",
            "RO" => "Romania",
            "RU" => "Russian Federation",
            "RW" => "Rwanda",
            "SH" => "Saint Helena",
            "KN" => "Saint Kitts And Nevis",
            "LC" => "Saint Lucia",
            "PM" => "Saint Pierre And Miquelon",
            "VC" => "Saint Vincent And The Grenadines",
            "WS" => "Samoa",
            "SM" => "San Marino",
            "ST" => "Sao Tome And Principe",
            "SA" => "Saudi Arabia",
            "SN" => "Senegal",
            "SC" => "Seychelles",
            "SL" => "Sierra Leone",
            "SG" => "Singapore",
            "SK" => "Slovakia",
            "SI" => "Slovenia",
            "SB" => "Solomon Islands",
            "SO" => "Somalia",
            "ZA" => "South Africa",
            "ES" => "Spain",
            "LK" => "Sri Lanka",
            "SR" => "Suriname",
            "SJ" => "Svalbard And Jan Mayen",
            "SZ" => "Swaziland",
            "SE" => "Sweden",
            "CH" => "Switzerland",
            "TW" => "Taiwan",
            "TJ" => "Tajikistan",
            "TZ" => "Tanzania",
            "TH" => "Thailand",
            "TG" => "Togo",
            "TK" => "Tokelau",
            "TO" => "Tonga",
            "TT" => "Trinidad And Tobago",
            "TN" => "Tunisia",
            "TR" => "Turkey",
            "TM" => "Turkmenistan",
            "TC" => "Turks And Caicos Islands",
            "TV" => "Tuvalu",
            "UG" => "Uganda",
            "UA" => "Ukraine",
            "AE" => "United Arab Emirates",
            "GB" => "United Kingdom",
            "UM" => "United States Minor Outlying Islands",
            "UY" => "Uruguay",
            "UZ" => "Uzbekistan",
            "VU" => "Vanuatu",
            "VA" => "Vatican City State (Holy See)",
            "VE" => "Venezuela",
            "VN" => "Viet Nam",
            "VG" => "Virgin Islands, (British)",
            "VI" => "Virgin Islands, (U.S.)",
            "WF" => "Wallis And Futuna",
            "EH" => "Western Sahara",
            "YE" => "Yemen",
            "YU" => "Yugoslavia",
            "ZM" => "Zambia",
            "ZW" => "Zimbabwe"
        );
    }

    $parameterList = new ACF_ParameterList();
    $parameterList->AddParameter(new ACF_DirectParameter('countries',$countries));
    $parameterList->AddParameter(new ACF_DirectParameter('display_country',strtoupper(GetWebOption('display_country',$storeid))));
    $parameterList->AddParameter(new ACF_DirectParameter('default_country',strtoupper(GetWebOption('default_country',$storeid))));
    return $parameterList;
}

function DC_GetOldPasswordRequired (ACF_ParameterList $inParameterList) {
    $paramList = new ACF_ParameterList();
    $paramList->AddParameter(new ACF_DirectParameter('oldpasswordrequired',SecurityCheck('Web Action Customer-Password-Require Old')));
    return $paramList;
}

function DC_GetRadiusUsage (ACF_ParameterList $inParameterList) {
	if ($_SESSION['piwi']['custid']) {
		$radius_svcid = 0;
		if($_SESSION['piwi']['serviceDefs']) {
			foreach($_SESSION['piwi']['serviceDefs'] as $thisServiceID=>$thisServiceType) {
				if($thisServiceType['svc_table'] == 'radius_data')
					$radius_svcid = $thisServiceID;
			}
		}

		if ($inParameterList->ParameterExists('radius_dataid')) {
			$instanceData['sqlreturn'][0]['data_id'] = $inParameterList->ParameterValue('radius_dataid');
		} else {
			if ($inParameterList->ParameterExists('all_dataid')) {
					$instanceData = ExecuteSQL("select data_id from radius_data where d_active<>'N' and d_custid=".SQLTrim($_SESSION['piwi']['custid']." order by data_id"));
			} else {
					$instanceData = ExecuteSQL("select data_id from radius_data where data_id in (select min(data_id) from radius_data where d_active<>'N' and d_custid=".SQLTrim($_SESSION['piwi']['custid'].")"));
			}
			if($instanceData['success']) {
				$dataid = $instanceData['sqlreturn'][0]['data_id'];
			} else {
				$instanceData['sqlreturn'][0]['data_id'] = 0;
			}
		}

		$smallMB = ExecuteSQL("select value from options where name = 'Small Megabytes'");

		if($smallMB['success'] && strtolower($smallMB['sqlreturn'][0]['value']) == 'y') {
			$gbFactor = 1000000000.0;
		} else {
			$gbFactor = 1073741824.0;
		}

		$radiusData = array();
		foreach($instanceData['sqlreturn'] as $thisKey=>$dataid) {
			$svcdata = GetServiceDetail($_SESSION['piwi']['custid'],$radius_svcid,$dataid);

			if(is_array($svcdata)) {
				$svcdata['up_down_used'] = $svcdata['up_used'] + $svcdata['down_used'];

				$svcdata['up_limit_remaining'] = ($svcdata['up_limit'] - $svcdata['up_used']);
				if(!empty($svcdata['up_limit_topup'])) {
					$svcdata['up_limit_remaining'] = $svcdata['up_limit_remaining'] + $svcdata['up_limit_topup'];
					$svcdata['up_limit'] = $svcdata['up_limit'] + $svcdata['up_limit_topup'];
				}

				$svcdata['down_limit_remaining'] = ($svcdata['down_limit'] - $svcdata['down_used']);
				if(!empty($svcdata['down_limit_topup'])) {
					$svcdata['down_limit_remaining'] = $svcdata['down_limit_remaining'] + $svcdata['down_limit_topup'];
					$svcdata['down_limit'] = $svcdata['down_limit'] + $svcdata['down_limit_topup'];
				}

				$svcdata['up_down_limit_remaining'] = ($svcdata['up_down_limit'] - $svcdata['up_down_used']);
				if(!empty($svcdata['up_down_limit_topup'])) {
					$svcdata['up_down_limit_remaining'] = $svcdata['up_down_limit_remaining'] + $svcdata['up_down_limit_topup'];
					$svcdata['up_down_limit'] = $svcdata['up_down_limit'] + $svcdata['up_down_limit_topup'];
				}

				$svcdata['maximum_value'] = max(max(max($svcdata['up_limit'],$svcdata['down_limit']),$svcdata['up_down_limit']),$svcdata['up_down_used']) / $gbFactor;

				$svcdata['up_down_used'] = $svcdata['up_down_used'] / $gbFactor;
				$svcdata['up_used'] = $svcdata['up_used'] / $gbFactor;
				$svcdata['down_used'] = $svcdata['down_used'] / $gbFactor;
				$svcdata['up_limit'] = $svcdata['up_limit'] / $gbFactor;
				$svcdata['down_limit'] = $svcdata['down_limit'] / $gbFactor;
				$svcdata['up_down_limit'] = $svcdata['up_down_limit'] / $gbFactor;
				$svcdata['up_limit_remaining'] = $svcdata['up_limit_remaining'] / $gbFactor;
				$svcdata['down_limit_remaining'] = $svcdata['down_limit_remaining'] / $gbFactor;
				$svcdata['up_down_limit_remaining'] = $svcdata['up_down_limit_remaining'] / $gbFactor;

				$svcdata['time_limit_remaining'] = $svcdata['time_limit'] - $svcdata['time_used'];
				if(!empty($svcdata['time_limit_topup'])) {
					$svcdata['time_limit_remaining'] = $svcdata['time_limit_remaining'] + $svcdata['time_limit_topup'];
					$svcdata['time_limit'] = $svcdata['time_limit'] + $svcdata['time_limit_topup'];
				}

				$svcdata['time_limit_remaining_display'] = sec2hms($svcdata['time_limit'] - $svcdata['time_used'],true);
				$svcdata['time_limit_display'] = sec2hms($svcdata['time_limit'],true);
				$svcdata['time_used_display'] = sec2hms($svcdata['time_used'],true);

				if(empty($svcdata['last_reset_date']))
						$svcdata['usage_period'] = '';
				else
					$svcdata['usage_period'] = ' since '.date('F j, Y, g:i:a',strtotime($svcdata['last_reset_date']));

				$limit_count = 0;
				if($svcdata['up_limit']>0)
					$limit_count++;
				if($svcdata['down_limit']>0)
					$limit_count++;
				if($svcdata['up_down_limit']>0)
					$limit_count++;
				if($svcdata['time_limit']>0)
					$limit_count++;

				$svcdata['limit_count'] = $limit_count;
			}
			$radiusData[$thisKey] = $svcdata;
		}
	} else {
		$radiusData = false;
	}

    $paramList = new ACF_ParameterList();
    $paramList->AddParameter(new ACF_DirectParameter('radiusdata',$radiusData));
    return $paramList;
}

function DC_GetRadiusUsageHistory (ACF_ParameterList $inParameterList) {
	if ($_SESSION['piwi']['custid']) {
		if ($inParameterList->ParameterExists('radius_dataid')) {
			$instanceData['sqlreturn'][0]['data_id'] = $inParameterList->ParameterValue('radius_dataid');
		} else {
			if ($inParameterList->ParameterExists('all_dataid')) {
					$instanceData = ExecuteSQL("select data_id,time_limit from radius_data where d_active<>'N' and d_custid=".SQLTrim($_SESSION['piwi']['custid']." order by data_id"));
			} else {
					$instanceData = ExecuteSQL("select data_id,time_limit from radius_data where data_id in (select min(data_id) from radius_data where d_active<>'N' and d_custid=".SQLTrim($_SESSION['piwi']['custid'].")"));
			}
			if($instanceData['success']) {
				$dataid = $instanceData['sqlreturn'][0]['data_id'];
			} else {
				$instanceData['sqlreturn'][0]['data_id'] = 0;
			}
		}

		$smallMB = ExecuteSQL("select value from options where name = 'Small Megabytes'");

		if($smallMB['success'] && strtolower($smallMB['sqlreturn'][0]['value']) == 'y') {
			$gbFactor = 1000000000.0;
		} else {
			$gbFactor = 1073741824.0;
		}

		$radiusHistoryData = array();
		foreach($instanceData['sqlreturn'] as $thisInstance) {
			$historydata = GetRadiusUsageHistory($thisInstance['data_id']);
			foreach($historydata as & $thisRow) {
				$thisRow['upload'] = round($thisRow['upload'] / $gbFactor,2);
				$thisRow['download'] = round($thisRow['download'] / $gbFactor,2);
				$thisRow['combined'] = round($thisRow['combined'] / $gbFactor,2);
				$thisRow['time'] = $thisRow['time'] / 3600;
				$thisRow['current_time_limit'] = $thisInstance['time_limit'];
			}
			$radiusHistoryData[$thisInstance['data_id']] = $historydata;
		}
	} else {
		$radiusHistoryData = false;
	}

    $paramList = new ACF_ParameterList();
    $paramList->AddParameter(new ACF_DirectParameter('radiushistorydata',$radiusHistoryData));
    return $paramList;
}

function DC_GetRadiusUsageDetailsDaily (ACF_ParameterList $inParameterList) {
	if ($_SESSION['piwi']['custid']) {
		if ($inParameterList->ParameterExists('radius_dataid')) {
			$instanceData = ExecuteSQL("select username from radius_data where data_id=".SQLTrim($inParameterList->ParameterValue('radius_dataid'))." and d_custid=".SQLTrim($_SESSION['piwi']['custid']));
		} else {
			if ($inParameterList->ParameterExists('all_dataid')) {
					$instanceData = ExecuteSQL("select username from radius_data where d_active<>'N' and d_custid=".SQLTrim($_SESSION['piwi']['custid'])." order by data_id");
			} else {
					$instanceData = ExecuteSQL("select username from radius_data where data_id in (select min(data_id) from radius_data where d_active<>'N' and d_custid=".SQLTrim($_SESSION['piwi']['custid']).")");
			}
		}
		if(!$instanceData['success']) {
			$instanceData['sqlreturn'][0]['username'] = "";
		}

		$paramStartDate = date('Y-m-d', strtotime("-30 days"));
		if ($inParameterList->ParameterExists('radiusdailystartdate')) {
			$mytemp = $inParameterList->ParameterValue('radiusdailystartdate');
			if (!empty($mytemp)) {
				$paramStartDate = date('Y-m-d', strtotime($inParameterList->ParameterValue('radiusdailystartdate')));
			}
		}

		$paramEndDate = date('Y-m-d', strtotime($paramStartDate."+30 days"));

		$smallMB = ExecuteSQL("select value from options where name = 'Small Megabytes'");

		if($smallMB['success'] && strtolower($smallMB['sqlreturn'][0]['value']) == 'y') {
			$gbFactor = 1000000000.0;
		} else {
			$gbFactor = 1073741824.0;
		}

		$radiusDailyDetailData = array();
		foreach($instanceData['sqlreturn'] as $thisInstance) {

            $sqlStmt = "select ud_username=username,ud_year=datepart(yy,callend),ud_month=datepart(mm,callend),ud_day=datepart(dd,callend),ud_data_in=sum(data_in),ud_data_out=sum(data_out),ud_data_in_out=sum(data_in_out),ud_time=sum(datediff(ss,callstart,callend))
                        from radius_usage
                        where username='".SQLTrim($thisInstance['username'])."' and callend between '".$paramStartDate."' and '".$paramEndDate."'
                        group by username,datepart(yy,callend),datepart(mm,callend),datepart(dd,callend)
                        order by username,datepart(yy,callend),datepart(mm,callend),datepart(dd,callend)";

    		$sqlResults = ExecuteSQL($sqlStmt);
    		$detailData = array();
    		if($sqlResults['success'] && isset($sqlResults['sqlreturn']) && is_array($sqlResults['sqlreturn'])) {
    		    foreach($sqlResults['sqlreturn'] as $thisType) {
    		        array_push($detailData,$thisType);
    		    }
    		}

			foreach($detailData as & $thisRow) {
				$thisRow['ud_data_in'] = $thisRow['ud_data_in'] / $gbFactor;
				$thisRow['ud_data_out'] = $thisRow['ud_data_out'] / $gbFactor;
				$thisRow['ud_data_in_out'] = $thisRow['ud_data_in_out'] / $gbFactor;
				$thisRow['ud_time'] = $thisRow['ud_time'] / 3600;
			}
			$radiusDailyDetailData[$thisInstance['username']] = $detailData;
		}
	} else {
		$radiusDailyDetailData = false;
	}

    $paramList = new ACF_ParameterList();
    $paramList->AddParameter(new ACF_DirectParameter('radiusdailydetaildata',$radiusDailyDetailData));
    $paramList->AddParameter(new ACF_DirectParameter('radiusdailystartdate',$paramStartDate));
    return $paramList;
}

function DC_GetRadiusUsageDetailsHourly (ACF_ParameterList $inParameterList) {
	if ($_SESSION['piwi']['custid']) {
		if ($inParameterList->ParameterExists('radius_dataid')) {
			$instanceData = ExecuteSQL("select username from radius_data where data_id=".SQLTrim($inParameterList->ParameterValue('radius_dataid'))." and d_custid=".SQLTrim($_SESSION['piwi']['custid']));
		} else {
			if ($inParameterList->ParameterExists('all_dataid')) {
					$instanceData = ExecuteSQL("select username from radius_data where d_active<>'N' and d_custid=".SQLTrim($_SESSION['piwi']['custid'])." order by data_id");
			} else {
					$instanceData = ExecuteSQL("select username from radius_data where data_id in (select min(data_id) from radius_data where d_active<>'N' and d_custid=".SQLTrim($_SESSION['piwi']['custid']).")");
			}
		}
		if(!$instanceData['success']) {
			$instanceData['sqlreturn'][0]['username'] = "";
		}

		$paramStartDate = date('Y-m-d h:00:00 A', strtotime("-24 hours"));
		if ($inParameterList->ParameterExists('radiushourlystartdate')) {
			$mytemp = $inParameterList->ParameterValue('radiushourlystartdate');
			if (!empty($mytemp)) {
				$paramStartDate = date('Y-m-d h:00:00 A', strtotime($inParameterList->ParameterValue('radiushourlystartdate')));
			}
		}

		$paramEndDate = date('Y-m-d h:i:s A', strtotime("+1 day",strtotime($paramStartDate)));

		$smallMB = ExecuteSQL("select value from options where name = 'Small Megabytes'");

		if($smallMB['success'] && strtolower($smallMB['sqlreturn'][0]['value']) == 'y') {
			$gbFactor = 1000000000.0;
		} else {
			$gbFactor = 1073741824.0;
		}

		$radiusHourlyDetailData = array();
		foreach($instanceData['sqlreturn'] as $thisInstance) {

            $sqlStmt = "select ud_username=username,ud_year=datepart(yy,callend),ud_month=datepart(mm,callend),ud_day=datepart(dd,callend),ud_hour=datepart(hh,callend),ud_data_in=sum(data_in),ud_data_out=sum(data_out),ud_data_in_out=sum(data_in_out),ud_time=sum(datediff(ss,callstart,callend))
                        from radius_usage
                        where username='".SQLTrim($thisInstance['username'])."' and callend between '".$paramStartDate."' and '".$paramEndDate."'
                        group by username,datepart(yy,callend),datepart(mm,callend),datepart(dd,callend),datepart(hh,callend)
                        order by username,datepart(yy,callend),datepart(mm,callend),datepart(dd,callend),datepart(hh,callend)";

    		$sqlResults = ExecuteSQL($sqlStmt);
    		$detailData = array();
    		if($sqlResults['success'] && isset($sqlResults['sqlreturn']) && is_array($sqlResults['sqlreturn'])) {
    		    foreach($sqlResults['sqlreturn'] as $thisType) {
    		        array_push($detailData,$thisType);
    		    }
    		}

			foreach($detailData as & $thisRow) {
				$thisRow['ud_data_in'] = $thisRow['ud_data_in'] / $gbFactor;
				$thisRow['ud_data_out'] = $thisRow['ud_data_out'] / $gbFactor;
				$thisRow['ud_data_in_out'] = $thisRow['ud_data_in_out'] / $gbFactor;
				$thisRow['ud_time'] = $thisRow['ud_time'] / 3600;
			}
			$radiusHourlyDetailData[$thisInstance['username']] = $detailData;
		}
	} else {
		$radiusHourlyDetailData = false;
	}

    $paramList = new ACF_ParameterList();
    $paramList->AddParameter(new ACF_DirectParameter('radiushourlydetaildata',$radiusHourlyDetailData));
    $paramList->AddParameter(new ACF_DirectParameter('radiushourlystartdate',$paramStartDate));
    return $paramList;
}

function DC_GetTicketsByStatus (ACF_ParameterList $inParameterList) {
	if ($_SESSION['piwi']['custid'] && $inParameterList->ParameterExists('status')) {
		$ticketArray = ExecuteSQL("select tkt_id,tkt_customer_id,tkt_problem,tkt_solution,tkt_date_entered,st_name,tkt_status,tkt_category,tkt_priority,tkt_type,tkt_last_status_change,tkt_last_updated,tkt_service_id,tkt_service_instance from ticket_tbl,status_tbl where tkt_status=st_id and tkt_contact='N' and tkt_customer_id=".SQLTrim($_SESSION['piwi']['custid'])." and tkt_status=".$inParameterList->ParameterValue('status'));
	} else {
		$ticketArray = false;
	}

    $paramList = new ACF_ParameterList();
    $paramList->AddParameter(new ACF_DirectParameter('ticketArray',$ticketArray));
    return $paramList;
}

function DC_GetGuarantorInfo (ACF_ParameterList $inParameterList) {
	$guarInfo = GetCustomerData($_SESSION['piwi']['parentid']);

	$paramList = new ACF_ParameterList();
    $paramList->AddParameter(new ACF_DirectParameter('guarInfo',$guarInfo));

    return $paramList;
}

function DC_GetTaxProfiles (ACF_ParameterList $inParameterList) {
	$taxProfilesList = ExecuteSQL("select tp_id, tp_name from tax_profile where tp_active = 'Y'");

	if($taxProfilesList['success'] && isset($taxProfilesList['sqlreturn']) && is_array($taxProfilesList['sqlreturn'])) {
        foreach($taxProfilesList['sqlreturn'] as $thisProfile) {
            $taxProfiles[$thisProfile['tp_id']] = $thisProfile['tp_name'];
        }
    }

	$paramList = new ACF_ParameterList();
	$paramList->AddParameter(new ACF_DirectParameter('taxprofiles',$taxProfiles));

	return $paramList;
}

function DC_GetInvoiceItems(ACF_ParameterList $inParameterList) {
	global $wow;
	global $wowlogintype;

	$wow->setMethod('GetItems');
	$wow->addAttribute('logintype', $wowlogintype);

	$wow->addParameter('datatype', 'XML');
	$wow->addParameter('itemtype', '1');

	if($wow->execute()) {
		$itemResults = $wow->getAttributesArray();
	} else {
		$error = $wow->lastError;
	}

	$oDomDoc = new domDocument();

	if ($error) {
		$root = $oDomDoc->createElement('error');
		$oDomDoc->appendChild($root);
		$root->appendChild($oDomDoc->createTextNode(trim($error)));
	} else {
		$root = $oDomDoc->createElement('itemdata');
		$oDomDoc->appendChild($root);
		foreach($itemResults as $item) {
			$currentitem = $root->appendChild($oDomDoc->createElement('item'));
			$itemcode = $currentitem->appendChild($oDomDoc->createAttribute('itemcode'));
			$itemcode->appendChild($oDomDoc->createTextNode(trim($item['i_item'])));
			$name = $currentitem->appendChild($oDomDoc->createAttribute('name'));
			$name->appendChild($oDomDoc->createTextNode(trim($item['i_name'])));
			$price = $currentitem->appendChild($oDomDoc->createAttribute('price'));
			$price->appendChild($oDomDoc->createTextNode(trim($item['i_price'])));
			$taxprofile = $currentitem->appendChild($oDomDoc->createAttribute('taxprofile'));
			$taxprofile->appendChild($oDomDoc->createTextNode(trim($item['i_tp'])));
		}
	}

	$paramList = new ACF_ParameterList();
	$paramList->AddParameter(new ACF_DirectParameter('xml', $oDomDoc->savexml()));
	return $paramList;
}

function DC_GetEligibleServiceTopups(ACF_ParameterList $inParameterList) {
	if ($_SESSION['piwi']['custid']) {
		unset($_SESSION['piwi']['payment']['ccdata']);
		global $wow;
		global $wowlogintype;

		$wow->setMethod('service_topup_eligible_get');
		$wow->addAttribute('logintype', $wowlogintype);
		$wow->addProperty('custid',$_SESSION['piwi']['custid'],'integer');
		if($inParameterList->ParameterExists('svc_id'))
			$wow->addParameter('svc_id', $inParameterList->ParameterValue('svc_id'));

		if($wow->execute()) {
			$eligibleTopups = $wow->getAttributesArray();
		} else {
			$error = $wow->lastError;
		}
	} else {
		$eligibleTopups = false;
	}

    $paramList = new ACF_ParameterList();
    $paramList->AddParameter(new ACF_DirectParameter('eligibleTopups',$eligibleTopups));
//    if($error)
//    	$paramList->AddParameter(new ACF_DirectParameter('error',$error));

    return $paramList;
}

function DC_GetServiceTopups(ACF_ParameterList $inParameterList) {
	if ($_SESSION['piwi']['custid'] && $inParameterList->ParameterExists('svc_id') && $inParameterList->ParameterExists('data_id')) {
		global $wow;
		global $wowlogintype;

		$wow->setMethod('service_topup_get');
		$wow->addAttribute('logintype', $wowlogintype);
		$wow->addProperty('custid',$_SESSION['piwi']['custid'],'integer');
		$wow->addParameter('svc_id', $inParameterList->ParameterValue('svc_id'));
		$wow->addParameter('data_id', $inParameterList->ParameterValue('data_id'));

		if($wow->execute()) {
			$svcTopups = $wow->getAttributesArray();
		} else {
			$error = $wow->lastError;
		}
	} else {
		$svcTopups = false;
	}

    $paramList = new ACF_ParameterList();
    $paramList->AddParameter(new ACF_DirectParameter('svcTopups',$svcTopups));
    if($error)
    	$paramList->AddParameter(new ACF_DirectParameter('error',$error));

    return $paramList;
}

function DC_GetMaxedServiceTopups(ACF_ParameterList $inParameterList) {
	if ($_SESSION['piwi']['custid']) {
		global $wow;
		global $wowlogintype;

		$wow->setMethod('service_topup_maxed_get');
		$wow->addAttribute('logintype', $wowlogintype);
		$wow->addProperty('custid',$_SESSION['piwi']['custid'],'integer');
		if ($inParameterList->ParameterExists('svc_id')) {
			$wow->addParameter('svc_id', $inParameterList->ParameterValue('svc_id'));
		}

		if($wow->execute()) {
			$svcMaxedTopups = $wow->getAttributesArray();
		} else {
			$error = $wow->lastError;
		}
	} else {
		$svcMaxedTopups = false;
	}

    $paramList = new ACF_ParameterList();
    $paramList->AddParameter(new ACF_DirectParameter('svcMaxedTopups',$svcMaxedTopups));
    if($error)
    	$paramList->AddParameter(new ACF_DirectParameter('error',$error));

    return $paramList;
}

function DC_GetEligibleRatesByServiceType (ACF_ParameterList $inParameterList) {
	if ($_SESSION['piwi']['custid'] && $inParameterList->ParameterExists('svc_id')) {
		$svcDefData = ExecuteSQL("select svc_name,svc_table,svc_ccs_service=isnull(svc_ccs_service,'none') from svc_defs where svc_id=".SQLTrim($inParameterList->ParameterValue('svc_id')));
		if($svcDefData['success']) {
			$svcName = $svcDefData['sqlreturn'][0]['svc_name'];
			$svcTable = $svcDefData['sqlreturn'][0]['svc_table'];
			$svcCCS = $svcDefData['sqlreturn'][0]['svc_ccs_service'];

			if(SecurityCheck("Form Svc-".$svcName."-Overload")) {
				$sqlQuery = "select rg_id,rg_name,custrate.crid,rs_svc_qty,used=count(data_id),rs_id,svc_name='".SQLTrim($svcName)."',svc_ccs_service='".SQLTrim($svcCCS)."' from custrate inner join rg_struct rs on rgid=rs_rg_id inner join rgheader on rgid=rg_id left outer join ".$svcTable." x on custrate.crid=x.crid where rs_parent_id=0 and custid=".$_SESSION['piwi']['custid']." and rs_svc_id=".SQLTrim($inParameterList->ParameterValue('svc_id'))." group by rg_id,rg_name,custrate.crid,rs_svc_qty,rs_id";
			} else {
				$sqlQuery = "select rg_id,rg_name,custrate.crid,rs_svc_qty,used=count(data_id),rs_id,svc_name='".SQLTrim($svcName)."',svc_ccs_service='".SQLTrim($svcCCS)."' from custrate inner join rg_struct rs on rgid=rs_rg_id inner join rgheader on rgid=rg_id left outer join ".$svcTable." x on custrate.crid=x.crid where rs_parent_id=0 and custid=".$_SESSION['piwi']['custid']." and rs_svc_id=".SQLTrim($inParameterList->ParameterValue('svc_id'))." group by rg_id,rg_name,custrate.crid,rs_svc_qty,rs_id having rs_svc_qty>count(data_id)";
			}

			$custrateData = ExecuteSQL($sqlQuery);

			$returnData = array();
    		if($custrateData['success'] && isset($custrateData['sqlreturn']) && is_array($custrateData['sqlreturn'])) {
    		    foreach($custrateData['sqlreturn'] as $thisType) {
    		        array_push($returnData,$thisType);
    		    }
    		}
    	} else {
    		$returnData = false;
		}
	} else {
		$returnData = false;
	}

    $paramList = new ACF_ParameterList();
    $paramList->AddParameter(new ACF_DirectParameter('eligibleratesbyservicetype',$returnData));
    return $paramList;
}

?>
