<?php
require_once("../../libs/platypus/wow.inc.php");
require_once('../../libs/ccs/utilities.inc.php');

$stafflogin = $_SESSION['wow']['staffname'];
$staffpass  = $_SESSION['wow']['staffpass'];

global $wowlogintype;
$wowlogintype  = $_SESSION['wow']['logintype'] ? $_SESSION['wow']['logintype'] : 'staff';

global $wow;
$wow = new WOW_Request();
$wow->setUsername($stafflogin);
$wow->setPassword($staffpass);

function ResetStaffLogin() {
    global $wow;
    global $wowlogintype;

    $stafflogin   = $_SESSION['wow']['staffname'] = $_SESSION['wow']['file_staffname'];
    $staffpass    = $_SESSION['wow']['staffpass'] = $_SESSION['wow']['file_staffpass'];
    $wowlogintype = $_SESSION['wow']['logintype'] = 'staff';

    $wow->setUsername($stafflogin);
    $wow->setPassword($staffpass);
}

function SetStaffLogin() {
    global $wow;
    global $wowlogintype;

    $stafflogin   = $_SESSION['wow']['staffname'];
    $staffpass    = $_SESSION['wow']['staffpass'];
    $wowlogintype = $_SESSION['wow']['logintype'] ? $_SESSION['wow']['logintype'] : 'staff';

    $wow->setUsername($stafflogin);
    $wow->setPassword($staffpass);
}

function GetPrice($service,$action,$period,$subservice = false,$rgid) {
    global $wow;
    global $wowlogintype;

    $wow->setMethod('Transaction_GetPrice');
    $wow->addAttribute('logintype',$wowlogintype);

    $wow->addParameter('Service',$service);
    $wow->addParameter('SubService',$subservice,$subservice ? 'string' : 'boolean');
    $wow->addParameter('Action',$action);
    $wow->addParameter('Period',$period,'int');
    $wow->addParameter('RGID',$rgid,'string');
    $wow->addParameter('DataType','XML');

    if($wow->execute()) {
        return $wow->getAttribute(0);
    } else {
        return false;
    }
}

function GetAllPrices($rgid) {
    global $wow;
    global $wowlogintype;

    $wow->setMethod('Transaction_GetPrice');
    $wow->addAttribute('logintype',$wowlogintype);

    $wow->addParameter('Service',false,'boolean');
    $wow->addParameter('SubService',false,'boolean');
    $wow->addParameter('Action',false,'boolean');
    $wow->addParameter('Period',false,'boolean');
    $wow->addParameter('RGID',$rgid,'string');
    $wow->addParameter('DataType','XML');

    if($wow->execute()) {
        return $wow->getAttributesArray();
    } else {
        return false;
    }
}

function GetServiceDefs() {
    global $wow;
    global $wowlogintype;

    $wow->setMethod('GetServiceDefs');
    $wow->addAttribute('logintype',$wowlogintype);

    $wow->addParameter('datatype','XML');

    if($wow->execute()) {
        return $wow->getAttributesArray();
    } else {
        return false;
    }
}

function SetPriceList($rgid) {
    $allPrices = GetAllPrices($rgid);

    $priceArray = array();

    if(isset($allPrices) && is_array($allPrices)) {
        foreach($allPrices as $thisPrice) {
            switch($thisPrice['transaction_type']) {
                case "Register":
                    $type = "new";
                    break;
                default:
                    $type = strtolower($thisPrice['transaction_type']);
            }
            $type = 'period-pricing-'.$type;

            $tld = ".".strtolower($thisPrice['service_subtype']);
            $year = $thisPrice['period'];

            if(!$priceArray[$tld]) {
                $priceArray[$tld] = array();
            }
            if(!$priceArray[$tld][$type]) {
                $priceArray[$tld][$type] = array();
            }
            $priceArray[$tld][$type][$year-1] = $thisPrice['price'];
        }

        if(isset($_SESSION['ccs']['options']['driver-options']['service-modules']['domain']['service-options']['service-offering-list']['service-offering']) && is_array($_SESSION['ccs']['options']['driver-options']['service-modules']['domain']['service-options']['service-offering-list']['service-offering'])) {
            foreach($_SESSION['ccs']['options']['driver-options']['service-modules']['domain']['service-options']['service-offering-list']['service-offering'] as &$thisTLD) {
                $thisTLD['price']['period-pricing-new'] = $priceArray[$thisTLD['tld']]['period-pricing-new'];
                $thisTLD['price']['period-pricing-renew'] = $priceArray[$thisTLD['tld']]['period-pricing-renew'];
                $thisTLD['price']['period-pricing-transfer'] = $priceArray[$thisTLD['tld']]['period-pricing-transfer'];
            }
        }
    }
}

function GetWebOption ($optionname,$storeid) {
    global $wow;
    global $wowlogintype;

    $wow->setMethod('GetWebOption');
    $wow->addAttribute('logintype',$wowlogintype);

    $wow->addParameter('option_name',$optionname);
    $wow->addParameter('storeappended',false,'boolean');
    $wow->addParameter('datatype','XML');

    $wow->addProperty('storeid',$storeid,'integer');

    if($wow->execute()) {
        return $wow->getAttribute(0,$optionname);
    }
}

function ExecuteSQL ($query) {
    global $wow;
    global $wowlogintype;

    $wow->setMethod('SQL');
    $wow->addAttribute('logintype',$wowlogintype);

    $wow->addParameter('query',$query);
    $wow->addParameter('noconn',false,'boolean');
    $wow->addParameter('datatype','XML');

    if($wow->execute()) {
        $results['success'] = true;
        $results['sqlreturn'] = $wow->getAttributesArray();
    } else {
        $results['success'] = false;
        $results['errormsg'] = $wow->lastError;
    }

    return $results;
}

function SQLTrim ($instring) {
    if(!$instring)
        return "";
    if(!is_string($instring))
        return $instring;

    $instring = str_replace("&apos;","'",$instring);

    $outstring = "";
    while ($instring != $outstring) {
        $outstring = $instring;
        $instring = trim(str_replace("''","'",$instring));
    }

    return trim(str_replace("'","''",$instring));
}

function UpdateColumn ($table,$column,$value,$where) {
    global $wow;
    global $wowlogintype;

    $wow->setMethod('Update');
    $wow->addAttribute('logintype',$wowlogintype);

    $wow->addParameter('table',$table);
    $wow->addParameter('column',$column);
    $wow->addParameter('value',"'".$value."'");
    $wow->addParameter('whereclause',$where);
    $wow->addParameter('noconn',false,'boolean');
    $wow->addParameter('datatype','XML');

    if($wow->execute())
        return true;
    else
        return false;
}

function LogError($funcname,$errmsg) {
    if(!$_SESSION['signup']['lastError'])
        $_SESSION['signup']['lastError'] = $funcname.":".$errmsg."\n";
    else
        $_SESSION['signup']['lastError'] .= $funcname.":".$errmsg."\n";
}

function GetHeader($custid,$parentid,$displaystaff,$staffid,$staffname,$section,$subsection) {
    $header = array();

    if($custid) {
        $header['customer'] = GetCustomerData($custid);
        if($header['customer']) {
            if(strpos($header['customer']['attn'],' ')) {
                $header['customer']['fattn'] = substr($header['customer']['attn'],0,strpos($header['customer']['attn'],' '));
                $header['customer']['lattn'] = substr($header['customer']['attn'],strpos($header['customer']['attn'],' ')+1);
            }

            switch($header['customer']['active']) {
                case 'Y':
                    $header['customer']['activeStatus'] = 'Active';
                    break;
                case 'H':
                    $header['customer']['activeStatus'] = 'On Hold';
                    break;
                case 'S':
                    $header['customer']['activeStatus'] = 'Suspended';
                    break;
                case 'N':
                    $header['customer']['activeStatus'] = 'Inactive';
                    break;
            }

            $header['customer']['balanceDisplay'] = ShowMoney($header['customer']['balance']);
            $header['customer']['creditDisplay']  = ShowMoney($header['customer']['credit']);

            if($header['customer']['blockuser'] == 'Y') {
                switch($header['customer']['blocktype']) {
                    case 2:
                        $header['customer']['blocktypeDisplay'] = 'KBytes In';
                        break;
                    case 3:
                        $header['customer']['blocktypeDisplay'] = 'KBytes Out';
                        break;
                    case 4:
                        $header['customer']['blocktypeDisplay'] = 'KBytes In+Out';
                        break;
                    default:
                        $header['customer']['blocktypeDisplay'] = 'Minutes';
                }
            }

            $header['children'] = GetChildren($custid);
            $header['parentid'] = $parentid;
        }
    }

//---- check for helpdesk
    if (isset($_SESSION['helpdesk']['options']['driver-options']['url']))
        if ((isset($_SESSION['piwi']['staffid']) && $_SESSION['helpdesk']['options']['staffEnabled'])
                || $_SESSION['helpdesk']['options']['customerEnabled']){
            $header['helpdesk']                    = array();
            $header['helpdesk']['URL']             = $_SESSION['helpdesk']['options']['driver-options']['url'];
            $header['helpdesk']['staffEnabled']    = $_SESSION['helpdesk']['options']['staffEnabled'];
            $header['helpdesk']['customerEnabled'] = $_SESSION['helpdesk']['options']['customerEnabled'];
            if ($_SESSION['helpdesk']['ticketid']){
                if ($section != "tickets")
                    $header['ticketid'] = $_SESSION['helpdesk']['ticketid'];
                else
                    $header['ticketid'] = $_SESSION['helpdesk']['oldticketid'] ? $_SESSION['helpdesk']['oldticketid'] : $_SESSION['helpdesk']['ticketid'];
            }
        }

        if($displaystaff) {
            $header['staff']['display'] = $displaystaff;
            $header['staff']['id']      = $staffid;
            $header['staff']['name']    = $staffname;
        }
        $header['section']    = $section;
        $header['subsection'] = $subsection;
        return $header;
}

function GetAvailableWebRates($storeid,$custid,$ccs = false) {
    if(!$_SESSION['optimization']['webrates'][$custid][$ccs ? 'ccs' : 'nonccs']) {
        global $wow;
        global $wowlogintype;

        $wow->setMethod('GetAvailableRates');
        $wow->addAttribute('logintype',$wowlogintype);

        $wow->addParameter('datatype','XML');
        $wow->addParameter('ccs',$ccs,'boolean');

        $wow->addProperty('storeid',$storeid ? $storeid : 0,'integer');
        $wow->addProperty('custid',$custid,'integer');

        if($wow->execute()) {
            $_SESSION['optimization']['webrates'][$custid][$ccs ? 'ccs' : 'nonccs'] = $wow->getAttributesArray();
        } else {
            $_SESSION['optimization']['webrates'][$custid][$ccs ? 'ccs' : 'nonccs'] = false;
        }
    }

    return $_SESSION['optimization']['webrates'][$custid][$ccs ? 'ccs' : 'nonccs'];
}

function GetUDPath($storeid,$rgid,$pathdirection,$custid) {
    global $wow;
    global $wowlogintype;

    $wow->setMethod('GetPaths');
    $wow->addAttribute('logintype',$wowlogintype);

    $wow->addParameter('rgid',$rgid,'integer');
    $wow->addParameter('pathtype',$pathdirection);
    $wow->addParameter('datatype','XML');

    $wow->addProperty('storeid',$storeid,'integer');
	$wow->addProperty('custid',$custid,'integer');

    if($wow->execute()) {
        return $wow->getAttributesArray();
    } else {
        return false;
    }
}

function Login($username,$password,$type) {
    global $wow;
    global $wowlogintype;

    $wow->setMethod('Login');
    $wow->addAttribute('logintype',$wowlogintype);

    $wow->addParameter('logintype',$type);
    $wow->addParameter('username',$username);
    $wow->addParameter('password',$password);
    $wow->addParameter('datatype','XML');
    $wow->addParameter('allowedactive',"'Y','H','S'");

    if($wow->execute()) {
        return $wow->getAttribute(0);
    } else {
        return false;
    }
}

function GetStaffNames() {
    global $wow;
    global $wowlogintype;

    $wow->setMethod('GetStaffLogins');
    $wow->addAttribute('logintype',$wowlogintype);

    $wow->addParameter('datatype','XML');

    if($wow->execute()) {
        if(is_array($wow->getAttributesArray())) {
            foreach($wow->getAttributesArray() as $thisStaff) {
            	if($thisStaff['position'] != 2) {
	                $staffList[$thisStaff['num']] = $thisStaff['name'];
	            }
            }
        }

        return $staffList;
    } else {
        return false;
    }
}

function CustomerSearch($searchstring) {
    global $wow;
    global $wowlogintype;

    $wow->setMethod('SearchCustomer');
    $wow->addAttribute('logintype',$wowlogintype);

    $wow->addParameter('datatype','XML');

    $wow->addProperty('search',$searchstring);

    if($wow->execute()) {
        $results['success'] = true;
        $results['searchResults'] = $wow->getAttributesArray();
    } else {
        $results['success'] = false;
        $results['errormsg'] = $wow->lastError;
    }

    return $results;
}

function GetProfile($custid) {
    global $wow;
    global $wowlogintype;

    $wow->setMethod('OpenSRSGetProfile');
    $wow->addAttribute('logintype',$wowlogintype);

    $wow->addParameter('nCustID',$custid,'string');
    $wow->addParameter('cDataType','XML');

    if($wow->execute()) {
        return $wow->getAttribute(0,'profile');
    } else {
        return false;
    }
}

function GenerateProfile() {
    global $wow;
    global $wowlogintype;

    $wow->setMethod('OpenSRSGenProfile');
    $wow->addAttribute('logintype',$wowlogintype);

    $wow->addParameter('cDataType','XML');

    if($wow->execute()) {
        return $wow->getAttribute(0,'profile');
    } else {
        return false;
    }
}

function GetCustomerData($custid) {
    global $wow;
    global $wowlogintype;

    // Check Cache
    if($_SESSION['piwi']['custinfo'][$custid])
        return $_SESSION['piwi']['custinfo'][$custid];

    $wow->setMethod('GetCustomer');
    $wow->addAttribute('logintype',$wowlogintype);

    $wow->addParameter('datatype','XML');

    $wow->addProperty('custid',$custid);

    if($wow->execute()) {
        $custData = $wow->getAttribute(0);

        if($custData['ccnumber'] == '' || $custData['ccnumber'] == 'NULL' || !$custData['ccnumber']) {
            $custData['creditcardmasked'] = false;
        }

        if($custData['acctnumber'] == '' || $custData['acctnumber'] == 'NULL' || !$custData['acctnumber']) {
            $custData['acctnumbermasked'] = false;
        }

        // Set Cache
        $_SESSION['piwi']['custinfo'][$custid] = $custData;

        return $custData;
    } else {
        return false;
    }
}

function GetAddresses($custid,$type = false) {
//    LINE BELOW DOESN'T WORK AT ALL TIMES (can't guarantee category.options is set)
//    $sqlResults = ExecuteSQL("select name, value from options where category = 'Customer Defaults'");
    $sqlResults = ExecuteSQL("select name, value from options where name in ('City','Zip','Country','State')");
    if($sqlResults['success'] && is_array($sqlResults['sqlreturn'])) {
        foreach($sqlResults['sqlreturn'] as $thisOption) {
            $custDefaults[$thisOption['name']] = $thisOption['value'];
        }
    }

    global $wow;
    global $wowlogintype;

    $wow->setMethod('GetAddress');
    $wow->addAttribute('logintype',$wowlogintype);

    $wow->addParameter('datatype', 'XML');

    $wow->addProperty('custid', $custid);

    if($wow->execute()) {
        $addressList = $wow->getAttributesArray();
        $assocAddressList = array();
        if(isset($addressList) && is_array($addressList)) {
            foreach($addressList as &$thisAddress) {
                if($thisAddress['city'] == $custDefaults['City'] && $thisAddress['zip'] == $custDefaults['Zip'] && $thisAddress['country'] == $custDefaults['Country'] && $thisAddress['state'] == $custDefaults['State'] && !$thisAddress['addr1'] && !$thisAddress['addr2']) {
                    $thisAddress = array();
                } else {
                    $assocAddressList[$thisAddress['type']] = $thisAddress;
                }
            }
        }
        if($type)
            $assocAddressList = $assocAddressList[$type];
        return $assocAddressList;
    } else {
        return false;
    }
}

function GetPhones($custid) {
    global $wow;
    global $wowlogintype;

    $wow->setMethod('GetPhone');
    $wow->addAttribute('logintype',$wowlogintype);

    $wow->addParameter('datatype','XML');

    $wow->addProperty('custid',$custid);

    if($wow->execute()) {
        $phoneList = $wow->getAttributesArray();
        $assocPhoneList = array();
        if(isset($phoneList) && is_array($phoneList)) {
            foreach($phoneList as $thisPhone) {
                $assocPhoneList[$thisPhone['type']] = $thisPhone;
            }
        }
        return $assocPhoneList;
    } else {
        return false;
    }
}

function GetCustomerRates($custid,$crid = false) {
    global $wow;
    global $wowlogintype;

    $wow->setMethod('GetRates');
    $wow->addAttribute('logintype',$wowlogintype);

    $wow->addParameter('datatype', 'XML');
    $wow->addParameter('crid', $crid);

    $wow->addProperty('custid', $custid);

    if($wow->execute()) {
        $custrates = $wow->getAttributesArray();
        return $custrates;
    } else {
        return false;
    }
}

function ChangeRate($crid,$newrgid,$newfreq,$custid) {
    global $wow;
    global $wowlogintype;

    $wow->setMethod('ChangeRate');
    $wow->addAttribute('logintype',$wowlogintype);

    $wow->addParameter('crid',$crid,'integer');
    $wow->addParameter('newrgid',$newrgid,'integer');
    $wow->addParameter('datatype','XML');
    $wow->addParameter('newfreq',$newfreq,'integer');

    $wow->addProperty('custid',$custid);

    if($wow->execute()) {
        $results['success'] = true;
        if(isset($_SESSION['piwi']['listservices']))
            unset($_SESSION['piwi']['listservices']);
    } else {
        $results['success'] = false;
        $results['error'] = $wow->lastError;
    }

    return $results;
}

function GetCCSServiceDetails($rgid = false,$custid = false) {
    $wow = new WOW_Request();
    $wow->setUsername($_SESSION['wow']['file_staffname']);
    $wow->setPassword($_SESSION['wow']['file_staffpass']);

    $wow->setMethod('ListServiceTree');
    $wow->addAttribute('logintype','staff');

    $wow->addParameter('datatype','XML');
    if($rgid)
        $wow->addParameter('rgid',$rgid);
    if($custid)
        $wow->addProperty('custid',$custid);

    if($wow->execute()) {
        $results['success'] = true;
        $results['serviceData'] = $wow->getAttribute(0);
    } else {
        $results['success'] = false;
        $results['error'] = $wow->lastError;
    }

    return $results;
}

function GetServiceFields($serviceID,$rgid = false,$crid = false,$branch = false,$parentinstance = false,$parentservice = false,$custid) {
    global $wow;
    global $wowlogintype;

    $wow->setMethod('GetServiceInfo');
    $wow->addAttribute('logintype',$wowlogintype);

    $wow->addParameter('svcid',$serviceID);
    $wow->addParameter('datatype','XML');
    $wow->addParameter('rgid',$rgid,$rgid ? 'string' : 'boolean');
    $wow->addParameter('crid',$crid,$crid ? 'string' : 'boolean');
    $wow->addParameter('branch',$branch,$branch ? 'string' : 'boolean');
    $wow->addParameter('parentInstance',$parentinstance,$parentinstance ? 'string' : 'boolean');
    $wow->addParameter('parentService',$parentservice,$parentservice ? 'string' : 'boolean');

    $wow->addProperty('custid',$custid,'integer');

    if($wow->execute()) {
        return $wow->getAttributesArray();
    } else {
        return false;
    }
}

function GetRatesForService($custid,$svc_id) {
    global $wow;
    global $wowlogintype;

    $wow->setMethod('getRates4Service');
    $wow->addAttribute('logintype',$wowlogintype);

    $wow->addParameter('svcid',$svc_id);
    $wow->addParameter('staffid',null);
    $wow->addParameter('datatype','XML');

    $wow->addProperty('custid',$custid);

    if($wow->execute()) {
        return $wow->getAttributesArray();
    } else {
        return false;
    }
}

function GetEmailDomains($custid,$datatable) {
    global $wow;
    global $wowlogintype;

    $wow->setMethod('getEmailDomains');
    $wow->addAttribute('logintype',$wowlogintype);

    $wow->addParameter('datatype', 'XML');
    $wow->addParameter('cdatatable',$datatable);

    $wow->addProperty('custid', $custid);

    if($wow->execute()) {
        return $wow->getAttributesArray();
    } else {
        return false;
    }
}

function ListServices($custid, $serviceType = false, $data_id = false, $crid = false) {
    global $wow;
    global $wowlogintype;

    $serviceArray = array();

    foreach($_SESSION['piwi']['serviceTree'] as $thisServiceType) {
        if((!$serviceType || ($serviceType == $thisServiceType['rs_svc_id'])) && (!$crid || ($crid == $thisServiceType['rs_cr_id']))) {
            if(is_array($thisServiceType['services']) && count($thisServiceType['services'] > 0)) {
                foreach($thisServiceType['services'] as $thisService) {
                    if(!$data_id || ($data_id == $thisService['s_num'])) {
                        $serviceArray[!$serviceType ? 'BLANK' : $serviceType][!$data_id ? 'BLANK' : $data_id][!$crid ? 'BLANK' : $crid] = $thisService;
                    }
                }
            }
        }
    }

    return $serviceArray[!$serviceType ? 'BLANK' : $serviceType][!$data_id ? 'BLANK' : $data_id][!$crid ? 'BLANK' : $crid];
}

function GetServiceHeader($custid,$crid = false) {
    return ListServices($custid,false,false,$crid);
}

function GetServiceUsage($svcid,$dataid,$startdate,$enddate,$branch) {
    global $wow;
    global $wowlogintype;

    $wow->setMethod('GetRatingInfo');
    $wow->addAttribute('logintype',$wowlogintype);

    $wow->addParameter('svcid',$svcid);
    $wow->addParameter('dataid',$dataid);
    $wow->addParameter('lastbilled',$startdate);
    $wow->addParameter('nextbill',$enddate);
    $wow->addParameter('branch',$branch);
    $wow->addParameter('datatype','XML');

    if($wow->execute()) {
        return $wow->getAttributesArray();
    } else {
        return false;
    }
}

function FakePost($crid,$startdate,$enddate) {
    global $wow;
    global $wowlogintype;

    $wow->setMethod('FakePost');
    $wow->addAttribute('logintype',$wowlogintype);

    $wow->addParameter('crid',$crid,'integer');
    $wow->addParameter('activeconn',false,'boolean');
    $wow->addParameter('lastbilled',$startdate);
    $wow->addParameter('nextbill',$enddate);
    $wow->addParameter('datatype','XML');

    if($wow->execute()) {
        return $wow->getAttributesArray();
    } else {
        return false;
    }
}

function GetDtlCustRates($storeid,$custid,$crid = false) {
    $rateData = GetAvailableWebRates($storeid,$custid,false);
    $platData = GetCustomerRates($custid,$crid);

    $combinedData = array();
    if(isset($platData) && is_array($platData)) {
        foreach($platData as $thisRate) {
            $arrayFound = false;
            if(isset($rateData) && is_array($rateData)) {
                foreach($rateData as $thisBundle) {
                    if($thisBundle['id'] == $thisRate['id']) {
                        $arrayFound = true;
                        $tempThisRate = $thisRate; // put it in a temp value that i can edit locally
                        $tempThisRate['rg_ccs_svc_id'] = $thisBundle['rg_ccs_svc_id'];
                        $tempThisRate['svc_ccs_service'] = $thisBundle['svc_ccs_service'];
                        $tempThisRate['rg_frequency'] = $thisBundle['rg_frequency'];
                        $tempThisRate['rg_fixed_price'] = $thisBundle['rg_fixed_price'];
                        $tempThisRate['rg_companies'] = $thisBundle['rg_companies'];
                        array_push($combinedData,$tempThisRate);
                        break;
                    }
                }
            }

            if(!$arrayFound) {
                array_push($combinedData,$thisRate);
            }
        }
    }

    return $combinedData;
}

function GetSingleRate($storeid,$custid,$rgid,$freq) {
    $bundleList = GetAvailableWebRates($storeid,$custid,true);

    if(isset($bundleList) && is_array($bundleList)) {
        foreach($bundleList as &$thisBundle) {
            if($thisBundle['rg_id'] == $rgid && $thisBundle['r_frequency'] == $freq) {
                return $thisBundle;
            }
        }
    }

    $rateList = GetAvailableWebRates($storeid,$custid,false);

    if(isset($rateList) && is_array($rateList)) {
        foreach($rateList as $thisRate) {
            if($thisRate['rg_id'] == $rgid && $thisRate['r_frequency'] == $freq) {
                return $thisRate;
            }
        }
    }

    return false;
}

function GetSingleBundle($storeid,$custid,$crid) {
    $bundleData = GetAvailableWebRates($storeid,$custid,false);
    $rateData   = GetCustomerRates($custid);

    if(isset($rateData) && is_array($rateData)) {
        foreach($rateData as $thisRate) {
            if($thisRate['crid'] == $crid) {
                $rate = $thisRate;
                break;
            }
        }
    }

    if(isset($bundleData) && is_array($bundleData)) {
        foreach($bundleData as $thisBundle) {
            if($thisBundle['rg_id'] == $rate['rgid']) {
                $bundle = $thisBundle;
                break;
            }
        }
    }

    if(!$bundle) {
        $bundle = array();
        if($rate) {
            $ratePrice = ExecuteSQL("select totalprice = sum(r_price) from rate where r_rg_id = ".SQLTrim($rate['rgid'])." and r_type = 'FIXED' and r_frequency=".SQLTrim($rate['cr_frequency']));
            $bundle['rg_fixed_price'] = $ratePrice['sqlreturn'][0]['totalprice'];
            $bundle['rg_frequency']   = $rate['cr_frequency'];
        } else {
            $bundle['rg_fixed_price'] = 0;
            $bundle['rg_frequency']   = 0;
        }
    } else {
        $bundle['rg_frequency'] = $bundle['r_frequency'];
    }

    if(!$rate['rg_frequency'])
        $rate['rg_frequency'] = $bundle['r_frequency'];
    if(!$rate['rg_fixed_price'])
        $rate['rg_fixed_price'] = $bundle['rg_fixed_price'];
    if(!$rate['rg_companies'])
        $rate['rg_companies'] = $bundle['rg_companies'];

    return $rate;
}

function GetServiceTree($rgid,$custid) {
    global $wow;
    global $wowlogintype;

    $wow->setMethod('ListServiceTree');
    $wow->addAttribute('logintype',$wowlogintype);

    $wow->addParameter('datatype','XML');
    $wow->addParameter('rgid',$rgid);

    $wow->addProperty('custid',$custid);

    if($wow->execute()) {
        $serviceTree = $wow->getAttributesArray();
    } else {
        $serviceTree = false;
    }

    return $serviceTree;
}

function GetSingleService($custid,$svctype,$svcid) {
    return ListServices($custid,$svctype,$svcid,false);
}

function GetAllServices($custid) {
    $serviceTypesArray = ListServices($custid);

    if(isset($serviceTypesArray) && is_array($serviceTypeArray)) {
        foreach($serviceTypesArray as &$thisServiceType) {
            $thisServiceType['details'] = ListServices($custid,$thisServiceType['svc_id'],false,false);
        }
    }

    return $serviceTypesArray;
}

function GetPaymentTypes($cctypes = false) {
    global $wow;
    global $wowlogintype;

    $paymentTypes = array();

    $wow->setMethod('getpaymenttypes');
    $wow->addAttribute('logintype',$wowlogintype);

    $wow->addParameter('datatype','XML');
    $wow->addParameter('active','Y');

    if($wow->execute()) {
        $ALLpaymentTypes = $wow->getAttributesArray();
        if(isset($ALLpaymentTypes) && is_array($ALLpaymentTypes)) {
            foreach($ALLpaymentTypes as $thisType) {
                if($cctypes) {
                    if($thisType['p_type'] == 'CREDITCARD' || $thisType['p_type'] == 'ECHECK') {
                        array_push($paymentTypes,$thisType);
                    }
                } else {
                    if($thisType['p_deposittype'] != 'NA') {
                        array_push($paymentTypes,$thisType);
                    }
                }
            }
        }

        return $paymentTypes;
    } else {
        return false;
    }
}

function GetTypeServices($custid,$svc_id) {
    return ListServices($custid,$svc_id);
}

function GetRateServices($custid,$crid) {
    $serviceArray = array();

    $tempServiceTypesArray = ListServices($custid,false,false,$crid);

    if(isset($tempServiceTypesArray) && is_array($tempServiceTypesArray)) {
        foreach($tempServiceTypesArray as $thisServiceType) {
            $serviceArray[$thisServiceType['svc_name']] = ListServices($custid,$thisServiceType['svc_id'],false,$crid);
        }

        if(isset($serviceArray) && is_array($serviceArray)) {
            foreach($serviceArray as &$thisServiceType) { // if no services of this type exist, they are wiped from the array
                if(!count($thisServiceType)) {
                    $thisServiceType = false;
                }
            }
        }
    }

    return $serviceArray;
}

function GetBonuses($bonustype,$id,$listtype,$payid = false) {
    global $wow;
    global $wowlogintype;

    if($bonustype == 'customer') {
        $wow->setMethod('GetReferrals');
    }
    if($bonustype == 'staff') {
        $wow->setMethod('GetCommissions');
    }

    $wow->addAttribute('logintype',$wowlogintype);

    $wow->addParameter('referraltype',$listtype);

    if($listtype == 'D' && $payid) {
        $wow->addParameter('payid',$payid,'integer');
    } else {
        $wow->addParameter('payid',0,'integer');
    }

    $wow->addParameter('datatype','XML');

    if($bonustype == 'customer') {
        $wow->addProperty('custid',$id);
    }
    if($bonustype == 'staff') {
        $wow->addProperty('staffid',$id);
    }

    if($wow->execute()) {
        return $wow->getAttributesArray();
    } else {
        return false;
    }
}

function GetUsageSummary($custid,$startdate,$enddate) {
    global $wow;
    global $wowlogintype;

    $wow->setMethod('getUsage');
    $wow->addAttribute('logintype',$wowlogintype);

    $wow->addParameter('datatype', 'XML');

    $wow->addProperty('custid', $custid);
    $wow->addProperty('begin', $startdate);
    $wow->addProperty('end', $enddate);

    if ($wow->execute()) {
        return $wow->getAttributesArray();
    } else {
        return false;
    }
}

function GetDateFormat() {
    global $wow;
    global $wowlogintype;

    $wow->setMethod('GetDateFormat');
    $wow->addAttribute('logintype',$wowlogintype);

    $wow->addParameter('datatype','XML');

    if($wow->execute()) {
        return $wow->getAttribute(0,'dateformat');
    } else {
        return false;
    }
}

function GetNotes($staffid,$custid = false,$noteidtype,$notetype = false) {
    global $wow;
    global $wowlogintype;

    $wow->setMethod('GetStaffNotes');
    $wow->addAttribute('logintype',$wowlogintype);

    $wow->addParameter('datatype','XML');

    $wow->addProperty('staffid',$staffid);
    $wow->addProperty('custid',$custid);
    $wow->addProperty('noteidtype',$noteidtype ? $noteidtype : '');
    $wow->addProperty('notenumber',false,'boolean');
    $wow->addProperty('notetype',$notetype ? $notetype : '');

    if($wow->execute()) {
        $notes = $wow->getAttributesArray();
        return $notes;
    } else {
        return false;
    }
}

function GetSingleNote($staffid,$custid = false,$notenumber,$noteidtype,$notetype = false) {
    global $wow;
    global $wowlogintype;

    $wow->setMethod('GetStaffNotes');
    $wow->addAttribute('logintype',$wowlogintype);

    $wow->addParameter('datatype','XML');

    $wow->addProperty('staffid',$staffid);
    $wow->addProperty('custid',$custid);
    $wow->addProperty('notetype',$notetype ? $notetype : '');
    $wow->addProperty('notenumber',$notenumber);
    $wow->addProperty('noteidtype',$noteidtype ? $noteidtype : '');

    if($wow->execute()) {
        $note = $wow->getAttribute(0);
        $note['staffcmpl'] = ($note['staffcmpl'] == 'NULL' || $note['staffcmpl'] == '') ? false : $note['staffcmpl'];
        return $note;
    } else {
        return false;
    }
}

function AddNote($custid,$staffid,$notetype,$notetext,$noteto,$notepriority,$sendemail,$emailsubject) {
    global $wow;
    global $wowlogintype;

    $wow->setMethod('AddNote');
    $wow->addAttribute('logintype',$wowlogintype);

    $wow->addParameter('datatype','XML');

    $wow->addProperty('custid',$custid);
    $wow->addProperty('staffid',$staffid);
    $wow->addProperty('notetype',$notetype);
    $wow->addProperty('notetext',$notetext);
    $wow->addProperty('noteto',$noteto);
    $wow->addProperty('notepriority',$notepriority);
    if($sendemail == 'on')
        $wow->addProperty('sendemail',1,'integer');
    else
        $wow->addProperty('sendemail',0,'integer');
    $wow->addProperty('emailsubject',$emailsubject);

    if($wow->execute()) {
        $result['success'] = true;
    } else {
        $result['success'] = false;
        $result['error'] = $wow->lastError;
    }

    return $result;
}

function UpdateNote($notenumber,$notetext,$notetype,$staffid) {
    global $wow;
    global $wowlogintype;

    $wow->setMethod('ChangeNotes');
    $wow->addAttribute('logintype',$wowlogintype);

    $wow->addParameter('datatype','XML');

    $wow->addProperty('notenumber',$notenumber);
    $wow->addProperty('notetext',$notetext);
    $wow->addProperty('notetype',$notetype);
    $wow->addProperty('staffid',$staffid);

    if($wow->execute()) {
        $result['success'] = true;
    } else {
        $result['success'] = false;
        $result['error'] = $wow->lastError;
    }

    return $result;
}

function GetDailyUsage($custid,$usagedate) {
    global $wow;
    global $wowlogintype;

    $wow->setMethod('getUsageDay');
    $wow->addAttribute('logintype',$wowlogintype);

    $wow->addParameter('datatype', 'XML');

    $wow->addProperty('custid', $custid);
    $wow->addProperty('usagedate', date('Y-m-d', $usagedate));

    if($wow->execute()) {
        return $wow->getAttributesArray();
    } else {
        return false;
    }
}

function GetRangeUsage($custid,$startdate,$enddate) {
    global $wow;
    global $wowlogintype;

    $wow->setMethod('getUsageByTerm');
    $wow->addAttribute('logintype',$wowlogintype);

    $wow->addParameter('datatype', 'XML');

    $wow->addProperty('custid', $custid);
    $wow->addProperty('begin', $startdate);
    $wow->addProperty('end', $enddate);

    if($wow->execute()) {
        return $wow->getAttributesArray();
    } else {
        return false;
    }
}

function GetChildren($custid) {
    global $wow;
    global $wowlogintype;

    // Check Cache
   	if($_SESSION['piwi']['custinfo'][$custid]['nochildren'])
            return false;

    if($_SESSION['piwi']['custinfo'][$custid]['children']) {
	        return $_SESSION['piwi']['custinfo'][$custid]['children'];
	}

    $wow->setMethod('GetChildren');
    $wow->addAttribute('logintype',$wowlogintype);

    $wow->addParameter('datatype', 'XML');

    $wow->addProperty('custid', $custid);

    if($wow->execute()) {
        $childData = $wow->getAttributesArray();

        // Set Cache
        $_SESSION['piwi']['custinfo'][$custid]['children'] = $childData;

		return $childData;
    } else {
        // Set Cache
    	$_SESSION['piwi']['custinfo'][$custid]['nochildren'] = true;

        return false;
    }
}

function DeleteUser($custid) {
    global $wow;
    global $wowlogintype;

    $wow->setMethod('DeleteCustomer');
    $wow->addAttribute('logintype',$wowlogintype);

    $wow->addParameter('datatype','XML');
    $wow->addProperty('custid',$custid);
    if($wow->execute()) {
        return true;
    } else {
        return false;
    }
}
function AddRate($custid,$rgid,$freq) {
    global $wow;
    global $wowlogintype;

    $wow->setMethod('addrate');
    $wow->addAttribute('logintype',$wowlogintype);

    $wow->addProperty('custid',$custid);

    $wow->addParameter('rate',$rgid);
    $wow->addParameter('noconn',false);
    $wow->addParameter('datatype','XML');
    $wow->addParameter('freq',$freq);

    if($wow->execute()) {
        if(isset($_SESSION['piwi']['listservices']))
            unset($_SESSION['piwi']['listservices']);
        return $wow->getAttribute(0,'crid');
    } else {
        return false;
    }
}

function PostCharges($custid,$storeid) {
    $days = GetWebOption('futuredays',$storeid);
    global $wow;
    global $wowlogintype;

    $wow->setMethod('Post');
    $wow->addAttribute('logintype',$wowlogintype);

    $wow->addParameter('noconn',false,'boolean');
    $wow->addParameter('days',$days,'string');
    $wow->addParameter('datatype','XML');

    $wow->addProperty('custid',$custid,'string');

    if($wow->execute())
        return true;
    else {
        LogError('PostCharges',$wow->lastError);
        return false;
    }
}

function GetInvoices($custid,$invoicetype = false,$invoiceowner = false,$invoicenumber = false,$startdate = false,$enddate = false) {
    global $wow;
    global $wowlogintype;

    if($enddate) {
        $enddateArray = explode('/',$enddate);
        switch($_SESSION['piwi']['dateformat']) {
        case "YMD":
            $enddate = date("Y/n/j",strtotime("+1 day",mktime(0,0,0,$enddateArray[1],$enddateArray[2],$enddateArray[0])));
            break;
        case "DMY":
            $enddate = date("j/n/Y",strtotime("+1 day",mktime(0,0,0,$enddateArray[1],$enddateArray[0],$enddateArray[2])));
            break;
        case "MDY":
            $enddate = date("n/j/Y",strtotime("+1 day",mktime(0,0,0,$enddateArray[0],$enddateArray[1],$enddateArray[2])));
            break;
        }
    }

    $wow->setMethod('GetInvoices');
    $wow->addAttribute('logintype',$wowlogintype);

    $wow->addParameter('datatype','XML');
    if($startdate && trim($startdate) != "")
        $wow->addParameter('startdate',$startdate,'string');
    else
        $wow->addParameter('startdate',false,'boolean');

    if($enddate && trim($enddate) != "")
        $wow->addParameter('enddate',$enddate,'string');
    else
        $wow->addParameter('enddate',false,'boolean');

    if($invoiceowner)
        $wow->addParameter('invoiceowner',$invoiceowner);
    else
        $wow->addParameter('invoiceowner','Guarantor');

    if($invoicenumber && trim($invoicenumber) != "")
        $wow->addParameter('invoicenumber',$invoicenumber,'string');
    else
        $wow->addParameter('invoicenumber',false,'boolean');

    $wow->addProperty('custid',$custid);

    if($invoicetype && $invoicetype != 'all') {
        $wow->addProperty('invoicetype',$invoicetype,'string');
    } else {
        $wow->addProperty('invoicetype',false,'boolean');
    }

    if($wow->execute()) {
        $invoiceData['success'] = true;
        if($invoicenumber) {
            $invoiceData['list'] = $wow->getAttribute(0);
        } else {
            $invoiceData['list'] = $wow->getAttributesArray();
        }
    } else {
        $invoiceData['success'] = false;
        $invoiceData['error'] = $wow->lastError;
    }

    return $invoiceData;
}

function GetSingleInvoice($custid,$invoicenumber) {
    global $wow;
    global $wowlogintype;

    $wow->setMethod('GetInvoiceDetails');
    $wow->addAttribute('logintype',$wowlogintype);

    $wow->addParameter('invoice',$invoicenumber);
    $wow->addParameter('datatype','XML');

    $wow->addProperty('custid',$custid);

    if($wow->execute()) {
        $results['success'] = true;
        $results['data'] = $wow->getAttributesArray();
    } else {
        $results['success'] = false;
        $results['error'] = $wow->lastError;
    }

    return $results;
}

function GetPayments($custid,$startdate = false,$enddate = false) {
    global $wow;
    global $wowlogintype;

    if($enddate) {
        $enddateArray = explode('/',$enddate);
        switch($_SESSION['piwi']['dateformat']) {
        case "YMD":
            $enddate = date("Y/n/j",strtotime("+1 day",mktime(0,0,0,$enddateArray[1],$enddateArray[2],$enddateArray[0])));
            break;
        case "DMY":
            $enddate = date("j/n/Y",strtotime("+1 day",mktime(0,0,0,$enddateArray[1],$enddateArray[0],$enddateArray[2])));
            break;
        case "MDY":
            $enddate = date("n/j/Y",strtotime("+1 day",mktime(0,0,0,$enddateArray[0],$enddateArray[1],$enddateArray[2])));
            break;
        }
    }

    $wow->setMethod('GetPayments');
    $wow->addAttribute('logintype',$wowlogintype);

    $wow->addParameter('datatype','XML');

    if($startdate && trim($startdate) != "")
        $wow->addParameter('startdate',$startdate,'string');
    else
        $wow->addParameter('startdate',false,'boolean');

    if($enddate && trim($enddate) != "")
        $wow->addParameter('enddate',$enddate,'string');
    else
        $wow->addParameter('enddate',false,'boolean');

    $wow->addProperty('custid',$custid);

    if($wow->execute()) {
        return $wow->getAttributesArray();
    } else {
        return false;
    }
}

function GetSinglePayment($custid,$paymentnumber) {
    global $wow;
    global $wowlogintype;

    $wow->setMethod('GetPaymentDetails');
    $wow->addAttribute('logintype',$wowlogintype);

    $wow->addParameter('payid',$paymentnumber);
    $wow->addParameter('datatype','XML');

    $wow->addProperty('custid',$custid);

    if($wow->execute()) {
        $results['success'] = true;
        $results['data'] = $wow->getAttributesArray();
    } else {
        $results['success'] = false;
        $results['error'] = $wow->lastError;
    }

    return $results;
}

function MakePayment($custid,$balance,$invoices,$paymentinfo,$storeid) {
    global $wow;
    global $wowlogintype;

    // Clear Cache
    if($_SESSION['piwi']['custinfo'][$custid])
        unset($_SESSION['piwi']['custinfo'][$custid]);

    $wow->setMethod('PostPayment');
    $wow->addAttribute('logintype',$wowlogintype);

    $wow->addParameter('tender',$balance,'currency');
    switch($_SESSION['piwi']['dateformat']) {
        case "YMD":
            $wow->addParameter('paydate',date("Y/n/j"));
            break;
        case "DMY":
            $wow->addParameter('paydate',date("j/n/Y"));
            break;
        case "MDY":
            $wow->addParameter('paydate',date("n/j/Y"));
            break;
    }

    $wow->addParameter('invoicelist',$invoices);
    $wow->addParameter('paymenttypeid',$paymentinfo['type']);
    $wow->addParameter('custid',$custid);
    $wow->addParameter('paymentnumber',$paymentinfo['number']);
    $wow->addParameter('name',$paymentinfo['name']);
    $wow->addParameter('chargerealtime','1','integer');
    $wow->addParameter('ignore',false,'boolean');
    $wow->addParameter('noisy',false,'boolean');
    if($paymentinfo['month'] && $paymentinfo['year']) {
        switch($_SESSION['piwi']['dateformat']) {
        case "YMD":
            $wow->addParameter('ccexpire',date("Y/n/j",mktime(0,0,0,$paymentinfo['month']+1,0,$paymentinfo['year'])));
            break;
        case "DMY":
            $wow->addParameter('ccexpire',date("j/n/Y",mktime(0,0,0,$paymentinfo['month']+1,0,$paymentinfo['year'])));
            break;
        case "MDY":
            $wow->addParameter('ccexpire',date("n/j/Y",mktime(0,0,0,$paymentinfo['month']+1,0,$paymentinfo['year'])));
            break;
        }
    } else {
        $wow->addParameter('ccexpire',false,'boolean');
    }
    $wow->addParameter('noconn',false,'boolean');
    $wow->addParameter('authorizeonly',false,'boolean');
    $wow->addParameter('routenumber',$paymentinfo['routenumber']);
    $wow->addParameter('accounttype',$paymentinfo['accttype']);
    $wow->addParameter('bankname',$paymentinfo['bankname']);
    $wow->addParameter('datatype','XML');
    $wow->addParameter('address',trim($paymentinfo['address']['addr1']." ".$paymentinfo['address']['addr2']));
    $wow->addParameter('city',$paymentinfo['address']['city']);
    $wow->addParameter('state',$paymentinfo['address']['state']);
    $wow->addParameter('zip',$paymentinfo['address']['zip']);
    $wow->addParameter('country',$paymentinfo['address']['country']);

    $wow->addProperty('ccv2',$paymentinfo['cvv2']);

    if($wow->execute()) {
        $results['success'] = true;
    } else {
        $results['success'] = false;
        $results['errormsg'] = $wow->lastError;
    }

    return $results;
}

function GetServiceDetail($custid,$svcid,$dataid) {
    global $wow;
    global $wowlogintype;

    $wow->setMethod('GetServiceDetail');
    $wow->addAttribute('logintype',$wowlogintype);

    $wow->addParameter('svcid',$svcid);
    $wow->addParameter('dataid',$dataid);
    $wow->addParameter('datatype','XML');

    $wow->addProperty('custid',$custid);

    if($wow->execute()) {
        return $wow->getAttribute(0);
    } else {
        return false;
    }
}

function getEmail($custid) {
    global $wow;
    global $wowlogintype;

    $wow->setMethod('GetCustomer');
    $wow->addAttribute('logintype',$wowlogintype);

    $wow->addParameter('datatype','XML');

    $wow->addProperty('custid',$custid);

    if($wow->execute()) {
        return $wow->getAttribute(0,'email');
    } else {
        LogError('GetEmail',$wow->lastError);
        return false;
    }
}

function AddService($crid,$custid,$svcid,$fieldArray,$branch,$p_instance,$p_service) {
    global $wow;
    global $wowlogintype;

    $servicearray = array();

    $newrow = array();
    $newrow['column_name'] = 'crid';
    $newrow['newvalue']    = $crid;
    $newrow['oldvalue']    = 'NEW ENTRY';
    $newrow['control']     = 'txt_text';
    $newrow['display']     = 'CRID';
    array_push($servicearray,$newrow);

    $newrow = array();
    $newrow['column_name'] = 'd_custid';
    $newrow['newvalue']    = $custid;
    $newrow['oldvalue']    = 'NEW ENTRY';
    $newrow['control']     = 'txt_text';
    $newrow['display']     = 'Customer ID';
    array_push($servicearray,$newrow);

    if(isset($fieldArray) && is_array($fieldArray)) {
        foreach($fieldArray as $thisFieldName=>$thisFieldData) {
            $newrow = array();
            $newrow['column_name']  = $thisFieldName;
            $newrow['newvalue'] = trim($thisFieldData['value']);
            if(strtoupper($thisFieldName) == 'D_ACTIVE') {
                $newrow['oldvalue']     = 'Y';
            } else {
                $newrow['oldvalue']     = 'NEW ENTRY';
            }
            $newrow['control']      = $thisFieldData['type'];
            $newrow['display']      = $thisFieldData['name'];
            array_push($servicearray,$newrow);
        }
    }

    $wow->setMethod('AddService');
    $wow->addAttribute('logintype',$wowlogintype);

    $wow->addParameter('serviceid',$svcid);
    $wow->addParameter('crid',$crid);
    $wow->addParameter('columnarray',$servicearray,'array');
    $wow->addParameter('datatype','XML');
    $wow->addParameter('noconn',false,'boolean');
    $wow->addParameter('branch',$branch);
    $wow->addParameter('parentInstance',$p_instance);
    $wow->addParameter('parentService',$p_service);

    $wow->addProperty('custid',$custid);

    if($wow->execute()) {
        $results['success'] = true;
        $results['data_id'] = $wow->getAttribute(0,'dataid');
        if(isset($_SESSION['piwi']['listservices'][$svcid]))
            unset($_SESSION['piwi']['listservices'][$svcid]);
        if(isset($_SESSION['piwi']['listservices']['BLANK']))
            unset($_SESSION['piwi']['listservices']['BLANK']);
    } else {
        $results['success'] = false;
        $results['error'] = $wow->lastError;
    }

    return $results;
}

function UpdateService($custid,$svcid,$dataid,$fieldArray,$branch,$p_instance,$p_service) {
    global $wow;
    global $wowlogintype;

    $servicearray = array();

    // hard-coding of d_active, as it's NECESSARY for every call
    $newrow = array();
    $newrow['columnname'] = 'd_active';
    if(!$fieldArray['d_active']['value']) // support for customer page
        $newrow['newvalue'] = $fieldArray['d_active']['currentvalue'];
    else
        $newrow['newvalue'] = $fieldArray['d_active']['value'];
    $newrow['currentvalue'] = $fieldArray['d_active']['currentvalue'];
    $newrow['control'] = 'dropdown';
    $newrow['displayname'] = 'Active Status';
    array_push($servicearray,$newrow);

    if(isset($fieldArray) && is_array($fieldArray)) {
        foreach($fieldArray as $thisFieldName=>$thisFieldData) {
            if($thisFieldName != 'd_active') {
                $newrow = array();
                $newrow['columnname']   = $thisFieldName;
                $newrow['newvalue']     = trim($thisFieldData['value']);
                $newrow['currentvalue'] = $thisFieldData['currentvalue'];
                $newrow['control']      = $thisFieldData['type'];
                $newrow['displayname']  = $thisFieldData['name'];
                array_push($servicearray,$newrow);
            }
        }
    }

    $wow->setMethod('UpdateService');
    $wow->addAttribute('logintype',$wowlogintype);

    $wow->addParameter('serviceid',$svcid);
    $wow->addParameter('dataid',$dataid);
    $wow->addParameter('columnarray',$servicearray,'array');
    $wow->addParameter('datatype','XML');
    $wow->addParameter('branch',$branch);
    $wow->addParameter('parentInstance',$p_instance);
    $wow->addParameter('parentService',$p_service);

    $wow->addProperty('custid',$custid);

    if($wow->execute()) {
        $results['success'] = true;
        if(isset($_SESSION['piwi']['listservices'][$svcid]))
            unset($_SESSION['piwi']['listservices'][$svcid]);
        if(isset($_SESSION['piwi']['listservices']['BLANK']))
            unset($_SESSION['piwi']['listservices']['BLANK']);
    } else {
        $results['success'] = false;
        $results['error'] = $wow->lastError;
    }

    return $results;
}

function DeleteService($serviceData) {
    global $wow;
    global $wowlogintype;

    $wow->setMethod('DeleteService');
    $wow->addAttribute('logintype',$wowlogintype);

    $wow->addParameter('serviceid',$serviceData['svc_id']);
    $wow->addParameter('dataid',$serviceData['data_id']);
    $wow->addParameter('datatype','XML');
    $wow->addParameter('branch',$serviceData['d_struct_id']);
    $wow->addParameter('parentInstance',$serviceData['d_parent_id']);
    $wow->addParameter('parentService',$serviceData['d_parent_type']);

    $wow->addProperty('custid',$serviceData['d_custid']);

    if($wow->execute()) {
        $result['success'] = true;
        if(isset($_SESSION['piwi']['listservices'][$svcid]))
            unset($_SESSION['piwi']['listservices'][$svcid]);
        if(isset($_SESSION['piwi']['listservices']['BLANK']))
            unset($_SESSION['piwi']['listservices']['BLANK']);
    } else {
        $result['success'] = false;
        $result['error'] = $wow->lastError;
    }

    return $result;
}

function launchUM($custid,$option,$dataid = false) {
    global $wow;
    global $wowlogintype;

    $wow->setMethod('LaunchUM');
    $wow->addAttribute('logintype',$wowlogintype);

    $wow->addParameter('option','UM_'.$option);
    $wow->addParameter('dataid',$dataid,$dataid ? 'string' : 'boolean');
    $wow->addParameter('openconnection','1','string');
    $wow->addParameter('datatype','XML');

    $wow->addProperty('custid',$custid);

    if($wow->execute()) {
        $results['success'] = true;
    } else {
        $results['success'] = false;
        $results['error'] = $wow->lastError;
    }

    return $results;
}

function MultiSecurityCheck($sectags) {
    global $wow;
    global $wowlogintype;

    $results = false;

    $wow->setMethod('chk_multi_sec');
    $wow->addAttribute('logintype',$wowlogintype);

    $wow->addParameter('sectags',$sectags,'array');
    $wow->addParameter('datatype','XML');

    if($wow->execute()) {
        $results = $wow->getAttributesArray();
        foreach($results as &$result) {
            if (strcasecmp($result['item_2'],'true') == 0) { //using strcasecmp() because web objects prior to version [] returned "True" or "False"
                $result['item_2'] = true;
            } else {
                $result['item_2'] = false;
            }
        }
        unset($result);
    }

    return $results;
}

function SecurityCheck($sectag) {
    global $wow;
    global $wowlogintype;

    $wow->setMethod('chk_sec');
    $wow->addAttribute('logintype',$wowlogintype);

    $wow->addParameter('sectag',$sectag);
    $wow->addParameter('category',false,'boolean');
    $wow->addParameter('noconn',false,'boolean');
    $wow->addParameter('datatype','XML');

    if($wow->execute()) {
        if($wow->getAttribute(0,'return_value') === 'true')
            return true;
    }

    return false;
}

function UpdateCustomer($custid,$column,$value) {
    global $wow;
    global $wowlogintype;

    // Clear Cache
    if($_SESSION['piwi']['custinfo'][$custid])
        unset($_SESSION['piwi']['custinfo'][$custid]);

    $wow->setMethod('UpdateCustomer');
    $wow->addAttribute('logintype',$wowlogintype);

    $wow->addParameter('column',$column);
    if(is_numeric($value)) {
        $wow->addParameter('value',$value);
    } else {
        $wow->addParameter('value',"'".$value."'");
    }
    $wow->addParameter('datatype','XML');
    $wow->addProperty('custid',$custid);

    if($wow->execute()) {
        $results['success'] = true;
    } else {
        $results['success'] = false;
        $results['error'] = $wow->lastError;
    }

    return $results;
}

function UpdatePhone($custid,$phonetype,$number) {
    global $wow;
    global $wowlogintype;

    $phonearray = array();

    $newrow = array();
    $newrow['col_name'] = 'Number';
    $newrow['col_value'] = $number;
    array_push($phonearray,$newrow);

    $wow->setMethod('SetPhone');
    $wow->addAttribute('logintype',$wowlogintype);

    $wow->addParameter('datatype','XML');
    $wow->addParameter('phonearray',$phonearray,'array');
    $wow->addParameter('phonetype',$phonetype,'integer');

    $wow->addProperty('custid',$custid);

    if($wow->execute()) {
        $results['success'] = true;
    } else {
        $results['success'] = false;
        $results['error'] = $wow->lastError;
    }

    return $results;
}

function UpdateAddress($custid,$addresstype,$attn,$addr1,$addr2,$city,$state,$zip,$country) {
    global $wow;
    global $wowlogintype;

    $addressarray = array();

    $newrow = array();
    $newrow['col_name'] = 'attn';
    $newrow['col_value'] = $attn;
    array_push($addressarray,$newrow);
    $newrow = array();
    $newrow['col_name'] = 'addr1';
    $newrow['col_value'] = $addr1;
    array_push($addressarray,$newrow);
    $newrow = array();
    $newrow['col_name'] = 'addr2';
    $newrow['col_value'] = $addr2;
    array_push($addressarray,$newrow);
    $newrow = array();
    $newrow['col_name'] = 'city';
    $newrow['col_value'] = $city;
    array_push($addressarray,$newrow);
    $newrow = array();
    $newrow['col_name'] = 'state';
    $newrow['col_value'] = $state;
    array_push($addressarray,$newrow);
    $newrow = array();
    $newrow['col_name'] = 'zip';
    $newrow['col_value'] = $zip;
    array_push($addressarray,$newrow);
    $newrow = array();
    $newrow['col_name'] = 'country';
    $newrow['col_value'] = $country;
    array_push($addressarray,$newrow);

    $wow->setMethod('setaddress');
    $wow->addAttribute('logintype',$wowlogintype);

    $wow->addParameter('datatype','XML');
    $wow->addParameter('addrarray',$addressarray,'array');
    $wow->addParameter('addrtype',$addresstype,'integer');

    $wow->addProperty('custid',$custid);

    if($wow->execute()) {
        $results['success'] = true;
    } else {
        $results['success'] = false;
        $results['error'] = $wow->lastError;
    }

    return $results;
}

function UpdateBillingInfo($custid,$cctype,$ccmonth,$ccyear,$ccnumber,$ccname,$ccupdate = true) {
    if($ccupdate) {
        global $wow;
        global $wowlogintype;

        // Clear Cache
		if($_SESSION['piwi']['custinfo'][$custid])
			unset($_SESSION['piwi']['custinfo'][$custid]);


        $wow->setMethod('UpdateCCInfo');
        $wow->addAttribute('logintype',$wowlogintype);

        $wow->addParameter('cctype',$cctype);
        $wow->addParameter('ccmonth',$ccmonth);
        $wow->addParameter('ccyear',$ccyear);
        $wow->addParameter('ccnumber',$ccnumber);
        $wow->addParameter('ccname',$ccname);
        $wow->addParameter('datatype','XML');

        $wow->addProperty('custid',$custid);

        if($wow->execute()) {
            $results['success'] = true;
        } else {
            $results['success'] = false;
            $results['error'] = $wow->lastError;
        }
    } else {
        $setccnumberResults = UpdateCustomer($custid,'ccnumber',$ccnumber);
        if($ccmonth && $ccyear) {
            switch($_SESSION['piwi']['dateformat']) {
            case "YMD":
                $setccdateResults = UpdateCustomer($custid,'ccdate',date("Y/n/j",mktime(0,0,0,$ccmonth+1,0,$ccyear)));
                break;
            case "DMY":
                $setccdateResults = UpdateCustomer($custid,'ccdate',date("j/n/Y",mktime(0,0,0,$ccmonth+1,0,$ccyear)));
                break;
            case "MDY":
                $setccdateResults = UpdateCustomer($custid,'ccdate',date("n/j/Y",mktime(0,0,0,$ccmonth+1,0,$ccyear)));
                break;
            }
        } else {
            $setccdateResults = ExecuteSQL("update customer set ccdate = NULL where id = ".SQLTrim($custid));
        }
        $setcctypeResults = UpdateCustomer($custid,'cctype',$cctype);
        if($setccnumberResults['success'] && $setccdateResults['success'] && $setcctypeResults['success']) {
            $results['success'] = true;
        } else {
            $results['success'] = false;
            $results['error'] = ($setccnumberResults['error'] ? $setccnumberResults['error']."\n" : "") . ($setccdateResults['error'] ? $setccdateResults['error']."\n" : "") . ($setcctypeResults['error'] ? $setcctypeResults['error']."\n" : "");
        }
    }

    return $results;
}

function ValidateCard($cctype,$ccnumber,$ccmonth,$ccyear) {
    $error = "";

    if(!$ccnumber) {
        $error .= 'Credit Card Number is blank.  ';
    }

    if(!$cctype) {
        $error .= 'Credit Card Type is blank.  ';
    }

    if(!$ccmonth) {
        $error .= 'CC Expiration Date Month is blank.  ';
    }

    if(!$ccyear) {
        $error .= 'CC Expiration Date Year is blank.  ';
    }

    if(strlen($error) == 0) {
        $cclength = strlen($ccnumber);
        switch($cctype) {
            case 'VISA':
                if($cclength != 13 && $cclength != 16)
                    $error .= 'VISA Length Invalid.  ';
                if(substr($ccnumber,0,1) != '4')
                    $error .= 'VISA Number Invalid.  ';
                break;
            case 'MASTERCARD':
                if($cclength != 16)
                    $error .= 'MASTERCARD Length Invalid.  ';
                if(substr($ccnumber,0,2) != '51' && substr($ccnumber,0,2) != '52' && substr($ccnumber,0,2) != '53' && substr($ccnumber,0,2) != '54' && substr($ccnumber,0,2) != '55')
                    $error .= 'MASTERCARD Number Invalid.  ';
                break;
            case 'AMEX':
                if($cclength != 15)
                    $error .= 'AMEX Length Invalid.  ';
                if(substr($ccnumber,0,2) != '34' && substr($ccnumber,0,2) != '37')
                    $error .= 'AMEX Number Invalid.  ';
                break;
            case 'DISCOVER':
                if($cclength != 16)
                    $error .= 'DISCOVER Length Invalid.  ';
                if(substr($ccnumber,0,4) != '6011')
                    $error .= 'DISCOVER Number Invalid.  ';
                break;
        }

        $ccnumberArray = array();
        $ccextradigits = 0;
        $checksum = 0;

        for($index=$cclength-1;$index>=0;$index--) {
            array_push($ccnumberArray,substr($ccnumber,$index,1));
        }

        if(isset($ccnumberArray) && is_array($ccnumberArray)) {
            foreach($ccnumberArray as $ccIndex=>$ccValue) {
                if($ccIndex%2 == 1) {
                    $checksum += ($ccValue * 2);
                    if(($ccValue * 2) > 9) {
                        $checksum -= 9;
                    }
                } else {
                    $checksum += $ccValue;
                }
            }
        }

        if($checksum%10 != 0) {
            $error .= 'Invalid Card Number.  ';
        }

        $expDate = mktime(0,0,0,$ccmonth+1,0,$ccyear);

        if(time() > $expDate) {
            $error .= 'Invalid Expiration Date.  ';
        }
    }

    if(strlen($error) == 0) {
        $results['success'] = true;
    } else {
        $results['success'] = false;
        $results['error'] = $error;
    }

    return $results;
}

function UpdatePassword($custid,$oldpassword,$newpassword,$confirmnewpassword) {
    global $wow;
    global $wowlogintype;

    $wow->setMethod('ChangePassword');
    $wow->addAttribute('logintype',$wowlogintype);

    $wow->addParameter('datatype','XML');

    $wow->addProperty('custid',$custid);
    $wow->addProperty('password',$oldpassword);
    $wow->addProperty('newpassword',$newpassword);
    $wow->addProperty('password2',$confirmnewpassword);

    if($wow->execute()) {
        $results['success'] = true;
    } else {
        $results['success'] = false;
        $results['error'] = $wow->lastError;
    }

    return $results;
}

function GetReportCategories() {
    global $wow;
    global $wowlogintype;

    $categories = array();

    $wow->setMethod('GetReportCategories');
    $wow->addAttribute('logintype',$wowlogintype);

    $wow->addParameter('datatype','XML');

    if($wow->execute()) {
        if(is_array($wow->getAttributesArray())) {
            foreach($wow->getAttributesArray() as $thisCategory) {
                array_push($categories,$thisCategory['category']);
            }
        }

        return $categories;
    } else {
        return false;
    }
}

function GetReports($category) {
    global $wow;
    global $wowlogintype;

    $wow->setMethod('GetReports');
    $wow->addAttribute('logintype',$wowlogintype);

    $wow->addParameter('reportcategory',$category);
    $wow->addParameter('datatype','XML');

    if($wow->execute()) {
        $reports = $wow->getAttributesArray();
        $nonwebReports = ExecuteSQL("select id from reports where category = '".SQLTrim($category)."' and r_param != 'X' and (selection like '%?%' or selection2 like '%?%' or selection3 like '%?%')");

        if($nonwebReports['success'] && isset($nonwebReports['sqlreturn']) && is_array($nonwebReports['sqlreturn']) && count($nonwebReports['sqlreturn']) > 0) {
            foreach($nonwebReports['sqlreturn'] as $excludeThisReport) {
                if(isset($reports) && is_array($reports)) {
                    foreach($reports as $thisReportIndex => $thisReport) {
                        if($thisReport['id'] == $excludeThisReport['id']) {
                            unset($reports[$thisReportIndex]);
                            break;
                        }
                    }
                }
            }
        }

        return $reports;
    } else {
        return false;
    }
}

function GetSingleReport($category,$reportid,$reports = false) {
    if(!$reports) {
        $reports = GetReports($category);
    }

    if(isset($reports) && is_array($reports)) {
        foreach($reports as $thisReport) {
            if($thisReport['id'] == $reportid) {
                $report = $thisReport;
                break;
            }
        }

        $sqlreports = ExecuteSQL("select criteria from reports where id = ".SQLTrim($report['id']));
        if($sqlreports['success']) {
            $criteria = explode(',', $sqlreports['sqlreturn'][0]['criteria']);
        }

        if(isset($criteria) && is_array($criteria)) {
            foreach($criteria as $thisCriteria) {
                if($thisCriteria == 'A') {
                    $report['criteria']['date'] = true;
                }

                if($thisCriteria == 'B') {
                    $report['criteria']['daterange'] = true;
                }

                if($thisCriteria == 'C') {
                    $report['criteria']['id'] = true;
                }

                if($thisCriteria == 'D') {
                    $report['criteria']['idrange'] = true;
                }

                if($thisCriteria == 'E') {
                    $report['criteria']['stores'] = true;
                }
            }
        }

        if($report) {
            return $report;
        } else {
            return false;
        }
    } else {
        return false;
    }
}

function RunReport($reportArray,$staffid) {
    global $wow;
    global $wowlogintype;

    $storedata = GetStores($staffid);
    $storeArray = array();

    if(isset($reportArray['storeid']) && is_array($reportArray['storeid'])) {
        foreach($reportArray['storeid'] as $thisStoreID=>$thisStoreSwitch) {
            array_push($storeArray,$thisStoreID);
        }
    } else {
        if(isset($storedata['storesList']) && is_array($storedata['storesList'])) {
            foreach($storedata['storesList'] as $thisStore) {
                array_push($storeArray,$thisStore['storeid']);
            }
        }
    }

    $wow->setMethod('getreportfile');
    $wow->addAttribute('logintype',$wowlogintype);

    $wow->addParameter('reportId',$_SESSION['piwi']['reports']['id'],'integer');

    if($reportArray['date']['formatted']) {
        $wow->addParameter('startdate',$reportArray['date']['formatted'],'date');
        $wow->addParameter('enddate',$reportArray['date']['formatted'],'date');
    } else {
        if($reportArray['startdate']['formatted'] && $reportArray['enddate']['formatted']) {
            $wow->addParameter('startdate',$reportArray['startdate']['formatted'],'date');
            $wow->addParameter('enddate',$reportArray['enddate']['formatted'],'date');
        } else {
            $wow->addParameter('startdate',false,'boolean');
            $wow->addParameter('enddate',false,'boolean');
        }
    }

    if($reportArray['id']) {
        $wow->addParameter('startid',$reportArray['id']);
        $wow->addParameter('endid',$reportArray['id']);
    } else {
        if($reportArray['startid'] && $reportArray['endid']) {
            $wow->addParameter('startid',$reportArray['startid']);
            $wow->addParameter('endid',$reportArray['endid']);
        } else {
            $wow->addParameter('startid',false,'boolean');
            $wow->addParameter('endid',false,'boolean');
        }
    }

    $wow->addParameter('cStores',implode(',',$storeArray));

    $wow->addParameter('datatype','XML');

    if($wow->execute()) {
        $filedata = $wow->getAttribute(0,'reportfile');
        $filedata = base64_decode($filedata);
        return $filedata;
    } else {
        return false;
    }
}

function GetStores($staffid) {
    global $wow;
    global $wowlogintype;

    $wow->setMethod('GetStores');
    $wow->addAttribute('logintype',$wowlogintype);

    $wow->addParameter('datatype','xml');

    if($wow->execute()) {
        $storeData['storesList'] = $wow->getAttributesArray();
        $storesAllowed = ExecuteSQL("select CR_CompanyID from CompanyRelationship where CR_Type = 'Staff' and CR_TypeID = ".SQLTrim($staffid));
        if($storesAllowed['success'] && isset($storeData['storesList']) && is_array($storeData['storesList'])) {
            foreach($storeData['storesList'] as $thisStoreKey=>$thisStore) {
                $keepStore = false;
                if(isset($storesAllowed['sqlreturn']) && is_array($storesAllowed['sqlreturn'])) {
                    foreach($storesAllowed['sqlreturn'] as $thisAllowedStore) {
                        if($thisStore['storeid'] == $thisAllowedStore['cr_companyid']) {
                            $keepStore = true;
                        }
                    }
                }

                if(!$keepStore) {
                    unset($storeData['storesList'][$thisStoreKey]);
                }
            }
        }
        $storeData['storeCount'] = count($storeData['storesList']);

        return $storeData;
    } else {
        return false;
    }
}

function ChangeStatus($custid,$status,$reason) {
    global $wow;
    global $wowlogintype;

    $wow->setMethod('ChangeStatus');
    $wow->addAttribute('logintype',$wowlogintype);

    $wow->addParameter('newstatus',$status);
    $wow->addParameter('reasonid','999');
    $wow->addParameter('reasonnote',$reason);
    $wow->addParameter('datatype','XML');

    $wow->addProperty('custid',$custid);

    if($wow->execute()) {
        $results['success'] = true;
    } else {
        $results['success'] = false;
        $results['error'] = $wow->lastError;
    }

    return $results;
}

function GetStmtMethods() {
    $sqlResults = ExecuteSQL("select value from stmtmethods");
    $stmtmethods = array();
    if($sqlResults['success'] && isset($sqlResults['sqlreturn']) && is_array($sqlResults['sqlreturn'])) {
        foreach($sqlResults['sqlreturn'] as $thisType) {
            array_push($stmtmethods,$thisType['value']);
        }
    }
    return $stmtmethods;
}

function GetBlockTime($showDetails = false) {
    global $wow;
    global $wowlogintype;

    $wow->setMethod('GetAvailableBlockRates');
    $wow->addAttribute('logintype',$wowlogintype);

    $wow->addParameter('datatype','XML');
    $wow->addParameter('details',$showDetails,'boolean');

    if($wow->execute()) {
        return $wow->getAttributesArray();
    } else {
        return false;
    }
}

function AddBlockTime($custid,$blockrate) {
    global $wow;
    global $wowlogintype;

    $wow->setMethod('AddBlockTime');
    $wow->addAttribute('logintype',$wowlogintype);

    $wow->addParameter('blockrateid',$blockrate);
    $wow->addParameter('quantity',1,'int');
    $wow->addParameter('nosave',false,'boolean');
    $wow->addParameter('datatype','XML');

    $wow->addProperty('custid',$custid,'string');

    if($wow->execute()) {
        $results['success'] = true;
    } else {
        $results['success'] = false;
        $results['errormsg'] = $wow->lastError;
    }

    return $results;
}

function ValidCRID($custid,$crid) {
    $results = ExecuteSQL("select * from custrate where crid = ".SQLTrim($crid)." and custid = ".SQLTrim($custid));
    if ($results['success'] && is_array($results['sqlreturn'])) {
        return true;
    } else {
        return false;
    }
}

function ShowMoney($string) {
    if($string == "")
 		return "0.00";
    $pos = strstr($string,".");
    $tail = "." . substr($pos,1,2);

    if($pos == $tail) {
        return str_replace(" ","",fixMoney($string));
    } else {
        return $string;
    }
}


function loadHelpdeskOptions(){
    if (isset($_SESSION['ccs']['options']['driver-options']['url-prefix'])){
        if (isset($_SESSION['ccs']['options']['helpdesk-options']['staff-enabled']) &&
                strtolower($_SESSION['ccs']['options']['helpdesk-options']['staff-enabled']) == 'true')
            $_SESSION['helpdesk']['options']['staffEnabled'] = true;
        if (isset($_SESSION['ccs']['options']['helpdesk-options']['customer-enabled']) &&
                strtolower($_SESSION['ccs']['options']['helpdesk-options']['customer-enabled']) == 'true')
            $_SESSION['helpdesk']['options']['customerEnabled'] = true;
        if ($_SESSION['helpdesk']['options']['customerEnabled'] || $_SESSION['helpdesk']['options']['staffEnabled']){
            $prefix = $_SESSION['ccs']['options']['driver-options']['url-prefix'];
            $_SESSION['helpdesk']['options']['driver-options']['url']     = $prefix . "://" . $_SERVER['HTTP_HOST'] . "/projects/helpdesk/index.php";
            $_SESSION['helpdesk']['options']['driver-options']['piwiURL'] = $prefix . "://" . $_SERVER['HTTP_HOST'] . "/projects/piwi/index.php";
            return true;
        }
    }
    return false;
}

function GetServiceCommands(&$thisBranch) {
    global $wow;
    global $wowlogintype;

    if(isset($_SESSION['piwi']['serviceCommands'][$thisBranch['rs_svc_id']]['addCommand']) && is_array($_SESSION['piwi']['serviceCommands'][$thisBranch['rs_svc_id']]['addCommand'])) { // if an addCommand exists for this branch's service type
        $wow->setMethod('RunServiceCommandNew');
        $wow->addAttribute('logintype',$wowlogintype);

        $wow->addParameter('command_id',$_SESSION['piwi']['serviceCommands'][$thisBranch['rs_svc_id']]['addCommand']['sc_id']);
        $wow->addParameter('data_id',0);
        $wow->addParameter('crid',$thisBranch['rs_cr_id']);
        $wow->addParameter('struct',$thisBranch['rs_id']);
        $wow->addParameter('parent',$thisBranch['parent_instance']);
        $wow->addParameter('parentType',$thisBranch['parent_service']);
        $wow->addParameter('datatype','XML');

        $wow->addProperty('custid',$_SESSION['piwi']['custid']);

        if($wow->execute()) {
            $urlData = $wow->getAttribute(0);

            $thisBranch['addCommand']['url'] = urldecode($urlData['url']);

            if($urlData['data']) {
                $thisBranch['addCommand']['parameters'] = array();
                $paramArray = explode('&',$urlData['data']);

                if(isset($paramArray) && is_array($paramArray)) {
                    foreach($paramArray as $thisParameter) {
                        if(strpos($thisParameter,'=')) {
                            $thisBranch['addCommand']['parameters'][substr($thisParameter,0,strpos($thisParameter,'='))] = urldecode(substr($thisParameter,strpos($thisParameter,'=')+1));
                        } else {
                            $thisBranch['addCommand']['parameters'][$thisParameter] = true;
                        }
                    }
                }
            }
        }
    }

    if(isset($_SESSION['piwi']['serviceCommands'][$thisBranch['rs_svc_id']]['modifyCommands']) && is_array($_SESSION['piwi']['serviceCommands'][$thisBranch['rs_svc_id']]['modifyCommands']) && isset($thisBranch['services']) && is_array($thisBranch['services'])) { // if command(s) exist AND service instance(s) exist
        foreach($thisBranch['services'] as &$thisService) { // loop through each service instance and make the run command for it
            $thisService['svcCommands'] = array();
            foreach($_SESSION['piwi']['serviceCommands'][$thisBranch['rs_svc_id']]['modifyCommands'] as $thisCommand) {
                if(strtoupper($thisCommand['sc_type']) == 'URL') { // if it's URL, run the command to get parameters for POST
                    $wow->setMethod('RunServiceCommand');
                    $wow->addAttribute('logintype',$wowlogintype);

                    $wow->addParameter('command_id',$thisCommand['sc_id']);
                    $wow->addParameter('data_id',$thisService['s_num']);
                    $wow->addParameter('datatype','XML');

                    $wow->addProperty('custid',$_SESSION['piwi']['custid']);

                    if($wow->execute()) {
                        $urlData = $wow->getAttribute(0);
                        $commandData = array();

                        $commandData['sc_caption'] = $thisCommand['sc_caption'];
                        $commandData['sc_type'] = 'URL';
                        $commandData['url'] = urldecode($urlData['url']);

                        if($urlData['data']) {
                            $commandData['parameters'] = array();
                            $paramArray = explode('&',$urlData['data']);

                            if(isset($paramArray) && is_array($paramArray)) {
                                foreach($paramArray as $thisParameter) {
                                    if(strpos($thisParameter,'=')) {
                                        $commandData['parameters'][substr($thisParameter,0,strpos($thisParameter,'='))] = urldecode(substr($thisParameter,strpos($thisParameter,'=')+1));
                                    } else {
                                        $commandData['parameters'][$thisParameter] = true;
                                    }
                                }
                            }
                        }

                        array_push($thisService['svcCommands'],$commandData);
                    }
                } else { // just put the command parameters in the array for use in the servicecommand event
                    $commandData = array();
                    $commandData['sc_caption'] = $thisCommand['sc_caption'];
                    $commandData['sc_type'] = $thisCommand['sc_type'];
                    $commandData['sc_id'] = $thisCommand['sc_id'];

                    array_push($thisService['svcCommands'],$commandData);
                }
            }
        }
    }
}

function GetRadiusUsageHistory($dataid) {
    $sqlResults = ExecuteSQL("select top 6 * from radius_summary where instance=".$dataid." order by date desc");
    $radiusHistory = array();
    if($sqlResults['success'] && isset($sqlResults['sqlreturn']) && is_array($sqlResults['sqlreturn'])) {
        foreach($sqlResults['sqlreturn'] as $thisType) {
            array_push($radiusHistory,$thisType);
        }
    }
    return $radiusHistory;
}

function EmailPassword($username) {
    $results = array();
    $templateFile = "../../etc/lostpassword.xml";
    $userData = ExecuteSQL("select email,password,username from customer where username = '".SQLTrim($username)."' or email = '".SQLTrim($username)."'");

    if($userData['success'] && count($userData['sqlreturn'][0]) != 3) {
        $results['success'] = false;
        $results['error'] = "Invalid username or email address.";
    } else {
        if($userData['success'] && !$userData['sqlreturn'][0]['email']) {
            $results['success'] = false;
            $results['error'] = "There is no email address associated with the specified username.";
        } else {
            if(!file_exists($templateFile)) {
                $results['success'] = false;
                $results['error'] = "Service unavailable at this time.";
            } else {
                $templateData = simplexml_load_file($templateFile);

                if(isset($templateData)) {
                foreach($templateData as $thisFieldName=>$thisFieldData) {
                    $template[$thisFieldName] = (string) $thisFieldData;
                }
                }

                $template['body'] = str_replace('XXUSERNAMEXX',$userData['sqlreturn'][0]['username'],$template['body']);
                $template['body'] = str_replace('XXPASSWORDXX',$userData['sqlreturn'][0]['password'],$template['body']);

                global $wow;
                global $wowlogintype;

                $wow->setMethod('SendMail');
                $wow->addAttribute('logintype',$wowlogintype);

                $wow->addParameter('toaddr',$userData['sqlreturn'][0]['email']);
                $wow->addParameter('fromaddr',$template['from']);
                $wow->addParameter('subject',$template['subject']);
                $wow->addParameter('emailbody',$template['body']);
                $wow->addParameter('ccaddr','');
                $wow->addParameter('datatype','XML');

                if($wow->execute()) {
                    $results['success'] = true;
                } else {
                    $results['success'] = false;
                    $results['error'] = $wow->lastError;
                }
            }
        }
    }

    return $results;
}

function sec2hms ($sec, $padHours = false)
  {

    // start with a blank string
    $hms = "";

    // do the hours first: there are 3600 seconds in an hour, so if we divide
    // the total number of seconds by 3600 and throw away the remainder, we're
    // left with the number of hours in those seconds
    $hours = intval(intval($sec) / 3600);

    // add hours to $hms (with a leading 0 if asked for)
    $hms .= ($padHours)
          ? str_pad($hours, 2, "0", STR_PAD_LEFT). ":"
          : $hours. ":";

    // dividing the total seconds by 60 will give us the number of minutes
    // in total, but we're interested in *minutes past the hour* and to get
    // this, we have to divide by 60 again and then use the remainder
    $minutes = intval(($sec / 60) % 60);

    // add minutes to $hms (with a leading 0 if needed)
    $hms .= str_pad($minutes, 2, "0", STR_PAD_LEFT). ":";

    // seconds past the minute are found by dividing the total number of seconds
    // by 60 and using the remainder
    $seconds = intval($sec % 60);

    // add seconds to $hms (with a leading 0 if needed)
    $hms .= str_pad($seconds, 2, "0", STR_PAD_LEFT);

    // done!
    return $hms;

  }
?>
