<?php

// *******************************************************************
// COMMENTS IN CAPS ARE TEMP UNTIL FIXED, COMPLETED, CHANGED, ETC ....
// *******************************************************************

require_once('platfunctions.php');
require_once('../../libs/platypus/wow.inc.php');
require_once("../../libs/ccs/options.inc.php");

//---- load the CCS Options have to laod it here because this is the first manditory function call
if (!$_SESSION['ccs'])
    loadCCSOptions();

$stafflogin = $_SESSION['wow']['staffname'];
$staffpass  = $_SESSION['wow']['staffpass'];

global $wow;

$wow = new WOW_Request();

$wow->setUsername($stafflogin);
$wow->setPassword($staffpass);

function AH_AddRegTemplate (ACF_ParameterList $inParameterList) {
    $templateData = $inParameterList->ParameterValue('template');

    if (trim($templateData['regcode']) == "") {
        $paramList = new ACF_ParameterList();
        $paramList->AddParameter(new ACF_DirectParameter('error',"The 'Template Name' cannot be left blank."));
        $retEvent = new ACF_Event('addregtemplate_fail');
        $retEvent->SetParameterList($paramList);
        return $retEvent;
    }
    if (!is_numeric($templateData['reuse'])) {
        $paramList = new ACF_ParameterList();
        $paramList->AddParameter(new ACF_DirectParameter('error',"The 'Number of Uses Allowed' must be a number."));
        $retEvent = new ACF_Event('addregtemplate_fail');
        $retEvent->SetParameterList($paramList);
        return $retEvent;
    }
    if (!is_numeric($templateData['affinity']) || ($templateData['affinity'] != 1 && $templateData['affinity'] != 0)) {
        $paramList = new ACF_ParameterList();
        $paramList->AddParameter(new ACF_DirectParameter('error',"The 'Affinity Action' must be a number."));
        $retEvent = new ACF_Event('addregtemplate_fail');
        $retEvent->SetParameterList($paramList);
        return $retEvent;
    }
    if (!is_numeric($templateData['prepaidamount'])) {
        $paramList = new ACF_ParameterList();
        $paramList->AddParameter(new ACF_DirectParameter('error',"The 'Prepaid Amount' must be a number."));
        $retEvent = new ACF_Event('addregtemplate_fail');
        $retEvent->SetParameterList($paramList);
        return $retEvent;
    }
    if (!is_numeric($templateData['prepaid_paymenttype'])) {
        $paramList = new ACF_ParameterList();
        $paramList->AddParameter(new ACF_DirectParameter('error',"The 'Prepaid Payment Type' must be a number."));
        $retEvent = new ACF_Event('addregtemplate_fail');
        $retEvent->SetParameterList($paramList);
        return $retEvent;
    }

    $addCommand  = "insert into reg_header (reg_template,reg_create,"
           . "reg_expire,reg_reuse,reg_affinity,reg_displayrates,"
           . "reg_displayblock,reg_prepaid,reg_prepaidamount,"
           . "reg_prepaid_paymenttype) values (";
    $addCommand .= "'".SQLTrim($templateData['regcode'])."',";
    $addCommand .= "'".SQLTrim($templateData['create'])."',";
    if(!$templateData['expire'])
        $addCommand .= "NULL,";
    else
        $addCommand .= "'".SQLTrim($templateData['expire'])."',";
    $addCommand .= ((integer) $templateData['reuse']).",";
    $addCommand .= "'".((integer) $templateData['affinity'])."',";
    $addCommand .= "'".SQLTrim($templateData['displayrates'])."',";
    $addCommand .= "'".SQLTrim($templateData['displayblock'])."',";
    $addCommand .= "'".SQLTrim($templateData['prepaid'])."',";
    if(!$templateData['prepaidamount'])
        $addCommand .= "0,";
    else
        $addCommand .= ((float) $templateData['prepaidamount']).",";
    $addCommand .= ((integer) $templateData['prepaid_paymenttype']);
    $addCommand .= ")";

    $addSuccess = ExecuteSQL($addCommand);

    if($addSuccess)
        return new ACF_Event('addregtemplate_success');
    else {
        $paramList = new ACF_ParameterList();
        $paramList->AddParameter(new ACF_DirectParameter('error',"Error Adding Registration Code Template"));
        $retEvent = new ACF_Event('addregtemplate_fail');
        $retEvent->SetParameterList($paramList);
        return $retEvent;
    }
}

function AH_StaffLogin (ACF_ParameterList $inParameterList) {
    $username = trim($inParameterList->ParameterValue('username'));
    $password = trim($inParameterList->ParameterValue('password'));
    $status = array();

//---- create the API object
    global $wow;
//---- assign values to the API object
    $wow->setMethod('Login');
    $wow->addAttribute('logintype', 'staff');
    $wow->setUsername('');
    $wow->setPassword('');

    $wow->addParameter('logintype','staff');
    $wow->addParameter('username',$username);
    $wow->addParameter('password',$password);
    $wow->addParameter('datatype','XML');
//---- process the API request
    if ($wow->execute()) {
        $_SESSION['signup']['regmaint']['staffname'] = $username;
        $staffIDarray = $wow->getAttribute(0);
        $_SESSION['signup']['regmaint']['staffid'] = $staffIDarray['id'];
        $_SESSION['signup']['regmaint']['password'] = $password;
        $wow->setUsername($username);
        $wow->setPassword($password);
        $eventName = 'stafflogin_success';
    } else {
        unset($_SESSION['signup']['regmaint']);
        $status['code'] = 'LOGIN_ERROR';
        $status['text'] = $wow->lastError;
        $eventName = 'stafflogin_fail';
    }

    $parameterList = new ACF_ParameterList();
    $retEvent = new ACF_Event($eventName);
    $parameterList->AddParameter(new ACF_DirectParameter('status', $status));
    $retEvent->SetParameterList($parameterList);
    return $retEvent;
}

function AH_StaffLogout (ACF_ParameterList $inParameterList) {
    unset($_SESSION['signup']['regmaint']);
    return new ACF_Event('stafflogout_complete');
}

function AH_CheckStaff (ACF_ParameterList $inParameterList) {
    if(!$_SESSION['signup']['regmaint']) {
        unset($_SESSION['signup']['regmaint']);
        $paramList = new ACF_ParameterList();
        $paramList->AddParameter(new ACF_DirectParameter('error','Not Logged In.  Please Login.'));
        $retEvent = new ACF_Event('staff_notset');
        $retEvent->SetParameterList($paramList);
        return $retEvent;
    } else {
        return new ACF_Event('staff_set');
    }
}

function AH_UpdateRegTemplate (ACF_ParameterList $inParameterList) {
    $regID        = $inParameterList->ParameterValue('regid');
    $templateData = $inParameterList->ParameterValue('template');

    if (trim($templateData['regcode']) == "") {
        $paramList = new ACF_ParameterList();
        $paramList->AddParameter(new ACF_DirectParameter('error',"The 'Template Name' cannot be left blank."));
        $paramList->AddParameter(new ACF_DirectParameter('regcode',$templateData['old_regcode']));
        $retEvent = new ACF_Event('updateregtemplate_fail');
        $retEvent->SetParameterList($paramList);
        return $retEvent;
    }
    if (!is_numeric($regID) || $regID <= 0) {
        $paramList = new ACF_ParameterList();
        $paramList->AddParameter(new ACF_DirectParameter('error',"The 'Registration Template ID' must be a number."));
        $paramList->AddParameter(new ACF_DirectParameter('regcode',$templateData['old_regcode']));
        $retEvent = new ACF_Event('updateregtemplate_fail');
        $retEvent->SetParameterList($paramList);
        return $retEvent;
    }
    if (!is_numeric($templateData['reuse'])) {
        $paramList = new ACF_ParameterList();
        $paramList->AddParameter(new ACF_DirectParameter('error',"The 'Number of Uses Allowed' must be a number."));
        $paramList->AddParameter(new ACF_DirectParameter('regcode',$templateData['old_regcode']));
        $retEvent = new ACF_Event('updateregtemplate_fail');
        $retEvent->SetParameterList($paramList);
        return $retEvent;
    }
    if (!is_numeric($templateData['affinity']) || ($templateData['affinity'] != 1 && $templateData['affinity'] != 0)) {
        $paramList = new ACF_ParameterList();
        $paramList->AddParameter(new ACF_DirectParameter('error',"The 'Affinity Action' must be a number."));
        $paramList->AddParameter(new ACF_DirectParameter('regcode',$templateData['old_regcode']));
        $retEvent = new ACF_Event('updateregtemplate_fail');
        $retEvent->SetParameterList($paramList);
        return $retEvent;
    }
    if (strtoupper(trim($templateData['prepaid'])) != "N" && !is_numeric($templateData['prepaidamount'])) {
        $paramList = new ACF_ParameterList();
        $paramList->AddParameter(new ACF_DirectParameter('error',"The 'Prepaid Amount' must be a number."));
        $paramList->AddParameter(new ACF_DirectParameter('regcode',$templateData['old_regcode']));
        $retEvent = new ACF_Event('updateregtemplate_fail');
        $retEvent->SetParameterList($paramList);
        return $retEvent;
    }
    if (strtoupper(trim($templateData['prepaid'])) != "N" && ((integer)$templateData['prepaid_paymenttype']) == 0) {
        $paramList = new ACF_ParameterList();
        $paramList->AddParameter(new ACF_DirectParameter('error',"The 'Prepaid Payment Type' must be a valid payment type."));
        $paramList->AddParameter(new ACF_DirectParameter('regcode',$templateData['old_regcode']));
        $retEvent = new ACF_Event('updateregtemplate_fail');
        $retEvent->SetParameterList($paramList);
        return $retEvent;
    }

    $updateCommand  = "update reg_header set ";
    $updateCommand .= "reg_template = '".SQLTrim($templateData['regcode'])."',";
    $updateCommand .= "reg_create = '".SQLTrim($templateData['create'])."',";
    if(!$templateData['expire'])
        $updateCommand .= "reg_expire = NULL,";
    else
        $updateCommand .= "reg_expire = '".SQLTrim($templateData['expire'])."',";
    $updateCommand .= "reg_reuse = ".((integer) $templateData['reuse']).",";
    $updateCommand .= "reg_affinity = '".((integer) $templateData['affinity'])."',";
    $updateCommand .= "reg_displayrates = '".SQLTrim($templateData['displayrates'])."',";
    $updateCommand .= "reg_displayblock = '".SQLTrim($templateData['displayblock'])."',";
    $updateCommand .= "reg_prepaid = '".SQLTrim($templateData['prepaid'])."',";
    if (strtoupper(trim($templateData['prepaid'])) != "N") {
        $updateCommand .= "reg_prepaidamount = ".((float) $templateData['prepaidamount']).",";
        $updateCommand .= "reg_prepaid_paymenttype = ".((integer) $templateData['prepaid_paymenttype']);
    } else {
        $updateCommand .= "reg_prepaidamount = 0,";
        $updateCommand .= "reg_prepaid_paymenttype = 0";
    }
    $updateCommand .= " where reg_id = ".((integer) $regID);

    $updateSuccess = ExecuteSQL($updateCommand);

    if($updateSuccess)
        return new ACF_Event('updateregtemplate_success');
    else {
        $paramList = new ACF_ParameterList();
        $paramList->AddParameter(new ACF_DirectParameter('error',"Error Updating Registration Code Template"));
        $paramList->AddParameter(new ACF_DirectParameter('regcode',$templateData['old_regcode']));
        $retEvent = new ACF_Event('updateregtemplate_fail');
        $retEvent->SetParameterList($paramList);
        return $retEvent;
    }
}

function AH_DeleteRegTemplate (ACF_ParameterList $inParameterList) {
    $regID = $inParameterList->ParameterValue('regid');
    $regcode = $inParameterList->ParameterValue('regcode');

    if (!is_numeric($regID) || $regID <= 0) {
        $paramList = new ACF_ParameterList();
        $paramList->AddParameter(new ACF_DirectParameter('error',"The 'Registration Template ID' must be a number."));
        $paramList->AddParameter(new ACF_DirectParameter('regcode',$regcode));
        $retEvent = new ACF_Event('deleteregtemplate_fail');
        $retEvent->SetParameterList($paramList);
        return $retEvent;
    }

    $deleteCommand = "BEGIN TRANSACTION\n";
    $deleteCommand .= "delete from reg_header where reg_id = ".((integer) $regID) . "\n";
    $deleteCommand .= "delete from reg_details where rd_hdr_id = ".((integer) $regID) . "\n";
    $deleteCommand .= "delete from reg_rate_header where rrh_regid = " . ((integer) $regID) . "\n";
    $deleteCommand .= "delete from reg_block_header where rbh_regid = " . ((integer) $regID) . "\n";
    $deleteCommand .= "if @@ERROR > 0\n";
    $deleteCommand .= "ROLLBACK TRANSACTION\n";
    $deleteCommand .= "else\n";
    $deleteCommand .= "COMMIT TRANSACTION\n";

    $deleteSuccess = ExecuteSQL($deleteCommand);

    //---- process the API request
    if ($deleteSuccess) {
        return new ACF_Event('deleteregtemplate_success');
    } else {
        $paramList = new ACF_ParameterList();
        $paramList->AddParameter(new ACF_DirectParameter('error',"Error Deleting Registration Code Template"));
        $paramList->AddParameter(new ACF_DirectParameter('regcode',$regcode));
        $retEvent = new ACF_Event('deleteregtemplate_fail');
        $retEvent->SetParameterList($paramList);
        return $retEvent;
    }
}

function AH_AddRatePlan (ACF_ParameterList $inParameterList) {
    $planname = trim($inParameterList->ParameterValue('ratename'));

    if ($planname == "") {
        $paramList = new ACF_ParameterList();
        $paramList->AddParameter(new ACF_DirectParameter('error',"The 'Rate Group Plan Name' cannot be left blank."));
        $retEvent = new ACF_Event('addrateplan_fail');
        $retEvent->SetParameterList($paramList);
        return $retEvent;
    }

    $addCommand = "insert into reg_rates (rr_rate_description) values ('".SQLTrim($planname)."')";

    $addSuccess = ExecuteSQL($addCommand);

    if($addSuccess) {
        return new ACF_Event('addrateplan_success');
    } else {
        $paramList = new ACF_ParameterList();
        $paramList->AddParameter(new ACF_DirectParameter('error',"Error Adding Rate Plan"));
        $retEvent = new ACF_Event('addrateplan_fail');
        $retEvent->SetParameterList($paramList);
        return $retEvent;
    }
}

function AH_DeleteRatePlan (ACF_ParameterList $inParameterList) {
    $planid = $inParameterList->ParameterValue('deleteid');

    if (!is_numeric($planid) || $planid <= 0) {
        $paramList = new ACF_ParameterList();
        $paramList->AddParameter(new ACF_DirectParameter('error',"The 'Rate Group Plan ID' must be a number."));
        $retEvent = new ACF_Event('deleterateplan_fail');
        $retEvent->SetParameterList($paramList);
        return $retEvent;
    }

    $deleteCommand = "BEGIN TRANSACTION\n";
    $deleteCommand .= "delete from reg_rates where rr_id = ".((integer) $planid) . "\n";
    $deleteCommand .= "delete from reg_rate_details where rrd_planid=".((integer) $planid) . "\n";
    $deleteCommand .= "if @@ERROR > 0\n";
    $deleteCommand .= "ROLLBACK TRANSACTION\n";
    $deleteCommand .= "else\n";
    $deleteCommand .= "COMMIT TRANSACTION\n";

    $deleteSuccess = ExecuteSQL($deleteCommand);

    if($deleteSuccess) {
        return new ACF_Event('deleterateplan_success');
    } else {
        $paramList = new ACF_ParameterList();
        $paramList->AddParameter(new ACF_DirectParameter('error',"Error Deleting Rate Plan"));
        $retEvent = new ACF_Event('deleterateplan_fail');
        $retEvent->SetParameterList($paramList);
        return $retEvent;
    }
}

function AH_AddBlockPlan (ACF_ParameterList $inParameterList) {
    $planname = trim($inParameterList->ParameterValue('blockname'));

    if ($planname == "") {
        $paramList = new ACF_ParameterList();
        $paramList->AddParameter(new ACF_DirectParameter('error',"The 'Block Time Plan Name' cannot be left blank."));
        $retEvent = new ACF_Event('addblockplan_fail');
        $retEvent->SetParameterList($paramList);
        return $retEvent;
    }

    $addCommand = "insert into reg_block (rb_rate_description) values ('".SQLTrim($planname)."')";

    $addSuccess = ExecuteSQL($addCommand);

    if($addSuccess) {
        return new ACF_Event('addblockplan_success');
    } else {
        $paramList = new ACF_ParameterList();
        $paramList->AddParameter(new ACF_DirectParameter('error',"Error Adding Block Rate Plan"));
        $retEvent = new ACF_Event('addblockplan_fail');
        $retEvent->SetParameterList($paramList);
        return $retEvent;
    }
}

function AH_DeleteBlockPlan (ACF_ParameterList $inParameterList) {
    $planid = $inParameterList->ParameterValue('deleteid');

    if (!is_numeric($planid) || $planid <= 0) {
        $paramList = new ACF_ParameterList();
        $paramList->AddParameter(new ACF_DirectParameter('error',"The 'Block Time Plan ID' must be a number."));
        $retEvent = new ACF_Event('deleteblockplan_fail');
        $retEvent->SetParameterList($paramList);
        return $retEvent;
    }

    $deleteCommand = "BEGIN TRANSACTION\n";
    $deleteCommand .= "delete from reg_block where rb_id = ".((integer) $planid) . "\n";
    $deleteCommand .= "delete from reg_block_details where rbd_planid=".((integer) $planid) . "\n";
    $deleteCommand .= "if @@ERROR > 0\n";
    $deleteCommand .= "ROLLBACK TRANSACTION\n";
    $deleteCommand .= "else\n";
    $deleteCommand .= "COMMIT TRANSACTION\n";

    $deleteSuccess = ExecuteSQL($deleteCommand);

    if($deleteSuccess) {
        return new ACF_Event('deleteblockplan_success');
    } else {
        $paramList = new ACF_ParameterList();
        $paramList->AddParameter(new ACF_DirectParameter('error',"Error Deleting Block Rate Plan"));
        $retEvent = new ACF_Event('deleteblockplan_fail');
        $retEvent->SetParameterList($paramList);
        return $retEvent;
    }
}

function AH_AddRateToPlan (ACF_ParameterList $inParameterList) {
    $planID = $inParameterList->ParameterValue('plan');
    $rgid = substr($inParameterList->ParameterValue('rgid'),0,strpos($inParameterList->ParameterValue('rgid'),'X'));
    $freq = substr($inParameterList->ParameterValue('rgid'),strpos($inParameterList->ParameterValue('rgid'),'X')+1);

    if (!is_numeric($planID) || $planID <= 0) {
        $paramList = new ACF_ParameterList();
        $paramList->AddParameter(new ACF_DirectParameter('plan',$planID));
        $paramList->AddParameter(new ACF_DirectParameter('error',"The 'Rate Group Plan ID' must be a positive number."));
        $retEvent = new ACF_Event('addratetoplan_fail');
        $retEvent->SetParameterList($paramList);
        return $retEvent;
    }
    if (!is_numeric($rgid) || $rgid <= 0) {
        $paramList = new ACF_ParameterList();
        $paramList->AddParameter(new ACF_DirectParameter('plan',$planID));
        $paramList->AddParameter(new ACF_DirectParameter('error',"The 'Rate Group ID' must be a positive number."));
        $retEvent = new ACF_Event('addratetoplan_fail');
        $retEvent->SetParameterList($paramList);
        return $retEvent;
    }

    if (!is_numeric($freq) || $freq <= 0) {
        $paramList = new ACF_ParameterList();
        $paramList->AddParameter(new ACF_DirectParameter('plan',$planID));
        $paramList->AddParameter(new ACF_DirectParameter('error',"The 'Rate Group Billing Frequency' must be a positive number."));
        $retEvent = new ACF_Event('addratetoplan_fail');
        $retEvent->SetParameterList($paramList);
        return $retEvent;
    }

    $addCommand = "insert into reg_rate_details (rrd_planid,rrd_rgid,rrd_freq) values (".((integer) $planID).",".((integer) $rgid).",".((integer) $freq).")";
    $addSuccess = ExecuteSQL($addCommand);

    if($addSuccess) {
        $paramList = new ACF_ParameterList();
        $paramList->AddParameter(new ACF_DirectParameter('plan',$planID));
        $retEvent = new ACF_Event('addratetoplan_success');
        $retEvent->SetParameterList($paramList);
        return $retEvent;
    } else {
        $paramList = new ACF_ParameterList();
        $paramList->AddParameter(new ACF_DirectParameter('plan',$planID));
        $paramList->AddParameter(new ACF_DirectParameter('error',"Error Adding Rate To Rate Plan"));
        $retEvent = new ACF_Event('addratetoplan_fail');
        $retEvent->SetParameterList($paramList);
        return $retEvent;
    }
}

function AH_DeleteRateFromPlan (ACF_ParameterList $inParameterList) {
    $planID = $inParameterList->ParameterValue('plan');
    $deleteID = $inParameterList->ParameterValue('deleteid');

    if (!is_numeric($planID) || $planID <= 0) {
        $paramList = new ACF_ParameterList();
        $paramList->AddParameter(new ACF_DirectParameter('plan',$planID));
        $paramList->AddParameter(new ACF_DirectParameter('error',"The 'Rate Group Plan ID' must be a positive number."));
        $retEvent = new ACF_Event('deleteratefromplan_fail');
        $retEvent->SetParameterList($paramList);
        return $retEvent;
    }

    if (!is_numeric($deleteID) || $deleteID <= 0) {
        $paramList = new ACF_ParameterList();
        $paramList->AddParameter(new ACF_DirectParameter('plan',$planID));
        $paramList->AddParameter(new ACF_DirectParameter('error',"The 'Rate Group Mapping ID' must be a positive number."));
        $retEvent = new ACF_Event('deleteratefromplan_fail');
        $retEvent->SetParameterList($paramList);
        return $retEvent;
    }

    $deleteCommand = "delete from reg_rate_details";
    $deleteCommand .= " where rrd_id=".((integer) $deleteID);
    $deleteCommand .= " and rrd_planid=".((integer) $planID);

    $deleteSuccess = ExecuteSQL($deleteCommand);

    if($deleteSuccess) {
        $paramList = new ACF_ParameterList();
        $paramList->AddParameter(new ACF_DirectParameter('plan',$planID));
        $retEvent = new ACF_Event('deleteratefromplan_success');
        $retEvent->SetParameterList($paramList);
        return $retEvent;
    } else {
        $paramList = new ACF_ParameterList();
        $paramList->AddParameter(new ACF_DirectParameter('plan',$planID));
        $paramList->AddParameter(new ACF_DirectParameter('error',"Error Deleting Rate From Rate Plan"));
        $retEvent = new ACF_Event('deleteratefromplan_fail');
        $retEvent->SetParameterList($paramList);
        return $retEvent;
    }
}

function AH_AddBlockToPlan (ACF_ParameterList $inParameterList) {
    $planID = $inParameterList->ParameterValue('plan');
    $rgid   = $inParameterList->ParameterValue('rgid');

    if (!is_numeric($planID) || $planID <= 0) {
        $paramList = new ACF_ParameterList();
        $paramList->AddParameter(new ACF_DirectParameter('plan',$planID));
        $paramList->AddParameter(new ACF_DirectParameter('error',"The 'Block Time Plan ID' must be a positive number."));
        $retEvent = new ACF_Event('addblocktoplan_fail');
        $retEvent->SetParameterList($paramList);
        return $retEvent;
    }
    if (!is_numeric($rgid) || $rgid <= 0) {
        $paramList = new ACF_ParameterList();
        $paramList->AddParameter(new ACF_DirectParameter('plan',$planID));
        $paramList->AddParameter(new ACF_DirectParameter('error',"The 'Block Time ID' must be a positive number."));
        $retEvent = new ACF_Event('addblocktoplan_fail');
        $retEvent->SetParameterList($paramList);
        return $retEvent;
    }

    $addCommand = "insert into reg_block_details (rbd_planid,rbd_rgid) values (".((integer) $planID).",".((integer) $rgid).")";

    $addSuccess = ExecuteSQL($addCommand);

    if($addSuccess) {
        $paramList = new ACF_ParameterList();
        $paramList->AddParameter(new ACF_DirectParameter('plan',$planID));
        $retEvent = new ACF_Event('addblocktoplan_success');
        $retEvent->SetParameterList($paramList);
        return $retEvent;
    } else {
        $paramList = new ACF_ParameterList();
        $paramList->AddParameter(new ACF_DirectParameter('plan',$planID));
        $paramList->AddParameter(new ACF_DirectParameter('error',"Error Adding Block Rate To Block Rate Plan"));
        $retEvent = new ACF_Event('addblocktoplan_fail');
        $retEvent->SetParameterList($paramList);
        return $retEvent;
    }
}

function AH_DeleteBlockFromPlan (ACF_ParameterList $inParameterList) {
    $planID = $inParameterList->ParameterValue('plan');
    $deleteID = $inParameterList->ParameterValue('deleteid');

    if (!is_numeric($planID) || $planID <= 0) {
        $paramList = new ACF_ParameterList();
        $paramList->AddParameter(new ACF_DirectParameter('plan',$planID));
        $paramList->AddParameter(new ACF_DirectParameter('error',"The 'Block Time Plan ID' must be a positive number."));
        $retEvent = new ACF_Event('deleteblockfromplan_fail');
        $retEvent->SetParameterList($paramList);
        return $retEvent;
    }
    if (!is_numeric($deleteID) || $deleteID <= 0) {
        $paramList = new ACF_ParameterList();
        $paramList->AddParameter(new ACF_DirectParameter('plan',$deleteID));
        $paramList->AddParameter(new ACF_DirectParameter('error',"The 'Block Time Mapping ID' must be a positive number."));
        $retEvent = new ACF_Event('deleteblockfromplan_fail');
        $retEvent->SetParameterList($paramList);
        return $retEvent;
    }
    $deleteCommand = "delete from reg_block_details ";
    $deleteCommand .= "where rbd_id=".((integer) $deleteID);
    $deleteCommand .= " and rbd_planid=".((integer) $planID);

    $deleteSuccess = ExecuteSQL($deleteCommand);

    if($deleteSuccess) {
        $paramList = new ACF_ParameterList();
        $paramList->AddParameter(new ACF_DirectParameter('plan',$planID));
        $retEvent = new ACF_Event('deleteblockfromplan_success');
        $retEvent->SetParameterList($paramList);
        return $retEvent;
    } else {
        $paramList = new ACF_ParameterList();
        $paramList->AddParameter(new ACF_DirectParameter('plan',$planID));
        $paramList->AddParameter(new ACF_DirectParameter('error',"Error Deleting Block Rate From Block Rate Plan"));
        $retEvent = new ACF_Event('deleteblockfromplan_fail');
        $retEvent->SetParameterList($paramList);
        return $retEvent;
    }
}

function AH_AddRatePlanToTemplate (ACF_ParameterList $inParameterList) {
    $planID  = $inParameterList->ParameterValue('rateplan');
    $regid   = $inParameterList->ParameterValue('regid');
    $regcode = $inParameterList->ParameterValue('regcode');

    if (!is_numeric($planID) || $planID <= 0) {
        $paramList = new ACF_ParameterList();
        $paramList->AddParameter(new ACF_DirectParameter('regid',$regid));
        $paramList->AddParameter(new ACF_DirectParameter('regcode',$regcode));
        $paramList->AddParameter(new ACF_DirectParameter('error',"The 'Rate Group Plan ID' must be a positive number."));
        $retEvent = new ACF_Event('addrateplantotemplate_fail');
        $retEvent->SetParameterList($paramList);
        return $retEvent;
    }
    if (!is_numeric($regid) || $regid <= 0) {
        $paramList = new ACF_ParameterList();
        $paramList->AddParameter(new ACF_DirectParameter('regid',$regid));
        $paramList->AddParameter(new ACF_DirectParameter('regcode',$regcode));
        $paramList->AddParameter(new ACF_DirectParameter('error',"The 'Registration Template ID' must be a positive number."));
        $retEvent = new ACF_Event('addrateplantotemplate_fail');
        $retEvent->SetParameterList($paramList);
        return $retEvent;
    }

    $addCommand = "insert into reg_rate_header (rrh_regid,rrh_planid) values (".((integer) $regid).",".((integer) $planID).")";

    $addSuccess = ExecuteSQL($addCommand);

    if($addSuccess) {
        $paramList = new ACF_ParameterList();
        $paramList->AddParameter(new ACF_DirectParameter('regid',$regid));
        $paramList->AddParameter(new ACF_DirectParameter('regcode',$regcode));
        $retEvent = new ACF_Event('addrateplantotemplate_success');
        $retEvent->SetParameterList($paramList);
        return $retEvent;
    } else {
        $paramList = new ACF_ParameterList();
        $paramList->AddParameter(new ACF_DirectParameter('regid',$regid));
        $paramList->AddParameter(new ACF_DirectParameter('regcode',$regcode));
        $paramList->AddParameter(new ACF_DirectParameter('error',"Error Adding Rate Plan To Registation Code Template"));
        $retEvent = new ACF_Event('addrateplantotemplate_fail');
        $retEvent->SetParameterList($paramList);
        return $retEvent;
    }
}

function AH_DeleteRatePlanFromTemplate (ACF_ParameterList $inParameterList) {
    $regid    = $inParameterList->ParameterValue('regid');
    $regcode = $inParameterList->ParameterValue('regcode');
    $deleteID = $inParameterList->ParameterValue('deleteid');

    if (!is_numeric($regid) || $regid <= 0) {
        $paramList = new ACF_ParameterList();
        $paramList->AddParameter(new ACF_DirectParameter('regid',$regid));
        $paramList->AddParameter(new ACF_DirectParameter('regcode',$regcode));
        $paramList->AddParameter(new ACF_DirectParameter('error',"The 'Rate Group Plan ID' must be a positive number."));
        $retEvent = new ACF_Event('deleterateplanfromtemplate_fail');
        $retEvent->SetParameterList($paramList);
        return $retEvent;
    }
    if (!is_numeric($deleteID) || $deleteID <= 0) {
        $paramList = new ACF_ParameterList();
        $paramList->AddParameter(new ACF_DirectParameter('regid',$regid));
        $paramList->AddParameter(new ACF_DirectParameter('regcode',$regcode));
        $paramList->AddParameter(new ACF_DirectParameter('error',"The 'Rate Group Mapping ID' must be a positive number."));
        $retEvent = new ACF_Event('deleterateplanfromtemplate_fail');
        $retEvent->SetParameterList($paramList);
        return $retEvent;
    }

    $deleteCommand = "delete from reg_rate_header ";
    $deleteCommand .= "where rrh_id = ".((integer) $deleteID);
    $deleteCommand .=" and rrh_regid = ".((integer) $regid);

    $deleteSuccess = ExecuteSQL($deleteCommand);

    if($deleteSuccess) {
        $paramList = new ACF_ParameterList();
        $paramList->AddParameter(new ACF_DirectParameter('regid',$regid));
        $paramList->AddParameter(new ACF_DirectParameter('regcode',$regcode));
        $retEvent = new ACF_Event('deleterateplanfromtemplate_success');
        $retEvent->SetParameterList($paramList);
        return $retEvent;
    } else {
        $paramList = new ACF_ParameterList();
        $paramList->AddParameter(new ACF_DirectParameter('regid',$regid));
        $paramList->AddParameter(new ACF_DirectParameter('regcode',$regcode));
        $paramList->AddParameter(new ACF_DirectParameter('error',"Error Deleting Rate Plan From Registration Code Template"));
        $retEvent = new ACF_Event('deleterateplanfromtemplate_fail');
        $retEvent->SetParameterList($paramList);
        return $retEvent;
    }
}

function AH_AddBlockPlanToTemplate (ACF_ParameterList $inParameterList) {
    $planID = $inParameterList->ParameterValue('blockplan');
    $regid  = $inParameterList->ParameterValue('regid');
    $regcode = $inParameterList->ParameterValue('regcode');

    if (!is_numeric($planID) || $planID <= 0) {
        $paramList = new ACF_ParameterList();
        $paramList->AddParameter(new ACF_DirectParameter('regid',$regid));
        $paramList->AddParameter(new ACF_DirectParameter('regcode',$regcode));
        $paramList->AddParameter(new ACF_DirectParameter('error',"The 'Block Time Plan ID' must be a positive number."));
        $retEvent = new ACF_Event('addblockplantotemplate_fail');
        $retEvent->SetParameterList($paramList);
        return $retEvent;
    }
    if (!is_numeric($regid) || $regid <= 0) {
        $paramList = new ACF_ParameterList();
        $paramList->AddParameter(new ACF_DirectParameter('regid',$regid));
        $paramList->AddParameter(new ACF_DirectParameter('regcode',$regcode));
        $paramList->AddParameter(new ACF_DirectParameter('error',"The 'Registration Template ID' must be a positive number."));
        $retEvent = new ACF_Event('addblockplantotemplate_fail');
        $retEvent->SetParameterList($paramList);
        return $retEvent;
    }

    $addCommand = "insert into reg_block_header (rbh_regid,rbh_planid) values (".((integer) $regid).",".((integer) $planID).")";
	$addSuccess = ExecuteSQL($addCommand);

    if($addSuccess) {
        $paramList = new ACF_ParameterList();
        $paramList->AddParameter(new ACF_DirectParameter('regid',$regid));
        $paramList->AddParameter(new ACF_DirectParameter('regcode',$regcode));
        $retEvent = new ACF_Event('addblockplantotemplate_success');
        $retEvent->SetParameterList($paramList);
        return $retEvent;
    } else {
        $paramList = new ACF_ParameterList();
        $paramList->AddParameter(new ACF_DirectParameter('regid',$regid));
        $paramList->AddParameter(new ACF_DirectParameter('regcode',$regcode));
        $paramList->AddParameter(new ACF_DirectParameter('error',"Error Adding Block Rate Plan To Registration Code Template"));
        $retEvent = new ACF_Event('addblockplantotemplate_fail');
        $retEvent->SetParameterList($paramList);
        return $retEvent;
    }
}

function AH_DeleteBlockPlanFromTemplate (ACF_ParameterList $inParameterList) {
    $regid    = $inParameterList->ParameterValue('regid');
    $regcode = $inParameterList->ParameterValue('regcode');
    $deleteID = $inParameterList->ParameterValue('deleteid');

    if (!is_numeric($regid) || $regid <= 0) {
        $paramList = new ACF_ParameterList();
        $paramList->AddParameter(new ACF_DirectParameter('regid',$regid));
        $paramList->AddParameter(new ACF_DirectParameter('regcode',$regcode));
        $paramList->AddParameter(new ACF_DirectParameter('error',"The 'Block Time Plan ID' must be a positive number."));
        $retEvent = new ACF_Event('deleteblockplanfromtemplate_fail');
        $retEvent->SetParameterList($paramList);
        return $retEvent;
    }
    if (!is_numeric($deleteID) || $deleteID <= 0) {
        $paramList = new ACF_ParameterList();
        $paramList->AddParameter(new ACF_DirectParameter('regid',$regid));
        $paramList->AddParameter(new ACF_DirectParameter('regcode',$regcode));
        $paramList->AddParameter(new ACF_DirectParameter('error',"The 'Block Time Mapping ID' must be a positive number."));
        $retEvent = new ACF_Event('deleteblockplanfromtemplate_fail');
        $retEvent->SetParameterList($paramList);
        return $retEvent;
    }

    $deleteCommand = "delete from reg_block_header ";
    $deleteCommand .= "where rbh_id = ".((integer) $deleteID);
    $deleteCommand .= " and rbh_regid = ".((integer) $regid);

    $deleteSuccess = ExecuteSQL($deleteCommand);

    if($deleteSuccess) {
        $paramList = new ACF_ParameterList();
        $paramList->AddParameter(new ACF_DirectParameter('regid',$regid));
        $paramList->AddParameter(new ACF_DirectParameter('regcode',$regcode));
        $retEvent = new ACF_Event('deleteblockplanfromtemplate_success');
        $retEvent->SetParameterList($paramList);
        return $retEvent;
    } else {
        $paramList = new ACF_ParameterList();
        $paramList->AddParameter(new ACF_DirectParameter('regid',$regid));
        $paramList->AddParameter(new ACF_DirectParameter('regcode',$regcode));
        $paramList->AddParameter(new ACF_DirectParameter('error',"Error Deleting Block Rate Plan From Registration Code Template"));
        $retEvent = new ACF_Event('deleteblockplanfromtemplate_fail');
        $retEvent->SetParameterList($paramList);
        return $retEvent;
    }
}

function AH_AddBonusRule (ACF_ParameterList $inParameterList) {
    $bonusData = $inParameterList->ParameterValue('bonusrule');
    $regid = $inParameterList->ParameterValue('regid');
    $regcode = $inParameterList->ParameterValue('regcode');

    if (!is_numeric($regid) || $regid <= 0) {
        $paramList = new ACF_ParameterList();
        $paramList->AddParameter(new ACF_DirectParameter('regid',$regid));
        $paramList->AddParameter(new ACF_DirectParameter('regcode',$regcode));
        $paramList->AddParameter(new ACF_DirectParameter('error',"The 'Registration Template ID' must be a positive number."));
        $retEvent = new ACF_Event('addbonusrule_fail');
        $retEvent->SetParameterList($paramList);
        return $retEvent;
    }
    if (!is_numeric($bonusData['salesid']) || $bonusData['salesid'] <= 0) {
        $paramList = new ACF_ParameterList();
        $paramList->AddParameter(new ACF_DirectParameter('regid',$regid));
        $paramList->AddParameter(new ACF_DirectParameter('regcode',$regcode));
        $paramList->AddParameter(new ACF_DirectParameter('error',"The 'Salesperson / Affinity' must be a positive number."));
        $retEvent = new ACF_Event('addbonusrule_fail');
        $retEvent->SetParameterList($paramList);
        return $retEvent;
    }
    if (!is_numeric($bonusData['amount'])) {
        $paramList = new ACF_ParameterList();
        $paramList->AddParameter(new ACF_DirectParameter('regid',$regid));
        $paramList->AddParameter(new ACF_DirectParameter('regcode',$regcode));
        $paramList->AddParameter(new ACF_DirectParameter('error',"The 'Amount' must be a number."));
        $retEvent = new ACF_Event('addbonusrule_fail');
        $retEvent->SetParameterList($paramList);
        return $retEvent;
    }
    if (!is_numeric($bonusData['startoffset'])) {
        $paramList = new ACF_ParameterList();
        $paramList->AddParameter(new ACF_DirectParameter('regid',$regid));
        $paramList->AddParameter(new ACF_DirectParameter('regcode',$regcode));
        $paramList->AddParameter(new ACF_DirectParameter('error',"The 'Starting Offset' must be a number."));
        $retEvent = new ACF_Event('addbonusrule_fail');
        $retEvent->SetParameterList($paramList);
        return $retEvent;
    }
    if (!is_numeric($bonusData['endoffset'])) {
        $paramList = new ACF_ParameterList();
        $paramList->AddParameter(new ACF_DirectParameter('regid',$regid));
        $paramList->AddParameter(new ACF_DirectParameter('regcode',$regcode));
        $paramList->AddParameter(new ACF_DirectParameter('error',"The 'Ending Offset' must be a number."));
        $retEvent = new ACF_Event('addbonusrule_fail');
        $retEvent->SetParameterList($paramList);
        return $retEvent;
    }

    $staffList = ExecuteSQL("select affinity from staff where num=".((integer) $bonusData['salesid']));

    if(isset($staffList) && is_array($staffList)) {
        foreach($staffList as $thisStaff) {
            $addCommand  = "insert into reg_details (rd_hdr_id, rd_salesid, rd_type, rd_amount, rd_onetime, rd_startoffset, rd_endoffset, rd_visible, rd_bonustype) values (";
            $addCommand .= ((integer) $regid).",";
            $addCommand .= ((integer) $bonusData['salesid']).",";
            $addCommand .= "'".SQLTrim($bonusData['type'])."',";
            $addCommand .= ((float) $bonusData['amount']).",";
            $addCommand .= "'".SQLTrim($bonusData['onetime'])."',";
            $addCommand .= ((integer) $bonusData['startoffset']).",";
            $addCommand .= ((integer) $bonusData['endoffset']).",";
            if($thisStaff['affinity'] == 'Y')
                $addCommand .= "'".SQLTrim($bonusData['visible'])."',";
            else
                $addCommand .= "'N',";
            $addCommand .= "'".SQLTrim($bonusData['bonustype'])."'";
            $addCommand .= ")";
        }
    }

    $addSuccess = ExecuteSQL($addCommand);

    if($addSuccess) {
        $paramList = new ACF_ParameterList();
        $paramList->AddParameter(new ACF_DirectParameter('regid',$regid));
        $paramList->AddParameter(new ACF_DirectParameter('regcode',$regcode));
        $retEvent = new ACF_Event('addbonusrule_success');
        $retEvent->SetParameterList($paramList);
        return $retEvent;
    } else {
        $paramList = new ACF_ParameterList();
        $paramList->AddParameter(new ACF_DirectParameter('regid',$regid));
        $paramList->AddParameter(new ACF_DirectParameter('regcode',$regcode));
        $paramList->AddParameter(new ACF_DirectParameter('error',"Error Adding Bonus Rule"));
        $retEvent = new ACF_Event('addbonusrule_fail');
        $retEvent->SetParameterList($paramList);
        return $retEvent;
    }
}

function AH_UpdateBonusRule (ACF_ParameterList $inParameterList) {
    $bonusData = $inParameterList->ParameterValue('bonusrule');
    $rdid = $inParameterList->ParameterValue('rdid');
    $reg_id = $inParameterList->ParameterValue('regid');
    $reg_code = $inParameterList->ParameterValue('regcode');

    if (!is_numeric($rdid) || $rdid <= 0) {
        $paramList = new ACF_ParameterList();
        $paramList->AddParameter(new ACF_DirectParameter('regid',$reg_id));
        $paramList->AddParameter(new ACF_DirectParameter('regcode',$reg_code));
        $paramList->AddParameter(new ACF_DirectParameter('error',"The 'Commission ID' must be a positive number."));
        $retEvent = new ACF_Event('updatebonusrule_fail');
        $retEvent->SetParameterList($paramList);
        return $retEvent;
    }
    if (!is_numeric($reg_id) || $reg_id <= 0) {
        $paramList = new ACF_ParameterList();
        $paramList->AddParameter(new ACF_DirectParameter('regid',$reg_id));
        $paramList->AddParameter(new ACF_DirectParameter('regcode',$reg_code));
        $paramList->AddParameter(new ACF_DirectParameter('error',"The 'Registration Template ID' must be a positive number."));
        $retEvent = new ACF_Event('updatebonusrule_fail');
        $retEvent->SetParameterList($paramList);
        return $retEvent;
    }
    if (!is_numeric($bonusData['salesid']) || $bonusData['salesid'] <= 0) {
        $paramList = new ACF_ParameterList();
        $paramList->AddParameter(new ACF_DirectParameter('regid',$reg_id));
        $paramList->AddParameter(new ACF_DirectParameter('regcode',$reg_code));
        $paramList->AddParameter(new ACF_DirectParameter('error',"The 'Salesperson / Affinity' must be a positive number."));
        $retEvent = new ACF_Event('updatebonusrule_fail');
        $retEvent->SetParameterList($paramList);
        return $retEvent;
    }
    if (!is_numeric($bonusData['amount'])) {
        $paramList = new ACF_ParameterList();
        $paramList->AddParameter(new ACF_DirectParameter('regid',$reg_id));
        $paramList->AddParameter(new ACF_DirectParameter('regcode',$reg_code));
        $paramList->AddParameter(new ACF_DirectParameter('error',"The 'Amount' must be a number."));
        $retEvent = new ACF_Event('updatebonusrule_fail');
        $retEvent->SetParameterList($paramList);
        return $retEvent;
    }
    if (!is_numeric($bonusData['startoffset'])) {
        $paramList = new ACF_ParameterList();
        $paramList->AddParameter(new ACF_DirectParameter('regid',$reg_id));
        $paramList->AddParameter(new ACF_DirectParameter('regcode',$reg_code));
        $paramList->AddParameter(new ACF_DirectParameter('error',"The 'Starting Offset' must be a number."));
        $retEvent = new ACF_Event('updatebonusrule_fail');
        $retEvent->SetParameterList($paramList);
        return $retEvent;
    }
    if (!is_numeric($bonusData['endoffset'])) {
        $paramList = new ACF_ParameterList();
        $paramList->AddParameter(new ACF_DirectParameter('regid',$reg_id));
        $paramList->AddParameter(new ACF_DirectParameter('regcode',$reg_code));
        $paramList->AddParameter(new ACF_DirectParameter('error',"The 'Ending Offset' must be a number."));
        $retEvent = new ACF_Event('updatebonusrule_fail');
        $retEvent->SetParameterList($paramList);
        return $retEvent;
    }

    $updateCommand  = "update reg_details set ";
    $updateCommand .= "rd_salesid=".((integer) $bonusData['salesid']).", ";
    $updateCommand .= "rd_type='".SQLTrim($bonusData['type'])."', ";
    $updateCommand .= "rd_amount=".((float) $bonusData['amount']).", ";
    $updateCommand .= "rd_onetime='".SQLTrim($bonusData['onetime'])."', ";
    $updateCommand .= "rd_startoffset=".((integer) $bonusData['startoffset']).", ";
    $updateCommand .= "rd_endoffset=".((integer) $bonusData['endoffset']).", ";
    $updateCommand .= "rd_visible='".SQLTrim($bonusData['visible'])."', ";
    $updateCommand .= "rd_bonustype='".SQLTrim($bonusData['bonustype'])."' ";
    $updateCommand .= "where rd_id=".((integer) $rdid) . " ";
    $updateCommand .= "and rd_hdr_id=".((integer) $reg_id);

    $updateSuccess = ExecuteSQL($updateCommand);

    if($updateSuccess) {
        $paramList = new ACF_ParameterList();
        $paramList->AddParameter(new ACF_DirectParameter('regid',$reg_id));
        $paramList->AddParameter(new ACF_DirectParameter('regcode',$reg_code));
        $retEvent = new ACF_Event('updatebonusrule_success');
        $retEvent->SetParameterList($paramList);
        return $retEvent;
    } else {
        $paramList = new ACF_ParameterList();
        $paramList->AddParameter(new ACF_DirectParameter('regid',$reg_id));
        $paramList->AddParameter(new ACF_DirectParameter('regcode',$reg_code));
        $paramList->AddParameter(new ACF_DirectParameter('error',"Error Updating Bonus Rule"));
        $retEvent = new ACF_Event('updatebonusrule_fail');
        $retEvent->SetParameterList($paramList);
        return $retEvent;
    }
}

function AH_DeleteBonusRule (ACF_ParameterList $inParameterList) {
    $rdid = $inParameterList->ParameterValue('rdid');
    $reg_id = $inParameterList->ParameterValue('regid');
    $reg_code = $inParameterList->ParameterValue('regcode');

    if (!is_numeric($rdid) || $rdid <= 0) {
        $paramList = new ACF_ParameterList();
        $paramList->AddParameter(new ACF_DirectParameter('regid',$reg_id));
        $paramList->AddParameter(new ACF_DirectParameter('regcode',$reg_code));
        $paramList->AddParameter(new ACF_DirectParameter('error',"The 'Commission ID' must be a positive number."));
        $retEvent = new ACF_Event('deletebonusrule_success');
        $retEvent->SetParameterList($paramList);
        return $retEvent;
    }

    $deleteCommand = "delete from reg_details ";
    $deleteCommand .= "where rd_id=".((integer) $rdid);
    $deleteCommand .= "and rd_hdr_id=".((integer) $reg_id);

    $deleteSuccess = ExecuteSQL($deleteCommand);

    if($deleteSuccess) {
        $paramList = new ACF_ParameterList();
        $paramList->AddParameter(new ACF_DirectParameter('regid',$reg_id));
        $paramList->AddParameter(new ACF_DirectParameter('regcode',$reg_code));
        $retEvent = new ACF_Event('deletebonusrule_success');
        $retEvent->SetParameterList($paramList);
        return $retEvent;
    } else {
        $paramList = new ACF_ParameterList();
        $paramList->AddParameter(new ACF_DirectParameter('regid',$reg_id));
        $paramList->AddParameter(new ACF_DirectParameter('regcode',$reg_code));
        $paramList->AddParameter(new ACF_DirectParameter('error',"Error Deleting Bonus Rule"));
        $retEvent = new ACF_Event('deletebonusrule_fail');
        $retEvent->SetParameterList($paramList);
        return $retEvent;
    }
}

function AH_GenerateRandomRegCodes (ACF_ParameterList $inParameterList) {
    $mask = $inParameterList->ParameterValue('mask');
    $codecount = $inParameterList->ParameterValue('number');
    $regid = $inParameterList->ParameterValue('regid');
    $regcode = $inParameterList->ParameterValue('regcode');
    $successCount = 0;

    if (!is_numeric($codecount) || $codecount <= 0) {
        $paramList = new ACF_ParameterList();
        $paramList->AddParameter(new ACF_DirectParameter('regcode',$reg_code));
        $paramList->AddParameter(new ACF_DirectParameter('return_message', ""));
        $paramList->AddParameter(new ACF_DirectParameter('error',"The 'Number of Codes to Create' must be a positive number."));
        $retEvent = new ACF_Event('generaterandomregcodes_complete');
        $retEvent->SetParameterList($paramList);
        return $retEvent;
    }
    if (!is_numeric($regid) || $regid <= 0) {
        $paramList = new ACF_ParameterList();
        $paramList->AddParameter(new ACF_DirectParameter('regcode',$reg_code));
        $paramList->AddParameter(new ACF_DirectParameter('return_message', ""));
        $paramList->AddParameter(new ACF_DirectParameter('error',"The 'Registration Template ID' must be a positive number."));
        $retEvent = new ACF_Event('generaterandomregcodes_complete');
        $retEvent->SetParameterList($paramList);
        return $retEvent;
    }

    for ($i = 1;$i <= $codecount;$i++) {
        $currentCode = GetNextRandomCode($mask);
        $addCommand = "insert into reg_codes (rc_rh_id,rc_code,rc_used) values (".((integer) $regid).",'".((integer) $currentCode)."',0)";
		$codeAdd = ExecuteSQL($addCommand);
		if ($codeAdd)
            $successCount++;
    }

    $returnMsg = $successCount." registration codes were successfully generated.";

    $paramList = new ACF_ParameterList();
    $paramList->AddParameter(new ACF_DirectParameter('return_message',$returnMsg));
    $paramList->AddParameter(new ACF_DirectParameter('regcode',$reg_code));
    $retEvent = new ACF_Event('generaterandomregcodes_complete');
    $retEvent->SetParameterList($paramList);
    return $retEvent;
}

function AH_GenerateSequentialRegCodes (ACF_ParameterList $inParameterList) {
    $mask = $inParameterList->ParameterValue('mask');
    $start = $inParameterList->ParameterValue('start');
    $regid = $inParameterList->ParameterValue('regid');
    $regcode = $inParameterList->ParameterValue('regcode');
    $codecount = $inParameterList->ParameterValue('number');

    if (!is_numeric($codecount) || $codecount <= 0) {
        $paramList = new ACF_ParameterList();
        $paramList->AddParameter(new ACF_DirectParameter('regcode',$regcode));
        $paramList->AddParameter(new ACF_DirectParameter('return_message', ""));
        $paramList->AddParameter(new ACF_DirectParameter('error',"The 'Number of Codes to Create' must be a positive number."));
        $retEvent = new ACF_Event('generatesequentialregcodes_complete');
        $retEvent->SetParameterList($paramList);
        return $retEvent;
    }
    if (!is_numeric($regid) || $regid <= 0) {
        $paramList = new ACF_ParameterList();
        $paramList->AddParameter(new ACF_DirectParameter('regcode',$regcode));
        $paramList->AddParameter(new ACF_DirectParameter('return_message', ""));
        $paramList->AddParameter(new ACF_DirectParameter('error',"The 'Registration Template ID' must be a positive number."));
        $retEvent = new ACF_Event('generatesequentialregcodes_complete');
        $retEvent->SetParameterList($paramList);
        return $retEvent;
    }

    $currentCode = $start;
    $successCount = 0;
    for ($i = 1;$i <= $codecount;$i++) {
        $addCommand = "insert into reg_codes (rc_rh_id, rc_code, rc_used) values (".((integer) $regid).",'".SQLTrim($currentCode)."',0)";
		$codeAdd = ExecuteSQL($addCommand);
		if ($codeAdd)
            $successCount++;
        $currentCode = GetNextCode($mask,$currentCode);
    }

    $returnMsg = $successCount." registration codes were successfully generated.";

    $paramList = new ACF_ParameterList();
    $paramList->AddParameter(new ACF_DirectParameter('return_message',$returnMsg));
    $paramList->AddParameter(new ACF_DirectParameter('regcode',$regcode));
    $retEvent = new ACF_Event('generatesequentialregcodes_complete');
    $retEvent->SetParameterList($paramList);
    return $retEvent;
}

function AH_AddRegCode (ACF_ParameterList $inParameterList) {
    $reg_code = $inParameterList->ParameterValue('regcode');
    $code     = $inParameterList->ParameterValue('code');
    $template = $inParameterList->ParameterValue('template');

    if (!is_numeric($reg_code) || $reg_code <= 0) {
        $paramList = new ACF_ParameterList();
        $paramList->AddParameter(new ACF_DirectParameter('template',$template));
        $paramList->AddParameter(new ACF_DirectParameter('error',"The 'Registration Template ID' must be a positive number."));
        $retEvent = new ACF_Event('addregcode_fail');
        $retEvent->SetParameterList($paramList);
        return $retEvent;
    }

    if (trim($code) == "") {
        $paramList = new ACF_ParameterList();
        $paramList->AddParameter(new ACF_DirectParameter('template',$template));
        $paramList->AddParameter(new ACF_DirectParameter('error',"The 'Registration Code' cannot be left blank."));
        $retEvent = new ACF_Event('addregcode_fail');
        $retEvent->SetParameterList($paramList);
        return $retEvent;
    }

    $addCommand = "insert into reg_codes (rc_rh_id,rc_code,rc_used) values (".((integer) $reg_code).",'".SQLTrim($code)."',0)";

    $addSuccess = ExecuteSQL($addCommand);

    if($addSuccess) {
        if(!$template) {
            return new ACF_Event('addregcode_success');
        } else {
            $paramList = new ACF_ParameterList();
            $paramList->AddParameter(new ACF_DirectParameter('template',$template));
            $retEvent = new ACF_Event('addregcode_success');
            $retEvent->SetParameterList($paramList);
            return $retEvent;
        }
    } else {
        $paramList = new ACF_ParameterList();
        if($template)
            $paramList->AddParameter(new ACF_DirectParameter('template',$template));
        $paramList->AddParameter(new ACF_DirectParameter('error',"Error Adding Registration Code".$template ? " To Template" : ""));
        $retEvent = new ACF_Event('addregcode_fail');
        $retEvent->SetParameterList($paramList);
        return $retEvent;
    }
}

function AH_DeleteRegCode (ACF_ParameterList $inParameterList) {
    $codeID   = $inParameterList->ParameterValue('deleteid');
    $template = $inParameterList->ParameterValue('template');

    if (trim($codeID) == "") {
        $paramList = new ACF_ParameterList();
        $paramList->AddParameter(new ACF_DirectParameter('template',$template));
        $paramList->AddParameter(new ACF_DirectParameter('error',"The 'Registration Code' cannot be left blank."));
        $retEvent = new ACF_Event('deleteregcode_fail');
        $retEvent->SetParameterList($paramList);
        return $retEvent;
    }

    $deleteCommand = "delete from reg_codes where rc_id = ".((integer) $codeID);

    $deleteSuccess = ExecuteSQL($deleteCommand);

    if($deleteSuccess) {
        if(!$template) {
            return new ACF_Event('deleteregcode_success');
        } else {
            $paramList = new ACF_ParameterList();
            $paramList->AddParameter(new ACF_DirectParameter('template',$template));
            $retEvent = new ACF_Event('deleteregcode_success');
            $retEvent->SetParameterList($paramList);
            return $retEvent;
        }
    } else {
        $paramList = new ACF_ParameterList();
        if($template)
            $paramList->AddParameter(new ACF_DirectParameter('template',$template));
        $paramList->AddParameter(new ACF_DirectParameter('error',"Error Deleting Registration Code".$template ? " From Template" : ""));
        $retEvent = new ACF_Event('deleteregcode_fail');
        $retEvent->SetParameterList($paramList);
        return $retEvent;
    }
}

?>
