<?php

// *******************************************************************
// COMMENTS IN CAPS ARE TEMP UNTIL FIXED, COMPLETED, CHANGED, ETC ....
// *******************************************************************

require_once("platfunctions.php");
require_once("../../libs/ccs/options.inc.php");
require_once("../../libs/ccs/utilities.inc.php");

function AH_LoadOptions (ACF_ParameterList $inParameterList) {

    if(!$_SESSION['wow']) {
        loadCCSOptions();
    }

    $_SESSION['ccs']['source'] = 'platsignup';

    if($inParameterList->ParameterValue('options')) {
        $_SESSION['signup']['options'] = $inParameterList->ParameterValue('options');
        if($_SESSION['signup']['options']['storeid']) {
            $_SESSION['signup']['storeid'] = $_SESSION['signup']['options']['storeid'];
        }
    }

    if($_SESSION['modules']['billing'] && !$_SESSION['signup']['options']['rate']) {
        $_SESSION['signup']['newcustomer']['rate']['id'] = $_SESSION['modules']['billing']['bundle']['id'];
        $_SESSION['signup']['options']['rate'] = substr($_SESSION['modules']['billing']['bundle']['id'],0,strpos($_SESSION['modules']['billing']['bundle']['id'],'X'));
        $_SESSION['signup']['options']['frequency'] = substr($_SESSION['modules']['billing']['bundle']['id'],strpos($_SESSION['modules']['billing']['bundle']['id'],'X')+1);
        $_SESSION['signup']['storeid'] = $_SESSION['modules']['billing']['storeid'];
    }

    if(!$_SESSION['wow']) {
        $paramList = new ACF_ParameterList();
        $paramList->AddParameter(new ACF_DirectParameter('errormessage',"The CCS options could not be loaded."));
        $retEvent = new ACF_Event('loadoptions_fail');
        $retEvent->SetParameterList($paramList);
        return $retEvent;
    } else {
        SetStaffLogin();
        GetDateFormat();
    // get GST display options
        $_SESSION['GST']['showGST'] = GetWebOption('australianGST_display',$_SESSION['signup']['storeid']);

        if(strtoupper($_SESSION['GST']['showGST']) ==  'Y') {
            $_SESSION['GST']['percent'] = GetWebOption('australianGST_percent',$_SESSION['signup']['storeid']);
            $_SESSION['GST']['desc'] = GetWebOption('australianGST_desc',$_SESSION['signup']['storeid']);
        } else {
            unset($_SESSION['GST']);
        }

        $_SESSION['signup']['ip_address'] = $_SERVER['REMOTE_ADDR'];
        return new ACF_Event('loadoptions_success');
    }
}

function AH_CheckGuarantor (ACF_ParameterList $inParameterList) {
    if(!$_SESSION['signup']['storeid'] && $_SESSION['signup']['options']['parentid']) {
        $_SESSION['signup']['storeid'] = GetStoreID($_SESSION['signup']['options']['parentid']);
    }

    return new ACF_Event('checkguarantor_done');
}

function AH_AddCustomerToSession (ACF_ParameterList $inParameterList) {
    unset($_SESSION['signup']['error']);
    $popBackup = $_SESSION['signup']['newcustomer']['poplocation'];
    $_SESSION['signup']['newcustomer'] = $inParameterList->ParameterValue('newcustomer');
    $_SESSION['signup']['newcustomer']['poplocation'] = $popBackup;
    if($_SESSION['signup']['options']['rate'] && $_SESSION['signup']['options']['frequency']) {
        $_SESSION['signup']['newcustomer']['rate']['id'] = $_SESSION['signup']['options']['rate'] . 'X' . $_SESSION['signup']['options']['frequency'];
    }

	if($_SESSION['signup']['landing']['rate']) {
		$_SESSION['signup']['newcustomer']['rate']['id'] = $_SESSION['signup']['landing']['rate'];
	}

	else if($_SESSION['signup']['landing']['blockrate']) {
		$_SESSION['signup']['newcustomer']['blockrate']['id'] = $_SESSION['signup']['landing']['blockrate'];
	}

    return new ACF_Event('addcustomertosession_done');
}

function AH_AddRateToSession (ACF_ParameterList $inParameterList) {
	unset($_SESSION['signup']['error']);
	$_SESSION['signup']['landing'] = $inParameterList->ParameterValue('landing');

	return new ACF_Event('addratetosession_done');
}

function AH_CheckRegCodes (ACF_ParameterList $inParameterList) {
    if($_SESSION['signup']['options']['regcode']) {
        $retEvent = new ACF_Event('passedregcode');
        $retParamList = new ACF_ParameterList();
        $retParamList->AddParameter(new ACF_DirectParameter('regcode',$_SESSION['signup']['options']['regcode']));
        $retEvent->SetParameterList($retParamList);
        return $retEvent;
    }

    if(strtolower(GetWebOption('showregcode',$_SESSION['signup']['storeid'])) == 'y') {
	    $retParamList = new ACF_ParameterList();
    	if(strtolower($_SESSION['signup']['options']['alt']) == "yes") {
	        $retEvent = new ACF_Event('showregcodes_alt');
	    } else {
	    	$retEvent = new ACF_Event('showregcodes');
	        $retParamList->AddParameter(new ACF_DirectParameter('displayregcode','yes'));
	    }
        if($inParameterList->ParameterValue('error')) {
            $retParamList->AddParameter(new ACF_DirectParameter('error',$inParameterList->ParameterValue('error')));
        }
        $retEvent->SetParameterList($retParamList);
        return $retEvent;
    } else {
    	if(strtolower($_SESSION['signup']['options']['alt']) == "yes") {
	        $retEvent = new ACF_Event('noregcodes_alt');
	    } else {
	    	$retEvent = new ACF_Event('noregcodes');
		    $retParamList = new ACF_ParameterList();
	        $retParamList->AddParameter(new ACF_DirectParameter('displayregcode','no'));
	        $retEvent->SetParameterList($retParamList);
	    }

        return $retEvent;
    }
}

function AH_VerifyRegCode (ACF_ParameterList $inParameterList) {
    $_SESSION['signup']['regcode'] = $inParameterList->ParameterValue('regcode');
    if(!$_SESSION['signup']['regcode']) { // no regcode entered, check option for this scenario
        unset($_SESSION['signup']['regrates']);
        unset($_SESSION['signup']['regblock']);
        switch(GetWebOption('noregcode',$_SESSION['signup']['storeid'])) {
            case 'SELECT':
                $_SESSION['signup']['affinitylist'] = ExecuteSQL("select num, name from staff where affinity = 'Y'");
                return new ACF_Event('verifyregcode_success');
                break;
            case 'VALID':
                return new ACF_Event('verifyregcode_success');
                break;
            case 'INVALID':
                return new ACF_Event('verifyregcode_fail');
                break;
            case 'DEFAULT':
                $_SESSION['signup']['regcode'] = GetWebOption('defaultregcode',$_SESSION['signup']['storeid']);
                break;
        }
    }

    $sqlcommand = "select distinct"
                    ." id=rr_id,"
                    ." name=rr_rate_description,"
                    ." reg_displayrates"
                ." from reg_header, reg_rates, reg_rate_header, reg_codes"
                ." where reg_id = rc_rh_id"
                ." and reg_id = rrh_regid"
                ." and rr_id = rrh_planid"
                ." and (reg_expire is null or reg_expire > getdate())"
                ." and (rc_used < reg_reuse or reg_reuse = -1)"
                ." and rc_code = '".SQLTrim($_SESSION['signup']['regcode'])."'";
    $sqlresults = ExecuteSQL($sqlcommand);

    if($sqlresults && is_array($sqlresults)) { // reg code is valid
        $_SESSION['signup']['regrates'] = $sqlresults;
        $sqlresults = ExecuteSQL("select reg_affinity from reg_header where reg_id in (select rc_rh_id from reg_codes where rc_code = '".SQLTrim($_SESSION['signup']['regcode'])."')");
        if($sqlresults && is_array($sqlresults)) {
            if($sqlresults[0]['reg_affinity']) {
                $_SESSION['signup']['affinitylist'] = ExecuteSQL("select num, name from staff where affinity = 'Y'");
            }
        }

        $sqlresults = ExecuteSQL("select * from reg_rate_details where rrd_planid = " . $_SESSION['signup']['regrates'][0]['id']);
        if($sqlresults && is_array($sqlresults)) {
            $sqlresults = ExecuteSQL("select * from companyrelationship where cr_type = 'rate' and cr_typeid = " . $sqlresults[0]['rrd_rgid'] . " order by cr_companyid");
            if(isset($sqlresults) && is_array($sqlresults)) {
                if($_SESSION['signup']['storeid']) {
                    foreach($sqlresults as $thisCompany) {
                        if($_SESSION['signup']['storeid'] == $thisCompany['cr_companyid']) {
                            $companyFound = true;
                            break;
                        }
                    }
                    if(!$companyFound) {
                        $_SESSION['signup']['storeid'] = $sqlresults[0]['cr_companyid'];
                    }
                } else {
                    $_SESSION['signup']['storeid'] = $sqlresults[0]['cr_companyid'];
                }
            }
        }
    }

    $sqlcommand = "select distinct"
                    ." id=rb_id,"
                    ." name=rb_rate_description,"
                    ." reg_displayblock"
                ." from reg_header, reg_block, reg_block_header, reg_codes"
                ." where reg_id = rc_rh_id"
                ." and reg_id = rbh_regid"
                ." and rb_id = rbh_planid"
                ." and (reg_expire is null or reg_expire > getdate())"
                ." and (rc_used < reg_reuse or reg_reuse = -1)"
                ." and rc_code = '".SQLTrim($_SESSION['signup']['regcode'])."'";

    $sqlresults = ExecuteSQL($sqlcommand);

    if($sqlresults && is_array($sqlresults)) { // reg code is valid
        $_SESSION['signup']['regblock'] = $sqlresults;
        $sqlresults = ExecuteSQL("select reg_affinity from reg_header where reg_id in (select rc_rh_id from reg_codes where rc_code = '".SQLTrim($_SESSION['signup']['regcode'])."')");
        if($sqlresults && is_array($sqlresults)) {
            if($sqlresults[0]['reg_affinity']) {
                $_SESSION['signup']['affinitylist'] = ExecuteSQL("select num, name from staff where affinity = 'Y'");
            }
        }
    }

    if (isset($_SESSION['signup']['regrates']) || isset($_SESSION['signup']['regblock'])) {
        if (!isset($_SESSION['signup']['regrates']))
            $_SESSION['signup']['regrates'] = array();
        if (!isset($_SESSION['signup']['regblock']))
            $_SESSION['signup']['regblock'] = array();
        return new ACF_Event('verifyregcode_success');
    } else {
        unset($_SESSION['signup']['regrates']);
        unset($_SESSION['signup']['regblock']);
        unset($_SESSION['signup']['options']['regcode']);

        $retParamList = new ACF_ParameterList();
        $retParamList->AddParameter(new ACF_DirectParameter('error','Registration Code Is Invalid!'));
        $retEvent = new ACF_Event('verifyregcode_fail');
        $retEvent->SetParameterList($retParamList);
        return $retEvent;
    }
}

function AH_CheckPop (ACF_ParameterList $inParameterList) {
    if($_SESSION['signup']['options']['popid']) {
        $_SESSION['signup']['poplist'] = GetAvailablePOPs();
        if(isset($_SESSION['signup']['poplist']) && is_array($_SESSION['signup']['poplist'])) {
            $_SESSION['signup']['newcustomer']['poplocation'] = false;
            foreach($_SESSION['signup']['poplist'] as $thisPOP) {
                if($thisPOP['pop_id'] == $_SESSION['signup']['options']['popid']) {
                    $_SESSION['signup']['newcustomer']['poplocation']['id'] = $_SESSION['signup']['options']['popid'];
                    $_SESSION['signup']['newcustomer']['poplocation']['detail'] = $thisPOP;
                    break;
                }
            }
        }
    }

    if($_SESSION['signup']['newcustomer']['poplocation']) {
        return new ACF_Event('nopop');
    } else {
        $popCount = ExecuteSQL("select popcount = count(*) from pop where pop_active = 'Y'");
        $popCount = $popCount[0]['popcount'];

        if(strtolower(GetWebOption('showpop',$_SESSION['signup']['storeid'])) == 'y' && $popCount > 0) {
            $_SESSION['signup']['poprequired'] = true;
            if(strtolower(GetWebOption('suggestpop',$_SESSION['signup']['storeid'])) == 'y') {
                return new ACF_Event('suggestpop');
            } else {
                return new ACF_Event('showpop');
            }
        } else {
            $_SESSION['signup']['poprequired'] = false;
            $default_popid = (int) GetWebOption('defaultpop',$_SESSION['signup']['storeid']);

            if($default_popid > 0) {
                $popData = ExecuteSQL("select * from pop where pop_id = ".$default_popid);
            $_SESSION['signup']['newcustomer']['poplocation'] = false;
            $_SESSION['signup']['newcustomer']['poplocation']['id'] = $default_popid;
            $_SESSION['signup']['newcustomer']['poplocation']['detail'] = $popData[0];
        } else {
            $_SESSION['signup']['newcustomer']['poplocation']['id'] = 0;
            $_SESSION['signup']['newcustomer']['poplocation']['detail'] = false;
        }

            return new ACF_Event('nopop');
        }
    }
}

function AH_VerifySuggestion (ACF_ParameterList $inParameterList) {
    $_SESSION['signup']['matchvalue'] = $inParameterList->ParameterValue('matchvalue');
    $_SESSION['signup']['popvalue'] = GetWebOption('popvalue',$_SESSION['signup']['storeid']);

    if(!$_SESSION['signup']['matchvalue']) { // Nothing entered for suggestion; check the blankpop option to see what to do
        switch (GetWebOption('blankpop',$_SESSION['signup']['storeid'])) {
            case 'SELECT':
                $_SESSION['signup']['popForceSelect'] = true;
                $retEvent = new ACF_Event('verifysuggestion_Failure');
                $retParamList = new ACF_ParameterList();
                $retParamList->AddParameter(new ACF_DirectParameter('error','POP Suggestion left blank.  Select one below.'));
                $retEvent->SetParameterList($retParamList);
                break;
            case 'TYPE':
                $_SESSION['signup']['popForceType'] = true;
                $retEvent = new ACF_Event('verifysuggestion_Failure');
                $retParamList = new ACF_ParameterList();
                $retParamList->AddParameter(new ACF_DirectParameter('error','POP Suggestion left blank.  Type one below.'));
                $retEvent->SetParameterList($retParamList);
                break;
            case 'DEFAULT':
                $_SESSION['signup']['poplocation'] = GetWebOption('defaultpop',$_SESSION['signup']['storeid']);
                $retEvent = new ACF_Event('verifypop_Success');
                break;
            case 'SHOWALL':
                $_SESSION['signup']['poplist'] = GetAvailablePOPs();

                $_SESSION['signup']['poplistSet'] = true;
                $retEvent = new ACF_Event('verifysuggestion_Success');
                $retParamList = new ACF_ParameterList();
                $retParamList->AddParameter(new ACF_DirectParameter('poplist',$_SESSION['signup']['poplist']));
                $retEvent->SetParameterList($retParamList);
                break;
        }

        return $retEvent;
    } else {
        $_SESSION['signup']['poplist'] = GetAvailablePOPs($_SESSION['signup']['matchvalue']);
    }

    if(!is_array($_SESSION['signup']['poplist'])) { // Nothing matches the value entered for suggestion; check the nopopaction option to see what to do
        switch (GetWebOption('nopopaction',$_SESSION['signup']['storeid'])) {
            case 'SELECT':
                $_SESSION['signup']['popForceSelect'] = true;
                $retEvent = new ACF_Event('verifysuggestion_Failure');
                $retParamList = new ACF_ParameterList();
                $retParamList->AddParameter(new ACF_DirectParameter('error','POP Suggestion not found.  Select one below.'));
                $retEvent->SetParameterList($retParamList);
                break;
            case 'TYPE':
                $_SESSION['signup']['popForceType'] = true;
                $retEvent = new ACF_Event('verifysuggestion_Failure');
                $retParamList = new ACF_ParameterList();
                $retParamList->AddParameter(new ACF_DirectParameter('error','POP Suggestion not found.  Type one below.'));
                $retEvent->SetParameterList($retParamList);
                break;
            case 'DEFAULT':
                $_SESSION['signup']['poplocation'] = GetWebOption('defaultpop',$_SESSION['signup']['storeid']);
                $retEvent = new ACF_Event('verifypop_Success');
                break;
            case 'SHOWALL':
                $_SESSION['signup']['poplist'] = GetAvailablePOPs();

                $_SESSION['signup']['poplistSet'] = true;
                $retEvent = new ACF_Event('verifysuggestion_Success');
                $retParamList = new ACF_ParameterList();
                $retParamList->AddParameter(new ACF_DirectParameter('poplist',$_SESSION['signup']['poplist']));
                $retEvent->SetParameterList($retParamList);
                break;
        }

        return $retEvent;
    } else {
        $_SESSION['signup']['poplistSet'] = true;
        $retEvent = new ACF_Event('verifysuggestion_Success');
        $retParamList = new ACF_ParameterList();
        $retParamList->AddParameter(new ACF_DirectParameter('poplist',$_SESSION['signup']['poplist']));
        $retEvent->SetParameterList($retParamList);

        return $retEvent;
    }
}

function AH_VerifyPOP (ACF_ParameterList $inParameterList) {
    if (!is_numeric($inParameterList->ParameterValue('poplocation'))) {
        $retEvent = new ACF_Event('verifypop_Failure');
        $retParamList = new ACF_ParameterList();
        $retParamList->AddParameter(new ACF_DirectParameter('error','POP Location is invalid!'));
        $retEvent->SetParameterList($retParamList);
        return $retEvent;
    }

    $_SESSION['signup']['newcustomer']['poplocation']['id'] = $inParameterList->ParameterValue('poplocation');

    if($_SESSION['signup']['newcustomer']['poplocation']['id']) {
        if(isset($_SESSION['signup']['poplist']) && is_array($_SESSION['signup']['poplist'])) {
            foreach($_SESSION['signup']['poplist'] as $thisPOP) {
                if($thisPOP['pop_id'] == $_SESSION['signup']['newcustomer']['poplocation']['id']) {
                    $_SESSION['signup']['newcustomer']['poplocation']['detail'] = $thisPOP;
                    break;
                }
            }
        }
        return new ACF_Event('verifypop_Success');
    } else {
        $retEvent = new ACF_Event('verifypop_Failure');
        $retParamList = new ACF_ParameterList();
        $retParamList->AddParameter(new ACF_DirectParameter('error','POP Location Is Blank!'));
        $retEvent->SetParameterList($retParamList);
        return $retEvent;
    }
}

function AH_CheckDomainRate (ACF_ParameterList $inParameterList) {
	global $storeid;

	$URL = $_SESSION['ccs']['options']['driver-options']['url'];
	$bundleid = $inParameterList->ParameterValue('landing');

	if($bundleid) {

		$rgid = substr($bundleid['rate'],0,strpos($bundleid['rate'],'X'));
		$freq = substr($bundleid['rate'],strpos($bundleid['rate'],'X')+1);

		$bundle = GetSingleRate($rgid,$freq);

		if($bundle['svc_ccs_service'] == 'domain') {
			$_SESSION['modules']['billing']['bundle'] = $bundle;
			$_SESSION['modules']['billing']['bundle']['id'] = $rgid;
			$_SESSION['ccs']['bundled'] = true;

			SetPriceList($rgid);

			$serviceHeader = GetCCSServiceDetails($bundle['rg_id']);
			$fieldData = GetServiceFields($bundle['rg_ccs_svc_id'],$bundle['rg_id'],false,$serviceHeader['serviceData']['rs_id'],$serviceHeader['serviceData']['rs_parent_instance'],$serviceHeader['serviceData']['rs_parent_service']);

			if(isset($fieldData) && is_array($fieldData)) {
				foreach($fieldData as $thisField) {
					if(!isset($thisField['template_dflt'])) {
						$error = "No Service Template assigned to this Rate";
						break;
					} else {
						if($thisField['datacol'] == 'register_period') {
							$_SESSION['modules']['domain']['passed']['register_period'] = $thisField['template_dflt'];
						}
					}
				}
			}

			if($_SESSION['modules']['billing']['bundle']['rg_fixed_price'] <= 0 && $_SESSION['modules']['billing']['bundle']['rg_one_time_fees'] <= 0) {
				if(is_array($_SESSION['ccs']['excludeSteps'])) {
					array_push($_SESSION['ccs']['excludeSteps'],'payment');
				} else {
					$_SESSION['ccs']['excludeSteps'] = array('payment');
				}
			}

			$returnURL = $URL."/checkserviceavailability?servicetype=".$bundle['svc_ccs_service'];
			header("location:".$returnURL);
			return new ACF_Event('checkdomainrate_domain');
		} else {
			$_SESSION['signup']['landing'] = $bundleid;
			return new ACF_Event('checkdomainrate_notdomain');
		}
	}
}

function AH_VerifyRate (ACF_ParameterList $inParameterList) {
    $_SESSION['signup']['newcustomer']['rate']['detail'] = array();
    $displayRates = "N";
    $ratearray = array();
    $badrateList = array();
    $ratelist = GetAvailableWebRates();

    if(isset($_SESSION['signup']['regrates']) && is_array($_SESSION['signup']['regrates'])) {
        foreach($_SESSION['signup']['regrates'] as $thisPlan) {
            $displayRates = $thisPlan['reg_displayrates'];
        }
        if (is_numeric($_SESSION['signup']['newcustomer']['rate']['id'])) {
            $_SESSION['signup']['regrgid'] = $_SESSION['signup']['newcustomer']['rate']['id'];

            $sqlresults = ExecuteSQL("select rrd_rgid, rrd_freq from reg_rate_details where rrd_planid = ". $_SESSION['signup']['regrgid']);
            if(isset($sqlresults) && is_array($sqlresults)) {
                foreach($sqlresults as $thisRate) {
                    $thisRateData = array('rgid'=> $thisRate['rrd_rgid'], 'freq'=>$thisRate['rrd_freq']);
                    array_push($ratearray,$thisRateData);
                }
            }
        }
    } else {
        $displayRates = GetWebOption('displayrates',$_SESSION['signup']['storeid']);
        if ($_SESSION['signup']['newcustomer']['rate']['id']) {
            $rgid = substr($_SESSION['signup']['newcustomer']['rate']['id'],0,strpos($_SESSION['signup']['newcustomer']['rate']['id'],'X'));
            $freq = substr($_SESSION['signup']['newcustomer']['rate']['id'],strpos($_SESSION['signup']['newcustomer']['rate']['id'],'X')+1);
            $thisRateData = array('rgid'=> $rgid, 'freq'=>$freq);

            array_push($ratearray,$thisRateData);
        }
    }

    $_SESSION['signup']['chargeamount'] = 0;

    if(isset($ratearray) && is_array($ratearray)) {
        foreach($ratearray as $thisRate) {
            if(isset($ratelist) && is_array($ratelist)) {
                $rateFound = false;
                foreach($ratelist as $thisDetail) {
                    if($thisDetail['rg_id'] == $thisRate['rgid'] && $thisDetail['r_frequency'] == $thisRate['freq']) {
                        $rateFound = true;
                        $thisDetail['rg_fixed_price'] = ShowMoney($thisDetail['rg_fixed_price']);
                        $thisDetail['rg_one_time_fees'] = ShowMoney($thisDetail['rg_one_time_fees']);
                        array_push($_SESSION['signup']['newcustomer']['rate']['detail'], $thisDetail);
                        $_SESSION['signup']['chargeamount'] += $thisDetail['rg_fixed_price'] + $thisDetail['rg_one_time_fees'];
                        if(!$_SESSION['signup']['storeid']) {
                            $storeList = explode(',',$thisDetail['rg_companies']);
                            $_SESSION['signup']['storeid'] = trim($storeList[0]);
                        }
                        break;
                    }
                }

                if(!$rateFound) {
                    $badrateList[$thisRate['rgid']] = $thisRate['freq'];
                }
            }
        }
    }

    if(!$_SESSION['signup']['newcustomer']['rate']['detail']) {
        if (strtolower($displayRates) == 'r' || (strtolower($displayRates) == 'c' && $_SESSION['wow']['logintype'] != 'staff')) {
            $_SESSION['signup']['error'] = ($_SESSION['signup']['error'] ? $_SESSION['signup']['error'] . "\n" : "") . "Rate Group Is Blank!";
        } else {
            //'-1' is a special code that tells the wwque not to verify rate group
            array_push($_SESSION['signup']['newcustomer']['rate']['detail'],array('rg_id'=>'-1','r_frequency'=>'-1'));
        }
    }

    if(isset($badrateList) && is_array($badrateList) && count($badrateList) > 0) {
        foreach($badrateList as $badRGID => $badFreq) {
            $_SESSION['signup']['error'] = ($_SESSION['signup']['error'] ? $_SESSION['signup']['error'] . "\n" : "") . "Rate Group ID " . $badRGID . " - Frequency: " . $badFreq . " Not Found!";
        }
    }

    return new ACF_Event('verifyrate_complete');
}

function AH_VerifyBlockRate (ACF_ParameterList $inParameterList) {
    $_SESSION['signup']['newcustomer']['blockrate']['detail'] = array();
    $displayBlock = "N";
    $ratearray = array();
    $badrateList = array();
    $ratelist = GetBlockRates(true);

    if (!is_numeric($_SESSION['signup']['newcustomer']['blockrate']['id']))
        $_SESSION['signup']['newcustomer']['blockrate']['id'] = 0;

    if(!$_SESSION['signup']['chargeamount'])
        $_SESSION['signup']['chargeamount'] = 0;

    if(isset($_SESSION['signup']['regblock']) && is_array($_SESSION['signup']['regblock'])) {
        foreach($_SESSION['signup']['regblock'] as $thisPlan) {
            $displayBlock = $thisPlan['reg_displayblock'];
        }
        if (is_numeric($_SESSION['signup']['newcustomer']['blockrate']['id'])) {
            $_SESSION['signup']['regblockid'] = $_SESSION['signup']['newcustomer']['blockrate']['id'];
            $sqlresults = ExecuteSQL("select rbd_rgid from reg_block_details where rbd_planid = ". $_SESSION['signup']['regblockid']);
            if(isset($sqlresults) && is_array($sqlresults)) {
                foreach($sqlresults as $thisRate) {
                    array_push($ratearray,$thisRate['rbd_rgid']);
                }
            }
        }
    } else {
        $displayBlock = GetWebOption('displayblock',$_SESSION['signup']['storeid']);
        if ($_SESSION['signup']['newcustomer']['blockrate']['id']) {
            array_push($ratearray,$_SESSION['signup']['newcustomer']['blockrate']['id']);
        }
    }

    if(isset($ratearray) && is_array($ratearray)) {
        foreach($ratearray as $thisRate) {
            if(isset($ratelist) && is_array($ratelist)) {
                $rateFound = false;
                foreach($ratelist as $thisDetail) {
                    if($thisDetail['id'] == $thisRate) {
                        $rateFound = true;
                        $_SESSION['signup']['chargeamount'] += $thisDetail['price'];
                        array_push($_SESSION['signup']['newcustomer']['blockrate']['detail'],$thisDetail);
                    }
                }

                if(!$rateFound) {
                    array_push($badrateList,$thisRate['id']);
                }
            }
        }
    }
    if(isset($badrateList) && is_array($badrateList) && count($badrateList) > 0) {
        foreach($badrateList as $badRGID) {
            $_SESSION['signup']['error'] = ($_SESSION['signup']['error'] ? $_SESSION['signup']['error'] . "\n" : "") . "Block Item " . $badRGID . " Not Found!";
        }
    } elseif (strtolower($displayBlock) == 'r' && !$_SESSION['signup']['newcustomer']['blockrate']['id']) {
        $_SESSION['signup']['error'] = ($_SESSION['signup']['error'] ? $_SESSION['signup']['error'] . "\n" : "") . "Block Item Is Blank!";
    }

    return new ACF_Event('verifyblockrate_complete');
}

function AH_VerifyCustomer (ACF_ParameterList $inParameterList) {
    $error = "";

    if(isset($_SESSION['signup']['newcustomer']['rate']['detail']) && is_array($_SESSION['signup']['newcustomer']['rate']['detail'])) {
        foreach($_SESSION['signup']['newcustomer']['rate']['detail'] as $thisRate) {
            $_SESSION['signup']['newcustomer']['info']['rgid'] = $_SESSION['signup']['newcustomer']['info']['rgid'] . $thisRate['rg_id'] . ',';
            $_SESSION['signup']['newcustomer']['info']['rg_freq'] = $_SESSION['signup']['newcustomer']['info']['rg_freq'] . $thisRate['r_frequency'] . ',';
        }
    }

    $_SESSION['signup']['newcustomer']['info']['rgid'] = $_SESSION['signup']['rates']['rgid'] = substr($_SESSION['signup']['newcustomer']['info']['rgid'],0,strlen($_SESSION['signup']['newcustomer']['info']['rgid'])-1);
    $_SESSION['signup']['newcustomer']['info']['rg_freq'] = $_SESSION['signup']['rates']['freq'] = substr($_SESSION['signup']['newcustomer']['info']['rg_freq'],0,strlen($_SESSION['signup']['newcustomer']['info']['rg_freq'])-1);

    $verifyResults = VerifyNewUser($_SESSION['signup']['newcustomer'],$_SESSION['signup']['storeid']);
    if(!$verifyResults['success']) {
        $error .= $verifyResults['error'];
    }

    if($_SESSION['signup']['poprequired'] && !$_SESSION['signup']['newcustomer']['poplocation']) {
        $error .= "\n"."POP Location required!";
        $_SESSION['signup']['poperror'] = true;
    } else {
        $_SESSION['signup']['poperror'] = false;
    }

    $combinedData = $_SESSION['signup']['newcustomer']['info']['nonrequired'] ? $_SESSION['signup']['newcustomer']['info']['required'] + $_SESSION['signup']['newcustomer']['info']['nonrequired'] : $_SESSION['signup']['newcustomer']['info']['required'];

    if(isset($_SESSION['signup']['newcustomer']['info']['required']) && is_array($_SESSION['signup']['newcustomer']['info']['required']))
        foreach($_SESSION['signup']['newcustomer']['info']['required'] as $reqfield=>$reqvalue)
            if(!$reqvalue) {
            	$error .= "\n"."One or more required fields were left blank.";
            	break;
/*                $error .= "\n".$reqfield." is a required field.  Please enter a value for this field.";*/
			}

    if($error)
        $_SESSION['signup']['error'] = ($_SESSION['signup']['error'] ? $_SESSION['signup']['error'] . "\n" : "") . $error;
    $_SESSION['signup']['newcustomer']['info'] = $combinedData;

    if($_SESSION['signup']['newcustomer']['info']['salesid'])
        $_SESSION['signup']['salesidSet'] = true;
    if($_SESSION['signup']['newcustomer']['info']['referralid'])
        $_SESSION['signup']['referralidSet'] = true;

    $_SESSION['signup']['newcustomer']['info']['rgid'] = $_SESSION['signup']['rates']['rgid'];
    $_SESSION['signup']['newcustomer']['info']['rg_freq'] = $_SESSION['signup']['rates']['freq'];

    return new ACF_Event('verifycustomer_complete');
}

function AH_VerifyReferral (ACF_ParameterList $inParameterList) {
    $_SESSION['signup']['referral'] = $inParameterList->ParameterValue('referral');
    return new ACF_Event('verifyreferral_Success');
}

function AH_VerifyPaymentType (ACF_ParameterList $inParameterList) {
    if(!$_SESSION['signup']['newcustomer']['info']['paymenttype'])
        $_SESSION['signup']['error'] = ($_SESSION['signup']['error'] ? $_SESSION['signup']['error'] . "\n" : "") . "No Payment Type Selected!";
    return new ACF_Event('verifypaymenttype_complete');
}

function AH_VerifyLogin (ACF_ParameterList $inParameterList) {
    $_SESSION['signup']['newcustomer']['info']['username'] = $_SESSION['signup']['newcustomer']['login']['username'];
    $_SESSION['signup']['newcustomer']['info']['password'] = $_SESSION['signup']['newcustomer']['login']['password'];
    if($_SESSION['signup']['newcustomer']['info']['password'])
        $_SESSION['signup']['newcustomer']['info']['passwordMasked'] = str_repeat("*",strlen($_SESSION['signup']['newcustomer']['info']['password']));
    $_SESSION['signup']['newcustomer']['info']['password2'] = $_SESSION['signup']['newcustomer']['login']['password2'];

    if($_SESSION['signup']['newcustomer']['login']['password'] != $_SESSION['signup']['newcustomer']['login']['password2'])
        $errormsg = 'Password Fields Do Not Match!';
    if(!$_SESSION['signup']['newcustomer']['login']['password'] || !$_SESSION['signup']['newcustomer']['login']['password2'])
        $errormsg = 'Password Field Is Blank!';
    if(!$_SESSION['signup']['newcustomer']['login']['username'])
        $errormsg = 'Username Is Blank!';

    $usernamechk = ExecuteSQL("select username from customer where username = '".SQLTrim($_SESSION['signup']['newcustomer']['login']['username'])."'");
    if(isset($usernamechk[0]['username'])) {
        $errormsg = "Username '".$_SESSION['signup']['newcustomer']['login']['username']."' Already Taken!";
        $suggestion = SuggestUsername($_SESSION['signup']['newcustomer']['info']['name']);
        if($suggestion) {
            $errormsg .= "\n".'The following suggested username is available: <B>'.$suggestion.'</B>';
            $_SESSION['signup']['newcustomer']['login']['username'] = $_SESSION['signup']['newcustomer']['info']['username'] = $suggestion;
        }
    }

    if($errormsg)
        $_SESSION['signup']['error'] = ($_SESSION['signup']['error'] ? $_SESSION['signup']['error'] . "\n" : "") . $errormsg;
    return new ACF_Event('verifylogin_complete');
}

function AH_VerifyPaymentInfo (ACF_ParameterList $inParameterList) {
    $newPayment = $inParameterList->ParameterValue('payment');

    if($_SESSION['signup']['newcustomer']['paymentinfo'] && $_SESSION['signup']['newcustomer']['info']['paymenttype'] == 'ccard') {
        if($newPayment['ccnumber'] == $_SESSION['signup']['newcustomer']['paymentinfo']['ccnumberMasked']) {
            $newPayment['ccnumber'] = $_SESSION['signup']['newcustomer']['paymentinfo']['ccnumber'];
        }
    }

    $cvv2Required = $_SESSION['signup']['newcustomer']['paymentinfo']['cvv2Required'];
    $_SESSION['signup']['newcustomer']['paymentinfo'] = $newPayment;
    $_SESSION['signup']['newcustomer']['paymentinfo']['cvv2Required'] = $cvv2Required;

    switch($_SESSION['signup']['newcustomer']['info']['paymenttype']) {
        case 'ach':
            if(!($_SESSION['signup']['newcustomer']['paymentinfo']['acctnumber'])) {
                $errormsg .= 'BANK ACCOUNT NUMBER not set.  ';
            }
            if(!$_SESSION['signup']['newcustomer']['paymentinfo']['routenumber']) {
                $errormsg .= 'BANK ROUTING NUMBER not set.  ';
            }
            if(!$_SESSION['signup']['newcustomer']['paymentinfo']['bankaccttype']) {
                $errormsg .= 'BANK ACCOUNT TYPE not set.  ';
            }
/*
            if(some function to see if this ACH payment info is valid)
                $errormsg = 'ACH Payment Info Invalid!';
            else
*/
            $_SESSION['signup']['newcustomer']['info']['stmtmethod'] = GetWebOption('achstmt',$_SESSION['signup']['storeid']);
            if(strtolower(GetWebOption('addach',$_SESSION['signup']['storeid'])) == 'y')
                $_SESSION['signup']['fireUM'] = true;
            switch(GetWebOption('active_ach',$_SESSION['signup']['storeid'])) {
                case 'N':
                    $_SESSION['signup']['newcustomer']['info']['active'] = 'N';
                    break;
                default:
                    $_SESSION['signup']['newcustomer']['info']['active'] = 'Y';
            }

            if(!$errormsg) {
                return new ACF_Event('verifypaymentinfo_Success');
            }
            break;


        case 'check':
            $_SESSION['signup']['newcustomer']['info']['stmtmethod'] = GetWebOption('checkstmt',$_SESSION['signup']['storeid']);
            if(strtolower(GetWebOption('addcheck',$_SESSION['signup']['storeid'])) == 'y')
                $_SESSION['signup']['fireUM'] = true;
            switch(strtolower(GetWebOption('active_check',$_SESSION['signup']['storeid']))) {
                case 'n':
                    $_SESSION['signup']['newcustomer']['info']['active'] = 'N';
                    break;
                default:
                    $_SESSION['signup']['newcustomer']['info']['active'] = 'Y';
            }
            return new ACF_Event('verifypaymentinfo_Success');
            break;
        case 'ccard':
            if($_SESSION['signup']['newcustomer']['paymentinfo']['ccnumber'])
                $_SESSION['signup']['newcustomer']['paymentinfo']['ccnumberMasked'] = str_repeat("*",strlen($_SESSION['signup']['newcustomer']['paymentinfo']['ccnumber'])-4).substr($_SESSION['signup']['newcustomer']['paymentinfo']['ccnumber'],strlen($_SESSION['signup']['newcustomer']['paymentinfo']['ccnumber'])-4);
            $validation = ValidateCard($_SESSION['signup']['newcustomer']['paymentinfo']['cctype'],$_SESSION['signup']['newcustomer']['paymentinfo']['ccnumber'],$_SESSION['signup']['newcustomer']['paymentinfo']['ccmonth'],$_SESSION['signup']['newcustomer']['paymentinfo']['ccyear']);
            if(!$validation['success']) {
                $errormsg = $validation['error'];
            } else {
                if(!$_SESSION['signup']['newcustomer']['paymentinfo']['cvv2'] && $_SESSION['signup']['newcustomer']['paymentinfo']['cvv2Required'] == 'R') {
                    $errormsg = "Credit Card Validation Number Required.";
                } else {
                    $_SESSION['signup']['newcustomer']['info']['stmtmethod'] = 'CREDIT CARD';
                    $_SESSION['signup']['fireUM'] = true;
                    switch(strtolower(GetWebOption('active_ccard',$_SESSION['signup']['storeid']))) {
                        case 'n':
                            $_SESSION['signup']['newcustomer']['info']['active'] = 'N';
                            break;
                        default:
                            $_SESSION['signup']['newcustomer']['info']['active'] = 'Y';
                    }
                    return new ACF_Event('verifypaymentinfo_Success');
                }
            }

            break;
    }

    if($errormsg) {
        $retEvent = new ACF_Event('verifypaymentinfo_Failure');
        $retParamList = new ACF_ParameterList();
        $retParamList->AddParameter(new ACF_DirectParameter('error',$errormsg));
        $retParamList->AddParameter(new ACF_DirectParameter('payment',$_SESSION['signup']['newcustomer']['paymentinfo']));
        $retEvent->SetParameterList($retParamList);
        return $retEvent;
    }
}

function AH_SetExtraFields (ACF_ParameterList $inParameterList) {
/* This function will actually run GetWebOption for a bunch of differnet optional fields to see if they should be displayed
   If so, they will be set in the session, much like you see here */

    $_SESSION['signup']['extrafields']['test1'] = true;
    $_SESSION['signup']['extrafields']['test2'] = true;
    $_SESSION['signup']['extrafields']['test3'] = true;
    $_SESSION['signup']['extrafields']['test4'] = true;

    return new ACF_Event('setextrafields_Success');
}

function AH_VerifyExtraFields (ACF_ParameterList $inParameterList) {
    $extrainput = $inParameterList->ParameterValue('extrafields');
    if(isset($extrainput) && is_array($extrainput))
        foreach ($extrainput as $inputname=>$inputvalue)
            $_SESSION['signup']['extrafields'][$inputname] = $inputvalue;
    return new ACF_Event('verifyextrafields_Success');
}

function AH_VerifyAll (ACF_ParameterList $inParameterList) {
    $retParamList = new ACF_ParameterList();

    if(!$_SESSION['ccs']) {
        $retEvent = new ACF_Event('verifyall_Fail');
        $retParamList->AddParameter(new ACF_DirectParameter('error','CCS Options not loaded.'));
        $retEvent->SetParameterList($retParamList);

        header("location:/projects/platsignup/index.php?NEWSESSION");
        return $retEvent;
    }

    $verifyResults = VerifyNewUser($_SESSION['signup']['newcustomer'],$_SESSION['signup']['storeid']);

    if(!$verifyResults['success']) {
        $retEvent = new ACF_Event('verifyall_Fail');
        $retParamList->AddParameter(new ACF_DirectParameter('error',$verifyResults['error']));
        $retEvent->SetParameterList($retParamList);
        return $retEvent;
    }

    if(!AddUser($_SESSION['signup']['storeid'])) {
        $retEvent = new ACF_Event('verifyall_Fail');
        if($_SESSION['signup']['storeid'])
            $retParamList->AddParameter(new ACF_DirectParameter('error',$_SESSION['signup']['error']));
        else
            $retParamList->AddParameter(new ACF_DirectParameter('error','The Company ID must be set before the customer can be added'));
        $retEvent->SetParameterList($retParamList);
        return $retEvent;
    }

    getRates();

    if($_SESSION['signup']['regrates'] || $_SESSION['signup']['regblock']) { // registration codes in place, setup bonuses if necessary
        ProcessRegistrationCode();
    }

    postCharges($_SESSION['signup']['storeid']);
    if($_SESSION['signup']['newcustomer']['blockrate']['id']) {
        foreach($_SESSION['signup']['newcustomer']['blockrate']['detail'] as $thisRate) {
            postBlockCharges($thisRate['id']);
        }
    }
    getInvoices();
    $enableRealTime = ExecuteSQL("select value from options where name = 'Enable Real Time'");
    if(strtolower($enableRealTime[0]['value']) == 'y' && $_SESSION['signup']['newcustomer']['info']['paymenttype'] == 'ccard') {
        if(!chargeCard($_SESSION['signup']['storeid'])) {
            if (strtolower(GetWebOption('addbadcredit')) == 'y') {
                $retParamList->AddParameter(new ACF_DirectParameter('error','Your account has been created, but your initial payment could not be processed: '.$_SESSION['signup']['error']));
            } else {
                $retParamList->AddParameter(new ACF_DirectParameter('error',$_SESSION['signup']['error']));
                $retEvent = new ACF_Event('verifyall_Fail');
                $retEvent->SetParameterList($retParamList);
                return $retEvent;
            }
        }
    }

    if($_SESSION['signup']['fireUM']) {
        launchUM();
    }

    WelcomeEmail($_SESSION['signup']['custid']);

    $retEvent = new ACF_Event('verifyall_Success');
    $retEvent->SetParameterList($retParamList);

    return $retEvent;
}

//---- function to check to see if any errors exist
function AH_CheckErrors(ACF_ParameterList $inParameters){
    if ($_SESSION['signup']['error']){
        $param = new ACF_ParameterList();
        $param->AddParameter(new ACF_DirectParameter('error',$_SESSION['signup']['error']));
        if($_SESSION['signup']['poperror']) {
            $event = new ACF_Event('popRequired');
        } else {
            $event = new ACF_Event('errorFound');
        }

        $event->SetParameterList($param);
        $_SESSION['signup']['error'] = "";
    } else {
        $event = new ACF_Event('noErrors');
    }

    return $event;
}
?>
