<?php

require_once("platfunctions.php");

function DC_GetStaffNames (ACF_ParameterList $inParameterList) {
    unset($_SESSION['signup']['regmaint']);
    $staffList = GetStaffNames();

    $paramList = new ACF_ParameterList();
    $paramList->AddParameter(new ACF_DirectParameter('stafflist',$staffList));

    return $paramList;
}

function DC_GetTodaysDate (ACF_ParameterList $inParameterList) {

    if (!isset($_SESSION['signup']['dateformat']))
        GetDateFormat();

    $paramList = new ACF_ParameterList();
    switch($_SESSION['signup']['dateformat']) {
    case "YMD":
        $paramList->AddParameter(new ACF_DirectParameter('todaysdate',date("Y/n/j")));
        break;
    case "DMY":
        $paramList->AddParameter(new ACF_DirectParameter('todaysdate',date("j/n/Y")));
        break;
    case "MDY":
        $paramList->AddParameter(new ACF_DirectParameter('todaysdate',date("n/j/Y")));
        break;
    }

    $paramList->AddParameter(new ACF_DirectParameter('dateformat',$_SESSION['signup']['dateformat']));

    return $paramList;
}

function DC_GetRegHeader (ACF_ParameterList $inParameterList) {

    if (!isset($_SESSION['signup']['dateformat']))
        GetDateFormat();

    $regheader = ExecuteSQL("select * from reg_header order by reg_id");
    if(isset($regheader) and is_array($regheader)) {
        foreach($regheader as &$thisHeader) {
            switch($_SESSION['signup']['dateformat']) {
                case "YMD":
                    $thisHeader['reg_create'] = date("Y/n/j",strtotime($thisHeader['reg_create']));
                    if($thisHeader['reg_expire']) {
                        $thisHeader['reg_expire'] = date("Y/n/j",strtotime($thisHeader['reg_expire']));
                    }
                    break;
                case "DMY":
                    $thisHeader['reg_create'] = date("j/n/Y",strtotime($thisHeader['reg_create']));
                    if($thisHeader['reg_expire']) {
                        $thisHeader['reg_expire'] = date("j/n/Y",strtotime($thisHeader['reg_expire']));
                    }
                    break;
                case "MDY":
                    $thisHeader['reg_create'] = date("n/j/Y",strtotime($thisHeader['reg_create']));
                    if($thisHeader['reg_expire']) {
                        $thisHeader['reg_expire'] = date("n/j/Y",strtotime($thisHeader['reg_expire']));
                    }
                break;
            }
        }
    }

    $paramList = new ACF_ParameterList();
    $paramList->AddParameter(new ACF_DirectParameter('regheader',$regheader));

    return $paramList;
}

function DC_GetSingleRegHeader (ACF_ParameterList $inParameterList) {
    $reg_code = $inParameterList->ParameterValue('regcode');
    $regheader = ExecuteSQL("select * from reg_header where reg_template='".SQLTrim($reg_code)."'");
    $regheader = $regheader[0];

    if (!isset($_SESSION['signup']['dateformat']))
        GetDateFormat();
    switch($_SESSION['signup']['dateformat']) {
    case "YMD":
        $regheader['reg_create'] = date("Y/n/j",strtotime($regheader['reg_create']));
        if($regheader['reg_expire']) {
            $regheader['reg_expire'] = date("Y/n/j",strtotime($regheader['reg_expire']));
        }
        break;
    case "DMY":
        $regheader['reg_create'] = date("j/n/Y",strtotime($regheader['reg_create']));
        if($regheader['reg_expire']) {
            $regheader['reg_expire'] = date("j/n/Y",strtotime($regheader['reg_expire']));
        }
        break;
    case "MDY":
        $regheader['reg_create'] = date("n/j/Y",strtotime($regheader['reg_create']));
        if($regheader['reg_expire']) {
            $regheader['reg_expire'] = date("n/j/Y",strtotime($regheader['reg_expire']));
        }
        break;
    }

    $paramList = new ACF_ParameterList();
    $paramList->AddParameter(new ACF_DirectParameter('regheader',$regheader));

    return $paramList;
}

function DC_GetPrepayTypes (ACF_ParameterList $inParameterList) {
    $paymenttypes = ExecuteSQL("select p_id,p_name from payment_types");

    $paramList = new ACF_ParameterList();
    $paramList->AddParameter(new ACF_DirectParameter('paytypes',$paymenttypes));

    return $paramList;
}

function DC_GetRatePlans (ACF_ParameterList $inParameterList) {
    $rateplans['rates'] = ExecuteSQL("select * from reg_rates order by rr_rate_description");
    if(!is_array($rateplans['rates']))
        unset($rateplans['rates']);

    $rateplans['block'] = ExecuteSQL("select * from reg_block order by rb_rate_description");
    if(!is_array($rateplans['block']))
        unset($rateplans['block']);

    $paramList = new ACF_ParameterList();
    $paramList->AddParameter(new ACF_DirectParameter('rateplans',$rateplans));

    return $paramList;
}

function DC_GetAssignedPlans (ACF_ParameterList $inParameterList) {
    $regid = $inParameterList->ParameterValue('regid');

    $assignedPlans['rates'] = ExecuteSQL("select * from reg_rates, reg_rate_header where rr_id = rrh_planid and rrh_regid = ".((integer) $regid)." order by rr_rate_description");
    if(!is_array($assignedPlans['rates']))
        unset($assignedPlans['rates']);

    $assignedPlans['block'] = ExecuteSQL("select * from reg_block, reg_block_header where rb_id = rbh_planid and rbh_regid = ".((integer) $regid)." order by rb_rate_description");
    if(!is_array($assignedPlans['block']))
        unset($assignedPlans['block']);

    $paramList = new ACF_ParameterList();
    $paramList->AddParameter(new ACF_DirectParameter('assignedplans',$assignedPlans));

    return $paramList;
}

function DC_GetAvailablePlans (ACF_ParameterList $inParameterList) {
    $regid = $inParameterList->ParameterValue('regid');

    $availablePlans['rates'] = ExecuteSQL("select * from reg_rates where rr_id not in (select rrh_planid from reg_rate_header where rrh_regid = ".((integer) $regid).") order by rr_rate_description");
    if(!is_array($availablePlans['rates']))
        unset($availablePlans['rates']);

    $availablePlans['block'] = ExecuteSQL("select * from reg_block where rb_id not in (select rbh_planid from reg_block_header where rbh_regid = ".((integer) $regid).") order by rb_rate_description");
    if(!is_array($availablePlans['block']))
        unset($availablePlans['block']);

    $paramList = new ACF_ParameterList();
    $paramList->AddParameter(new ACF_DirectParameter('availableplans',$availablePlans));

    return $paramList;
}

function DC_GetAssignedRates (ACF_ParameterList $inParameterList) {
    $rates = array();
    $ratelist = GetAvailableWebRates();

    if(isset($ratelist) && is_array($ratelist)) {
        foreach($ratelist as $rate) {
            $rates[$rate['rg_id'].'X'.$rate['r_frequency']] = $rate['rg_name'].' - '.$rate['r_frequency'].' month'.($rate['r_frequency'] > 1 ? 's' : '');
        }
    }

    $planID = $inParameterList->ParameterValue('plan');

    $assignedRates = ExecuteSQL("select distinct rrd_id, rg_name, rg_id, r_frequency from reg_rate_details, rgheader, rate where rrd_rgid = rg_id and rrd_freq = r_frequency and rg_id = r_rg_id and rrd_planid=".((integer) $planID));

    $paramList = new ACF_ParameterList();
    $paramList->AddParameter(new ACF_DirectParameter('rates',$rates));
    $paramList->AddParameter(new ACF_DirectParameter('assignedrates',$assignedRates));

    return $paramList;
}

function DC_GetAssignedBlockItems (ACF_ParameterList $inParameterList) {
    $rates = GetBlockRates(true);

    $planID = $inParameterList->ParameterValue('plan');
    $assignedRates = ExecuteSQL("select * from reg_block_details,btheader where rbd_rgid=id and rbd_planid=".((integer) $planID));

    $paramList = new ACF_ParameterList();
    $paramList->AddParameter(new ACF_DirectParameter('blockrates',$rates));
    $paramList->AddParameter(new ACF_DirectParameter('assignedrates',$assignedRates));

    return $paramList;
}

function DC_GetRegCodes (ACF_ParameterList $inParameterList) {
    $template = $inParameterList->ParameterValue('template');

    if($template) {
        $regcodes = ExecuteSQL("select reg_template,rc_id,reg_expire,reg_reuse,rc_code,rc_used from reg_codes,reg_header where reg_template = '".SQLTrim($template)."' and rc_rh_id=reg_id order by rc_code");
    } else {
        $regcodes = ExecuteSQL("select reg_template,rc_id,reg_expire,reg_reuse,rc_code,rc_used from reg_codes,reg_header where rc_rh_id=reg_id order by rc_code");
    }

    if(!(isset($regcodes) && is_array($regcodes))) {
        $regcodes = false;
    }

    $paramList = new ACF_ParameterList();
    $paramList->AddParameter(new ACF_DirectParameter('regcodes',$regcodes));

    return $paramList;
}

function DC_GetRegTemplateNames (ACF_ParameterList $inParameterList) {
    $templates = ExecuteSQL("select id = reg_id, template = reg_template from reg_header");

    $paramList = new ACF_ParameterList();
    $paramList->AddParameter(new ACF_DirectParameter('templates',$templates));

    return $paramList;
}

function DC_GetBonusRules (ACF_ParameterList $inParameterList) {
    $regid = $inParameterList->ParameterValue('regid');

    $bonusRules = ExecuteSQL("select * from reg_details, staff where rd_salesid = staff.num and rd_hdr_id = ".((integer) $regid));
    if(isset($bonusRules) && is_array($bonusRules)) {
        foreach($bonusRules as &$thisRule) {
            switch($thisRule['rd_bonustype']) {
            case "M":
               $thisRule['rd_bonustype_Display'] = 'Manual';
                break;
            case "G":
                $thisRule['rd_bonustype_Display'] = 'Global';
                break;
            case "B":
                $thisRule['rd_bonustype_Display'] = 'Both';
                break;
            }
            switch($thisRule['rd_type']) {
            case "F":
                $thisRule['rd_type_Display'] = 'Fixed';
                break;
            case "P":
                $thisRule['rd_type_Display'] = 'Percentage';
                break;
            }
            $thisRule['rd_visible_Display'] = $thisRule['affinity'] == 'Y' ? $thisRule['rd_visible'] : "--";
        }
    }

    $paramList = new ACF_ParameterList();
    $paramList->AddParameter(new ACF_DirectParameter('bonusrules',$bonusRules));

    return $paramList;
}

function DC_GetSingleBonusRule (ACF_ParameterList $inParameterList) {
    $rdid = $inParameterList->ParameterValue('rdid');

    $bonusRule = ExecuteSQL("select * from reg_details,staff where rd_salesid=staff.num and rd_id=".((integer) $rdid));
    $bonusRule = $bonusRule[0];

    $paramList = new ACF_ParameterList();
    $paramList->AddParameter(new ACF_DirectParameter('bonusrule',$bonusRule));

    return $paramList;
}

function DC_GetRuleAffinities (ACF_ParameterList $inParameterList) {
    $affinities = ExecuteSQL("select * from staff where active='Y' and (position in (2,3) or affinity='Y')");

    $paramList = new ACF_ParameterList();
    $paramList->AddParameter(new ACF_DirectParameter('affinities',$affinities));

    return $paramList;
}

?>
