<?php

// *******************************************************************
// COMMENTS IN CAPS ARE TEMP UNTIL FIXED, COMPLETED, CHANGED, ETC ....
// *******************************************************************
require_once("platfunctions.php");

function DC_GetDateFormat (ACF_ParameterList $inParameterList) {
    $paramList = new ACF_ParameterList();
    $paramList->AddParameter(new ACF_DirectParameter('dateformat',$_SESSION['signup']['dateformat']));

    return $paramList;
}

function DC_GetStoreID (ACF_ParameterList $inParameterList) {
    $paramList = new ACF_ParameterList();
    $paramList->AddParameter(new ACF_DirectParameter('storeid',$_SESSION['signup']['storeid']));

    return $paramList;
}

function DC_GetPOPChkVal (ACF_ParameterList $inParameterList) {
    $popvalue = strtoupper(GetWebOption('popvalue',$_SESSION['signup']['storeid']));

    $paramList = new ACF_ParameterList();
    $paramList->AddParameter(new ACF_DirectParameter('popvalue',$popvalue));

    return $paramList;
}

function DC_GetPaymentTypes (ACF_ParameterList $inParameterList) {
    $paymenttypes = array();

    // *********************************
    //--- Check to see if ACH is allowed
    // *********************************

    if(strtolower(GetWebOption('acceptach',$_SESSION['signup']['storeid'])) == 'y')
        $paymenttypes['ach'] = 'Direct Debit (ACH)';
    //--- THE FAILURE SHOULD BE LOGGED BUT SHOULD CONTINUE (JCW NEEDS TO ADD LOGGING SCHEME)

    // ***********************************
    //--- Check to see if Check is allowed
    // ***********************************
    if(strtolower(GetWebOption('acceptck',$_SESSION['signup']['storeid'])) == 'y')
        $paymenttypes['check'] = 'Check';
    //--- THE FAILURE SHOULD BE LOGGED BUT SHOULD CONTINUE (JCW NEEDS TO ADD LOGGING SCHEME)

    // ********************************
    //--- Check to see if CC is allowed
    // ********************************
    if(strtolower(GetWebOption('acceptcc',$_SESSION['signup']['storeid'])) == 'y')
        $paymenttypes['ccard'] = 'Credit Card';
    //--- THE FAILURE SHOULD BE LOGGED BUT SHOULD CONTINUE (JCW NEEDS TO ADD LOGGING SCHEME)

    $paramList = new ACF_ParameterList();
    $paramList->AddParameter(new ACF_DirectParameter('paytypes',$paymenttypes));
    $paramList->AddParameter(new ACF_DirectParameter('default_paymenttype',GetWebOption('default_billingmeth',$_SESSION['signup']['storeid'])));

    return $paramList;
}

function DC_GetPaymentType (ACF_ParameterList $inParameterList) {
    $paramList = new ACF_ParameterList();
    $paramList->AddParameter(new ACF_DirectParameter('paymenttype',$_SESSION['signup']['newcustomer']['info']['paymenttype']));

    return $paramList;
}

function DC_GetCustomerInfo (ACF_ParameterList $inParameterList) {
    $paramList = new ACF_ParameterList();
    $paramList->AddParameter(new ACF_DirectParameter('customer',$_SESSION['signup']['newcustomer']));

    return $paramList;
}

function DC_GetGSTInfo (ACF_ParameterList $inParameterList) {
	$paramList = new ACF_ParameterList();
	if($_SESSION['GST']) {
		$paramList->AddParameter(new ACF_DirectParameter('gstinfo',$_SESSION['GST']));
	}

	return $paramList;
}

function DC_GetPaymentInfo (ACF_ParameterList $inParameterList) {
    $_SESSION['signup']['newcustomer']['paymentinfo']['cvv2Required'] = strtoupper(GetWebOption('show_card_sec_code',$_SESSION['signup']['storeid']));
    $paramList = new ACF_ParameterList();
    $paramList->AddParameter(new ACF_DirectParameter('payment',$_SESSION['signup']['newcustomer']['paymentinfo']));

    return $paramList;
}

function DC_GetAffinities (ACF_ParameterList $inParameterList) {
    $paramList = new ACF_ParameterList();
    $paramList->AddParameter(new ACF_DirectParameter('affinities',$_SESSION['signup']['affinitylist']));

    return $paramList;
}

function DC_GetRates (ACF_ParameterList $inParameterList) {
    $rates = array();
    $displayRates = "N";
    if(isset($_SESSION['signup']['regrates']) && is_array($_SESSION['signup']['regrates'])) {
        foreach($_SESSION['signup']['regrates'] as $thisPlan) {
            $rates[$thisPlan['id']]['name'] = $thisPlan['name'];
            $displayRates = $thisPlan['reg_displayrates'];
        }
    } else {
        $ratelist = GetAvailableWebRates();

        if(isset($ratelist) && is_array($ratelist)) {
            foreach($ratelist as $thisRate) {
                $rates[$thisRate['rg_id'].'X'.$thisRate['r_frequency']]['name'] = $thisRate['rg_name'].' - '.$thisRate['r_frequency'].' month'.($thisRate['r_frequency'] != 1 ? 's' : '');
                $rates[$thisRate['rg_id'].'X'.$thisRate['r_frequency']]['price'] = ShowMoney($thisRate['rg_fixed_price']);
                $rates[$thisRate['rg_id'].'X'.$thisRate['r_frequency']]['setupfees'] = ShowMoney($thisRate['rg_one_time_fees']);
				$rates[$thisRate['rg_id'].'X'.$thisRate['r_frequency']]['description'] = $thisRate['rg_description'];
				$rates[$thisRate['rg_id'].'X'.$thisRate['r_frequency']]['ccs_svc_id'] = $thisRate['rg_ccs_svc_id'];
				$rates[$thisRate['rg_id'].'X'.$thisRate['r_frequency']]['ccs_service'] = $thisRate['svc_ccs_service'];
				$rates[$thisRate['rg_id'].'X'.$thisRate['r_frequency']]['r_frequency'] = $thisRate['r_frequency'];
				$rates[$thisRate['rg_id'].'X'.$thisRate['r_frequency']]['id'] = $thisRate['rg_id'];
				$rates[$thisRate['rg_id'].'X'.$thisRate['r_frequency']]['frequency'] = $thisRate['r_frequency'].' month'.($thisRate['r_frequency'] != 1 ? 's' : '');
				$rates[$thisRate['rg_id'].'X'.$thisRate['r_frequency']]['rg_name'] = $thisRate['rg_name'];
            }
        }
        $displayRates = GetWebOption('displayrates',$_SESSION['signup']['storeid']);
    }
    $parameterList = new ACF_ParameterList();
    $parameterList->AddParameter(new ACF_DirectParameter('rates',$rates));
    if(!$_SESSION['signup']['options']['rate']) {
        $parameterList->AddParameter(new ACF_DirectParameter('displayrates',$displayRates));
    } else {
        $parameterList->AddParameter(new ACF_DirectParameter('displayrates','N'));
    }

    return $parameterList;
}

function DC_GetBlockRates (ACF_ParameterList $inParameterList) {
    $blockrates = array();
    $displayBlock = "N";
    if(isset($_SESSION['signup']['regblock']) && is_array($_SESSION['signup']['regblock'])) {
        foreach($_SESSION['signup']['regblock'] as $thisPlan) {
            $blockrates[$thisPlan['id']]['name'] = $thisPlan['name'];
            $displayBlock = $thisPlan['reg_displayblock'];
        }
    } else {
        $blockratelist = GetBlockRates(true);

        if(isset($blockratelist) && is_array($blockratelist)) {
            foreach($blockratelist as $blockrate) {
                $blockrates[$blockrate['id']]['name'] = $blockrate['name'];
                $blockrates[$blockrate['id']]['timelimit'] = $blockrate['timelimit'];
                $blockrates[$blockrate['id']]['uom'] = $blockrate['uom'];
                $blockrates[$blockrate['id']]['price'] = $blockrate['price'];
            }
        }
        $displayBlock = GetWebOption('displayblock',$_SESSION['signup']['storeid']);
    }

    $parameterList = new ACF_ParameterList();
    $parameterList->AddParameter(new ACF_DirectParameter('blockrates',$blockrates));
    $parameterList->AddParameter(new ACF_DirectParameter('displayblock',$displayBlock));

    return $parameterList;
}

function DC_GetCCInfo (ACF_ParameterList $inParameterList) {
    $ccinfo = array();
    $ccinfo['ccyear'] = array();
    $ccinfo['ccmonth'] = array();

    $paymentTypes = GetPaymentTypes(true);

    if(isset($paymentTypes) && is_array($paymentTypes)) {
        foreach($paymentTypes as $thisType) {
            $ccinfo['cctypes'][$thisType['p_id']] = $thisType['p_name'];
        }
    }

    for($expyear=date("Y");$expyear<date("Y")+10;$expyear++)
        array_push($ccinfo['ccyear'],$expyear);

    for($expmonth=1;$expmonth<=12;$expmonth++)
        array_push($ccinfo['ccmonth'],$expmonth);

    $paramList = new ACF_ParameterList();
    $paramList->AddParameter(new ACF_DirectParameter('ccinfo',$ccinfo));

    return $paramList;
}

function DC_GetPOPLocations (ACF_ParameterList $inParameterList) {
    $paramList = new ACF_ParameterList();
    $paramList->AddParameter(new ACF_DirectParameter('matchvalue',$_SESSION['signup']['matchvalue']));
    if(!$_SESSION['signup']['poplistSet'] || $inParameterList->ParameterValue('error')) { // if the activity handler is bypassed and the select POP page is still loaded, the POPlist should be made here
        $_SESSION['signup']['poplist'] = GetAvailablePOPs();
	$_SESSION['signup']['poplistSet'] = true;
        $paramList->AddParameter(new ACF_DirectParameter('poplist',$_SESSION['signup']['poplist']));
    }

    return $paramList;
}

function DC_GetExtraFields (ACF_ParameterList $inParameterList) {
    $paramList = new ACF_ParameterList();
    $paramList->AddParameter(new ACF_DirectParameter('extrafields',$_SESSION['signup']['extrafields']));

    return $paramList;
}

function DC_CheckINSOptions(ACF_ParameterList $inParameterList) {
    if(strtolower(GetWebOption('insenable',$_SESSION['signup']['storeid'])) == 'y') { // Create INS file if enabled
        if(strtolower(GetWebOption('autodlins',$_SESSION['signup']['storeid'])) == 'y') {
            $insData['refresh']  = true;
        } else {
            $insData['refresh']  = false;
        }

        $insData['linktext'] = GetWebOption('inslinktext',$_SESSION['signup']['storeid']);
    } else {
        $insData = false;
    }

    $paramList = new ACF_ParameterList();
    $paramList->AddParameter(new ACF_DirectParameter('insdata',$insData));

    return $paramList;
}

function DC_GenerateINS(ACF_ParameterList $inParameterList) {
    $insfile_Return = CreateINSFile();

    if($insfile_Return['success']) {
        $paramList = new ACF_ParameterList();
        $paramList->AddParameter(new ACF_DirectParameter('filedata',$insfile_Return['filedata']));
        $paramList->AddParameter(new ACF_DirectParameter('filename',$insfile_Return['filename']));

        return $paramList;
    }
}

function DC_SuggestUsername (ACF_ParameterList $inParameterList) {
    if(!$_SESSION['signup']['username'] && $_SESSION['signup']['customer']['name']) { // username hasn't been set and customer's name has, so suggest away...
        $unamefmt = ExecuteSQL("select value from options where name = 'Username Format'");
        if(!strpos($unamefmt[0]['value'],'9')) { // if the format strictly specifies a number, then don't suggest any usernames
            if(!strpos($unamefmt[0]['value'],'['))
                $maxlength = strlen($unamefmt[0]['value']);
            else
                $maxlength = strlen($unamefmt[0]['value'])-2;

            $name = $_SESSION['signup']['customer']['name'];

            $spaceinname = strpos($name,' ');

            if(!$spaceinname) {
                $firstname = $name;
                $lastname = "";
            } else {
                $firstname = substr($name,0,$spaceinname);
                $lastname = substr($name,$spaceinname+1,strlen($name)-($spaceinname+1));
            }
            if(strtolower(GetWebOption('suggest1',$_SESSION['signup']['storeid'])) == 'y') { // first initial plus last name for username
                $suggestion = strtolower(substr($firstname,0,1).$lastname);
                $usernamecheck = ExecuteSQL("select id from customer where username = '".SQLTrim($suggestion)."'");
                $emailnamecheck = ExecuteSQL("select data_id from email_data where username = '".SQLTrim($suggestion)."'");
                if(isset($usernamecheck[0]['id']) || isset($emailnamecheck[0]['data_id']) || strlen($suggestion) > $maxlength) // this username is taken or it's too long
                    unset($suggestion);
            }
            if(strtolower(GetWebOption('suggest2',$_SESSION['signup']['storeid'])) == 'y' && !$suggestion) { // first name plus last initial for username
                $suggestion = strtolower($firstname.substr($lastname,0,1));
                $usernamecheck = ExecuteSQL("select id from customer where username = '".SQLTrim($suggestion)."'");
                $emailnamecheck = ExecuteSQL("select data_id from email_data where username = '".SQLTrim($suggestion)."'");
                if(isset($usernamecheck[0]['id']) || isset($emailnamecheck[0]['data_id']) || strlen($suggestion) > $maxlength) // this username is taken or it's too long
                    unset($suggestion);
            }
            if(strtolower(GetWebOption('suggest3',$_SESSION['signup']['storeid'])) == 'y' && !$suggestion) { // first name plus last initial plus number for username
                for($i = 1;$i < 100;$i++) {
                    $suggestion = strtolower($firstname.substr($lastname,0,1).$i);
                    $usernamecheck = ExecuteSQL("select id from customer where username = '".SQLTrim($suggestion)."'");
                    $emailnamecheck = ExecuteSQL("select data_id from email_data where username = '".SQLTrim($suggestion)."'");
                    if(isset($usernamecheck[0]['id']) || isset($emailnamecheck[0]['data_id']) || strlen($suggestion) > $maxlength) // this username is taken or it's too long
                        unset($suggestion);
                    else
                        $i = 100; // set $i to the break point, so it drops out with the good username
                }
            }
        }
    }

    $paramList = new ACF_ParameterList();
    $paramList->AddParameter(new ACF_DirectParameter('suggestion',$suggestion));

    return $paramList;
}

function DC_GetShellTypes (ACF_ParameterList $inParameterList) {
    $paramList = new ACF_ParameterList();

    if(strtoupper(GetWebOption('showshell',$_SESSION['signup']['storeid'])) == 'Y') {
	$shells = array();
        $sqlresults = ExecuteSQL('select value, display from shelltypes');
	if(isset($sqlresults) && is_array($sqlresults))
	    foreach($sqlresults as $sqlrow)
	        $shells[$sqlrow['value']] = $sqlrow['display'];

	$paramList->AddParameter(new ACF_DirectParameter('shells',$shells));
        $paramList->AddParameter(new ACF_DirectParameter('show_shell','Y'));
    } else {
	$paramList->AddParameter(new ACF_DirectParameter('shells',false));
        $paramList->AddParameter(new ACF_DirectParameter('show_shell','N'));
    }

    $paramList->AddParameter(new ACF_DirectParameter('default_shell',GetWebOption('defaultshell',$_SESSION['signup']['storeid'])));
    return $paramList;
}

function DC_GetSalespeople (ACF_ParameterList $inParameterList) {
    $paramList = new ACF_ParameterList();
    $salesoptions = array();

    if(strtoupper(GetWebOption('showsales',$_SESSION['signup']['storeid'])) == 'Y') {
	$salespeople = array();
	$sqlString = "select num, name from staff where position <> 1";
	if($_SESSION['signup']['storeid'])
            $sqlString .= " and (num in (select cr_typeid from companyrelationship where cr_type = 'Staff' and cr_companyid = ".((integer)$_SESSION['signup']['storeid']).") or num not in (select cr_typeid from companyrelationship where cr_type = 'Staff'))";

	$sqlresults = ExecuteSQL($sqlString);

        if(isset($sqlresults) && is_array($sqlresults))
	    foreach($sqlresults as $sqlrow)
	        $salespeople[$sqlrow['num']] = $sqlrow['name'];

	$paramList->AddParameter(new ACF_DirectParameter('salespeople',$salespeople));
	$salesoptions['showsales'] = 'Y';
        $salesoptions['sales_required'] = GetWebOption('salesrequired',$_SESSION['signup']['storeid']);
    } else {
	$paramList->AddParameter(new ACF_DirectParameter('salespeople',false));
	$salesoptions['showsales'] = 'N';
	$salesoptions['sales_required'] = 'N';
    }

    $salesoptions['default_salesperson'] = GetWebOption('defaultsales',$_SESSION['signup']['storeid']);
    $salesoptions['showreferral'] = GetWebOption('showreferral',$_SESSION['signup']['storeid']);
    $salesoptions['referralvalue'] = GetWebOption('referralvalue',$_SESSION['signup']['storeid']);

    $paramList->AddParameter(new ACF_DirectParameter('salesoptions',$salesoptions));
    return $paramList;
}

function DC_GetReferralInfo (ACF_ParameterList $inParameterList) {
    $paramList = new ACF_ParameterList();
    $paramList->AddParameter(new ACF_DirectParameter('referraltype',GetWebOption('referralvalue',$_SESSION['signup']['storeid'])));
    return $paramList;
}

function DC_GetPOPData (ACF_ParameterList $inParameterList) {
    $popdata = array();
    $popdata['cities'] = array();
    $popdata['states'] = array();
    $popdata['areacodes'] = array();

    if($_SESSION['signup']['popForceSelect']) {
	$popdata['inputtype'] = 'SELECT';
	$_SESSION['signup']['popForceSelect'] = false;
    }
    if($_SESSION['signup']['popForceType']) {
	$popdata['inputtype'] = 'TYPE';
        $_SESSION['signup']['popForceType'] = false;
    }

    if(!$popdata['inputtype']) {
        $popdata['inputtype'] = strtoupper(GetWebOption('popinputtype',$_SESSION['signup']['storeid']));
    }
    //--- THE FAILURE SHOULD BE LOGGED BUT SHOULD CONTINUE (JCW NEEDS TO ADD LOGGING SCHEME)

    // *************************
    //--- Getting cities from DB
    // *************************
    $sqlresults = ExecuteSQL("select distinct pop_city from pop where pop_active = 'Y'");
    if(isset($sqlresults) && is_array($sqlresults))
        foreach($sqlresults as $sqlrow)
            array_push($popdata['cities'],$sqlrow['pop_city']);

    // *************************
    //--- Getting states from DB
    // *************************
    $sqlresults = ExecuteSQL("select distinct pop_state from pop where pop_active = 'Y'");
    if(isset($sqlresults) && is_array($sqlresults))
        foreach($sqlresults as $sqlrow)
            array_push($popdata['states'],strtoupper($sqlrow['pop_state']));

    // *****************************************************
    //--- Getting area codes from DB (using same WOW method)
    // *****************************************************
    $sqlresults = ExecuteSQL("select distinct pop_areacode = substring(pop_number,1,3) from pop where pop_active = 'Y'");
    if(isset($sqlresults) && is_array($sqlresults))
        foreach($sqlresults as $sqlrow)
            array_push($popdata['areacodes'],$sqlrow['pop_areacode']);

    $paramList = new ACF_ParameterList();
    $paramList->AddParameter(new ACF_DirectParameter('popdata',$popdata));

    return $paramList;
}

function DC_GetConfirmationData (ACF_ParameterList $inParameterList) {
    // support for current version of confirmation.htm
    if(isset($_SESSION['signup']['newcustomer']['rate']['detail']) && is_array($_SESSION['signup']['newcustomer']['rate']['detail'])) {
	foreach($_SESSION['signup']['newcustomer']['rate']['detail'] as &$thisRate) {
	    $thisRate['name'] = $thisRate['rg_name'];
	    $thisRate['id'] = $thisRate['rg_id'];
	    $thisRate['rg_frequency'] = $thisRate['r_frequency'];
	}
    }

    $paramList = new ACF_ParameterList();
    $paramList->AddParameter(new ACF_DirectParameter('custdata',$_SESSION['signup']));

    return $paramList;
}

function DC_GetStatesList (ACF_ParameterList $inParameterList) {
    if (file_exists('../../etc/plat_config.xml')) {
        $xml = simplexml_load_file('../../etc/plat_config.xml');
        $indexname = 'state-list';
        $statelist = (string) $xml->$indexname;
        if($statelist) {
            if (file_exists($statelist)) {
                $statexml = simplexml_load_file($statelist);
                $states = array();
                if($statexml)
                    foreach($statexml as $state)
                        $states[(string) $state->code] = (string) $state->name;
            }
        }
    }

    if (!$states) {
        $states = array(
            "AL" => "Alabama",
            "AK" => "Alaska",
            "AS" => "American Samoa",
            "AB" => "Alberta",
            "AZ" => "Arizona",
            "AR" => "Arkansas",
            "BC" => "British Columbia",
            "CA" => "California",
            "CO" => "Colorado",
            "CT" => "Connecticut",
            "DE" => "Deleware",
            "DC" => "District of Columbia",
            "FM" => "Federated States of Micronesia",
            "FL" => "Florida",
            "GA" => "Georgia",
            "GU" => "Guam",
            "HI" => "Hawaii",
            "ID" => "Idaho",
            "IL" => "Illinois",
            "IN" => "Indiana",
            "IA" => "Iowa",
            "KS" => "Kansas",
            "KY" => "Kentucky",
            "LA" => "Louisiana",
            "ME" => "Maine",
            "MB" => "Manitoba",
            "MH" => "Marshall Islands",
            "MD" => "Maryland",
            "MA" => "Massachusetts",
            "MI" => "Michigan",
            "MN" => "Minnesota",
            "MS" => "Mississippi",
            "MO" => "Missouri",
            "MT" => "Montana",
            "NE" => "Nebraska",
            "NV" => "Nevada",
            "NB" => "New Brunswick",
            "NH" => "New Hampshire",
            "NJ" => "New Jersey",
            "NM" => "New Mexico",
            "NY" => "New York",
            "NL" => "Newfoundland and Labrador",
            "NC" => "North Carolina",
            "ND" => "North Dakota",
            "MP" => "Northern Mariana Islands",
            "NT" => "Northwest Territories",
            "NS" => "Nova Scotia",
            "NU" => "Nunavut",
            "OH" => "Ohio",
            "OK" => "Oklahoma",
            "ON" => "Ontario",
            "OR" => "Oregon",
            "PW" => "Palau",
            "PA" => "Pennsylvania",
            "PE" => "Prince Edward Island",
            "PR" => "Puerto Rico",
            "QC" => "Quebec",
            "RI" => "Rhode Island",
            "SK" => "Saskatchewan",
            "SC" => "South Carolina",
            "SD" => "South Dakota",
            "TN" => "Tennessee",
            "TX" => "Texas",
            "UT" => "Utah",
            "VT" => "Vermont",
            "VI" => "Virgin Islands",
            "VA" => "Virginia",
            "WA" => "Washington",
            "WV" => "West Virginia",
            "WI" => "Wisconsin",
            "WY" => "Wyoming",
            "YT" => "Yukon"
        );
    }
    $paramList = new ACF_ParameterList();
    $paramList->AddParameter(new ACF_DirectParameter('states',$states));

    return $paramList;
}

function DC_GetCountriesList(ACF_ParameterList $inParameterList) {
    if (file_exists('../../etc/plat_config.xml')) {
        $xml = simplexml_load_file('../../etc/plat_config.xml');
        $indexname = 'country-list';
        $countrylist = (string) $xml->$indexname;
        if($countrylist) {
            if (file_exists($countrylist)) {
                $countryxml = simplexml_load_file($countrylist);
                $countries = array();
                if($countryxml)
                    foreach($countryxml as $country)
                        $countries[(string) $country->code] = (string) $country->name;
            }
        }
    }

    if (!$countries) {
        $countries = array(
            "US" => "United States of America",
            "CA" => "Canada",
            "AF" => "Afghanistan",
            "AL" => "Albania",
            "DZ" => "Algeria",
            "AS" => "American Samoa",
            "AD" => "Andorra",
            "AI" => "Anguilla",
            "AQ" => "Antarctica",
            "AG" => "Antigua And Barbuda",
            "AR" => "Argentina",
            "AM" => "Armenia",
            "AW" => "Aruba",
            "AU" => "Australia",
            "AT" => "Austria",
            "AZ" => "Azerbaijan",
            "BS" => "Bahamas",
            "BH" => "Bahrain",
            "BD" => "Bangladesh",
            "BB" => "Barbados",
            "BY" => "Belarus",
            "BE" => "Belgium",
            "BZ" => "Belize",
            "BJ" => "Benin",
            "BM" => "Bermuda",
            "BT" => "Bhutan",
            "BO" => "Bolivia",
            "BA" => "Bosnia And Herzegowina",
            "BW" => "Botswana",
            "BV" => "Bouvet Island",
            "BR" => "Brazil",
            "IO" => "British Indian Ocean Territory",
            "BN" => "Brunei Darussalam",
            "BG" => "Bulgaria",
            "BF" => "Burkina Faso",
            "BI" => "Burundi",
            "KH" => "Cambodia",
            "CM" => "Cameroon",
            "CV" => "Cape Verde",
            "KY" => "Cayman Islands",
            "CF" => "Central African Republic",
            "TD" => "Chad",
            "CL" => "Chile",
            "CN" => "China",
            "CX" => "Christmas Island",
            "CC" => "Cocos (Keeling) Islands",
            "CO" => "Colombia",
            "KM" => "Comoros",
            "CG" => "Congo",
            "CK" => "Cook Islands",
            "CR" => "Costa Rica",
            "CI" => "Cote D'ivoire",
            "HR" => "Croatia",
            "CY" => "Cyprus",
            "CZ" => "Czech Republic",
            "DK" => "Denmark",
            "DJ" => "Djibouti",
            "DM" => "Dominica",
            "DO" => "Dominican Republic",
            "TP" => "East Timor",
            "EC" => "Ecuador",
            "EG" => "Egypt",
            "SV" => "El Salvador",
            "GQ" => "Equatorial Guinea",
            "ER" => "Eritrea",
            "EE" => "Estonia",
            "ET" => "Ethiopia",
            "FK" => "Falkland Islands",
            "FO" => "Faroe Islands",
            "FJ" => "Fiji",
            "FI" => "Finland",
            "FR" => "France",
            "GF" => "French Guiana",
            "PF" => "French Polynesia",
            "TF" => "French Southern Territories",
            "GA" => "Gabon",
            "GM" => "Gambia",
            "GE" => "Georgia",
            "DE" => "Germany",
            "GH" => "Ghana",
            "GI" => "Gibraltar",
            "GR" => "Greece",
            "GL" => "Greenland",
            "GD" => "Grenada",
            "GP" => "Guadeloupe",
            "GU" => "Guam",
            "GT" => "Guatemala",
            "GN" => "Guinea",
            "GW" => "Guinea-Bissau",
            "GY" => "Guyana",
            "HT" => "Haiti",
            "HM" => "Heard And Mcdonald Islands",
            "HN" => "Honduras",
            "HK" => "Hong Kong",
            "HU" => "Hungary",
            "IS" => "Iceland",
            "IN" => "India",
            "ID" => "Indonesia",
            "IE" => "Ireland",
            "IL" => "Israel",
            "IT" => "Italy",
            "JM" => "Jamaica",
            "JP" => "Japan",
            "JO" => "Jordan",
            "KZ" => "Kazakstan",
            "KE" => "Kenya",
            "KI" => "Kiribati",
            "KR" => "Korea, Republic Of (South)",
            "KW" => "Kuwait",
            "KG" => "Kyrgyzstan",
            "LA" => "Lao People's Democratic Republic",
            "LV" => "Latvia",
            "LB" => "Lebanon",
            "LS" => "Lesotho",
            "LR" => "Liberia",
            "LI" => "Liechtenstein",
            "LT" => "Lithuania",
            "LU" => "Luxembourg",
            "MO" => "Macau",
            "MK" => "Macedonia",
            "MG" => "Madagascar",
            "MW" => "Malawi",
            "MY" => "Malaysia",
            "MV" => "Maldives",
            "ML" => "Mali",
            "MT" => "Malta",
            "MH" => "Marshall Islands",
            "MQ" => "Martinique",
            "MR" => "Mauritania",
            "MU" => "Mauritius",
            "YT" => "Mayotte",
            "MX" => "Mexico",
            "FM" => "Micronesia",
            "MD" => "Moldova, Republic Of",
            "MC" => "Monaco",
            "MN" => "Mongolia",
            "MS" => "Montserrat",
            "MA" => "Morocco",
            "MZ" => "Mozambique",
            "NA" => "Namibia",
            "NR" => "Nauru",
            "NP" => "Nepal",
            "NL" => "Netherlands",
            "AN" => "Netherlands Antilles",
            "NC" => "New Caledonia",
            "NZ" => "New Zealand",
            "NI" => "Nicaragua",
            "NE" => "Niger",
            "NG" => "Nigeria",
            "NU" => "Niue",
            "NF" => "Norfolk Island",
            "MP" => "Northern Mariana Islands",
            "NO" => "Norway",
            "OM" => "Oman",
            "PK" => "Pakistan",
            "PW" => "Palau",
            "PA" => "Panama",
            "PG" => "Papua New Guinea",
            "PY" => "Paraguay",
            "PE" => "Peru",
            "PH" => "Philippines",
            "PN" => "Pitcairn",
            "PL" => "Poland",
            "PT" => "Portugal",
            "PR" => "Puerto Rico",
            "QA" => "Qatar",
            "RE" => "Reunion",
            "RO" => "Romania",
            "RU" => "Russian Federation",
            "RW" => "Rwanda",
            "SH" => "Saint Helena",
            "KN" => "Saint Kitts And Nevis",
            "LC" => "Saint Lucia",
            "PM" => "Saint Pierre And Miquelon",
            "VC" => "Saint Vincent And The Grenadines",
            "WS" => "Samoa",
            "SM" => "San Marino",
            "ST" => "Sao Tome And Principe",
            "SA" => "Saudi Arabia",
            "SN" => "Senegal",
            "SC" => "Seychelles",
            "SL" => "Sierra Leone",
            "SG" => "Singapore",
            "SK" => "Slovakia",
            "SI" => "Slovenia",
            "SB" => "Solomon Islands",
            "SO" => "Somalia",
            "ZA" => "South Africa",
            "ES" => "Spain",
            "LK" => "Sri Lanka",
            "SR" => "Suriname",
            "SJ" => "Svalbard And Jan Mayen",
            "SZ" => "Swaziland",
            "SE" => "Sweden",
            "CH" => "Switzerland",
            "TW" => "Taiwan",
            "TJ" => "Tajikistan",
            "TZ" => "Tanzania",
            "TH" => "Thailand",
            "TG" => "Togo",
            "TK" => "Tokelau",
            "TO" => "Tonga",
            "TT" => "Trinidad And Tobago",
            "TN" => "Tunisia",
            "TR" => "Turkey",
            "TM" => "Turkmenistan",
            "TC" => "Turks And Caicos Islands",
            "TV" => "Tuvalu",
            "UG" => "Uganda",
            "UA" => "Ukraine",
            "AE" => "United Arab Emirates",
            "GB" => "United Kingdom",
            "UM" => "United States Minor Outlying Islands",
            "UY" => "Uruguay",
            "UZ" => "Uzbekistan",
            "VU" => "Vanuatu",
            "VA" => "Vatican City State (Holy See)",
            "VE" => "Venezuela",
            "VN" => "Viet Nam",
            "VG" => "Virgin Islands, (British)",
            "VI" => "Virgin Islands, (U.S.)",
            "WF" => "Wallis And Futuna",
            "EH" => "Western Sahara",
            "YE" => "Yemen",
            "YU" => "Yugoslavia",
            "ZM" => "Zambia",
            "ZW" => "Zimbabwe"
        );
    }

    $parameterList = new ACF_ParameterList();
    $parameterList->AddParameter(new ACF_DirectParameter('countries',$countries));
    $parameterList->AddParameter(new ACF_DirectParameter('display_country',strtoupper(GetWebOption('display_country',$_SESSION['signup']['storeid']))));
    $parameterList->AddParameter(new ACF_DirectParameter('default_country',strtoupper(GetWebOption('default_country',$_SESSION['signup']['storeid']))));

    return $parameterList;
}

?>
