<?php

$projectname = 'Platsignup';
$receiver    = basename(__FILE__);

include '../../etc/config.php';
include '../../libs/codecs/apachedecoder.inc.php';
include '../../libs/codecs/apachefileencoder.inc.php';
include '../../etc/receiver_config.php';

// Resume the session or start a new one
if(isset($_GET['NEWSESSION'])) {	// URL flag to start a new session.  Helps with testing.
	session_start();
	session_destroy();
	$_SESSION = array();
} else {
}

if(!session_id())
	session_start();

if(isset($_SESSION['controller']) && $_SESSION['ACF_ActiveProject'] === $projectname)
	$controller = $_SESSION['controller'];

$_SESSION['ACF_ActiveProject'] = $projectname;

$layers = Receiver_GetLayers($projectname,$receiver);

try {	// Create or refresh controller and connection to database
	$Persistence = Receiver_GetPersistence($projectname);
	if(!isset($controller)) {
		if($Persistence['type'] == "adodb") {
		    $db = new ACF_DB($Persistence['dboptions']['server'], $Persistence['dboptions']['dbname'], $Persistence['dboptions']['username'], $Persistence['dboptions']['password']);
		    $controller = new ACF_ControllerADODB(true, $db, $layers);
		} else {
			$controller = new ACF_ControllerXML(true, $layers);
			$controller->SetProjectPath($Persistence['dir']);
			$controller->LoadFramework();
		}

		$controller->EnableStackHistory(true);	/********************* Debugging ****************** */
		$_SESSION['controller'] = $controller;
	} else if($Persistence['type'] == "adodb") {
		$db = new ACF_DB($Persistence['dboptions']['server'], $Persistence['dboptions']['dbname'], $Persistence['dboptions']['username'], $Persistence['dboptions']['password']);
		$controller->SetDB($db);	// Necessary because db connections do not persist in sessions
	}
} catch(Exception $e) {
	ErrorExit('errors/nodatabase', $e, $layers);
}


try {	// Decode the request
	$request = decoder();
} catch(Exception $e) {
	ErrorExit('error', $e, $layers);
}

try {	// Process the request
	$viewInvocation = $controller->Process($request);
} catch(Exception $e) {
	ErrorExit('error', $e, $layers);
}

/******/
//Debugging
	$viewInvocation->parameterList()->AddParameter(new ACF_DirectParameter('stack',$controller->StackString()));
	$viewInvocation->parameterList()->AddParameter(new ACF_DirectParameter('stackhistory',$controller->StackHistoryString()));
/************/
encoder($viewInvocation, $layers);

function ErrorExit($name, ACF_Exception $e, $layers)
{
	global $controller;

	$parameterList = new ACF_ParameterList();
	$parameterList->AddParameter(new ACF_DirectParameter('message', $e->GetMessage()));
	$parameterList->AddParameter(new ACF_DirectParameter('stack',$controller->StackString()));
	$parameterList->AddParameter(new ACF_DirectParameter('stackhistory',$controller->StackHistoryString()));
	$invocation = new ACF_ViewInvocation($name, $parameterList);
	encoder($invocation, $layers);
	SaveExceptionAndExit($e);
}
?>
