<?php
require_once('../../libs/platypus/wow.inc.php');

$stafflogin = $_SESSION['wow']['staffname'];
$staffpass  = $_SESSION['wow']['staffpass'];

global $wow;

$wow = new WOW_Request();

$wow->setUsername($stafflogin);
$wow->setPassword($staffpass);

function SetStaffLogin() {
    global $wow;

    $stafflogin = $_SESSION['wow']['staffname'];
    $staffpass  = $_SESSION['wow']['staffpass'];

    $wow->setUsername($stafflogin);
    $wow->setPassword($staffpass);

    $loginData = Login($stafflogin,$staffpass,'staff');
    $_SESSION['signup']['staffid'] = $loginData['id'];
}

function GetStaffNames() {
    global $wow;

    $wow->setMethod('GetStaffLogins');
    $wow->addAttribute('logintype','staff');

    $wow->addParameter('datatype','XML');

    if($wow->execute()) {
	    if(is_array($wow->getAttributesArray())) {
        foreach($wow->getAttributesArray() as $thisStaff) {
            $staffList[$thisStaff['num']] = $thisStaff['name'];
	}
        }
        return $staffList;
    } else {
        return false;
    }
}

function GetDateFormat() {
    global $wow;

    $wow->setMethod('GetDateFormat');
    $wow->addAttribute('logintype','staff');

    $wow->addParameter('datatype','XML');

    if($wow->execute())
        $_SESSION['signup']['dateformat'] = $wow->getAttribute(0,'dateformat');
}

function CreateBonus($crid,$bonusid,$type,$custid) {
    global $wow;

    $wow->setMethod('CreateBonus');
    $wow->addAttribute('logintype','staff');

    $wow->addParameter('crid',$crid);
    $wow->addParameter('doconn',true,'boolean');
    $wow->addParameter('getdefaults',true,'boolean');
    $wow->addParameter('datatype','XML');

    if($type == 'referral')
        $wow->addProperty('refid',$bonusid,'int');
    if($type == 'sales')
        $wow->addProperty('salesid',$bonusid,'int');
    $wow->addProperty('custid',$custid);

    if($wow->execute()) {
        return true;
    } else {
        return false;
    }
}

function Login($username,$password,$type) {
    global $wow;

    $wow->setMethod('Login');
    $wow->addAttribute('logintype','staff');

    $wow->addParameter('logintype',$type);
    $wow->addParameter('username',$username);
    $wow->addParameter('password',$password);
    $wow->addParameter('datatype','XML');
    $wow->addParameter('allowedactive',"'Y','H','S'");

    if($wow->execute()) {
        return $wow->getAttribute(0);
    } else {
        return false;
    }
}

function GetWebOption ($optionname,$storeid = false) {
    global $wow;

    $wow->setMethod('GetWebOption');
    $wow->addAttribute('logintype','staff');

    //--- Set Parameters
    $wow->addParameter('option_name',$optionname);
    $wow->addParameter('storeappended',false,'boolean');
    $wow->addParameter('datatype','XML');

    if($storeid)
        $wow->addProperty('storeid',$storeid,'integer');
    else
	$wow->addProperty('storeid',false,'boolean');
    if($wow->execute()) {
        return $wow->getAttribute(0,$optionname);
    } else {
	return false;
    }
}

function ExecuteSQL ($query) {
    global $wow;

    $wow->setMethod('SQL');
    $wow->addAttribute('logintype','staff');

    //--- Set Parameters
    $wow->addParameter('query',$query);
    $wow->addParameter('noconn',false,'boolean');
    $wow->addParameter('datatype','XML');

    if($wow->execute()) {
        if(substr($query,0,6) == 'select') {
            return $wow->getAttributesArray();
	} else {
            return true;
	}
    } else {
        $_SESSION['signup']['error'] = $wow->lastError;
        return false;
    }
}

function SQLTrim ($instring) {
    if(!$instring)
        return "";
    if(!is_string($instring))
	return $instring;

    $instring = str_replace("&apos;","'",$instring);

    $outstring = "";
    while ($instring != $outstring) {
	$outstring = $instring;
	$instring = trim(str_replace("''","'",$instring));
    }

    return trim(str_replace("'","''",$instring));
}

function LogError($funcname,$errmsg) {
    if(!$_SESSION['signup']['lastError'])
        $_SESSION['signup']['lastError'] = $funcname.":".$errmsg."<BR>";
    else
        $_SESSION['signup']['lastError'] .= $funcname.":".$errmsg."<BR>";
}

function GetAvailablePOPs($matchvalue = false) {
    global $wow;

    $wow->setMethod('GetAvailablePOPs');
    $wow->addAttribute('logintype','staff');

    $wow->addParameter('datatype','XML');
    $wow->addParameter('custid',0,'string');
    $wow->addParameter('matchvalue',$matchvalue,$matchvalue ? 'string' : 'boolean');

    if($wow->execute()) {
        return $wow->getAttributesArray();
    } else {
        return false;
    }
}

function AddUser($storeid) {
    $defaultshell = GetWebOption('defaultshell',$storeid);
    $default_country = GetWebOption('default_country',$storeid);
    if($_SESSION['signup']['referralidSet']) {
        $referralField = GetWebOption('referralvalue',$storeid);
        switch($referralField) {
            case "Customer ID":
                $referralField = 'id';
                break;
            case "Customer Username":
                $referralField = 'username';
                break;
            case "Customer Email Address":
                $referralField = 'email';
                break;
        }

        $referralid = ExecuteSQL("select id from customer where ".SQLTrim($referralField)." = '".SQLTrim($_SESSION['signup']['newcustomer']['info']['referralid'])."'");
        if($referralid and is_array($referralid)) {
            $_SESSION['signup']['newcustomer']['info']['referral_' . $referralField] = $_SESSION['signup']['newcustomer']['info']['referralid'];
            $_SESSION['signup']['newcustomer']['info']['referralid'] = $referralid[0]['id'];
        } else {
            $_SESSION['signup']['referralidSet'] = false;
        }
    }

    global $wow;

    $wow->setMethod('addtoplat');
    $wow->addAttribute('logintype','staff');

    $wow->addProperty('BillingMeth',$_SESSION['signup']['newcustomer']['info']['paymenttype']);
    $wow->addProperty('IPAddress',$_SESSION['signup']['ip_address']);
    $wow->addProperty('Phone',$_SESSION['signup']['newcustomer']['info']['phone']);
    $wow->addProperty('Username',$_SESSION['signup']['newcustomer']['login']['username']);
    $wow->addProperty('Password',$_SESSION['signup']['newcustomer']['login']['password']);
    $wow->addProperty('Name2',$_SESSION['signup']['newcustomer']['info']['name']);
    $wow->addProperty('Address',$_SESSION['signup']['newcustomer']['info']['addr1']);
    $wow->addProperty('Address2',$_SESSION['signup']['newcustomer']['info']['addr2']);
    $wow->addProperty('State',$_SESSION['signup']['newcustomer']['info']['state']);
    $wow->addProperty('City',$_SESSION['signup']['newcustomer']['info']['city']);
    $wow->addProperty('Zip',$_SESSION['signup']['newcustomer']['info']['zip']);
    $wow->addProperty('Fax',$_SESSION['signup']['newcustomer']['info']['phone2']);
    $wow->addProperty('Guarantor',$_SESSION['signup']['options']['parentid'],$_SESSION['signup']['options']['parentid'] ? 'string' : 'boolean');
    $wow->addProperty('billtoguar',$_SESSION['signup']['options']['parentid'] && $_SESSION['signup']['options']['billparent'] == 1 ? 'Y' : 'N');
    $wow->addProperty('Email',$_SESSION['signup']['newcustomer']['info']['email'],$_SESSION['signup']['newcustomer']['info']['email'] ? 'string' : 'boolean');
    $wow->addProperty('BonusType','G');
    $wow->addProperty('StaffID',$_SESSION['signup']['options']['staffid'] ? $_SESSION['signup']['options']['staffid'] : $_SESSION['signup']['staffid']);
    $wow->addProperty('SelectPop',$_SESSION['signup']['newcustomer']['poplocation']['id'],'string');
    $wow->addProperty('SelectRate',$_SESSION['signup']['newcustomer']['info']['rgid'],'string');
    $wow->addProperty('rate_frequency',$_SESSION['signup']['newcustomer']['info']['rg_freq'],'string');
    $wow->addProperty('SelectShell',$_SESSION['signup']['newcustomer']['info']['shellid'] ? $_SESSION['signup']['newcustomer']['info']['shellid'] : $defaultshell,'string');
    $wow->addProperty('HTMLEmail','Y');
    $wow->addProperty('Country',$_SESSION['signup']['newcustomer']['info']['country'] ? $_SESSION['signup']['newcustomer']['info']['country'] : $default_country);
    $wow->addProperty('storeid',$storeid,'int');
    if($_SESSION['signup']['salesidSet']) {
        $wow->addProperty('salesid',$_SESSION['signup']['newcustomer']['info']['salesid'],'int');
    }
    if($_SESSION['signup']['referralidSet']) {
        $wow->addProperty('refid',$_SESSION['signup']['newcustomer']['info']['referralid'],'int');
    }

    $wow->addProperty('CCExpireM',$_SESSION['signup']['newcustomer']['paymentinfo']['ccmonth']);
    $wow->addProperty('CCExpireY',$_SESSION['signup']['newcustomer']['paymentinfo']['ccyear']);
    $wow->addProperty('CCName',$_SESSION['signup']['newcustomer']['paymentinfo']['ccname']);
    $wow->addProperty('CCAddr',$_SESSION['signup']['newcustomer']['paymentinfo']['ccaddr1']);
    $wow->addProperty('CCAddr2',$_SESSION['signup']['newcustomer']['paymentinfo']['ccaddr2']);
    $wow->addProperty('CCCity',$_SESSION['signup']['newcustomer']['paymentinfo']['cccity']);
    $wow->addProperty('CCState',$_SESSION['signup']['newcustomer']['paymentinfo']['ccstate']);
    $wow->addProperty('CCZip',$_SESSION['signup']['newcustomer']['paymentinfo']['cczip']);
    $wow->addProperty('CCCountry',$_SESSION['signup']['newcustomer']['paymentinfo']['cccountry']);
    $wow->addProperty('CCNumber',$_SESSION['signup']['newcustomer']['paymentinfo']['ccnumber']);
    $wow->addProperty('CCType',$_SESSION['signup']['newcustomer']['paymentinfo']['cctype']);

    $wow->addProperty('BankNumber',$_SESSION['signup']['newcustomer']['paymentinfo']['acctnumber']);
    $wow->addProperty('RouteNumber',$_SESSION['signup']['newcustomer']['paymentinfo']['routenumber']);
    $wow->addProperty('Bank_Acct_Type',$_SESSION['signup']['newcustomer']['paymentinfo']['bankaccttype'],'string');

    $wow->addParameter('activeconn','false','boolean');
    $wow->addParameter('datatype','XML');

    if($wow->execute()) {
        $_SESSION['signup']['custid'] = trim($wow->getAttribute(0,'custid'));
        return true;
    } else {
        $_SESSION['signup']['error'] = $wow->lastError;
        return false;
    }
}

function WelcomeEmail($custid) {
    global $wow;

    $wow->setMethod('Welcome_Email');
    $wow->addAttribute('logintype','staff');

    $wow->addParameter('datatype','XML');

    $wow->addProperty('custid',$custid);

    if($wow->execute())
        return true;
    else
        return false;
}

function CreateINSFile() {
    global $wow;

    $wow->setMethod('CreateINSFile');
    $wow->addAttribute('logintype','staff');

    $wow->addParameter('extension',false,'boolean');
    $wow->addParameter('datatype','XML');
    $wow->addParameter('dataloaded',false,'boolean');
    $wow->addParameter('returnfile',true,'boolean');

    $wow->addProperty('custid',$_SESSION['signup']['custid']);

    if($wow->execute()) {
	$result['success'] = true;
	$result['filename'] = $wow->getAttribute(0,'linktext');
	$result['filedata'] = base64_decode($wow->getAttribute(0,'insfile'));
    } else {
	$result['success'] = false;
	$result['error'] = $wow->lastError;
    }

    return $result;
}

function postCharges($storeid) {
    $days = GetWebOption('futuredays',$storeid);
    global $wow;

    $wow->setMethod('Post');
    $wow->addAttribute('logintype','staff');

    $wow->addParameter('noconn',false,'boolean');
    $wow->addParameter('days',$days,'string');
    $wow->addParameter('datatype','XML');

    $wow->addProperty('custid',$_SESSION['signup']['custid'],'string');

    if($wow->execute())
        return true;
    else {
        LogError('PostCharges',$wow->lastError);
        return false;
    }
}

function postBlockCharges($blockid) {
    global $wow;

    $wow->setMethod('AddBlockTime');
    $wow->addAttribute('logintype','staff');

    $wow->addParameter('blockrateid',$blockid);
    $wow->addParameter('quantity',1,'int');
    $wow->addParameter('nosave',false,'boolean');
    $wow->addParameter('datatype','XML');

    $wow->addProperty('custid',$_SESSION['signup']['custid'],'string');

    if($wow->execute())
        return true;
    else {
        LogError('PostBlockCharges',$wow->lastError);
        return false;
    }
}

function getInvoices() {
    global $wow;

	//if the customer has a prepay ammount from a registration code, post a payment
    if($_SESSION['signup']['regproc']['prepay'] && $_SESSION['signup']['regproc']['prepay'] != 'N') {
        $invoiceResults = ExecuteSQL("select invoice from iheader where total>paid and customer=".SQLTrim($_SESSION['signup']['custid']));
        $invoiceArray = array();
	if(isset($invoiceResults) && is_array($invoiceResults)) {
        foreach($invoiceResults as $thisInvoice) {
            array_push($invoiceArray,$thisInvoice['invoice']);
        }
	}
        $invoicelist = implode(",",$invoiceArray);
        $amountResult = ExecuteSQL("select amount = sum(total-paid) from iheader where customer = ".SQLTrim($_SESSION['signup']['custid']));

        $wow->setMethod('PostPayment');
        $wow->addAttribute('logintype','staff');
        if($_SESSION['signup']['regproc']['prepay'] == 'S') {
            $wow->addParameter('tender',$_SESSION['signup']['regproc']['prepayamount'],'currency');
        } else {
            $wow->addParameter('tender',$amountResult[0]['amount'],'currency');
        }
        $wow->addParameter('paydate',date('m/d/Y'));
        $wow->addParameter('invoicelist',$invoicelist);
        $wow->addParameter('paymenttypeid',$_SESSION['signup']['regproc']['prepaypaymenttype']);
        $wow->addParameter('custid',$_SESSION['signup']['custid']);
        $wow->addParameter('paymentnumber','');
        $wow->addParameter('name',$_SESSION['signup']['customer']['name']);
        $wow->addParameter('chargerealtime',0,'int');
        $wow->addParameter('ignore',false,'boolean');
        $wow->addParameter('noisy',false,'boolean');
        $wow->addParameter('ccexpire',false,'boolean');
        $wow->addParameter('noconn',false,'boolean');
        $wow->addParameter('authorizeonly',false,'boolean');
        $wow->addParameter('routenumber','');
        $wow->addParameter('accounttype','');
        $wow->addParameter('bankname','');
        $wow->addParameter('datatype','XML');
		$wow->execute(); //bug fix:  this line was not present
    }  //end registration code prepayment

    $invoiceData = array();

    $wow->setMethod('GetInvoices');
    $wow->addAttribute('logintype','staff');

    $wow->addParameter('datatype','XML');
    $wow->addParameter('startdate',false,'boolean');
    $wow->addParameter('enddate',false,'boolean');
    $wow->addParameter('invoiceowner','Guarantor');

    $wow->addProperty('custid',$_SESSION['signup']['custid']);

    if($wow->execute()) {
        $balance = 0;
        $invoices = array();
	if(is_array($wow->getAttributesArray())) {
        foreach($wow->getAttributesArray() as $invoice) {
            if($invoice['due'] > 0) {
                $balance += $invoice['due'];
                array_push($invoices,$invoice['invoice']);
            }
            }
        }

        $invoiceData['balance'] = $balance;
        $invoiceData['invoices'] = $invoices;

        $_SESSION['signup']['invoiceData'] = $invoiceData;

        return true;
    } else {
        LogError('GetInvoices',$wow->lastError);
        return false;
    }
}

function ProcessRegistrationCode() {
    $_SESSION['signup']['regproc']['prepay'] = 'N';
    if(!$_SESSION['signup']['customer']['salesid']) {
        $_SESSION['signup']['customer']['salesid'] = 0;
    }
    $sqlcommand = "select * from custrate where custid = ".SQLTrim($_SESSION['signup']['custid']);
    $rateResults = ExecuteSQL($sqlcommand);

    if($_SESSION['signup']['regcode']) {
        $sqlcommand = "select * from reg_details,reg_header,staff,reg_codes where reg_id=rc_rh_id and reg_id=rd_hdr_id and rc_code='".SQLTrim($_SESSION['signup']['regcode'])."' and (reg_expire is null or getdate() < reg_expire) and staff.num=rd_salesid and (rc_used < reg_reuse or reg_reuse=-1) and ((staff.affinity='Y' and (reg_affinity='0' or (reg_affinity='1' and rd_salesid=".((integer) $_SESSION['signup']['customer']['salesid'])."))) or (affinity='N' or affinity is null))";
        $bonusResults = ExecuteSQL($sqlcommand);
        if(isset($bonusResults) && is_array($bonusResults)) {
            foreach($bonusResults as $thisRow) {
                $salesid = $thisRow['rd_salesid'];
                $bonustype = strtoupper(trim($thisRow['rd_bonustype']));
                if($bonustype == 'M' || $bonustype == 'B') {
                    $feetype = strtoupper(trim($thisRow['rd_type']));
                    $startdate = time() + (86400 * $thisRow['rd_startoffset']);
                    if($thisRow['rd_endoffset'] != 'NULL' && $thisRow['rd_endoffset'] != '') {
                        $enddate = time() + (86400 * $thisRow['rd_endoffset']);
                    } else {
                        $enddate = false;
                    }
                    $amount = $thisRow['rd_amount'];
                    if($thisRow['rd_onetime'] == 'F') {
                        $onetime = false;
                    } else {
                        $onetime = true;
                    }

					//session variables for the current registration bonus
					/*
					$_SESSION['signup']['regproc']['bonus_type'] = $feetype;
					$_SESSION['signup']['regproc']['bonus_startdate'] = $startdate;
					$_SESSION['signup']['regproc']['bonus_enddate'] = $enddate;
					$_SESSION['signup']['regproc']['bonus_amount'] = $amount;
					$_SESSION['signup']['regproc']['bonus_onetime'] = $onetime;
					*/
                }
                if(isset($rateResults) && is_array($rateResults)) {
                    foreach($rateResults as $thisRate) {
                        if($bonustype == 'M' || $bonustype == 'B') {
                            CreateManualRegBonus($thisRate['crid'],$salesid,$feetype,$startdate,$enddate,$amount,$onetime);
                        }
                        if($bonustype == 'G' || $bonustype == 'B') {
                            CreateGlobalRegBonus($thisRate['crid'],$salesid);
                        }
                    }
                }
            }
        }

        ExecuteSQL("update reg_codes set rc_used = rc_used + 1 where rc_code = '".SQLTrim($_SESSION['signup']['regcode'])."'");
		//bug fix:  setting the reg code value on the customer
		ExecuteSQL("update customer set reg_code_number = '".SQLTrim($_SESSION['signup']['regcode'])."' where id = ".((integer) $_SESSION['signup']['custid']));

        $sqlcommand = "select * from reg_header, reg_codes where reg_id = rc_rh_id and rc_code = '".SQLTrim($_SESSION['signup']['regcode'])."'";
        $prepayResults = ExecuteSQL($sqlcommand);

        if(isset($prepayResults) && is_array($prepayResults)) {
            foreach($prepayResults as $thisResult) {
                $_SESSION['signup']['regproc']['prepay'] = $thisResult['reg_prepaid'];
                $_SESSION['signup']['regproc']['prepayamount'] = $thisResult['reg_prepaidamount'];
                $_SESSION['signup']['regproc']['prepaypaymenttype'] = $thisResult['reg_prepaid_paymenttype'];
            }
        }

        if(!$_SESSION['signup']['regproc']['prepay'])
            $_SESSION['signup']['regproc']['prepay'] = 'N';
        if(!$_SESSION['signup']['regproc']['prepayamount'])
            $_SESSION['signup']['regproc']['prepayamount'] = 0;
        if(!$_SESSION['signup']['regproc']['prepaypaymenttype'])
            $_SESSION['signup']['regproc']['prepaypaymenttype'] = 8;
    } else {
        if($_SESSION['signup']['customer']['salesid']) {
            $bonustype = 'G';
            $salesid = $_SESSION['signup']['customer']['salesid'];
            if(isset($rateResults) && is_array($rateResults)) {
                foreach($rateResults as $thisRate) {
                    CreateGlobalRegBonus($thisRate['crid'],$salesid);
                }
            }
        }
    }
}

function CreateGlobalRegBonus($crid,$salesid) {
	//used to apply global bonus rules to specific staff member via registration codes
    global $wow;

    $wow->setMethod('CreateBonus');
    $wow->addAttribute('logintype','staff');
    $wow->addParameter('crid',$crid,'int');
    $wow->addParameter('doconn',true,'boolean');
    $wow->addParameter('getdefaults',true,'boolean');
    $wow->addParameter('datatype','XML');
	$wow->addProperty('refid', false, 'boolean');
	$wow->addProperty('salesid',$salesid,'int');
    $wow->addProperty('custid',$_SESSION['signup']['custid'],'int');

    if($wow->execute()) {
        return true;
    } else {
        return false;
    }
}

function CreateManualRegBonus($crid,$salesid,$feetype,$startdate,$enddate,$amount,$onetime) {
	//used to apply manual bonus rules to a specific staff member via registration codes
	global $wow;

	/* this wow call will not work until the next release of the wwque, billy herren : 5/21/2007

    $wow->setMethod('CreateBonus');
    $wow->addAttribute('logintype','staff');
    $wow->addParameter('crid',$crid,'int');
    $wow->addParameter('doconn',true,'boolean');
    $wow->addParameter('getdefaults',false,'boolean');
	$wow->addParameter('datatype','XML');
	$wow->addProperty('refid', false, 'boolean');
	//properties specific to only manual bonus rules
	$wow->addProperty('globalbonus1.BonusType','M');
	$wow->addProperty('globalbonus1.FeeType',$feetype);
	$wow->addProperty('globalbonus1.Amount',$amount,'currency');
	$wow->addProperty('globalbonus1.OneTime',$onetime,'boolean');
	$wow->addProperty('globalbonus1.Startdate',date("F j, Y",$startdate),'date');
	if($_SESSION['signup']['regproc']['bonus_enddate']) {
		$wow->addProperty('globalbonus1.EndDate',date("F j, Y",$enddate),'date');
	} else {
		$wow->addProperty('globalbonus1.Enddate',false,'boolean');
	}
	//end manual-specific properties
	$wow->addProperty('salesid',$salesid,'int');
    $wow->addProperty('custid',$_SESSION['signup']['custid'],'int');

 	if($wow->execute()) {
        return true;
	} else {
		return false;
	} */

	//workaround: insert the bonus rule manually
	$sql = "insert into bonus_act(idnum,idtype,dependentid,startdate,enddate,type,amount,onetime,rgid,crid) ";
	$sql .= "select ".((integer) $salesid).",'Staff',custid,'".date("F j, Y",$startdate)."',";
	$sql .= $enddate ? "'".date("F j, Y",$enddate)."'," : "NULL,";
	$sql .= "'".SQLTrim($feetype)."',".((float) $amount).",'".($onetime === true ? 'Y' : 'N')."',rgid,crid from custrate where crid = ".((integer) $crid);

	ExecuteSQL($sql);
	return true;

} //end CreateManualRegBonus

function chargeCard($storeid) {
    if($_SESSION['signup']['invoiceData']['balance'] > 0) {
        $cc_action = GetWebOption('cc_action',$storeid);
        global $wow;

        $wow->setMethod('ChargeAll');
        $wow->addAttribute('logintype','staff');

        $wow->addParameter('cc_action',$cc_action);
        $wow->addParameter('datatype','XML');

        $wow->addProperty('cctype',$_SESSION['signup']['newcustomer']['paymentinfo']['cctype']);
        $wow->addProperty('ccexpirem',$_SESSION['signup']['newcustomer']['paymentinfo']['ccmonth']);
        $wow->addProperty('ccexpirey',$_SESSION['signup']['newcustomer']['paymentinfo']['ccyear']);
        $wow->addProperty('ccnumber',$_SESSION['signup']['newcustomer']['paymentinfo']['ccnumber']);
        $wow->addProperty('name2',$_SESSION['signup']['newcustomer']['paymentinfo']['ccname']);
        $wow->addProperty('ccv2',$_SESSION['signup']['newcustomer']['paymentinfo']['cvv2']);
        $wow->addProperty('staffid',$_SESSION['signup']['staffid']);
        $wow->addProperty('custid',$_SESSION['signup']['custid']);

        if($wow->execute()) {
            return true;
        } else {
	    $_SESSION['signup']['error'] = $wow->lastError;
            return false;
        }
    } else {
        return true;
    }
}

function getRates() {
    global $wow;

    $wow->setMethod('GetRates');
    $wow->addAttribute('logintype','staff');

    $wow->addParameter('datatype','XML');

    $wow->addProperty('custid',$_SESSION['signup']['custid']);

    if($wow->execute()) {
        $crids = $wow->getAttributesArray();
        $cridList = array();
	if(isset($crids) && is_array($crids)) {
        foreach($crids as $thisCrid) {
            array_push($cridList,$thisCrid['crid']);
	}
        }
        $_SESSION['signup']['crid'] = implode(',',$cridList);
        return true;
    } else {
        LogError('GetRates',$wow->lastError);
        return false;
    }
}

function GetAvailableWebRates() {
    global $wow;

    $wow->setMethod('GetAvailableWebRates');
    $wow->addAttribute('logintype','staff');

    $wow->addParameter('datatype','XML');

    $wow->addProperty('storeid',$_SESSION['signup']['storeid'] ? $_SESSION['signup']['storeid'] : 0,'integer');

    if($wow->execute()) {
        return $wow->getAttributesArray();
    } else {
        return false;
    }
}

function GetAvailableWebRatesCCS($ccs) {
    global $wow;

    $wow->setMethod('GetAvailableWebRates');
    $wow->addAttribute('logintype','staff');

    $wow->addParameter('datatype','XML');
	$wow->addParameter('ccs',$ccs,'boolean');

    $wow->addProperty('storeid',$_SESSION['signup']['storeid'] ? $_SESSION['signup']['storeid'] : 0,'integer');

    if($wow->execute()) {
        return $wow->getAttributesArray();
    } else {
        return false;
    }
}


function GetSingleRate($rgid,$freq) {
//    $bundleList = GetAvailableWebRatesCCS(true);

//    if(isset($bundleList) && is_array($bundleList)) {
//        foreach($bundleList as $thisBundle) {
//            if($thisBundle['rg_id'] == $rgid && $thisBundle['r_frequency'] == $freq) {
//                return $thisBundle;
//            }
//        }
//    }

    $rateList = GetAvailableWebRatesCCS(false);

    if(isset($rateList) && is_array($rateList)) {
        foreach($rateList as $thisRate) {
            if($thisRate['rg_id'] == $rgid && $thisRate['r_frequency'] == $freq) {
                return $thisRate;
            }
        }
    }

    return false;
}

function SetPriceList($rgid) {
    $allPrices = GetAllPrices($rgid);

    $priceArray = array();

    if(isset($allPrices) && is_array($allPrices)) {
        foreach($allPrices as $thisPrice) {
            switch($thisPrice['transaction_type']) {
                case "Register":
                    $type = "new";
                    break;
                default:
                    $type = strtolower($thisPrice['transaction_type']);
            }
            $type = 'period-pricing-'.$type;

            $tld = ".".strtolower($thisPrice['service_subtype']);
            $year = $thisPrice['period'];

            if(!$priceArray[$tld]) {
                $priceArray[$tld] = array();
            }
            if(!$priceArray[$tld][$type]) {
                $priceArray[$tld][$type] = array();
            }
            $priceArray[$tld][$type][$year-1] = $thisPrice['price'];
        }

        if(isset($_SESSION['ccs']['options']['driver-options']['service-modules']['domain']['service-options']['service-offering-list']['service-offering']) && is_array($_SESSION['ccs']['options']['driver-options']['service-modules']['domain']['service-options']['service-offering-list']['service-offering'])) {
            foreach($_SESSION['ccs']['options']['driver-options']['service-modules']['domain']['service-options']['service-offering-list']['service-offering'] as &$thisTLD) {
                $thisTLD['price']['period-pricing-new'] = $priceArray[$thisTLD['tld']]['period-pricing-new'];
                $thisTLD['price']['period-pricing-renew'] = $priceArray[$thisTLD['tld']]['period-pricing-renew'];
                $thisTLD['price']['period-pricing-transfer'] = $priceArray[$thisTLD['tld']]['period-pricing-transfer'];
            }
        }
    }
}

function GetAllPrices($rgid) {
    global $wow;

    $wow->setMethod('Transaction_GetPrice');
    $wow->addAttribute('logintype','staff');

    $wow->addParameter('Service',false,'boolean');
    $wow->addParameter('SubService',false,'boolean');
    $wow->addParameter('Action',false,'boolean');
    $wow->addParameter('Period',false,'boolean');
    $wow->addParameter('RGID',$rgid,'string');
    $wow->addParameter('DataType','XML');

    if($wow->execute()) {
        return $wow->getAttributesArray();
    } else {
        return false;
    }
}

function GetServiceFields($serviceID,$rgid = false,$crid = false,$branch = false,$parentinstance = false,$parentservice = false) {
    global $wow;

    $wow->setMethod('GetServiceInfo');
    $wow->addAttribute('logintype','staff');

    $wow->addParameter('svcid',$serviceID);
    $wow->addParameter('datatype','XML');
    $wow->addParameter('rgid',$rgid,$rgid ? 'string' : 'boolean');
    $wow->addParameter('crid',$crid,$crid ? 'string' : 'boolean');
    $wow->addParameter('branch',$branch,$branch ? 'string' : 'boolean');
    $wow->addParameter('parentInstance',$parentinstance,$parentinstance ? 'string' : 'boolean');
    $wow->addParameter('parentService',$parentservice,$parentservice ? 'string' : 'boolean');

    if($wow->execute()) {
        return $wow->getAttributesArray();
    } else {
        return false;
    }
}

function GetCCSServiceDetails($rgid = false,$custid = false) {
    $wow = new WOW_Request();
    $wow->setUsername($_SESSION['wow']['file_staffname']);
    $wow->setPassword($_SESSION['wow']['file_staffpass']);

    $wow->setMethod('ListServiceTree');
    $wow->addAttribute('logintype','staff');

    $wow->addParameter('datatype','XML');
    if($rgid)
        $wow->addParameter('rgid',$rgid);
    if($custid)
        $wow->addProperty('custid',$custid);

    if($wow->execute()) {
        $results['success'] = true;
        $results['serviceData'] = $wow->getAttribute(0);
    } else {
        $results['success'] = false;
        $results['error'] = $wow->lastError;
    }

    return $results;
}

function GetBlockRates($showDetails = false) {
    global $wow;

    $wow->setMethod('GetAvailableBlockRates');
    $wow->addAttribute('logintype','staff');

    $wow->addParameter('datatype','XML');
    $wow->addParameter('details',$showDetails,'boolean');

    if($wow->execute()) {
        return $wow->getAttributesArray();
    } else {
        return false;
    }
}

function GetStoreID($custid) {
    global $wow;

    $wow->setMethod('GetCustomer');
    $wow->addAttribute('logintype','staff');

    $wow->addParameter('datatype','XML');

    $wow->addProperty('custid',$custid);

    if($wow->execute()) {
        return $wow->getAttribute(0,'storeid');
    } else {
        return false;
    }
}

function ValidateCard($cctype,$ccnumber,$ccmonth,$ccyear) {
    $cclength = strlen($ccnumber);
    $error = "";

	if (!$cctype) {
		$error .= 'CREDIT CARD TYPE not selected.  ';
	}

    switch($cctype) {
        case 'VISA':
            if($cclength != 13 && $cclength != 16)
                $error .= 'VISA Length Invalid.  ';
            if(substr($ccnumber,0,1) != '4')
                $error .= 'VISA Number Invalid.  ';
            break;
        case 'MASTERCARD':
            if($cclength != 16)
                $error .= 'MASTERCARD Length Invalid.  ';
            if(substr($ccnumber,0,2) != '51' && substr($ccnumber,0,2) != '52' && substr($ccnumber,0,2) != '53' && substr($ccnumber,0,2) != '54' && substr($ccnumber,0,2) != '55')
                $error .= 'MASTERCARD Number Invalid.  ';
            break;
        case 'AMEX':
            if($cclength != 15)
                $error .= 'AMEX Length Invalid.  ';
            if(substr($ccnumber,0,2) != '34' && substr($ccnumber,0,2) != '37')
                $error .= 'AMEX Number Invalid.  ';
            break;
        case 'DISCOVER':
            if($cclength != 16)
                $error .= 'DISCOVER Length Invalid.  ';
            if(substr($ccnumber,0,4) != '6011')
                $error .= 'DISCOVER Number Invalid.  ';
            break;
    }

    $ccnumberArray = array();
    $ccextradigits = 0;
    $checksum = 0;

    for($index=$cclength-1;$index>=0;$index--) {
        array_push($ccnumberArray,substr($ccnumber,$index,1));
    }

    if(isset($ccnumberArray) && is_array($ccnumberArray)) {
    foreach($ccnumberArray as $ccIndex=>$ccValue) {
        if($ccIndex%2 == 1) {
            $checksum += ($ccValue * 2);
            if(($ccValue * 2) > 9) {
                $checksum -= 9;
            }
        } else {
            $checksum += $ccValue;
        }
    }
    }

    if($checksum%10 != 0) {
        $error .= 'INVALID CARD NUMBER.  ';
    }

    if($ccmonth && $ccyear) {
        $expDate = mktime(0,0,0,$ccmonth+1,0,$ccyear);

        if(time() > $expDate) {
            $error .= 'INVALID EXPIRATION DATE.  ';
        }
    } else {
        $error .= 'EXPIRATION DATE NOT ENTERED.  ';
    }

    if(strlen($error) == 0) {
        $results['success'] = true;
    } else {
        $results['success'] = false;
        $results['error'] = $error;
    }

    return $results;
}

function ShowMoney($money) {
    $pos = strstr($money,".");

    if(!$pos) // Add .00
        return str_replace(" ","",$money.".00");

    $tail = substr($pos,1,2);
    $newmoney = substr($money,0,strpos($money,".")+1);

    if(strlen($tail) == 1)
        return str_replace(" ","",$newmoney.$tail."0");
    else
        if(strlen($tail) == 0)
            return str_replace(" ","",$newmoney."00");
        else
            return str_replace(" ","",$newmoney.$tail);
}


function launchUM() {
    global $wow;

    $wow->setMethod('LaunchUM');
    $wow->addAttribute('logintype','staff');

    $wow->addParameter('option','UM_New Save');
    $wow->addParameter('dataid',false,'boolean');
    $wow->addParameter('openconnection','1','string');
    $wow->addParameter('datatype','XML');

    $wow->addProperty('custid',$_SESSION['signup']['custid']);

    if($wow->execute()) {
        return true;
    } else {
        LogError('LaunchUM',$wow->lastError);
        return false;
    }
}

function deleteCustomer($custid) {
    global $wow;

    $wow->setMethod('DeleteCustomer');
    $wow->addAttribute('logintype','staff');

    $wow->addParameter('datatype','XML');

    $wow->addProperty('custid',$custid);

    if($wow->execute())
        return true;
    else {
        LogError('DeleteCustomer',$wow->lastError);
        return false;
    }
}

function GetRegHeader() {
   $regHeader = ExecuteSQL("select * from reg_header order by reg_id");

   if(isset($regHeader) && is_array($regHeader)) {
   foreach($regHeader as &$thisHeader) {
       $thisHeader['reg_create'] = strtotime($thisHeader['reg_create']);
       if($thisHeader['reg_expire'] != 'NULL' && $thisHeader['reg_expire'] != '')
           $thisHeader['reg_expire'] = strtotime($thisHeader['reg_expire']);
       else
           $thisHeader['reg_expire'] = false;
       $thisHeader['reg_date'] = strtotime($thisHeader['reg_date']);
   }
   }

   return $regHeader;
}

function GetNextRandomCode($mask) {
    $maskLength = strlen($mask);
    $goodCode = 1;
    $loopCount = 0;

    while ($goodCode != 0 && $loopCount < 100) {
        $newCode = "";
        for ($j = 0;$j < $maskLength;$j++) {
            $maskValue = substr($mask,$maskLength - $j - 1,1);

            switch($maskValue) {
                case "9":
                    $value = chr(rand(48,57));
                    break;
                case "A":
                    $value = chr(rand(65,90));
                    break;
                case "a":
                    $value = chr(rand(97,122));
                    break;
                case "X":
                case "x":
                    $r_num = rand(1,2);
                    switch($r_num) {
                        case 1:
                            $value = chr(rand(97,122));
                            break;
                        default:
                            $value = chr(rand(65,90));
                    }
                    break;
                case "#":
                    $r_num = rand(1,3);
                    switch($r_num) {
                        case 1:
                            $value = chr(rand(97,122));
                            break;
                        case 2:
                            $value = chr(rand(65,90));
                            break;
                        default:
                            $value = chr(rand(48,57));
                    }
                    break;
                default:
                    $value = $maskValue;
            }

            $newCode = $newCode . $value;
        }

        $newCode = strrev($newCode);

        $testRS = ExecuteSQL("select used=count(*) from reg_codes where rc_code='".SQLTrim($newCode)."'");
        if($testRS)
            $goodCode = $testRS[0]['used'];

        $loopCount++;
    }

    return $newCode;
}

Function GetNextCode($mask,$currentCode) {
    $codeLength = strlen($currentCode);
    $newCode = "";
    $incrementNextIndex = true;

    for($index = 0;$index < $codeLength;$index++)
    {
        $currentIndexValue = ord(substr($currentCode,$codeLength - $index - 1,1));
        $maskIndexValue = substr($mask,$codeLength - $index - 1,1);
        if($currentIndexValue == 57) // 9
        {
            $incrementNextIndex = false;
            switch($maskIndexValue) {
                case "A":   // reset cycle from 9 to A
                    $nextIndexValue = chr(65);
                    break;
                case "a":   // reset cycle from 9 to a
                    $nextIndexValue = chr(97);   // a
                    break;
                case "9":   // reset cycle from 9 to 0
                    $incrementNextIndex = true;
                    $nextIndexValue = chr(48);
                    break;
                default:    // default to A for "#" mask format.
                    $nextIndexValue = chr(65);
            }
            $newCode = $nextIndexValue . $newCode;
        }
        elseif ($currentIndexValue == 122 /* z */ || $currentIndexValue == 90 /* Z */)
        {
            $incrementNextIndex = false;
            switch($maskIndexValue) {
                case "A":   // reset cycle from "Z" to "A"
                    $incrementNextIndex = true;
                    $nextIndexValue = chr(65);
                    break;
                case "a":   // reset cycle from "z" to "a"
                    $incrementNextIndex = true;
                    $nextIndexValue = chr(97);   // a
                    break;
                case "X":
                case "x":   // cycle from "A" to "Z" to "a" to "z"
                    if ($currentIndexValue == 122) { // z cycles to A
                        $incrementNextIndex = true;
                        $nextIndexValue = chr(65);
                    } elseif ($currentIndexValue == 90) { // Z cycles to a
                        $nextIndexValue = chr(97);
                    } else
                        $nextIndexValue = chr(65);  // fail to A
                    break;
                default:    // cycle from "0" to "9" to "A" to "Z" to "a" to "z"
                    if ($currentIndexValue == 122) { // z cycles to 0
                        $incrementNextIndex = true;
                        $nextIndexValue = chr(48);
                    } elseif ($currentIndexValue == 90) // Z cycles to a
                        $nextIndexValue = chr(97);
                    elseif ($currentIndexValue == 59) // 9 cycles to A
                        $nextIndexValue = chr(65);
                    else
                        $nextIndexValue = chr(48);      // fail to 0 (zero)
            }
            $newCode = $nextIndexValue . $newCode;
        }
        elseif ($incrementNextIndex)
        {
            $incrementNextIndex = false;
            $nextIndexValue = chr($currentIndexValue+1);
            $newCode = $nextIndexValue . $newCode;
        }
        else
        {
            $newCode = chr($currentIndexValue) . $newCode;
        }
    }
    return $newCode;
}

function SuggestUsername($customerName) {
    if($customerName) { // username hasn't been set and customer's name has, so suggest away...
        $unamefmt = ExecuteSQL("select value from options where name = 'Username Format'");
        if(!strpos($unamefmt[0]['value'],'9')) { // if the format strictly specifies a number, then don't suggest any usernames
            if(!strpos($unamefmt[0]['value'],'['))
                $maxlength = strlen($unamefmt[0]['value']);
            else
                $maxlength = strlen($unamefmt[0]['value'])-2;

            $spaceinname = strpos($customerName,' ');

            if(!$spaceinname) {
                $firstname = $customerName;
                $lastname = "";
            } else {
                $firstname = substr($customerName,0,$spaceinname);
                $lastname = substr($customerName,$spaceinname+1,strlen($customerName)-($spaceinname+1));
            }
            if(strtolower(GetWebOption('suggest1',$_SESSION['signup']['storeid'])) == 'y') { // first initial plus last name for username
                $suggestion = strtolower(substr($firstname,0,1).$lastname);
                $usernamecheck = ExecuteSQL("select id from customer where username = '".SQLTrim($suggestion)."'");
                $emailnamecheck = ExecuteSQL("select data_id from email_data where username = '".SQLTrim($suggestion)."'");
                if(isset($usernamecheck[0]['id']) || isset($emailnamecheck[0]['data_id']) || strlen($suggestion) > $maxlength) // this username is taken or it's too long
                    unset($suggestion);
            }
            if(strtolower(GetWebOption('suggest2',$_SESSION['signup']['storeid'])) == 'y' && !$suggestion) { // first name plus last initial for username
                $suggestion = strtolower($firstname.substr($lastname,0,1));
                $usernamecheck = ExecuteSQL("select id from customer where username = '".SQLTrim($suggestion)."'");
                $emailnamecheck = ExecuteSQL("select data_id from email_data where username = '".SQLTrim($suggestion)."'");
                if(isset($usernamecheck[0]['id']) || isset($emailnamecheck[0]['data_id']) || strlen($suggestion) > $maxlength) // this username is taken or it's too long
                    unset($suggestion);
            }
            if(strtolower(GetWebOption('suggest3',$_SESSION['signup']['storeid'])) == 'y' && !$suggestion) { // first name plus last initial plus number for username
                for($i = 1;$i < 100;$i++) {
                    $suggestion = strtolower($firstname.substr($lastname,0,1).$i);
                    $usernamecheck = ExecuteSQL("select id from customer where username = '".SQLTrim($suggestion)."'");
                    $emailnamecheck = ExecuteSQL("select data_id from email_data where username = '".SQLTrim($suggestion)."'");
                    if(isset($usernamecheck[0]['id']) || isset($emailnamecheck[0]['data_id']) || strlen($suggestion) > $maxlength) // this username is taken or it's too long
                        unset($suggestion);
                    else
                        $i = 100; // set $i to the break point, so it drops out with the good username
                }
            }

	    if($suggestion) {
		return $suggestion;
	    } else {
		return false;
	    }
        } else {
	    return false;
	}
    } else {
	return false;
    }
}

function VerifyNewUser($customerInfo,$storeid) {
    if($customerInfo['info']['nonrequired']) {
        if($customerInfo['info']['required']) {
            $customerInfo['info']['combined'] = $customerInfo['info']['required'] + $customerInfo['info']['nonrequired'];
        } else {
            $customerInfo['info']['combined'] = $customerInfo['info']['nonrequired'];
        }
    } else {
        if($customerInfo['info']['required']) {
            $customerInfo['info']['combined'] = $customerInfo['info']['required'];
        } else {
            $customerInfo['info']['combined'] = $customerInfo['info'];
        }
    }

    $default_shell = GetWebOption('defaultshell',$storeid);

    global $wow;

    $results = array();

    $wow->setMethod('VerifyInfo');
    $wow->addAttribute('logintype','staff');

    $wow->addProperty('BillingMeth','CHECK');
    $wow->addProperty('Phone',$customerInfo['info']['combined']['phone']);
    $wow->addProperty('Username',$customerInfo['login']['username']);
    $wow->addProperty('Password',$customerInfo['login']['password']);
    $wow->addProperty('Password2',$customerInfo['login']['password2']);
    $wow->addProperty('Name2',$customerInfo['info']['combined']['name']);
    $wow->addProperty('Address',$customerInfo['info']['combined']['addr1']);
    $wow->addProperty('Address2',$customerInfo['info']['combined']['addr2']);
    if (!$customerInfo['info']['combined']['state'] && $customerInfo['info']['combined']['country'] != 'CA' && $customerInfo['info']['combined']['country'] != 'US')
        $wow->addProperty('State','NA');
    else
        $wow->addProperty('State',$customerInfo['info']['combined']['state']);
    $wow->addProperty('City',$customerInfo['info']['combined']['city']);
    $wow->addProperty('Zip',$customerInfo['info']['combined']['zip']);
    $wow->addProperty('Fax',$customerInfo['info']['combined']['phone2']);
    $wow->addProperty('Guarantor',$_SESSION['signup']['options']['parentid'],$_SESSION['signup']['options']['parentid'] ? 'string' : 'boolean');
    $wow->addProperty('billtoguar',$_SESSION['signup']['options']['parentid'] && $_SESSION['signup']['options']['billparent'] == 1 ? 'Y' : 'N');
    $wow->addProperty('Email',false,'boolean');
    $wow->addProperty('BonusType','F');
    $wow->addProperty('StaffID',$_SESSION['signup']['options']['staffid'] ? $_SESSION['signup']['options']['staffid'] : $_SESSION['signup']['staffid']);
    $wow->addProperty('SelectPop',$customerInfo['poplocation']['id'],'string');
    $wow->addProperty('SelectRate',$customerInfo['info']['rgid'],'string');
    $wow->addProperty('rate_frequency',$customerInfo['info']['rg_freq'],'string');
    $wow->addProperty('SelectShell',$default_shell,'string');
    $wow->addProperty('HTMLEmail','Y');
    $wow->addProperty('Country',$customerInfo['info']['combined']['country']);
    $wow->addProperty('storeid',$storeid,'int');

    $wow->addProperty('CCExpireM','');
    $wow->addProperty('CCExpireY','');
    $wow->addProperty('CCName','');
    $wow->addProperty('CCAddr','');
    $wow->addProperty('CCAddr2','');
    $wow->addProperty('CCCity','');
    $wow->addProperty('CCState','');
    $wow->addProperty('CCZip','');
    $wow->addProperty('CCCountry','');
    $wow->addProperty('CCNumber','');
    $wow->addProperty('CCType','');

    $wow->addProperty('BankNumber','');
    $wow->addProperty('RouteNumber','');
    $wow->addProperty('Bank_Acct_Type','');

    $wow->addParameter('display_rates','N');
    $wow->addParameter('display_block_rates','N');
    $wow->addParameter('sales_required','N');
    $wow->addParameter('show_sales','N');
    $wow->addParameter('selectsales',1);
    $wow->addParameter('selectref',1);
    $wow->addParameter('selectblock','');
    $wow->addParameter('datatype','XML');

    if($wow->execute()) {
	$results['success'] = true;
    } else {
	$results['success'] = false;
	$results['error'] = $wow->lastError;
    }

    return $results;
}

function GetPaymentTypes($cctypes = false) {
    global $wow;

    $paymentTypes = array();

    $wow->setMethod('getpaymenttypes');
    $wow->addAttribute('logintype','staff');
    $wow->addParameter('datatype','XML');

    if($wow->execute()) {
        $ALLpaymentTypes = $wow->getAttributesArray();
        if(isset($ALLpaymentTypes) && is_array($ALLpaymentTypes)) {
            foreach($ALLpaymentTypes as $thisType) {
                if($cctypes) {
                    if($thisType['p_active'] == 'Y' && $thisType['p_type'] == 'CREDITCARD') {
                        array_push($paymentTypes,$thisType);
                    }
                } else {
                    if($thisType['p_active'] == 'Y' && $thisType['p_deposittype'] != 'NA') {
                        array_push($paymentTypes,$thisType);
                    }
                }
            }
        }

        return $paymentTypes;
    } else {
        return false;
    }
}

?>
