<?php
/*---------------------------------------------------------------------------------------------------------*/
/*---- This file has performs the logging in and logging out of the helpdesk pages                     ----*/
/*---- These functions are invoked from the acf framework                                              ----*/
/*---------------------------------------------------------------------------------------------------------*/

require_once('../../libs/platypus/wow.inc.php');
require_once("../../libs/ccs/options.inc.php");
//---- load the CCS Options have to laod it here because this is the first manditory function call
if (!$_SESSION['ccs'])
    loadCCSOptions();

function AH_SaveSurveyData(ACF_ParameterList $inParameterList){
    $responses = $inParameterList->ParameterValue('responses');
    $surveyData = array();

    if (count($_SESSION['survey']['questions']['questions_item'][0])) {
        foreach ($_SESSION['survey']['questions']['questions_item'] as $question){
            if (strtoupper($question['questiontype']) == "LABEL") {
                // Skip Labels
            } elseif (strtoupper($question['questiontype']) == "CHECKBOX") {
                if (isset($responses[$question['questionid']])){
                    foreach ($responses[$question['questionid']] as $answer){
                        $item = array($question['questionid'],
                            $answer,
                            $question['questiontype'],
                            $question['questionmandatory']);
                        array_push($surveyData, $item);
                    }
                }
            } else {
                $item = array($question['questionid'],
                    (isset($responses[$question['questionid']]) ? $responses[$question['questionid']]: ""),
                    $question['questiontype'],
                    $question['questionmandatory']);
                array_push($surveyData, $item);
            }
        }
    } else {
        foreach ($_SESSION['survey']['questions'] as $question){
            if (strtoupper($question['questiontype']) == "LABEL") {
                // Skip Labels
            } elseif (strtoupper($question['questiontype']) == "CHECKBOX") {
                if (isset($responses[$question['questionid']])){
                    foreach ($responses[$question['questionid']] as $answer){
                        $item = array($question['questionid'],
                            $answer,
                            $question['questiontype'],
                            $question['questionmandatory']);
                        array_push($surveyData, $item);
                    }
                }
            } else {
                $item = array($question['questionid'],
                    (isset($responses[$question['questionid']]) ? $responses[$question['questionid']]: ""),
                    $question['questiontype'],
                    $question['questionmandatory']);
                array_push($surveyData, $item);
            }
        }
    }
    $helpdesk = new WOW_Request('', '', 'wombat');
//---- assign values to the helpdesk object
    $helpdesk->setMethod('survey_Save');
    $helpdesk->setUsername('');
    $helpdesk->setPassword('');
    $helpdesk->addAttribute('logintype', 'staff');
    $helpdesk->addParameter('nSurveyId', $_SESSION['survey']['surveyid'], 'int');
    $helpdesk->addParameter('aResponses', $surveyData, 'array');
    $helpdesk->addParameter('nTicketId', $_SESSION['survey']['ticketid'], 'int');
    $helpdesk->addParameter('nStaffId', $_SESSION['survey']['staffid'], 'int');
    if ($helpdesk->execute())
        if ($helpdesk->getAttribute(0, 'survey_Save') != "true")
            $error = "Survey failed to save.";
    if ($helpdesk->lastError)
        $error = $helpdesk->lastError;
    if ($error){
        $retEvent = new ACF_Event('SaveSurveyData_Failure');
        $parameterList = new ACF_ParameterList();
        $parameterList->AddParameter(new ACF_DirectParameter('error', $error));
        $parameterList->AddParameter(new ACF_DirectParameter('surveyid', $_SESSION['survey']['surveyid']));
        $parameterList->AddParameter(new ACF_DirectParameter('ticketid', $_SESSION['survey']['ticketid']));
        $parameterList->AddParameter(new ACF_DirectParameter('staffid', $_SESSION['survey']['staffid']));
        $parameterList->AddParameter(new ACF_DirectParameter('custid', $_SESSION['survey']['customerid']));
        $retEvent->SetParameterList($parameterList);
    }else
        $retEvent = new ACF_Event('SaveSurveyData_Success');
    return $retEvent;
}
?>
