<?php

require_once('../../libs/platypus/wow.inc.php');
require_once("../../libs/ccs/options.inc.php");
//---- load the CCS Options have to laod it here because this is the first manditory function call
if (!$_SESSION['ccs'])
    loadCCSOptions();


function DC_GetSurveyData(ACF_ParameterList $inParameterList){
    if (isset($_SESSION['survey']))
        unset($_SESSION['survey']);

    $error = "";
    if (!is_numeric($inParameterList->ParameterValue('surveyid')))
        $error = "Invalid Survey Number";
    if (!is_numeric($inParameterList->ParameterValue('ticketid')))
        $error = ($error ? $error . "\n" : "") . "Invalid Ticket Number";
    if (!is_numeric($inParameterList->ParameterValue('staffid')))
        $error = ($error ? $error . "\n" : "") . "Invalid Staff Number";
    if (!is_numeric($inParameterList->ParameterValue('custid')))
        $error = ($error ? $error . "\n" : "") . "Invalid Customer Number";

    if ($error) {
        $parameterList = new ACF_ParameterList();
        $parameterList->AddParameter(new ACF_DirectParameter('error', $error));
        return $parameterList;
    }

    $helpdesk = new WOW_Request('', '', 'wombat');
    $helpdesk->setMethod('survey_load');
    $helpdesk->setUsername('');
    $helpdesk->setPassword('');
    $helpdesk->addAttribute('logintype', 'staff');
    $helpdesk->addParameter('nSurveyId', $inParameterList->ParameterValue('surveyid'), 'int');
    $helpdesk->addParameter('nTicketId', $inParameterList->ParameterValue('ticketid'), 'int');
    $helpdesk->addParameter('nStaffId', $inParameterList->ParameterValue('staffid'), 'int');
    $helpdesk->addParameter('nCustId', $inParameterList->ParameterValue('custid'), 'int');
    if ($helpdesk->execute()){
        $surveyData = $helpdesk->getAttribute(0);
        $_SESSION['survey'] = $surveyData;
    }else
        $error = $helpdesk->lastError;
    if ($inParameterList->ParameterValue('error'))
        $error = ($error ? $error . "\n" : "") . $inParameterList->ParameterValue('error');
    $parameterList = new ACF_ParameterList();                              //---- create a parameter object
//---- add values to the parameter object
    if ($error)
        $parameterList->AddParameter(new ACF_DirectParameter('error', $error));
    if ($surveyData)
        $parameterList->AddParameter(new ACF_DirectParameter('surveydata', $surveyData));
    return $parameterList;
}
?>
