// <![CDATA[ {literal}

String.prototype.trim = function () {
    return this.replace(/^\s+|\s+$/g,'');
};

String.prototype.ltrim = function () {
    return this.replace(/^\s+/g,'');
};

String.prototype.rtrim = function () {
    return this.replace(/\s+$/g,'');
};

String.prototype.stripTags = function () {
    return this.replace(/<([^>]+)>/g,'');
};

String.prototype.encodeHTML = function () {
    return HtmlEncode(this);
};

function isArray (objTest) {
    return objTest
        && !(objTest.propertyIsEnumerable('length'))
        && typeof objTest === 'object'
        && typeof objTest.length === 'number';
};

Date.prototype.setISO8601 = function (strDate) {
    var strExpression = "([0-9]{4})(-([0-9]{2})(-([0-9]{2})" +
        "(T([0-9]{2}):([0-9]{2})(:([0-9]{2})(\.([0-9]+))?)?" +
        "(Z|(([-+])([0-9]{2}):([0-9]{2})))?)?)?)?";
    var arrResult = strDate.match(new RegExp(strExpression));
    var numOffset = 0;
    var dtmTemp = new Date(arrResult[1], 0, 1);

    if (arrResult[3]) { dtmTemp.setMonth(arrResult[3] - 1); }
    if (arrResult[5]) { dtmTemp.setDate(arrResult[5]); }
    if (arrResult[7]) { dtmTemp.setHours(arrResult[7]); }
    if (arrResult[8]) { dtmTemp.setMinutes(arrResult[8]); }
    if (arrResult[10]) { dtmTemp.setSeconds(arrResult[10]); }
    if (arrResult[12]) { dtmTemp.setMilliseconds(Number("0." + arrResult[12]) * 1000); }
    if (arrResult[14]) {
        numOffset = (Number(arrResult[16]) * 60) + Number(arrResult[17]);
        numOffset *= ((arrResult[15] == '-') ? 1 : -1);
    }

    numOffset -= dtmTemp.getTimezoneOffset();
    numTime = (Number(dtmTemp) + (numOffset * 60 * 1000));
    this.setTime(Number(numTime));
}

function loadFader (strMessage) {
    var objFader = document.getElementById('faderMessage');
    if (objFader) {
        objFader.innerHTML = strMessage.encodeHTML();
        document.getElementById('loadFader').style.display = 'block';
    }
};

function getXMLHttpRequest () {
    if (window.XMLHttpRequest) {
        return new XMLHttpRequest();
    } else if (window.ActiveXObject) {
        var objXMLHttpRequest = false;
        try {
            objXMLHttpRequest = ActiveXObject('MSXML2.XMLHTTP');
        } catch (objException) {
            try {
                objXMLHttpRequest = ActiveXObject('Microsoft.XMLHTTP');
            } catch (objException) { }
        }
        return objXMLHttpRequest;
    } else
        throw new Error('Browser does not support AJAX');
};

// {/literal} ]]>
