// <![CDATA[ {literal}

var arrTracker = new Array();
var blnRefreshing  = false;
var dtmLastRefresh = new Date();
var strSelectedName = '';

/*********************************************************************\
  treeTicketDisplayReset - reset displayed buttons and lists
\*********************************************************************/
function treeTicketDisplayReset () {
    try {
        document.forms['ticketEdit'].elements['ticketid'].value = '0';
    } catch (e) {}
    try {
        document.getElementById('ticketDeleteId').value = '0';
    } catch (e) {}
    try {
        document.getElementById('ticketReassignId').value = '0';
    } catch (e) {}

    // Reset Ticket Info list
    var objTable = document.getElementById('ticketData');
    for (var i=objTable.rows.length-1;i>0;i--) {
        objTable.deleteRow(i);
    }
    // Reset Problem and hide buttons
    document.getElementById('ticketProblem').innerHTML = '';
    document.getElementById('ticketEditButton').style.display = 'none';
    document.getElementById('ticketReassignButton').style.display = 'none';
    document.getElementById('ticketDeleteButton').style.display = 'none';
    document.getElementById('ticketReassign').style.display = 'none';
    document.getElementById('ticketDelete').style.display = 'none';
}

/*********************************************************************\
  treeTicketdisplay - validate security and display buttons
\*********************************************************************/
function treeTicketDisplay (strTicketId) {

    if (isNaN(strTicketId))
        return false;

    var tkt_access_get_url = SERVER_PROTOCOL + SERVER_NAME + SCRIPT_PATH + '/xml.php/loadaccess?ticketid=' + strTicketId;
    var objHttp = getXMLHttpRequest();
    try {
        objHttp.open('GET', tkt_access_get_url, false);
        objHttp.send();
    } catch(e) {
//---- auto refreshing and clicking conflicted
        objHttp = null;
        return false;
    }

    if (objHttp.status != 200)
        return false;

    var objAccessNodes = objHttp.responseXML.getElementsByTagName('tag');
    for (var i=0;i<objAccessNodes.length;i++) {
        switch (objAccessNodes[i].getAttribute("name")) {
        case "Form Ticket Tree-Reassign Button":
            try {
                document.getElementById('ticketReassignId').value = strTicketId;
                document.getElementById('ticketReassignButton').style.display = 'block';
            } catch (e) {}
            break;
        case "Form Ticket Tree-Delete Button":
            try {
                document.getElementById('ticketDeleteId').value = strTicketId;
                document.getElementById('ticketDeleteButton').style.display = 'block';
            } catch (e) {}
            break;
        case "Menu Helpdesk-Ticket-Edit":
            try {
                document.forms['ticketEdit'].elements['ticketid'].value = strTicketId;
                document.getElementById('ticketEditButton').style.display = 'block';
            } catch (e) {}
            break;
        }
    }
    return true;
}

/*********************************************************************\
  treeTicketClick - load information for the ticket
\*********************************************************************/
function treeTicketClick(strTicketTag) {

    // Reset displayed ticket info and buttons
    treeTicketDisplayReset();

    // Abort if nothing passed in
    if (!strTicketTag)
        return false;

    var strTicketId = '0';
    // Strip off type ":leaf" from "ticket9999:leaf"
	if (strTicketTag.indexOf(":") > -1)
	    strTicketId = strTicketTag.substring(0, strTicketTag.indexOf(':'));
    else
        strTicketId = strTicketTag;
    // Strip off prefix "ticket" from "ticket9999" to get a  number
    strTicketId = strTicketId.substring(6);

    // Abort if invalid ticket passed in
    if (isNaN(Number(strTicketId)))
        return false;

    var tkt_info_get_url =  SERVER_PROTOCOL + SERVER_NAME + SCRIPT_PATH + '/xml.php/loadticket?ticketid=' + encodeURIComponent(strTicketId);
    var objHttp = getXMLHttpRequest();
    try {
        objHttp.open('GET', tkt_info_get_url, false);
        objHttp.send();
    } catch (e) {
//---- auto refreshing and clicking conflicted
        return false;
    }

    if (objHttp.status != 200)
        return false;

    var objTable = document.getElementById('ticketData');
    var objInfoNodes = objHttp.responseXML.getElementsByTagName('data');
    var objRow = false;
    var objCell = false;
    var strProblem = '';
    for (var i=0;i<objInfoNodes.length;i++) {
        objRow = objTable.insertRow(i+1);
        objCell = objRow.insertCell(0);
        objCell.innerHTML = objInfoNodes[i].getAttribute('name').encodeHTML();
        objCell = objRow.insertCell(1);
        try {
            objCell.innerHTML = objInfoNodes[i].childNodes[0].nodeValue.encodeHTML();
        } catch (e) { }
        if (objInfoNodes[i].getAttribute('name') == 'Problem') {
            try {
                strProblem = objInfoNodes[i].childNodes[0].nodeValue;
            } catch (e) { }
        }
    }

    document.getElementById('ticketProblem').innerHTML = strProblem.encodeHTML();
    treeTicketDisplay(strTicketId);
    return true;
}

/*********************************************************************\
  treeBranchPopulate - populate a branch of the tree
\*********************************************************************/
function treeBranchPopulate (strBranchName) {
    // Get Handle on Object
    var objBranch = false;
    if (strBranchName)
        objBranch = document.getElementById(strBranchName);
    if (!objBranch)
        return false;

    // Strip off type
	if (strBranchName.indexOf(":") > -1)
	    strBranchName = strBranchName.substring(0, strBranchName.indexOf(':'));

	// If already expanded, delete and recreate the expand node
	var objExpand = document.getElementById("expand-" + strBranchName);
	if (objExpand != null)
        objBranch.removeChild(objExpand);
    var objExpand = document.createElement('div');
    objExpand.id = 'expand-' + strBranchName;
    objBranch.appendChild(objExpand);
    var tkt_tree_branch_get_url = "/projects/piwi/xml.php/tickettreebranch?sections=" + encodeURIComponent(strBranchName);
    var objHttp = getXMLHttpRequest();
    try {
        objHttp.open("GET",tkt_tree_branch_get_url, false);
        objHttp.send();
    } catch(e) {
//---- auto refreshing and clicking conflicted
        return false;
    }
    if (objHttp.status != 200)
        return false;
    var objBranchNodes = false;
    if (strBranchName.toLowerCase() == 'root') {
        objBranchNodes =  objHttp.responseXML.getElementsByTagName('view');
    } else {
        // When not in root, branches can have branches too
        // So, getElementsByTagName('view') will cause problems
        try {
            objBranchNodes = objHttp.responseXML.getElementsByTagName('tree')[0].childNodes[0].childNodes;
        } catch (e) {}
    }
    if (!objBranchNodes || objBranchNodes.length == 0) {
        // If no branched returned from API and "No tickets found" node already exists, abort
        if (document.getElementById('noticket-' + strBranchName)) {
            return true;
        } else {
            // If no branches returned from API add "No tickets found" node
            var objChild = document.createElement('span');
            objChild.id = 'noticket-' + strBranchName;
            objChild.innerHTML = 'No Tickets Found';
            objExpand.appendChild(objChild);
        }
        return false;
    }

    for (var i=0; i < objBranchNodes.length; i++) {
        if (objBranchNodes[i].nodeName.toLowerCase() != 'view') {
            var strName = 
                strBranchName + '/' + 
                objBranchNodes[i].nodeName +
                objBranchNodes[i].getAttribute('id') + ':' +
                objBranchNodes[i].getAttribute('type');
        } else {
            var strName = 
                strBranchName + '/' + 
                objBranchNodes[i].getAttribute('name');
        }
        var objChild = document.getElementById(strName);
        if (objChild) {
            if (objBranchNodes[i].getAttribute('bold') == 'true')
                objChild.className = 'nodebold'
            else
                objChild.className = 'node'
            var objSpan = document.getElementById('title-' + strName);
            try {
                objSpan.innerHTML = '&nbsp;' + objBranchNodes[i].getAttribute('title').encodeHTML();
            } catch (e) {}
        } else {
            objChild = document.createElement('div');
            objChild.id = strName;
            if (objBranchNodes[i].getAttribute('bold') == 'true')
                objChild.className = 'nodebold'
            else
                objChild.className = 'node'
            objExpand.appendChild(objChild);

            var objImage = document.createElement('img');
            objImage.id = 'img-' + strName;
            if (objBranchNodes[i].getAttribute('type').toLowerCase() == 'folder')
                objImage.src = '../../../resources/defaultlayer/piwi/images/closed.gif'
            else
                objImage.src = '../../../resources/defaultlayer/piwi/images/item.gif'
            objChild.appendChild(objImage);

            var objSpan = document.createElement('span');
            objSpan.id = 'title-' + strName;
            objSpan.innerHTML = '&nbsp;' + objBranchNodes[i].getAttribute('title').encodeHTML();
            objSpan.onclick = function() { treeBranchClick(this.parentNode.id); };
            objChild.appendChild(objSpan);
        }
    }
    return true;
}

/*********************************************************************\
  treeBranchClick - expand/collapse tree & highlight ticket
\*********************************************************************/
function treeBranchClick (strBranchName) {
    if (strBranchName)
        var objBranch = document.getElementById(strBranchName);
	if (!objBranch)
        return false;

    var objType = false;
	if (strBranchName.indexOf(":") > -1) {
        objType = strBranchName.substring(strBranchName.indexOf(":") + 1);
    }

    if (objType && objType.toLowerCase() == 'leaf') {
        // Reset highlighting on last object
        if (strSelectedName && document.getElementById(strSelectedName))
            document.getElementById(strSelectedName).style.backgroundColor = 'transparent';
        // Set highlighting on current object
        strSelectedName = strBranchName;
        objBranch.style.backgroundColor = '#ACABAB';
        // Strip off ":leaf" suffix
        strBranchName = strBranchName.substring(0, strBranchName.indexOf(':'));
        // Strip off "root/branch/" prefix
        strBranchName = strBranchName.substring(strBranchName.lastIndexOf('/') + 1)
        treeTicketClick(strBranchName);
    } else {
        // Strip off ":folder" suffix, if it exists
        if (strBranchName.indexOf(':') > -1)
            strBranchName = strBranchName.substring(0, strBranchName.indexOf(':'));
        // If branch is expanded, collapse it and remove it from tracking array
        var objExpand = document.getElementById("expand-" + strBranchName);
        if (objExpand != null) {
            objBranch.removeChild(objExpand);
            for (var i=arrTracker.length-1; i>-1; i--) {
                if (arrTracker[i] == strBranchName) {
                    arrTracker.splice(i, 1);
                }
            }
            
        // If branch is not expanded and refreshing isn't occuring, add branch to tracking array
        } else if (!blnRefreshing) {
            // Check for branch in tracking array
            var blnFound = false;
            for (var i=arrTracker.length-1; i>-1; i--) {
                if (arrTracker[i] == strBranchName) {
                    blnFound = true;
                    break;
                }
            }
            // Append to tracking array and force a refresh
            if (!blnFound) {
                arrTracker.push(strBranchName);
                treeRefresh(true);
            }
        }
    }
    return true;
}

/*********************************************************************\
  treeRefresh - refresh the ticket tree
\*********************************************************************/
function treeRefresh (blnForce) {
	if (blnRefreshing)
	    return false;
    if (!arrTracker.length)
	    return false;
    if (!blnForce) {
        if (Date().valueOf() - dtmLastRefresh.valueOf() < 5000)
            return false;
    }
	blnRefreshing = true;

    // Populate branches marked for tracking
	for (var i=0;i < arrTracker.length; i++) {
        treeBranchPopulate(arrTracker[i]);
    }
    // Attempt to select last selected ticket
    if (strSelectedName && document.getElementById(strSelectedName))
        treeBranchClick(strSelectedName);

    dtmLastRefresh = new Date();
    blnRefreshing = false;
    return true;
}

/*********************************************************************\
  setCookie - save cookie to the client
\*********************************************************************/
function setCookie(strName,strValue,numExpireDays) {

    if (!numExpireDays)
        numExpireDays = 30;

    var objDate = new Date();
    objDate.setDate(objDate.getDate() + numExpireDays);

    document.cookie = 
        escape(strName) + '=' +
        escape(strValue) + ';' +
        'expires=' + objDate.toGMTString();
}

/*********************************************************************\
  getCookie - get cookie from the client
\*********************************************************************/
function getCookie (strName) {
    if (document.cookie.length == 0)
        return '';

    var strCookie = ';' + document.cookie +';';
    var numStart = strCookie.indexOf(escape(strName) + "=");
    if (numStart > -1)
        numStart += escape(strName).length + 1;
    var numEnd = strCookie.indexOf(';', numStart);
    var strValue = strCookie.substring(numStart, numEnd);

    return strValue;
}

/*********************************************************************\
  compareCookie - compare client's cookie against view settings
\*********************************************************************/
function compareCookie() {
    var strCookie = getCookie('treeTicketView');
    var objForm  = document.forms['treeViewSettings'];
    var blnFound = false;

    for (var i=0; i < objForm.elements['view'].length; i++) {
        if (objForm.elements['view'][i].value == strCookie) {
            objForm.elements['view'][i].checked = true;
            blnFound = true;
        } else {
            objForm.elements['view'][i].checked = false;
        }
    }
    if (!blnFound) {
        for (var i=0; i < objForm.elements['view'].length; i++) {
            if (objForm.elements['view'][i].value == 'status') {
                objForm.elements['view'][i].checked = true;
                blnFound = true;
            } else {
                objForm.elements['view'][i].checked = false;
            }
        }
    }
}

/*********************************************************************\
  treeViewChange - change ticket tree view settings
\*********************************************************************/
function treeViewChange() {
    var objForm = document.forms['treeViewSettings'];
    if (!objForm)
        return false;

    var arrValues = new Array(new Array(), new Array());
    var numCount = 0;
    var strCookie = '';
    for (var i=0; i<objForm.elements.length; i++) {
        switch (objForm.elements[i].type){
        case 'radio':
            if (objForm.elements[i].checked) {
                strCookie = objForm.elements[i].value;
                arrValues[0].push(objForm.elements[i].name);
                arrValues[1].push(objForm.elements[i].value);
                numCount++;
            }
            break;
        case 'checkbox':
            if (objForm.elements[i].checked) {
                arrValues[0].push(objForm.elements[i].name);
                arrValues[1].push(objForm.elements[i].value);
                numCount++;
            }
            break;
        case 'select-one':
            if (objForm.elements[i].checked) {
                arrValues[0].push(objForm.elements[i].name);
                arrValues[1].push(objForm.elements[i].options[objForm.elements[i].selectedIndex].value);
                numCount++;
            }
            break;
        }
    }

    var strPostBody = '';
    for (var i=0; i<numCount; i++) {
        strPostBody += 
            encodeURIComponent(arrValues[0][i]) + '=' +
            encodeURIComponent(arrValues[1][i]);
        if (i < (numCount - 1))
            strPostBody += '&';
    }
    var objHttp = getXMLHttpRequest();
    var tkt_tree_view_reset_url = SERVER_PROTOCOL + SERVER_NAME + SCRIPT_PATH + '/xml.php/reloadtickettree';
    tkt_tree_view_reset_url += '?' + strPostBody;
    try {
        objHttp.open('GET', tkt_tree_view_reset_url, false);
        objHttp.send();
    } catch(e) {
//---- auto refreshing and clicking conflicted
        return false;
    }

    setCookie('treeTicketView', strCookie);
    treeRefresh(true);
    return true;
}

// {/literal}
// {if $stafftools}
// {literal}

/*********************************************************************\
  ticketReassign - AJAX ticket reassign
\*********************************************************************/
function ticketReassign(strTicketId,strStaffId) {

    if (isNaN(strTicketId))
        return false;

    var tkt_reassign_url = SERVER_PROTOCOL + SERVER_NAME + SCRIPT_PATH + '/xml.php/reassignticket?ticketid=' + encodeURIComponent(strTicketId) + '&staff=' + encodeURIComponent(strStaffId);
    var objHttp = getXMLHttpRequest();
    try {
        objHttp.open("GET", tkt_reassign_url, false);
        objHttp.send();
    } catch (e) {
//---- auto refreshing and clicking conflicted
        objHttp = null;
        return false;
    }

    if (objHttp.status != 200)
        return false;

    try {
        if (objHttp.responseXML.getElementsByTagName('error')) {
            alert(objHttp.responseXML.getElementsByTagName('error')[0].childNodes[0].nodeValue);
        }
    } catch (e) {}

    treeRefresh(true);
    return true;
}

/*********************************************************************\
  ticketDelete - AJAX ticket delete
\*********************************************************************/
function ticketDelete(strTicketId, strDeleteEmails) {

    if (isNaN(strTicketId))
        return false;

    var tkt_delete_url = SERVER_PROTOCOL + SERVER_NAME + SCRIPT_NAME + '/deleteticket?ticketid=' + encodeURIComponent(strTicketId) + '&deleteemails=' + encodeURIComponent(strDeleteEmails);
    var objHttp = getXMLHttpRequest();

    try {
        objHttp.open('GET', tkt_delete_url, false);
        objHttp.send();
    } catch (e) {
//---- auto refreshing and clicking conflicted
        objHttp = null;
        return false;
    }

    if (objHttp.status != 200)
        return false;

    try {
        if (objHttp.responseXML.getElementsByTagName('error')) {
            alert(objHttp.responseXML.getElementsByTagName('error')[0].childNodes[0].nodeValue);
        }
    } catch (e) {}

    treeTicketClick();
    treeRefresh(true);
    return true;
}

/*********************************************************************\
  treeStaffChange - change ticket tree view to a different staff id
\*********************************************************************/
function treeStaffChange (strStaffId) {

    // Reset list of expanded branches
    arrTracker = new Array('root');

    var tkt_tree_view_reset_url = SERVER_PROTOCOL + SERVER_NAME + SCRIPT_PATH + '/xml.php/reloadtickettree?staffid=' + encodeURIComponent(strStaffId);
    var objHttp = getXMLHttpRequest();

    try {
        objHttp.open('GET', tkt_tree_view_reset_url, false);
        objHttp.send();
    } catch(e) {
//---- auto refreshing and clicking conflicted
        return false;
    }
    treeRefresh(true);
    return true;
}

// {/literal}
// {/if}
// {literal}

// {/literal} ]]>
