<?php
	// *****************************************************************************************
	// **** CCS Environment Check Script
	// **** ##VER1.0.3##
	// **** 09/19/06 - JCW
	// *****************************************************************************************

    $versionFile = fopen("../etc/release.info",'r');
	$CCSENVVER = fread($versionFile, 100);
	fclose($versionFile);
	$inBrowser = false;
	$noError = true;
	$activeServices = array();
	$serverType = '';
	$inIIS = false;
	$instructions = array();

	// Populate Solutions Array
	buildSolutions();

	// Check for Browser
	if($_SERVER['HTTP_USER_AGENT']) {
	    $inBrowser = true;
	    print "<html><head><title>CCS Environment Test</title><style type=\"text/css\"><!-- div.solution{padding: 5px; text-align: left; width: 80%;border-width: 1px; border-color: red; border-style: dashed;}--></style></head></body>";
	}

	// Check IIS
	if($_SERVER['SERVER_SOFTWARE'])
	    if(strstr($_SERVER['SERVER_SOFTWARE'],'IIS'))
		$inIIS = true;

	function printText($msg, $success = true, $header = false, $justText = false, $error = false) {
	    global $inBrowser;
	    global $noError;
	    global $serverType;
	    global $instructions;

	    // Set noError
	    if($noError && !$success && !$header && !$justText)
		$noError = $success;

	    if($inBrowser) {
		if($header) {
		    print "<br>\n<h2>".$msg."</h2>\n";
		} else
		    if($justText)
			print $msg."<br>\n";
		    else
			print $msg.($success?" [<font color=\"green\">Success</font>]":" [<font color=\"red\">Failure</font>]")."<br>\n";
	    } else {
		if($header) {
		    $message = "***".$msg."***\n";
		    print "\n";
		    print str_repeat("*",strlen($message)-1)."\n";
		    print "***".$msg."***\n";
		    print str_repeat("*",strlen($message)-1)."\n";
		} else
		    if($justText)
			print $msg."\n";
		    else
			if($serverType == 'UNIX')
			    print $msg.($success?" [\033[32mSuccess\033[m]":" [\033[31mFailure\033[m]")."\n";
			else
			    print $msg.($success?" [Success]":" [*** Failure ***]")."\n";

	    }

	    if($error && !$success) {
		if($inBrowser) {
		    print "<br>\n<center><div class=solution><b>Solution:</b><br>\n";
		    print $instructions[$error]['solution'];
		    print "<br>\n</div></center><br><br>\n";
		    //print "<br>\n********Solution*********</br>\n";
		    //print $instructions[$error]['solution'];
		    //print "<br>\n********/Solution*********</br></br>\n";
		} else {
		    print "\n\t********Solution*********\n";
		    print "\t".$instructions[$error]['solution'];
		    print "\n\t********/Solution*********\n\n";
		}
	    }
	}

	function processAPICall($request,$vars) {
	    global $serverType;
	    if($serverType == 'WIN')
		$_ENV['pathDelimiter'] = ';';
	    else
		$_ENV['pathDelimiter'] = ':';

	    $_ENV['TCA_HOME']       = $_SESSION['ccs']['options']['tca-options']['tca-home'];
	    $_ENV['TCA_CARTRIDGES'] = $_SESSION['ccs']['options']['tca-options']['tca-cartridges'];
	    $_ENV['TCA_ETC']        = $_SESSION['ccs']['options']['tca-options']['tca-etc'];
	    set_include_path(get_include_path() . $_ENV['pathDelimiter'] . $_ENV['TCA_HOME']);

	    $retval = array();
	    $cwd = getcwd();
	    chdir('../projects/modules');

	    require_once("client.inc.php");
	    TCA_Client::initEnv();
	    $client = new TCA_Client(new TCA_XMLConfigReader("tucows-client.xml"));

	    // Check A Username
	    $request = $client->createServiceRequest($request);
	    $pset = new TCA_ServiceRequestParameterSet();

	    foreach($vars as $key=>$value) {
		$pset->addParameter(new TCA_ServiceRequestParameter($key, $value));
	    }

	    $request->addParameterSet('attributes', $pset);

	    // attempt to process the service request
	    try {
		$result = $client->processServiceRequest($request);
	    }
	    catch(Exception $error) {
		$retval['error'] = $error->getMessage();
	    }

	    $retval['result'] = $result;

	    chdir($cwd);
	    return $retval;
	}

	function getlocalhostname() {
		$name = getenv('HOSTNAME');
		if(!$name) {
			$ip = getenv('REMOTE_ADDR');
			if (!$ip)
				$ip = getenv('REMOTE_HOST');
			$name = @GetHostByAddr($ip);
		}
		if(!$name)
			$name = 'localhost';
		return $name;
	}

	function compareVersion($current, $online) {
		// Parse Version String
		$currentArray = explode('.',$current);
		$onlineArray = explode('.',$online);

		// This function assumes Version String will always be in the X.X.X format
		if(intval($currentArray[0]) < intval($onlineArray[0]))
			return true;
		if(intval($currentArray[1]) < intval($onlineArray[1]))
			return true;
		if(intval($currentArray[2]) < intval($onlineArray[2]))
			return true;

		return false; // Current is greater, don't update
	}

	function updateFile($host,$url,$filename,$port = 80) {
		$retval = false;
		global $serverType;
		global $inBrowser;

		if(!is_writeable($filename)) {
			if($serverType == "WIN")
			    if($inBrowser)
					printText("Unable to update script.  File ".$_SERVER['SCRIPT_FILENAME']." is not writeable.",false,false,true);
			    else
					printText("Unable to update script.  File ".getcwd()."\\".$_SERVER['SCRIPT_NAME']." is not writeable.",false,false,true);
			else
			    if($inBrowser)
				    printText("Unable to update script.  File ".$_SERVER['SCRIPT_FILENAME']." is not writeable.",false,false,true);
				else
				    printText("Unable to update script.  File ".getcwd()."/".$_SERVER['SCRIPT_NAME']." is not writeable.",false,false,true);

			return $retval;
		}

		global $CCSENVVER;
		$s = fsockopen($host,$port);
		if($s) {
			$request = "GET ".$url." HTTP/1.1\r\n";
			$request .= "Accept: */*\r\n";
			$request .= "Accept-Language: en-us\r\n";
			$request .= "Accept-Encoding: deflate\r\n";
			$request .= "Host: ".$host."\r\n";
			$request .= "User-Agent: Mozilla/4.0 (compatible; MSIE 5.01; Windows NT)\r\n";
			$request .= "Connection: Keep-Alive\r\n\r\n";

			$headers = array();
			fwrite($s,$request);
			$buffer = fgets($s);
			$noID = 0;
			while ($buffer != "\r\n") {
				if(strstr($buffer,":")) // Header
					$headers[strtolower(substr($buffer,0,strpos($buffer,":")))] = substr($buffer,strpos($buffer,":")+1);
				else
					$headers['NoID.'.$noID] = $buffer;

				$buffer = fgets($s);
			}

			$length = intval($headers['content-length']);

			if($length > 0) {
				$bytesRead = 0;
				$file = "";
				while($bytesRead < $length) {
					$file .= fread($s,$length - $bytesRead);
					$bytesRead = strlen($file);
				}
			}

			if($file) {
				// Check Version
				$version = substr(substr(strstr($file,"##VER"),5),0,strpos(substr(strstr($file,"##VER"),5),"##"));
				if($version && (compareVersion($CCSENVVER,$version))) {
					$retval = true;
					printText("Updating: ".$CCSENVVER." => ".$version,false,false,true);
					// Reright File
					$f = fopen($filename,"w");
					fwrite($f,$file,$length);
					fclose($f);
				} else {
					if($version)
						printText("No Update Needed, Running Lastest Check Script (".$CCSENVVER.") vs Online Version (".$version.")",false,false,true);
					else
						printText("No Update Needed, Running Lastest Check Script (".$CCSENVVER.")",false,false,true);
				}
			}

			fclose($s);
		}
		return $retval;
	}

	// Print Version Number
	printText('CCS Environment Test Version:'.$CCSENVVER,false,true);

	// ********************************************************
	// OS and PHP Checks
	// ********************************************************

	// Check PHP Version
	if(substr(PHP_VERSION,0,1) < 5) { // Version 4 or less
	    printText("You have PHP version ".PHP_VERSION.". You must have version 5 or later to run CCS/PIWI.",false,false,false,'E01');
	    exit(0);
	}

	// Display CCS Version
	if(file_exists('../etc/release.info')) { // Read and display Version
	    $versionfh = fopen('../etc/release.info','r');
	    $line = fgets($versionfh);
	    while($line) {
		if(stristr($line,'version:')) {
		    printText('CCS '.$line,false,false,true);
		    break;
		}
		$line = fgets($versionfh);
	    }
	    fclose($versionfh);
	}

	// Checking OS Type
	$incpath = get_include_path();
	if(strstr($incpath,";")) {
	    $serverType = 'WIN';
	    printText('Windows Operating System Detected: '.php_uname(),false,false,true);
	} else {
	    $serverType = 'UNIX';
	    printText('Unix Operating System Detected: '.php_uname(),false,false,true);
	}

	// ******************************************************
	// Check Current CET version,  Update from Web if needed.  - Removed per Grant's request on 10-22-08 - faldridge
	// ******************************************************
	/*if(updateFile('resellers.tucows.com','/current/testenv.dat','./testenv.php')) {
	    if($inBrowser)
			print "<h3>This script has been updated.  Please refresh this page.</h3></body></html>";
	    else
			print "\nThis script has been updated and should be executed again.\n";
		exit(0);
    }*/

	// Check OS, PHP
	printText('System Information',false,true);
	if($_SERVER['OS'])
	    printText("Operating System: ".$_SERVER['OS'],true);
	printText("PHP: ".PHP_VERSION,true);
	if($_SERVER['SERVER_SOFTWARE'])
	    printText("Web Server: ".$_SERVER['SERVER_SOFTWARE'],true);

	// Virtual Host Check
	if($inBrowser) {
	    if($_SERVER['REQUEST_URI'] == '/scripts/testenv.php')
			printText("CCS package found in the root of the web host directory.",true);
	    else
			printText("CCS package not found in the root of the web host directory.  CCS must be located in the document root.",false,false,false,'E02');
	}

	// ********************************************************
	// WebServer Setup
	// ********************************************************
	if(($serverType == "WIN") && $inBrowser && $inIIS) {
	    printText('Web Server Settings',false,true);
	    if (php_sapi_name() == 'isapi')
		printText("PHP is running as an ISAPI filter in IIS.",true,false,false,'E03');
 	    elseif (php_sapi_name() == 'cgi-fcgi')
		printText("PHP is running as a FastCGI filter in IIS.",true,false,false,'E03');
	    else
		printText("PHP must be ran as an ISAPI or FASTCGI filter in IIS.",false);
	}

	// ********************************************************
	// PHP.ini variables
	// ********************************************************

	// php.ini options
	printText('Checking PHP.INI Variables',false,true);

	// Check Errors
	if(ini_get('display_errors'))
	    printText("display_errors = On",true);
	else
	    printText("display_errors = Off",false,false,false,'E04');

	if(ini_get('error_reporting') == (E_ALL & ~E_NOTICE))
	    printText('error_reporting = E_ALL & ~E_NOTICE',true);
	else
	    printText('error_reporting != E_ALL & ~E_NOTICE',false,false,false,'E04');

	// Check register_globals
	if(ini_get('register_globals'))
	    printText("register_globals = On",false,false,false,'E04');
	else
	    printText("register_globals = Off",true);

// Requirement removed as part of php 5.3 compatibility
//	// Check Call Time Reference Passing
//	if(ini_get('allow_call_time_pass_reference'))
//	    printText("allow_call_time_pass_reference = On",true);
//	else
//	    printText("allow_call_time_pass_reference = Off",false,false,false,'E04');

	// Windows Only Checks
	if($serverType == "WIN") {
	    // Check Doc Root
	    if(ini_get('doc_root'))
		printText("doc_root = ".ini_get('doc_root').", Please unset this variable.",false,false,false,'E04');
	    else
		printText("doc_root = ",true);



	}

	// ********************************************************
	// PHP Extensions
	// ********************************************************

	printText('Checking PHP Extensions',false,true);
	//if(extension_loaded('openssl'))
	if (in_array('ssl', stream_get_transports(), TRUE))
	    if($serverType == "WIN")
		printText("extension=php_openssl.dll",true);
	    else
		printText("extension openssl loaded.",true);
	else
	    if($serverType == "WIN")
		printText("missing extension=php_openssl.dll",false,false,false,'E05');
	    else
		printText("extension openssl not loaded.",false,false,false,'E05');

	//if(extension_loaded('sockets'))
	if (in_array('tcp', stream_get_transports(), TRUE))
	    if($serverType == "WIN")
		printText("extension=php_sockets.dll",true);
	    else
		printText("extension sockets loaded.",true);
	else
	    if($serverType == "WIN")
		printText("missing extension=php_sockets.dll",false,false,false,'E05');
	    else
		printText("extension sockets not loaded.",false,false,false,'E05');

//	if(extension_loaded('xmlrpc'))
//	    if($serverType == "WIN")
//		printText("extension=php_xmlrpc.dll",true);
//	    else
//		printText("extension xmlrpc loaded.",true);
//	else
//	    if($serverType == "WIN")
//		printText("missing extension=php_xmlrpc.dll",false,false,false,'E05');
//	    else
//		printText("extension xmlrpc not loaded.",false,false,false,'E05');

	if(extension_loaded('libxml'))
	    if($serverType == "WIN")
		printText("extension=php_libxml.dll",true);
	    else
		printText("extension libxml loaded.",true);
	else
	    if($serverType == "WIN")
		printText("missing extension=php_libxml.dll",false,false,false,'E05');
	    else
		printText("extension libxml not loaded.",false,false,false,'E05');

	// ********************************************************
	// CCS Options
	// ********************************************************

	// Check CCS Options
	printText('Checking CCS Options',false,true);
	if(file_exists('../etc/ccs_options.xml')) {
	    printText("ccs_options.xml exists.",true);

	    // Load CCS Options
	    $cwd = getcwd();
	    chdir('../projects/ccs');
	    $_SESSION = array();
	    require_once('../../libs/ccs/options.inc.php');
	    loadCCSOptions();
	    $options = $_SESSION['ccs']['options'];
	    chdir($cwd);

	    // Check url-prefix
	    if(($options['driver-options']['url-prefix'] == 'http') || ($options['driver-options']['url-prefix'] == 'https'))
		printText("url-prefix = ".$options['driver-options']['url-prefix'],true);
	    else
		printText("url-prefix value is invalid (".$options['driver-options']['url-prefix'].")",false,false,false,'E06');

	    // Check Billing Modules
	    if($options['driver-options']['billing-module'])
		if($inBrowser)
		    printText("Billing Module Present at ".$options['driver-options']['billing-module']['url'],true);
		else
		    printText("Billing Module Present.",true);
	    else
		printText("Billing Module Not Present.",false,false,false,'E07');

	    // Check Services Modules
	    $atLeastOne = false;
	    if($options['driver-options']['service-modules']) {
		foreach($options['driver-options']['service-modules'] as $module) {
		    printText($module['name']);
		    if(strtolower($module['active']) == 'true') {
			$atLeastOne = true;
			if($inBrowser)
			    printText(ucfirst($module['name'])." Module Active at ".$module['url'],true);
			else
			    printText(ucfirst($module['name'])." Module Active",true);

			array_push($activeServices,$module['name']);
		    }
		}

		if(!$atLeastOne && !$_SESSION['wow'])
		    printText("No Service Modules Active.",false,false,false,'E08');

	    } else
		printText("Service Modules Not Present.",false,false,false,'E07');

	} else
	    printText("ccs_options.xml does not exists.",false,false,false,'E06');

	// ********************************************************
	// Check TCA Connections
	// ********************************************************
	if(count($activeServices) > 0) {
		printText('Checking Tucows API Communications.',false,true);

		//OpenSRS
		if(in_array('domain',$activeServices)) {
		    $vars = array('domain'=>'tucowstestdomain.com');
		    $response = processAPICall('TUCOWS_domains.lookup_domain',$vars);

		    if ($response['result'])
			if ($response['result']->isSuccess())
				printText("Domain API Up.",true);
			else
				printText("Domain API Down. Error => ".$response['result']->getResponseText(),false);
		    else
			if($response['error'])
			    printText("Domain API Down. Error => ".$response['error'],false);
			else
			    printText("Domain API Down. Error => Unknown, Client didn't return a response.",false);
		}
	}

	// ********************************************************
	// Check Plat API (including Login)
	// ********************************************************
	if($_SESSION['wow']) {
	    printText('Checking WOW Options',false,true);
	    if($_SESSION['wow']['staffname']) {
			printText("Platypus user set: ".$_SESSION['wow']['staffname'],true);

			$cwd = getcwd();
			chdir('../projects/ccs');
			require_once("../../libs/platypus/wow.inc.php");

			if (!isset($_SESSION['wow']['object']))
				$_SESSION['wow']['object'] = new WOW_Request();
			$wow = $_SESSION['wow']['object'];
			$wow->setUsername($_SESSION['wow']['staffname']);
			$wow->setPassword($_SESSION['wow']['staffpass']);

			$wow->setMethod('Login');
			$wow->addAttribute('logintype','staff');

			$wow->addParameter('logintype','staff');
			$wow->addParameter('username',$_SESSION['wow']['staffname']);
			$wow->addParameter('password',$_SESSION['wow']['staffpass']);
			$wow->addParameter('datatype','XML');
			$wow->addParameter('allowedactive',"'Y','H','S'");

			if($wow->execute()){
				printText("Platypus Login Successful.",true);
				printText("Platypus API Version: ".$wow->getAPIVersion());}
			else
				printText("Platypus Login Failed. Error => ".$wow->lastError,false,false,false,'E09');

			// Check OpenSRS server, match vs CCS settings
			if(in_array('domain',$activeServices)) {
				// Get Plat Server Settings
				$wow->setMethod('SQL');
				$wow->addAttribute('logintype','staff');

				$wow->addParameter('query',"select * from options where name = 'OpenSRS Server URL'");
				$wow->addParameter('noconn',false,'boolean');
				$wow->addParameter('datatype','XML');

				if($wow->execute()) {
					$results = $wow->getAttributesArray();
					$platOSRSServer = $results[0]['value'];

					// Strip trailing slash
					if(substr($platOSRSServer,strlen($platOSRSServer) - 1) == "/")
						$platOSRSServer = substr($platOSRSServer,0,strlen($platOSRSServer) - 1);

					// Load TCA Options
					if(file_exists($options['tca-options']['tca-etc']))
						$optionsFile = simplexml_load_file($options['tca-options']['tca-etc'].'/tucows-client.xml');

					if($optionsFile) {
						foreach($optionsFile->{'communication'}->{'providers'}->{'provider'} as $provider) {
							if(strcasecmp((string)$provider->{'name'},'tucows-services') == 0) {
								// find service endpoint
								foreach($optionsFile->{'communication'}->{'service-endpoint-list'}->{'service-endpoint'} as $endpoint) {
									if((string)$endpoint->{'name'} == (string)$provider->{'reseller-settings'}->{'service-endpoint-ref'}) {
										$tcaOSRSServer = 'https://'.(string)$endpoint->{'hostname'}.':'.(string)$endpoint->{'port'};
										break;
									}
								}
							}
						}
					} else
						printText("OpenSRS Server Check Failed. Error => Could not read TCA Options File.",false,false,false,'E06');

					if($tcaOSRSServer == $platOSRSServer)
						printText("Platypus and CCS OpenSRS server settings match: ".$platOSRSServer,true);
					else {
						printText("Platypus and CCS OpenSRS server settings do not match:",false,false,false,'E10');
						printText("Platypus: ".$platOSRSServer,false,false,true);
						printText("CCS: ".$tcaOSRSServer,false,false,true);
					}
				} else
					printText("Platypus OpenSRS Check Failed. Error => ".$wow->lastError,false);
			}
			chdir($cwd);
	    }
	}

	// ********************************************************
	// Check Workspace (Is writeable)
	// ********************************************************
	printText('Checking CCS Workspace',false,true);

	// Check Workspace
	if(is_writeable('../workspace'))
	    printText("workspace is writeable.",true);
	else
	    printText("workspace is not writeable.",false,false,false,'E11');

	// Check Template Bucket
	if(is_writeable('../workspace/templates_c'))
	    printText("workspace/templates_c is writeable.",true);
	else
	    printText("workspace/templates_c is not writeable.",false,false,false,'E11');

	// Check ACF Cache
	if(is_writeable('../workspace/acf_cache'))
	    printText("workspace/acf_cache is writeable.",true);
	else
	    printText("workspace/acf_cache is not writeable.",false,false,false,'E11');

	// Report Status
	if($noError) {
	    if($inBrowser)
		print "<h3>CCS Environment Check Successful!</h3>";
	    else
		print "\nCCS Environment Check Successful!\nPlease Run This Script From Your Web Browser Using:\n[CVSHOST]/scripts/testenv.php";
	} else {
	    if($inBrowser)
		print "<h3>CCS Environment Check Failed,Please Check Errors Listed Above.</h3>";
	    else
		print "\nCCS Environment Check Failed!\nPlease Check Errors Listed Above.";
	}

	// Make things look good
	if($inBrowser)
	    print "</body></html>";
	else
	    print "\n";

	// Solutions
	function buildSolutions() {
	    global $instructions;
	    global $serverType;
	    $instructions['E01'] = array();

	    $instructions['E01']['error'] = 'PHP version 5 not installed.';
	    $instructions['E01']['solution'] = 'Please install PHP version 5.0 or later.';

	    $instructions['E02']['error'] = 'CCS in not in html root.';
	    $instructions['E02']['solution'] = 'CCS directories must be moved to the document root of your webserver.  For example, CCS must be accessed as http://HOSTNAME/projects/ccs/index.php NOT http://HOSTNAME/something/projects/ccs/index.php.';

	    $instructions['E03']['error'] = 'ISAPI is not configured';
	    $instructions['E03']['solution'] = 'https://support.ispbilling.com/ccs/download/ccsinstall.pdf';

	    $instructions['E04']['error'] = 'PHP.ini option is incorrect';
	    $instructions['E04']['solution'] = 'You must set this option in the php.ini file.  After saving php.ini, you must restart your web server.  For more information, visit: https://support.ispbilling.com/ccs/download/ccsinstall.pdf';

	    $instructions['E05']['error'] = 'Extension missing';
	    if($serverType == "WIN")
		$instructions['E05']['solution'] = 'You must uncomment this extension in your php.ini file.  For more information, visit: https://support.ispbilling.com/ccs/download/ccsinstall.pdf';
	    else
		$instructions['E05']['solution'] = 'You must configure your php with this extension.  For more information, visit: https://support.ispbilling.com/ccs/download/ccsinstall.pdf';

	    $instructions['E06']['error'] = 'invalid values in ccs_options.';
	    $instructions['E06']['solution'] = 'Please rerun CCSROOT/etc/setup.php.';

	    $instructions['E07']['error'] = 'module section is missing from ccs_option.xml';
	    $instructions['E07']['solution'] = 'Your ccs_options.xml file is corupt.  Please delete this file from your CCSROOT/etc directory and rerun setup.php';

	    $instructions['E08']['error'] = 'No modules are active.';
	    $instructions['E08']['solution'] = 'Please rerun CCSROOT/etc/setup.php activating one Tucows service.';

	    $instructions['E09']['error'] = 'Plat login Failed';
	    $instructions['E09']['solution'] = 'Platypus Staff Username/Password should be corrected.  Please rerun CCSROOT/etc/setup.php entering the correct Platypus Username/Password.';

	    $instructions['E10']['error'] = 'Plat/CCS Opensrs server do not match.';
	    $instructions['E10']['solution'] = 'The OpenSRS server set in your Platypus options (OpenSRS Server URL) does not match the OpenSRS server set with CCSROOT/etc/setup.php.  Please change one of these values to match the other.';

	    $instructions['E11']['error'] = 'Permission Issues';
	    $instructions['E11']['solution'] = 'Please ensure that the user running the web server on this system has write permissions to the directory mentioned above.';

	}
?>
